/* Do not modify this file.                                                   */
/* It is created automatically by the ASN.1 to Ethereal dissector compiler    */
/* ./packet-rnsap.c                                                           */
/* ../../tools/asn2eth.py -X -e -p rnsap -c rnsap.cnf -s packet-rnsap-template rnsap.asn */

/* Input file: packet-rnsap-template.c */

#line 1 "packet-rnsap-template.c"
/* packet-rnsap.c
 * Routines for dissecting Universal Mobile Telecommunications System (UMTS);
 * UTRAN Iur interface Radio Network Subsystem
 * Application Part (RNSAP) signalling
 * (3GPP TS 25.423 version 6.7.0 Release 6) packet dissection
 * Copyright 2005, Anders Broman <anders.broman@ericsson.com>
 *
 * $Id: packet-rnsap.c 16866 2005-12-20 09:23:42Z jmayer $
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@ethereal.com>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Ref: 3GPP TS 25.423 version 6.7.0 Release 6
 */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <glib.h>
#include <epan/packet.h>
#include <epan/conversation.h>

#include <stdio.h>
#include <string.h>

#include "packet-rnsap.h"
#include "packet-ber.h"
#include "packet-per.h"

#define PNAME  "UTRAN Iur interface Radio Network Subsystem Application Part"
#define PSNAME "RNSAP"
#define PFNAME "rnsap"

#define RNSAP_FDD 1
/* Procedure codes */
#define	RNSAP_ID_COMMONTRANSPORTCHANNELRESOURCESINITIALISATION			 0
#define	RNSAP_ID_COMMONTRANSPORTCHANNELRESOURCESRELEASE					 1
#define	RNSAP_ID_COMPRESSEDMODECOMMAND									 2
#define	RNSAP_ID_DOWNLINKPOWERCONTROL									 3
#define	RNSAP_ID_DOWNLINKPOWERTIMESLOTCONTROL							 4
#define	RNSAP_ID_DOWNLINKSIGNALLINGTRANSFER								 5
#define	RNSAP_ID_ERRORINDICATION										 6
#define	RNSAP_ID_DEDICATEDMEASUREMENTFAILURE							 7
#define	RNSAP_ID_DEDICATEDMEASUREMENTINITIATION							 8
#define	RNSAP_ID_DEDICATEDMEASUREMENTREPORTING							 9
#define	RNSAP_ID_DEDICATEDMEASUREMENTTERMINATION						 10
#define	RNSAP_ID_PAGING													 11
#define	RNSAP_ID_PHYSICALCHANNELRECONFIGURATION							 12
#define	RNSAP_ID_PRIVATEMESSAGE											 13
#define	RNSAP_ID_RADIOLINKADDITION										 14
#define	RNSAP_ID_RADIOLINKCONGESTION									 34
#define	RNSAP_ID_RADIOLINKDELETION										 15
#define	RNSAP_ID_RADIOLINKFAILURE										 16
#define	RNSAP_ID_RADIOLINKPREEMPTION									 17
#define	RNSAP_ID_RADIOLINKRESTORATION									 18
#define	RNSAP_ID_RADIOLINKSETUP											 19
#define	RNSAP_ID_RELOCATIONCOMMIT										 20
#define	RNSAP_ID_SYNCHRONISEDRADIOLINKRECONFIGURATIONCANCELLATION		 21
#define	RNSAP_ID_SYNCHRONISEDRADIOLINKRECONFIGURATIONCOMMIT				 22
#define	RNSAP_ID_SYNCHRONISEDRADIOLINKRECONFIGURATIONPREPARATION		 23
#define	RNSAP_ID_UNSYNCHRONISEDRADIOLINKRECONFIGURATION					 24
#define	RNSAP_ID_UPLINKSIGNALLINGTRANSFER								 25
#define	RNSAP_ID_COMMONMEASUREMENTFAILURE								 26
#define	RNSAP_ID_COMMONMEASUREMENTINITIATION							 27
#define	RNSAP_ID_COMMONMEASUREMENTREPORTING								 28
#define	RNSAP_ID_COMMONMEASUREMENTTERMINATION							 29
#define	RNSAP_ID_INFORMATIONEXCHANGEFAILURE								 30
#define	RNSAP_ID_INFORMATIONEXCHANGEINITIATION							 31
#define	RNSAP_ID_INFORMATIONREPORTING									 32
#define	RNSAP_ID_INFORMATIONEXCHANGETERMINATION							 33
#define	RNSAP_ID_RESET													 35
#define	RNSAP_ID_RADIOLINKACTIVATION 									 36
#define	RNSAP_ID_GERANUPLINKSIGNALLINGTRANSFER							 37
#define	RNSAP_ID_RADIOLINKPARAMETERUPDATE								 38
#define	RNSAP_ID_UEMEASUREMENTFAILURE									 39
#define	RNSAP_ID_UEMEASUREMENTINITIATION								 40
#define	RNSAP_ID_UEMEASUREMENTREPORTING									 41
#define	RNSAP_ID_UEMEASUREMENTTERMINATION								 42
#define	RNSAP_ID_IURDEACTIVATETRACE										 43
#define	RNSAP_ID_IURINVOKETRACE											 44
#define	RNSAP_ID_MBMSATTACH												 45
#define	RNSAP_ID_MBMSDETACH												 46
#define	RNSAP_ID_DIRECTINFORMATIONTRANSFER								 48

#define	RNSAP_ID_ALLOWEDQUEUINGTIME														 4
#define	RNSAP_ID_ALLOWED_RATE_INFORMATION												 42
#define	RNSAP_ID_ANTENNACOLOCATIONINDICATOR												 309
#define	RNSAP_ID_BINDINGID																 5
#define	RNSAP_ID_C_ID																	 6
#define	RNSAP_ID_C_RNTI																	 7
#define	RNSAP_ID_CELL_CAPACITY_CLASS_VALUE												 303
#define	RNSAP_ID_CFN																	 8
#define	RNSAP_ID_CN_CS_DOMAINIDENTIFIER													 9
#define	RNSAP_ID_CN_PS_DOMAINIDENTIFIER													 10
#define	RNSAP_ID_CAUSE																	 11
#define	RNSAP_ID_COVERAGEINDICATOR														 310
#define	RNSAP_ID_CRITICALITYDIAGNOSTICS													 20
#define	RNSAP_ID_CONTEXTINFOITEM_RESET													 211
#define	RNSAP_ID_CONTEXTGROUPINFOITEM_RESET												 515
#define	RNSAP_ID_D_RNTI																	 21
#define	RNSAP_ID_D_RNTI_RELEASEINDICATION												 22
#define	RNSAP_ID_DCHS_TO_ADD_FDD														 26
#define	RNSAP_ID_DCHS_TO_ADD_TDD														 27
#define	RNSAP_ID_DCH_DELETELIST_RL_RECONFPREPFDD										 30
#define	RNSAP_ID_DCH_DELETELIST_RL_RECONFPREPTDD										 31
#define	RNSAP_ID_DCH_DELETELIST_RL_RECONFRQSTFDD										 32
#define	RNSAP_ID_DCH_DELETELIST_RL_RECONFRQSTTDD										 33
#define	RNSAP_ID_DCH_FDD_INFORMATION													 34
#define	RNSAP_ID_DCH_TDD_INFORMATION													 35
#define	RNSAP_ID_FDD_DCHS_TO_MODIFY														 39
#define	RNSAP_ID_TDD_DCHS_TO_MODIFY														 40
#define	RNSAP_ID_DCH_INFORMATIONRESPONSE												 43
#define	RNSAP_ID_DCH_RATE_INFORMATIONITEM_RL_CONGESTIND									 38
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONADDITEM_RL_RECONFPREPTDD							 44
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONLISTIE_RL_RECONFREADYTDD							 45
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONDELETEITEM_RL_RECONFRQSTTDD						 46
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONITEM_RL_SETUPRQSTTDD								 47
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONLISTIE_PHYCHRECONFRQSTTDD							 48
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONLISTIE_RL_ADDITIONRSPTDD							 49
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONLISTIE_RL_SETUPRSPTDD								 50
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONADDLIST_RL_RECONFPREPTDD							 51
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONDELETELIST_RL_RECONFRQSTTDD						 52
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONLIST_RL_SETUPRQSTTDD								 53
#define	RNSAP_ID_FDD_DL_CODEINFORMATION													 54
#define	RNSAP_ID_DL_DPCH_INFORMATION_RL_RECONFPREPFDD									 59
#define	RNSAP_ID_DL_DPCH_INFORMATION_RL_SETUPRQSTFDD									 60
#define	RNSAP_ID_DL_DPCH_INFORMATION_RL_RECONFRQSTFDD									 61
#define	RNSAP_ID_DL_DPCH_INFORMATIONITEM_PHYCHRECONFRQSTTDD								 62
#define	RNSAP_ID_DL_DPCH_INFORMATIONITEM_RL_ADDITIONRSPTDD								 63
#define	RNSAP_ID_DL_DPCH_INFORMATIONITEM_RL_SETUPRSPTDD									 64
#define	RNSAP_ID_DL_DPCH_TIMINGADJUSTMENT												 278
#define	RNSAP_ID_DLREFERENCEPOWER														 67
#define	RNSAP_ID_DLREFERENCEPOWERLIST_DL_PC_RQST										 68
#define	RNSAP_ID_DL_REFERENCEPOWERINFORMATION_DL_PC_RQST								 69
#define	RNSAP_ID_DPC_MODE																 12
#define	RNSAP_ID_DRXCYCLELENGTHCOEFFICIENT												 70
#define	RNSAP_ID_DEDICATEDMEASUREMENTOBJECTTYPE_DM_FAIL_IND								 470
#define	RNSAP_ID_DEDICATEDMEASUREMENTOBJECTTYPE_DM_FAIL									 471
#define	RNSAP_ID_DEDICATEDMEASUREMENTOBJECTTYPE_DM_RPRT									 71
#define	RNSAP_ID_DEDICATEDMEASUREMENTOBJECTTYPE_DM_RQST									 72
#define	RNSAP_ID_DEDICATEDMEASUREMENTOBJECTTYPE_DM_RSP									 73
#define	RNSAP_ID_DEDICATEDMEASUREMENTTYPE												 74
#define	RNSAP_ID_FACH_INFOFORUESELECTEDS_CCPCH_CTCH_RESOURCERSPFDD						 82
#define	RNSAP_ID_FACH_INFOFORUESELECTEDS_CCPCH_CTCH_RESOURCERSPTDD						 83
#define	RNSAP_ID_GUARANTEED_RATE_INFORMATION											 41
#define	RNSAP_ID_IMSI																	 84
#define	RNSAP_ID_HCS_PRIO																 311
#define	RNSAP_ID_L3_INFORMATION															 85
#define	RNSAP_ID_ADJUSTMENTPERIOD														 90
#define	RNSAP_ID_MAXADJUSTMENTSTEP														 91
#define	RNSAP_ID_MEASUREMENTFILTERCOEFFICIENT											 92
#define	RNSAP_ID_MESSAGESTRUCTURE														 57
#define	RNSAP_ID_MEASUREMENTID															 93
#define	RNSAP_ID_NEIGHBOURING_GSM_CELLINFORMATION										 13
#define	RNSAP_ID_NEIGHBOURING_UMTS_CELLINFORMATIONITEM									 95
#define	RNSAP_ID_NRT_LOAD_INFORMATION_VALUE												 305
#define	RNSAP_ID_NRT_LOAD_INFORMATION_VALUE_INCRDECRTHRES								 306
#define	RNSAP_ID_PAGINGAREA_PAGINGRQST													 102
#define	RNSAP_ID_FACH_FLOWCONTROLINFORMATION											 103
#define	RNSAP_ID_PARTIALREPORTINGINDICATOR												 472
#define	RNSAP_ID_PERMANENT_NAS_UE_IDENTITY												 17
#define	RNSAP_ID_POWERADJUSTMENTTYPE													 107
#define	RNSAP_ID_RANAP_RELOCATIONINFORMATION											 109
#define	RNSAP_ID_RL_INFORMATION_PHYCHRECONFRQSTFDD										 110
#define	RNSAP_ID_RL_INFORMATION_PHYCHRECONFRQSTTDD										 111
#define	RNSAP_ID_RL_INFORMATION_RL_ADDITIONRQSTFDD										 112
#define	RNSAP_ID_RL_INFORMATION_RL_ADDITIONRQSTTDD										 113
#define	RNSAP_ID_RL_INFORMATION_RL_DELETIONRQST											 114
#define	RNSAP_ID_RL_INFORMATION_RL_FAILUREIND											 115
#define	RNSAP_ID_RL_INFORMATION_RL_RECONFPREPFDD										 116
#define	RNSAP_ID_RL_INFORMATION_RL_RESTOREIND											 117
#define	RNSAP_ID_RL_INFORMATION_RL_SETUPRQSTFDD											 118
#define	RNSAP_ID_RL_INFORMATION_RL_SETUPRQSTTDD											 119
#define	RNSAP_ID_RL_INFORMATIONITEM_RL_CONGESTIND										 55
#define	RNSAP_ID_RL_INFORMATIONITEM_DM_RPRT												 120
#define	RNSAP_ID_RL_INFORMATIONITEM_DM_RQST												 121
#define	RNSAP_ID_RL_INFORMATIONITEM_DM_RSP												 122
#define	RNSAP_ID_RL_INFORMATIONITEM_RL_PREEMPTREQUIREDIND								 2
#define	RNSAP_ID_RL_INFORMATIONITEM_RL_SETUPRQSTFDD										 123
#define	RNSAP_ID_RL_INFORMATIONLIST_RL_CONGESTIND										 56
#define	RNSAP_ID_RL_INFORMATIONLIST_RL_ADDITIONRQSTFDD									 124
#define	RNSAP_ID_RL_INFORMATIONLIST_RL_DELETIONRQST										 125
#define	RNSAP_ID_RL_INFORMATIONLIST_RL_PREEMPTREQUIREDIND								 1
#define	RNSAP_ID_RL_INFORMATIONLIST_RL_RECONFPREPFDD									 126
#define	RNSAP_ID_RL_INFORMATIONRESPONSE_RL_ADDITIONRSPTDD								 127
#define	RNSAP_ID_RL_INFORMATIONRESPONSE_RL_RECONFREADYTDD								 128
#define	RNSAP_ID_RL_INFORMATIONRESPONSE_RL_SETUPRSPTDD									 129
#define	RNSAP_ID_RL_INFORMATIONRESPONSEITEM_RL_ADDITIONRSPFDD							 130
#define	RNSAP_ID_RL_INFORMATIONRESPONSEITEM_RL_RECONFREADYFDD							 131
#define	RNSAP_ID_RL_INFORMATIONRESPONSEITEM_RL_RECONFRSPFDD								 132
#define	RNSAP_ID_RL_INFORMATIONRESPONSEITEM_RL_SETUPRSPFDD								 133
#define	RNSAP_ID_RL_INFORMATIONRESPONSELIST_RL_ADDITIONRSPFDD							 134
#define	RNSAP_ID_RL_INFORMATIONRESPONSELIST_RL_RECONFREADYFDD							 135
#define	RNSAP_ID_RL_INFORMATIONRESPONSELIST_RL_RECONFRSPFDD								 136
#define	RNSAP_ID_RL_INFORMATIONRESPONSE_RL_RECONFRSPTDD									 28
#define	RNSAP_ID_RL_INFORMATIONRESPONSELIST_RL_SETUPRSPFDD								 137
#define	RNSAP_ID_RL_RECONFIGURATIONFAILURE_RL_RECONFFAIL								 141
#define	RNSAP_ID_RL_SET_INFORMATIONITEM_DM_RPRT											 143
#define	RNSAP_ID_RL_SET_INFORMATIONITEM_DM_RQST											 144
#define	RNSAP_ID_RL_SET_INFORMATIONITEM_DM_RSP											 145
#define	RNSAP_ID_RL_SET_INFORMATION_RL_FAILUREIND										 146
#define	RNSAP_ID_RL_SET_INFORMATION_RL_RESTOREIND										 147
#define	RNSAP_ID_RL_SET_SUCCESSFUL_INFORMATIONITEM_DM_FAIL								 473
#define	RNSAP_ID_RL_SET_UNSUCCESSFUL_INFORMATIONITEM_DM_FAIL							 474
#define	RNSAP_ID_RL_SET_UNSUCCESSFUL_INFORMATIONITEM_DM_FAIL_IND						 475
#define	RNSAP_ID_RL_SUCCESSFUL_INFORMATIONITEM_DM_FAIL									 476
#define	RNSAP_ID_RL_UNSUCCESSFUL_INFORMATIONITEM_DM_FAIL								 477
#define	RNSAP_ID_RL_UNSUCCESSFUL_INFORMATIONITEM_DM_FAIL_IND							 478
#define	RNSAP_ID_REPORTCHARACTERISTICS													 152
#define	RNSAP_ID_REPORTING_OBJECT_RL_FAILUREIND											 153
#define	RNSAP_ID_REPORING_OBJECT_RL_RESTOREIND											 154
#define	RNSAP_ID_RT_LOAD_VALUE															 307
#define	RNSAP_ID_RT_LOAD_VALUE_INCRDECRTHRES											 308
#define	RNSAP_ID_S_RNTI																	 155
#define	RNSAP_ID_RESETINDICATOR															 244
#define	RNSAP_ID_RNC_ID																	 245
#define	RNSAP_ID_SAI																	 156
#define	RNSAP_ID_SRNC_ID																 157
#define	RNSAP_ID_SUCCESSFULRL_INFORMATIONRESPONSE_RL_ADDITIONFAILUREFDD					 159
#define	RNSAP_ID_SUCCESSFULRL_INFORMATIONRESPONSE_RL_SETUPFAILUREFDD					 160
#define	RNSAP_ID_TRANSPORTBEARERID														 163
#define	RNSAP_ID_TRANSPORTBEARERREQUESTINDICATOR										 164
#define	RNSAP_ID_TRANSPORTLAYERADDRESS													 165
#define	RNSAP_ID_TYPEOFERROR															 140
#define	RNSAP_ID_UC_ID																	 166
#define	RNSAP_ID_UL_CCTRCH_ADDINFORMATION_RL_RECONFPREPTDD								 167
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONADDLIST_RL_RECONFPREPTDD							 169
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONITEM_RL_SETUPRQSTTDD								 171
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONLIST_RL_SETUPRQSTTDD								 172
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONLISTIE_PHYCHRECONFRQSTTDD							 173
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONLISTIE_RL_ADDITIONRSPTDD							 174
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONLISTIE_RL_RECONFREADYTDD							 175
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONLISTIE_RL_SETUPRSPTDD								 176
#define	RNSAP_ID_UL_DPCH_INFORMATION_RL_RECONFPREPFDD									 177
#define	RNSAP_ID_UL_DPCH_INFORMATION_RL_RECONFRQSTFDD									 178
#define	RNSAP_ID_UL_DPCH_INFORMATION_RL_SETUPRQSTFDD									 179
#define	RNSAP_ID_UL_DPCH_INFORMATIONITEM_PHYCHRECONFRQSTTDD								 180
#define	RNSAP_ID_UL_DPCH_INFORMATIONITEM_RL_ADDITIONRSPTDD								 181
#define	RNSAP_ID_UL_DPCH_INFORMATIONITEM_RL_SETUPRSPTDD									 182
#define	RNSAP_ID_UL_DPCH_INFORMATIONADDLISTIE_RL_RECONFREADYTDD							 183
#define	RNSAP_ID_UL_SIRTARGET															 184
#define	RNSAP_ID_URA_INFORMATION														 185
#define	RNSAP_ID_UNSUCCESSFULRL_INFORMATIONRESPONSE_RL_ADDITIONFAILUREFDD				 188
#define	RNSAP_ID_UNSUCCESSFULRL_INFORMATIONRESPONSE_RL_SETUPFAILUREFDD					 189
#define	RNSAP_ID_UNSUCCESSFULRL_INFORMATIONRESPONSE_RL_SETUPFAILURETDD					 190
#define	RNSAP_ID_ACTIVE_PATTERN_SEQUENCE_INFORMATION									 193
#define	RNSAP_ID_ADJUSTMENTRATIO														 194
#define	RNSAP_ID_CAUSELEVEL_RL_ADDITIONFAILUREFDD										 197
#define	RNSAP_ID_CAUSELEVEL_RL_ADDITIONFAILURETDD										 198
#define	RNSAP_ID_CAUSELEVEL_RL_RECONFFAILURE											 199
#define	RNSAP_ID_CAUSELEVEL_RL_SETUPFAILUREFDD											 200
#define	RNSAP_ID_CAUSELEVEL_RL_SETUPFAILURETDD											 201
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONDELETEITEM_RL_RECONFPREPTDD						 205
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONMODIFYITEM_RL_RECONFPREPTDD						 206
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONMODIFYITEM_RL_RECONFRQSTTDD						 207
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONDELETELIST_RL_RECONFPREPTDD						 208
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONMODIFYLIST_RL_RECONFPREPTDD						 209
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONMODIFYLIST_RL_RECONFRQSTTDD						 210
#define	RNSAP_ID_DL_DPCH_INFORMATIONADDLISTIE_RL_RECONFREADYTDD							 212
#define	RNSAP_ID_DL_DPCH_INFORMATIONDELETELISTIE_RL_RECONFREADYTDD						 213
#define	RNSAP_ID_DL_DPCH_INFORMATIONMODIFYLISTIE_RL_RECONFREADYTDD						 214
#define	RNSAP_ID_DSCHS_TO_ADD_TDD														 215
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_216											 216
#define	RNSAP_ID_DSCH_DELETELIST_RL_RECONFPREPTDD										 217
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_218											 218
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_219											 219
#define	RNSAP_ID_DSCH_INFORMATIONLISTIE_RL_ADDITIONRSPTDD								 220
#define	RNSAP_ID_DSCH_INFORMATIONLISTIES_RL_SETUPRSPTDD									 221
#define	RNSAP_ID_DSCH_TDD_INFORMATION													 222
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_223											 223
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_226											 226
#define	RNSAP_ID_DSCH_MODIFYLIST_RL_RECONFPREPTDD										 227
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_228											 228
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_324											 324
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_229											 229
#define	RNSAP_ID_DSCHTOBEADDEDORMODIFIEDLIST_RL_RECONFREADYTDD							 230
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_29											 29
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_225											 225
#define	RNSAP_ID_GA_CELL																 232
#define	RNSAP_ID_GA_CELLADDITIONALSHAPES												 3
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_246											 246
#define	RNSAP_ID_TRANSMISSION_GAP_PATTERN_SEQUENCE_INFORMATION							 255
#define	RNSAP_ID_UL_CCTRCH_DELETEINFORMATION_RL_RECONFPREPTDD							 256
#define	RNSAP_ID_UL_CCTRCH_MODIFYINFORMATION_RL_RECONFPREPTDD							 257
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONMODIFYITEM_RL_RECONFRQSTTDD						 258
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONDELETELIST_RL_RECONFPREPTDD						 259
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONMODIFYLIST_RL_RECONFPREPTDD						 260
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONMODIFYLIST_RL_RECONFRQSTTDD						 261
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONDELETEITEM_RL_RECONFRQSTTDD						 262
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONDELETELIST_RL_RECONFRQSTTDD						 263
#define	RNSAP_ID_UL_DPCH_INFORMATIONDELETELISTIE_RL_RECONFREADYTDD						 264
#define	RNSAP_ID_UL_DPCH_INFORMATIONMODIFYLISTIE_RL_RECONFREADYTDD						 265
#define	RNSAP_ID_UNSUCCESSFULRL_INFORMATIONRESPONSE_RL_ADDITIONFAILURETDD				 266
#define	RNSAP_ID_USCHS_TO_ADD															 267
#define	RNSAP_ID_USCH_DELETELIST_RL_RECONFPREPTDD										 268
#define	RNSAP_ID_USCH_INFORMATIONLISTIE_RL_ADDITIONRSPTDD								 269
#define	RNSAP_ID_USCH_INFORMATIONLISTIES_RL_SETUPRSPTDD									 270
#define	RNSAP_ID_USCH_INFORMATION														 271
#define	RNSAP_ID_USCH_MODIFYLIST_RL_RECONFPREPTDD										 272
#define	RNSAP_ID_USCHTOBEADDEDORMODIFIEDLIST_RL_RECONFREADYTDD							 273
#define	RNSAP_ID_DL_PHYSICAL_CHANNEL_INFORMATION_RL_SETUPRQSTTDD						 274
#define	RNSAP_ID_UL_PHYSICAL_CHANNEL_INFORMATION_RL_SETUPRQSTTDD						 275
#define	RNSAP_ID_CLOSEDLOOPMODE1_SUPPORTINDICATOR										 276
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_277											 277
#define	RNSAP_ID_STTD_SUPPORTINDICATOR													 279
#define	RNSAP_ID_CFNREPORTINGINDICATOR             										 14
#define	RNSAP_ID_CNORIGINATEDPAGE_PAGINGRQST											 23
#define	RNSAP_ID_INNERLOOPDLPCSTATUS													 24
#define	RNSAP_ID_PROPAGATIONDELAY														 25
#define	RNSAP_ID_RXTIMINGDEVIATIONFORTA													 36
#define	RNSAP_ID_TIMESLOT_ISCP															 37
#define	RNSAP_ID_CCTRCH_INFORMATIONITEM_RL_FAILUREIND									 15
#define	RNSAP_ID_CCTRCH_INFORMATIONITEM_RL_RESTOREIND									 16
#define	RNSAP_ID_COMMONMEASUREMENTACCURACY												 280
#define	RNSAP_ID_COMMONMEASUREMENTOBJECTTYPE_CM_RPRT									 281
#define	RNSAP_ID_COMMONMEASUREMENTOBJECTTYPE_CM_RQST									 282
#define	RNSAP_ID_COMMONMEASUREMENTOBJECTTYPE_CM_RSP										 283
#define	RNSAP_ID_COMMONMEASUREMENTTYPE													 284
#define	RNSAP_ID_CONGESTIONCAUSE 														 18
#define	RNSAP_ID_SFN																	 285
#define	RNSAP_ID_SFNREPORTINGINDICATOR													 286
#define	RNSAP_ID_INFORMATIONEXCHANGEID													 287
#define	RNSAP_ID_INFORMATIONEXCHANGEOBJECTTYPE_INFEX_RPRT								 288
#define	RNSAP_ID_INFORMATIONEXCHANGEOBJECTTYPE_INFEX_RQST								 289
#define	RNSAP_ID_INFORMATIONEXCHANGEOBJECTTYPE_INFEX_RSP								 290
#define	RNSAP_ID_INFORMATIONREPORTCHARACTERISTICS										 291
#define	RNSAP_ID_INFORMATIONTYPE														 292
#define	RNSAP_ID_NEIGHBOURING_LCR_TDD_CELLINFORMATION									 58
#define	RNSAP_ID_DL_TIMESLOT_ISCP_LCR_INFORMATION_RL_SETUPRQSTTDD						 65
#define	RNSAP_ID_RL_LCR_INFORMATIONRESPONSE_RL_SETUPRSPTDD								 66
#define	RNSAP_ID_UL_CCTRCH_LCR_INFORMATIONLISTIE_RL_SETUPRSPTDD							 75
#define	RNSAP_ID_UL_DPCH_LCR_INFORMATIONITEM_RL_SETUPRSPTDD								 76
#define	RNSAP_ID_DL_CCTRCH_LCR_INFORMATIONLISTIE_RL_SETUPRSPTDD							 77
#define	RNSAP_ID_DL_DPCH_LCR_INFORMATIONITEM_RL_SETUPRSPTDD								 78
#define	RNSAP_ID_DSCH_LCR_INFORMATIONLISTIES_RL_SETUPRSPTDD								 79
#define	RNSAP_ID_USCH_LCR_INFORMATIONLISTIES_RL_SETUPRSPTDD								 80
#define	RNSAP_ID_DL_TIMESLOT_ISCP_LCR_INFORMATION_RL_ADDITIONRQSTTDD					 81
#define	RNSAP_ID_RL_LCR_INFORMATIONRESPONSE_RL_ADDITIONRSPTDD							 86
#define	RNSAP_ID_UL_CCTRCH_LCR_INFORMATIONLISTIE_RL_ADDITIONRSPTDD						 87
#define	RNSAP_ID_UL_DPCH_LCR_INFORMATIONITEM_RL_ADDITIONRSPTDD							 88
#define	RNSAP_ID_DL_CCTRCH_LCR_INFORMATIONLISTIE_RL_ADDITIONRSPTDD						 89
#define	RNSAP_ID_DL_DPCH_LCR_INFORMATIONITEM_RL_ADDITIONRSPTDD							 94
#define	RNSAP_ID_DSCH_LCR_INFORMATIONLISTIES_RL_ADDITIONRSPTDD							 96
#define	RNSAP_ID_USCH_LCR_INFORMATIONLISTIES_RL_ADDITIONRSPTDD							 97
#define	RNSAP_ID_UL_DPCH_LCR_INFORMATIONADDLISTIE_RL_RECONFREADYTDD						 98
#define	RNSAP_ID_UL_TIMESLOT_LCR_INFORMATIONMODIFYLIST_RL_RECONFREADYTDD				 100
#define	RNSAP_ID_DL_DPCH_LCR_INFORMATIONADDLISTIE_RL_RECONFREADYTDD						 101
#define	RNSAP_ID_DL_TIMESLOT_LCR_INFORMATIONMODIFYLIST_RL_RECONFREADYTDD				 104
#define	RNSAP_ID_UL_TIMESLOT_LCR_INFORMATIONLIST_PHYCHRECONFRQSTTDD						 105
#define	RNSAP_ID_DL_TIMESLOT_LCR_INFORMATIONLIST_PHYCHRECONFRQSTTDD						 106
#define	RNSAP_ID_TIMESLOT_ISCP_LCR_LIST_DL_PC_RQST_TDD									 138
#define	RNSAP_ID_TSTD_SUPPORT_INDICATOR_RL_SETUPRQSTTDD									 139
#define	RNSAP_ID_RESTRICTIONSTATEINDICATOR												 142
#define	RNSAP_ID_LOAD_VALUE																 233
#define	RNSAP_ID_LOAD_VALUE_INCRDECRTHRES												 234
#define	RNSAP_ID_ONMODIFICATION															 235
#define	RNSAP_ID_RECEIVED_TOTAL_WIDEBAND_POWER_VALUE									 236
#define	RNSAP_ID_RECEIVED_TOTAL_WIDEBAND_POWER_VALUE_INCRDECRTHRES						 237
#define	RNSAP_ID_SFNSFNMEASUREMENTTHRESHOLDINFORMATION									 238
#define	RNSAP_ID_TRANSMITTED_CARRIER_POWER_VALUE										 239
#define	RNSAP_ID_TRANSMITTED_CARRIER_POWER_VALUE_INCRDECRTHRES							 240
#define	RNSAP_ID_TUTRANGPSMEASUREMENTTHRESHOLDINFORMATION								 241
#define	RNSAP_ID_UL_TIMESLOT_ISCP_VALUE													 242
#define	RNSAP_ID_UL_TIMESLOT_ISCP_VALUE_INCRDECRTHRES									 243
#define	RNSAP_ID_RX_TIMING_DEVIATION_VALUE_LCR											 293
#define	RNSAP_ID_DPC_MODE_CHANGE_SUPPORTINDICATOR										 19
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_247											 247
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_295											 295
#define	RNSAP_ID_PRIMARYCCPCH_RSCP_RL_RECONFPREPTDD										 202
#define	RNSAP_ID_DL_TIMESLOT_ISCP_INFO_RL_RECONFPREPTDD									 203
#define	RNSAP_ID_DL_TIMESLOT_ISCP_LCR_INFORMATION_RL_RECONFPREPTDD						 204
#define	RNSAP_ID_DSCH_RNTI																 249
#define	RNSAP_ID_DL_POWERBALANCING_INFORMATION											 296
#define	RNSAP_ID_DL_POWERBALANCING_ACTIVATIONINDICATOR									 297
#define	RNSAP_ID_DL_POWERBALANCING_UPDATEDINDICATOR										 298
#define	RNSAP_ID_DL_REFERENCEPOWERINFORMATION											 299
#define	RNSAP_ID_ENHANCED_PRIMARYCPICH_ECNO												 224
#define	RNSAP_ID_IPDL_TDD_PARAMETERSLCR													 252
#define	RNSAP_ID_CELLCAPABILITYCONTAINER_FDD											 300
#define	RNSAP_ID_CELLCAPABILITYCONTAINER_TDD											 301
#define	RNSAP_ID_CELLCAPABILITYCONTAINER_TDD_LCR										 302
#define	RNSAP_ID_RL_SPECIFIC_DCH_INFO													 317
#define	RNSAP_ID_RL_RECONFIGURATIONREQUESTFDD_RL_INFORMATIONLIST 						 318
#define	RNSAP_ID_RL_RECONFIGURATIONREQUESTFDD_RL_INFORMATION_IES						 319
#define	RNSAP_ID_RL_RECONFIGURATIONREQUESTTDD_RL_INFORMATION							 321
#define	RNSAP_ID_COMMONTRANSPORTCHANNELRESOURCESINITIALISATIONNOTREQUIRED				 250
#define	RNSAP_ID_DELAYEDACTIVATION 														 312
#define	RNSAP_ID_DELAYEDACTIVATIONLIST_RL_ACTIVATIONCMDFDD								 313
#define	RNSAP_ID_DELAYEDACTIVATIONINFORMATION_RL_ACTIVATIONCMDFDD						 314
#define	RNSAP_ID_DELAYEDACTIVATIONLIST_RL_ACTIVATIONCMDTDD								 315
#define	RNSAP_ID_DELAYEDACTIVATIONINFORMATION_RL_ACTIVATIONCMDTDD						 316
#define	RNSAP_ID_NEIGHBOURINGTDDCELLMEASUREMENTINFORMATIONLCR							 251
#define	RNSAP_ID_UL_SIR_TARGET_CCTRCH_INFORMATIONITEM_RL_SETUPRSPTDD					 150
#define	RNSAP_ID_UL_SIR_TARGET_CCTRCH_LCR_INFORMATIONITEM_RL_SETUPRSPTDD				 151
#define	RNSAP_ID_PRIMCCPCH_RSCP_DL_PC_RQSTTDD											 451
#define	RNSAP_ID_HSDSCH_FDD_INFORMATION													 452
#define	RNSAP_ID_HSDSCH_FDD_INFORMATION_RESPONSE										 453
#define	RNSAP_ID_HSDSCH_FDD_UPDATE_INFORMATION											 466
#define	RNSAP_ID_HSDSCH_INFORMATION_TO_MODIFY											 456
#define	RNSAP_ID_HSDSCHMACDFLOWSPECIFICINFORMATIONLIST_RL_PREEMPTREQUIREDIND			 516
#define	RNSAP_ID_HSDSCHMACDFLOWSPECIFICINFORMATIONITEM_RL_PREEMPTREQUIREDIND			 517
#define	RNSAP_ID_HSDSCH_RNTI															 457
#define	RNSAP_ID_HSDSCH_TDD_INFORMATION													 458
#define	RNSAP_ID_HSDSCH_TDD_INFORMATION_RESPONSE										 459
#define	RNSAP_ID_HSDSCH_TDD_UPDATE_INFORMATION											 467
#define	RNSAP_ID_HSPDSCH_RL_ID															 463
#define	RNSAP_ID_HSDSCH_MACDFLOWS_TO_ADD 												 531
#define	RNSAP_ID_HSDSCH_MACDFLOWS_TO_DELETE												 532
#define	RNSAP_ID_ANGLE_OF_ARRIVAL_VALUE_LCR												 148
#define	RNSAP_ID_TRAFFICCLASS															 158
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_248											 248
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_253											 253
#define	RNSAP_ID_PDSCH_RL_ID															 323
#define	RNSAP_ID_TIMESLOT_RL_SETUPRSPTDD												 325
#define	RNSAP_ID_GERAN_CELL_CAPABILITY													 468
#define	RNSAP_ID_GERAN_CLASSMARK														 469
#define	RNSAP_ID_DSCH_INITIALWINDOWSIZE													 480
#define	RNSAP_ID_UL_SYNCHRONISATION_PARAMETERS_LCR										 464
#define	RNSAP_ID_SNA_INFORMATION														 479
#define	RNSAP_ID_MACHS_RESETINDICATOR													 465
#define	RNSAP_ID_TDD_DL_DPCH_TIMESLOTFORMATMODIFYITEM_LCR_RL_RECONFREADYTDD				 481
#define	RNSAP_ID_TDD_UL_DPCH_TIMESLOTFORMATMODIFYITEM_LCR_RL_RECONFREADYTDD				 482
#define	RNSAP_ID_TDD_TPC_UPLINKSTEPSIZE_LCR_RL_SETUPRQSTTDD								 483
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONLIST_RL_ADDITIONRQSTTDD							 484
#define	RNSAP_ID_UL_CCTRCH_INFORMATIONITEM_RL_ADDITIONRQSTTDD							 485
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONLIST_RL_ADDITIONRQSTTDD							 486
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONITEM_RL_ADDITIONRQSTTDD							 487
#define	RNSAP_ID_TDD_TPC_UPLINKSTEPSIZE_INFORMATIONADD_LCR_RL_RECONFPREPTDD				 488
#define	RNSAP_ID_TDD_TPC_UPLINKSTEPSIZE_INFORMATIONMODIFY_LCR_RL_RECONFPREPTDD			 489
#define	RNSAP_ID_TDD_TPC_DOWNLINKSTEPSIZE_INFORMATIONADD_RL_RECONFPREPTDD				 490
#define	RNSAP_ID_TDD_TPC_DOWNLINKSTEPSIZE_INFORMATIONMODIFY_RL_RECONFPREPTDD			 491
#define	RNSAP_ID_UL_TIMINGADVANCECTRL_LCR												 492
#define	RNSAP_ID_HSPDSCH_TIMESLOT_INFORMATIONLIST_PHYCHRECONFRQSTTDD					 493
#define	RNSAP_ID_HSPDSCH_TIMESLOT_INFORMATIONLISTLCR_PHYCHRECONFRQSTTDD					 494
#define	RNSAP_ID_HS_SICH_RECEPTION_QUALITY 												 495
#define	RNSAP_ID_HS_SICH_RECEPTION_QUALITY_MEASUREMENT_VALUE 							 496
#define	RNSAP_ID_HSSICH_INFO_DM_RPRT													 497
#define	RNSAP_ID_HSSICH_INFO_DM_RQST													 498
#define	RNSAP_ID_HSSICH_INFO_DM															 499
#define	RNSAP_ID_CCTRCH_MAXIMUM_DL_POWER_RL_SETUPRSPTDD									 500
#define	RNSAP_ID_CCTRCH_MINIMUM_DL_POWER_RL_SETUPRSPTDD									 501
#define	RNSAP_ID_CCTRCH_MAXIMUM_DL_POWER_RL_ADDITIONRSPTDD								 502
#define	RNSAP_ID_CCTRCH_MINIMUM_DL_POWER_RL_ADDITIONRSPTDD								 503
#define	RNSAP_ID_CCTRCH_MAXIMUM_DL_POWER_RL_RECONFREADYTDD								 504
#define	RNSAP_ID_CCTRCH_MINIMUM_DL_POWER_RL_RECONFREADYTDD								 505
#define	RNSAP_ID_MAXIMUM_DL_POWER_TIMESLOTLCR_INFORMATIONMODIFYITEM_RL_RECONFREADYTDD	 506
#define	RNSAP_ID_MINIMUM_DL_POWER_TIMESLOTLCR_INFORMATIONMODIFYITEM_RL_RECONFREADYTDD	 507
#define	RNSAP_ID_DL_CCTRCH_INFORMATIONLIST_RL_RECONFRSPTDD								 508
#define	RNSAP_ID_DL_DPCH_INFORMATIONMODIFYITEM_LCR_RL_RECONFRSPTDD						 509
#define	RNSAP_ID_MAXIMUM_DL_POWER_TIMESLOTLCR_INFORMATIONITEM							 510
#define	RNSAP_ID_MINIMUM_DL_POWER_TIMESLOTLCR_INFORMATIONITEM							 511
#define	RNSAP_ID_TDD_SUPPORT_8PSK														 512
#define	RNSAP_ID_TDD_MAXNRDLPHYSICALCHANNELS											 513
#define	RNSAP_ID_EXTENDEDGSMCELLINDIVIDUALOFFSET										 514
#define	RNSAP_ID_RL_PARAMETERUPDATEINDICATIONFDD_RL_INFORMATIONLIST 					 518
#define	RNSAP_ID_PRIMARY_CPICH_USAGE_FOR_CHANNEL_ESTIMATION								 519
#define	RNSAP_ID_SECONDARY_CPICH_INFORMATION											 520
#define	RNSAP_ID_SECONDARY_CPICH_INFORMATION_CHANGE										 521
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_522											 522
#define	RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_523											 523
#define	RNSAP_ID_RL_PARAMETERUPDATEINDICATIONFDD_RL_INFORMATION_ITEM					 524
#define	RNSAP_ID_PHASE_REFERENCE_UPDATE_INDICATOR										 525
#define	RNSAP_ID_UNIDIRECTIONAL_DCH_INDICATOR											 526
#define	RNSAP_ID_RL_INFORMATION_RL_RECONFPREPTDD										 527
#define	RNSAP_ID_MULTIPLE_RL_INFORMATIONRESPONSE_RL_RECONFREADYTDD						 528
#define	RNSAP_ID_RL_RECONFIGURATIONRESPONSETDD_RL_INFORMATION							 529
#define	RNSAP_ID_SATELLITE_ALMANAC_INFORMATION_EXTITEM									 530
#define	RNSAP_ID_HSDSCH_INFORMATION_TO_MODIFY_UNSYNCHRONISED							 533
#define	RNSAP_ID_TNLQOS																	 534
#define	RNSAP_ID_RTLOADVALUE															 535
#define	RNSAP_ID_NRTLOADINFORMATIONVALUE												 536
#define	RNSAP_ID_CELLPORTIONID															 537
#define	RNSAP_ID_UPPTSINTERFERENCEVALUE													 538
#define	RNSAP_ID_PRIMARYCCPCH_RSCP_DELTA												 539
#define	RNSAP_ID_UEMEASUREMENTTYPE														 540
#define	RNSAP_ID_UEMEASUREMENTTIMESLOTINFOHCR											 541
#define	RNSAP_ID_UEMEASUREMENTTIMESLOTINFOLCR											 542
#define	RNSAP_ID_UEMEASUREMENTREPORTCHARACTERISTICS										 543
#define	RNSAP_ID_UEMEASUREMENTPARAMETERMODALLOW											 544
#define	RNSAP_ID_UEMEASUREMENTVALUEINFORMATION											 545
#define	RNSAP_ID_INTERFACESTOTRACEITEM													 546
#define	RNSAP_ID_LISTOFINTERFACESTOTRACE												 547
#define	RNSAP_ID_TRACEDEPTH																 548
#define	RNSAP_ID_TRACERECORDINGSESSIONREFERENCE											 549
#define	RNSAP_ID_TRACEREFERENCE															 550
#define	RNSAP_ID_UEIDENTITY																 551
#define	RNSAP_ID_NACC_RELATED_DATA														 552
#define	RNSAP_ID_GSM_CELL_INFEX_RQST													 553
#define	RNSAP_ID_MEASUREMENTRECOVERYBEHAVIOR											 554
#define	RNSAP_ID_MEASUREMENTRECOVERYREPORTINGINDICATOR									 555
#define	RNSAP_ID_MEASUREMENTRECOVERYSUPPORTINDICATOR									 556
#define	RNSAP_ID_DL_DPCH_POWER_INFORMATION_RL_RECONFPREPFDD								 557
#define	RNSAP_ID_F_DPCH_INFORMATION_RL_RECONFPREPFDD									 558
#define	RNSAP_ID_F_DPCH_INFORMATION_RL_SETUPRQSTFDD										 559
#define	RNSAP_ID_MBMS_BEARER_SERVICE_LIST												 560
#define	RNSAP_ID_MBMS_BEARER_SERVICE_LIST_INFEX_RSP										 561
#define	RNSAP_ID_ACTIVE_MBMS_BEARER_SERVICEFDD											 562
#define	RNSAP_ID_ACTIVE_MBMS_BEARER_SERVICETDD											 563
#define	RNSAP_ID_OLD_URA_ID																 564
#define	RNSAP_ID_UE_STATE																 568
#define	RNSAP_ID_URA_ID																	 569
#define	RNSAP_ID_HARQ_PREAMBLE_MODE														 571
#define	RNSAP_ID_SYNCHRONISATIONINDICATOR												 572
#define	RNSAP_ID_UL_DPDCHINDICATOREDCH													 573
#define	RNSAP_ID_EDPCH_INFORMATION														 574
#define	RNSAP_ID_RL_SPECIFIC_EDCH_INFORMATION											 575
#define	RNSAP_ID_EDCH_RL_INDICATION														 576
#define	RNSAP_ID_EDCH_FDD_INFORMATION													 577
#define	RNSAP_ID_EDCH_RLSET_ID															 578
#define	RNSAP_ID_SERVING_EDCHRL_ID														 579
#define	RNSAP_ID_EDCH_FDD_DL_CONTROLCHANNELINFORMATION									 580
#define	RNSAP_ID_EDCH_FDD_INFORMATIONRESPONSE											 581
#define	RNSAP_ID_EDCH_MACDFLOWS_TO_ADD													 582
#define	RNSAP_ID_EDCH_FDD_INFORMATION_TO_MODIFY											 583
#define	RNSAP_ID_EDCH_MACDFLOWS_TO_DELETE												 584
#define	RNSAP_ID_EDPCH_INFORMATION_RLRECONFREQUEST_FDD									 585
#define	RNSAP_ID_EDCH_MACDFLOWSPECIFICINFORMATIONLIST_RL_PREEMPTREQUIREDIND				 586
#define	RNSAP_ID_EDCH_MACDFLOWSPECIFICINFORMATIONITEM_RL_PREEMPTREQUIREDIND				 587
#define	RNSAP_ID_EDCH_MACDFLOWSPECIFICINFORMATIONLIST_RL_CONGESTIND  					 588
#define	RNSAP_ID_EDCH_MACDFLOWSPECIFICINFORMATIONITEM_RL_CONGESTIND						 589
#define	RNSAP_ID_MBMS_BEARER_SERVICE_FULL_ADDRESS										 590
#define	RNSAP_ID_INITIAL_DL_DPCH_TIMINGADJUSTMENT										 591
#define	RNSAP_ID_INITIAL_DL_DPCH_TIMINGADJUSTMENT_ALLOWED								 592
#define	RNSAP_ID_USER_PLANE_CONGESTION_FIELDS_INCLUSION									 593
#define	RNSAP_ID_HARQ_PREAMBLE_MODE_ACTIVATION_INDICATOR								 594
#define	RNSAP_ID_MULTIPLE_DEDICATEDMEASUREMENTVALUELIST_TDD_DM_RSP						 595
#define	RNSAP_ID_MULTIPLE_DEDICATEDMEASUREMENTVALUELIST_LCR_TDD_DM_RSP					 596
#define	RNSAP_ID_PROVIDEDINFORMATION													 597
#define	RNSAP_ID_ACTIVE_MBMS_BEARER_SERVICEFDD_PFL										 598
#define	RNSAP_ID_ACTIVE_MBMS_BEARER_SERVICETDD_PFL										 599
#define	RNSAP_ID_FREQUENCYBANDINDICATOR													 600
static dissector_handle_t rnsap_handle=NULL;

/* Initialize the protocol and registered fields */
static int proto_rnsap = -1;

static int hf_rnsap_pdu_length = -1;
static int hf_rnsap_IE_length = -1;


/*--- Included file: packet-rnsap-hf.c ---*/
#line 1 "packet-rnsap-hf.c"
static int hf_rnsap_RNSAP_PDU_PDU = -1;           /* RNSAP_PDU */
static int hf_rnsap_initiatingMessage = -1;       /* InitiatingMessage */
static int hf_rnsap_successfulOutcome = -1;       /* SuccessfulOutcome */
static int hf_rnsap_unsuccessfulOutcome = -1;     /* UnsuccessfulOutcome */
static int hf_rnsap_outcome = -1;                 /* Outcome */
static int hf_rnsap_procedureID = -1;             /* ProcedureID */
static int hf_rnsap_criticality = -1;             /* Criticality */
static int hf_rnsap_transactionID = -1;           /* TransactionID */
static int hf_rnsap_initiatingMessageValue = -1;  /* InitiatingMessageValue */
static int hf_rnsap_successfulOutcomeValue = -1;  /* SuccessfulOutcomeValue */
static int hf_rnsap_unsuccessfulOutcomeValue = -1;  /* UnsuccessfulOutcomeValue */
static int hf_rnsap_outcomeValue = -1;            /* OutcomeValue */
static int hf_rnsap_id_downlinkSignallingTransfer = -1;  /* DownlinkSignallingTransferRequest */
static int hf_rnsap_id_physicalChannelReconfiguration = -1;  /* PhysicalChannelReconfigurationRequestTDD */
static int hf_rnsap_id_privateMessage = -1;       /* PrivateMessage */
static int hf_rnsap_id_radioLinkAddition = -1;    /* RadioLinkAdditionRequestFDD */
static int hf_rnsap_id_radioLinkAddition_TDD = -1;  /* RadioLinkAdditionRequestTDD */
static int hf_rnsap_id_radioLinkDeletion = -1;    /* RadioLinkDeletionRequest */
static int hf_rnsap_id_radioLinkSetup = -1;       /* RadioLinkSetupRequestFDD */
static int hf_rnsap_id_radioLinkSetupTdd = -1;    /* RadioLinkSetupRequestTDD */
static int hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation = -1;  /* RadioLinkReconfigurationPrepareFDD */
static int hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation_TDD = -1;  /* RadioLinkReconfigurationReadyTDD */
static int hf_rnsap_id_unSynchronisedRadioLinkReconfiguration = -1;  /* RadioLinkReconfigurationRequestFDD */
static int hf_rnsap_id_unSynchronisedRadioLinkReconfiguration_TDD = -1;  /* RadioLinkReconfigurationRequestTDD */
static int hf_rnsap_id_physicalChannelReconfiguration1 = -1;  /* PhysicalChannelReconfigurationCommand */
static int hf_rnsap_id_radioLinkAddition1 = -1;   /* RadioLinkAdditionResponseFDD */
static int hf_rnsap_id_radioLinkAddition_TDD1 = -1;  /* RadioLinkAdditionResponseTDD */
static int hf_rnsap_id_radioLinkDeletion1 = -1;   /* RadioLinkDeletionResponse */
static int hf_rnsap_id_radioLinkSetup1 = -1;      /* RadioLinkSetupResponseFDD */
static int hf_rnsap_id_radioLinkSetupTdd1 = -1;   /* RadioLinkSetupResponseTDD */
static int hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation1 = -1;  /* RadioLinkReconfigurationReadyFDD */
static int hf_rnsap_id_unSynchronisedRadioLinkReconfiguration1 = -1;  /* RadioLinkReconfigurationResponseFDD */
static int hf_rnsap_id_unSynchronisedRadioLinkReconfiguration_TDD1 = -1;  /* RadioLinkReconfigurationResponseTDD */
static int hf_rnsap_id_physicalChannelReconfiguration2 = -1;  /* PhysicalChannelReconfigurationFailure */
static int hf_rnsap_id_radioLinkAddition2 = -1;   /* RadioLinkAdditionFailureFDD */
static int hf_rnsap_id_radioLinkAddition_TDD2 = -1;  /* RadioLinkAdditionFailureTDD */
static int hf_rnsap_id_radioLinkSetup2 = -1;      /* RadioLinkSetupFailureFDD */
static int hf_rnsap_id_radioLinkSetupTdd2 = -1;   /* RadioLinkSetupFailureTDD */
static int hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation2 = -1;  /* RadioLinkReconfigurationFailure */
static int hf_rnsap_id_unSynchronisedRadioLinkReconfiguration2 = -1;  /* RadioLinkReconfigurationFailure */
static int hf_rnsap_id_unSynchronisedRadioLinkReconfiguration_TDD2 = -1;  /* RadioLinkReconfigurationFailure */
static int hf_rnsap_id_AllowedQueuingTime = -1;   /* AllowedQueuingTime */
static int hf_rnsap_id_Allowed_Rate_Information = -1;  /* Allowed_Rate_Information */
static int hf_rnsap_id_AntennaColocationIndicator = -1;  /* AntennaColocationIndicator */
static int hf_rnsap_id_BindingID = -1;            /* BindingID */
static int hf_rnsap_id_C_ID = -1;                 /* C_ID */
static int hf_rnsap_id_C_RNTI = -1;               /* C_RNTI */
static int hf_rnsap_id_Cell_Capacity_Class_Value = -1;  /* Cell_Capacity_Class_Value */
static int hf_rnsap_id_CFN = -1;                  /* CFN */
static int hf_rnsap_id_CN_CS_DomainIdentifier = -1;  /* CN_CS_DomainIdentifier */
static int hf_rnsap_id_CN_PS_DomainIdentifier = -1;  /* CN_PS_DomainIdentifier */
static int hf_rnsap_id_Cause = -1;                /* Cause */
static int hf_rnsap_id_CoverageIndicator = -1;    /* CoverageIndicator */
static int hf_rnsap_id_CriticalityDiagnostics = -1;  /* CriticalityDiagnostics */
static int hf_rnsap_id_ContextInfoItem_Reset = -1;  /* ContextInfoItem_Reset */
static int hf_rnsap_id_ContextGroupInfoItem_Reset = -1;  /* ContextGroupInfoItem_Reset */
static int hf_rnsap_id_D_RNTI = -1;               /* D_RNTI */
static int hf_rnsap_id_D_RNTI_ReleaseIndication = -1;  /* D_RNTI_ReleaseIndication */
static int hf_rnsap_id_DCHs_to_Add_FDD = -1;      /* DCH_FDD_Information */
static int hf_rnsap_id_DCHs_to_Add_TDD = -1;      /* DCH_TDD_Information */
static int hf_rnsap_id_DCH_DeleteList_RL_ReconfPrepFDD = -1;  /* DCH_DeleteList_RL_ReconfPrepFDD */
static int hf_rnsap_id_DCH_DeleteList_RL_ReconfPrepTDD = -1;  /* DCH_DeleteList_RL_ReconfPrepTDD */
static int hf_rnsap_id_DCH_DeleteList_RL_ReconfRqstFDD = -1;  /* DCH_DeleteList_RL_ReconfRqstFDD */
static int hf_rnsap_id_DCH_DeleteList_RL_ReconfRqstTDD = -1;  /* DCH_DeleteList_RL_ReconfRqstTDD */
static int hf_rnsap_id_DCH_FDD_Information = -1;  /* DCH_FDD_Information */
static int hf_rnsap_id_DCH_TDD_Information = -1;  /* DCH_TDD_Information */
static int hf_rnsap_id_FDD_DCHs_to_Modify = -1;   /* FDD_DCHs_to_Modify */
static int hf_rnsap_id_TDD_DCHs_to_Modify = -1;   /* TDD_DCHs_to_Modify */
static int hf_rnsap_id_DCH_InformationResponse = -1;  /* DCH_InformationResponse */
static int hf_rnsap_id_DCH_Rate_InformationItem_RL_CongestInd = -1;  /* DCH_Rate_InformationItem_RL_CongestInd */
static int hf_rnsap_id_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD = -1;  /* DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD */
static int hf_rnsap_id_DL_CCTrCH_InformationListIE_RL_ReconfReadyTDD = -1;  /* DL_CCTrCHInformationListIE_RL_ReconfReadyTDD */
static int hf_rnsap_id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = -1;  /* DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD */
static int hf_rnsap_id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD = -1;  /* DL_CCTrCH_InformationItem_RL_SetupRqstTDD */
static int hf_rnsap_id_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD = -1;  /* DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD */
static int hf_rnsap_id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD = -1;  /* DL_CCTrCHInformationListIE_RL_AdditionRspTDD */
static int hf_rnsap_id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD = -1;  /* DL_CCTrCH_InformationItem_RL_SetupRqstTDD */
static int hf_rnsap_id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = -1;  /* DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD */
static int hf_rnsap_id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = -1;  /* DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD */
static int hf_rnsap_id_DL_CCTrCH_InformationList_RL_SetupRqstTDD = -1;  /* DL_CCTrCH_InformationList_RL_SetupRqstTDD */
static int hf_rnsap_id_FDD_DL_CodeInformation = -1;  /* FDD_DL_CodeInformation */
static int hf_rnsap_id_DL_DPCH_Information_RL_ReconfPrepFDD = -1;  /* DL_DPCH_Information_RL_ReconfPrepFDD */
static int hf_rnsap_id_DL_DPCH_Information_RL_SetupRqstFDD = -1;  /* DL_DPCH_Information_RL_SetupRqstFDD */
static int hf_rnsap_id_DL_DPCH_Information_RL_ReconfRqstFDD = -1;  /* DL_DPCH_Information_RL_ReconfRqstFDD */
static int hf_rnsap_id_DL_DPCH_InformationItem_PhyChReconfRqstTDD = -1;  /* DL_DPCH_InformationItem_PhyChReconfRqstTDD */
static int hf_rnsap_id_DL_DPCH_InformationItem_RL_AdditionRspTDD = -1;  /* DL_DPCH_InformationItem_RL_AdditionRspTDD */
static int hf_rnsap_id_DL_DPCH_InformationItem_RL_SetupRspTDD = -1;  /* DL_DPCH_InformationItem_RL_SetupRspTDD */
static int hf_rnsap_id_DL_DPCH_TimingAdjustment = -1;  /* DL_DPCH_TimingAdjustment */
static int hf_rnsap_id_DLReferencePower = -1;     /* DL_Power */
static int hf_rnsap_id_DLReferencePowerList_DL_PC_Rqst = -1;  /* DL_ReferencePowerInformationList_DL_PC_Rqst */
static int hf_rnsap_id_DL_ReferencePowerInformation_DL_PC_Rqst = -1;  /* DL_ReferencePowerInformation_DL_PC_Rqst */
static int hf_rnsap_id_DPC_Mode = -1;             /* DPC_Mode */
static int hf_rnsap_id_DRXCycleLengthCoefficient = -1;  /* DRXCycleLengthCoefficient */
static int hf_rnsap_id_DedicatedMeasurementObjectType_DM_Fail_Ind = -1;  /* DedicatedMeasurementObjectType_DM_Fail_Ind */
static int hf_rnsap_id_DedicatedMeasurementObjectType_DM_Fail = -1;  /* DedicatedMeasurementObjectType_DM_Fail */
static int hf_rnsap_id_DedicatedMeasurementObjectType_DM_Rprt = -1;  /* DedicatedMeasurementObjectType_DM_Rprt */
static int hf_rnsap_id_DedicatedMeasurementObjectType_DM_Rqst = -1;  /* DedicatedMeasurementObjectType_DM_Rqst */
static int hf_rnsap_id_DedicatedMeasurementObjectType_DM_Rsp = -1;  /* DedicatedMeasurementObjectType_DM_Rsp */
static int hf_rnsap_id_DedicatedMeasurementType = -1;  /* DedicatedMeasurementType */
static int hf_rnsap_id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD = -1;  /* FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD */
static int hf_rnsap_id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD = -1;  /* FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD */
static int hf_rnsap_id_Guaranteed_Rate_Information = -1;  /* Guaranteed_Rate_Information */
static int hf_rnsap_id_IMSI = -1;                 /* IMSI */
static int hf_rnsap_id_HCS_Prio = -1;             /* HCS_Prio */
static int hf_rnsap_id_L3_Information = -1;       /* L3_Information */
static int hf_rnsap_id_AdjustmentPeriod = -1;     /* AdjustmentPeriod */
static int hf_rnsap_id_MaxAdjustmentStep = -1;    /* MaxAdjustmentStep */
static int hf_rnsap_id_MeasurementFilterCoefficient = -1;  /* MeasurementFilterCoefficient */
static int hf_rnsap_id_MessageStructure = -1;     /* MessageStructure */
static int hf_rnsap_id_MeasurementID = -1;        /* MeasurementID */
static int hf_rnsap_id_Neighbouring_GSM_CellInformation = -1;  /* Neighbouring_GSM_CellInformation */
static int hf_rnsap_id_Neighbouring_UMTS_CellInformationItem = -1;  /* Neighbouring_UMTS_CellInformationItem */
static int hf_rnsap_id_NRT_Load_Information_Value = -1;  /* NRT_Load_Information_Value */
static int hf_rnsap_id_NRT_Load_Information_Value_IncrDecrThres = -1;  /* NRT_Load_Information_Value_IncrDecrThres */
static int hf_rnsap_id_PagingArea_PagingRqst = -1;  /* PagingArea_PagingRqst */
static int hf_rnsap_id_FACH_FlowControlInformation = -1;  /* FACH_FlowControlInformation */
static int hf_rnsap_id_PartialReportingIndicator = -1;  /* PartialReportingIndicator */
static int hf_rnsap_id_Permanent_NAS_UE_Identity = -1;  /* Permanent_NAS_UE_Identity */
static int hf_rnsap_id_PowerAdjustmentType = -1;  /* PowerAdjustmentType */
static int hf_rnsap_id_RANAP_RelocationInformation = -1;  /* RANAP_RelocationInformation */
static int hf_rnsap_id_RL_Information_PhyChReconfRqstFDD = -1;  /* RL_Information_PhyChReconfRqstFDD */
static int hf_rnsap_id_RL_Information_PhyChReconfRqstTDD = -1;  /* RL_Information_PhyChReconfRqstTDD */
static int hf_rnsap_id_RL_Information_RL_AdditionRqstFDD = -1;  /* RL_Information_RL_AdditionRqstFDD */
static int hf_rnsap_id_RL_Information_RL_AdditionRqstTDD = -1;  /* RL_Information_RL_AdditionRqstTDD */
static int hf_rnsap_id_RL_Information_RL_DeletionRqst = -1;  /* RL_Information_RL_DeletionRqst */
static int hf_rnsap_id_RL_Information_RL_FailureInd = -1;  /* RL_Information_RL_FailureInd */
static int hf_rnsap_id_RL_Information_RL_ReconfPrepFDD = -1;  /* RL_Information_RL_ReconfPrepFDD */
static int hf_rnsap_id_RL_Information_RL_RestoreInd = -1;  /* RL_Information_RL_RestoreInd */
static int hf_rnsap_id_RL_Information_RL_SetupRqstFDD = -1;  /* RL_InformationList_RL_SetupRqstFDD */
static int hf_rnsap_id_RL_Information_RL_SetupRqstTDD = -1;  /* RL_Information_RL_SetupRqstTDD */
static int hf_rnsap_id_RL_InformationItem_RL_CongestInd = -1;  /* RL_InformationItem_RL_CongestInd */
static int hf_rnsap_id_RL_InformationItem_DM_Rprt = -1;  /* RL_InformationItem_DM_Rprt */
static int hf_rnsap_id_RL_InformationItem_DM_Rqst = -1;  /* RL_InformationItem_DM_Rqst */
static int hf_rnsap_id_RL_InformationItem_DM_Rsp = -1;  /* RL_InformationItem_DM_Rsp */
static int hf_rnsap_id_RL_InformationItem_RL_PreemptRequiredInd = -1;  /* RL_InformationItem_RL_PreemptRequiredInd */
static int hf_rnsap_id_RL_InformationItem_RL_SetupRqstFDD = -1;  /* RL_InformationItem_RL_SetupRqstFDD */
static int hf_rnsap_id_RL_InformationList_RL_CongestInd = -1;  /* RL_InformationList_RL_CongestInd */
static int hf_rnsap_id_RL_InformationList_RL_AdditionRqstFDD = -1;  /* RL_InformationList_RL_AdditionRqstFDD */
static int hf_rnsap_id_RL_InformationList_RL_DeletionRqst = -1;  /* RL_InformationList_RL_DeletionRqst */
static int hf_rnsap_id_RL_InformationList_RL_PreemptRequiredInd = -1;  /* RL_InformationList_RL_PreemptRequiredInd */
static int hf_rnsap_id_RL_InformationList_RL_ReconfPrepFDD = -1;  /* RL_InformationList_RL_ReconfPrepFDD */
static int hf_rnsap_id_RL_InformationResponse_RL_AdditionRspTDD = -1;  /* RL_InformationResponse_RL_AdditionRspTDD */
static int hf_rnsap_id_RL_InformationResponse_RL_ReconfReadyTDD = -1;  /* RL_InformationResponse_RL_ReconfReadyTDD */
static int hf_rnsap_id_RL_InformationResponse_RL_SetupRspTDD = -1;  /* RL_InformationResponse_RL_SetupRspTDD */
static int hf_rnsap_id_RL_InformationResponseItem_RL_AdditionRspFDD = -1;  /* RL_InformationResponseItem_RL_AdditionRspFDD */
static int hf_rnsap_id_RL_InformationResponseItem_RL_ReconfReadyFDD = -1;  /* RL_InformationResponseItem_RL_ReconfReadyFDD */
static int hf_rnsap_id_RL_InformationResponseItem_RL_ReconfRspFDD = -1;  /* RL_InformationResponseItem_RL_ReconfRspFDD */
static int hf_rnsap_id_RL_InformationResponseItem_RL_SetupRspFDD = -1;  /* RL_InformationResponseItem_RL_SetupRspFDD */
static int hf_rnsap_id_RL_InformationResponseList_RL_AdditionRspFDD = -1;  /* RL_InformationResponseList_RL_AdditionRspFDD */
static int hf_rnsap_id_RL_InformationResponseList_RL_ReconfReadyFDD = -1;  /* RL_InformationResponseList_RL_ReconfReadyFDD */
static int hf_rnsap_id_RL_InformationResponseList_RL_ReconfRspFDD = -1;  /* RL_InformationResponseList_RL_ReconfRspFDD */
static int hf_rnsap_id_RL_InformationResponse_RL_ReconfRspTDD = -1;  /* RL_InformationResponse_RL_ReconfRspTDD */
static int hf_rnsap_id_RL_InformationResponseList_RL_SetupRspFDD = -1;  /* RL_InformationResponseList_RL_SetupRspFDD */
static int hf_rnsap_id_RL_ReconfigurationFailure_RL_ReconfFail = -1;  /* RL_ReconfigurationFailure_RL_ReconfFail */
static int hf_rnsap_id_RL_Set_InformationItem_DM_Rprt = -1;  /* RL_Set_InformationItem_DM_Rprt */
static int hf_rnsap_id_RL_Set_InformationItem_DM_Rqst = -1;  /* RL_Set_InformationItem_DM_Rqst */
static int hf_rnsap_id_RL_Set_InformationItem_DM_Rsp = -1;  /* RL_Set_InformationItem_DM_Rsp */
static int hf_rnsap_id_RL_Set_Information_RL_FailureInd = -1;  /* RL_Set_Information_RL_FailureInd */
static int hf_rnsap_id_RL_Set_Information_RL_RestoreInd = -1;  /* RL_Set_Information_RL_RestoreInd */
static int hf_rnsap_id_RL_Set_Successful_InformationItem_DM_Fail = -1;  /* RL_Set_Successful_InformationItem_DM_Fail */
static int hf_rnsap_id_RL_Set_Unsuccessful_InformationItem_DM_Fail = -1;  /* RL_Set_Unsuccessful_InformationItem_DM_Fail */
static int hf_rnsap_id_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind = -1;  /* RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind */
static int hf_rnsap_id_RL_Successful_InformationItem_DM_Fail = -1;  /* RL_Successful_InformationItem_DM_Fail */
static int hf_rnsap_id_RL_Unsuccessful_InformationItem_DM_Fail = -1;  /* RL_Unsuccessful_InformationItem_DM_Fail */
static int hf_rnsap_id_RT_Load_Value = -1;        /* RT_Load_Value */
static int hf_rnsap_id_RT_Load_Value_IncrDecrThres = -1;  /* RT_Load_Value_IncrDecrThres */
static int hf_rnsap_id_S_RNTI = -1;               /* S_RNTI */
static int hf_rnsap_id_ResetIndicator = -1;       /* ResetIndicator */
static int hf_rnsap_id_RNC_ID = -1;               /* RNC_ID */
static int hf_rnsap_id_SAI = -1;                  /* SAI */
static int hf_rnsap_id_SRNC_ID = -1;              /* RNC_ID */
static int hf_rnsap_id_UL_DPCH_Information_RL_SetupRqstFDD = -1;  /* UL_DPCH_Information_RL_SetupRqstFDD */
static int hf_rnsap_id_Old_URA_ID = -1;           /* URA_ID */
static int hf_rnsap_id_UE_State = -1;             /* UE_State */
static int hf_rnsap_id_URA_ID = -1;               /* URA_ID */
static int hf_rnsap_id_HARQ_Preamble_Mode = -1;   /* HARQ_Preamble_Mode */
static int hf_rnsap_id_SynchronisationIndicator = -1;  /* SynchronisationIndicator */
static int hf_rnsap_id_UL_DPDCHIndicatorEDCH = -1;  /* UL_DPDCHIndicatorEDCH */
static int hf_rnsap_id_EDPCH_Information_RLReconfRequest_FDD = -1;  /* EDPCH_Information_RLReconfRequest_FDD */
static int hf_rnsap_id_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd = -1;  /* EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd */
static int hf_rnsap_id_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd = -1;  /* EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd */
static int hf_rnsap_id_EDCH_MacdFlowSpecificInformationList_RL_CongestInd = -1;  /* EDCH_MacdFlowSpecificInformationList_RL_CongestInd */
static int hf_rnsap_id_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd = -1;  /* EDCH_MacdFlowSpecificInformationItem_RL_CongestInd */
static int hf_rnsap_id_MBMS_Bearer_Service_Full_Address = -1;  /* MBMS_Bearer_Service_Full_Address */
static int hf_rnsap_id_Initial_DL_DPCH_TimingAdjustment = -1;  /* DL_DPCH_TimingAdjustment */
static int hf_rnsap_id_Initial_DL_DPCH_TimingAdjustment_Allowed = -1;  /* Initial_DL_DPCH_TimingAdjustment_Allowed */
static int hf_rnsap_id_User_Plane_Congestion_Fields_Inclusion = -1;  /* User_Plane_Congestion_Fields_Inclusion */
static int hf_rnsap_id_HARQ_Preamble_Mode_Activation_Indicator = -1;  /* HARQ_Preamble_Mode_Activation_Indicator */
static int hf_rnsap_id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp = -1;  /* Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp */
static int hf_rnsap_id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp = -1;  /* Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp */
static int hf_rnsap_id_ProvidedInformation = -1;  /* ProvidedInformation */
static int hf_rnsap_id_Active_MBMS_Bearer_ServiceFDD_PFL = -1;  /* Active_MBMS_Bearer_Service_ListTDD_PFL */
static int hf_rnsap_id_Active_MBMS_Bearer_ServiceTDD_PFL = -1;  /* Active_MBMS_Bearer_Service_ListTDD_PFL */
static int hf_rnsap_id_FrequencyBandIndicator = -1;  /* FrequencyBandIndicator */
static int hf_rnsap_protocolIEs = -1;             /* ProtocolIE_Container */
static int hf_rnsap_protocolExtensions = -1;      /* ProtocolExtensionContainer */
static int hf_rnsap_ul_ScramblingCode = -1;       /* UL_ScramblingCode */
static int hf_rnsap_minUL_ChannelisationCodeLength = -1;  /* MinUL_ChannelisationCodeLength */
static int hf_rnsap_maxNrOfUL_DPCHs = -1;         /* MaxNrOfUL_DPCHs */
static int hf_rnsap_ul_PunctureLimit = -1;        /* PunctureLimit */
static int hf_rnsap_ul_TFCS = -1;                 /* TFCS */
static int hf_rnsap_ul_DPCCH_SlotFormat = -1;     /* UL_DPCCH_SlotFormat */
static int hf_rnsap_ul_SIRTarget = -1;            /* UL_SIR */
static int hf_rnsap_diversityMode = -1;           /* DiversityMode */
static int hf_rnsap_not_Used_sSDT_CellIdLength = -1;  /* NULL */
static int hf_rnsap_not_Used_s_FieldLength = -1;  /* NULL */
static int hf_rnsap_iE_Extensions = -1;           /* ProtocolExtensionContainer */
static int hf_rnsap_tFCS = -1;                    /* TFCS */
static int hf_rnsap_dl_DPCH_SlotFormat = -1;      /* DL_DPCH_SlotFormat */
static int hf_rnsap_nrOfDLchannelisationcodes = -1;  /* NrOfDLchannelisationcodes */
static int hf_rnsap_tFCI_SignallingMode = -1;     /* TFCI_SignallingMode */
static int hf_rnsap_tFCI_Presence = -1;           /* TFCI_Presence */
static int hf_rnsap_multiplexingPosition = -1;    /* MultiplexingPosition */
static int hf_rnsap_powerOffsetInformation = -1;  /* PowerOffsetInformation_RL_SetupRqstFDD */
static int hf_rnsap_fdd_dl_TPC_DownlinkStepSize = -1;  /* FDD_TPC_DownlinkStepSize */
static int hf_rnsap_limitedPowerIncrease = -1;    /* LimitedPowerIncrease */
static int hf_rnsap_innerLoopDLPCStatus = -1;     /* InnerLoopDLPCStatus */
static int hf_rnsap_po1_ForTFCI_Bits = -1;        /* PowerOffset */
static int hf_rnsap_po2_ForTPC_Bits = -1;         /* PowerOffset */
static int hf_rnsap_po3_ForPilotBits = -1;        /* PowerOffset */
static int hf_rnsap_RL_InformationList_RL_SetupRqstFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_rL_ID = -1;                   /* RL_ID */
static int hf_rnsap_c_ID = -1;                    /* C_ID */
static int hf_rnsap_firstRLS_indicator = -1;      /* FirstRLS_Indicator */
static int hf_rnsap_frameOffset = -1;             /* FrameOffset */
static int hf_rnsap_chipOffset = -1;              /* ChipOffset */
static int hf_rnsap_propagationDelay = -1;        /* PropagationDelay */
static int hf_rnsap_diversityControlField = -1;   /* DiversityControlField */
static int hf_rnsap_dl_InitialTX_Power = -1;      /* DL_Power */
static int hf_rnsap_primaryCPICH_EcNo = -1;       /* PrimaryCPICH_EcNo */
static int hf_rnsap_not_Used_sSDT_CellID = -1;    /* NULL */
static int hf_rnsap_transmitDiversityIndicator = -1;  /* TransmitDiversityIndicator */
static int hf_rnsap_powerOffsetInformation1 = -1;  /* PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD */
static int hf_rnsap_maxNrTimeslots_UL = -1;       /* MaxNrTimeslots */
static int hf_rnsap_minimumSpreadingFactor_UL = -1;  /* MinimumSpreadingFactor */
static int hf_rnsap_maxNrULPhysicalchannels = -1;  /* MaxNrULPhysicalchannels */
static int hf_rnsap_maxNrTimeslots_DL = -1;       /* MaxNrTimeslots */
static int hf_rnsap_minimumSpreadingFactor_DL = -1;  /* MinimumSpreadingFactor */
static int hf_rnsap_maxNrDLPhysicalchannels = -1;  /* MaxNrDLPhysicalchannels */
static int hf_rnsap_UL_CCTrCH_InformationList_RL_SetupRqstTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_cCTrCH_ID = -1;               /* CCTrCH_ID */
static int hf_rnsap_tFCI_Coding = -1;             /* TFCI_Coding */
static int hf_rnsap_DL_CCTrCH_InformationList_RL_SetupRqstTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_dl_TFCS = -1;                 /* TFCS */
static int hf_rnsap_dl_PunctureLimit = -1;        /* PunctureLimit */
static int hf_rnsap_tdd_TPC_DownlinkStepSize = -1;  /* TDD_TPC_DownlinkStepSize */
static int hf_rnsap_cCTrCH_TPCList = -1;          /* CCTrCH_TPCList_RL_SetupRqstTDD */
static int hf_rnsap_CCTrCH_TPCList_RL_SetupRqstTDD_item = -1;  /* CCTrCH_TPCItem_RL_SetupRqstTDD */
static int hf_rnsap_specialBurstScheduling = -1;  /* SpecialBurstScheduling */
static int hf_rnsap_primaryCCPCH_RSCP = -1;       /* PrimaryCCPCH_RSCP */
static int hf_rnsap_dL_TimeSlot_ISCP = -1;        /* DL_TimeSlot_ISCP_Info */
static int hf_rnsap_RL_InformationResponseList_RL_SetupRspFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_rL_Set_ID = -1;               /* RL_Set_ID */
static int hf_rnsap_uRA_Information = -1;         /* URA_Information */
static int hf_rnsap_sAI = -1;                     /* SAI */
static int hf_rnsap_gA_Cell = -1;                 /* GA_Cell */
static int hf_rnsap_gA_AccessPointPosition = -1;  /* GA_AccessPointPosition */
static int hf_rnsap_received_total_wide_band_power = -1;  /* Received_total_wide_band_power */
static int hf_rnsap_not_Used_secondary_CCPCH_Info = -1;  /* NULL */
static int hf_rnsap_dl_CodeInformation = -1;      /* FDD_DL_CodeInformation */
static int hf_rnsap_diversityIndication = -1;     /* DiversityIndication_RL_SetupRspFDD */
static int hf_rnsap_sSDT_SupportIndicator = -1;   /* SSDT_SupportIndicator */
static int hf_rnsap_maxUL_SIR = -1;               /* UL_SIR */
static int hf_rnsap_minUL_SIR = -1;               /* UL_SIR */
static int hf_rnsap_closedlooptimingadjustmentmode = -1;  /* Closedlooptimingadjustmentmode */
static int hf_rnsap_maximumAllowedULTxPower = -1;  /* MaximumAllowedULTxPower */
static int hf_rnsap_maximumDLTxPower = -1;        /* DL_Power */
static int hf_rnsap_minimumDLTxPower = -1;        /* DL_Power */
static int hf_rnsap_primaryScramblingCode = -1;   /* PrimaryScramblingCode */
static int hf_rnsap_uL_UARFCN = -1;               /* UARFCN */
static int hf_rnsap_dL_UARFCN = -1;               /* UARFCN */
static int hf_rnsap_primaryCPICH_Power = -1;      /* PrimaryCPICH_Power */
static int hf_rnsap_not_Used_dSCHInformationResponse = -1;  /* NULL */
static int hf_rnsap_neighbouring_UMTS_CellInformation = -1;  /* Neighbouring_UMTS_CellInformation */
static int hf_rnsap_neighbouring_GSM_CellInformation = -1;  /* Neighbouring_GSM_CellInformation */
static int hf_rnsap_pC_Preamble = -1;             /* PC_Preamble */
static int hf_rnsap_sRB_Delay = -1;               /* SRB_Delay */
static int hf_rnsap_combining = -1;               /* Combining_RL_SetupRspFDD */
static int hf_rnsap_nonCombiningOrFirstRL = -1;   /* NonCombiningOrFirstRL_RL_SetupRspFDD */
static int hf_rnsap_dCH_InformationResponse = -1;  /* DCH_InformationResponse */
static int hf_rnsap_ul_TimeSlot_ISCP_Info = -1;   /* UL_TimeSlot_ISCP_Info */
static int hf_rnsap_uARFCNforNt = -1;             /* UARFCN */
static int hf_rnsap_cellParameterID = -1;         /* CellParameterID */
static int hf_rnsap_syncCase = -1;                /* SyncCase */
static int hf_rnsap_sCH_TimeSlot = -1;            /* SCH_TimeSlot */
static int hf_rnsap_sCTD_Indicator = -1;          /* SCTD_Indicator */
static int hf_rnsap_pCCPCH_Power = -1;            /* PCCPCH_Power */
static int hf_rnsap_timingAdvanceApplied = -1;    /* TimingAdvanceApplied */
static int hf_rnsap_alphaValue = -1;              /* AlphaValue */
static int hf_rnsap_ul_PhysCH_SF_Variation = -1;  /* UL_PhysCH_SF_Variation */
static int hf_rnsap_synchronisationConfiguration = -1;  /* SynchronisationConfiguration */
static int hf_rnsap_secondary_CCPCH_Info_TDD = -1;  /* Secondary_CCPCH_Info_TDD */
static int hf_rnsap_ul_CCTrCHInformation = -1;    /* UL_CCTrCHInformationList_RL_SetupRspTDD */
static int hf_rnsap_dl_CCTrCHInformation = -1;    /* DL_CCTrCHInformationList_RL_SetupRspTDD */
static int hf_rnsap_dCH_InformationResponse1 = -1;  /* DCH_InformationResponseList_RL_SetupRspTDD */
static int hf_rnsap_dsch_InformationResponse = -1;  /* DSCH_InformationResponse_RL_SetupRspTDD */
static int hf_rnsap_usch_InformationResponse = -1;  /* USCH_InformationResponse_RL_SetupRspTDD */
static int hf_rnsap_UL_CCTrCHInformationListIE_RL_SetupRspTDD_item = -1;  /* UL_CCTrCHInformationItem_RL_SetupRspTDD */
static int hf_rnsap_ul_DPCH_Information = -1;     /* UL_DPCH_InformationList_RL_SetupRspTDD */
static int hf_rnsap_repetitionPeriod = -1;        /* RepetitionPeriod */
static int hf_rnsap_repetitionLength = -1;        /* RepetitionLength */
static int hf_rnsap_tDD_DPCHOffset = -1;          /* TDD_DPCHOffset */
static int hf_rnsap_uL_Timeslot_Information = -1;  /* UL_Timeslot_Information */
static int hf_rnsap_DL_CCTrCHInformationListIE_RL_SetupRspTDD_item = -1;  /* DL_CCTrCHInformationItem_RL_SetupRspTDD */
static int hf_rnsap_dl_DPCH_Information = -1;     /* DL_DPCH_InformationList_RL_SetupRspTDD */
static int hf_rnsap_dL_Timeslot_Information = -1;  /* DL_Timeslot_Information */
static int hf_rnsap_DSCH_InformationListIEs_RL_SetupRspTDD_item = -1;  /* DSCHInformationItem_RL_SetupRspTDD */
static int hf_rnsap_dsch_ID = -1;                 /* DSCH_ID */
static int hf_rnsap_dSCH_FlowControlInformation = -1;  /* DSCH_FlowControlInformation */
static int hf_rnsap_bindingID = -1;               /* BindingID */
static int hf_rnsap_transportLayerAddress = -1;   /* TransportLayerAddress */
static int hf_rnsap_transportFormatManagement = -1;  /* TransportFormatManagement */
static int hf_rnsap_USCH_InformationListIEs_RL_SetupRspTDD_item = -1;  /* USCHInformationItem_RL_SetupRspTDD */
static int hf_rnsap_usch_ID = -1;                 /* USCH_ID */
static int hf_rnsap_ul_TimeSlot_ISCP_LCR_Info = -1;  /* UL_TimeSlot_ISCP_LCR_Info */
static int hf_rnsap_secondary_LCR_CCPCH_Info_TDD = -1;  /* Secondary_LCR_CCPCH_Info_TDD */
static int hf_rnsap_ul_LCR_CCTrCHInformation = -1;  /* UL_LCR_CCTrCHInformationList_RL_SetupRspTDD */
static int hf_rnsap_dl_LCR_CCTrCHInformation = -1;  /* DL_LCR_CCTrCHInformationList_RL_SetupRspTDD */
static int hf_rnsap_dsch_LCR_InformationResponse = -1;  /* DSCH_LCR_InformationResponse_RL_SetupRspTDD */
static int hf_rnsap_usch_LCR_InformationResponse = -1;  /* USCH_LCR_InformationResponse_RL_SetupRspTDD */
static int hf_rnsap_UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD_item = -1;  /* UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD */
static int hf_rnsap_ul_DPCH_LCR_Information = -1;  /* UL_DPCH_LCR_InformationList_RL_SetupRspTDD */
static int hf_rnsap_uL_TimeslotLCR_Information = -1;  /* UL_TimeslotLCR_Information */
static int hf_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD_item = -1;  /* DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD */
static int hf_rnsap_dl_DPCH_LCR_Information = -1;  /* DL_DPCH_LCR_InformationList_RL_SetupRspTDD */
static int hf_rnsap_dL_Timeslot_LCR_Information = -1;  /* DL_TimeslotLCR_Information */
static int hf_rnsap_tSTD_Indicator = -1;          /* TSTD_Indicator */
static int hf_rnsap_DSCH_LCR_InformationListIEs_RL_SetupRspTDD_item = -1;  /* DSCH_LCR_InformationItem_RL_SetupRspTDD */
static int hf_rnsap_USCH_LCR_InformationListIEs_RL_SetupRspTDD_item = -1;  /* USCH_LCR_InformationItem_RL_SetupRspTDD */
static int hf_rnsap_generalCause = -1;            /* GeneralCauseList_RL_SetupFailureFDD */
static int hf_rnsap_rLSpecificCause = -1;         /* RLSpecificCauseList_RL_SetupFailureFDD */
static int hf_rnsap_cause = -1;                   /* Cause */
static int hf_rnsap_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD = -1;  /* UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD */
static int hf_rnsap_successful_RL_InformationRespList_RL_SetupFailureFDD = -1;  /* SuccessfulRL_InformationResponseList_RL_SetupFailureFDD */
static int hf_rnsap_UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_SuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_diversityIndication1 = -1;    /* DiversityIndication_RL_SetupFailureFDD */
static int hf_rnsap_not_Used_dSCH_InformationResponse_RL_SetupFailureFDD = -1;  /* NULL */
static int hf_rnsap_combining1 = -1;              /* Combining_RL_SetupFailureFDD */
static int hf_rnsap_nonCombiningOrFirstRL1 = -1;  /* NonCombiningOrFirstRL_RL_SetupFailureFDD */
static int hf_rnsap_generalCause1 = -1;           /* GeneralCauseList_RL_SetupFailureTDD */
static int hf_rnsap_rLSpecificCause1 = -1;        /* RLSpecificCauseList_RL_SetupFailureTDD */
static int hf_rnsap_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD = -1;  /* Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD */
static int hf_rnsap_RL_InformationList_RL_AdditionRqstFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_dL_TimeSlot_ISCP_Info = -1;   /* DL_TimeSlot_ISCP_Info */
static int hf_rnsap_UL_CCTrCH_InformationList_RL_AdditionRqstTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_uplinkStepSizeLCR = -1;       /* TDD_TPC_UplinkStepSize_LCR */
static int hf_rnsap_DL_CCTrCH_InformationList_RL_AdditionRqstTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_downlinkStepSize = -1;        /* TDD_TPC_DownlinkStepSize */
static int hf_rnsap_RL_InformationResponseList_RL_AdditionRspFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_dl_CodeInformation1 = -1;     /* DL_CodeInformationList_RL_AdditionRspFDD */
static int hf_rnsap_diversityIndication2 = -1;    /* DiversityIndication_RL_AdditionRspFDD */
static int hf_rnsap_combining2 = -1;              /* Combining_RL_AdditionRspFDD */
static int hf_rnsap_nonCombining = -1;            /* NonCombining_RL_AdditionRspFDD */
static int hf_rnsap_ul_CCTrCHInformation1 = -1;   /* UL_CCTrCHInformationList_RL_AdditionRspTDD */
static int hf_rnsap_dl_CCTrCHInformation1 = -1;   /* DL_CCTrCHInformationList_RL_AdditionRspTDD */
static int hf_rnsap_dCH_Information = -1;         /* DCH_Information_RL_AdditionRspTDD */
static int hf_rnsap_dSCH_InformationResponse = -1;  /* DSCH_InformationResponse_RL_AdditionRspTDD */
static int hf_rnsap_uSCH_InformationResponse = -1;  /* USCH_InformationResponse_RL_AdditionRspTDD */
static int hf_rnsap_UL_CCTrCHInformationListIE_RL_AdditionRspTDD_item = -1;  /* UL_CCTrCHInformationItem_RL_AdditionRspTDD */
static int hf_rnsap_ul_DPCH_Information1 = -1;    /* UL_DPCH_InformationList_RL_AdditionRspTDD */
static int hf_rnsap_DL_CCTrCHInformationListIE_RL_AdditionRspTDD_item = -1;  /* DL_CCTrCHInformationItem_RL_AdditionRspTDD */
static int hf_rnsap_dl_DPCH_Information1 = -1;    /* DL_DPCH_InformationList_RL_AdditionRspTDD */
static int hf_rnsap_diversityIndication3 = -1;    /* DiversityIndication_RL_AdditionRspTDD */
static int hf_rnsap_combining3 = -1;              /* Combining_RL_AdditionRspTDD */
static int hf_rnsap_nonCombining1 = -1;           /* NonCombining_RL_AdditionRspTDD */
static int hf_rnsap_DSCH_InformationListIE_RL_AdditionRspTDD_item = -1;  /* DSCHInformationItem_RL_AdditionRspTDD */
static int hf_rnsap_diversityIndication4 = -1;    /* DiversityIndication_RL_AdditionRspTDD2 */
static int hf_rnsap_USCH_InformationListIE_RL_AdditionRspTDD_item = -1;  /* USCHInformationItem_RL_AdditionRspTDD */
static int hf_rnsap_uSCH_ID = -1;                 /* USCH_ID */
static int hf_rnsap_ul_CCTrCH_LCR_Information = -1;  /* UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD */
static int hf_rnsap_dl_CCTrCH_LCR_Information = -1;  /* DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD */
static int hf_rnsap_dCH_InformationResponse2 = -1;  /* DCH_InformationResponseList_RL_AdditionRspTDD */
static int hf_rnsap_dsch_LCR_InformationResponse1 = -1;  /* DSCH_LCR_InformationResponse_RL_AdditionRspTDD */
static int hf_rnsap_usch_LCR_InformationResponse1 = -1;  /* USCH_LCR_InformationResponse_RL_AdditionRspTDD */
static int hf_rnsap_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item = -1;  /* UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD */
static int hf_rnsap_ul_DPCH_LCR_Information1 = -1;  /* UL_DPCH_LCR_InformationList_RL_AdditionRspTDD */
static int hf_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item = -1;  /* DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD */
static int hf_rnsap_dl_DPCH_LCR_Information1 = -1;  /* DL_DPCH_LCR_InformationList_RL_AdditionRspTDD */
static int hf_rnsap_dL_TimeslotLCR_Information = -1;  /* DL_TimeslotLCR_Information */
static int hf_rnsap_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD_item = -1;  /* DSCH_LCR_InformationItem_RL_AdditionRspTDD */
static int hf_rnsap_USCH_LCR_InformationListIEs_RL_AdditionRspTDD_item = -1;  /* USCH_LCR_InformationItem_RL_AdditionRspTDD */
static int hf_rnsap_generalCause2 = -1;           /* GeneralCauseList_RL_AdditionFailureFDD */
static int hf_rnsap_rLSpecificCause2 = -1;        /* RLSpecificCauseList_RL_AdditionFailureFDD */
static int hf_rnsap_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD = -1;  /* UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD */
static int hf_rnsap_successful_RL_InformationRespList_RL_AdditionFailureFDD = -1;  /* SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD */
static int hf_rnsap_UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_dl_CodeInformation2 = -1;     /* DL_CodeInformationList_RL_AdditionFailureFDD */
static int hf_rnsap_diversityIndication5 = -1;    /* DiversityIndication_RL_AdditionFailureFDD */
static int hf_rnsap_combining4 = -1;              /* Combining_RL_AdditionFailureFDD */
static int hf_rnsap_nonCombining2 = -1;           /* NonCombining_RL_AdditionFailureFDD */
static int hf_rnsap_generalCause3 = -1;           /* GeneralCauseList_RL_AdditionFailureTDD */
static int hf_rnsap_rLSpecificCause3 = -1;        /* RLSpecificCauseList_RL_AdditionFailureTDD */
static int hf_rnsap_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD = -1;  /* Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD */
static int hf_rnsap_RL_InformationList_RL_DeletionRqst_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_maxNrOfUL_DPDCHs = -1;        /* MaxNrOfUL_DPCHs */
static int hf_rnsap_not_Used_sSDT_CellIDLength = -1;  /* NULL */
static int hf_rnsap_powerOffsetInformation2 = -1;  /* PowerOffsetInformation_RL_ReconfPrepFDD */
static int hf_rnsap_fdd_TPC_DownlinkStepSize = -1;  /* FDD_TPC_DownlinkStepSize */
static int hf_rnsap_pO1_ForTFCI_Bits = -1;        /* PowerOffset */
static int hf_rnsap_pO2_ForTPC_Bits = -1;         /* PowerOffset */
static int hf_rnsap_pO3_ForPilotBits = -1;        /* PowerOffset */
static int hf_rnsap_DCH_DeleteList_RL_ReconfPrepFDD_item = -1;  /* DCH_DeleteItem_RL_ReconfPrepFDD */
static int hf_rnsap_dCH_ID = -1;                  /* DCH_ID */
static int hf_rnsap_RL_InformationList_RL_ReconfPrepFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_not_Used_sSDT_Indication = -1;  /* NULL */
static int hf_rnsap_not_Used_sSDT_CellIdentity = -1;  /* NULL */
static int hf_rnsap_powerOffsetInformation3 = -1;  /* PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD */
static int hf_rnsap_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_punctureLimit = -1;           /* PunctureLimit */
static int hf_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_cCTrCH_TPCList1 = -1;         /* CCTrCH_TPCAddList_RL_ReconfPrepTDD */
static int hf_rnsap_CCTrCH_TPCAddList_RL_ReconfPrepTDD_item = -1;  /* CCTrCH_TPCAddItem_RL_ReconfPrepTDD */
static int hf_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_cCTrCH_TPCList2 = -1;         /* CCTrCH_TPCModifyList_RL_ReconfPrepTDD */
static int hf_rnsap_CCTrCH_TPCModifyList_RL_ReconfPrepTDD_item = -1;  /* CCTrCH_TPCModifyItem_RL_ReconfPrepTDD */
static int hf_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_DCH_DeleteList_RL_ReconfPrepTDD_item = -1;  /* DCH_DeleteItem_RL_ReconfPrepTDD */
static int hf_rnsap_DSCH_ModifyList_RL_ReconfPrepTDD_item = -1;  /* DSCH_ModifyItem_RL_ReconfPrepTDD */
static int hf_rnsap_dSCH_ID = -1;                 /* DSCH_ID */
static int hf_rnsap_dl_ccTrCHID = -1;             /* CCTrCH_ID */
static int hf_rnsap_trChSourceStatisticsDescriptor = -1;  /* TrCH_SrcStatisticsDescr */
static int hf_rnsap_transportFormatSet = -1;      /* TransportFormatSet */
static int hf_rnsap_allocationRetentionPriority = -1;  /* AllocationRetentionPriority */
static int hf_rnsap_schedulingPriorityIndicator = -1;  /* SchedulingPriorityIndicator */
static int hf_rnsap_bLER = -1;                    /* BLER */
static int hf_rnsap_transportBearerRequestIndicator = -1;  /* TransportBearerRequestIndicator */
static int hf_rnsap_DSCH_DeleteList_RL_ReconfPrepTDD_item = -1;  /* DSCH_DeleteItem_RL_ReconfPrepTDD */
static int hf_rnsap_USCH_ModifyList_RL_ReconfPrepTDD_item = -1;  /* USCH_ModifyItem_RL_ReconfPrepTDD */
static int hf_rnsap_ul_ccTrCHID = -1;             /* CCTrCH_ID */
static int hf_rnsap_rb_Info = -1;                 /* RB_Info */
static int hf_rnsap_USCH_DeleteList_RL_ReconfPrepTDD_item = -1;  /* USCH_DeleteItem_RL_ReconfPrepTDD */
static int hf_rnsap_RL_Information_RL_ReconfPrepTDD_item = -1;  /* RL_InformationIE_RL_ReconfPrepTDD */
static int hf_rnsap_rL_Specific_DCH_Info = -1;    /* RL_Specific_DCH_Info */
static int hf_rnsap_RL_InformationResponseList_RL_ReconfReadyFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_max_UL_SIR = -1;              /* UL_SIR */
static int hf_rnsap_min_UL_SIR = -1;              /* UL_SIR */
static int hf_rnsap_dl_CodeInformationList = -1;  /* DL_CodeInformationList_RL_ReconfReadyFDD */
static int hf_rnsap_dCHInformationResponse = -1;  /* DCH_InformationResponseList_RL_ReconfReadyFDD */
static int hf_rnsap_not_Used_dSCHsToBeAddedOrModified = -1;  /* NULL */
static int hf_rnsap_ul_CCTrCH_Information = -1;   /* UL_CCTrCH_InformationList_RL_ReconfReadyTDD */
static int hf_rnsap_dl_CCTrCH_Information = -1;   /* DL_CCTrCH_InformationList_RL_ReconfReadyTDD */
static int hf_rnsap_dCHInformationResponse1 = -1;  /* DCH_InformationResponseList_RL_ReconfReadyTDD */
static int hf_rnsap_dSCHsToBeAddedOrModified = -1;  /* DSCHToBeAddedOrModified_RL_ReconfReadyTDD */
static int hf_rnsap_uSCHsToBeAddedOrModified = -1;  /* USCHToBeAddedOrModified_RL_ReconfReadyTDD */
static int hf_rnsap_UL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item = -1;  /* UL_CCTrCH_InformationItem_RL_ReconfReadyTDD */
static int hf_rnsap_ul_DPCH_AddInformation = -1;  /* UL_DPCH_InformationAddList_RL_ReconfReadyTDD */
static int hf_rnsap_ul_DPCH_ModifyInformation = -1;  /* UL_DPCH_InformationModifyList_RL_ReconfReadyTDD */
static int hf_rnsap_ul_DPCH_DeleteInformation = -1;  /* UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD */
static int hf_rnsap_uL_TimeslotLCR_Info = -1;     /* UL_TimeslotLCR_Information */
static int hf_rnsap_rxTimingDeviationForTA = -1;  /* RxTimingDeviationForTA */
static int hf_rnsap_uL_Timeslot_InformationModifyList_RL_ReconfReadyTDD = -1;  /* UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD */
static int hf_rnsap_UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item = -1;  /* UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD */
static int hf_rnsap_timeSlotLCR = -1;             /* TimeSlotLCR */
static int hf_rnsap_midambleShiftLCR = -1;        /* MidambleShiftLCR */
static int hf_rnsap_tDD_uL_Code_LCR_Information = -1;  /* TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD */
static int hf_rnsap_TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item = -1;  /* TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD */
static int hf_rnsap_dPCH_ID = -1;                 /* DPCH_ID */
static int hf_rnsap_tDD_ChannelisationCodeLCR = -1;  /* TDD_ChannelisationCodeLCR */
static int hf_rnsap_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item = -1;  /* UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD */
static int hf_rnsap_timeSlot = -1;                /* TimeSlot */
static int hf_rnsap_midambleShiftAndBurstType = -1;  /* MidambleShiftAndBurstType */
static int hf_rnsap_uL_Code_Information = -1;     /* TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD */
static int hf_rnsap_TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD_item = -1;  /* TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD */
static int hf_rnsap_tDD_ChannelisationCode = -1;  /* TDD_ChannelisationCode */
static int hf_rnsap_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item = -1;  /* UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD */
static int hf_rnsap_DL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item = -1;  /* DL_CCTrCH_InformationItem_RL_ReconfReadyTDD */
static int hf_rnsap_dl_DPCH_AddInformation = -1;  /* DL_DPCH_InformationAddList_RL_ReconfReadyTDD */
static int hf_rnsap_dl_DPCH_ModifyInformation = -1;  /* DL_DPCH_InformationModifyList_RL_ReconfReadyTDD */
static int hf_rnsap_dl_DPCH_DeleteInformation = -1;  /* DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD */
static int hf_rnsap_dL_TimeslotLCR_Info = -1;     /* DL_TimeslotLCR_Information */
static int hf_rnsap_dL_Timeslot_InformationModifyList_RL_ReconfReadyTDD = -1;  /* DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD */
static int hf_rnsap_DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item = -1;  /* DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD */
static int hf_rnsap_tDD_dL_Code_LCR_Information = -1;  /* TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD */
static int hf_rnsap_TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item = -1;  /* TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD */
static int hf_rnsap_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item = -1;  /* DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD */
static int hf_rnsap_dL_Code_Information = -1;     /* TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD */
static int hf_rnsap_TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD_item = -1;  /* TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD */
static int hf_rnsap_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item = -1;  /* DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD */
static int hf_rnsap_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item = -1;  /* DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD */
static int hf_rnsap_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item = -1;  /* USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD */
static int hf_rnsap_Multiple_RL_InformationResponse_RL_ReconfReadyTDD_item = -1;  /* RL_InformationResponse_RL_ReconfReadyTDD */
static int hf_rnsap_generalCause4 = -1;           /* GeneralCauseList_RL_ReconfFailure */
static int hf_rnsap_rLSpecificCause4 = -1;        /* RLSpecificCauseList_RL_ReconfFailure */
static int hf_rnsap_rL_ReconfigurationFailureList_RL_ReconfFailure = -1;  /* RL_ReconfigurationFailureList_RL_ReconfFailure */
static int hf_rnsap_RL_ReconfigurationFailureList_RL_ReconfFailure_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_DCH_DeleteList_RL_ReconfRqstFDD_item = -1;  /* DCH_DeleteItem_RL_ReconfRqstFDD */
static int hf_rnsap_RL_ReconfigurationRequestFDD_RL_InformationList_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_DCH_DeleteList_RL_ReconfRqstTDD_item = -1;  /* DCH_DeleteItem_RL_ReconfRqstTDD */
static int hf_rnsap_Multiple_RL_ReconfigurationRequestTDD_RL_Information_item = -1;  /* RL_ReconfigurationRequestTDD_RL_Information */
static int hf_rnsap_RL_InformationResponseList_RL_ReconfRspFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_dCHsInformationResponseList = -1;  /* DCH_InformationResponseList_RL_ReconfRspFDD */
static int hf_rnsap_dL_CodeInformationList_RL_ReconfResp = -1;  /* DL_CodeInformationList_RL_ReconfRspFDD */
static int hf_rnsap_dCHsInformationResponseList1 = -1;  /* DCH_InformationResponseList_RL_ReconfRspTDD */
static int hf_rnsap_DL_CCTrCH_InformationList_RL_ReconfRspTDD_item = -1;  /* DL_CCTrCH_InformationItem_RL_ReconfRspTDD */
static int hf_rnsap_dl_DPCH_ModifyInformation_LCR = -1;  /* DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD */
static int hf_rnsap_cCTrCH_Maximum_DL_Power = -1;  /* DL_Power */
static int hf_rnsap_cCTrCH_Minimum_DL_Power = -1;  /* DL_Power */
static int hf_rnsap_dL_Timeslot_LCR_InformationModifyList_RL_ReconfRqstTDD = -1;  /* DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD */
static int hf_rnsap_DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD_item = -1;  /* DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD */
static int hf_rnsap_maxPowerLCR = -1;             /* DL_Power */
static int hf_rnsap_minPowerLCR = -1;             /* DL_Power */
static int hf_rnsap_Multiple_RL_InformationResponse_RL_ReconfRspTDD_item = -1;  /* RL_InformationResponse_RL_ReconfRspTDD */
static int hf_rnsap_rL = -1;                      /* RL_RL_FailureInd */
static int hf_rnsap_rL_Set = -1;                  /* RL_Set_RL_FailureInd */
static int hf_rnsap_cCTrCH = -1;                  /* CCTrCH_RL_FailureInd */
static int hf_rnsap_rL_InformationList_RL_FailureInd = -1;  /* RL_InformationList_RL_FailureInd */
static int hf_rnsap_RL_InformationList_RL_FailureInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_rL_Set_InformationList_RL_FailureInd = -1;  /* RL_Set_InformationList_RL_FailureInd */
static int hf_rnsap_RL_Set_InformationList_RL_FailureInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_cCTrCH_InformationList_RL_FailureInd = -1;  /* CCTrCH_InformationList_RL_FailureInd */
static int hf_rnsap_CCTrCH_InformationList_RL_FailureInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_RL_InformationList_RL_PreemptRequiredInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_hSDSCH_MACdFlow_ID = -1;      /* HSDSCH_MACdFlow_ID */
static int hf_rnsap_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_eDCH_MACdFlow_ID = -1;        /* EDCH_MACdFlow_ID */
static int hf_rnsap_rL1 = -1;                     /* RL_RL_RestoreInd */
static int hf_rnsap_rL_Set1 = -1;                 /* RL_Set_RL_RestoreInd */
static int hf_rnsap_cCTrCH1 = -1;                 /* CCTrCH_RL_RestoreInd */
static int hf_rnsap_rL_InformationList_RL_RestoreInd = -1;  /* RL_InformationList_RL_RestoreInd */
static int hf_rnsap_RL_InformationList_RL_RestoreInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_rL_Set_InformationList_RL_RestoreInd = -1;  /* RL_Set_InformationList_RL_RestoreInd */
static int hf_rnsap_RL_Set_InformationList_RL_RestoreInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_cCTrCH_InformationList_RL_RestoreInd = -1;  /* CCTrCH_InformationList_RL_RestoreInd */
static int hf_rnsap_CCTrCH_InformationList_RL_RestoreInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_DL_ReferencePowerInformationList_DL_PC_Rqst_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_dl_Reference_Power = -1;      /* DL_Power */
static int hf_rnsap_dl_CodeInformation3 = -1;     /* DL_CodeInformationList_PhyChReconfRqstFDD */
static int hf_rnsap_ul_CCTrCH_Information1 = -1;  /* UL_CCTrCH_InformationList_PhyChReconfRqstTDD */
static int hf_rnsap_dl_CCTrCH_Information1 = -1;  /* DL_CCTrCH_InformationList_PhyChReconfRqstTDD */
static int hf_rnsap_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item = -1;  /* UL_CCTrCH_InformationItem_PhyChReconfRqstTDD */
static int hf_rnsap_ul_DPCH_Information2 = -1;    /* UL_DPCH_InformationList_PhyChReconfRqstTDD */
static int hf_rnsap_uL_Timeslot_InformationList_PhyChReconfRqstTDD = -1;  /* UL_Timeslot_InformationList_PhyChReconfRqstTDD */
static int hf_rnsap_UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item = -1;  /* UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD */
static int hf_rnsap_uL_Code_LCR_Information = -1;  /* TDD_UL_Code_LCR_Information */
static int hf_rnsap_UL_Timeslot_InformationList_PhyChReconfRqstTDD_item = -1;  /* UL_Timeslot_InformationItem_PhyChReconfRqstTDD */
static int hf_rnsap_uL_Code_Information1 = -1;    /* TDD_UL_Code_Information */
static int hf_rnsap_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item = -1;  /* DL_CCTrCH_InformationItem_PhyChReconfRqstTDD */
static int hf_rnsap_dl_DPCH_Information2 = -1;    /* DL_DPCH_InformationList_PhyChReconfRqstTDD */
static int hf_rnsap_dL_Timeslot_InformationList_PhyChReconfRqstTDD = -1;  /* DL_Timeslot_InformationList_PhyChReconfRqstTDD */
static int hf_rnsap_DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item = -1;  /* DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD */
static int hf_rnsap_dL_Code_LCR_Information = -1;  /* TDD_DL_Code_LCR_Information */
static int hf_rnsap_DL_Timeslot_InformationList_PhyChReconfRqstTDD_item = -1;  /* DL_Timeslot_InformationItem_PhyChReconfRqstTDD */
static int hf_rnsap_dL_Code_Information1 = -1;    /* TDD_DL_Code_Information */
static int hf_rnsap_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD_item = -1;  /* HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD */
static int hf_rnsap_timeslot = -1;                /* TimeSlot */
static int hf_rnsap_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD_item = -1;  /* HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD */
static int hf_rnsap_timeslotLCR = -1;             /* TimeSlotLCR */
static int hf_rnsap_RL_InformationList_RL_CongestInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_dCH_Rate_Information = -1;    /* DCH_Rate_Information_RL_CongestInd */
static int hf_rnsap_DCH_Rate_Information_RL_CongestInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_allowed_Rate_Information = -1;  /* Allowed_Rate_Information */
static int hf_rnsap_EDCH_MacdFlowSpecificInformationList_RL_CongestInd_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_uRA = -1;                     /* URA_PagingRqst */
static int hf_rnsap_cell = -1;                    /* Cell_PagingRqst */
static int hf_rnsap_uRA_ID = -1;                  /* URA_ID */
static int hf_rnsap_pagingCause = -1;             /* PagingCause */
static int hf_rnsap_cNDomainType = -1;            /* CNDomainType */
static int hf_rnsap_pagingRecordType = -1;        /* PagingRecordType */
static int hf_rnsap_rL2 = -1;                     /* RL_DM_Rqst */
static int hf_rnsap_rLS = -1;                     /* RL_Set_DM_Rqst */
static int hf_rnsap_allRL = -1;                   /* All_RL_DM_Rqst */
static int hf_rnsap_allRLS = -1;                  /* All_RL_Set_DM_Rqst */
static int hf_rnsap_rL_InformationList_DM_Rqst = -1;  /* RL_InformationList_DM_Rqst */
static int hf_rnsap_RL_InformationList_DM_Rqst_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_HSSICH_Info_DM_Rqst_item = -1;  /* HS_SICH_ID */
static int hf_rnsap_rL_Set_InformationList_DM_Rqst = -1;  /* RL_Set_InformationList_DM_Rqst */
static int hf_rnsap_RL_Set_InformationList_DM_Rqst_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_rLs = -1;                     /* RL_DM_Rsp */
static int hf_rnsap_rLS1 = -1;                    /* RL_Set_DM_Rsp */
static int hf_rnsap_allRL1 = -1;                  /* RL_DM_Rsp */
static int hf_rnsap_allRLS1 = -1;                 /* RL_Set_DM_Rsp */
static int hf_rnsap_rL_InformationList_DM_Rsp = -1;  /* RL_InformationList_DM_Rsp */
static int hf_rnsap_rL_Set_InformationList_DM_Rsp = -1;  /* RL_Set_InformationList_DM_Rsp */
static int hf_rnsap_RL_InformationList_DM_Rsp_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_dedicatedMeasurementValue = -1;  /* DedicatedMeasurementValue */
static int hf_rnsap_cFN = -1;                     /* CFN */
static int hf_rnsap_RL_Set_InformationList_DM_Rsp_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp_item = -1;  /* Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp */
static int hf_rnsap_Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp_item = -1;  /* Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp */
static int hf_rnsap_rL3 = -1;                     /* RL_DM_Fail */
static int hf_rnsap_rLS2 = -1;                    /* RL_Set_DM_Fail */
static int hf_rnsap_allRL2 = -1;                  /* RL_DM_Fail */
static int hf_rnsap_allRLS2 = -1;                 /* RL_Set_DM_Fail */
static int hf_rnsap_rL_unsuccessful_InformationRespList_DM_Fail = -1;  /* RL_Unsuccessful_InformationRespList_DM_Fail */
static int hf_rnsap_rL_successful_InformationRespList_DM_Fail = -1;  /* RL_Successful_InformationRespList_DM_Fail */
static int hf_rnsap_rL_Set_unsuccessful_InformationRespList_DM_Fail = -1;  /* RL_Set_Unsuccessful_InformationRespList_DM_Fail */
static int hf_rnsap_rL_Set_successful_InformationRespList_DM_Fail = -1;  /* RL_Set_Successful_InformationRespList_DM_Fail */
static int hf_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_individualcause = -1;         /* Cause */
static int hf_rnsap_RL_Successful_InformationRespList_DM_Fail_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_RL_Set_Successful_InformationRespList_DM_Fail_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_rLs1 = -1;                    /* RL_DM_Rprt */
static int hf_rnsap_rLS3 = -1;                    /* RL_Set_DM_Rprt */
static int hf_rnsap_allRL3 = -1;                  /* RL_DM_Rprt */
static int hf_rnsap_allRLS3 = -1;                 /* RL_Set_DM_Rprt */
static int hf_rnsap_rL_InformationList_DM_Rprt = -1;  /* RL_InformationList_DM_Rprt */
static int hf_rnsap_rL_Set_InformationList_DM_Rprt = -1;  /* RL_Set_InformationList_DM_Rprt */
static int hf_rnsap_RL_InformationList_DM_Rprt_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_dedicatedMeasurementValueInformation = -1;  /* DedicatedMeasurementValueInformation */
static int hf_rnsap_RL_Set_InformationList_DM_Rprt_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_rL4 = -1;                     /* RL_DM_Fail_Ind */
static int hf_rnsap_rLS4 = -1;                    /* RL_Set_DM_Fail_Ind */
static int hf_rnsap_allRL4 = -1;                  /* RL_DM_Fail_Ind */
static int hf_rnsap_allRLS4 = -1;                 /* RL_Set_DM_Fail_Ind */
static int hf_rnsap_rL_unsuccessful_InformationRespList_DM_Fail_Ind = -1;  /* RL_Unsuccessful_InformationRespList_DM_Fail_Ind */
static int hf_rnsap_rL_Set_unsuccessful_InformationRespList_DM_Fail_Ind = -1;  /* RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind */
static int hf_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_Ind_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_fACH_FlowControlInformation = -1;  /* FACH_FlowControlInformation_CTCH_ResourceRspFDD */
static int hf_rnsap_fACH_FlowControlInformation1 = -1;  /* FACH_FlowControlInformation_CTCH_ResourceRspTDD */
static int hf_rnsap_cell1 = -1;                   /* Cell_CM_Rqst */
static int hf_rnsap_uC_ID = -1;                   /* UC_ID */
static int hf_rnsap_neighbouringCellMeasurementInformation = -1;  /* NeighbouringCellMeasurementInfo */
static int hf_rnsap_NeighbouringCellMeasurementInfo_item = -1;  /* NeighbouringCellMeasurementInfo_item */
static int hf_rnsap_neighbouringFDDCellMeasurementInformation = -1;  /* NeighbouringFDDCellMeasurementInformation */
static int hf_rnsap_neighbouringTDDCellMeasurementInformation = -1;  /* NeighbouringTDDCellMeasurementInformation */
static int hf_rnsap_extension_neighbouringCellMeasurementInformation = -1;  /* Extension_neighbouringCellMeasurementInformation */
static int hf_rnsap_cell2 = -1;                   /* Cell_CM_Rsp */
static int hf_rnsap_commonMeasurementValue = -1;  /* CommonMeasurementValue */
static int hf_rnsap_cell3 = -1;                   /* Cell_CM_Rprt */
static int hf_rnsap_commonMeasurementValueInformation = -1;  /* CommonMeasurementValueInformation */
static int hf_rnsap_cell4 = -1;                   /* Cell_InfEx_Rqst */
static int hf_rnsap_extension_InformationExchangeObjectType_InfEx_Rqst = -1;  /* Extension_InformationExchangeObjectType_InfEx_Rqst */
static int hf_rnsap_cGI = -1;                     /* CGI */
static int hf_rnsap_cell5 = -1;                   /* Cell_InfEx_Rsp */
static int hf_rnsap_extension_InformationExchangeObjectType_InfEx_Rsp = -1;  /* Extension_InformationExchangeObjectType_InfEx_Rsp */
static int hf_rnsap_requestedDataValue = -1;      /* RequestedDataValue */
static int hf_rnsap_MBMS_Bearer_Service_List_InfEx_Rsp_item = -1;  /* MBMS_Bearer_ServiceItemIEs_InfEx_Rsp */
static int hf_rnsap_tmgi = -1;                    /* TMGI */
static int hf_rnsap_cell6 = -1;                   /* Cell_InfEx_Rprt */
static int hf_rnsap_requestedDataValueInformation = -1;  /* RequestedDataValueInformation */
static int hf_rnsap_context = -1;                 /* ContextList_Reset */
static int hf_rnsap_all_contexts = -1;            /* NULL */
static int hf_rnsap_contextGroup = -1;            /* ContextGroupList_Reset */
static int hf_rnsap_contextInfoList_Reset = -1;   /* ContextInfoList_Reset */
static int hf_rnsap_ContextInfoList_Reset_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_contextType_Reset = -1;       /* ContextType_Reset */
static int hf_rnsap_sRNTI = -1;                   /* S_RNTI */
static int hf_rnsap_dRNTI = -1;                   /* D_RNTI */
static int hf_rnsap_contextGroupInfoList_Reset = -1;  /* ContextGroupInfoList_Reset */
static int hf_rnsap_ContextGroupInfoList_Reset_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_s_RNTI_Group = -1;            /* S_RNTI_Group */
static int hf_rnsap_DelayedActivationInformationList_RL_ActivationCmdFDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_delayed_activation_update = -1;  /* DelayedActivationUpdate */
static int hf_rnsap_DelayedActivationInformationList_RL_ActivationCmdTDD_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_RL_ParameterUpdateIndicationFDD_RL_InformationList_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_phase_Reference_Update_Indicator = -1;  /* Phase_Reference_Update_Indicator */
static int hf_rnsap_ListOfInterfacesToTrace_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_interface = -1;               /* T_interface */
static int hf_rnsap_privateIEs = -1;              /* PrivateIE_Container */
static int hf_rnsap_Active_MBMS_Bearer_Service_ListFDD_item = -1;  /* MBMS_Bearer_ServiceItemFDD */
static int hf_rnsap_Active_MBMS_Bearer_Service_ListFDD_PFL_item = -1;  /* MBMS_Bearer_ServiceItemFDD_PFL */
static int hf_rnsap_Active_MBMS_Bearer_Service_ListTDD_item = -1;  /* MBMS_Bearer_ServiceItemTDD */
static int hf_rnsap_Active_MBMS_Bearer_Service_ListTDD_PFL_item = -1;  /* MBMS_Bearer_ServiceItemTDD_PFL */
static int hf_rnsap_cMConfigurationChangeCFN = -1;  /* CFN */
static int hf_rnsap_transmission_Gap_Pattern_Sequence_Status = -1;  /* Transmission_Gap_Pattern_Sequence_Status_List */
static int hf_rnsap_AdditionalPreferredFrequency_item = -1;  /* AdditionalPreferredFrequencyItem */
static int hf_rnsap_correspondingCells = -1;      /* CorrespondingCells */
static int hf_rnsap_AffectedUEInformationForMBMS_item = -1;  /* S_RNTI */
static int hf_rnsap_priorityLevel = -1;           /* PriorityLevel */
static int hf_rnsap_pre_emptionCapability = -1;   /* Pre_emptionCapability */
static int hf_rnsap_pre_emptionVulnerability = -1;  /* Pre_emptionVulnerability */
static int hf_rnsap_allowed_UL_Rate = -1;         /* Allowed_Rate */
static int hf_rnsap_allowed_DL_Rate = -1;         /* Allowed_Rate */
static int hf_rnsap_aOA_LCR = -1;                 /* AOA_LCR */
static int hf_rnsap_aOA_LCR_Accuracy_Class = -1;  /* AOA_LCR_Accuracy_Class */
static int hf_rnsap_badSatelliteInformation = -1;  /* T_badSatelliteInformation */
static int hf_rnsap_badSatelliteInformation_item = -1;  /* T_badSatelliteInformation_item */
static int hf_rnsap_badSAT_ID = -1;               /* SAT_ID */
static int hf_rnsap_nCC = -1;                     /* NCC */
static int hf_rnsap_bCC = -1;                     /* BCC */
static int hf_rnsap_burstStart = -1;              /* INTEGER_0_15 */
static int hf_rnsap_burstLength = -1;             /* INTEGER_10_25 */
static int hf_rnsap_burstFreq = -1;               /* INTEGER_1_16 */
static int hf_rnsap_radioNetwork = -1;            /* CauseRadioNetwork */
static int hf_rnsap_transport = -1;               /* CauseTransport */
static int hf_rnsap_protocol = -1;                /* CauseProtocol */
static int hf_rnsap_misc = -1;                    /* CauseMisc */
static int hf_rnsap_uplinkCellCapacityClassValue = -1;  /* INTEGER_1_100_ */
static int hf_rnsap_downlinkCellCapacityClassValue = -1;  /* INTEGER_1_100_ */
static int hf_rnsap_lAI = -1;                     /* T_lAI */
static int hf_rnsap_pLMN_Identity = -1;           /* PLMN_Identity */
static int hf_rnsap_lAC = -1;                     /* LAC */
static int hf_rnsap_cI = -1;                      /* CI */
static int hf_rnsap_tUTRANGPSMeasurementAccuracyClass = -1;  /* TUTRANGPSAccuracyClass */
static int hf_rnsap_tUTRANGPSMeasurementValueInformation = -1;  /* TUTRANGPSMeasurementValueInformation */
static int hf_rnsap_sFNSFNMeasurementValueInformation = -1;  /* SFNSFNMeasurementValueInformation */
static int hf_rnsap_loadValue = -1;               /* LoadValue */
static int hf_rnsap_transmittedCarrierPowerValue = -1;  /* INTEGER_0_100 */
static int hf_rnsap_receivedTotalWideBandPowerValue = -1;  /* INTEGER_0_621 */
static int hf_rnsap_uplinkTimeslotISCPValue = -1;  /* UL_TimeslotISCP */
static int hf_rnsap_extension_CommonMeasurementValue = -1;  /* Extension_CommonMeasurementValue */
static int hf_rnsap_measurementAvailable = -1;    /* CommonMeasurementAvailable */
static int hf_rnsap_measurementnotAvailable = -1;  /* NULL */
static int hf_rnsap_CorrespondingCells_item = -1;  /* C_ID */
static int hf_rnsap_triggeringMessage = -1;       /* TriggeringMessage */
static int hf_rnsap_procedureCriticality = -1;    /* Criticality */
static int hf_rnsap_iEsCriticalityDiagnostics = -1;  /* CriticalityDiagnostics_IE_List */
static int hf_rnsap_CriticalityDiagnostics_IE_List_item = -1;  /* CriticalityDiagnostics_IE_List_item */
static int hf_rnsap_iECriticality = -1;           /* Criticality */
static int hf_rnsap_iE_ID = -1;                   /* ProtocolIE_ID */
static int hf_rnsap_repetitionNumber = -1;        /* RepetitionNumber0 */
static int hf_rnsap_MessageStructure_item = -1;   /* MessageStructure_item */
static int hf_rnsap_repetitionNumber1 = -1;       /* RepetitionNumber1 */
static int hf_rnsap_rAC = -1;                     /* RAC */
static int hf_rnsap_DCH_FDD_Information_item = -1;  /* DCH_FDD_InformationItem */
static int hf_rnsap_payloadCRC_PresenceIndicator = -1;  /* PayloadCRC_PresenceIndicator */
static int hf_rnsap_ul_FP_Mode = -1;              /* UL_FP_Mode */
static int hf_rnsap_toAWS = -1;                   /* ToAWS */
static int hf_rnsap_toAWE = -1;                   /* ToAWE */
static int hf_rnsap_dCH_SpecificInformationList = -1;  /* DCH_Specific_FDD_InformationList */
static int hf_rnsap_DCH_Specific_FDD_InformationList_item = -1;  /* DCH_Specific_FDD_Item */
static int hf_rnsap_trCH_SrcStatisticsDescr = -1;  /* TrCH_SrcStatisticsDescr */
static int hf_rnsap_ul_transportFormatSet = -1;   /* TransportFormatSet */
static int hf_rnsap_dl_transportFormatSet = -1;   /* TransportFormatSet */
static int hf_rnsap_ul_BLER = -1;                 /* BLER */
static int hf_rnsap_dl_BLER = -1;                 /* BLER */
static int hf_rnsap_frameHandlingPriority = -1;   /* FrameHandlingPriority */
static int hf_rnsap_qE_Selector = -1;             /* QE_Selector */
static int hf_rnsap_dRACControl = -1;             /* DRACControl */
static int hf_rnsap_DCH_InformationResponse_item = -1;  /* DCH_InformationResponseItem */
static int hf_rnsap_DCH_TDD_Information_item = -1;  /* DCH_TDD_InformationItem */
static int hf_rnsap_dCH_SpecificInformationList1 = -1;  /* DCH_Specific_TDD_InformationList */
static int hf_rnsap_DCH_Specific_TDD_InformationList_item = -1;  /* DCH_Specific_TDD_Item */
static int hf_rnsap_ul_cCTrCH_ID = -1;            /* CCTrCH_ID */
static int hf_rnsap_dl_cCTrCH_ID = -1;            /* CCTrCH_ID */
static int hf_rnsap_sIR_Value = -1;               /* SIR_Value */
static int hf_rnsap_sIR_ErrorValue = -1;          /* SIR_Error_Value */
static int hf_rnsap_transmittedCodePowerValue = -1;  /* Transmitted_Code_Power_Value */
static int hf_rnsap_rSCP = -1;                    /* RSCP_Value */
static int hf_rnsap_rxTimingDeviationValue = -1;  /* Rx_Timing_Deviation_Value */
static int hf_rnsap_roundTripTime = -1;           /* Round_Trip_Time_Value */
static int hf_rnsap_extension_DedicatedMeasurementValue = -1;  /* Extension_DedicatedMeasurementValue */
static int hf_rnsap_measurementAvailable1 = -1;   /* DedicatedMeasurementAvailable */
static int hf_rnsap_measurementnotAvailable1 = -1;  /* DedicatedMeasurementnotAvailable */
static int hf_rnsap_dedicatedmeasurementValue = -1;  /* DedicatedMeasurementValue */
static int hf_rnsap_cfn = -1;                     /* CFN */
static int hf_rnsap_separate_indication = -1;     /* NULL */
static int hf_rnsap_activate = -1;                /* Activate_Info */
static int hf_rnsap_deactivate = -1;              /* Deactivate_Info */
static int hf_rnsap_activation_type = -1;         /* Execution_Type */
static int hf_rnsap_initial_dl_tx_power = -1;     /* DL_Power */
static int hf_rnsap_firstRLS_Indicator = -1;      /* FirstRLS_Indicator */
static int hf_rnsap_propagation_delay = -1;       /* PropagationDelay */
static int hf_rnsap_deactivation_type = -1;       /* Execution_Type */
static int hf_rnsap_synchronised = -1;            /* CFN */
static int hf_rnsap_unsynchronised = -1;          /* NULL */
static int hf_rnsap_gPSTOW = -1;                  /* GPSTOW */
static int hf_rnsap_gPS_Status_Health = -1;       /* GPS_Status_Health */
static int hf_rnsap_satellite_DGPSCorrections_Information = -1;  /* T_satellite_DGPSCorrections_Information */
static int hf_rnsap_satellite_DGPSCorrections_Information_item = -1;  /* T_satellite_DGPSCorrections_Information_item */
static int hf_rnsap_sAT_ID = -1;                  /* SAT_ID */
static int hf_rnsap_iode_dgps = -1;               /* BIT_STRING_SIZE_8 */
static int hf_rnsap_uDRE = -1;                    /* UDRE */
static int hf_rnsap_pRC = -1;                     /* PRC */
static int hf_rnsap_range_Correction_Rate = -1;   /* Range_Correction_Rate */
static int hf_rnsap_pRCDeviation = -1;            /* PRCDeviation */
static int hf_rnsap_powerAdjustmentType = -1;     /* PowerAdjustmentType */
static int hf_rnsap_dLReferencePower = -1;        /* DL_Power */
static int hf_rnsap_dLReferencePowerList = -1;    /* DL_ReferencePowerInformationList */
static int hf_rnsap_maxAdjustmentStep = -1;       /* MaxAdjustmentStep */
static int hf_rnsap_adjustmentPeriod = -1;        /* AdjustmentPeriod */
static int hf_rnsap_adjustmentRatio = -1;         /* ScaledAdjustmentRatio */
static int hf_rnsap_DL_ReferencePowerInformationList_item = -1;  /* DL_ReferencePowerInformationItem */
static int hf_rnsap_common_DL_ReferencePowerInformation = -1;  /* DL_Power */
static int hf_rnsap_individual_DL_ReferencePowerInformation = -1;  /* DL_ReferencePowerInformationList */
static int hf_rnsap_DL_Timeslot_Information_item = -1;  /* DL_Timeslot_InformationItem */
static int hf_rnsap_DL_TimeslotLCR_Information_item = -1;  /* DL_TimeslotLCR_InformationItem */
static int hf_rnsap_DL_TimeSlot_ISCP_Info_item = -1;  /* DL_TimeSlot_ISCP_InfoItem */
static int hf_rnsap_dL_TimeslotISCP = -1;         /* DL_TimeslotISCP */
static int hf_rnsap_DL_TimeSlot_ISCP_LCR_Information_item = -1;  /* DL_TimeSlot_ISCP_LCR_InfoItem */
static int hf_rnsap_DSCH_FlowControlInformation_item = -1;  /* DSCH_FlowControlItem */
static int hf_rnsap_dSCH_SchedulingPriority = -1;  /* SchedulingPriorityIndicator */
static int hf_rnsap_mAC_c_sh_SDU_Lengths = -1;    /* MAC_c_sh_SDU_LengthList */
static int hf_rnsap_DSCH_TDD_Information_item = -1;  /* DSCH_TDD_InformationItem */
static int hf_rnsap_eAGCH_ERGCH_EHICH_FDD_ScramblingCode = -1;  /* DL_ScramblingCode */
static int hf_rnsap_eAGCH_ChannelisationCode = -1;  /* FDD_DL_ChannelisationCodeNumber */
static int hf_rnsap_primary_e_RNTI = -1;          /* E_RNTI */
static int hf_rnsap_secondary_e_RNTI = -1;        /* E_RNTI */
static int hf_rnsap_eRGCH_EHICH_ChannelisationCode = -1;  /* FDD_DL_ChannelisationCodeNumber */
static int hf_rnsap_eRGCH_SignatureSequence = -1;  /* ERGCH_SignatureSequence */
static int hf_rnsap_eHICH_SignatureSequence = -1;  /* EHICH_SignatureSequence */
static int hf_rnsap_serving_Grant_Value = -1;     /* E_Serving_Grant_Value */
static int hf_rnsap_primary_Secondary_Grant_Selector = -1;  /* E_Primary_Secondary_Grant_Selector */
static int hf_rnsap_e_RGCH_Release_Indicator = -1;  /* E_RGCH_Release_Indicator */
static int hf_rnsap_eDCH_MACdFlows_Information = -1;  /* EDCH_MACdFlows_Information */
static int hf_rnsap_EDCH_FDD_InformationResponse_item = -1;  /* EDCH_FDD_InformationResponseItem */
static int hf_rnsap_eDCH_MACdFlow_Specific_Information = -1;  /* EDCH_MACdFlow_Specific_InfoToModifyList */
static int hf_rnsap_EDCH_FDD_Update_Information_item = -1;  /* EDCH_FDD_Update_InfoItem */
static int hf_rnsap_eDCH_FDD_DL_ControlChannelInformation = -1;  /* EDCH_FDD_DL_ControlChannelInformation */
static int hf_rnsap_e_DCH_Non_Scheduled_Transmission_Grant = -1;  /* E_DCH_Non_Scheduled_Transmission_Grant_Items */
static int hf_rnsap_e_DCH_Scheduled_Transmission_Grant = -1;  /* NULL */
static int hf_rnsap_E_DCH_LogicalChannelInformation_item = -1;  /* E_DCH_LogicalChannelInformationItem */
static int hf_rnsap_logicalChannelId = -1;        /* LogicalChannelID */
static int hf_rnsap_mACes_GuaranteedBitRate = -1;  /* MACes_Guaranteed_Bitrate */
static int hf_rnsap_eDCH_DDI_Value = -1;          /* EDCH_DDI_Value */
static int hf_rnsap_mACd_PDU_Size_List = -1;      /* E_DCH_MACdPDU_SizeList */
static int hf_rnsap_E_DCH_MACdPDU_SizeList_item = -1;  /* E_DCH_MACdPDU_SizeListItem */
static int hf_rnsap_mACdPDU_Size = -1;            /* MACdPDU_Size */
static int hf_rnsap_E_DCH_LogicalChannelToModify_item = -1;  /* E_DCH_LogicalChannelToModifyItem */
static int hf_rnsap_mACd_PDU_Size_List1 = -1;     /* E_DCH_MACdPDU_SizeToModifyList */
static int hf_rnsap_E_DCH_MACdPDU_SizeToModifyList_item = -1;  /* E_DCH_MACdPDU_SizeListItem */
static int hf_rnsap_E_DCH_LogicalChannelToDelete_item = -1;  /* E_DCH_LogicalChannelToDeleteItem */
static int hf_rnsap_eDCH_MACdFlow_Specific_Information1 = -1;  /* EDCH_MACdFlow_Specific_InfoList */
static int hf_rnsap_EDCH_MACdFlow_Specific_InfoList_item = -1;  /* EDCH_MACdFlow_Specific_InfoItem */
static int hf_rnsap_eDSCH_MACdFlow_ID = -1;       /* EDCH_MACdFlow_ID */
static int hf_rnsap_tnlQoS = -1;                  /* TnlQos */
static int hf_rnsap_maxNr_Retransmissions_EDCH = -1;  /* MaxNr_Retransmissions_EDCH */
static int hf_rnsap_trafficClass = -1;            /* TrafficClass */
static int hf_rnsap_eDCH_HARQ_PO_FDD = -1;        /* E_DCH_HARQ_PO_FDD */
static int hf_rnsap_eDCH_MACdFlow_Multiplexing_List = -1;  /* E_DCH_MACdFlow_Multiplexing_List */
static int hf_rnsap_eDCH_Grant_Type_Information = -1;  /* E_DCH_Grant_Type_Information */
static int hf_rnsap_bundlingModeIndicator = -1;   /* BundlingModeIndicator */
static int hf_rnsap_eDCHLogicalChannelInformation = -1;  /* E_DCH_LogicalChannelInformation */
static int hf_rnsap_EDCH_MACdFlow_Specific_InfoToModifyList_item = -1;  /* EDCH_MACdFlow_Specific_InfoToModifyItem */
static int hf_rnsap_eDCH_LogicalChannelToAdd = -1;  /* E_DCH_LogicalChannelInformation */
static int hf_rnsap_eDCH_LogicalChannelToModify = -1;  /* E_DCH_LogicalChannelToModify */
static int hf_rnsap_eDCH_LogicalChannelToDelete = -1;  /* E_DCH_LogicalChannelToDelete */
static int hf_rnsap_EDCH_MACdFlows_To_Delete_item = -1;  /* EDCH_MACdFlows_To_Delete_Item */
static int hf_rnsap_maxBits_MACe_PDU_non_scheduled = -1;  /* Max_Bits_MACe_PDU_non_scheduled */
static int hf_rnsap_hARQ_Process_Allocation_2ms = -1;  /* HARQ_Process_Allocation_2ms_EDCH */
static int hf_rnsap_maxSet_E_DPDCHs = -1;         /* Max_Set_E_DPDCHs */
static int hf_rnsap_e_TFCS_Information = -1;      /* E_TFCS_Information */
static int hf_rnsap_e_TTI = -1;                   /* E_TTI */
static int hf_rnsap_e_DPCCH_PO = -1;              /* E_DPCCH_PO */
static int hf_rnsap_e_DCH_Serving_RL_in_this_DRNS = -1;  /* EDCH_Serving_RL_in_this_DRNS */
static int hf_rnsap_e_DCH_Serving_RL_not_in_this_DRNS = -1;  /* NULL */
static int hf_rnsap_e_DCH_Serving_RL_Id = -1;     /* RL_ID */
static int hf_rnsap_e_DCH_TFCI_Table_Index = -1;  /* E_DCH_TFCI_Table_Index */
static int hf_rnsap_e_DCH_Min_Set_E_TFCI = -1;    /* E_TFCI */
static int hf_rnsap_reference_E_TFCI_Information = -1;  /* Reference_E_TFCI_Information */
static int hf_rnsap_measurementTreshold = -1;     /* MeasurementThreshold */
static int hf_rnsap_measurementHysteresisTime = -1;  /* MeasurementHysteresisTime */
static int hf_rnsap_measurementIncreaseDecreaseThreshold = -1;  /* MeasurementIncreaseDecreaseThreshold */
static int hf_rnsap_measurementChangeTime = -1;   /* MeasurementChangeTime */
static int hf_rnsap_measurementThreshold1 = -1;   /* MeasurementThreshold */
static int hf_rnsap_measurementThreshold2 = -1;   /* MeasurementThreshold */
static int hf_rnsap_reportPeriodicity = -1;       /* ReportPeriodicity */
static int hf_rnsap_FACH_FlowControlInformation_item = -1;  /* FACH_FlowControlInformationItem */
static int hf_rnsap_fACH_SchedulingPriority = -1;  /* SchedulingPriorityIndicator */
static int hf_rnsap_fACH_InitialWindowSize = -1;  /* FACH_InitialWindowSize */
static int hf_rnsap_FACH_InformationList_item = -1;  /* FACH_InformationItem */
static int hf_rnsap_FACH_PCH_InformationList_item = -1;  /* FACH_PCH_InformationItem */
static int hf_rnsap_FDD_DCHs_to_Modify_item = -1;  /* FDD_DCHs_to_ModifyItem */
static int hf_rnsap_dCH_SpecificInformationList2 = -1;  /* FDD_DCHs_to_ModifySpecificInformationList */
static int hf_rnsap_FDD_DCHs_to_ModifySpecificInformationList_item = -1;  /* FDD_DCHs_to_ModifySpecificItem */
static int hf_rnsap_ul_TransportformatSet = -1;   /* TransportFormatSet */
static int hf_rnsap_dl_TransportformatSet = -1;   /* TransportFormatSet */
static int hf_rnsap_not_Used_dRACControl = -1;    /* NULL */
static int hf_rnsap_FDD_DL_CodeInformation_item = -1;  /* FDD_DL_CodeInformationItem */
static int hf_rnsap_dl_ScramblingCode = -1;       /* DL_ScramblingCode */
static int hf_rnsap_fDD_DL_ChannelisationCodeNumber = -1;  /* FDD_DL_ChannelisationCodeNumber */
static int hf_rnsap_transmission_Gap_Pattern_Sequence_ScramblingCode_Information = -1;  /* Transmission_Gap_Pattern_Sequence_ScramblingCode_Information */
static int hf_rnsap_wT = -1;                      /* INTEGER_1_4 */
static int hf_rnsap_GA_Cell_item = -1;            /* GA_Cell_item */
static int hf_rnsap_cell_GAIgeographicalCoordinate = -1;  /* GeographicalCoordinate */
static int hf_rnsap_pointWithUncertainty = -1;    /* GA_PointWithUnCertainty */
static int hf_rnsap_pointWithUncertaintyEllipse = -1;  /* GA_PointWithUnCertaintyEllipse */
static int hf_rnsap_pointWithAltitude = -1;       /* GA_PointWithAltitude */
static int hf_rnsap_pointWithAltitudeAndUncertaintyEllipsoid = -1;  /* GA_PointWithAltitudeAndUncertaintyEllipsoid */
static int hf_rnsap_ellipsoidArc = -1;            /* GA_EllipsoidArc */
static int hf_rnsap_directionOfAltitude = -1;     /* T_directionOfAltitude */
static int hf_rnsap_altitude = -1;                /* INTEGER_0_32767 */
static int hf_rnsap_geographicalCoordinates = -1;  /* GeographicalCoordinate */
static int hf_rnsap_innerRadius = -1;             /* INTEGER_0_65535 */
static int hf_rnsap_uncertaintyRadius = -1;       /* INTEGER_0_127 */
static int hf_rnsap_offsetAngle = -1;             /* INTEGER_0_179 */
static int hf_rnsap_includedAngle = -1;           /* INTEGER_0_179 */
static int hf_rnsap_confidence = -1;              /* INTEGER_0_127 */
static int hf_rnsap_altitudeAndDirection = -1;    /* GA_AltitudeAndDirection */
static int hf_rnsap_uncertaintyEllipse = -1;      /* GA_UncertaintyEllipse */
static int hf_rnsap_uncertaintyAltitude = -1;     /* INTEGER_0_127 */
static int hf_rnsap_uncertaintySemi_major = -1;   /* INTEGER_0_127 */
static int hf_rnsap_uncertaintySemi_minor = -1;   /* INTEGER_0_127 */
static int hf_rnsap_orientationOfMajorAxis = -1;  /* INTEGER_0_179 */
static int hf_rnsap_uncertaintyCode = -1;         /* INTEGER_0_127 */
static int hf_rnsap_geographicalCoordinate = -1;  /* GeographicalCoordinate */
static int hf_rnsap_latitudeSign = -1;            /* T_latitudeSign */
static int hf_rnsap_latitude = -1;                /* INTEGER_0_8388607 */
static int hf_rnsap_longitude = -1;               /* INTEGER_M8388608_8388607 */
static int hf_rnsap_sI = -1;                      /* GERAN_SystemInfo */
static int hf_rnsap_pSI = -1;                     /* GERAN_SystemInfo */
static int hf_rnsap_GERAN_SystemInfo_item = -1;   /* GERAN_SystemInfo_item */
static int hf_rnsap_gERAN_SI_block = -1;          /* OCTET_STRING_SIZE_1_23 */
static int hf_rnsap_wna_alm = -1;                 /* BIT_STRING_SIZE_8 */
static int hf_rnsap_satellite_Almanac_Information = -1;  /* T_satellite_Almanac_Information */
static int hf_rnsap_satellite_Almanac_Information_item = -1;  /* T_satellite_Almanac_Information_item */
static int hf_rnsap_dATA_ID = -1;                 /* DATA_ID */
static int hf_rnsap_gps_e_alm = -1;               /* BIT_STRING_SIZE_16 */
static int hf_rnsap_gps_toa_alm = -1;             /* BIT_STRING_SIZE_8 */
static int hf_rnsap_gps_delta_I_alm = -1;         /* BIT_STRING_SIZE_16 */
static int hf_rnsap_omegadot_alm = -1;            /* BIT_STRING_SIZE_16 */
static int hf_rnsap_svhealth_alm = -1;            /* BIT_STRING_SIZE_8 */
static int hf_rnsap_gps_a_sqrt_alm = -1;          /* BIT_STRING_SIZE_24 */
static int hf_rnsap_omegazero_alm = -1;           /* BIT_STRING_SIZE_24 */
static int hf_rnsap_m_zero_alm = -1;              /* BIT_STRING_SIZE_24 */
static int hf_rnsap_gps_omega_alm = -1;           /* BIT_STRING_SIZE_24 */
static int hf_rnsap_gps_af_zero_alm = -1;         /* BIT_STRING_SIZE_11 */
static int hf_rnsap_gps_af_one_alm = -1;          /* BIT_STRING_SIZE_11 */
static int hf_rnsap_sVGlobalHealth_alm = -1;      /* BIT_STRING_SIZE_364 */
static int hf_rnsap_Satellite_Almanac_Information_ExtItem_item = -1;  /* Satellite_Almanac_Information_ExtItem_item */
static int hf_rnsap_GPSInformation_item = -1;     /* GPSInformation_item */
static int hf_rnsap_gPSInformationItem = -1;      /* T_gPSInformationItem */
static int hf_rnsap_alpha_zero_ionos = -1;        /* BIT_STRING_SIZE_8 */
static int hf_rnsap_alpha_one_ionos = -1;         /* BIT_STRING_SIZE_8 */
static int hf_rnsap_alpha_two_ionos = -1;         /* BIT_STRING_SIZE_8 */
static int hf_rnsap_alpha_three_ionos = -1;       /* BIT_STRING_SIZE_8 */
static int hf_rnsap_beta_zero_ionos = -1;         /* BIT_STRING_SIZE_8 */
static int hf_rnsap_beta_one_ionos = -1;          /* BIT_STRING_SIZE_8 */
static int hf_rnsap_beta_two_ionos = -1;          /* BIT_STRING_SIZE_8 */
static int hf_rnsap_beta_three_ionos = -1;        /* BIT_STRING_SIZE_8 */
static int hf_rnsap_GPS_NavigationModel_and_TimeRecovery_item = -1;  /* GPS_NavigationModel_and_TimeRecovery_item */
static int hf_rnsap_tx_tow_nav = -1;              /* INTEGER_0_1048575 */
static int hf_rnsap_tlm_message_nav = -1;         /* BIT_STRING_SIZE_14 */
static int hf_rnsap_tlm_revd_c_nav = -1;          /* BIT_STRING_SIZE_2 */
static int hf_rnsap_ho_word_nav = -1;             /* BIT_STRING_SIZE_22 */
static int hf_rnsap_w_n_nav = -1;                 /* BIT_STRING_SIZE_10 */
static int hf_rnsap_ca_or_p_on_l2_nav = -1;       /* BIT_STRING_SIZE_2 */
static int hf_rnsap_user_range_accuracy_index_nav = -1;  /* BIT_STRING_SIZE_4 */
static int hf_rnsap_sv_health_nav = -1;           /* BIT_STRING_SIZE_6 */
static int hf_rnsap_iodc_nav = -1;                /* BIT_STRING_SIZE_10 */
static int hf_rnsap_l2_p_dataflag_nav = -1;       /* BIT_STRING_SIZE_1 */
static int hf_rnsap_sf1_reserved_nav = -1;        /* BIT_STRING_SIZE_87 */
static int hf_rnsap_t_gd_nav = -1;                /* BIT_STRING_SIZE_8 */
static int hf_rnsap_t_oc_nav = -1;                /* BIT_STRING_SIZE_16 */
static int hf_rnsap_a_f_2_nav = -1;               /* BIT_STRING_SIZE_8 */
static int hf_rnsap_a_f_1_nav = -1;               /* BIT_STRING_SIZE_16 */
static int hf_rnsap_a_f_zero_nav = -1;            /* BIT_STRING_SIZE_22 */
static int hf_rnsap_c_rs_nav = -1;                /* BIT_STRING_SIZE_16 */
static int hf_rnsap_delta_n_nav = -1;             /* BIT_STRING_SIZE_16 */
static int hf_rnsap_m_zero_nav = -1;              /* BIT_STRING_SIZE_32 */
static int hf_rnsap_c_uc_nav = -1;                /* BIT_STRING_SIZE_16 */
static int hf_rnsap_gps_e_nav = -1;               /* BIT_STRING_SIZE_32 */
static int hf_rnsap_c_us_nav = -1;                /* BIT_STRING_SIZE_16 */
static int hf_rnsap_a_sqrt_nav = -1;              /* BIT_STRING_SIZE_32 */
static int hf_rnsap_t_oe_nav = -1;                /* BIT_STRING_SIZE_16 */
static int hf_rnsap_fit_interval_flag_nav = -1;   /* BIT_STRING_SIZE_1 */
static int hf_rnsap_aodo_nav = -1;                /* BIT_STRING_SIZE_5 */
static int hf_rnsap_c_ic_nav = -1;                /* BIT_STRING_SIZE_16 */
static int hf_rnsap_omega_zero_nav = -1;          /* BIT_STRING_SIZE_32 */
static int hf_rnsap_c_is_nav = -1;                /* BIT_STRING_SIZE_16 */
static int hf_rnsap_i_zero_nav = -1;              /* BIT_STRING_SIZE_32 */
static int hf_rnsap_c_rc_nav = -1;                /* BIT_STRING_SIZE_16 */
static int hf_rnsap_gps_omega_nav = -1;           /* BIT_STRING_SIZE_32 */
static int hf_rnsap_omegadot_nav = -1;            /* BIT_STRING_SIZE_24 */
static int hf_rnsap_idot_nav = -1;                /* BIT_STRING_SIZE_14 */
static int hf_rnsap_spare_zero_fill = -1;         /* BIT_STRING_SIZE_20 */
static int hf_rnsap_badSatellites = -1;           /* BadSatellites */
static int hf_rnsap_noBadSatellite = -1;          /* NULL */
static int hf_rnsap_a_one_utc = -1;               /* BIT_STRING_SIZE_24 */
static int hf_rnsap_a_zero_utc = -1;              /* BIT_STRING_SIZE_32 */
static int hf_rnsap_t_ot_utc = -1;                /* BIT_STRING_SIZE_8 */
static int hf_rnsap_delta_t_ls_utc = -1;          /* BIT_STRING_SIZE_8 */
static int hf_rnsap_w_n_t_utc = -1;               /* BIT_STRING_SIZE_8 */
static int hf_rnsap_w_n_lsf_utc = -1;             /* BIT_STRING_SIZE_8 */
static int hf_rnsap_dn_utc = -1;                  /* BIT_STRING_SIZE_8 */
static int hf_rnsap_delta_t_lsf_utc = -1;         /* BIT_STRING_SIZE_8 */
static int hf_rnsap_guaranteed_UL_Rate = -1;      /* Guaranteed_Rate */
static int hf_rnsap_guaranteed_DL_Rate = -1;      /* Guaranteed_Rate */
static int hf_rnsap_implicit = -1;                /* HARQ_MemoryPartitioning_Implicit */
static int hf_rnsap_explicit = -1;                /* HARQ_MemoryPartitioning_Explicit */
static int hf_rnsap_number_of_Processes = -1;     /* INTEGER_1_8_ */
static int hf_rnsap_hARQ_MemoryPartitioningList = -1;  /* HARQ_MemoryPartitioningList */
static int hf_rnsap_HARQ_MemoryPartitioningList_item = -1;  /* HARQ_MemoryPartitioningItem */
static int hf_rnsap_process_Memory_Size = -1;     /* T_process_Memory_Size */
static int hf_rnsap_hSDSCH_MACdFlows_Information = -1;  /* HSDSCH_MACdFlows_Information */
static int hf_rnsap_uE_Capabilities_Info = -1;    /* UE_Capabilities_Info */
static int hf_rnsap_mAChs_Reordering_Buffer_Size_for_RLC_UM = -1;  /* MAChsReorderingBufferSize_for_RLC_UM */
static int hf_rnsap_cqiFeedback_CycleK = -1;      /* CQI_Feedback_Cycle */
static int hf_rnsap_cqiRepetitionFactor = -1;     /* CQI_RepetitionFactor */
static int hf_rnsap_ackNackRepetitionFactor = -1;  /* AckNack_RepetitionFactor */
static int hf_rnsap_cqiPowerOffset = -1;          /* CQI_Power_Offset */
static int hf_rnsap_ackPowerOffset = -1;          /* Ack_Power_Offset */
static int hf_rnsap_nackPowerOffset = -1;         /* Nack_Power_Offset */
static int hf_rnsap_hsscch_PowerOffset = -1;      /* HSSCCH_PowerOffset */
static int hf_rnsap_hSDSCH_MACdFlow_Specific_InfoList_Response = -1;  /* HSDSCH_MACdFlow_Specific_InfoList_Response */
static int hf_rnsap_hSSCCH_Specific_InfoList_Response = -1;  /* HSSCCH_FDD_Specific_InfoList_Response */
static int hf_rnsap_hSPDSCH_and_HSSCCH_ScramblingCode = -1;  /* DL_ScramblingCode */
static int hf_rnsap_measurement_Power_Offset = -1;  /* Measurement_Power_Offset */
static int hf_rnsap_hARQ_MemoryPartitioning = -1;  /* HARQ_MemoryPartitioning */
static int hf_rnsap_hSDSCH_MACdFlow_Specific_InfoList_to_Modify = -1;  /* HSDSCH_MACdFlow_Specific_InfoList_to_Modify */
static int hf_rnsap_priorityQueue_Info_to_Modify = -1;  /* PriorityQueue_InfoList_to_Modify */
static int hf_rnsap_hSSCCH_CodeChangeGrant = -1;  /* HSSCCH_Code_Change_Grant */
static int hf_rnsap_tDDAckNackPowerOffset = -1;   /* TDD_AckNack_Power_Offset */
static int hf_rnsap_priorityQueueInfotoModifyUnsynchronised = -1;  /* PriorityQueue_InfoList_to_Modify_Unsynchronised */
static int hf_rnsap_HSDSCH_MACdFlow_Specific_InfoList_item = -1;  /* HSDSCH_MACdFlow_Specific_InfoItem */
static int hf_rnsap_HSDSCH_MACdFlow_Specific_InfoList_Response_item = -1;  /* HSDSCH_MACdFlow_Specific_InfoItem_Response */
static int hf_rnsap_hSDSCH_Initial_Capacity_Allocation = -1;  /* HSDSCH_Initial_Capacity_Allocation */
static int hf_rnsap_HSDSCH_MACdFlow_Specific_InfoList_to_Modify_item = -1;  /* HSDSCH_MACdFlow_Specific_InfoItem_to_Modify */
static int hf_rnsap_hSDSCH_MACdFlow_Specific_Info = -1;  /* HSDSCH_MACdFlow_Specific_InfoList */
static int hf_rnsap_priorityQueue_Info = -1;      /* PriorityQueue_InfoList */
static int hf_rnsap_HSDSCH_MACdFlows_to_Delete_item = -1;  /* HSDSCH_MACdFlows_to_Delete_Item */
static int hf_rnsap_hsDSCH_MACdFlow_ID = -1;      /* HSDSCH_MACdFlow_ID */
static int hf_rnsap_HSDSCH_Initial_Capacity_Allocation_item = -1;  /* HSDSCH_Initial_Capacity_AllocationItem */
static int hf_rnsap_maximum_MACdPDU_Size = -1;    /* MACdPDU_Size */
static int hf_rnsap_hSDSCH_InitialWindowSize = -1;  /* HSDSCH_InitialWindowSize */
static int hf_rnsap_tDD_AckNack_Power_Offset = -1;  /* TDD_AckNack_Power_Offset */
static int hf_rnsap_hSSCCH_TDD_Specific_InfoList_Response = -1;  /* HSSCCH_TDD_Specific_InfoList_Response */
static int hf_rnsap_hSSCCH_TDD_Specific_InfoList_Response_LCR = -1;  /* HSSCCH_TDD_Specific_InfoList_Response_LCR */
static int hf_rnsap_hSPDSCH_TDD_Specific_InfoList_Response = -1;  /* HSPDSCH_TDD_Specific_InfoList_Response */
static int hf_rnsap_hSPDSCH_TDD_Specific_InfoList_Response_LCR = -1;  /* HSPDSCH_TDD_Specific_InfoList_Response_LCR */
static int hf_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_item = -1;  /* HSPDSCH_TDD_Specific_InfoItem_Response */
static int hf_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_LCR_item = -1;  /* HSPDSCH_TDD_Specific_InfoItem_Response_LCR */
static int hf_rnsap_HSSCCH_FDD_Specific_InfoList_Response_item = -1;  /* HSSCCH_FDD_Specific_InfoItem_Response */
static int hf_rnsap_code_Number = -1;             /* INTEGER_0_127 */
static int hf_rnsap_HSSCCH_TDD_Specific_InfoList_Response_item = -1;  /* HSSCCH_TDD_Specific_InfoItem_Response */
static int hf_rnsap_hSSICH_Info = -1;             /* HSSICH_Info */
static int hf_rnsap_HSSCCH_TDD_Specific_InfoList_Response_LCR_item = -1;  /* HSSCCH_TDD_Specific_InfoItem_Response_LCR */
static int hf_rnsap_first_TDD_ChannelisationCode = -1;  /* TDD_ChannelisationCode */
static int hf_rnsap_second_TDD_ChannelisationCode = -1;  /* TDD_ChannelisationCode */
static int hf_rnsap_hSSICH_InfoLCR = -1;          /* HSSICH_InfoLCR */
static int hf_rnsap_hsSICH_ID = -1;               /* HS_SICH_ID */
static int hf_rnsap_failed_HS_SICH = -1;          /* HS_SICH_failed */
static int hf_rnsap_missed_HS_SICH = -1;          /* HS_SICH_missed */
static int hf_rnsap_total_HS_SICH = -1;           /* HS_SICH_total */
static int hf_rnsap_hsSCCHCodeChangeIndicator = -1;  /* HSSCCH_CodeChangeIndicator */
static int hf_rnsap_onDemand = -1;                /* NULL */
static int hf_rnsap_periodic = -1;                /* PeriodicInformation */
static int hf_rnsap_onModification = -1;          /* OnModificationInformation */
static int hf_rnsap_min = -1;                     /* INTEGER_1_60_ */
static int hf_rnsap_hour = -1;                    /* INTEGER_1_24_ */
static int hf_rnsap_dGPSThreshold = -1;           /* DGPSThreshold */
static int hf_rnsap_informationTypeItem = -1;     /* T_informationTypeItem */
static int hf_rnsap_gPSInformation = -1;          /* GPSInformation */
static int hf_rnsap_iPDL_FDD_Parameters = -1;     /* IPDL_FDD_Parameters */
static int hf_rnsap_iPDL_TDD_Parameters = -1;     /* IPDL_TDD_Parameters */
static int hf_rnsap_extension_IPDLParameters = -1;  /* Extension_IPDLParameters */
static int hf_rnsap_iPSpacingFDD = -1;            /* IPSpacingFDD */
static int hf_rnsap_iPLength = -1;                /* IPLength */
static int hf_rnsap_iPOffset = -1;                /* IPOffset */
static int hf_rnsap_seed = -1;                    /* Seed */
static int hf_rnsap_burstModeParameters = -1;     /* BurstModeParameters */
static int hf_rnsap_iPSpacingTDD = -1;            /* IPSpacingTDD */
static int hf_rnsap_iPStart = -1;                 /* IPStart */
static int hf_rnsap_iPSlot = -1;                  /* IPSlot */
static int hf_rnsap_iP_P_CCPCH = -1;              /* IP_P_CCPCH */
static int hf_rnsap_iPSub = -1;                   /* IPSub */
static int hf_rnsap_uplinkLoadValue = -1;         /* INTEGER_0_100 */
static int hf_rnsap_downlinkLoadValue = -1;       /* INTEGER_0_100 */
static int hf_rnsap_MAC_c_sh_SDU_LengthList_item = -1;  /* MAC_c_sh_SDU_Length */
static int hf_rnsap_MACdPDU_Size_IndexList_item = -1;  /* MACdPDU_Size_IndexItem */
static int hf_rnsap_sID = -1;                     /* SID */
static int hf_rnsap_MACdPDU_Size_IndexList_to_Modify_item = -1;  /* MACdPDU_Size_IndexItem_to_Modify */
static int hf_rnsap_accessPointName = -1;         /* AccessPointName */
static int hf_rnsap_iPMulticastAddress = -1;      /* IPMulticastAddress */
static int hf_rnsap_MBMS_Bearer_Service_List_item = -1;  /* TMGI */
static int hf_rnsap_transmissionMode = -1;        /* TransmissionMode */
static int hf_rnsap_preferredFrequencyLayer = -1;  /* UARFCN */
static int hf_rnsap_tMGI = -1;                    /* TMGI */
static int hf_rnsap_pTM_Cell_List = -1;           /* PTMCellList */
static int hf_rnsap_pTP_Cell_List = -1;           /* PTPCellList */
static int hf_rnsap_not_Provided_Cell_List = -1;  /* NotProvidedCellList */
static int hf_rnsap_affectedUEInformationForMBMS = -1;  /* AffectedUEInformationForMBMS */
static int hf_rnsap_preferredFrequencyLayerInfo = -1;  /* PreferredFrequencyLayerInfo */
static int hf_rnsap_sir = -1;                     /* SIR_Value_IncrDecrThres */
static int hf_rnsap_sir_error = -1;               /* SIR_Error_Value_IncrDecrThres */
static int hf_rnsap_transmitted_code_power = -1;  /* Transmitted_Code_Power_Value_IncrDecrThres */
static int hf_rnsap_rscp = -1;                    /* RSCP_Value_IncrDecrThres */
static int hf_rnsap_round_trip_time = -1;         /* Round_Trip_Time_IncrDecrThres */
static int hf_rnsap_extension_MeasurementIncreaseDecreaseThreshold = -1;  /* Extension_MeasurementIncreaseDecreaseThreshold */
static int hf_rnsap_sir1 = -1;                    /* SIR_Value */
static int hf_rnsap_sir_error1 = -1;              /* SIR_Error_Value */
static int hf_rnsap_transmitted_code_power1 = -1;  /* Transmitted_Code_Power_Value */
static int hf_rnsap_rscp1 = -1;                   /* RSCP_Value */
static int hf_rnsap_rx_timing_deviation = -1;     /* Rx_Timing_Deviation_Value */
static int hf_rnsap_round_trip_time1 = -1;        /* Round_Trip_Time_Value */
static int hf_rnsap_extension_MeasurementThreshold = -1;  /* Extension_MeasurementThreshold */
static int hf_rnsap_type1 = -1;                   /* T_type1 */
static int hf_rnsap_midambleConfigurationBurstType1And3 = -1;  /* MidambleConfigurationBurstType1And3 */
static int hf_rnsap_midambleAllocationMode = -1;  /* T_midambleAllocationMode */
static int hf_rnsap_defaultMidamble = -1;         /* NULL */
static int hf_rnsap_commonMidamble = -1;          /* NULL */
static int hf_rnsap_ueSpecificMidamble = -1;      /* MidambleShiftLong */
static int hf_rnsap_type2 = -1;                   /* T_type2 */
static int hf_rnsap_midambleConfigurationBurstType2 = -1;  /* MidambleConfigurationBurstType2 */
static int hf_rnsap_midambleAllocationMode1 = -1;  /* T_midambleAllocationMode1 */
static int hf_rnsap_ueSpecificMidamble1 = -1;     /* MidambleShiftShort */
static int hf_rnsap_type3 = -1;                   /* T_type3 */
static int hf_rnsap_midambleAllocationMode2 = -1;  /* T_midambleAllocationMode2 */
static int hf_rnsap_midambleAllocationMode3 = -1;  /* MidambleAllocationMode */
static int hf_rnsap_midambleShift = -1;           /* MidambleShiftLong */
static int hf_rnsap_midambleConfigurationLCR = -1;  /* MidambleConfigurationLCR */
static int hf_rnsap_addPriorityQueue = -1;        /* PriorityQueue_InfoItem_to_Add */
static int hf_rnsap_modifyPriorityQueue = -1;     /* PriorityQueue_InfoItem_to_Modify */
static int hf_rnsap_deletePriorityQueue = -1;     /* PriorityQueue_Id */
static int hf_rnsap_gERAN_SI_Type = -1;           /* GERAN_SI_Type */
static int hf_rnsap_Neighbouring_UMTS_CellInformation_item = -1;  /* ProtocolIE_Single_Container */
static int hf_rnsap_rNC_ID = -1;                  /* RNC_ID */
static int hf_rnsap_cN_PS_DomainIdentifier = -1;  /* CN_PS_DomainIdentifier */
static int hf_rnsap_cN_CS_DomainIdentifier = -1;  /* CN_CS_DomainIdentifier */
static int hf_rnsap_neighbouring_FDD_CellInformation = -1;  /* Neighbouring_FDD_CellInformation */
static int hf_rnsap_neighbouring_TDD_CellInformation = -1;  /* Neighbouring_TDD_CellInformation */
static int hf_rnsap_Neighbouring_FDD_CellInformation_item = -1;  /* Neighbouring_FDD_CellInformationItem */
static int hf_rnsap_uARFCNforNu = -1;             /* UARFCN */
static int hf_rnsap_uARFCNforNd = -1;             /* UARFCN */
static int hf_rnsap_cellIndividualOffset = -1;    /* CellIndividualOffset */
static int hf_rnsap_txDiversityIndicator = -1;    /* TxDiversityIndicator */
static int hf_rnsap_sTTD_SupportIndicator = -1;   /* STTD_SupportIndicator */
static int hf_rnsap_closedLoopMode1_SupportIndicator = -1;  /* ClosedLoopMode1_SupportIndicator */
static int hf_rnsap_not_used_closedLoopMode2_SupportIndicator = -1;  /* NULL */
static int hf_rnsap_uARFCN = -1;                  /* UARFCN */
static int hf_rnsap_Neighbouring_GSM_CellInformationIEs_item = -1;  /* Neighbouring_GSM_CellInformationItem */
static int hf_rnsap_bSIC = -1;                    /* BSIC */
static int hf_rnsap_band_Indicator = -1;          /* Band_Indicator */
static int hf_rnsap_bCCH_ARFCN = -1;              /* BCCH_ARFCN */
static int hf_rnsap_Neighbouring_TDD_CellInformation_item = -1;  /* Neighbouring_TDD_CellInformationItem */
static int hf_rnsap_dPCHConstantValue = -1;       /* DPCHConstantValue */
static int hf_rnsap_Neighbouring_LCR_TDD_CellInformation_item = -1;  /* Neighbouring_LCR_TDD_CellInformationItem */
static int hf_rnsap_restrictionStateIndicator = -1;  /* RestrictionStateIndicator */
static int hf_rnsap_NotProvidedCellList_item = -1;  /* MBMSChannelTypeCellList */
static int hf_rnsap_uplinkNRTLoadInformationValue = -1;  /* INTEGER_0_3 */
static int hf_rnsap_downlinkNRTLoadInformationValue = -1;  /* INTEGER_0_3 */
static int hf_rnsap_measurementThreshold = -1;    /* MeasurementThreshold */
static int hf_rnsap_informationThreshold = -1;    /* InformationThreshold */
static int hf_rnsap_PCH_InformationList_item = -1;  /* PCH_InformationItem */
static int hf_rnsap_informationReportPeriodicity = -1;  /* InformationReportPeriodicity */
static int hf_rnsap_imsi = -1;                    /* IMSI */
static int hf_rnsap_defaultPreferredFrequency = -1;  /* UARFCN */
static int hf_rnsap_additionalPreferredFrequency = -1;  /* AdditionalPreferredFrequency */
static int hf_rnsap_PriorityQueue_InfoList_item = -1;  /* PriorityQueue_InfoItem */
static int hf_rnsap_priorityQueue_Id = -1;        /* PriorityQueue_Id */
static int hf_rnsap_associatedHSDSCH_MACdFlow = -1;  /* HSDSCH_MACdFlow_ID */
static int hf_rnsap_t1 = -1;                      /* T1 */
static int hf_rnsap_discardTimer = -1;            /* DiscardTimer */
static int hf_rnsap_mAC_hsWindowSize = -1;        /* MAC_hsWindowSize */
static int hf_rnsap_mAChsGuaranteedBitRate = -1;  /* MAChsGuaranteedBitRate */
static int hf_rnsap_mACdPDU_Size_Index = -1;      /* MACdPDU_Size_IndexList */
static int hf_rnsap_rLC_Mode = -1;                /* RLC_Mode */
static int hf_rnsap_PriorityQueue_InfoList_to_Modify_item = -1;  /* ModifyPriorityQueue */
static int hf_rnsap_mACdPDU_Size_Index_to_Modify = -1;  /* MACdPDU_Size_IndexList_to_Modify */
static int hf_rnsap_PriorityQueue_InfoList_to_Modify_Unsynchronised_item = -1;  /* PriorityQueue_InfoItem_to_Modify_Unsynchronised */
static int hf_rnsap_priorityQueueId = -1;         /* PriorityQueue_Id */
static int hf_rnsap_mBMSChannelTypeInfo = -1;     /* MBMSChannelTypeInfo */
static int hf_rnsap_mBMSPreferredFreqLayerInfo = -1;  /* MBMSPreferredFreqLayerInfo */
static int hf_rnsap_PTMCellList_item = -1;        /* MBMSChannelTypeCellList */
static int hf_rnsap_PTPCellList_item = -1;        /* MBMSChannelTypeCellList */
static int hf_rnsap_RB_Info_item = -1;            /* RB_Identity */
static int hf_rnsap_Reference_E_TFCI_Information_item = -1;  /* Reference_E_TFCI_Information_Item */
static int hf_rnsap_reference_E_TFCI = -1;        /* E_TFCI */
static int hf_rnsap_reference_E_TFCI_PO = -1;     /* Reference_E_TFCI_PO */
static int hf_rnsap_periodic1 = -1;               /* Periodic */
static int hf_rnsap_eventA = -1;                  /* EventA */
static int hf_rnsap_eventB = -1;                  /* EventB */
static int hf_rnsap_eventC = -1;                  /* EventC */
static int hf_rnsap_eventD = -1;                  /* EventD */
static int hf_rnsap_eventE = -1;                  /* EventE */
static int hf_rnsap_eventF = -1;                  /* EventF */
static int hf_rnsap_extension_ReportCharacteristics = -1;  /* Extension_ReportCharacteristics */
static int hf_rnsap_ten_msec = -1;                /* INTEGER_1_6000_ */
static int hf_rnsap_gA_AccessPointPositionwithAltitude = -1;  /* GA_AccessPointPositionwithOptionalAltitude */
static int hf_rnsap_iPDLParameters = -1;          /* IPDLParameters */
static int hf_rnsap_dGPSCorrections = -1;         /* DGPSCorrections */
static int hf_rnsap_gPS_NavigationModel_and_TimeRecovery = -1;  /* GPS_NavigationModel_and_TimeRecovery */
static int hf_rnsap_gPS_Ionospheric_Model = -1;   /* GPS_Ionospheric_Model */
static int hf_rnsap_gPS_UTC_Model = -1;           /* GPS_UTC_Model */
static int hf_rnsap_gPS_Almanac = -1;             /* GPS_Almanac */
static int hf_rnsap_gPS_RealTime_Integrity = -1;  /* GPS_RealTime_Integrity */
static int hf_rnsap_gPS_RX_POS = -1;              /* GPS_RX_POS */
static int hf_rnsap_sFNSFN_GA_AccessPointPosition = -1;  /* GA_AccessPointPositionwithOptionalAltitude */
static int hf_rnsap_informationAvailable = -1;    /* InformationAvailable */
static int hf_rnsap_informationNotAvailable = -1;  /* InformationNotAvailable */
static int hf_rnsap_RL_Specific_DCH_Info_item = -1;  /* RL_Specific_DCH_Info_Item */
static int hf_rnsap_dCH_id = -1;                  /* DCH_ID */
static int hf_rnsap_RL_Specific_EDCH_Information_item = -1;  /* RL_Specific_EDCH_InfoItem */
static int hf_rnsap_uplinkRTLoadValue = -1;       /* INTEGER_0_100 */
static int hf_rnsap_downlinkRTLoadValue = -1;     /* INTEGER_0_100 */
static int hf_rnsap_sAC = -1;                     /* SAC */
static int hf_rnsap_secondary_CCPCH_TDD_InformationList = -1;  /* Secondary_CCPCH_TDD_InformationList */
static int hf_rnsap_fACH_InformationList = -1;    /* FACH_InformationList */
static int hf_rnsap_pCH_InformationList = -1;     /* PCH_InformationList */
static int hf_rnsap_new_secondary_CPICH = -1;     /* Secondary_CPICH_Information */
static int hf_rnsap_secondary_CPICH_shall_not_be_used = -1;  /* NULL */
static int hf_rnsap_secondary_LCR_CCPCH_TDD_InformationList = -1;  /* Secondary_LCR_CCPCH_TDD_InformationList */
static int hf_rnsap_Secondary_CCPCH_TDD_InformationList_item = -1;  /* Secondary_CCPCH_TDD_InformationItem */
static int hf_rnsap_secondary_CCPCH_TDD_Code_Information = -1;  /* Secondary_CCPCH_TDD_Code_Information */
static int hf_rnsap_tDD_PhysicalChannelOffset = -1;  /* TDD_PhysicalChannelOffset */
static int hf_rnsap_Secondary_LCR_CCPCH_TDD_InformationList_item = -1;  /* Secondary_LCR_CCPCH_TDD_InformationItem */
static int hf_rnsap_secondary_LCR_CCPCH_TDD_Code_Information = -1;  /* Secondary_LCR_CCPCH_TDD_Code_Information */
static int hf_rnsap_Secondary_CCPCH_TDD_Code_Information_item = -1;  /* Secondary_CCPCH_TDD_Code_InformationItem */
static int hf_rnsap_Secondary_LCR_CCPCH_TDD_Code_Information_item = -1;  /* Secondary_LCR_CCPCH_TDD_Code_InformationItem */
static int hf_rnsap_s_CCPCH_TimeSlotFormat_LCR = -1;  /* TDD_DL_DPCH_TimeSlotFormat_LCR */
static int hf_rnsap_sFNSFNChangeLimit = -1;       /* SFNSFNChangeLimit */
static int hf_rnsap_predictedSFNSFNDeviationLimit = -1;  /* PredictedSFNSFNDeviationLimit */
static int hf_rnsap_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation = -1;  /* T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation */
static int hf_rnsap_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item = -1;  /* T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item */
static int hf_rnsap_sFNSFNValue = -1;             /* SFNSFNValue */
static int hf_rnsap_sFNSFNQuality = -1;           /* SFNSFNQuality */
static int hf_rnsap_sFNSFNDriftRate = -1;         /* SFNSFNDriftRate */
static int hf_rnsap_sFNSFNDriftRateQuality = -1;  /* SFNSFNDriftRateQuality */
static int hf_rnsap_sFNSFNTimeStampInformation = -1;  /* SFNSFNTimeStampInformation */
static int hf_rnsap_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation = -1;  /* T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation */
static int hf_rnsap_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item = -1;  /* T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item */
static int hf_rnsap_sFNSFNTimeStamp_FDD = -1;     /* SFN */
static int hf_rnsap_sFNSFNTimeStamp_TDD = -1;     /* SFNSFNTimeStamp_TDD */
static int hf_rnsap_sFN = -1;                     /* SFN */
static int hf_rnsap_sFNSFN_FDD = -1;              /* SFNSFN_FDD */
static int hf_rnsap_sFNSFN_TDD = -1;              /* SFNSFN_TDD */
static int hf_rnsap_listOfSNAs = -1;              /* ListOfSNAs */
static int hf_rnsap_ListOfSNAs_item = -1;         /* SNACode */
static int hf_rnsap_sRNTI_BitMaskIndex = -1;      /* T_sRNTI_BitMaskIndex */
static int hf_rnsap_n_INSYNC_IND = -1;            /* INTEGER_1_256 */
static int hf_rnsap_n_OUTSYNC_IND = -1;           /* INTEGER_1_256 */
static int hf_rnsap_t_RLFAILURE = -1;             /* INTEGER_0_255 */
static int hf_rnsap_maxSYNC_UL_transmissions = -1;  /* T_maxSYNC_UL_transmissions */
static int hf_rnsap_powerRampStep = -1;           /* INTEGER_0_3_ */
static int hf_rnsap_modulation = -1;              /* Modulation */
static int hf_rnsap_TDD_DCHs_to_Modify_item = -1;  /* TDD_DCHs_to_ModifyItem */
static int hf_rnsap_dCH_SpecificInformationList3 = -1;  /* TDD_DCHs_to_ModifySpecificInformationList */
static int hf_rnsap_TDD_DCHs_to_ModifySpecificInformationList_item = -1;  /* TDD_DCHs_to_ModifySpecificItem */
static int hf_rnsap_ul_CCTrCH_ID = -1;            /* CCTrCH_ID */
static int hf_rnsap_dl_CCTrCH_ID = -1;            /* CCTrCH_ID */
static int hf_rnsap_TDD_DL_Code_Information_item = -1;  /* TDD_DL_Code_InformationItem */
static int hf_rnsap_TDD_DL_Code_LCR_Information_item = -1;  /* TDD_DL_Code_LCR_InformationItem */
static int hf_rnsap_tdd_ChannelisationCodeLCR = -1;  /* TDD_ChannelisationCodeLCR */
static int hf_rnsap_tdd_DL_DPCH_TimeSlotFormat_LCR = -1;  /* TDD_DL_DPCH_TimeSlotFormat_LCR */
static int hf_rnsap_qPSK = -1;                    /* QPSK_DL_DPCH_TimeSlotFormatTDD_LCR */
static int hf_rnsap_eightPSK = -1;                /* EightPSK_DL_DPCH_TimeSlotFormatTDD_LCR */
static int hf_rnsap_initialOffset = -1;           /* INTEGER_0_255 */
static int hf_rnsap_noinitialOffset = -1;         /* INTEGER_0_63 */
static int hf_rnsap_TDD_UL_Code_Information_item = -1;  /* TDD_UL_Code_InformationItem */
static int hf_rnsap_TDD_UL_Code_LCR_Information_item = -1;  /* TDD_UL_Code_LCR_InformationItem */
static int hf_rnsap_tdd_UL_DPCH_TimeSlotFormat_LCR = -1;  /* TDD_UL_DPCH_TimeSlotFormat_LCR */
static int hf_rnsap_qPSK1 = -1;                   /* QPSK_UL_DPCH_TimeSlotFormatTDD_LCR */
static int hf_rnsap_eightPSK1 = -1;               /* EightPSK_UL_DPCH_TimeSlotFormatTDD_LCR */
static int hf_rnsap_plmn_id = -1;                 /* PLMN_Identity */
static int hf_rnsap_service_id = -1;              /* Service_ID */
static int hf_rnsap_dsField = -1;                 /* DsField */
static int hf_rnsap_genericTrafficCategory = -1;  /* GenericTrafficCategory */
static int hf_rnsap_Transmission_Gap_Pattern_Sequence_Information_item = -1;  /* Transmission_Gap_Pattern_Sequence_Information_item */
static int hf_rnsap_tGPSID = -1;                  /* TGPSID */
static int hf_rnsap_tGSN = -1;                    /* TGSN */
static int hf_rnsap_tGL1 = -1;                    /* GapLength */
static int hf_rnsap_tGL2 = -1;                    /* GapLength */
static int hf_rnsap_tGD = -1;                     /* TGD */
static int hf_rnsap_tGPL1 = -1;                   /* GapDuration */
static int hf_rnsap_not_to_be_used_1 = -1;        /* GapDuration */
static int hf_rnsap_uL_DL_mode = -1;              /* UL_DL_mode */
static int hf_rnsap_downlink_Compressed_Mode_Method = -1;  /* Downlink_Compressed_Mode_Method */
static int hf_rnsap_uplink_Compressed_Mode_Method = -1;  /* Uplink_Compressed_Mode_Method */
static int hf_rnsap_dL_FrameType = -1;            /* DL_FrameType */
static int hf_rnsap_delta_SIR1 = -1;              /* DeltaSIR */
static int hf_rnsap_delta_SIR_after1 = -1;        /* DeltaSIR */
static int hf_rnsap_delta_SIR2 = -1;              /* DeltaSIR */
static int hf_rnsap_delta_SIR_after2 = -1;        /* DeltaSIR */
static int hf_rnsap_Transmission_Gap_Pattern_Sequence_Status_List_item = -1;  /* Transmission_Gap_Pattern_Sequence_Status_List_item */
static int hf_rnsap_tGPRC = -1;                   /* TGPRC */
static int hf_rnsap_tGCFN = -1;                   /* CFN */
static int hf_rnsap_ms_part = -1;                 /* INTEGER_0_16383 */
static int hf_rnsap_ls_part = -1;                 /* INTEGER_0_4294967295 */
static int hf_rnsap_tUTRANGPSChangeLimit = -1;    /* TUTRANGPSChangeLimit */
static int hf_rnsap_predictedTUTRANGPSDeviationLimit = -1;  /* PredictedTUTRANGPSDeviationLimit */
static int hf_rnsap_tUTRANGPS = -1;               /* TUTRANGPS */
static int hf_rnsap_tUTRANGPSQuality = -1;        /* TUTRANGPSQuality */
static int hf_rnsap_tUTRANGPSDriftRate = -1;      /* TUTRANGPSDriftRate */
static int hf_rnsap_tUTRANGPSDriftRateQuality = -1;  /* TUTRANGPSDriftRateQuality */
static int hf_rnsap_iEe_Extensions = -1;          /* ProtocolExtensionContainer */
static int hf_rnsap_signalledGainFactors = -1;    /* T_signalledGainFactors */
static int hf_rnsap_betaC = -1;                   /* BetaCD */
static int hf_rnsap_betaD = -1;                   /* BetaCD */
static int hf_rnsap_refTFCNumber = -1;            /* RefTFCNumber */
static int hf_rnsap_tFCSvalues = -1;              /* T_tFCSvalues */
static int hf_rnsap_no_Split_in_TFCI = -1;        /* TFCS_TFCSList */
static int hf_rnsap_not_Used_split_in_TFCI = -1;  /* NULL */
static int hf_rnsap_TFCS_TFCSList_item = -1;      /* TFCS_TFCSList_item */
static int hf_rnsap_cTFC = -1;                    /* TFCS_CTFC */
static int hf_rnsap_tFC_Beta = -1;                /* TransportFormatCombination_Beta */
static int hf_rnsap_ctfc2bit = -1;                /* INTEGER_0_3 */
static int hf_rnsap_ctfc4bit = -1;                /* INTEGER_0_15 */
static int hf_rnsap_ctfc6bit = -1;                /* INTEGER_0_63 */
static int hf_rnsap_ctfc8bit = -1;                /* INTEGER_0_255 */
static int hf_rnsap_ctfc12bit = -1;               /* INTEGER_0_4095 */
static int hf_rnsap_ctfc16bit = -1;               /* INTEGER_0_65535 */
static int hf_rnsap_ctfcmaxbit = -1;              /* INTEGER_0_16777215 */
static int hf_rnsap_dynamicParts = -1;            /* TransportFormatSet_DynamicPartList */
static int hf_rnsap_semi_staticPart = -1;         /* TransportFormatSet_Semi_staticPart */
static int hf_rnsap_TransportFormatSet_DynamicPartList_item = -1;  /* TransportFormatSet_DynamicPartList_item */
static int hf_rnsap_nrOfTransportBlocks = -1;     /* NrOfTransportBlocks */
static int hf_rnsap_transportBlockSize = -1;      /* TransportBlockSize */
static int hf_rnsap_mode = -1;                    /* TransportFormatSet_ModeDP */
static int hf_rnsap_tdd = -1;                     /* TDD_TransportFormatSet_ModeDP */
static int hf_rnsap_notApplicable = -1;           /* NULL */
static int hf_rnsap_transmissionTimeIntervalInformation = -1;  /* TransmissionTimeIntervalInformation */
static int hf_rnsap_TransmissionTimeIntervalInformation_item = -1;  /* TransmissionTimeIntervalInformation_item */
static int hf_rnsap_transmissionTimeInterval = -1;  /* TransmissionTimeIntervalDynamic */
static int hf_rnsap_transmissionTime = -1;        /* TransmissionTimeIntervalSemiStatic */
static int hf_rnsap_channelCoding = -1;           /* ChannelCodingType */
static int hf_rnsap_codingRate = -1;              /* CodingRate */
static int hf_rnsap_rateMatcingAttribute = -1;    /* RateMatchingAttribute */
static int hf_rnsap_cRC_Size = -1;                /* CRC_Size */
static int hf_rnsap_mode1 = -1;                   /* TransportFormatSet_ModeSSP */
static int hf_rnsap_tdd1 = -1;                    /* SecondInterleavingMode */
static int hf_rnsap_hSDSCH_Physical_Layer_Category = -1;  /* INTEGER_1_64_ */
static int hf_rnsap_imei = -1;                    /* IMEI */
static int hf_rnsap_imeisv = -1;                  /* IMEISV */
static int hf_rnsap_periodic2 = -1;               /* UEMeasurementReportCharacteristicsPeriodic */
static int hf_rnsap_event1h = -1;                 /* UEMeasurementReportCharacteristicsEvent1h */
static int hf_rnsap_event1i = -1;                 /* UEMeasurementReportCharacteristicsEvent1i */
static int hf_rnsap_event6a = -1;                 /* UEMeasurementReportCharacteristicsEvent6a */
static int hf_rnsap_event6b = -1;                 /* UEMeasurementReportCharacteristicsEvent6b */
static int hf_rnsap_event6c = -1;                 /* UEMeasurementReportCharacteristicsEvent6c */
static int hf_rnsap_event6d = -1;                 /* UEMeasurementReportCharacteristicsEvent6d */
static int hf_rnsap_extension_ReportCharacteristics1 = -1;  /* UEMeasurementReportCharacteristics_Extension */
static int hf_rnsap_uEMeasurementTreshold = -1;   /* UEMeasurementThreshold */
static int hf_rnsap_uEMeasurementTimeToTrigger = -1;  /* UEMeasurementTimeToTrigger */
static int hf_rnsap_uEMeasurementHysteresisTime = -1;  /* UEMeasurementHysteresisTime */
static int hf_rnsap_amountofReporting = -1;       /* UEMeasurementReportCharacteristicsPeriodicAmountofReporting */
static int hf_rnsap_reportingInterval = -1;       /* UEMeasurementReportCharacteristicsPeriodicReportingInterval */
static int hf_rnsap_timeslotISCP = -1;            /* UEMeasurementThresholdDLTimeslotISCP */
static int hf_rnsap_uETransmitPower = -1;         /* UEMeasurementThresholdUETransmitPower */
static int hf_rnsap_extension_UEMeasurementThreshold = -1;  /* UEMeasurementThreshold_Extension */
static int hf_rnsap_UEMeasurementTimeslotInfoHCR_item = -1;  /* UEMeasurementTimeslotInfoHCR_IEs */
static int hf_rnsap_burstType = -1;               /* UEMeasurementTimeslotInfoHCRBurstType */
static int hf_rnsap_UEMeasurementTimeslotInfoLCR_item = -1;  /* UEMeasurementTimeslotInfoLCR_IEs */
static int hf_rnsap_timeSlot1 = -1;               /* TimeSlotLCR */
static int hf_rnsap_uE_Transmitted_Power = -1;    /* UE_MeasurementValue_UE_Transmitted_Power */
static int hf_rnsap_primary_CCPCH_RSCP = -1;      /* UE_MeasurementValue_Primary_CCPCH_RSCP */
static int hf_rnsap_dL_Timeslot_ISCP = -1;        /* UE_MeasurementValue_DL_Timeslot_ISCP */
static int hf_rnsap_extension_UEMeasurementValue = -1;  /* UEMeasurementValue_Extension */
static int hf_rnsap_uEMeasurementTransmittedPowerListHCR = -1;  /* UEMeasurementValueTransmittedPowerListHCR */
static int hf_rnsap_uEMeasurementTransmittedPowerListLCR = -1;  /* UEMeasurementValueTransmittedPowerListLCR */
static int hf_rnsap_UEMeasurementValueTransmittedPowerListHCR_item = -1;  /* UEMeasurementValueTransmittedPowerListHCR_IEs */
static int hf_rnsap_uETransmitPower1 = -1;        /* INTEGER_0_104 */
static int hf_rnsap_UEMeasurementValueTransmittedPowerListLCR_item = -1;  /* UEMeasurementValueTransmittedPowerListLCR_IEs */
static int hf_rnsap_primaryCCPCH_RSCP_Delta = -1;  /* PrimaryCCPCH_RSCP_Delta */
static int hf_rnsap_uEMeasurementTimeslotISCPListHCR = -1;  /* UEMeasurementValueTimeslotISCPListHCR */
static int hf_rnsap_uEMeasurementTimeslotISCPListLCR = -1;  /* UEMeasurementValueTimeslotISCPListLCR */
static int hf_rnsap_UEMeasurementValueTimeslotISCPListHCR_item = -1;  /* UEMeasurementValueTimeslotISCPListHCR_IEs */
static int hf_rnsap_UEMeasurementValueTimeslotISCPListLCR_item = -1;  /* UEMeasurementValueTimeslotISCPListLCR_IEs */
static int hf_rnsap_measurementAvailable2 = -1;   /* UEMeasurementValueInformationAvailable */
static int hf_rnsap_measurementnotAvailable2 = -1;  /* UEMeasurementValueInformationnotAvailable */
static int hf_rnsap_uEmeasurementValue = -1;      /* UEMeasurementValue */
static int hf_rnsap_cell_fach_pch = -1;           /* Cell_Fach_Pch_State */
static int hf_rnsap_ura_pch = -1;                 /* Ura_Pch_State */
static int hf_rnsap_d_RNTI = -1;                  /* D_RNTI */
static int hf_rnsap_srnc_id = -1;                 /* RNC_ID */
static int hf_rnsap_ura_id = -1;                  /* URA_ID */
static int hf_rnsap_UL_Timeslot_Information_item = -1;  /* UL_Timeslot_InformationItem */
static int hf_rnsap_UL_TimeslotLCR_Information_item = -1;  /* UL_TimeslotLCR_InformationItem */
static int hf_rnsap_uL_Code_LCR_InformationList = -1;  /* TDD_UL_Code_LCR_Information */
static int hf_rnsap_UL_TimeSlot_ISCP_Info_item = -1;  /* UL_TimeSlot_ISCP_InfoItem */
static int hf_rnsap_uL_TimeslotISCP = -1;         /* UL_TimeslotISCP */
static int hf_rnsap_UL_TimeSlot_ISCP_LCR_Info_item = -1;  /* UL_TimeSlot_ISCP_LCR_InfoItem */
static int hf_rnsap_iSCP = -1;                    /* UL_Timeslot_ISCP_Value */
static int hf_rnsap_sync_UL_codes_bitmap = -1;    /* BIT_STRING_SIZE_8 */
static int hf_rnsap_fPACH_info = -1;              /* FPACH_Information */
static int hf_rnsap_prxUpPCHdes = -1;             /* INTEGER_M120_M58_ */
static int hf_rnsap_syncUL_procParameter = -1;    /* SYNC_UL_ProcParameters */
static int hf_rnsap_mMax = -1;                    /* INTEGER_1_32 */
static int hf_rnsap_ul_ScramblingCodeNumber = -1;  /* UL_ScramblingCodeNumber */
static int hf_rnsap_ul_ScramblingCodeLength = -1;  /* UL_ScramblingCodeLength */
static int hf_rnsap_uL_Synchronisation_StepSize = -1;  /* UL_Synchronisation_StepSize */
static int hf_rnsap_uL_Synchronisation_Frequency = -1;  /* UL_Synchronisation_Frequency */
static int hf_rnsap_multipleURAsIndicator = -1;   /* MultipleURAsIndicator */
static int hf_rnsap_rNCsWithCellsInTheAccessedURA_List = -1;  /* RNCsWithCellsInTheAccessedURA_List */
static int hf_rnsap_RNCsWithCellsInTheAccessedURA_List_item = -1;  /* RNCsWithCellsInTheAccessedURA_Item */
static int hf_rnsap_USCH_Information_item = -1;   /* USCH_InformationItem */
static int hf_rnsap_local = -1;                   /* INTEGER_0_65535 */
static int hf_rnsap_global = -1;                  /* OBJECT_IDENTIFIER */
static int hf_rnsap_procedureCode = -1;           /* ProcedureCode */
static int hf_rnsap_ddMode = -1;                  /* T_ddMode */
static int hf_rnsap_shortTransActionId = -1;      /* INTEGER_0_127 */
static int hf_rnsap_longTransActionId = -1;       /* INTEGER_0_32767 */
static int hf_rnsap_ProtocolIE_Container_item = -1;  /* ProtocolIE_Field */
static int hf_rnsap_id = -1;                      /* ProtocolIE_ID */
static int hf_rnsap_value = -1;                   /* ProtocolIEValue */
static int hf_rnsap_ProtocolIE_ContainerPair_item = -1;  /* ProtocolIE_FieldPair */
static int hf_rnsap_firstCriticality = -1;        /* Criticality */
static int hf_rnsap_firstValue = -1;              /* FirstValue */
static int hf_rnsap_secondCriticality = -1;       /* Criticality */
static int hf_rnsap_secondValue = -1;             /* SecondValue */
static int hf_rnsap_ProtocolIE_ContainerList_item = -1;  /* ProtocolIE_Container */
static int hf_rnsap_ProtocolIE_ContainerPairList_item = -1;  /* ProtocolIE_ContainerPair */
static int hf_rnsap_ProtocolExtensionContainer_item = -1;  /* ProtocolExtensionField */
static int hf_rnsap_extensionValue = -1;          /* Extension */
static int hf_rnsap_PrivateIE_Container_item = -1;  /* PrivateIE_Field */
static int hf_rnsap_privateIEid = -1;             /* PrivateIE_ID */
static int hf_rnsap_privateIEvalue = -1;          /* PrivateIEvalue */

/*--- End of included file: packet-rnsap-hf.c ---*/
#line 557 "packet-rnsap-template.c"

/* Initialize the subtree pointers */
static int ett_rnsap = -1;
static int ett_rnsap_initiatingMessageValue = -1;
static int ett_rnsap_ProtocolIEValueValue = -1;
static int ett_rnsap_SuccessfulOutcomeValue = -1;
static int ett_rnsap_UnsuccessfulOutcomeValue = -1;


/*--- Included file: packet-rnsap-ett.c ---*/
#line 1 "packet-rnsap-ett.c"
static gint ett_rnsap_RNSAP_PDU = -1;
static gint ett_rnsap_InitiatingMessage = -1;
static gint ett_rnsap_SuccessfulOutcome = -1;
static gint ett_rnsap_UnsuccessfulOutcome = -1;
static gint ett_rnsap_Outcome = -1;
static gint ett_rnsap_DummyInitiatingValue = -1;
static gint ett_rnsap_DummySuccessfulOutcomeValue = -1;
static gint ett_rnsap_DummyUnSuccessfulOutcomeValue = -1;
static gint ett_rnsap_DummyProtocolIE = -1;
static gint ett_rnsap_RadioLinkSetupRequestFDD = -1;
static gint ett_rnsap_UL_DPCH_Information_RL_SetupRqstFDD = -1;
static gint ett_rnsap_DL_DPCH_Information_RL_SetupRqstFDD = -1;
static gint ett_rnsap_PowerOffsetInformation_RL_SetupRqstFDD = -1;
static gint ett_rnsap_RL_InformationList_RL_SetupRqstFDD = -1;
static gint ett_rnsap_RL_InformationItem_RL_SetupRqstFDD = -1;
static gint ett_rnsap_F_DPCH_Information_RL_SetupRqstFDD = -1;
static gint ett_rnsap_PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD = -1;
static gint ett_rnsap_RadioLinkSetupRequestTDD = -1;
static gint ett_rnsap_UL_Physical_Channel_Information_RL_SetupRqstTDD = -1;
static gint ett_rnsap_DL_Physical_Channel_Information_RL_SetupRqstTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationList_RL_SetupRqstTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationItem_RL_SetupRqstTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationList_RL_SetupRqstTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationItem_RL_SetupRqstTDD = -1;
static gint ett_rnsap_CCTrCH_TPCList_RL_SetupRqstTDD = -1;
static gint ett_rnsap_CCTrCH_TPCItem_RL_SetupRqstTDD = -1;
static gint ett_rnsap_RL_Information_RL_SetupRqstTDD = -1;
static gint ett_rnsap_RadioLinkSetupResponseFDD = -1;
static gint ett_rnsap_RL_InformationResponseList_RL_SetupRspFDD = -1;
static gint ett_rnsap_RL_InformationResponseItem_RL_SetupRspFDD = -1;
static gint ett_rnsap_DiversityIndication_RL_SetupRspFDD = -1;
static gint ett_rnsap_Combining_RL_SetupRspFDD = -1;
static gint ett_rnsap_NonCombiningOrFirstRL_RL_SetupRspFDD = -1;
static gint ett_rnsap_RadioLinkSetupResponseTDD = -1;
static gint ett_rnsap_RL_InformationResponse_RL_SetupRspTDD = -1;
static gint ett_rnsap_UL_CCTrCHInformationListIE_RL_SetupRspTDD = -1;
static gint ett_rnsap_UL_CCTrCHInformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_UL_DPCH_InformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_DL_CCTrCHInformationListIE_RL_SetupRspTDD = -1;
static gint ett_rnsap_DL_CCTrCHInformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_DL_DPCH_InformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_DSCH_InformationListIEs_RL_SetupRspTDD = -1;
static gint ett_rnsap_DSCHInformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_USCH_InformationListIEs_RL_SetupRspTDD = -1;
static gint ett_rnsap_USCHInformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_RL_LCR_InformationResponse_RL_SetupRspTDD = -1;
static gint ett_rnsap_UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD = -1;
static gint ett_rnsap_UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_UL_DPCH_LCR_InformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD = -1;
static gint ett_rnsap_DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_DL_DPCH_LCR_InformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_DSCH_LCR_InformationListIEs_RL_SetupRspTDD = -1;
static gint ett_rnsap_DSCH_LCR_InformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_USCH_LCR_InformationListIEs_RL_SetupRspTDD = -1;
static gint ett_rnsap_USCH_LCR_InformationItem_RL_SetupRspTDD = -1;
static gint ett_rnsap_RadioLinkSetupFailureFDD = -1;
static gint ett_rnsap_CauseLevel_RL_SetupFailureFDD = -1;
static gint ett_rnsap_GeneralCauseList_RL_SetupFailureFDD = -1;
static gint ett_rnsap_RLSpecificCauseList_RL_SetupFailureFDD = -1;
static gint ett_rnsap_UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD = -1;
static gint ett_rnsap_UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD = -1;
static gint ett_rnsap_SuccessfulRL_InformationResponseList_RL_SetupFailureFDD = -1;
static gint ett_rnsap_SuccessfulRL_InformationResponse_RL_SetupFailureFDD = -1;
static gint ett_rnsap_DiversityIndication_RL_SetupFailureFDD = -1;
static gint ett_rnsap_Combining_RL_SetupFailureFDD = -1;
static gint ett_rnsap_NonCombiningOrFirstRL_RL_SetupFailureFDD = -1;
static gint ett_rnsap_RadioLinkSetupFailureTDD = -1;
static gint ett_rnsap_CauseLevel_RL_SetupFailureTDD = -1;
static gint ett_rnsap_GeneralCauseList_RL_SetupFailureTDD = -1;
static gint ett_rnsap_RLSpecificCauseList_RL_SetupFailureTDD = -1;
static gint ett_rnsap_UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD = -1;
static gint ett_rnsap_RadioLinkAdditionRequestFDD = -1;
static gint ett_rnsap_RL_InformationList_RL_AdditionRqstFDD = -1;
static gint ett_rnsap_RL_Information_RL_AdditionRqstFDD = -1;
static gint ett_rnsap_RadioLinkAdditionRequestTDD = -1;
static gint ett_rnsap_RL_Information_RL_AdditionRqstTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationList_RL_AdditionRqstTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationItem_RL_AdditionRqstTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationList_RL_AdditionRqstTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationItem_RL_AdditionRqstTDD = -1;
static gint ett_rnsap_RadioLinkAdditionResponseFDD = -1;
static gint ett_rnsap_RL_InformationResponseList_RL_AdditionRspFDD = -1;
static gint ett_rnsap_RL_InformationResponseItem_RL_AdditionRspFDD = -1;
static gint ett_rnsap_DiversityIndication_RL_AdditionRspFDD = -1;
static gint ett_rnsap_Combining_RL_AdditionRspFDD = -1;
static gint ett_rnsap_NonCombining_RL_AdditionRspFDD = -1;
static gint ett_rnsap_RadioLinkAdditionResponseTDD = -1;
static gint ett_rnsap_RL_InformationResponse_RL_AdditionRspTDD = -1;
static gint ett_rnsap_UL_CCTrCHInformationListIE_RL_AdditionRspTDD = -1;
static gint ett_rnsap_UL_CCTrCHInformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_UL_DPCH_InformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DL_CCTrCHInformationListIE_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DL_CCTrCHInformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DL_DPCH_InformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DCH_Information_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DiversityIndication_RL_AdditionRspTDD = -1;
static gint ett_rnsap_Combining_RL_AdditionRspTDD = -1;
static gint ett_rnsap_NonCombining_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DSCH_InformationListIE_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DSCHInformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DiversityIndication_RL_AdditionRspTDD2 = -1;
static gint ett_rnsap_USCH_InformationListIE_RL_AdditionRspTDD = -1;
static gint ett_rnsap_USCHInformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_RL_LCR_InformationResponse_RL_AdditionRspTDD = -1;
static gint ett_rnsap_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD = -1;
static gint ett_rnsap_UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD = -1;
static gint ett_rnsap_DSCH_LCR_InformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_USCH_LCR_InformationListIEs_RL_AdditionRspTDD = -1;
static gint ett_rnsap_USCH_LCR_InformationItem_RL_AdditionRspTDD = -1;
static gint ett_rnsap_RadioLinkAdditionFailureFDD = -1;
static gint ett_rnsap_CauseLevel_RL_AdditionFailureFDD = -1;
static gint ett_rnsap_GeneralCauseList_RL_AdditionFailureFDD = -1;
static gint ett_rnsap_RLSpecificCauseList_RL_AdditionFailureFDD = -1;
static gint ett_rnsap_UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD = -1;
static gint ett_rnsap_UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD = -1;
static gint ett_rnsap_SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD = -1;
static gint ett_rnsap_SuccessfulRL_InformationResponse_RL_AdditionFailureFDD = -1;
static gint ett_rnsap_DiversityIndication_RL_AdditionFailureFDD = -1;
static gint ett_rnsap_Combining_RL_AdditionFailureFDD = -1;
static gint ett_rnsap_NonCombining_RL_AdditionFailureFDD = -1;
static gint ett_rnsap_RadioLinkAdditionFailureTDD = -1;
static gint ett_rnsap_CauseLevel_RL_AdditionFailureTDD = -1;
static gint ett_rnsap_GeneralCauseList_RL_AdditionFailureTDD = -1;
static gint ett_rnsap_RLSpecificCauseList_RL_AdditionFailureTDD = -1;
static gint ett_rnsap_UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD = -1;
static gint ett_rnsap_RadioLinkDeletionRequest = -1;
static gint ett_rnsap_RL_InformationList_RL_DeletionRqst = -1;
static gint ett_rnsap_RL_Information_RL_DeletionRqst = -1;
static gint ett_rnsap_RadioLinkDeletionResponse = -1;
static gint ett_rnsap_RadioLinkReconfigurationPrepareFDD = -1;
static gint ett_rnsap_UL_DPCH_Information_RL_ReconfPrepFDD = -1;
static gint ett_rnsap_DL_DPCH_Information_RL_ReconfPrepFDD = -1;
static gint ett_rnsap_DL_DPCH_Power_Information_RL_ReconfPrepFDD = -1;
static gint ett_rnsap_PowerOffsetInformation_RL_ReconfPrepFDD = -1;
static gint ett_rnsap_DCH_DeleteList_RL_ReconfPrepFDD = -1;
static gint ett_rnsap_DCH_DeleteItem_RL_ReconfPrepFDD = -1;
static gint ett_rnsap_RL_InformationList_RL_ReconfPrepFDD = -1;
static gint ett_rnsap_RL_Information_RL_ReconfPrepFDD = -1;
static gint ett_rnsap_F_DPCH_Information_RL_ReconfPrepFDD = -1;
static gint ett_rnsap_PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD = -1;
static gint ett_rnsap_RadioLinkReconfigurationPrepareTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_UL_CCTrCH_AddInformation_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_CCTrCH_TPCAddList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_CCTrCH_TPCAddItem_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_CCTrCH_TPCModifyList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_CCTrCH_TPCModifyItem_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DCH_DeleteList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DCH_DeleteItem_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DSCH_ModifyList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DSCH_ModifyItem_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DSCH_DeleteList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_DSCH_DeleteItem_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_USCH_ModifyList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_USCH_ModifyItem_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_USCH_DeleteList_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_USCH_DeleteItem_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_RL_Information_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_RL_InformationIE_RL_ReconfPrepTDD = -1;
static gint ett_rnsap_RadioLinkReconfigurationReadyFDD = -1;
static gint ett_rnsap_RL_InformationResponseList_RL_ReconfReadyFDD = -1;
static gint ett_rnsap_RL_InformationResponseItem_RL_ReconfReadyFDD = -1;
static gint ett_rnsap_RadioLinkReconfigurationReadyTDD = -1;
static gint ett_rnsap_RL_InformationResponse_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_CCTrCHInformationListIE_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_CCTrCHInformationListIE_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_Multiple_RL_InformationResponse_RL_ReconfReadyTDD = -1;
static gint ett_rnsap_RadioLinkReconfigurationCommit = -1;
static gint ett_rnsap_RadioLinkReconfigurationFailure = -1;
static gint ett_rnsap_CauseLevel_RL_ReconfFailure = -1;
static gint ett_rnsap_GeneralCauseList_RL_ReconfFailure = -1;
static gint ett_rnsap_RLSpecificCauseList_RL_ReconfFailure = -1;
static gint ett_rnsap_RL_ReconfigurationFailureList_RL_ReconfFailure = -1;
static gint ett_rnsap_RL_ReconfigurationFailure_RL_ReconfFail = -1;
static gint ett_rnsap_RadioLinkReconfigurationCancel = -1;
static gint ett_rnsap_RadioLinkReconfigurationRequestFDD = -1;
static gint ett_rnsap_UL_DPCH_Information_RL_ReconfRqstFDD = -1;
static gint ett_rnsap_DL_DPCH_Information_RL_ReconfRqstFDD = -1;
static gint ett_rnsap_DCH_DeleteList_RL_ReconfRqstFDD = -1;
static gint ett_rnsap_DCH_DeleteItem_RL_ReconfRqstFDD = -1;
static gint ett_rnsap_RL_ReconfigurationRequestFDD_RL_InformationList = -1;
static gint ett_rnsap_RL_ReconfigurationRequestFDD_RL_Information_IEs = -1;
static gint ett_rnsap_RadioLinkReconfigurationRequestTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = -1;
static gint ett_rnsap_DCH_DeleteList_RL_ReconfRqstTDD = -1;
static gint ett_rnsap_DCH_DeleteItem_RL_ReconfRqstTDD = -1;
static gint ett_rnsap_Multiple_RL_ReconfigurationRequestTDD_RL_Information = -1;
static gint ett_rnsap_RL_ReconfigurationRequestTDD_RL_Information = -1;
static gint ett_rnsap_RadioLinkReconfigurationResponseFDD = -1;
static gint ett_rnsap_RL_InformationResponseList_RL_ReconfRspFDD = -1;
static gint ett_rnsap_RL_InformationResponseItem_RL_ReconfRspFDD = -1;
static gint ett_rnsap_RadioLinkReconfigurationResponseTDD = -1;
static gint ett_rnsap_RL_InformationResponse_RL_ReconfRspTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationList_RL_ReconfRspTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationItem_RL_ReconfRspTDD = -1;
static gint ett_rnsap_DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD = -1;
static gint ett_rnsap_DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD = -1;
static gint ett_rnsap_DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD = -1;
static gint ett_rnsap_Multiple_RL_InformationResponse_RL_ReconfRspTDD = -1;
static gint ett_rnsap_RadioLinkFailureIndication = -1;
static gint ett_rnsap_Reporting_Object_RL_FailureInd = -1;
static gint ett_rnsap_RL_RL_FailureInd = -1;
static gint ett_rnsap_RL_InformationList_RL_FailureInd = -1;
static gint ett_rnsap_RL_Information_RL_FailureInd = -1;
static gint ett_rnsap_RL_Set_RL_FailureInd = -1;
static gint ett_rnsap_RL_Set_InformationList_RL_FailureInd = -1;
static gint ett_rnsap_RL_Set_Information_RL_FailureInd = -1;
static gint ett_rnsap_CCTrCH_RL_FailureInd = -1;
static gint ett_rnsap_CCTrCH_InformationList_RL_FailureInd = -1;
static gint ett_rnsap_CCTrCH_InformationItem_RL_FailureInd = -1;
static gint ett_rnsap_RadioLinkPreemptionRequiredIndication = -1;
static gint ett_rnsap_RL_InformationList_RL_PreemptRequiredInd = -1;
static gint ett_rnsap_RL_InformationItem_RL_PreemptRequiredInd = -1;
static gint ett_rnsap_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd = -1;
static gint ett_rnsap_HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd = -1;
static gint ett_rnsap_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd = -1;
static gint ett_rnsap_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd = -1;
static gint ett_rnsap_RadioLinkRestoreIndication = -1;
static gint ett_rnsap_Reporting_Object_RL_RestoreInd = -1;
static gint ett_rnsap_RL_RL_RestoreInd = -1;
static gint ett_rnsap_RL_InformationList_RL_RestoreInd = -1;
static gint ett_rnsap_RL_Information_RL_RestoreInd = -1;
static gint ett_rnsap_RL_Set_RL_RestoreInd = -1;
static gint ett_rnsap_RL_Set_InformationList_RL_RestoreInd = -1;
static gint ett_rnsap_RL_Set_Information_RL_RestoreInd = -1;
static gint ett_rnsap_CCTrCH_RL_RestoreInd = -1;
static gint ett_rnsap_CCTrCH_InformationList_RL_RestoreInd = -1;
static gint ett_rnsap_CCTrCH_InformationItem_RL_RestoreInd = -1;
static gint ett_rnsap_DL_PowerControlRequest = -1;
static gint ett_rnsap_DL_ReferencePowerInformationList_DL_PC_Rqst = -1;
static gint ett_rnsap_DL_ReferencePowerInformation_DL_PC_Rqst = -1;
static gint ett_rnsap_DL_PowerTimeslotControlRequest = -1;
static gint ett_rnsap_PhysicalChannelReconfigurationRequestFDD = -1;
static gint ett_rnsap_RL_Information_PhyChReconfRqstFDD = -1;
static gint ett_rnsap_PhysicalChannelReconfigurationRequestTDD = -1;
static gint ett_rnsap_RL_Information_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_UL_CCTrCH_InformationItem_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_UL_DPCH_InformationItem_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_UL_Timeslot_InformationList_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_UL_Timeslot_InformationItem_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_DL_CCTrCH_InformationItem_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_DL_DPCH_InformationItem_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_DL_Timeslot_InformationList_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_DL_Timeslot_InformationItem_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD = -1;
static gint ett_rnsap_PhysicalChannelReconfigurationCommand = -1;
static gint ett_rnsap_PhysicalChannelReconfigurationFailure = -1;
static gint ett_rnsap_RadioLinkCongestionIndication = -1;
static gint ett_rnsap_RL_InformationList_RL_CongestInd = -1;
static gint ett_rnsap_RL_InformationItem_RL_CongestInd = -1;
static gint ett_rnsap_DCH_Rate_Information_RL_CongestInd = -1;
static gint ett_rnsap_DCH_Rate_InformationItem_RL_CongestInd = -1;
static gint ett_rnsap_EDCH_MacdFlowSpecificInformationList_RL_CongestInd = -1;
static gint ett_rnsap_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd = -1;
static gint ett_rnsap_UplinkSignallingTransferIndicationFDD = -1;
static gint ett_rnsap_UplinkSignallingTransferIndicationTDD = -1;
static gint ett_rnsap_DownlinkSignallingTransferRequest = -1;
static gint ett_rnsap_RelocationCommit = -1;
static gint ett_rnsap_PagingRequest = -1;
static gint ett_rnsap_PagingArea_PagingRqst = -1;
static gint ett_rnsap_URA_PagingRqst = -1;
static gint ett_rnsap_Cell_PagingRqst = -1;
static gint ett_rnsap_CNOriginatedPage_PagingRqst = -1;
static gint ett_rnsap_DedicatedMeasurementInitiationRequest = -1;
static gint ett_rnsap_DedicatedMeasurementObjectType_DM_Rqst = -1;
static gint ett_rnsap_RL_DM_Rqst = -1;
static gint ett_rnsap_RL_InformationList_DM_Rqst = -1;
static gint ett_rnsap_RL_InformationItem_DM_Rqst = -1;
static gint ett_rnsap_HSSICH_Info_DM_Rqst = -1;
static gint ett_rnsap_RL_Set_DM_Rqst = -1;
static gint ett_rnsap_RL_Set_InformationList_DM_Rqst = -1;
static gint ett_rnsap_RL_Set_InformationItem_DM_Rqst = -1;
static gint ett_rnsap_DedicatedMeasurementInitiationResponse = -1;
static gint ett_rnsap_DedicatedMeasurementObjectType_DM_Rsp = -1;
static gint ett_rnsap_RL_DM_Rsp = -1;
static gint ett_rnsap_RL_Set_DM_Rsp = -1;
static gint ett_rnsap_RL_InformationList_DM_Rsp = -1;
static gint ett_rnsap_RL_InformationItem_DM_Rsp = -1;
static gint ett_rnsap_RL_Set_InformationList_DM_Rsp = -1;
static gint ett_rnsap_RL_Set_InformationItem_DM_Rsp = -1;
static gint ett_rnsap_Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp = -1;
static gint ett_rnsap_Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp = -1;
static gint ett_rnsap_Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp = -1;
static gint ett_rnsap_Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp = -1;
static gint ett_rnsap_DedicatedMeasurementInitiationFailure = -1;
static gint ett_rnsap_DedicatedMeasurementObjectType_DM_Fail = -1;
static gint ett_rnsap_RL_DM_Fail = -1;
static gint ett_rnsap_RL_Set_DM_Fail = -1;
static gint ett_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail = -1;
static gint ett_rnsap_RL_Unsuccessful_InformationItem_DM_Fail = -1;
static gint ett_rnsap_RL_Successful_InformationRespList_DM_Fail = -1;
static gint ett_rnsap_RL_Successful_InformationItem_DM_Fail = -1;
static gint ett_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail = -1;
static gint ett_rnsap_RL_Set_Unsuccessful_InformationItem_DM_Fail = -1;
static gint ett_rnsap_RL_Set_Successful_InformationRespList_DM_Fail = -1;
static gint ett_rnsap_RL_Set_Successful_InformationItem_DM_Fail = -1;
static gint ett_rnsap_DedicatedMeasurementReport = -1;
static gint ett_rnsap_DedicatedMeasurementObjectType_DM_Rprt = -1;
static gint ett_rnsap_RL_DM_Rprt = -1;
static gint ett_rnsap_RL_Set_DM_Rprt = -1;
static gint ett_rnsap_RL_InformationList_DM_Rprt = -1;
static gint ett_rnsap_RL_InformationItem_DM_Rprt = -1;
static gint ett_rnsap_RL_Set_InformationList_DM_Rprt = -1;
static gint ett_rnsap_RL_Set_InformationItem_DM_Rprt = -1;
static gint ett_rnsap_DedicatedMeasurementTerminationRequest = -1;
static gint ett_rnsap_DedicatedMeasurementFailureIndication = -1;
static gint ett_rnsap_DedicatedMeasurementObjectType_DM_Fail_Ind = -1;
static gint ett_rnsap_RL_DM_Fail_Ind = -1;
static gint ett_rnsap_RL_Set_DM_Fail_Ind = -1;
static gint ett_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_Ind = -1;
static gint ett_rnsap_RL_Unsuccessful_InformationItem_DM_Fail_Ind = -1;
static gint ett_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind = -1;
static gint ett_rnsap_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind = -1;
static gint ett_rnsap_CommonTransportChannelResourcesReleaseRequest = -1;
static gint ett_rnsap_CommonTransportChannelResourcesRequest = -1;
static gint ett_rnsap_CommonTransportChannelResourcesResponseFDD = -1;
static gint ett_rnsap_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD = -1;
static gint ett_rnsap_CommonTransportChannelResourcesResponseTDD = -1;
static gint ett_rnsap_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD = -1;
static gint ett_rnsap_CommonTransportChannelResourcesFailure = -1;
static gint ett_rnsap_CompressedModeCommand = -1;
static gint ett_rnsap_ErrorIndication = -1;
static gint ett_rnsap_CommonMeasurementInitiationRequest = -1;
static gint ett_rnsap_CommonMeasurementObjectType_CM_Rqst = -1;
static gint ett_rnsap_Cell_CM_Rqst = -1;
static gint ett_rnsap_NeighbouringCellMeasurementInfo = -1;
static gint ett_rnsap_NeighbouringCellMeasurementInfo_item = -1;
static gint ett_rnsap_CommonMeasurementInitiationResponse = -1;
static gint ett_rnsap_CommonMeasurementObjectType_CM_Rsp = -1;
static gint ett_rnsap_Cell_CM_Rsp = -1;
static gint ett_rnsap_CommonMeasurementInitiationFailure = -1;
static gint ett_rnsap_CommonMeasurementReport = -1;
static gint ett_rnsap_CommonMeasurementObjectType_CM_Rprt = -1;
static gint ett_rnsap_Cell_CM_Rprt = -1;
static gint ett_rnsap_CommonMeasurementTerminationRequest = -1;
static gint ett_rnsap_CommonMeasurementFailureIndication = -1;
static gint ett_rnsap_InformationExchangeInitiationRequest = -1;
static gint ett_rnsap_InformationExchangeObjectType_InfEx_Rqst = -1;
static gint ett_rnsap_Cell_InfEx_Rqst = -1;
static gint ett_rnsap_GSM_Cell_InfEx_Rqst = -1;
static gint ett_rnsap_InformationExchangeInitiationResponse = -1;
static gint ett_rnsap_InformationExchangeObjectType_InfEx_Rsp = -1;
static gint ett_rnsap_Cell_InfEx_Rsp = -1;
static gint ett_rnsap_MBMS_Bearer_Service_List_InfEx_Rsp = -1;
static gint ett_rnsap_MBMS_Bearer_ServiceItemIEs_InfEx_Rsp = -1;
static gint ett_rnsap_InformationExchangeInitiationFailure = -1;
static gint ett_rnsap_InformationReport = -1;
static gint ett_rnsap_InformationExchangeObjectType_InfEx_Rprt = -1;
static gint ett_rnsap_Cell_InfEx_Rprt = -1;
static gint ett_rnsap_InformationExchangeTerminationRequest = -1;
static gint ett_rnsap_InformationExchangeFailureIndication = -1;
static gint ett_rnsap_ResetRequest = -1;
static gint ett_rnsap_ResetIndicator = -1;
static gint ett_rnsap_ContextList_Reset = -1;
static gint ett_rnsap_ContextInfoList_Reset = -1;
static gint ett_rnsap_ContextInfoItem_Reset = -1;
static gint ett_rnsap_ContextType_Reset = -1;
static gint ett_rnsap_ContextGroupList_Reset = -1;
static gint ett_rnsap_ContextGroupInfoList_Reset = -1;
static gint ett_rnsap_ContextGroupInfoItem_Reset = -1;
static gint ett_rnsap_ResetResponse = -1;
static gint ett_rnsap_RadioLinkActivationCommandFDD = -1;
static gint ett_rnsap_DelayedActivationInformationList_RL_ActivationCmdFDD = -1;
static gint ett_rnsap_DelayedActivationInformation_RL_ActivationCmdFDD = -1;
static gint ett_rnsap_RadioLinkActivationCommandTDD = -1;
static gint ett_rnsap_DelayedActivationInformationList_RL_ActivationCmdTDD = -1;
static gint ett_rnsap_DelayedActivationInformation_RL_ActivationCmdTDD = -1;
static gint ett_rnsap_GERANUplinkSignallingTransferIndication = -1;
static gint ett_rnsap_RadioLinkParameterUpdateIndicationFDD = -1;
static gint ett_rnsap_RL_ParameterUpdateIndicationFDD_RL_InformationList = -1;
static gint ett_rnsap_RL_ParameterUpdateIndicationFDD_RL_Information_Item = -1;
static gint ett_rnsap_RadioLinkParameterUpdateIndicationTDD = -1;
static gint ett_rnsap_UEMeasurementInitiationRequest = -1;
static gint ett_rnsap_UEMeasurementInitiationResponse = -1;
static gint ett_rnsap_UEMeasurementInitiationFailure = -1;
static gint ett_rnsap_UEMeasurementReport = -1;
static gint ett_rnsap_UEMeasurementTerminationRequest = -1;
static gint ett_rnsap_UEMeasurementFailureIndication = -1;
static gint ett_rnsap_IurInvokeTrace = -1;
static gint ett_rnsap_ListOfInterfacesToTrace = -1;
static gint ett_rnsap_InterfacesToTraceItem = -1;
static gint ett_rnsap_IurDeactivateTrace = -1;
static gint ett_rnsap_MBMSAttachCommand = -1;
static gint ett_rnsap_MBMSDetachCommand = -1;
static gint ett_rnsap_DirectInformationTransfer = -1;
static gint ett_rnsap_PrivateMessage = -1;
static gint ett_rnsap_Active_MBMS_Bearer_Service_ListFDD = -1;
static gint ett_rnsap_Active_MBMS_Bearer_Service_ListFDD_PFL = -1;
static gint ett_rnsap_Active_MBMS_Bearer_Service_ListTDD = -1;
static gint ett_rnsap_Active_MBMS_Bearer_Service_ListTDD_PFL = -1;
static gint ett_rnsap_Active_Pattern_Sequence_Information = -1;
static gint ett_rnsap_AdditionalPreferredFrequency = -1;
static gint ett_rnsap_AdditionalPreferredFrequencyItem = -1;
static gint ett_rnsap_AffectedUEInformationForMBMS = -1;
static gint ett_rnsap_AllocationRetentionPriority = -1;
static gint ett_rnsap_Allowed_Rate_Information = -1;
static gint ett_rnsap_Angle_Of_Arrival_Value_LCR = -1;
static gint ett_rnsap_BadSatellites = -1;
static gint ett_rnsap_T_badSatelliteInformation = -1;
static gint ett_rnsap_T_badSatelliteInformation_item = -1;
static gint ett_rnsap_BSIC = -1;
static gint ett_rnsap_BurstModeParameters = -1;
static gint ett_rnsap_Cause = -1;
static gint ett_rnsap_Cell_Capacity_Class_Value = -1;
static gint ett_rnsap_CGI = -1;
static gint ett_rnsap_T_lAI = -1;
static gint ett_rnsap_CommonMeasurementAccuracy = -1;
static gint ett_rnsap_CommonMeasurementValue = -1;
static gint ett_rnsap_CommonMeasurementValueInformation = -1;
static gint ett_rnsap_CommonMeasurementAvailable = -1;
static gint ett_rnsap_CorrespondingCells = -1;
static gint ett_rnsap_CriticalityDiagnostics = -1;
static gint ett_rnsap_CriticalityDiagnostics_IE_List = -1;
static gint ett_rnsap_CriticalityDiagnostics_IE_List_item = -1;
static gint ett_rnsap_MessageStructure = -1;
static gint ett_rnsap_MessageStructure_item = -1;
static gint ett_rnsap_CN_CS_DomainIdentifier = -1;
static gint ett_rnsap_CN_PS_DomainIdentifier = -1;
static gint ett_rnsap_DCH_FDD_Information = -1;
static gint ett_rnsap_DCH_FDD_InformationItem = -1;
static gint ett_rnsap_DCH_Specific_FDD_InformationList = -1;
static gint ett_rnsap_DCH_Specific_FDD_Item = -1;
static gint ett_rnsap_DCH_InformationResponse = -1;
static gint ett_rnsap_DCH_InformationResponseItem = -1;
static gint ett_rnsap_DCH_TDD_Information = -1;
static gint ett_rnsap_DCH_TDD_InformationItem = -1;
static gint ett_rnsap_DCH_Specific_TDD_InformationList = -1;
static gint ett_rnsap_DCH_Specific_TDD_Item = -1;
static gint ett_rnsap_DedicatedMeasurementValue = -1;
static gint ett_rnsap_DedicatedMeasurementValueInformation = -1;
static gint ett_rnsap_DedicatedMeasurementAvailable = -1;
static gint ett_rnsap_DelayedActivation = -1;
static gint ett_rnsap_DelayedActivationUpdate = -1;
static gint ett_rnsap_Activate_Info = -1;
static gint ett_rnsap_Deactivate_Info = -1;
static gint ett_rnsap_Execution_Type = -1;
static gint ett_rnsap_DGPSCorrections = -1;
static gint ett_rnsap_T_satellite_DGPSCorrections_Information = -1;
static gint ett_rnsap_T_satellite_DGPSCorrections_Information_item = -1;
static gint ett_rnsap_DGPSThreshold = -1;
static gint ett_rnsap_DL_PowerBalancing_Information = -1;
static gint ett_rnsap_DL_ReferencePowerInformationList = -1;
static gint ett_rnsap_DL_ReferencePowerInformationItem = -1;
static gint ett_rnsap_DL_ReferencePowerInformation = -1;
static gint ett_rnsap_DL_Timeslot_Information = -1;
static gint ett_rnsap_DL_Timeslot_InformationItem = -1;
static gint ett_rnsap_DL_TimeslotLCR_Information = -1;
static gint ett_rnsap_DL_TimeslotLCR_InformationItem = -1;
static gint ett_rnsap_DL_TimeSlot_ISCP_Info = -1;
static gint ett_rnsap_DL_TimeSlot_ISCP_InfoItem = -1;
static gint ett_rnsap_DL_TimeSlot_ISCP_LCR_Information = -1;
static gint ett_rnsap_DL_TimeSlot_ISCP_LCR_InfoItem = -1;
static gint ett_rnsap_DSCH_FlowControlInformation = -1;
static gint ett_rnsap_DSCH_FlowControlItem = -1;
static gint ett_rnsap_DSCH_TDD_Information = -1;
static gint ett_rnsap_DSCH_TDD_InformationItem = -1;
static gint ett_rnsap_EDCH_FDD_DL_ControlChannelInformation = -1;
static gint ett_rnsap_EDCH_FDD_Information = -1;
static gint ett_rnsap_EDCH_FDD_InformationResponse = -1;
static gint ett_rnsap_EDCH_FDD_InformationResponseItem = -1;
static gint ett_rnsap_EDCH_FDD_Information_To_Modify = -1;
static gint ett_rnsap_EDCH_FDD_Update_Information = -1;
static gint ett_rnsap_EDCH_FDD_Update_InfoItem = -1;
static gint ett_rnsap_E_DCH_Grant_Type_Information = -1;
static gint ett_rnsap_E_DCH_LogicalChannelInformation = -1;
static gint ett_rnsap_E_DCH_LogicalChannelInformationItem = -1;
static gint ett_rnsap_E_DCH_MACdPDU_SizeList = -1;
static gint ett_rnsap_E_DCH_MACdPDU_SizeListItem = -1;
static gint ett_rnsap_E_DCH_LogicalChannelToModify = -1;
static gint ett_rnsap_E_DCH_LogicalChannelToModifyItem = -1;
static gint ett_rnsap_E_DCH_MACdPDU_SizeToModifyList = -1;
static gint ett_rnsap_E_DCH_LogicalChannelToDelete = -1;
static gint ett_rnsap_E_DCH_LogicalChannelToDeleteItem = -1;
static gint ett_rnsap_EDCH_MACdFlows_Information = -1;
static gint ett_rnsap_EDCH_MACdFlow_Specific_InfoList = -1;
static gint ett_rnsap_EDCH_MACdFlow_Specific_InfoItem = -1;
static gint ett_rnsap_EDCH_MACdFlow_Specific_InfoToModifyList = -1;
static gint ett_rnsap_EDCH_MACdFlow_Specific_InfoToModifyItem = -1;
static gint ett_rnsap_EDCH_MACdFlows_To_Delete = -1;
static gint ett_rnsap_EDCH_MACdFlows_To_Delete_Item = -1;
static gint ett_rnsap_E_DCH_Non_Scheduled_Transmission_Grant_Items = -1;
static gint ett_rnsap_EDPCH_Information_FDD = -1;
static gint ett_rnsap_EDPCH_Information_RLReconfPrepare_FDD = -1;
static gint ett_rnsap_EDPCH_Information_RLReconfRequest_FDD = -1;
static gint ett_rnsap_EDCH_Serving_RL = -1;
static gint ett_rnsap_EDCH_Serving_RL_in_this_DRNS = -1;
static gint ett_rnsap_E_TFCS_Information = -1;
static gint ett_rnsap_EventA = -1;
static gint ett_rnsap_EventB = -1;
static gint ett_rnsap_EventC = -1;
static gint ett_rnsap_EventD = -1;
static gint ett_rnsap_EventE = -1;
static gint ett_rnsap_EventF = -1;
static gint ett_rnsap_FACH_FlowControlInformation = -1;
static gint ett_rnsap_FACH_FlowControlInformationItem = -1;
static gint ett_rnsap_FACH_InformationList = -1;
static gint ett_rnsap_FACH_InformationItem = -1;
static gint ett_rnsap_FACH_PCH_InformationList = -1;
static gint ett_rnsap_FACH_PCH_InformationItem = -1;
static gint ett_rnsap_FDD_DCHs_to_Modify = -1;
static gint ett_rnsap_FDD_DCHs_to_ModifyItem = -1;
static gint ett_rnsap_FDD_DCHs_to_ModifySpecificInformationList = -1;
static gint ett_rnsap_FDD_DCHs_to_ModifySpecificItem = -1;
static gint ett_rnsap_FDD_DL_CodeInformation = -1;
static gint ett_rnsap_FDD_DL_CodeInformationItem = -1;
static gint ett_rnsap_FPACH_Information = -1;
static gint ett_rnsap_GA_Cell = -1;
static gint ett_rnsap_GA_Cell_item = -1;
static gint ett_rnsap_GA_CellAdditionalShapes = -1;
static gint ett_rnsap_GA_AltitudeAndDirection = -1;
static gint ett_rnsap_GA_EllipsoidArc = -1;
static gint ett_rnsap_GA_PointWithAltitude = -1;
static gint ett_rnsap_GA_PointWithAltitudeAndUncertaintyEllipsoid = -1;
static gint ett_rnsap_GA_PointWithUnCertaintyEllipse = -1;
static gint ett_rnsap_GA_UncertaintyEllipse = -1;
static gint ett_rnsap_GA_PointWithUnCertainty = -1;
static gint ett_rnsap_GA_AccessPointPosition = -1;
static gint ett_rnsap_GeographicalCoordinate = -1;
static gint ett_rnsap_GERAN_SI_Type = -1;
static gint ett_rnsap_GERAN_SystemInfo = -1;
static gint ett_rnsap_GERAN_SystemInfo_item = -1;
static gint ett_rnsap_GPS_Almanac = -1;
static gint ett_rnsap_T_satellite_Almanac_Information = -1;
static gint ett_rnsap_T_satellite_Almanac_Information_item = -1;
static gint ett_rnsap_Satellite_Almanac_Information_ExtItem = -1;
static gint ett_rnsap_Satellite_Almanac_Information_ExtItem_item = -1;
static gint ett_rnsap_GPSInformation = -1;
static gint ett_rnsap_GPSInformation_item = -1;
static gint ett_rnsap_GPS_Ionospheric_Model = -1;
static gint ett_rnsap_GPS_NavigationModel_and_TimeRecovery = -1;
static gint ett_rnsap_GPS_NavigationModel_and_TimeRecovery_item = -1;
static gint ett_rnsap_GPS_RealTime_Integrity = -1;
static gint ett_rnsap_GPS_RX_POS = -1;
static gint ett_rnsap_GPS_UTC_Model = -1;
static gint ett_rnsap_Guaranteed_Rate_Information = -1;
static gint ett_rnsap_HARQ_MemoryPartitioning = -1;
static gint ett_rnsap_HARQ_MemoryPartitioning_Implicit = -1;
static gint ett_rnsap_HARQ_MemoryPartitioning_Explicit = -1;
static gint ett_rnsap_HARQ_MemoryPartitioningList = -1;
static gint ett_rnsap_HARQ_MemoryPartitioningItem = -1;
static gint ett_rnsap_HSDSCH_FDD_Information = -1;
static gint ett_rnsap_HSDSCH_FDD_Information_Response = -1;
static gint ett_rnsap_HSDSCH_Information_to_Modify = -1;
static gint ett_rnsap_HSDSCH_Information_to_Modify_Unsynchronised = -1;
static gint ett_rnsap_HSDSCH_MACdFlow_Specific_InfoList = -1;
static gint ett_rnsap_HSDSCH_MACdFlow_Specific_InfoItem = -1;
static gint ett_rnsap_HSDSCH_MACdFlow_Specific_InfoList_Response = -1;
static gint ett_rnsap_HSDSCH_MACdFlow_Specific_InfoItem_Response = -1;
static gint ett_rnsap_HSDSCH_MACdFlow_Specific_InfoList_to_Modify = -1;
static gint ett_rnsap_HSDSCH_MACdFlow_Specific_InfoItem_to_Modify = -1;
static gint ett_rnsap_HSDSCH_MACdFlows_Information = -1;
static gint ett_rnsap_HSDSCH_MACdFlows_to_Delete = -1;
static gint ett_rnsap_HSDSCH_MACdFlows_to_Delete_Item = -1;
static gint ett_rnsap_HSDSCH_Initial_Capacity_Allocation = -1;
static gint ett_rnsap_HSDSCH_Initial_Capacity_AllocationItem = -1;
static gint ett_rnsap_HSDSCH_TDD_Information = -1;
static gint ett_rnsap_HSDSCH_TDD_Information_Response = -1;
static gint ett_rnsap_HSPDSCH_TDD_Specific_InfoList_Response = -1;
static gint ett_rnsap_HSPDSCH_TDD_Specific_InfoItem_Response = -1;
static gint ett_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_LCR = -1;
static gint ett_rnsap_HSPDSCH_TDD_Specific_InfoItem_Response_LCR = -1;
static gint ett_rnsap_HSSCCH_FDD_Specific_InfoList_Response = -1;
static gint ett_rnsap_HSSCCH_FDD_Specific_InfoItem_Response = -1;
static gint ett_rnsap_HSSCCH_TDD_Specific_InfoList_Response = -1;
static gint ett_rnsap_HSSCCH_TDD_Specific_InfoItem_Response = -1;
static gint ett_rnsap_HSSCCH_TDD_Specific_InfoList_Response_LCR = -1;
static gint ett_rnsap_HSSCCH_TDD_Specific_InfoItem_Response_LCR = -1;
static gint ett_rnsap_HSSICH_Info = -1;
static gint ett_rnsap_HSSICH_InfoLCR = -1;
static gint ett_rnsap_HS_SICH_Reception_Quality_Value = -1;
static gint ett_rnsap_HSDSCH_FDD_Update_Information = -1;
static gint ett_rnsap_HSDSCH_TDD_Update_Information = -1;
static gint ett_rnsap_InformationAvailable = -1;
static gint ett_rnsap_InformationReportCharacteristics = -1;
static gint ett_rnsap_InformationReportPeriodicity = -1;
static gint ett_rnsap_InformationThreshold = -1;
static gint ett_rnsap_InformationType = -1;
static gint ett_rnsap_IPDLParameters = -1;
static gint ett_rnsap_IPDL_FDD_Parameters = -1;
static gint ett_rnsap_IPDL_TDD_Parameters = -1;
static gint ett_rnsap_IPDL_TDD_ParametersLCR = -1;
static gint ett_rnsap_LoadValue = -1;
static gint ett_rnsap_MAC_c_sh_SDU_LengthList = -1;
static gint ett_rnsap_MACdPDU_Size_IndexList = -1;
static gint ett_rnsap_MACdPDU_Size_IndexItem = -1;
static gint ett_rnsap_MACdPDU_Size_IndexList_to_Modify = -1;
static gint ett_rnsap_MACdPDU_Size_IndexItem_to_Modify = -1;
static gint ett_rnsap_MBMS_Bearer_Service_Full_Address = -1;
static gint ett_rnsap_MBMS_Bearer_Service_List = -1;
static gint ett_rnsap_MBMS_Bearer_ServiceItemFDD = -1;
static gint ett_rnsap_MBMS_Bearer_ServiceItemFDD_PFL = -1;
static gint ett_rnsap_MBMS_Bearer_ServiceItemTDD = -1;
static gint ett_rnsap_MBMS_Bearer_ServiceItemTDD_PFL = -1;
static gint ett_rnsap_MBMSChannelTypeInfo = -1;
static gint ett_rnsap_MBMSChannelTypeCellList = -1;
static gint ett_rnsap_MBMSPreferredFreqLayerInfo = -1;
static gint ett_rnsap_MeasurementIncreaseDecreaseThreshold = -1;
static gint ett_rnsap_MeasurementThreshold = -1;
static gint ett_rnsap_MidambleShiftAndBurstType = -1;
static gint ett_rnsap_T_type1 = -1;
static gint ett_rnsap_T_midambleAllocationMode = -1;
static gint ett_rnsap_T_type2 = -1;
static gint ett_rnsap_T_midambleAllocationMode1 = -1;
static gint ett_rnsap_T_type3 = -1;
static gint ett_rnsap_T_midambleAllocationMode2 = -1;
static gint ett_rnsap_MidambleShiftLCR = -1;
static gint ett_rnsap_ModifyPriorityQueue = -1;
static gint ett_rnsap_NACC_Related_Data = -1;
static gint ett_rnsap_Neighbouring_UMTS_CellInformation = -1;
static gint ett_rnsap_Neighbouring_UMTS_CellInformationItem = -1;
static gint ett_rnsap_Neighbouring_FDD_CellInformation = -1;
static gint ett_rnsap_Neighbouring_FDD_CellInformationItem = -1;
static gint ett_rnsap_NeighbouringFDDCellMeasurementInformation = -1;
static gint ett_rnsap_Neighbouring_GSM_CellInformationIEs = -1;
static gint ett_rnsap_Neighbouring_GSM_CellInformationItem = -1;
static gint ett_rnsap_Neighbouring_TDD_CellInformation = -1;
static gint ett_rnsap_Neighbouring_TDD_CellInformationItem = -1;
static gint ett_rnsap_NeighbouringTDDCellMeasurementInformation = -1;
static gint ett_rnsap_NeighbouringTDDCellMeasurementInformationLCR = -1;
static gint ett_rnsap_Neighbouring_LCR_TDD_CellInformation = -1;
static gint ett_rnsap_Neighbouring_LCR_TDD_CellInformationItem = -1;
static gint ett_rnsap_NotProvidedCellList = -1;
static gint ett_rnsap_NRTLoadInformationValue = -1;
static gint ett_rnsap_OnModification = -1;
static gint ett_rnsap_OnModificationInformation = -1;
static gint ett_rnsap_PCH_InformationList = -1;
static gint ett_rnsap_PCH_InformationItem = -1;
static gint ett_rnsap_Periodic = -1;
static gint ett_rnsap_PeriodicInformation = -1;
static gint ett_rnsap_Permanent_NAS_UE_Identity = -1;
static gint ett_rnsap_PreferredFrequencyLayerInfo = -1;
static gint ett_rnsap_PriorityQueue_InfoList = -1;
static gint ett_rnsap_PriorityQueue_InfoItem = -1;
static gint ett_rnsap_PriorityQueue_InfoList_to_Modify = -1;
static gint ett_rnsap_PriorityQueue_InfoItem_to_Add = -1;
static gint ett_rnsap_PriorityQueue_InfoItem_to_Modify = -1;
static gint ett_rnsap_PriorityQueue_InfoList_to_Modify_Unsynchronised = -1;
static gint ett_rnsap_PriorityQueue_InfoItem_to_Modify_Unsynchronised = -1;
static gint ett_rnsap_ProvidedInformation = -1;
static gint ett_rnsap_PTMCellList = -1;
static gint ett_rnsap_PTPCellList = -1;
static gint ett_rnsap_RB_Info = -1;
static gint ett_rnsap_Reference_E_TFCI_Information = -1;
static gint ett_rnsap_Reference_E_TFCI_Information_Item = -1;
static gint ett_rnsap_ReportCharacteristics = -1;
static gint ett_rnsap_ReportPeriodicity = -1;
static gint ett_rnsap_RequestedDataValue = -1;
static gint ett_rnsap_RequestedDataValueInformation = -1;
static gint ett_rnsap_RL_Specific_DCH_Info = -1;
static gint ett_rnsap_RL_Specific_DCH_Info_Item = -1;
static gint ett_rnsap_RL_Specific_EDCH_Information = -1;
static gint ett_rnsap_RL_Specific_EDCH_InfoItem = -1;
static gint ett_rnsap_RTLoadValue = -1;
static gint ett_rnsap_SAI = -1;
static gint ett_rnsap_Secondary_CCPCH_Info_TDD = -1;
static gint ett_rnsap_Secondary_CPICH_Information = -1;
static gint ett_rnsap_Secondary_CPICH_Information_Change = -1;
static gint ett_rnsap_Secondary_LCR_CCPCH_Info_TDD = -1;
static gint ett_rnsap_Secondary_CCPCH_TDD_InformationList = -1;
static gint ett_rnsap_Secondary_CCPCH_TDD_InformationItem = -1;
static gint ett_rnsap_Secondary_LCR_CCPCH_TDD_InformationList = -1;
static gint ett_rnsap_Secondary_LCR_CCPCH_TDD_InformationItem = -1;
static gint ett_rnsap_Secondary_CCPCH_TDD_Code_Information = -1;
static gint ett_rnsap_Secondary_CCPCH_TDD_Code_InformationItem = -1;
static gint ett_rnsap_Secondary_LCR_CCPCH_TDD_Code_Information = -1;
static gint ett_rnsap_Secondary_LCR_CCPCH_TDD_Code_InformationItem = -1;
static gint ett_rnsap_GA_AccessPointPositionwithOptionalAltitude = -1;
static gint ett_rnsap_SFNSFNMeasurementThresholdInformation = -1;
static gint ett_rnsap_SFNSFNMeasurementValueInformation = -1;
static gint ett_rnsap_T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation = -1;
static gint ett_rnsap_T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item = -1;
static gint ett_rnsap_T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation = -1;
static gint ett_rnsap_T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item = -1;
static gint ett_rnsap_SFNSFNTimeStampInformation = -1;
static gint ett_rnsap_SFNSFNTimeStamp_TDD = -1;
static gint ett_rnsap_SFNSFNValue = -1;
static gint ett_rnsap_SNA_Information = -1;
static gint ett_rnsap_ListOfSNAs = -1;
static gint ett_rnsap_S_RNTI_Group = -1;
static gint ett_rnsap_SynchronisationConfiguration = -1;
static gint ett_rnsap_SYNC_UL_ProcParameters = -1;
static gint ett_rnsap_TDD_ChannelisationCodeLCR = -1;
static gint ett_rnsap_TDD_DCHs_to_Modify = -1;
static gint ett_rnsap_TDD_DCHs_to_ModifyItem = -1;
static gint ett_rnsap_TDD_DCHs_to_ModifySpecificInformationList = -1;
static gint ett_rnsap_TDD_DCHs_to_ModifySpecificItem = -1;
static gint ett_rnsap_TDD_DL_Code_Information = -1;
static gint ett_rnsap_TDD_DL_Code_InformationItem = -1;
static gint ett_rnsap_TDD_DL_Code_LCR_Information = -1;
static gint ett_rnsap_TDD_DL_Code_LCR_InformationItem = -1;
static gint ett_rnsap_TDD_DL_DPCH_TimeSlotFormat_LCR = -1;
static gint ett_rnsap_TDD_DPCHOffset = -1;
static gint ett_rnsap_TDD_UL_Code_Information = -1;
static gint ett_rnsap_TDD_UL_Code_InformationItem = -1;
static gint ett_rnsap_TDD_UL_Code_LCR_Information = -1;
static gint ett_rnsap_TDD_UL_Code_LCR_InformationItem = -1;
static gint ett_rnsap_TDD_UL_DPCH_TimeSlotFormat_LCR = -1;
static gint ett_rnsap_TMGI = -1;
static gint ett_rnsap_TnlQos = -1;
static gint ett_rnsap_Transmission_Gap_Pattern_Sequence_Information = -1;
static gint ett_rnsap_Transmission_Gap_Pattern_Sequence_Information_item = -1;
static gint ett_rnsap_Transmission_Gap_Pattern_Sequence_Status_List = -1;
static gint ett_rnsap_Transmission_Gap_Pattern_Sequence_Status_List_item = -1;
static gint ett_rnsap_TUTRANGPS = -1;
static gint ett_rnsap_TUTRANGPSMeasurementThresholdInformation = -1;
static gint ett_rnsap_TUTRANGPSMeasurementValueInformation = -1;
static gint ett_rnsap_TransportFormatCombination_Beta = -1;
static gint ett_rnsap_T_signalledGainFactors = -1;
static gint ett_rnsap_TFCS = -1;
static gint ett_rnsap_T_tFCSvalues = -1;
static gint ett_rnsap_TFCS_TFCSList = -1;
static gint ett_rnsap_TFCS_TFCSList_item = -1;
static gint ett_rnsap_TFCS_CTFC = -1;
static gint ett_rnsap_TransportFormatSet = -1;
static gint ett_rnsap_TransportFormatSet_DynamicPartList = -1;
static gint ett_rnsap_TransportFormatSet_DynamicPartList_item = -1;
static gint ett_rnsap_TransportFormatSet_ModeDP = -1;
static gint ett_rnsap_TDD_TransportFormatSet_ModeDP = -1;
static gint ett_rnsap_TransmissionTimeIntervalInformation = -1;
static gint ett_rnsap_TransmissionTimeIntervalInformation_item = -1;
static gint ett_rnsap_TransportFormatSet_Semi_staticPart = -1;
static gint ett_rnsap_TransportFormatSet_ModeSSP = -1;
static gint ett_rnsap_UE_Capabilities_Info = -1;
static gint ett_rnsap_UEIdentity = -1;
static gint ett_rnsap_UEMeasurementReportCharacteristics = -1;
static gint ett_rnsap_UEMeasurementReportCharacteristicsEvent1h = -1;
static gint ett_rnsap_UEMeasurementReportCharacteristicsEvent1i = -1;
static gint ett_rnsap_UEMeasurementReportCharacteristicsEvent6a = -1;
static gint ett_rnsap_UEMeasurementReportCharacteristicsEvent6b = -1;
static gint ett_rnsap_UEMeasurementReportCharacteristicsEvent6c = -1;
static gint ett_rnsap_UEMeasurementReportCharacteristicsEvent6d = -1;
static gint ett_rnsap_UEMeasurementReportCharacteristicsPeriodic = -1;
static gint ett_rnsap_UEMeasurementThreshold = -1;
static gint ett_rnsap_UEMeasurementTimeslotInfoHCR = -1;
static gint ett_rnsap_UEMeasurementTimeslotInfoHCR_IEs = -1;
static gint ett_rnsap_UEMeasurementTimeslotInfoLCR = -1;
static gint ett_rnsap_UEMeasurementTimeslotInfoLCR_IEs = -1;
static gint ett_rnsap_UEMeasurementValue = -1;
static gint ett_rnsap_UE_MeasurementValue_UE_Transmitted_Power = -1;
static gint ett_rnsap_UEMeasurementValueTransmittedPowerListHCR = -1;
static gint ett_rnsap_UEMeasurementValueTransmittedPowerListHCR_IEs = -1;
static gint ett_rnsap_UEMeasurementValueTransmittedPowerListLCR = -1;
static gint ett_rnsap_UEMeasurementValueTransmittedPowerListLCR_IEs = -1;
static gint ett_rnsap_UE_MeasurementValue_Primary_CCPCH_RSCP = -1;
static gint ett_rnsap_UE_MeasurementValue_DL_Timeslot_ISCP = -1;
static gint ett_rnsap_UEMeasurementValueTimeslotISCPListHCR = -1;
static gint ett_rnsap_UEMeasurementValueTimeslotISCPListHCR_IEs = -1;
static gint ett_rnsap_UEMeasurementValueTimeslotISCPListLCR = -1;
static gint ett_rnsap_UEMeasurementValueTimeslotISCPListLCR_IEs = -1;
static gint ett_rnsap_UEMeasurementValueInformation = -1;
static gint ett_rnsap_UEMeasurementValueInformationAvailable = -1;
static gint ett_rnsap_UE_State = -1;
static gint ett_rnsap_Cell_Fach_Pch_State = -1;
static gint ett_rnsap_Ura_Pch_State = -1;
static gint ett_rnsap_UL_Timeslot_Information = -1;
static gint ett_rnsap_UL_Timeslot_InformationItem = -1;
static gint ett_rnsap_UL_TimeslotLCR_Information = -1;
static gint ett_rnsap_UL_TimeslotLCR_InformationItem = -1;
static gint ett_rnsap_UL_TimeSlot_ISCP_Info = -1;
static gint ett_rnsap_UL_TimeSlot_ISCP_InfoItem = -1;
static gint ett_rnsap_UL_TimeSlot_ISCP_LCR_Info = -1;
static gint ett_rnsap_UL_TimeSlot_ISCP_LCR_InfoItem = -1;
static gint ett_rnsap_UL_TimingAdvanceCtrl_LCR = -1;
static gint ett_rnsap_UC_ID = -1;
static gint ett_rnsap_UL_ScramblingCode = -1;
static gint ett_rnsap_UL_Synchronisation_Parameters_LCR = -1;
static gint ett_rnsap_URA_Information = -1;
static gint ett_rnsap_RNCsWithCellsInTheAccessedURA_List = -1;
static gint ett_rnsap_RNCsWithCellsInTheAccessedURA_Item = -1;
static gint ett_rnsap_USCH_Information = -1;
static gint ett_rnsap_USCH_InformationItem = -1;
static gint ett_rnsap_PrivateIE_ID = -1;
static gint ett_rnsap_ProcedureID = -1;
static gint ett_rnsap_TransactionID = -1;
static gint ett_rnsap_ProtocolIE_Container = -1;
static gint ett_rnsap_ProtocolIE_Field = -1;
static gint ett_rnsap_ProtocolIE_ContainerPair = -1;
static gint ett_rnsap_ProtocolIE_FieldPair = -1;
static gint ett_rnsap_ProtocolIE_ContainerList = -1;
static gint ett_rnsap_ProtocolIE_ContainerPairList = -1;
static gint ett_rnsap_ProtocolExtensionContainer = -1;
static gint ett_rnsap_ProtocolExtensionField = -1;
static gint ett_rnsap_PrivateIE_Container = -1;
static gint ett_rnsap_PrivateIE_Field = -1;

/*--- End of included file: packet-rnsap-ett.c ---*/
#line 566 "packet-rnsap-template.c"

/* Global variables */
static proto_tree *top_tree;
static guint32 ProcedureCode;
static guint32 ProtocolIE_ID;
static guint32 ddMode;

#define BYTE_ALIGN_OFFSET(offset)		\
	if(offset&0x07){			\
		offset=(offset&0xfffffff8)+8;	\
	}
#define RNSAP_FDD 1
/* Prodedure ID:s */

/* Protocol IE:s */



static int dissect_rnsap_InitiatingMessageValueValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree);
static int dissect_rnsap_SuccessfulOutcomeValueValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree);
static int dissect_rnsap_UnsuccessfulOutcomeValueValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree);
static int dissect_rnsap_ProtocolIEValueValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree);

/*--- Included file: packet-rnsap-fn.c ---*/
#line 1 "packet-rnsap-fn.c"
/*--- Fields for imported types ---*/



static const value_string rnsap_ProcedureCode_vals[] = {
  {   0, "id-commonTransportChannelResourcesInitialisation" },
  {   1, "id-commonTransportChannelResourcesRelease" },
  {   2, "id-compressedModeCommand" },
  {   3, "id-downlinkPowerControl" },
  {   4, "id-downlinkPowerTimeslotControl" },
  {   5, "id-downlinkSignallingTransfer" },
  {   6, "id-errorIndication" },
  {   7, "id-dedicatedMeasurementFailure" },
  {   8, "id-dedicatedMeasurementInitiation" },
  {   9, "id-dedicatedMeasurementReporting" },
  {  10, "id-dedicatedMeasurementTermination" },
  {  11, "id-paging" },
  {  12, "id-physicalChannelReconfiguration" },
  {  13, "id-privateMessage" },
  {  14, "id-radioLinkAddition" },
  {  34, "id-radioLinkCongestion" },
  {  15, "id-radioLinkDeletion" },
  {  16, "id-radioLinkFailure" },
  {  17, "id-radioLinkPreemption" },
  {  18, "id-radioLinkRestoration" },
  {  19, "id-radioLinkSetup" },
  {  20, "id-relocationCommit" },
  {  21, "id-synchronisedRadioLinkReconfigurationCancellation" },
  {  22, "id-synchronisedRadioLinkReconfigurationCommit" },
  {  23, "id-synchronisedRadioLinkReconfigurationPreparation" },
  {  24, "id-unSynchronisedRadioLinkReconfiguration" },
  {  25, "id-uplinkSignallingTransfer" },
  {  26, "id-commonMeasurementFailure" },
  {  27, "id-commonMeasurementInitiation" },
  {  28, "id-commonMeasurementReporting" },
  {  29, "id-commonMeasurementTermination" },
  {  30, "id-informationExchangeFailure" },
  {  31, "id-informationExchangeInitiation" },
  {  32, "id-informationReporting" },
  {  33, "id-informationExchangeTermination" },
  {  35, "id-reset" },
  {  36, "id-radioLinkActivation" },
  {  37, "id-gERANuplinkSignallingTransfer" },
  {  38, "id-radioLinkParameterUpdate" },
  {  39, "id-uEMeasurementFailure" },
  {  40, "id-uEMeasurementInitiation" },
  {  41, "id-uEMeasurementReporting" },
  {  42, "id-uEMeasurementTermination" },
  {  43, "id-iurDeactivateTrace" },
  {  44, "id-iurInvokeTrace" },
  {  45, "id-mBMSAttach" },
  {  46, "id-mBMSDetach" },
  {  48, "id-directInformationTransfer" },
  { 0, NULL }
};


static int
dissect_rnsap_ProcedureCode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, &ProcedureCode, NULL, FALSE);

#line 18 "rnsap.cnf"
	if (check_col(pinfo->cinfo, COL_INFO))
       col_add_fstr(pinfo->cinfo, COL_INFO, "%s ",
                   val_to_str(ProcedureCode, rnsap_ProcedureCode_vals,
                              "unknown message"));

  return offset;
}
static int dissect_procedureCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProcedureCode(tvb, offset, pinfo, tree, hf_rnsap_procedureCode);
}


static const value_string rnsap_T_ddMode_vals[] = {
  {   0, "tdd" },
  {   1, "fdd" },
  {   2, "common" },
  { 0, NULL }
};


static int
dissect_rnsap_T_ddMode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, &ddMode, NULL, TRUE);

  return offset;
}
static int dissect_ddMode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_ddMode(tvb, offset, pinfo, tree, hf_rnsap_ddMode);
}


static const per_sequence_t ProcedureID_sequence[] = {
  { "procedureCode"               , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_procedureCode },
  { "ddMode"                      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ddMode },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ProcedureID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ProcedureID, ProcedureID_sequence);

  return offset;
}
static int dissect_procedureID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProcedureID(tvb, offset, pinfo, tree, hf_rnsap_procedureID);
}


static const value_string rnsap_Criticality_vals[] = {
  {   0, "reject" },
  {   1, "ignore" },
  {   2, "notify" },
  { 0, NULL }
};


static int
dissect_rnsap_Criticality(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, FALSE);

  return offset;
}
static int dissect_criticality(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Criticality(tvb, offset, pinfo, tree, hf_rnsap_criticality);
}
static int dissect_procedureCriticality(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Criticality(tvb, offset, pinfo, tree, hf_rnsap_procedureCriticality);
}
static int dissect_iECriticality(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Criticality(tvb, offset, pinfo, tree, hf_rnsap_iECriticality);
}
static int dissect_firstCriticality(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Criticality(tvb, offset, pinfo, tree, hf_rnsap_firstCriticality);
}
static int dissect_secondCriticality(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Criticality(tvb, offset, pinfo, tree, hf_rnsap_secondCriticality);
}



static int
dissect_rnsap_INTEGER_0_127(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 127U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_uncertaintyRadius(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_127(tvb, offset, pinfo, tree, hf_rnsap_uncertaintyRadius);
}
static int dissect_confidence(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_127(tvb, offset, pinfo, tree, hf_rnsap_confidence);
}
static int dissect_uncertaintyAltitude(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_127(tvb, offset, pinfo, tree, hf_rnsap_uncertaintyAltitude);
}
static int dissect_uncertaintySemi_major(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_127(tvb, offset, pinfo, tree, hf_rnsap_uncertaintySemi_major);
}
static int dissect_uncertaintySemi_minor(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_127(tvb, offset, pinfo, tree, hf_rnsap_uncertaintySemi_minor);
}
static int dissect_uncertaintyCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_127(tvb, offset, pinfo, tree, hf_rnsap_uncertaintyCode);
}
static int dissect_code_Number(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_127(tvb, offset, pinfo, tree, hf_rnsap_code_Number);
}
static int dissect_shortTransActionId(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_127(tvb, offset, pinfo, tree, hf_rnsap_shortTransActionId);
}



static int
dissect_rnsap_INTEGER_0_32767(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 32767U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_altitude(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_32767(tvb, offset, pinfo, tree, hf_rnsap_altitude);
}
static int dissect_longTransActionId(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_32767(tvb, offset, pinfo, tree, hf_rnsap_longTransActionId);
}


static const value_string rnsap_TransactionID_vals[] = {
  {   0, "shortTransActionId" },
  {   1, "longTransActionId" },
  { 0, NULL }
};

static const per_choice_t TransactionID_choice[] = {
  {   0, "shortTransActionId"          , ASN1_NO_EXTENSIONS     , dissect_shortTransActionId },
  {   1, "longTransActionId"           , ASN1_NO_EXTENSIONS     , dissect_longTransActionId },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_TransactionID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_TransactionID, TransactionID_choice,
                                 NULL);

  return offset;
}
static int dissect_transactionID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransactionID(tvb, offset, pinfo, tree, hf_rnsap_transactionID);
}



static int
dissect_rnsap_InitiatingMessageValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
#line 35 "rnsap.cnf"

	offset = dissect_rnsap_InitiatingMessageValueValue(tvb, offset, pinfo, tree);



  return offset;
}
static int dissect_initiatingMessageValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_InitiatingMessageValue(tvb, offset, pinfo, tree, hf_rnsap_initiatingMessageValue);
}


static const per_sequence_t InitiatingMessage_sequence[] = {
  { "procedureID"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_procedureID },
  { "criticality"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_criticality },
  { "transactionID"               , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_transactionID },
  { "initiatingMessageValue"      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_initiatingMessageValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_InitiatingMessage(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_InitiatingMessage, InitiatingMessage_sequence);

  return offset;
}
static int dissect_initiatingMessage(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_InitiatingMessage(tvb, offset, pinfo, tree, hf_rnsap_initiatingMessage);
}



static int
dissect_rnsap_SuccessfulOutcomeValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
#line 39 "rnsap.cnf"

	offset = dissect_rnsap_SuccessfulOutcomeValueValue(tvb, offset, pinfo, tree);



  return offset;
}
static int dissect_successfulOutcomeValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SuccessfulOutcomeValue(tvb, offset, pinfo, tree, hf_rnsap_successfulOutcomeValue);
}


static const per_sequence_t SuccessfulOutcome_sequence[] = {
  { "procedureID"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_procedureID },
  { "criticality"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_criticality },
  { "transactionID"               , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_transactionID },
  { "successfulOutcomeValue"      , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_successfulOutcomeValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_SuccessfulOutcome(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_SuccessfulOutcome, SuccessfulOutcome_sequence);

  return offset;
}
static int dissect_successfulOutcome(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SuccessfulOutcome(tvb, offset, pinfo, tree, hf_rnsap_successfulOutcome);
}



static int
dissect_rnsap_UnsuccessfulOutcomeValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
#line 51 "rnsap.cnf"

	offset = dissect_rnsap_UnsuccessfulOutcomeValueValue(tvb, offset, pinfo, tree);



  return offset;
}
static int dissect_unsuccessfulOutcomeValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UnsuccessfulOutcomeValue(tvb, offset, pinfo, tree, hf_rnsap_unsuccessfulOutcomeValue);
}


static const per_sequence_t UnsuccessfulOutcome_sequence[] = {
  { "procedureID"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_procedureID },
  { "criticality"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_criticality },
  { "transactionID"               , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_transactionID },
  { "unsuccessfulOutcomeValue"    , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_unsuccessfulOutcomeValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UnsuccessfulOutcome(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UnsuccessfulOutcome, UnsuccessfulOutcome_sequence);

  return offset;
}
static int dissect_unsuccessfulOutcome(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UnsuccessfulOutcome(tvb, offset, pinfo, tree, hf_rnsap_unsuccessfulOutcome);
}



static int
dissect_rnsap_OutcomeValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
#line 43 "rnsap.cnf"
	/* FIX ME */
	guint length;

	offset = dissect_per_length_determinant(tvb, offset, pinfo, tree, hf_rnsap_pdu_length, &length);
	offset = offset + length;
	BYTE_ALIGN_OFFSET(offset)



  return offset;
}
static int dissect_outcomeValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_OutcomeValue(tvb, offset, pinfo, tree, hf_rnsap_outcomeValue);
}


static const per_sequence_t Outcome_sequence[] = {
  { "procedureID"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_procedureID },
  { "criticality"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_criticality },
  { "transactionID"               , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_transactionID },
  { "outcomeValue"                , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_outcomeValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Outcome(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Outcome, Outcome_sequence);

  return offset;
}
static int dissect_outcome(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Outcome(tvb, offset, pinfo, tree, hf_rnsap_outcome);
}


static const value_string rnsap_RNSAP_PDU_vals[] = {
  {   0, "initiatingMessage" },
  {   1, "successfulOutcome" },
  {   2, "unsuccessfulOutcome" },
  {   3, "outcome" },
  { 0, NULL }
};

static const per_choice_t RNSAP_PDU_choice[] = {
  {   0, "initiatingMessage"           , ASN1_EXTENSION_ROOT    , dissect_initiatingMessage },
  {   1, "successfulOutcome"           , ASN1_EXTENSION_ROOT    , dissect_successfulOutcome },
  {   2, "unsuccessfulOutcome"         , ASN1_EXTENSION_ROOT    , dissect_unsuccessfulOutcome },
  {   3, "outcome"                     , ASN1_EXTENSION_ROOT    , dissect_outcome },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_RNSAP_PDU(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_RNSAP_PDU, RNSAP_PDU_choice,
                                 NULL);

  return offset;
}


static const value_string rnsap_ProtocolIE_ID_vals[] = {
  {   4, "id-AllowedQueuingTime" },
  {  42, "id-Allowed-Rate-Information" },
  { 309, "id-AntennaColocationIndicator" },
  {   5, "id-BindingID" },
  {   6, "id-C-ID" },
  {   7, "id-C-RNTI" },
  { 303, "id-Cell-Capacity-Class-Value" },
  {   8, "id-CFN" },
  {   9, "id-CN-CS-DomainIdentifier" },
  {  10, "id-CN-PS-DomainIdentifier" },
  {  11, "id-Cause" },
  { 310, "id-CoverageIndicator" },
  {  20, "id-CriticalityDiagnostics" },
  { 211, "id-ContextInfoItem-Reset" },
  { 515, "id-ContextGroupInfoItem-Reset" },
  {  21, "id-D-RNTI" },
  {  22, "id-D-RNTI-ReleaseIndication" },
  {  26, "id-DCHs-to-Add-FDD" },
  {  27, "id-DCHs-to-Add-TDD" },
  {  30, "id-DCH-DeleteList-RL-ReconfPrepFDD" },
  {  31, "id-DCH-DeleteList-RL-ReconfPrepTDD" },
  {  32, "id-DCH-DeleteList-RL-ReconfRqstFDD" },
  {  33, "id-DCH-DeleteList-RL-ReconfRqstTDD" },
  {  34, "id-DCH-FDD-Information" },
  {  35, "id-DCH-TDD-Information" },
  {  39, "id-FDD-DCHs-to-Modify" },
  {  40, "id-TDD-DCHs-to-Modify" },
  {  43, "id-DCH-InformationResponse" },
  {  38, "id-DCH-Rate-InformationItem-RL-CongestInd" },
  {  44, "id-DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD" },
  {  45, "id-DL-CCTrCH-InformationListIE-RL-ReconfReadyTDD" },
  {  46, "id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD" },
  {  47, "id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD" },
  {  48, "id-DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD" },
  {  49, "id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD" },
  {  50, "id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD" },
  {  51, "id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD" },
  {  52, "id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD" },
  {  53, "id-DL-CCTrCH-InformationList-RL-SetupRqstTDD" },
  {  54, "id-FDD-DL-CodeInformation" },
  {  59, "id-DL-DPCH-Information-RL-ReconfPrepFDD" },
  {  60, "id-DL-DPCH-Information-RL-SetupRqstFDD" },
  {  61, "id-DL-DPCH-Information-RL-ReconfRqstFDD" },
  {  62, "id-DL-DPCH-InformationItem-PhyChReconfRqstTDD" },
  {  63, "id-DL-DPCH-InformationItem-RL-AdditionRspTDD" },
  {  64, "id-DL-DPCH-InformationItem-RL-SetupRspTDD" },
  { 278, "id-DL-DPCH-TimingAdjustment" },
  {  67, "id-DLReferencePower" },
  {  68, "id-DLReferencePowerList-DL-PC-Rqst" },
  {  69, "id-DL-ReferencePowerInformation-DL-PC-Rqst" },
  {  12, "id-DPC-Mode" },
  {  70, "id-DRXCycleLengthCoefficient" },
  { 470, "id-DedicatedMeasurementObjectType-DM-Fail-Ind" },
  { 471, "id-DedicatedMeasurementObjectType-DM-Fail" },
  {  71, "id-DedicatedMeasurementObjectType-DM-Rprt" },
  {  72, "id-DedicatedMeasurementObjectType-DM-Rqst" },
  {  73, "id-DedicatedMeasurementObjectType-DM-Rsp" },
  {  74, "id-DedicatedMeasurementType" },
  {  82, "id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD" },
  {  83, "id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD" },
  {  41, "id-Guaranteed-Rate-Information" },
  {  84, "id-IMSI" },
  { 311, "id-HCS-Prio" },
  {  85, "id-L3-Information" },
  {  90, "id-AdjustmentPeriod" },
  {  91, "id-MaxAdjustmentStep" },
  {  92, "id-MeasurementFilterCoefficient" },
  {  57, "id-MessageStructure" },
  {  93, "id-MeasurementID" },
  {  13, "id-Neighbouring-GSM-CellInformation" },
  {  95, "id-Neighbouring-UMTS-CellInformationItem" },
  { 305, "id-NRT-Load-Information-Value" },
  { 306, "id-NRT-Load-Information-Value-IncrDecrThres" },
  { 102, "id-PagingArea-PagingRqst" },
  { 103, "id-FACH-FlowControlInformation" },
  { 472, "id-PartialReportingIndicator" },
  {  17, "id-Permanent-NAS-UE-Identity" },
  { 107, "id-PowerAdjustmentType" },
  { 109, "id-RANAP-RelocationInformation" },
  { 110, "id-RL-Information-PhyChReconfRqstFDD" },
  { 111, "id-RL-Information-PhyChReconfRqstTDD" },
  { 112, "id-RL-Information-RL-AdditionRqstFDD" },
  { 113, "id-RL-Information-RL-AdditionRqstTDD" },
  { 114, "id-RL-Information-RL-DeletionRqst" },
  { 115, "id-RL-Information-RL-FailureInd" },
  { 116, "id-RL-Information-RL-ReconfPrepFDD" },
  { 117, "id-RL-Information-RL-RestoreInd" },
  { 118, "id-RL-Information-RL-SetupRqstFDD" },
  { 119, "id-RL-Information-RL-SetupRqstTDD" },
  {  55, "id-RL-InformationItem-RL-CongestInd" },
  { 120, "id-RL-InformationItem-DM-Rprt" },
  { 121, "id-RL-InformationItem-DM-Rqst" },
  { 122, "id-RL-InformationItem-DM-Rsp" },
  {   2, "id-RL-InformationItem-RL-PreemptRequiredInd" },
  { 123, "id-RL-InformationItem-RL-SetupRqstFDD" },
  {  56, "id-RL-InformationList-RL-CongestInd" },
  { 124, "id-RL-InformationList-RL-AdditionRqstFDD" },
  { 125, "id-RL-InformationList-RL-DeletionRqst" },
  {   1, "id-RL-InformationList-RL-PreemptRequiredInd" },
  { 126, "id-RL-InformationList-RL-ReconfPrepFDD" },
  { 127, "id-RL-InformationResponse-RL-AdditionRspTDD" },
  { 128, "id-RL-InformationResponse-RL-ReconfReadyTDD" },
  { 129, "id-RL-InformationResponse-RL-SetupRspTDD" },
  { 130, "id-RL-InformationResponseItem-RL-AdditionRspFDD" },
  { 131, "id-RL-InformationResponseItem-RL-ReconfReadyFDD" },
  { 132, "id-RL-InformationResponseItem-RL-ReconfRspFDD" },
  { 133, "id-RL-InformationResponseItem-RL-SetupRspFDD" },
  { 134, "id-RL-InformationResponseList-RL-AdditionRspFDD" },
  { 135, "id-RL-InformationResponseList-RL-ReconfReadyFDD" },
  { 136, "id-RL-InformationResponseList-RL-ReconfRspFDD" },
  {  28, "id-RL-InformationResponse-RL-ReconfRspTDD" },
  { 137, "id-RL-InformationResponseList-RL-SetupRspFDD" },
  { 141, "id-RL-ReconfigurationFailure-RL-ReconfFail" },
  { 143, "id-RL-Set-InformationItem-DM-Rprt" },
  { 144, "id-RL-Set-InformationItem-DM-Rqst" },
  { 145, "id-RL-Set-InformationItem-DM-Rsp" },
  { 146, "id-RL-Set-Information-RL-FailureInd" },
  { 147, "id-RL-Set-Information-RL-RestoreInd" },
  { 473, "id-RL-Set-Successful-InformationItem-DM-Fail" },
  { 474, "id-RL-Set-Unsuccessful-InformationItem-DM-Fail" },
  { 475, "id-RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind" },
  { 476, "id-RL-Successful-InformationItem-DM-Fail" },
  { 477, "id-RL-Unsuccessful-InformationItem-DM-Fail" },
  { 478, "id-RL-Unsuccessful-InformationItem-DM-Fail-Ind" },
  { 152, "id-ReportCharacteristics" },
  { 153, "id-Reporting-Object-RL-FailureInd" },
  { 154, "id-Reporing-Object-RL-RestoreInd" },
  { 307, "id-RT-Load-Value" },
  { 308, "id-RT-Load-Value-IncrDecrThres" },
  { 155, "id-S-RNTI" },
  { 244, "id-ResetIndicator" },
  { 245, "id-RNC-ID" },
  { 156, "id-SAI" },
  { 157, "id-SRNC-ID" },
  { 159, "id-SuccessfulRL-InformationResponse-RL-AdditionFailureFDD" },
  { 160, "id-SuccessfulRL-InformationResponse-RL-SetupFailureFDD" },
  { 163, "id-TransportBearerID" },
  { 164, "id-TransportBearerRequestIndicator" },
  { 165, "id-TransportLayerAddress" },
  { 140, "id-TypeOfError" },
  { 166, "id-UC-ID" },
  { 167, "id-UL-CCTrCH-AddInformation-RL-ReconfPrepTDD" },
  { 169, "id-UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD" },
  { 171, "id-UL-CCTrCH-InformationItem-RL-SetupRqstTDD" },
  { 172, "id-UL-CCTrCH-InformationList-RL-SetupRqstTDD" },
  { 173, "id-UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD" },
  { 174, "id-UL-CCTrCH-InformationListIE-RL-AdditionRspTDD" },
  { 175, "id-UL-CCTrCH-InformationListIE-RL-ReconfReadyTDD" },
  { 176, "id-UL-CCTrCH-InformationListIE-RL-SetupRspTDD" },
  { 177, "id-UL-DPCH-Information-RL-ReconfPrepFDD" },
  { 178, "id-UL-DPCH-Information-RL-ReconfRqstFDD" },
  { 179, "id-UL-DPCH-Information-RL-SetupRqstFDD" },
  { 180, "id-UL-DPCH-InformationItem-PhyChReconfRqstTDD" },
  { 181, "id-UL-DPCH-InformationItem-RL-AdditionRspTDD" },
  { 182, "id-UL-DPCH-InformationItem-RL-SetupRspTDD" },
  { 183, "id-UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD" },
  { 184, "id-UL-SIRTarget" },
  { 185, "id-URA-Information" },
  { 188, "id-UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD" },
  { 189, "id-UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD" },
  { 190, "id-UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD" },
  { 193, "id-Active-Pattern-Sequence-Information" },
  { 194, "id-AdjustmentRatio" },
  { 197, "id-CauseLevel-RL-AdditionFailureFDD" },
  { 198, "id-CauseLevel-RL-AdditionFailureTDD" },
  { 199, "id-CauseLevel-RL-ReconfFailure" },
  { 200, "id-CauseLevel-RL-SetupFailureFDD" },
  { 201, "id-CauseLevel-RL-SetupFailureTDD" },
  { 205, "id-DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD" },
  { 206, "id-DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD" },
  { 207, "id-DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD" },
  { 208, "id-DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD" },
  { 209, "id-DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD" },
  { 210, "id-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD" },
  { 212, "id-DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD" },
  { 213, "id-DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD" },
  { 214, "id-DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD" },
  { 215, "id-DSCHs-to-Add-TDD" },
  { 216, "id-Unused-ProtocolIE-ID-216" },
  { 217, "id-DSCH-DeleteList-RL-ReconfPrepTDD" },
  { 218, "id-Unused-ProtocolIE-ID-218" },
  { 219, "id-Unused-ProtocolIE-ID-219" },
  { 220, "id-DSCH-InformationListIE-RL-AdditionRspTDD" },
  { 221, "id-DSCH-InformationListIEs-RL-SetupRspTDD" },
  { 222, "id-DSCH-TDD-Information" },
  { 223, "id-Unused-ProtocolIE-ID-223" },
  { 226, "id-Unused-ProtocolIE-ID-226" },
  { 227, "id-DSCH-ModifyList-RL-ReconfPrepTDD" },
  { 228, "id-Unused-ProtocolIE-ID-228" },
  { 324, "id-Unused-ProtocolIE-ID-324" },
  { 229, "id-Unused-ProtocolIE-ID-229" },
  { 230, "id-DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD" },
  {  29, "id-Unused-ProtocolIE-ID-29" },
  { 225, "id-Unused-ProtocolIE-ID-225" },
  { 232, "id-GA-Cell" },
  {   3, "id-GA-CellAdditionalShapes" },
  { 246, "id-Unused-ProtocolIE-ID-246" },
  { 255, "id-Transmission-Gap-Pattern-Sequence-Information" },
  { 256, "id-UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD" },
  { 257, "id-UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD" },
  { 258, "id-UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD" },
  { 259, "id-UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD" },
  { 260, "id-UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD" },
  { 261, "id-UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD" },
  { 262, "id-UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD" },
  { 263, "id-UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD" },
  { 264, "id-UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD" },
  { 265, "id-UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD" },
  { 266, "id-UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD" },
  { 267, "id-USCHs-to-Add" },
  { 268, "id-USCH-DeleteList-RL-ReconfPrepTDD" },
  { 269, "id-USCH-InformationListIE-RL-AdditionRspTDD" },
  { 270, "id-USCH-InformationListIEs-RL-SetupRspTDD" },
  { 271, "id-USCH-Information" },
  { 272, "id-USCH-ModifyList-RL-ReconfPrepTDD" },
  { 273, "id-USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD" },
  { 274, "id-DL-Physical-Channel-Information-RL-SetupRqstTDD" },
  { 275, "id-UL-Physical-Channel-Information-RL-SetupRqstTDD" },
  { 276, "id-ClosedLoopMode1-SupportIndicator" },
  { 277, "id-Unused-ProtocolIE-ID-277" },
  { 279, "id-STTD-SupportIndicator" },
  {  14, "id-CFNReportingIndicator" },
  {  23, "id-CNOriginatedPage-PagingRqst" },
  {  24, "id-InnerLoopDLPCStatus" },
  {  25, "id-PropagationDelay" },
  {  36, "id-RxTimingDeviationForTA" },
  {  37, "id-timeSlot-ISCP" },
  {  15, "id-CCTrCH-InformationItem-RL-FailureInd" },
  {  16, "id-CCTrCH-InformationItem-RL-RestoreInd" },
  { 280, "id-CommonMeasurementAccuracy" },
  { 281, "id-CommonMeasurementObjectType-CM-Rprt" },
  { 282, "id-CommonMeasurementObjectType-CM-Rqst" },
  { 283, "id-CommonMeasurementObjectType-CM-Rsp" },
  { 284, "id-CommonMeasurementType" },
  {  18, "id-CongestionCause" },
  { 285, "id-SFN" },
  { 286, "id-SFNReportingIndicator" },
  { 287, "id-InformationExchangeID" },
  { 288, "id-InformationExchangeObjectType-InfEx-Rprt" },
  { 289, "id-InformationExchangeObjectType-InfEx-Rqst" },
  { 290, "id-InformationExchangeObjectType-InfEx-Rsp" },
  { 291, "id-InformationReportCharacteristics" },
  { 292, "id-InformationType" },
  {  58, "id-neighbouring-LCR-TDD-CellInformation" },
  {  65, "id-DL-Timeslot-ISCP-LCR-Information-RL-SetupRqstTDD" },
  {  66, "id-RL-LCR-InformationResponse-RL-SetupRspTDD" },
  {  75, "id-UL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD" },
  {  76, "id-UL-DPCH-LCR-InformationItem-RL-SetupRspTDD" },
  {  77, "id-DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD" },
  {  78, "id-DL-DPCH-LCR-InformationItem-RL-SetupRspTDD" },
  {  79, "id-DSCH-LCR-InformationListIEs-RL-SetupRspTDD" },
  {  80, "id-USCH-LCR-InformationListIEs-RL-SetupRspTDD" },
  {  81, "id-DL-Timeslot-ISCP-LCR-Information-RL-AdditionRqstTDD" },
  {  86, "id-RL-LCR-InformationResponse-RL-AdditionRspTDD" },
  {  87, "id-UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD" },
  {  88, "id-UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD" },
  {  89, "id-DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD" },
  {  94, "id-DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD" },
  {  96, "id-DSCH-LCR-InformationListIEs-RL-AdditionRspTDD" },
  {  97, "id-USCH-LCR-InformationListIEs-RL-AdditionRspTDD" },
  {  98, "id-UL-DPCH-LCR-InformationAddListIE-RL-ReconfReadyTDD" },
  { 100, "id-UL-Timeslot-LCR-InformationModifyList-RL-ReconfReadyTDD" },
  { 101, "id-DL-DPCH-LCR-InformationAddListIE-RL-ReconfReadyTDD" },
  { 104, "id-DL-Timeslot-LCR-InformationModifyList-RL-ReconfReadyTDD" },
  { 105, "id-UL-Timeslot-LCR-InformationList-PhyChReconfRqstTDD" },
  { 106, "id-DL-Timeslot-LCR-InformationList-PhyChReconfRqstTDD" },
  { 138, "id-timeSlot-ISCP-LCR-List-DL-PC-Rqst-TDD" },
  { 139, "id-TSTD-Support-Indicator-RL-SetupRqstTDD" },
  { 142, "id-RestrictionStateIndicator" },
  { 233, "id-Load-Value" },
  { 234, "id-Load-Value-IncrDecrThres" },
  { 235, "id-OnModification" },
  { 236, "id-Received-Total-Wideband-Power-Value" },
  { 237, "id-Received-Total-Wideband-Power-Value-IncrDecrThres" },
  { 238, "id-SFNSFNMeasurementThresholdInformation" },
  { 239, "id-Transmitted-Carrier-Power-Value" },
  { 240, "id-Transmitted-Carrier-Power-Value-IncrDecrThres" },
  { 241, "id-TUTRANGPSMeasurementThresholdInformation" },
  { 242, "id-UL-Timeslot-ISCP-Value" },
  { 243, "id-UL-Timeslot-ISCP-Value-IncrDecrThres" },
  { 293, "id-Rx-Timing-Deviation-Value-LCR" },
  {  19, "id-DPC-Mode-Change-SupportIndicator" },
  { 247, "id-Unused-ProtocolIE-ID-247" },
  { 295, "id-Unused-ProtocolIE-ID-295" },
  { 202, "id-PrimaryCCPCH-RSCP-RL-ReconfPrepTDD" },
  { 203, "id-DL-TimeSlot-ISCP-Info-RL-ReconfPrepTDD" },
  { 204, "id-DL-Timeslot-ISCP-LCR-Information-RL-ReconfPrepTDD" },
  { 249, "id-DSCH-RNTI" },
  { 296, "id-DL-PowerBalancing-Information" },
  { 297, "id-DL-PowerBalancing-ActivationIndicator" },
  { 298, "id-DL-PowerBalancing-UpdatedIndicator" },
  { 299, "id-DL-ReferencePowerInformation" },
  { 224, "id-Enhanced-PrimaryCPICH-EcNo" },
  { 252, "id-IPDL-TDD-ParametersLCR" },
  { 300, "id-CellCapabilityContainer-FDD" },
  { 301, "id-CellCapabilityContainer-TDD" },
  { 302, "id-CellCapabilityContainer-TDD-LCR" },
  { 317, "id-RL-Specific-DCH-Info" },
  { 318, "id-RL-ReconfigurationRequestFDD-RL-InformationList" },
  { 319, "id-RL-ReconfigurationRequestFDD-RL-Information-IEs" },
  { 321, "id-RL-ReconfigurationRequestTDD-RL-Information" },
  { 250, "id-CommonTransportChannelResourcesInitialisationNotRequired" },
  { 312, "id-DelayedActivation" },
  { 313, "id-DelayedActivationList-RL-ActivationCmdFDD" },
  { 314, "id-DelayedActivationInformation-RL-ActivationCmdFDD" },
  { 315, "id-DelayedActivationList-RL-ActivationCmdTDD" },
  { 316, "id-DelayedActivationInformation-RL-ActivationCmdTDD" },
  { 251, "id-neighbouringTDDCellMeasurementInformationLCR" },
  { 150, "id-UL-SIR-Target-CCTrCH-InformationItem-RL-SetupRspTDD" },
  { 151, "id-UL-SIR-Target-CCTrCH-LCR-InformationItem-RL-SetupRspTDD" },
  { 451, "id-PrimCCPCH-RSCP-DL-PC-RqstTDD" },
  { 452, "id-HSDSCH-FDD-Information" },
  { 453, "id-HSDSCH-FDD-Information-Response" },
  { 466, "id-HSDSCH-FDD-Update-Information" },
  { 456, "id-HSDSCH-Information-to-Modify" },
  { 516, "id-HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd" },
  { 517, "id-HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd" },
  { 457, "id-HSDSCH-RNTI" },
  { 458, "id-HSDSCH-TDD-Information" },
  { 459, "id-HSDSCH-TDD-Information-Response" },
  { 467, "id-HSDSCH-TDD-Update-Information" },
  { 463, "id-HSPDSCH-RL-ID" },
  { 531, "id-HSDSCH-MACdFlows-to-Add" },
  { 532, "id-HSDSCH-MACdFlows-to-Delete" },
  { 148, "id-Angle-Of-Arrival-Value-LCR" },
  { 158, "id-TrafficClass" },
  { 248, "id-Unused-ProtocolIE-ID-248" },
  { 253, "id-Unused-ProtocolIE-ID-253" },
  { 323, "id-PDSCH-RL-ID" },
  { 325, "id-TimeSlot-RL-SetupRspTDD" },
  { 468, "id-GERAN-Cell-Capability" },
  { 469, "id-GERAN-Classmark" },
  { 480, "id-DSCH-InitialWindowSize" },
  { 464, "id-UL-Synchronisation-Parameters-LCR" },
  { 479, "id-SNA-Information" },
  { 465, "id-MAChs-ResetIndicator" },
  { 481, "id-TDD-DL-DPCH-TimeSlotFormatModifyItem-LCR-RL-ReconfReadyTDD" },
  { 482, "id-TDD-UL-DPCH-TimeSlotFormatModifyItem-LCR-RL-ReconfReadyTDD" },
  { 483, "id-TDD-TPC-UplinkStepSize-LCR-RL-SetupRqstTDD" },
  { 484, "id-UL-CCTrCH-InformationList-RL-AdditionRqstTDD" },
  { 485, "id-UL-CCTrCH-InformationItem-RL-AdditionRqstTDD" },
  { 486, "id-DL-CCTrCH-InformationList-RL-AdditionRqstTDD" },
  { 487, "id-DL-CCTrCH-InformationItem-RL-AdditionRqstTDD" },
  { 488, "id-TDD-TPC-UplinkStepSize-InformationAdd-LCR-RL-ReconfPrepTDD" },
  { 489, "id-TDD-TPC-UplinkStepSize-InformationModify-LCR-RL-ReconfPrepTDD" },
  { 490, "id-TDD-TPC-DownlinkStepSize-InformationAdd-RL-ReconfPrepTDD" },
  { 491, "id-TDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD" },
  { 492, "id-UL-TimingAdvanceCtrl-LCR" },
  { 493, "id-HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD" },
  { 494, "id-HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD" },
  { 495, "id-HS-SICH-Reception-Quality" },
  { 496, "id-HS-SICH-Reception-Quality-Measurement-Value" },
  { 497, "id-HSSICH-Info-DM-Rprt" },
  { 498, "id-HSSICH-Info-DM-Rqst" },
  { 499, "id-HSSICH-Info-DM" },
  { 500, "id-CCTrCH-Maximum-DL-Power-RL-SetupRspTDD" },
  { 501, "id-CCTrCH-Minimum-DL-Power-RL-SetupRspTDD" },
  { 502, "id-CCTrCH-Maximum-DL-Power-RL-AdditionRspTDD" },
  { 503, "id-CCTrCH-Minimum-DL-Power-RL-AdditionRspTDD" },
  { 504, "id-CCTrCH-Maximum-DL-Power-RL-ReconfReadyTDD" },
  { 505, "id-CCTrCH-Minimum-DL-Power-RL-ReconfReadyTDD" },
  { 506, "id-Maximum-DL-Power-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD" },
  { 507, "id-Minimum-DL-Power-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD" },
  { 508, "id-DL-CCTrCH-InformationList-RL-ReconfRspTDD" },
  { 509, "id-DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD" },
  { 510, "id-Maximum-DL-Power-TimeslotLCR-InformationItem" },
  { 511, "id-Minimum-DL-Power-TimeslotLCR-InformationItem" },
  { 512, "id-TDD-Support-8PSK" },
  { 513, "id-TDD-maxNrDLPhysicalchannels" },
  { 514, "id-ExtendedGSMCellIndividualOffset" },
  { 518, "id-RL-ParameterUpdateIndicationFDD-RL-InformationList" },
  { 519, "id-Primary-CPICH-Usage-For-Channel-Estimation" },
  { 520, "id-Secondary-CPICH-Information" },
  { 521, "id-Secondary-CPICH-Information-Change" },
  { 522, "id-Unused-ProtocolIE-ID-522" },
  { 523, "id-Unused-ProtocolIE-ID-523" },
  { 524, "id-RL-ParameterUpdateIndicationFDD-RL-Information-Item" },
  { 525, "id-Phase-Reference-Update-Indicator" },
  { 526, "id-Unidirectional-DCH-Indicator" },
  { 527, "id-RL-Information-RL-ReconfPrepTDD" },
  { 528, "id-Multiple-RL-InformationResponse-RL-ReconfReadyTDD" },
  { 529, "id-RL-ReconfigurationResponseTDD-RL-Information" },
  { 530, "id-Satellite-Almanac-Information-ExtItem" },
  { 533, "id-HSDSCH-Information-to-Modify-Unsynchronised" },
  { 534, "id-TnlQos" },
  { 535, "id-RTLoadValue" },
  { 536, "id-NRTLoadInformationValue" },
  { 537, "id-CellPortionID" },
  { 538, "id-UpPTSInterferenceValue" },
  { 539, "id-PrimaryCCPCH-RSCP-Delta" },
  { 540, "id-UEMeasurementType" },
  { 541, "id-UEMeasurementTimeslotInfoHCR" },
  { 542, "id-UEMeasurementTimeslotInfoLCR" },
  { 543, "id-UEMeasurementReportCharacteristics" },
  { 544, "id-UEMeasurementParameterModAllow" },
  { 545, "id-UEMeasurementValueInformation" },
  { 546, "id-InterfacesToTraceItem" },
  { 547, "id-ListOfInterfacesToTrace" },
  { 548, "id-TraceDepth" },
  { 549, "id-TraceRecordingSessionReference" },
  { 550, "id-TraceReference" },
  { 551, "id-UEIdentity" },
  { 552, "id-NACC-Related-Data" },
  { 553, "id-GSM-Cell-InfEx-Rqst" },
  { 554, "id-MeasurementRecoveryBehavior" },
  { 555, "id-MeasurementRecoveryReportingIndicator" },
  { 556, "id-MeasurementRecoverySupportIndicator" },
  { 557, "id-DL-DPCH-Power-Information-RL-ReconfPrepFDD" },
  { 558, "id-F-DPCH-Information-RL-ReconfPrepFDD" },
  { 559, "id-F-DPCH-Information-RL-SetupRqstFDD" },
  { 560, "id-MBMS-Bearer-Service-List" },
  { 561, "id-MBMS-Bearer-Service-List-InfEx-Rsp" },
  { 562, "id-Active-MBMS-Bearer-ServiceFDD" },
  { 563, "id-Active-MBMS-Bearer-ServiceTDD" },
  { 564, "id-Old-URA-ID" },
  { 568, "id-UE-State" },
  { 569, "id-URA-ID" },
  { 571, "id-HARQ-Preamble-Mode" },
  { 572, "id-SynchronisationIndicator" },
  { 573, "id-UL-DPDCHIndicatorEDCH" },
  { 574, "id-EDPCH-Information" },
  { 575, "id-RL-Specific-EDCH-Information" },
  { 576, "id-EDCH-RL-Indication" },
  { 577, "id-EDCH-FDD-Information" },
  { 578, "id-EDCH-RLSet-Id" },
  { 579, "id-Serving-EDCHRL-Id" },
  { 580, "id-EDCH-FDD-DL-ControlChannelInformation" },
  { 581, "id-EDCH-FDD-InformationResponse" },
  { 582, "id-EDCH-MACdFlows-To-Add" },
  { 583, "id-EDCH-FDD-Information-To-Modify" },
  { 584, "id-EDCH-MACdFlows-To-Delete" },
  { 585, "id-EDPCH-Information-RLReconfRequest-FDD" },
  { 586, "id-EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd" },
  { 587, "id-EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd" },
  { 588, "id-EDCH-MacdFlowSpecificInformationList-RL-CongestInd" },
  { 589, "id-EDCH-MacdFlowSpecificInformationItem-RL-CongestInd" },
  { 590, "id-MBMS-Bearer-Service-Full-Address" },
  { 591, "id-Initial-DL-DPCH-TimingAdjustment" },
  { 592, "id-Initial-DL-DPCH-TimingAdjustment-Allowed" },
  { 593, "id-User-Plane-Congestion-Fields-Inclusion" },
  { 594, "id-HARQ-Preamble-Mode-Activation-Indicator" },
  { 595, "id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp" },
  { 596, "id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp" },
  { 597, "id-ProvidedInformation" },
  { 598, "id-Active-MBMS-Bearer-ServiceFDD-PFL" },
  { 599, "id-Active-MBMS-Bearer-ServiceTDD-PFL" },
  { 600, "id-FrequencyBandIndicator" },
  { 0, NULL }
};


static int
dissect_rnsap_ProtocolIE_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 65535U, &ProtocolIE_ID, NULL, FALSE);

  return offset;
}
static int dissect_iE_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_ID(tvb, offset, pinfo, tree, hf_rnsap_iE_ID);
}
static int dissect_id(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_ID(tvb, offset, pinfo, tree, hf_rnsap_id);
}



static int
dissect_rnsap_ProtocolIEValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
#line 55 "rnsap.cnf"

	offset = dissect_rnsap_ProtocolIEValueValue(tvb, offset, pinfo, tree);



  return offset;
}
static int dissect_value(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIEValue(tvb, offset, pinfo, tree, hf_rnsap_value);
}


static const per_sequence_t ProtocolIE_Field_sequence[] = {
  { "id"                          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_id },
  { "criticality"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_criticality },
  { "value"                       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_value },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ProtocolIE_Field(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ProtocolIE_Field, ProtocolIE_Field_sequence);

  return offset;
}
static int dissect_ProtocolIE_Container_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Field(tvb, offset, pinfo, tree, hf_rnsap_ProtocolIE_Container_item);
}


static const per_sequence_t ProtocolIE_Container_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ProtocolIE_Container_item },
};

static int
dissect_rnsap_ProtocolIE_Container(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_ProtocolIE_Container, ProtocolIE_Container_sequence_of,
                                                  0, 65535);

  return offset;
}
static int dissect_protocolIEs(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Container(tvb, offset, pinfo, tree, hf_rnsap_protocolIEs);
}
static int dissect_ProtocolIE_ContainerList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Container(tvb, offset, pinfo, tree, hf_rnsap_ProtocolIE_ContainerList_item);
}



static int
dissect_rnsap_Extension(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
#line 31 "rnsap.cnf"

	offset = dissect_rnsap_ProtocolIEValueValue(tvb, offset, pinfo, tree);



  return offset;
}
static int dissect_extensionValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Extension(tvb, offset, pinfo, tree, hf_rnsap_extensionValue);
}


static const per_sequence_t ProtocolExtensionField_sequence[] = {
  { "id"                          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_id },
  { "criticality"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_criticality },
  { "extensionValue"              , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_extensionValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ProtocolExtensionField(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ProtocolExtensionField, ProtocolExtensionField_sequence);

  return offset;
}
static int dissect_ProtocolExtensionContainer_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolExtensionField(tvb, offset, pinfo, tree, hf_rnsap_ProtocolExtensionContainer_item);
}


static const per_sequence_t ProtocolExtensionContainer_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ProtocolExtensionContainer_item },
};

static int
dissect_rnsap_ProtocolExtensionContainer(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_ProtocolExtensionContainer, ProtocolExtensionContainer_sequence_of,
                                                  1, 65535);

  return offset;
}
static int dissect_protocolExtensions(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolExtensionContainer(tvb, offset, pinfo, tree, hf_rnsap_protocolExtensions);
}
static int dissect_iE_Extensions(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolExtensionContainer(tvb, offset, pinfo, tree, hf_rnsap_iE_Extensions);
}
static int dissect_iEe_Extensions(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolExtensionContainer(tvb, offset, pinfo, tree, hf_rnsap_iEe_Extensions);
}


static const per_sequence_t DownlinkSignallingTransferRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DownlinkSignallingTransferRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DownlinkSignallingTransferRequest, DownlinkSignallingTransferRequest_sequence);

  return offset;
}
static int dissect_id_downlinkSignallingTransfer(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DownlinkSignallingTransferRequest(tvb, offset, pinfo, tree, hf_rnsap_id_downlinkSignallingTransfer);
}


static const per_sequence_t PhysicalChannelReconfigurationRequestTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PhysicalChannelReconfigurationRequestTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PhysicalChannelReconfigurationRequestTDD, PhysicalChannelReconfigurationRequestTDD_sequence);

  return offset;
}
static int dissect_id_physicalChannelReconfiguration(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PhysicalChannelReconfigurationRequestTDD(tvb, offset, pinfo, tree, hf_rnsap_id_physicalChannelReconfiguration);
}



static int
dissect_rnsap_INTEGER_0_65535(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 65535U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_innerRadius(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_65535(tvb, offset, pinfo, tree, hf_rnsap_innerRadius);
}
static int dissect_ctfc16bit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_65535(tvb, offset, pinfo, tree, hf_rnsap_ctfc16bit);
}
static int dissect_local(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_65535(tvb, offset, pinfo, tree, hf_rnsap_local);
}



static int
dissect_rnsap_OBJECT_IDENTIFIER(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_object_identifier(tvb, offset, pinfo, tree, hf_index, NULL);

  return offset;
}
static int dissect_global(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_OBJECT_IDENTIFIER(tvb, offset, pinfo, tree, hf_rnsap_global);
}


static const value_string rnsap_PrivateIE_ID_vals[] = {
  {   0, "local" },
  {   1, "global" },
  { 0, NULL }
};

static const per_choice_t PrivateIE_ID_choice[] = {
  {   0, "local"                       , ASN1_NO_EXTENSIONS     , dissect_local },
  {   1, "global"                      , ASN1_NO_EXTENSIONS     , dissect_global },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_PrivateIE_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_PrivateIE_ID, PrivateIE_ID_choice,
                                 NULL);

  return offset;
}
static int dissect_privateIEid(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PrivateIE_ID(tvb, offset, pinfo, tree, hf_rnsap_privateIEid);
}



static int
dissect_rnsap_PrivateIEvalue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
#line 76 "rnsap.cnf"
	/* FIX ME */
	guint length;

	offset = dissect_per_length_determinant(tvb, offset, pinfo, tree, hf_rnsap_IE_length, &length);
	offset = offset + length;
	BYTE_ALIGN_OFFSET(offset)



  return offset;
}
static int dissect_privateIEvalue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PrivateIEvalue(tvb, offset, pinfo, tree, hf_rnsap_privateIEvalue);
}


static const per_sequence_t PrivateIE_Field_sequence[] = {
  { "privateIEid"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_privateIEid },
  { "criticality"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_criticality },
  { "privateIEvalue"              , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_privateIEvalue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PrivateIE_Field(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PrivateIE_Field, PrivateIE_Field_sequence);

  return offset;
}
static int dissect_PrivateIE_Container_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PrivateIE_Field(tvb, offset, pinfo, tree, hf_rnsap_PrivateIE_Container_item);
}


static const per_sequence_t PrivateIE_Container_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_PrivateIE_Container_item },
};

static int
dissect_rnsap_PrivateIE_Container(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_PrivateIE_Container, PrivateIE_Container_sequence_of,
                                                  1, 65535);

  return offset;
}
static int dissect_privateIEs(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PrivateIE_Container(tvb, offset, pinfo, tree, hf_rnsap_privateIEs);
}


static const per_sequence_t PrivateMessage_sequence[] = {
  { "privateIEs"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_privateIEs },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PrivateMessage(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PrivateMessage, PrivateMessage_sequence);

  return offset;
}
static int dissect_id_privateMessage(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PrivateMessage(tvb, offset, pinfo, tree, hf_rnsap_id_privateMessage);
}


static const per_sequence_t RadioLinkAdditionRequestFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkAdditionRequestFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkAdditionRequestFDD, RadioLinkAdditionRequestFDD_sequence);

  return offset;
}
static int dissect_id_radioLinkAddition(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkAdditionRequestFDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkAddition);
}


static const per_sequence_t RadioLinkAdditionRequestTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkAdditionRequestTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkAdditionRequestTDD, RadioLinkAdditionRequestTDD_sequence);

  return offset;
}
static int dissect_id_radioLinkAddition_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkAdditionRequestTDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkAddition_TDD);
}


static const per_sequence_t RadioLinkDeletionRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkDeletionRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkDeletionRequest, RadioLinkDeletionRequest_sequence);

  return offset;
}
static int dissect_id_radioLinkDeletion(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkDeletionRequest(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkDeletion);
}


static const per_sequence_t RadioLinkSetupRequestFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkSetupRequestFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkSetupRequestFDD, RadioLinkSetupRequestFDD_sequence);

  return offset;
}
static int dissect_id_radioLinkSetup(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkSetupRequestFDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkSetup);
}


static const per_sequence_t RadioLinkSetupRequestTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkSetupRequestTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkSetupRequestTDD, RadioLinkSetupRequestTDD_sequence);

  return offset;
}
static int dissect_id_radioLinkSetupTdd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkSetupRequestTDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkSetupTdd);
}


static const per_sequence_t RadioLinkReconfigurationPrepareFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationPrepareFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationPrepareFDD, RadioLinkReconfigurationPrepareFDD_sequence);

  return offset;
}
static int dissect_id_synchronisedRadioLinkReconfigurationPreparation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkReconfigurationPrepareFDD(tvb, offset, pinfo, tree, hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation);
}


static const per_sequence_t RadioLinkReconfigurationReadyTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationReadyTDD, RadioLinkReconfigurationReadyTDD_sequence);

  return offset;
}
static int dissect_id_synchronisedRadioLinkReconfigurationPreparation_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkReconfigurationReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation_TDD);
}


static const per_sequence_t RadioLinkReconfigurationRequestFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationRequestFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationRequestFDD, RadioLinkReconfigurationRequestFDD_sequence);

  return offset;
}
static int dissect_id_unSynchronisedRadioLinkReconfiguration(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkReconfigurationRequestFDD(tvb, offset, pinfo, tree, hf_rnsap_id_unSynchronisedRadioLinkReconfiguration);
}


static const per_sequence_t RadioLinkReconfigurationRequestTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationRequestTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationRequestTDD, RadioLinkReconfigurationRequestTDD_sequence);

  return offset;
}
static int dissect_id_unSynchronisedRadioLinkReconfiguration_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkReconfigurationRequestTDD(tvb, offset, pinfo, tree, hf_rnsap_id_unSynchronisedRadioLinkReconfiguration_TDD);
}


static const value_string rnsap_DummyInitiatingValue_vals[] = {
  {   0, "id-downlinkSignallingTransfer" },
  {   1, "id-physicalChannelReconfiguration" },
  {   2, "id-privateMessage" },
  {   3, "id-radioLinkAddition" },
  {   4, "id-radioLinkAddition-TDD" },
  {   5, "id-radioLinkDeletion" },
  {   6, "id-radioLinkSetup" },
  {   7, "id-radioLinkSetupTdd" },
  {   8, "id-synchronisedRadioLinkReconfigurationPreparation" },
  {   9, "id-synchronisedRadioLinkReconfigurationPreparation-TDD" },
  {  10, "id-unSynchronisedRadioLinkReconfiguration" },
  {  11, "id-unSynchronisedRadioLinkReconfiguration-TDD" },
  { 0, NULL }
};

static const per_choice_t DummyInitiatingValue_choice[] = {
  {   0, "id-downlinkSignallingTransfer", ASN1_EXTENSION_ROOT    , dissect_id_downlinkSignallingTransfer },
  {   1, "id-physicalChannelReconfiguration", ASN1_EXTENSION_ROOT    , dissect_id_physicalChannelReconfiguration },
  {   2, "id-privateMessage"           , ASN1_EXTENSION_ROOT    , dissect_id_privateMessage },
  {   3, "id-radioLinkAddition"        , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkAddition },
  {   4, "id-radioLinkAddition-TDD"    , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkAddition_TDD },
  {   5, "id-radioLinkDeletion"        , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkDeletion },
  {   6, "id-radioLinkSetup"           , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkSetup },
  {   7, "id-radioLinkSetupTdd"        , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkSetupTdd },
  {   8, "id-synchronisedRadioLinkReconfigurationPreparation", ASN1_EXTENSION_ROOT    , dissect_id_synchronisedRadioLinkReconfigurationPreparation },
  {   9, "id-synchronisedRadioLinkReconfigurationPreparation-TDD", ASN1_EXTENSION_ROOT    , dissect_id_synchronisedRadioLinkReconfigurationPreparation_TDD },
  {  10, "id-unSynchronisedRadioLinkReconfiguration", ASN1_EXTENSION_ROOT    , dissect_id_unSynchronisedRadioLinkReconfiguration },
  {  11, "id-unSynchronisedRadioLinkReconfiguration-TDD", ASN1_EXTENSION_ROOT    , dissect_id_unSynchronisedRadioLinkReconfiguration_TDD },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DummyInitiatingValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DummyInitiatingValue, DummyInitiatingValue_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PhysicalChannelReconfigurationCommand_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PhysicalChannelReconfigurationCommand(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PhysicalChannelReconfigurationCommand, PhysicalChannelReconfigurationCommand_sequence);

  return offset;
}
static int dissect_id_physicalChannelReconfiguration1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PhysicalChannelReconfigurationCommand(tvb, offset, pinfo, tree, hf_rnsap_id_physicalChannelReconfiguration1);
}


static const per_sequence_t RadioLinkAdditionResponseFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkAdditionResponseFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkAdditionResponseFDD, RadioLinkAdditionResponseFDD_sequence);

  return offset;
}
static int dissect_id_radioLinkAddition1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkAdditionResponseFDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkAddition1);
}


static const per_sequence_t RadioLinkAdditionResponseTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkAdditionResponseTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkAdditionResponseTDD, RadioLinkAdditionResponseTDD_sequence);

  return offset;
}
static int dissect_id_radioLinkAddition_TDD1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkAdditionResponseTDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkAddition_TDD1);
}


static const per_sequence_t RadioLinkDeletionResponse_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkDeletionResponse(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkDeletionResponse, RadioLinkDeletionResponse_sequence);

  return offset;
}
static int dissect_id_radioLinkDeletion1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkDeletionResponse(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkDeletion1);
}


static const per_sequence_t RadioLinkSetupResponseFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkSetupResponseFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkSetupResponseFDD, RadioLinkSetupResponseFDD_sequence);

  return offset;
}
static int dissect_id_radioLinkSetup1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkSetupResponseFDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkSetup1);
}


static const per_sequence_t RadioLinkSetupResponseTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkSetupResponseTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkSetupResponseTDD, RadioLinkSetupResponseTDD_sequence);

  return offset;
}
static int dissect_id_radioLinkSetupTdd1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkSetupResponseTDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkSetupTdd1);
}


static const per_sequence_t RadioLinkReconfigurationReadyFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationReadyFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationReadyFDD, RadioLinkReconfigurationReadyFDD_sequence);

  return offset;
}
static int dissect_id_synchronisedRadioLinkReconfigurationPreparation1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkReconfigurationReadyFDD(tvb, offset, pinfo, tree, hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation1);
}


static const per_sequence_t RadioLinkReconfigurationResponseFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationResponseFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationResponseFDD, RadioLinkReconfigurationResponseFDD_sequence);

  return offset;
}
static int dissect_id_unSynchronisedRadioLinkReconfiguration1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkReconfigurationResponseFDD(tvb, offset, pinfo, tree, hf_rnsap_id_unSynchronisedRadioLinkReconfiguration1);
}


static const per_sequence_t RadioLinkReconfigurationResponseTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationResponseTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationResponseTDD, RadioLinkReconfigurationResponseTDD_sequence);

  return offset;
}
static int dissect_id_unSynchronisedRadioLinkReconfiguration_TDD1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkReconfigurationResponseTDD(tvb, offset, pinfo, tree, hf_rnsap_id_unSynchronisedRadioLinkReconfiguration_TDD1);
}


static const value_string rnsap_DummySuccessfulOutcomeValue_vals[] = {
  {   0, "id-physicalChannelReconfiguration" },
  {   1, "id-radioLinkAddition" },
  {   2, "id-radioLinkAddition-TDD" },
  {   3, "id-radioLinkDeletion" },
  {   4, "id-radioLinkSetup" },
  {   5, "id-radioLinkSetupTdd" },
  {   6, "id-synchronisedRadioLinkReconfigurationPreparation" },
  {   7, "id-synchronisedRadioLinkReconfigurationPreparation-TDD" },
  {   8, "id-unSynchronisedRadioLinkReconfiguration" },
  {   9, "id-unSynchronisedRadioLinkReconfiguration-TDD" },
  { 0, NULL }
};

static const per_choice_t DummySuccessfulOutcomeValue_choice[] = {
  {   0, "id-physicalChannelReconfiguration", ASN1_EXTENSION_ROOT    , dissect_id_physicalChannelReconfiguration1 },
  {   1, "id-radioLinkAddition"        , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkAddition1 },
  {   2, "id-radioLinkAddition-TDD"    , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkAddition_TDD1 },
  {   3, "id-radioLinkDeletion"        , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkDeletion1 },
  {   4, "id-radioLinkSetup"           , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkSetup1 },
  {   5, "id-radioLinkSetupTdd"        , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkSetupTdd1 },
  {   6, "id-synchronisedRadioLinkReconfigurationPreparation", ASN1_EXTENSION_ROOT    , dissect_id_synchronisedRadioLinkReconfigurationPreparation1 },
  {   7, "id-synchronisedRadioLinkReconfigurationPreparation-TDD", ASN1_EXTENSION_ROOT    , dissect_id_synchronisedRadioLinkReconfigurationPreparation_TDD },
  {   8, "id-unSynchronisedRadioLinkReconfiguration", ASN1_EXTENSION_ROOT    , dissect_id_unSynchronisedRadioLinkReconfiguration1 },
  {   9, "id-unSynchronisedRadioLinkReconfiguration-TDD", ASN1_EXTENSION_ROOT    , dissect_id_unSynchronisedRadioLinkReconfiguration_TDD1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DummySuccessfulOutcomeValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DummySuccessfulOutcomeValue, DummySuccessfulOutcomeValue_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PhysicalChannelReconfigurationFailure_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PhysicalChannelReconfigurationFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PhysicalChannelReconfigurationFailure, PhysicalChannelReconfigurationFailure_sequence);

  return offset;
}
static int dissect_id_physicalChannelReconfiguration2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PhysicalChannelReconfigurationFailure(tvb, offset, pinfo, tree, hf_rnsap_id_physicalChannelReconfiguration2);
}


static const per_sequence_t RadioLinkAdditionFailureFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkAdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkAdditionFailureFDD, RadioLinkAdditionFailureFDD_sequence);

  return offset;
}
static int dissect_id_radioLinkAddition2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkAdditionFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkAddition2);
}


static const per_sequence_t RadioLinkAdditionFailureTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkAdditionFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkAdditionFailureTDD, RadioLinkAdditionFailureTDD_sequence);

  return offset;
}
static int dissect_id_radioLinkAddition_TDD2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkAdditionFailureTDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkAddition_TDD2);
}


static const per_sequence_t RadioLinkSetupFailureFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkSetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkSetupFailureFDD, RadioLinkSetupFailureFDD_sequence);

  return offset;
}
static int dissect_id_radioLinkSetup2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkSetupFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkSetup2);
}


static const per_sequence_t RadioLinkSetupFailureTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkSetupFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkSetupFailureTDD, RadioLinkSetupFailureTDD_sequence);

  return offset;
}
static int dissect_id_radioLinkSetupTdd2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkSetupFailureTDD(tvb, offset, pinfo, tree, hf_rnsap_id_radioLinkSetupTdd2);
}


static const per_sequence_t RadioLinkReconfigurationFailure_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationFailure, RadioLinkReconfigurationFailure_sequence);

  return offset;
}
static int dissect_id_synchronisedRadioLinkReconfigurationPreparation2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkReconfigurationFailure(tvb, offset, pinfo, tree, hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation2);
}
static int dissect_id_unSynchronisedRadioLinkReconfiguration2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkReconfigurationFailure(tvb, offset, pinfo, tree, hf_rnsap_id_unSynchronisedRadioLinkReconfiguration2);
}
static int dissect_id_unSynchronisedRadioLinkReconfiguration_TDD2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RadioLinkReconfigurationFailure(tvb, offset, pinfo, tree, hf_rnsap_id_unSynchronisedRadioLinkReconfiguration_TDD2);
}


static const value_string rnsap_DummyUnSuccessfulOutcomeValue_vals[] = {
  {   0, "id-physicalChannelReconfiguration" },
  {   1, "id-radioLinkAddition" },
  {   2, "id-radioLinkAddition-TDD" },
  {   3, "id-radioLinkSetup" },
  {   4, "id-radioLinkSetupTdd" },
  {   5, "id-synchronisedRadioLinkReconfigurationPreparation" },
  {   6, "id-unSynchronisedRadioLinkReconfiguration" },
  {   7, "id-unSynchronisedRadioLinkReconfiguration-TDD" },
  { 0, NULL }
};

static const per_choice_t DummyUnSuccessfulOutcomeValue_choice[] = {
  {   0, "id-physicalChannelReconfiguration", ASN1_EXTENSION_ROOT    , dissect_id_physicalChannelReconfiguration2 },
  {   1, "id-radioLinkAddition"        , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkAddition2 },
  {   2, "id-radioLinkAddition-TDD"    , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkAddition_TDD2 },
  {   3, "id-radioLinkSetup"           , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkSetup2 },
  {   4, "id-radioLinkSetupTdd"        , ASN1_EXTENSION_ROOT    , dissect_id_radioLinkSetupTdd2 },
  {   5, "id-synchronisedRadioLinkReconfigurationPreparation", ASN1_EXTENSION_ROOT    , dissect_id_synchronisedRadioLinkReconfigurationPreparation2 },
  {   6, "id-unSynchronisedRadioLinkReconfiguration", ASN1_EXTENSION_ROOT    , dissect_id_unSynchronisedRadioLinkReconfiguration2 },
  {   7, "id-unSynchronisedRadioLinkReconfiguration-TDD", ASN1_EXTENSION_ROOT    , dissect_id_unSynchronisedRadioLinkReconfiguration_TDD2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DummyUnSuccessfulOutcomeValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DummyUnSuccessfulOutcomeValue, DummyUnSuccessfulOutcomeValue_choice,
                                 NULL);

  return offset;
}



static int
dissect_rnsap_AllowedQueuingTime(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 60U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_AllowedQueuingTime(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AllowedQueuingTime(tvb, offset, pinfo, tree, hf_rnsap_id_AllowedQueuingTime);
}



static int
dissect_rnsap_Allowed_Rate(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 32U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_allowed_UL_Rate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Allowed_Rate(tvb, offset, pinfo, tree, hf_rnsap_allowed_UL_Rate);
}
static int dissect_allowed_DL_Rate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Allowed_Rate(tvb, offset, pinfo, tree, hf_rnsap_allowed_DL_Rate);
}


static const per_sequence_t Allowed_Rate_Information_sequence[] = {
  { "allowed-UL-Rate"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_allowed_UL_Rate },
  { "allowed-DL-Rate"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_allowed_DL_Rate },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Allowed_Rate_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Allowed_Rate_Information, Allowed_Rate_Information_sequence);

  return offset;
}
static int dissect_id_Allowed_Rate_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Allowed_Rate_Information(tvb, offset, pinfo, tree, hf_rnsap_id_Allowed_Rate_Information);
}
static int dissect_allowed_Rate_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Allowed_Rate_Information(tvb, offset, pinfo, tree, hf_rnsap_allowed_Rate_Information);
}


static const value_string rnsap_AntennaColocationIndicator_vals[] = {
  {   0, "co-located" },
  { 0, NULL }
};


static int
dissect_rnsap_AntennaColocationIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, TRUE);

  return offset;
}
static int dissect_id_AntennaColocationIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AntennaColocationIndicator(tvb, offset, pinfo, tree, hf_rnsap_id_AntennaColocationIndicator);
}



static int
dissect_rnsap_BindingID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       1, 4, NULL);

  return offset;
}
static int dissect_id_BindingID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BindingID(tvb, offset, pinfo, tree, hf_rnsap_id_BindingID);
}
static int dissect_bindingID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BindingID(tvb, offset, pinfo, tree, hf_rnsap_bindingID);
}



static int
dissect_rnsap_C_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 65535U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_C_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_C_ID(tvb, offset, pinfo, tree, hf_rnsap_id_C_ID);
}
static int dissect_c_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_C_ID(tvb, offset, pinfo, tree, hf_rnsap_c_ID);
}
static int dissect_CorrespondingCells_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_C_ID(tvb, offset, pinfo, tree, hf_rnsap_CorrespondingCells_item);
}



static int
dissect_rnsap_C_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 65535U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_C_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_C_RNTI(tvb, offset, pinfo, tree, hf_rnsap_id_C_RNTI);
}



static int
dissect_rnsap_INTEGER_1_100_(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 100U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_uplinkCellCapacityClassValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_100_(tvb, offset, pinfo, tree, hf_rnsap_uplinkCellCapacityClassValue);
}
static int dissect_downlinkCellCapacityClassValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_100_(tvb, offset, pinfo, tree, hf_rnsap_downlinkCellCapacityClassValue);
}


static const per_sequence_t Cell_Capacity_Class_Value_sequence[] = {
  { "uplinkCellCapacityClassValue", ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_uplinkCellCapacityClassValue },
  { "downlinkCellCapacityClassValue", ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_downlinkCellCapacityClassValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Cell_Capacity_Class_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Cell_Capacity_Class_Value, Cell_Capacity_Class_Value_sequence);

  return offset;
}
static int dissect_id_Cell_Capacity_Class_Value(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cell_Capacity_Class_Value(tvb, offset, pinfo, tree, hf_rnsap_id_Cell_Capacity_Class_Value);
}



static int
dissect_rnsap_CFN(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_CFN(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CFN(tvb, offset, pinfo, tree, hf_rnsap_id_CFN);
}
static int dissect_cFN(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CFN(tvb, offset, pinfo, tree, hf_rnsap_cFN);
}
static int dissect_cMConfigurationChangeCFN(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CFN(tvb, offset, pinfo, tree, hf_rnsap_cMConfigurationChangeCFN);
}
static int dissect_cfn(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CFN(tvb, offset, pinfo, tree, hf_rnsap_cfn);
}
static int dissect_synchronised(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CFN(tvb, offset, pinfo, tree, hf_rnsap_synchronised);
}
static int dissect_tGCFN(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CFN(tvb, offset, pinfo, tree, hf_rnsap_tGCFN);
}



static int
dissect_rnsap_PLMN_Identity(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       3, 3, NULL);

  return offset;
}
static int dissect_pLMN_Identity(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PLMN_Identity(tvb, offset, pinfo, tree, hf_rnsap_pLMN_Identity);
}
static int dissect_plmn_id(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PLMN_Identity(tvb, offset, pinfo, tree, hf_rnsap_plmn_id);
}



static int
dissect_rnsap_LAC(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       2, 2, NULL);

  return offset;
}
static int dissect_lAC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_LAC(tvb, offset, pinfo, tree, hf_rnsap_lAC);
}


static const per_sequence_t CN_CS_DomainIdentifier_sequence[] = {
  { "pLMN-Identity"               , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_pLMN_Identity },
  { "lAC"                         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_lAC },
  { "iE-Extensions"               , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CN_CS_DomainIdentifier(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CN_CS_DomainIdentifier, CN_CS_DomainIdentifier_sequence);

  return offset;
}
static int dissect_id_CN_CS_DomainIdentifier(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CN_CS_DomainIdentifier(tvb, offset, pinfo, tree, hf_rnsap_id_CN_CS_DomainIdentifier);
}
static int dissect_cN_CS_DomainIdentifier(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CN_CS_DomainIdentifier(tvb, offset, pinfo, tree, hf_rnsap_cN_CS_DomainIdentifier);
}



static int
dissect_rnsap_RAC(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       1, 1, NULL);

  return offset;
}
static int dissect_rAC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RAC(tvb, offset, pinfo, tree, hf_rnsap_rAC);
}


static const per_sequence_t CN_PS_DomainIdentifier_sequence[] = {
  { "pLMN-Identity"               , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_pLMN_Identity },
  { "lAC"                         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_lAC },
  { "rAC"                         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_rAC },
  { "iE-Extensions"               , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CN_PS_DomainIdentifier(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CN_PS_DomainIdentifier, CN_PS_DomainIdentifier_sequence);

  return offset;
}
static int dissect_id_CN_PS_DomainIdentifier(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CN_PS_DomainIdentifier(tvb, offset, pinfo, tree, hf_rnsap_id_CN_PS_DomainIdentifier);
}
static int dissect_cN_PS_DomainIdentifier(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CN_PS_DomainIdentifier(tvb, offset, pinfo, tree, hf_rnsap_cN_PS_DomainIdentifier);
}


static const value_string rnsap_CauseRadioNetwork_vals[] = {
  {   0, "unknown-C-ID" },
  {   1, "cell-not-available" },
  {   2, "power-level-not-supported" },
  {   3, "ul-scrambling-code-already-in-use" },
  {   4, "dl-radio-resources-not-available" },
  {   5, "ul-radio-resources-not-available" },
  {   6, "measurement-not-supported-for-the-object" },
  {   7, "combining-resources-not-available" },
  {   8, "combining-not-supported" },
  {   9, "reconfiguration-not-allowed" },
  {  10, "requested-configuration-not-supported" },
  {  11, "synchronisation-failure" },
  {  12, "requested-tx-diversity-mode-not-supported" },
  {  13, "measurement-temporaily-not-available" },
  {  14, "unspecified" },
  {  15, "invalid-CM-settings" },
  {  16, "reconfiguration-CFN-not-elapsed" },
  {  17, "number-of-DL-codes-not-supported" },
  {  18, "dedicated-transport-channel-type-not-supported" },
  {  19, "dl-shared-channel-type-not-supported" },
  {  20, "ul-shared-channel-type-not-supported" },
  {  21, "common-transport-channel-type-not-supported" },
  {  22, "ul-spreading-factor-not-supported" },
  {  23, "dl-spreading-factor-not-supported" },
  {  24, "cm-not-supported" },
  {  25, "transaction-not-supported-by-destination-node-b" },
  {  26, "rl-already-activated-or-alocated" },
  {  27, "number-of-UL-codes-not-supported" },
  {  27, "cell-reserved-for-operator-use" },
  {  27, "dpc-mode-change-not-supported" },
  {  27, "information-temporarily-not-available" },
  {  27, "information-provision-not-supported-for-the-object" },
  {  27, "power-balancing-status-not-compatible" },
  {  27, "delayed-activation-not-supported" },
  {  27, "rl-timing-adjustment-not-supported" },
  {  27, "unknown-RNTI" },
  {  27, "measurement-repetition-rate-not-compatible" },
  {  27, "ue-not-capable-of-support" },
  {  27, "f-dpch-not-supported" },
  { 0, NULL }
};


static int
dissect_rnsap_CauseRadioNetwork(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 27, NULL, NULL, TRUE);

  return offset;
}
static int dissect_radioNetwork(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CauseRadioNetwork(tvb, offset, pinfo, tree, hf_rnsap_radioNetwork);
}


static const value_string rnsap_CauseTransport_vals[] = {
  {   0, "transport-resource-unavailable" },
  {   1, "unspecified" },
  { 0, NULL }
};


static int
dissect_rnsap_CauseTransport(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_transport(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CauseTransport(tvb, offset, pinfo, tree, hf_rnsap_transport);
}


static const value_string rnsap_CauseProtocol_vals[] = {
  {   0, "transfer-syntax-error" },
  {   1, "abstract-syntax-error-reject" },
  {   2, "abstract-syntax-error-ignore-and-notify" },
  {   3, "message-not-compatible-with-receiver-state" },
  {   4, "semantic-error" },
  {   5, "unspecified" },
  {   6, "abstract-syntax-error-falsely-constructed-message" },
  { 0, NULL }
};


static int
dissect_rnsap_CauseProtocol(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 6, NULL, NULL, TRUE);

  return offset;
}
static int dissect_protocol(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CauseProtocol(tvb, offset, pinfo, tree, hf_rnsap_protocol);
}


static const value_string rnsap_CauseMisc_vals[] = {
  {   0, "control-processing-overload" },
  {   1, "hardware-failure" },
  {   2, "om-intervention" },
  {   3, "not-enough-user-plane-processing-resources" },
  {   4, "unspecified" },
  { 0, NULL }
};


static int
dissect_rnsap_CauseMisc(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 4, NULL, NULL, TRUE);

  return offset;
}
static int dissect_misc(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CauseMisc(tvb, offset, pinfo, tree, hf_rnsap_misc);
}


static const value_string rnsap_Cause_vals[] = {
  {   0, "radioNetwork" },
  {   1, "transport" },
  {   2, "protocol" },
  {   3, "misc" },
  { 0, NULL }
};

static const per_choice_t Cause_choice[] = {
  {   0, "radioNetwork"                , ASN1_EXTENSION_ROOT    , dissect_radioNetwork },
  {   1, "transport"                   , ASN1_EXTENSION_ROOT    , dissect_transport },
  {   2, "protocol"                    , ASN1_EXTENSION_ROOT    , dissect_protocol },
  {   3, "misc"                        , ASN1_EXTENSION_ROOT    , dissect_misc },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_Cause(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_Cause, Cause_choice,
                                 NULL);

  return offset;
}
static int dissect_id_Cause(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cause(tvb, offset, pinfo, tree, hf_rnsap_id_Cause);
}
static int dissect_cause(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cause(tvb, offset, pinfo, tree, hf_rnsap_cause);
}
static int dissect_individualcause(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cause(tvb, offset, pinfo, tree, hf_rnsap_individualcause);
}


static const value_string rnsap_CoverageIndicator_vals[] = {
  {   0, "overlap" },
  {   1, "covers" },
  {   2, "containedIn" },
  { 0, NULL }
};


static int
dissect_rnsap_CoverageIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_id_CoverageIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CoverageIndicator(tvb, offset, pinfo, tree, hf_rnsap_id_CoverageIndicator);
}


static const value_string rnsap_TriggeringMessage_vals[] = {
  {   0, "initiating-message" },
  {   1, "successful-outcome" },
  {   2, "unsuccessful-outcome" },
  {   3, "outcome" },
  { 0, NULL }
};


static int
dissect_rnsap_TriggeringMessage(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 3, NULL, NULL, FALSE);

  return offset;
}
static int dissect_triggeringMessage(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TriggeringMessage(tvb, offset, pinfo, tree, hf_rnsap_triggeringMessage);
}



static int
dissect_rnsap_RepetitionNumber0(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_repetitionNumber(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RepetitionNumber0(tvb, offset, pinfo, tree, hf_rnsap_repetitionNumber);
}


static const per_sequence_t CriticalityDiagnostics_IE_List_item_sequence[] = {
  { "iECriticality"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iECriticality },
  { "iE-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iE_ID },
  { "repetitionNumber"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_repetitionNumber },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CriticalityDiagnostics_IE_List_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CriticalityDiagnostics_IE_List_item, CriticalityDiagnostics_IE_List_item_sequence);

  return offset;
}
static int dissect_CriticalityDiagnostics_IE_List_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CriticalityDiagnostics_IE_List_item(tvb, offset, pinfo, tree, hf_rnsap_CriticalityDiagnostics_IE_List_item);
}


static const per_sequence_t CriticalityDiagnostics_IE_List_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_CriticalityDiagnostics_IE_List_item },
};

static int
dissect_rnsap_CriticalityDiagnostics_IE_List(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_CriticalityDiagnostics_IE_List, CriticalityDiagnostics_IE_List_sequence_of,
                                                  1, 256);

  return offset;
}
static int dissect_iEsCriticalityDiagnostics(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CriticalityDiagnostics_IE_List(tvb, offset, pinfo, tree, hf_rnsap_iEsCriticalityDiagnostics);
}


static const per_sequence_t CriticalityDiagnostics_sequence[] = {
  { "procedureID"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_procedureID },
  { "triggeringMessage"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_triggeringMessage },
  { "procedureCriticality"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_procedureCriticality },
  { "transactionID"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transactionID },
  { "iEsCriticalityDiagnostics"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iEsCriticalityDiagnostics },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CriticalityDiagnostics(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CriticalityDiagnostics, CriticalityDiagnostics_sequence);

  return offset;
}
static int dissect_id_CriticalityDiagnostics(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CriticalityDiagnostics(tvb, offset, pinfo, tree, hf_rnsap_id_CriticalityDiagnostics);
}



static int
dissect_rnsap_S_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 1048575U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_S_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_S_RNTI(tvb, offset, pinfo, tree, hf_rnsap_id_S_RNTI);
}
static int dissect_sRNTI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_S_RNTI(tvb, offset, pinfo, tree, hf_rnsap_sRNTI);
}
static int dissect_AffectedUEInformationForMBMS_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_S_RNTI(tvb, offset, pinfo, tree, hf_rnsap_AffectedUEInformationForMBMS_item);
}



static int
dissect_rnsap_D_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 1048575U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_D_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_D_RNTI(tvb, offset, pinfo, tree, hf_rnsap_id_D_RNTI);
}
static int dissect_dRNTI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_D_RNTI(tvb, offset, pinfo, tree, hf_rnsap_dRNTI);
}
static int dissect_d_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_D_RNTI(tvb, offset, pinfo, tree, hf_rnsap_d_RNTI);
}


static const value_string rnsap_ContextType_Reset_vals[] = {
  {   0, "sRNTI" },
  {   1, "dRNTI" },
  { 0, NULL }
};

static const per_choice_t ContextType_Reset_choice[] = {
  {   0, "sRNTI"                       , ASN1_EXTENSION_ROOT    , dissect_sRNTI },
  {   1, "dRNTI"                       , ASN1_EXTENSION_ROOT    , dissect_dRNTI },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_ContextType_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_ContextType_Reset, ContextType_Reset_choice,
                                 NULL);

  return offset;
}
static int dissect_contextType_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ContextType_Reset(tvb, offset, pinfo, tree, hf_rnsap_contextType_Reset);
}


static const per_sequence_t ContextInfoItem_Reset_sequence[] = {
  { "contextType-Reset"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_contextType_Reset },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ContextInfoItem_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ContextInfoItem_Reset, ContextInfoItem_Reset_sequence);

  return offset;
}
static int dissect_id_ContextInfoItem_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ContextInfoItem_Reset(tvb, offset, pinfo, tree, hf_rnsap_id_ContextInfoItem_Reset);
}


static const value_string rnsap_T_sRNTI_BitMaskIndex_vals[] = {
  {   0, "b1" },
  {   1, "b2" },
  {   2, "b3" },
  {   3, "b4" },
  {   4, "b5" },
  {   5, "b6" },
  {   6, "b7" },
  {   7, "b8" },
  {   8, "b9" },
  {   9, "b10" },
  {  10, "b11" },
  {  11, "b12" },
  {  12, "b13" },
  {  13, "b14" },
  {  14, "b15" },
  {  15, "b16" },
  {  16, "b17" },
  {  17, "b18" },
  {  18, "b19" },
  { 0, NULL }
};


static int
dissect_rnsap_T_sRNTI_BitMaskIndex(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 18, NULL, NULL, TRUE);

  return offset;
}
static int dissect_sRNTI_BitMaskIndex(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_sRNTI_BitMaskIndex(tvb, offset, pinfo, tree, hf_rnsap_sRNTI_BitMaskIndex);
}


static const per_sequence_t S_RNTI_Group_sequence[] = {
  { "sRNTI"                       , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_sRNTI },
  { "sRNTI-BitMaskIndex"          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_sRNTI_BitMaskIndex },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_S_RNTI_Group(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_S_RNTI_Group, S_RNTI_Group_sequence);

  return offset;
}
static int dissect_s_RNTI_Group(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_S_RNTI_Group(tvb, offset, pinfo, tree, hf_rnsap_s_RNTI_Group);
}


static const per_sequence_t ContextGroupInfoItem_Reset_sequence[] = {
  { "s-RNTI-Group"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_s_RNTI_Group },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ContextGroupInfoItem_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ContextGroupInfoItem_Reset, ContextGroupInfoItem_Reset_sequence);

  return offset;
}
static int dissect_id_ContextGroupInfoItem_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ContextGroupInfoItem_Reset(tvb, offset, pinfo, tree, hf_rnsap_id_ContextGroupInfoItem_Reset);
}


static const value_string rnsap_D_RNTI_ReleaseIndication_vals[] = {
  {   0, "release-D-RNTI" },
  {   1, "not-release-D-RNTI" },
  { 0, NULL }
};


static int
dissect_rnsap_D_RNTI_ReleaseIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_D_RNTI_ReleaseIndication(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_D_RNTI_ReleaseIndication(tvb, offset, pinfo, tree, hf_rnsap_id_D_RNTI_ReleaseIndication);
}


static const value_string rnsap_PayloadCRC_PresenceIndicator_vals[] = {
  {   0, "crc-included" },
  {   1, "crc-not-included" },
  { 0, NULL }
};


static int
dissect_rnsap_PayloadCRC_PresenceIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_payloadCRC_PresenceIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PayloadCRC_PresenceIndicator(tvb, offset, pinfo, tree, hf_rnsap_payloadCRC_PresenceIndicator);
}


static const value_string rnsap_UL_FP_Mode_vals[] = {
  {   0, "normal" },
  {   1, "silent" },
  { 0, NULL }
};


static int
dissect_rnsap_UL_FP_Mode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_ul_FP_Mode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_FP_Mode(tvb, offset, pinfo, tree, hf_rnsap_ul_FP_Mode);
}



static int
dissect_rnsap_ToAWS(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 1279U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_toAWS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ToAWS(tvb, offset, pinfo, tree, hf_rnsap_toAWS);
}



static int
dissect_rnsap_ToAWE(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 2559U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_toAWE(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ToAWE(tvb, offset, pinfo, tree, hf_rnsap_toAWE);
}



static int
dissect_rnsap_DCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_dCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_ID(tvb, offset, pinfo, tree, hf_rnsap_dCH_ID);
}
static int dissect_dCH_id(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_ID(tvb, offset, pinfo, tree, hf_rnsap_dCH_id);
}


static const value_string rnsap_TrCH_SrcStatisticsDescr_vals[] = {
  {   0, "speech" },
  {   1, "rRC" },
  {   2, "unknown" },
  { 0, NULL }
};


static int
dissect_rnsap_TrCH_SrcStatisticsDescr(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_trChSourceStatisticsDescriptor(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TrCH_SrcStatisticsDescr(tvb, offset, pinfo, tree, hf_rnsap_trChSourceStatisticsDescriptor);
}
static int dissect_trCH_SrcStatisticsDescr(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TrCH_SrcStatisticsDescr(tvb, offset, pinfo, tree, hf_rnsap_trCH_SrcStatisticsDescr);
}



static int
dissect_rnsap_NrOfTransportBlocks(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 512U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_nrOfTransportBlocks(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NrOfTransportBlocks(tvb, offset, pinfo, tree, hf_rnsap_nrOfTransportBlocks);
}



static int
dissect_rnsap_TransportBlockSize(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 5000U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_transportBlockSize(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportBlockSize(tvb, offset, pinfo, tree, hf_rnsap_transportBlockSize);
}


static const value_string rnsap_TransmissionTimeIntervalDynamic_vals[] = {
  {   0, "msec-10" },
  {   1, "msec-20" },
  {   2, "msec-40" },
  {   3, "msec-80" },
  { 0, NULL }
};


static int
dissect_rnsap_TransmissionTimeIntervalDynamic(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 3, NULL, NULL, TRUE);

  return offset;
}
static int dissect_transmissionTimeInterval(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransmissionTimeIntervalDynamic(tvb, offset, pinfo, tree, hf_rnsap_transmissionTimeInterval);
}


static const per_sequence_t TransmissionTimeIntervalInformation_item_sequence[] = {
  { "transmissionTimeInterval"    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transmissionTimeInterval },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TransmissionTimeIntervalInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TransmissionTimeIntervalInformation_item, TransmissionTimeIntervalInformation_item_sequence);

  return offset;
}
static int dissect_TransmissionTimeIntervalInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransmissionTimeIntervalInformation_item(tvb, offset, pinfo, tree, hf_rnsap_TransmissionTimeIntervalInformation_item);
}


static const per_sequence_t TransmissionTimeIntervalInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TransmissionTimeIntervalInformation_item },
};

static int
dissect_rnsap_TransmissionTimeIntervalInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TransmissionTimeIntervalInformation, TransmissionTimeIntervalInformation_sequence_of,
                                                  1, 4);

  return offset;
}
static int dissect_transmissionTimeIntervalInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransmissionTimeIntervalInformation(tvb, offset, pinfo, tree, hf_rnsap_transmissionTimeIntervalInformation);
}


static const per_sequence_t TDD_TransportFormatSet_ModeDP_sequence[] = {
  { "transmissionTimeIntervalInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transmissionTimeIntervalInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_TransportFormatSet_ModeDP(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_TransportFormatSet_ModeDP, TDD_TransportFormatSet_ModeDP_sequence);

  return offset;
}
static int dissect_tdd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_TransportFormatSet_ModeDP(tvb, offset, pinfo, tree, hf_rnsap_tdd);
}



static int
dissect_rnsap_NULL(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_null(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_not_Used_sSDT_CellIdLength(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_sSDT_CellIdLength);
}
static int dissect_not_Used_s_FieldLength(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_s_FieldLength);
}
static int dissect_not_Used_sSDT_CellID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_sSDT_CellID);
}
static int dissect_not_Used_secondary_CCPCH_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_secondary_CCPCH_Info);
}
static int dissect_not_Used_dSCHInformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_dSCHInformationResponse);
}
static int dissect_not_Used_dSCH_InformationResponse_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_dSCH_InformationResponse_RL_SetupFailureFDD);
}
static int dissect_not_Used_sSDT_CellIDLength(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_sSDT_CellIDLength);
}
static int dissect_not_Used_sSDT_Indication(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_sSDT_Indication);
}
static int dissect_not_Used_sSDT_CellIdentity(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_sSDT_CellIdentity);
}
static int dissect_not_Used_dSCHsToBeAddedOrModified(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_dSCHsToBeAddedOrModified);
}
static int dissect_all_contexts(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_all_contexts);
}
static int dissect_measurementnotAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_measurementnotAvailable);
}
static int dissect_separate_indication(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_separate_indication);
}
static int dissect_unsynchronised(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_unsynchronised);
}
static int dissect_e_DCH_Scheduled_Transmission_Grant(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_e_DCH_Scheduled_Transmission_Grant);
}
static int dissect_e_DCH_Serving_RL_not_in_this_DRNS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_e_DCH_Serving_RL_not_in_this_DRNS);
}
static int dissect_not_Used_dRACControl(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_dRACControl);
}
static int dissect_noBadSatellite(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_noBadSatellite);
}
static int dissect_onDemand(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_onDemand);
}
static int dissect_defaultMidamble(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_defaultMidamble);
}
static int dissect_commonMidamble(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_commonMidamble);
}
static int dissect_not_used_closedLoopMode2_SupportIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_used_closedLoopMode2_SupportIndicator);
}
static int dissect_secondary_CPICH_shall_not_be_used(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_secondary_CPICH_shall_not_be_used);
}
static int dissect_not_Used_split_in_TFCI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_not_Used_split_in_TFCI);
}
static int dissect_notApplicable(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NULL(tvb, offset, pinfo, tree, hf_rnsap_notApplicable);
}


static const value_string rnsap_TransportFormatSet_ModeDP_vals[] = {
  {   0, "tdd" },
  {   1, "notApplicable" },
  { 0, NULL }
};

static const per_choice_t TransportFormatSet_ModeDP_choice[] = {
  {   0, "tdd"                         , ASN1_EXTENSION_ROOT    , dissect_tdd },
  {   1, "notApplicable"               , ASN1_EXTENSION_ROOT    , dissect_notApplicable },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_TransportFormatSet_ModeDP(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_TransportFormatSet_ModeDP, TransportFormatSet_ModeDP_choice,
                                 NULL);

  return offset;
}
static int dissect_mode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatSet_ModeDP(tvb, offset, pinfo, tree, hf_rnsap_mode);
}


static const per_sequence_t TransportFormatSet_DynamicPartList_item_sequence[] = {
  { "nrOfTransportBlocks"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_nrOfTransportBlocks },
  { "transportBlockSize"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportBlockSize },
  { "mode"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TransportFormatSet_DynamicPartList_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TransportFormatSet_DynamicPartList_item, TransportFormatSet_DynamicPartList_item_sequence);

  return offset;
}
static int dissect_TransportFormatSet_DynamicPartList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatSet_DynamicPartList_item(tvb, offset, pinfo, tree, hf_rnsap_TransportFormatSet_DynamicPartList_item);
}


static const per_sequence_t TransportFormatSet_DynamicPartList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TransportFormatSet_DynamicPartList_item },
};

static int
dissect_rnsap_TransportFormatSet_DynamicPartList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TransportFormatSet_DynamicPartList, TransportFormatSet_DynamicPartList_sequence_of,
                                                  1, 32);

  return offset;
}
static int dissect_dynamicParts(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatSet_DynamicPartList(tvb, offset, pinfo, tree, hf_rnsap_dynamicParts);
}


static const value_string rnsap_TransmissionTimeIntervalSemiStatic_vals[] = {
  {   0, "msec-10" },
  {   1, "msec-20" },
  {   2, "msec-40" },
  {   3, "msec-80" },
  {   4, "dynamic" },
  { 0, NULL }
};


static int
dissect_rnsap_TransmissionTimeIntervalSemiStatic(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 4, NULL, NULL, TRUE);

  return offset;
}
static int dissect_transmissionTime(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransmissionTimeIntervalSemiStatic(tvb, offset, pinfo, tree, hf_rnsap_transmissionTime);
}


static const value_string rnsap_ChannelCodingType_vals[] = {
  {   0, "no-codingTDD" },
  {   1, "convolutional-coding" },
  {   2, "turbo-coding" },
  { 0, NULL }
};


static int
dissect_rnsap_ChannelCodingType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_channelCoding(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ChannelCodingType(tvb, offset, pinfo, tree, hf_rnsap_channelCoding);
}


static const value_string rnsap_CodingRate_vals[] = {
  {   0, "half" },
  {   1, "third" },
  { 0, NULL }
};


static int
dissect_rnsap_CodingRate(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_codingRate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CodingRate(tvb, offset, pinfo, tree, hf_rnsap_codingRate);
}



static int
dissect_rnsap_RateMatchingAttribute(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 256U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_rateMatcingAttribute(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RateMatchingAttribute(tvb, offset, pinfo, tree, hf_rnsap_rateMatcingAttribute);
}


static const value_string rnsap_CRC_Size_vals[] = {
  {   0, "v0" },
  {   1, "v8" },
  {   2, "v12" },
  {   3, "v16" },
  {   4, "v24" },
  { 0, NULL }
};


static int
dissect_rnsap_CRC_Size(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 4, NULL, NULL, TRUE);

  return offset;
}
static int dissect_cRC_Size(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CRC_Size(tvb, offset, pinfo, tree, hf_rnsap_cRC_Size);
}


static const value_string rnsap_SecondInterleavingMode_vals[] = {
  {   0, "frame-related" },
  {   1, "timeslot-related" },
  { 0, NULL }
};


static int
dissect_rnsap_SecondInterleavingMode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_tdd1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SecondInterleavingMode(tvb, offset, pinfo, tree, hf_rnsap_tdd1);
}


static const value_string rnsap_TransportFormatSet_ModeSSP_vals[] = {
  {   0, "tdd" },
  {   1, "notApplicable" },
  { 0, NULL }
};

static const per_choice_t TransportFormatSet_ModeSSP_choice[] = {
  {   0, "tdd"                         , ASN1_EXTENSION_ROOT    , dissect_tdd1 },
  {   1, "notApplicable"               , ASN1_EXTENSION_ROOT    , dissect_notApplicable },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_TransportFormatSet_ModeSSP(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_TransportFormatSet_ModeSSP, TransportFormatSet_ModeSSP_choice,
                                 NULL);

  return offset;
}
static int dissect_mode1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatSet_ModeSSP(tvb, offset, pinfo, tree, hf_rnsap_mode1);
}


static const per_sequence_t TransportFormatSet_Semi_staticPart_sequence[] = {
  { "transmissionTime"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transmissionTime },
  { "channelCoding"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_channelCoding },
  { "codingRate"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_codingRate },
  { "rateMatcingAttribute"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rateMatcingAttribute },
  { "cRC-Size"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cRC_Size },
  { "mode"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mode1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TransportFormatSet_Semi_staticPart(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TransportFormatSet_Semi_staticPart, TransportFormatSet_Semi_staticPart_sequence);

  return offset;
}
static int dissect_semi_staticPart(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatSet_Semi_staticPart(tvb, offset, pinfo, tree, hf_rnsap_semi_staticPart);
}


static const per_sequence_t TransportFormatSet_sequence[] = {
  { "dynamicParts"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dynamicParts },
  { "semi-staticPart"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_semi_staticPart },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TransportFormatSet(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TransportFormatSet, TransportFormatSet_sequence);

  return offset;
}
static int dissect_transportFormatSet(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatSet(tvb, offset, pinfo, tree, hf_rnsap_transportFormatSet);
}
static int dissect_ul_transportFormatSet(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatSet(tvb, offset, pinfo, tree, hf_rnsap_ul_transportFormatSet);
}
static int dissect_dl_transportFormatSet(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatSet(tvb, offset, pinfo, tree, hf_rnsap_dl_transportFormatSet);
}
static int dissect_ul_TransportformatSet(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatSet(tvb, offset, pinfo, tree, hf_rnsap_ul_TransportformatSet);
}
static int dissect_dl_TransportformatSet(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatSet(tvb, offset, pinfo, tree, hf_rnsap_dl_TransportformatSet);
}



static int
dissect_rnsap_BLER(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -63, 0U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_bLER(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BLER(tvb, offset, pinfo, tree, hf_rnsap_bLER);
}
static int dissect_ul_BLER(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BLER(tvb, offset, pinfo, tree, hf_rnsap_ul_BLER);
}
static int dissect_dl_BLER(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BLER(tvb, offset, pinfo, tree, hf_rnsap_dl_BLER);
}



static int
dissect_rnsap_PriorityLevel(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_priorityLevel(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityLevel(tvb, offset, pinfo, tree, hf_rnsap_priorityLevel);
}


static const value_string rnsap_Pre_emptionCapability_vals[] = {
  {   0, "shall-not-trigger-pre-emption" },
  {   1, "may-trigger-pre-emption" },
  { 0, NULL }
};


static int
dissect_rnsap_Pre_emptionCapability(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_pre_emptionCapability(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Pre_emptionCapability(tvb, offset, pinfo, tree, hf_rnsap_pre_emptionCapability);
}


static const value_string rnsap_Pre_emptionVulnerability_vals[] = {
  {   0, "not-pre-emptable" },
  {   1, "pre-emptable" },
  { 0, NULL }
};


static int
dissect_rnsap_Pre_emptionVulnerability(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_pre_emptionVulnerability(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Pre_emptionVulnerability(tvb, offset, pinfo, tree, hf_rnsap_pre_emptionVulnerability);
}


static const per_sequence_t AllocationRetentionPriority_sequence[] = {
  { "priorityLevel"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_priorityLevel },
  { "pre-emptionCapability"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pre_emptionCapability },
  { "pre-emptionVulnerability"    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pre_emptionVulnerability },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_AllocationRetentionPriority(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_AllocationRetentionPriority, AllocationRetentionPriority_sequence);

  return offset;
}
static int dissect_allocationRetentionPriority(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AllocationRetentionPriority(tvb, offset, pinfo, tree, hf_rnsap_allocationRetentionPriority);
}


static const value_string rnsap_FrameHandlingPriority_vals[] = {
  {   0, "lowest" },
  {  15, "highest" },
  { 0, NULL }
};


static int
dissect_rnsap_FrameHandlingPriority(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_frameHandlingPriority(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FrameHandlingPriority(tvb, offset, pinfo, tree, hf_rnsap_frameHandlingPriority);
}


static const value_string rnsap_QE_Selector_vals[] = {
  {   0, "selected" },
  {   1, "non-selected" },
  { 0, NULL }
};


static int
dissect_rnsap_QE_Selector(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_qE_Selector(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_QE_Selector(tvb, offset, pinfo, tree, hf_rnsap_qE_Selector);
}


static const value_string rnsap_DRACControl_vals[] = {
  {   0, "not-Used-requested" },
  {   1, "not-requested" },
  { 0, NULL }
};


static int
dissect_rnsap_DRACControl(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_dRACControl(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DRACControl(tvb, offset, pinfo, tree, hf_rnsap_dRACControl);
}


static const per_sequence_t DCH_Specific_FDD_Item_sequence[] = {
  { "dCH-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_ID },
  { "trCH-SrcStatisticsDescr"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_trCH_SrcStatisticsDescr },
  { "ul-transportFormatSet"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_transportFormatSet },
  { "dl-transportFormatSet"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_transportFormatSet },
  { "ul-BLER"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_BLER },
  { "dl-BLER"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_BLER },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_allocationRetentionPriority },
  { "frameHandlingPriority"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_frameHandlingPriority },
  { "qE-Selector"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_qE_Selector },
  { "dRACControl"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dRACControl },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_Specific_FDD_Item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_Specific_FDD_Item, DCH_Specific_FDD_Item_sequence);

  return offset;
}
static int dissect_DCH_Specific_FDD_InformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_Specific_FDD_Item(tvb, offset, pinfo, tree, hf_rnsap_DCH_Specific_FDD_InformationList_item);
}


static const per_sequence_t DCH_Specific_FDD_InformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DCH_Specific_FDD_InformationList_item },
};

static int
dissect_rnsap_DCH_Specific_FDD_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DCH_Specific_FDD_InformationList, DCH_Specific_FDD_InformationList_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_dCH_SpecificInformationList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_Specific_FDD_InformationList(tvb, offset, pinfo, tree, hf_rnsap_dCH_SpecificInformationList);
}


static const per_sequence_t DCH_FDD_InformationItem_sequence[] = {
  { "payloadCRC-PresenceIndicator", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_payloadCRC_PresenceIndicator },
  { "ul-FP-Mode"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_FP_Mode },
  { "toAWS"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_toAWS },
  { "toAWE"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_toAWE },
  { "dCH-SpecificInformationList" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_SpecificInformationList },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_FDD_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_FDD_InformationItem, DCH_FDD_InformationItem_sequence);

  return offset;
}
static int dissect_DCH_FDD_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_FDD_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_DCH_FDD_Information_item);
}


static const per_sequence_t DCH_FDD_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DCH_FDD_Information_item },
};

static int
dissect_rnsap_DCH_FDD_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DCH_FDD_Information, DCH_FDD_Information_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_id_DCHs_to_Add_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_FDD_Information(tvb, offset, pinfo, tree, hf_rnsap_id_DCHs_to_Add_FDD);
}
static int dissect_id_DCH_FDD_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_FDD_Information(tvb, offset, pinfo, tree, hf_rnsap_id_DCH_FDD_Information);
}



static int
dissect_rnsap_CCTrCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_cCTrCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_ID(tvb, offset, pinfo, tree, hf_rnsap_cCTrCH_ID);
}
static int dissect_dl_ccTrCHID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_ID(tvb, offset, pinfo, tree, hf_rnsap_dl_ccTrCHID);
}
static int dissect_ul_ccTrCHID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_ID(tvb, offset, pinfo, tree, hf_rnsap_ul_ccTrCHID);
}
static int dissect_ul_cCTrCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_ID(tvb, offset, pinfo, tree, hf_rnsap_ul_cCTrCH_ID);
}
static int dissect_dl_cCTrCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_ID(tvb, offset, pinfo, tree, hf_rnsap_dl_cCTrCH_ID);
}
static int dissect_ul_CCTrCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_ID(tvb, offset, pinfo, tree, hf_rnsap_ul_CCTrCH_ID);
}
static int dissect_dl_CCTrCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_ID(tvb, offset, pinfo, tree, hf_rnsap_dl_CCTrCH_ID);
}


static const per_sequence_t DCH_Specific_TDD_Item_sequence[] = {
  { "dCH-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_ID },
  { "ul-cCTrCH-ID"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_cCTrCH_ID },
  { "dl-cCTrCH-ID"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_cCTrCH_ID },
  { "trCH-SrcStatisticsDescr"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_trCH_SrcStatisticsDescr },
  { "ul-transportFormatSet"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_transportFormatSet },
  { "dl-transportFormatSet"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_transportFormatSet },
  { "ul-BLER"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_BLER },
  { "dl-BLER"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_BLER },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_allocationRetentionPriority },
  { "frameHandlingPriority"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_frameHandlingPriority },
  { "qE-Selector"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_qE_Selector },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_Specific_TDD_Item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_Specific_TDD_Item, DCH_Specific_TDD_Item_sequence);

  return offset;
}
static int dissect_DCH_Specific_TDD_InformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_Specific_TDD_Item(tvb, offset, pinfo, tree, hf_rnsap_DCH_Specific_TDD_InformationList_item);
}


static const per_sequence_t DCH_Specific_TDD_InformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DCH_Specific_TDD_InformationList_item },
};

static int
dissect_rnsap_DCH_Specific_TDD_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DCH_Specific_TDD_InformationList, DCH_Specific_TDD_InformationList_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_dCH_SpecificInformationList1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_Specific_TDD_InformationList(tvb, offset, pinfo, tree, hf_rnsap_dCH_SpecificInformationList1);
}


static const per_sequence_t DCH_TDD_InformationItem_sequence[] = {
  { "payloadCRC-PresenceIndicator", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_payloadCRC_PresenceIndicator },
  { "ul-FP-Mode"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_FP_Mode },
  { "toAWS"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_toAWS },
  { "toAWE"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_toAWE },
  { "dCH-SpecificInformationList" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_SpecificInformationList1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_TDD_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_TDD_InformationItem, DCH_TDD_InformationItem_sequence);

  return offset;
}
static int dissect_DCH_TDD_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_TDD_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_DCH_TDD_Information_item);
}


static const per_sequence_t DCH_TDD_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DCH_TDD_Information_item },
};

static int
dissect_rnsap_DCH_TDD_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DCH_TDD_Information, DCH_TDD_Information_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_id_DCHs_to_Add_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_TDD_Information(tvb, offset, pinfo, tree, hf_rnsap_id_DCHs_to_Add_TDD);
}
static int dissect_id_DCH_TDD_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_TDD_Information(tvb, offset, pinfo, tree, hf_rnsap_id_DCH_TDD_Information);
}


static const per_sequence_t DCH_DeleteItem_RL_ReconfPrepFDD_sequence[] = {
  { "dCH-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_DeleteItem_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_DeleteItem_RL_ReconfPrepFDD, DCH_DeleteItem_RL_ReconfPrepFDD_sequence);

  return offset;
}
static int dissect_DCH_DeleteList_RL_ReconfPrepFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_DeleteItem_RL_ReconfPrepFDD(tvb, offset, pinfo, tree, hf_rnsap_DCH_DeleteList_RL_ReconfPrepFDD_item);
}


static const per_sequence_t DCH_DeleteList_RL_ReconfPrepFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DCH_DeleteList_RL_ReconfPrepFDD_item },
};

static int
dissect_rnsap_DCH_DeleteList_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DCH_DeleteList_RL_ReconfPrepFDD, DCH_DeleteList_RL_ReconfPrepFDD_sequence_of,
                                                  0, 128);

  return offset;
}
static int dissect_id_DCH_DeleteList_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_DeleteList_RL_ReconfPrepFDD(tvb, offset, pinfo, tree, hf_rnsap_id_DCH_DeleteList_RL_ReconfPrepFDD);
}


static const per_sequence_t DCH_DeleteItem_RL_ReconfPrepTDD_sequence[] = {
  { "dCH-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_DeleteItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_DeleteItem_RL_ReconfPrepTDD, DCH_DeleteItem_RL_ReconfPrepTDD_sequence);

  return offset;
}
static int dissect_DCH_DeleteList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_DeleteItem_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_DCH_DeleteList_RL_ReconfPrepTDD_item);
}


static const per_sequence_t DCH_DeleteList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DCH_DeleteList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_DCH_DeleteList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DCH_DeleteList_RL_ReconfPrepTDD, DCH_DeleteList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 128);

  return offset;
}
static int dissect_id_DCH_DeleteList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_DeleteList_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DCH_DeleteList_RL_ReconfPrepTDD);
}


static const per_sequence_t DCH_DeleteItem_RL_ReconfRqstFDD_sequence[] = {
  { "dCH-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_DeleteItem_RL_ReconfRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_DeleteItem_RL_ReconfRqstFDD, DCH_DeleteItem_RL_ReconfRqstFDD_sequence);

  return offset;
}
static int dissect_DCH_DeleteList_RL_ReconfRqstFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_DeleteItem_RL_ReconfRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_DCH_DeleteList_RL_ReconfRqstFDD_item);
}


static const per_sequence_t DCH_DeleteList_RL_ReconfRqstFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DCH_DeleteList_RL_ReconfRqstFDD_item },
};

static int
dissect_rnsap_DCH_DeleteList_RL_ReconfRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DCH_DeleteList_RL_ReconfRqstFDD, DCH_DeleteList_RL_ReconfRqstFDD_sequence_of,
                                                  0, 128);

  return offset;
}
static int dissect_id_DCH_DeleteList_RL_ReconfRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_DeleteList_RL_ReconfRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_id_DCH_DeleteList_RL_ReconfRqstFDD);
}


static const per_sequence_t DCH_DeleteItem_RL_ReconfRqstTDD_sequence[] = {
  { "dCH-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_DeleteItem_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_DeleteItem_RL_ReconfRqstTDD, DCH_DeleteItem_RL_ReconfRqstTDD_sequence);

  return offset;
}
static int dissect_DCH_DeleteList_RL_ReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_DeleteItem_RL_ReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_DCH_DeleteList_RL_ReconfRqstTDD_item);
}


static const per_sequence_t DCH_DeleteList_RL_ReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DCH_DeleteList_RL_ReconfRqstTDD_item },
};

static int
dissect_rnsap_DCH_DeleteList_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DCH_DeleteList_RL_ReconfRqstTDD, DCH_DeleteList_RL_ReconfRqstTDD_sequence_of,
                                                  0, 128);

  return offset;
}
static int dissect_id_DCH_DeleteList_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_DeleteList_RL_ReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DCH_DeleteList_RL_ReconfRqstTDD);
}


static const value_string rnsap_TransportBearerRequestIndicator_vals[] = {
  {   0, "bearer-requested" },
  {   1, "bearer-not-requested" },
  { 0, NULL }
};


static int
dissect_rnsap_TransportBearerRequestIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_transportBearerRequestIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportBearerRequestIndicator(tvb, offset, pinfo, tree, hf_rnsap_transportBearerRequestIndicator);
}


static const per_sequence_t FDD_DCHs_to_ModifySpecificItem_sequence[] = {
  { "dCH-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_ID },
  { "ul-TransportformatSet"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_TransportformatSet },
  { "dl-TransportformatSet"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_TransportformatSet },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_allocationRetentionPriority },
  { "frameHandlingPriority"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_frameHandlingPriority },
  { "not-Used-dRACControl"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_dRACControl },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_FDD_DCHs_to_ModifySpecificItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_FDD_DCHs_to_ModifySpecificItem, FDD_DCHs_to_ModifySpecificItem_sequence);

  return offset;
}
static int dissect_FDD_DCHs_to_ModifySpecificInformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_DCHs_to_ModifySpecificItem(tvb, offset, pinfo, tree, hf_rnsap_FDD_DCHs_to_ModifySpecificInformationList_item);
}


static const per_sequence_t FDD_DCHs_to_ModifySpecificInformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_FDD_DCHs_to_ModifySpecificInformationList_item },
};

static int
dissect_rnsap_FDD_DCHs_to_ModifySpecificInformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_FDD_DCHs_to_ModifySpecificInformationList, FDD_DCHs_to_ModifySpecificInformationList_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_dCH_SpecificInformationList2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_DCHs_to_ModifySpecificInformationList(tvb, offset, pinfo, tree, hf_rnsap_dCH_SpecificInformationList2);
}


static const per_sequence_t FDD_DCHs_to_ModifyItem_sequence[] = {
  { "ul-FP-Mode"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_FP_Mode },
  { "toAWS"                       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_toAWS },
  { "toAWE"                       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_toAWE },
  { "transportBearerRequestIndicator", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportBearerRequestIndicator },
  { "dCH-SpecificInformationList" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_SpecificInformationList2 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_FDD_DCHs_to_ModifyItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_FDD_DCHs_to_ModifyItem, FDD_DCHs_to_ModifyItem_sequence);

  return offset;
}
static int dissect_FDD_DCHs_to_Modify_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_DCHs_to_ModifyItem(tvb, offset, pinfo, tree, hf_rnsap_FDD_DCHs_to_Modify_item);
}


static const per_sequence_t FDD_DCHs_to_Modify_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_FDD_DCHs_to_Modify_item },
};

static int
dissect_rnsap_FDD_DCHs_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_FDD_DCHs_to_Modify, FDD_DCHs_to_Modify_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_id_FDD_DCHs_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_DCHs_to_Modify(tvb, offset, pinfo, tree, hf_rnsap_id_FDD_DCHs_to_Modify);
}


static const per_sequence_t TDD_DCHs_to_ModifySpecificItem_sequence[] = {
  { "dCH-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_ID },
  { "ul-CCTrCH-ID"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_CCTrCH_ID },
  { "dl-CCTrCH-ID"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_CCTrCH_ID },
  { "ul-TransportformatSet"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_TransportformatSet },
  { "dl-TransportformatSet"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_TransportformatSet },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_allocationRetentionPriority },
  { "frameHandlingPriority"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_frameHandlingPriority },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_DCHs_to_ModifySpecificItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_DCHs_to_ModifySpecificItem, TDD_DCHs_to_ModifySpecificItem_sequence);

  return offset;
}
static int dissect_TDD_DCHs_to_ModifySpecificInformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DCHs_to_ModifySpecificItem(tvb, offset, pinfo, tree, hf_rnsap_TDD_DCHs_to_ModifySpecificInformationList_item);
}


static const per_sequence_t TDD_DCHs_to_ModifySpecificInformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TDD_DCHs_to_ModifySpecificInformationList_item },
};

static int
dissect_rnsap_TDD_DCHs_to_ModifySpecificInformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TDD_DCHs_to_ModifySpecificInformationList, TDD_DCHs_to_ModifySpecificInformationList_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_dCH_SpecificInformationList3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DCHs_to_ModifySpecificInformationList(tvb, offset, pinfo, tree, hf_rnsap_dCH_SpecificInformationList3);
}


static const per_sequence_t TDD_DCHs_to_ModifyItem_sequence[] = {
  { "ul-FP-Mode"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_FP_Mode },
  { "toAWS"                       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_toAWS },
  { "toAWE"                       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_toAWE },
  { "transportBearerRequestIndicator", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportBearerRequestIndicator },
  { "dCH-SpecificInformationList" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_SpecificInformationList3 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_DCHs_to_ModifyItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_DCHs_to_ModifyItem, TDD_DCHs_to_ModifyItem_sequence);

  return offset;
}
static int dissect_TDD_DCHs_to_Modify_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DCHs_to_ModifyItem(tvb, offset, pinfo, tree, hf_rnsap_TDD_DCHs_to_Modify_item);
}


static const per_sequence_t TDD_DCHs_to_Modify_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TDD_DCHs_to_Modify_item },
};

static int
dissect_rnsap_TDD_DCHs_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TDD_DCHs_to_Modify, TDD_DCHs_to_Modify_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_id_TDD_DCHs_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DCHs_to_Modify(tvb, offset, pinfo, tree, hf_rnsap_id_TDD_DCHs_to_Modify);
}



static int
dissect_rnsap_TransportLayerAddress(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     1, 160, TRUE);

  return offset;
}
static int dissect_transportLayerAddress(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportLayerAddress(tvb, offset, pinfo, tree, hf_rnsap_transportLayerAddress);
}


static const per_sequence_t DCH_InformationResponseItem_sequence[] = {
  { "dCH-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_ID },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_InformationResponseItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_InformationResponseItem, DCH_InformationResponseItem_sequence);

  return offset;
}
static int dissect_DCH_InformationResponse_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_InformationResponseItem(tvb, offset, pinfo, tree, hf_rnsap_DCH_InformationResponse_item);
}


static const per_sequence_t DCH_InformationResponse_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DCH_InformationResponse_item },
};

static int
dissect_rnsap_DCH_InformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DCH_InformationResponse, DCH_InformationResponse_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_id_DCH_InformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_InformationResponse(tvb, offset, pinfo, tree, hf_rnsap_id_DCH_InformationResponse);
}
static int dissect_dCH_InformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_InformationResponse(tvb, offset, pinfo, tree, hf_rnsap_dCH_InformationResponse);
}


static const per_sequence_t DCH_Rate_InformationItem_RL_CongestInd_sequence[] = {
  { "dCH-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_ID },
  { "allowed-Rate-Information"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_allowed_Rate_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_Rate_InformationItem_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_Rate_InformationItem_RL_CongestInd, DCH_Rate_InformationItem_RL_CongestInd_sequence);

  return offset;
}
static int dissect_id_DCH_Rate_InformationItem_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_Rate_InformationItem_RL_CongestInd(tvb, offset, pinfo, tree, hf_rnsap_id_DCH_Rate_InformationItem_RL_CongestInd);
}



static int
dissect_rnsap_INTEGER_0_3(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 3U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_uplinkNRTLoadInformationValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_3(tvb, offset, pinfo, tree, hf_rnsap_uplinkNRTLoadInformationValue);
}
static int dissect_downlinkNRTLoadInformationValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_3(tvb, offset, pinfo, tree, hf_rnsap_downlinkNRTLoadInformationValue);
}
static int dissect_ctfc2bit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_3(tvb, offset, pinfo, tree, hf_rnsap_ctfc2bit);
}



static int
dissect_rnsap_INTEGER_0_15(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_burstStart(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_15(tvb, offset, pinfo, tree, hf_rnsap_burstStart);
}
static int dissect_ctfc4bit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_15(tvb, offset, pinfo, tree, hf_rnsap_ctfc4bit);
}



static int
dissect_rnsap_INTEGER_0_63(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 63U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_noinitialOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_63(tvb, offset, pinfo, tree, hf_rnsap_noinitialOffset);
}
static int dissect_ctfc6bit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_63(tvb, offset, pinfo, tree, hf_rnsap_ctfc6bit);
}



static int
dissect_rnsap_INTEGER_0_255(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_t_RLFAILURE(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_255(tvb, offset, pinfo, tree, hf_rnsap_t_RLFAILURE);
}
static int dissect_initialOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_255(tvb, offset, pinfo, tree, hf_rnsap_initialOffset);
}
static int dissect_ctfc8bit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_255(tvb, offset, pinfo, tree, hf_rnsap_ctfc8bit);
}



static int
dissect_rnsap_INTEGER_0_4095(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 4095U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ctfc12bit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_4095(tvb, offset, pinfo, tree, hf_rnsap_ctfc12bit);
}



static int
dissect_rnsap_INTEGER_0_16777215(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 16777215U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ctfcmaxbit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_16777215(tvb, offset, pinfo, tree, hf_rnsap_ctfcmaxbit);
}


static const value_string rnsap_TFCS_CTFC_vals[] = {
  {   0, "ctfc2bit" },
  {   1, "ctfc4bit" },
  {   2, "ctfc6bit" },
  {   3, "ctfc8bit" },
  {   4, "ctfc12bit" },
  {   5, "ctfc16bit" },
  {   6, "ctfcmaxbit" },
  { 0, NULL }
};

static const per_choice_t TFCS_CTFC_choice[] = {
  {   0, "ctfc2bit"                    , ASN1_NO_EXTENSIONS     , dissect_ctfc2bit },
  {   1, "ctfc4bit"                    , ASN1_NO_EXTENSIONS     , dissect_ctfc4bit },
  {   2, "ctfc6bit"                    , ASN1_NO_EXTENSIONS     , dissect_ctfc6bit },
  {   3, "ctfc8bit"                    , ASN1_NO_EXTENSIONS     , dissect_ctfc8bit },
  {   4, "ctfc12bit"                   , ASN1_NO_EXTENSIONS     , dissect_ctfc12bit },
  {   5, "ctfc16bit"                   , ASN1_NO_EXTENSIONS     , dissect_ctfc16bit },
  {   6, "ctfcmaxbit"                  , ASN1_NO_EXTENSIONS     , dissect_ctfcmaxbit },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_TFCS_CTFC(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_TFCS_CTFC, TFCS_CTFC_choice,
                                 NULL);

  return offset;
}
static int dissect_cTFC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TFCS_CTFC(tvb, offset, pinfo, tree, hf_rnsap_cTFC);
}



static int
dissect_rnsap_BetaCD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_betaC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BetaCD(tvb, offset, pinfo, tree, hf_rnsap_betaC);
}
static int dissect_betaD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BetaCD(tvb, offset, pinfo, tree, hf_rnsap_betaD);
}



static int
dissect_rnsap_RefTFCNumber(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_refTFCNumber(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RefTFCNumber(tvb, offset, pinfo, tree, hf_rnsap_refTFCNumber);
}


static const per_sequence_t T_signalledGainFactors_sequence[] = {
  { "betaC"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_betaC },
  { "betaD"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_betaD },
  { "refTFCNumber"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_refTFCNumber },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_T_signalledGainFactors(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_T_signalledGainFactors, T_signalledGainFactors_sequence);

  return offset;
}
static int dissect_signalledGainFactors(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_signalledGainFactors(tvb, offset, pinfo, tree, hf_rnsap_signalledGainFactors);
}


static const value_string rnsap_TransportFormatCombination_Beta_vals[] = {
  {   0, "signalledGainFactors" },
  {   1, "refTFCNumber" },
  { 0, NULL }
};

static const per_choice_t TransportFormatCombination_Beta_choice[] = {
  {   0, "signalledGainFactors"        , ASN1_EXTENSION_ROOT    , dissect_signalledGainFactors },
  {   1, "refTFCNumber"                , ASN1_EXTENSION_ROOT    , dissect_refTFCNumber },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_TransportFormatCombination_Beta(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_TransportFormatCombination_Beta, TransportFormatCombination_Beta_choice,
                                 NULL);

  return offset;
}
static int dissect_tFC_Beta(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatCombination_Beta(tvb, offset, pinfo, tree, hf_rnsap_tFC_Beta);
}


static const per_sequence_t TFCS_TFCSList_item_sequence[] = {
  { "cTFC"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cTFC },
  { "tFC-Beta"                    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFC_Beta },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TFCS_TFCSList_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TFCS_TFCSList_item, TFCS_TFCSList_item_sequence);

  return offset;
}
static int dissect_TFCS_TFCSList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TFCS_TFCSList_item(tvb, offset, pinfo, tree, hf_rnsap_TFCS_TFCSList_item);
}


static const per_sequence_t TFCS_TFCSList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TFCS_TFCSList_item },
};

static int
dissect_rnsap_TFCS_TFCSList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TFCS_TFCSList, TFCS_TFCSList_sequence_of,
                                                  1, 1024);

  return offset;
}
static int dissect_no_Split_in_TFCI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TFCS_TFCSList(tvb, offset, pinfo, tree, hf_rnsap_no_Split_in_TFCI);
}


static const value_string rnsap_T_tFCSvalues_vals[] = {
  {   0, "no-Split-in-TFCI" },
  {   1, "not-Used-split-in-TFCI" },
  { 0, NULL }
};

static const per_choice_t T_tFCSvalues_choice[] = {
  {   0, "no-Split-in-TFCI"            , ASN1_EXTENSION_ROOT    , dissect_no_Split_in_TFCI },
  {   1, "not-Used-split-in-TFCI"      , ASN1_EXTENSION_ROOT    , dissect_not_Used_split_in_TFCI },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_T_tFCSvalues(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_T_tFCSvalues, T_tFCSvalues_choice,
                                 NULL);

  return offset;
}
static int dissect_tFCSvalues(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_tFCSvalues(tvb, offset, pinfo, tree, hf_rnsap_tFCSvalues);
}


static const per_sequence_t TFCS_sequence[] = {
  { "tFCSvalues"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCSvalues },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TFCS(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TFCS, TFCS_sequence);

  return offset;
}
static int dissect_ul_TFCS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TFCS(tvb, offset, pinfo, tree, hf_rnsap_ul_TFCS);
}
static int dissect_tFCS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TFCS(tvb, offset, pinfo, tree, hf_rnsap_tFCS);
}
static int dissect_dl_TFCS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TFCS(tvb, offset, pinfo, tree, hf_rnsap_dl_TFCS);
}


static const value_string rnsap_TFCI_Coding_vals[] = {
  {   0, "v4" },
  {   1, "v8" },
  {   2, "v16" },
  {   3, "v32" },
  { 0, NULL }
};


static int
dissect_rnsap_TFCI_Coding(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 3, NULL, NULL, TRUE);

  return offset;
}
static int dissect_tFCI_Coding(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TFCI_Coding(tvb, offset, pinfo, tree, hf_rnsap_tFCI_Coding);
}



static int
dissect_rnsap_PunctureLimit(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ul_PunctureLimit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PunctureLimit(tvb, offset, pinfo, tree, hf_rnsap_ul_PunctureLimit);
}
static int dissect_dl_PunctureLimit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PunctureLimit(tvb, offset, pinfo, tree, hf_rnsap_dl_PunctureLimit);
}
static int dissect_punctureLimit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PunctureLimit(tvb, offset, pinfo, tree, hf_rnsap_punctureLimit);
}


static const per_sequence_t CCTrCH_TPCAddItem_RL_ReconfPrepTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CCTrCH_TPCAddItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CCTrCH_TPCAddItem_RL_ReconfPrepTDD, CCTrCH_TPCAddItem_RL_ReconfPrepTDD_sequence);

  return offset;
}
static int dissect_CCTrCH_TPCAddList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_TPCAddItem_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_CCTrCH_TPCAddList_RL_ReconfPrepTDD_item);
}


static const per_sequence_t CCTrCH_TPCAddList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_CCTrCH_TPCAddList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_CCTrCH_TPCAddList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_CCTrCH_TPCAddList_RL_ReconfPrepTDD, CCTrCH_TPCAddList_RL_ReconfPrepTDD_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_cCTrCH_TPCList1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_TPCAddList_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_cCTrCH_TPCList1);
}


static const per_sequence_t DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCS },
  { "tFCI-Coding"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Coding },
  { "punctureLimit"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_punctureLimit },
  { "cCTrCH-TPCList"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cCTrCH_TPCList1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD, DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_sequence);

  return offset;
}
static int dissect_id_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD);
}



static int
dissect_rnsap_ProtocolIE_Single_Container(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Field(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_RL_InformationList_RL_SetupRqstFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_RL_SetupRqstFDD_item);
}
static int dissect_UL_CCTrCH_InformationList_RL_SetupRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCH_InformationList_RL_SetupRqstTDD_item);
}
static int dissect_DL_CCTrCH_InformationList_RL_SetupRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_InformationList_RL_SetupRqstTDD_item);
}
static int dissect_RL_InformationResponseList_RL_SetupRspFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationResponseList_RL_SetupRspFDD_item);
}
static int dissect_UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item);
}
static int dissect_SuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_SuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item);
}
static int dissect_RL_InformationList_RL_AdditionRqstFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_RL_AdditionRqstFDD_item);
}
static int dissect_UL_CCTrCH_InformationList_RL_AdditionRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCH_InformationList_RL_AdditionRqstTDD_item);
}
static int dissect_DL_CCTrCH_InformationList_RL_AdditionRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_InformationList_RL_AdditionRqstTDD_item);
}
static int dissect_RL_InformationResponseList_RL_AdditionRspFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationResponseList_RL_AdditionRspFDD_item);
}
static int dissect_UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item);
}
static int dissect_SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item);
}
static int dissect_RL_InformationList_RL_DeletionRqst_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_RL_DeletionRqst_item);
}
static int dissect_RL_InformationList_RL_ReconfPrepFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_RL_ReconfPrepFDD_item);
}
static int dissect_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item);
}
static int dissect_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item);
}
static int dissect_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item);
}
static int dissect_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item);
}
static int dissect_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item);
}
static int dissect_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item);
}
static int dissect_RL_InformationResponseList_RL_ReconfReadyFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationResponseList_RL_ReconfReadyFDD_item);
}
static int dissect_RL_ReconfigurationFailureList_RL_ReconfFailure_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_ReconfigurationFailureList_RL_ReconfFailure_item);
}
static int dissect_RL_ReconfigurationRequestFDD_RL_InformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_ReconfigurationRequestFDD_RL_InformationList_item);
}
static int dissect_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item);
}
static int dissect_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item);
}
static int dissect_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item);
}
static int dissect_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item);
}
static int dissect_RL_InformationResponseList_RL_ReconfRspFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationResponseList_RL_ReconfRspFDD_item);
}
static int dissect_RL_InformationList_RL_FailureInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_RL_FailureInd_item);
}
static int dissect_RL_Set_InformationList_RL_FailureInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Set_InformationList_RL_FailureInd_item);
}
static int dissect_CCTrCH_InformationList_RL_FailureInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_CCTrCH_InformationList_RL_FailureInd_item);
}
static int dissect_RL_InformationList_RL_PreemptRequiredInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_RL_PreemptRequiredInd_item);
}
static int dissect_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd_item);
}
static int dissect_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd_item);
}
static int dissect_RL_InformationList_RL_RestoreInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_RL_RestoreInd_item);
}
static int dissect_RL_Set_InformationList_RL_RestoreInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Set_InformationList_RL_RestoreInd_item);
}
static int dissect_CCTrCH_InformationList_RL_RestoreInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_CCTrCH_InformationList_RL_RestoreInd_item);
}
static int dissect_DL_ReferencePowerInformationList_DL_PC_Rqst_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DL_ReferencePowerInformationList_DL_PC_Rqst_item);
}
static int dissect_RL_InformationList_RL_CongestInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_RL_CongestInd_item);
}
static int dissect_DCH_Rate_Information_RL_CongestInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DCH_Rate_Information_RL_CongestInd_item);
}
static int dissect_EDCH_MacdFlowSpecificInformationList_RL_CongestInd_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_EDCH_MacdFlowSpecificInformationList_RL_CongestInd_item);
}
static int dissect_RL_InformationList_DM_Rqst_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_DM_Rqst_item);
}
static int dissect_RL_Set_InformationList_DM_Rqst_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Set_InformationList_DM_Rqst_item);
}
static int dissect_RL_InformationList_DM_Rsp_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_DM_Rsp_item);
}
static int dissect_RL_Set_InformationList_DM_Rsp_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Set_InformationList_DM_Rsp_item);
}
static int dissect_RL_Unsuccessful_InformationRespList_DM_Fail_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_item);
}
static int dissect_RL_Successful_InformationRespList_DM_Fail_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Successful_InformationRespList_DM_Fail_item);
}
static int dissect_RL_Set_Unsuccessful_InformationRespList_DM_Fail_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_item);
}
static int dissect_RL_Set_Successful_InformationRespList_DM_Fail_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Set_Successful_InformationRespList_DM_Fail_item);
}
static int dissect_RL_InformationList_DM_Rprt_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_InformationList_DM_Rprt_item);
}
static int dissect_RL_Set_InformationList_DM_Rprt_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Set_InformationList_DM_Rprt_item);
}
static int dissect_RL_Unsuccessful_InformationRespList_DM_Fail_Ind_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_Ind_item);
}
static int dissect_RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind_item);
}
static int dissect_ContextInfoList_Reset_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_ContextInfoList_Reset_item);
}
static int dissect_ContextGroupInfoList_Reset_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_ContextGroupInfoList_Reset_item);
}
static int dissect_DelayedActivationInformationList_RL_ActivationCmdFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DelayedActivationInformationList_RL_ActivationCmdFDD_item);
}
static int dissect_DelayedActivationInformationList_RL_ActivationCmdTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_DelayedActivationInformationList_RL_ActivationCmdTDD_item);
}
static int dissect_RL_ParameterUpdateIndicationFDD_RL_InformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_RL_ParameterUpdateIndicationFDD_RL_InformationList_item);
}
static int dissect_ListOfInterfacesToTrace_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_ListOfInterfacesToTrace_item);
}
static int dissect_Neighbouring_UMTS_CellInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_rnsap_Neighbouring_UMTS_CellInformation_item);
}



static int
dissect_rnsap_DL_DPCH_InformationAddList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_DPCH_AddInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationAddList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_DPCH_AddInformation);
}



static int
dissect_rnsap_DL_DPCH_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_DPCH_ModifyInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationModifyList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_DPCH_ModifyInformation);
}



static int
dissect_rnsap_DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_DPCH_DeleteInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_DPCH_DeleteInformation);
}


static const per_sequence_t DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "dl-DPCH-AddInformation"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_DPCH_AddInformation },
  { "dl-DPCH-ModifyInformation"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_DPCH_ModifyInformation },
  { "dl-DPCH-DeleteInformation"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_DPCH_DeleteInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_InformationItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_InformationItem_RL_ReconfReadyTDD, DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_DL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item);
}


static const per_sequence_t DL_CCTrCHInformationListIE_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_DL_CCTrCHInformationListIE_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCHInformationListIE_RL_ReconfReadyTDD, DL_CCTrCHInformationListIE_RL_ReconfReadyTDD_sequence_of,
                                                  0, 16);

  return offset;
}
static int dissect_id_DL_CCTrCH_InformationListIE_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCHInformationListIE_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_CCTrCH_InformationListIE_RL_ReconfReadyTDD);
}


static const per_sequence_t DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD, DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_sequence);

  return offset;
}
static int dissect_id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD);
}


static const value_string rnsap_TDD_TPC_DownlinkStepSize_vals[] = {
  {   0, "step-size1" },
  {   1, "step-size2" },
  {   2, "step-size3" },
  { 0, NULL }
};


static int
dissect_rnsap_TDD_TPC_DownlinkStepSize(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_tdd_TPC_DownlinkStepSize(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_TPC_DownlinkStepSize(tvb, offset, pinfo, tree, hf_rnsap_tdd_TPC_DownlinkStepSize);
}
static int dissect_downlinkStepSize(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_TPC_DownlinkStepSize(tvb, offset, pinfo, tree, hf_rnsap_downlinkStepSize);
}


static const per_sequence_t CCTrCH_TPCItem_RL_SetupRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CCTrCH_TPCItem_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CCTrCH_TPCItem_RL_SetupRqstTDD, CCTrCH_TPCItem_RL_SetupRqstTDD_sequence);

  return offset;
}
static int dissect_CCTrCH_TPCList_RL_SetupRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_TPCItem_RL_SetupRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_CCTrCH_TPCList_RL_SetupRqstTDD_item);
}


static const per_sequence_t CCTrCH_TPCList_RL_SetupRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_CCTrCH_TPCList_RL_SetupRqstTDD_item },
};

static int
dissect_rnsap_CCTrCH_TPCList_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_CCTrCH_TPCList_RL_SetupRqstTDD, CCTrCH_TPCList_RL_SetupRqstTDD_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_cCTrCH_TPCList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_TPCList_RL_SetupRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_cCTrCH_TPCList);
}


static const per_sequence_t DL_CCTrCH_InformationItem_RL_SetupRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "dl-TFCS"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_TFCS },
  { "tFCI-Coding"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Coding },
  { "dl-PunctureLimit"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_PunctureLimit },
  { "tdd-TPC-DownlinkStepSize"    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tdd_TPC_DownlinkStepSize },
  { "cCTrCH-TPCList"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cCTrCH_TPCList },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_InformationItem_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_InformationItem_RL_SetupRqstTDD, DL_CCTrCH_InformationItem_RL_SetupRqstTDD_sequence);

  return offset;
}
static int dissect_id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationItem_RL_SetupRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD);
}
static int dissect_id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationItem_RL_SetupRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD);
}



static int
dissect_rnsap_DL_DPCH_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_DPCH_Information2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationList_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_DPCH_Information2);
}


static const per_sequence_t DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "dl-DPCH-Information"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_DPCH_Information2 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_InformationItem_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_InformationItem_PhyChReconfRqstTDD, DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_sequence);

  return offset;
}
static int dissect_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationItem_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item);
}


static const per_sequence_t DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD, DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_id_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD);
}



static int
dissect_rnsap_DL_DPCH_InformationList_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_DPCH_Information1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationList_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_DPCH_Information1);
}


static const per_sequence_t DL_CCTrCHInformationItem_RL_AdditionRspTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "dl-DPCH-Information"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_DPCH_Information1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCHInformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCHInformationItem_RL_AdditionRspTDD, DL_CCTrCHInformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_DL_CCTrCHInformationListIE_RL_AdditionRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCHInformationItem_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCHInformationListIE_RL_AdditionRspTDD_item);
}


static const per_sequence_t DL_CCTrCHInformationListIE_RL_AdditionRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCHInformationListIE_RL_AdditionRspTDD_item },
};

static int
dissect_rnsap_DL_CCTrCHInformationListIE_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCHInformationListIE_RL_AdditionRspTDD, DL_CCTrCHInformationListIE_RL_AdditionRspTDD_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCHInformationListIE_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD);
}


static const per_sequence_t DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD, DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 16);

  return offset;
}
static int dissect_id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD);
}


static const per_sequence_t DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD, DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_sequence_of,
                                                  0, 16);

  return offset;
}
static int dissect_id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD);
}


static const per_sequence_t DL_CCTrCH_InformationList_RL_SetupRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_InformationList_RL_SetupRqstTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_InformationList_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_InformationList_RL_SetupRqstTDD, DL_CCTrCH_InformationList_RL_SetupRqstTDD_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_id_DL_CCTrCH_InformationList_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationList_RL_SetupRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_CCTrCH_InformationList_RL_SetupRqstTDD);
}



static int
dissect_rnsap_DL_ScramblingCode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_eAGCH_ERGCH_EHICH_FDD_ScramblingCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_ScramblingCode(tvb, offset, pinfo, tree, hf_rnsap_eAGCH_ERGCH_EHICH_FDD_ScramblingCode);
}
static int dissect_dl_ScramblingCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_ScramblingCode(tvb, offset, pinfo, tree, hf_rnsap_dl_ScramblingCode);
}
static int dissect_hSPDSCH_and_HSSCCH_ScramblingCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_ScramblingCode(tvb, offset, pinfo, tree, hf_rnsap_hSPDSCH_and_HSSCCH_ScramblingCode);
}



static int
dissect_rnsap_FDD_DL_ChannelisationCodeNumber(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 511U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_eAGCH_ChannelisationCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_DL_ChannelisationCodeNumber(tvb, offset, pinfo, tree, hf_rnsap_eAGCH_ChannelisationCode);
}
static int dissect_eRGCH_EHICH_ChannelisationCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_DL_ChannelisationCodeNumber(tvb, offset, pinfo, tree, hf_rnsap_eRGCH_EHICH_ChannelisationCode);
}
static int dissect_fDD_DL_ChannelisationCodeNumber(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_DL_ChannelisationCodeNumber(tvb, offset, pinfo, tree, hf_rnsap_fDD_DL_ChannelisationCodeNumber);
}


static const value_string rnsap_Transmission_Gap_Pattern_Sequence_ScramblingCode_Information_vals[] = {
  {   0, "code-change" },
  {   1, "nocode-change" },
  { 0, NULL }
};


static int
dissect_rnsap_Transmission_Gap_Pattern_Sequence_ScramblingCode_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_transmission_Gap_Pattern_Sequence_ScramblingCode_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Transmission_Gap_Pattern_Sequence_ScramblingCode_Information(tvb, offset, pinfo, tree, hf_rnsap_transmission_Gap_Pattern_Sequence_ScramblingCode_Information);
}


static const per_sequence_t FDD_DL_CodeInformationItem_sequence[] = {
  { "dl-ScramblingCode"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_ScramblingCode },
  { "fDD-DL-ChannelisationCodeNumber", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fDD_DL_ChannelisationCodeNumber },
  { "transmission-Gap-Pattern-Sequence-ScramblingCode-Information", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transmission_Gap_Pattern_Sequence_ScramblingCode_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_FDD_DL_CodeInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_FDD_DL_CodeInformationItem, FDD_DL_CodeInformationItem_sequence);

  return offset;
}
static int dissect_FDD_DL_CodeInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_DL_CodeInformationItem(tvb, offset, pinfo, tree, hf_rnsap_FDD_DL_CodeInformation_item);
}


static const per_sequence_t FDD_DL_CodeInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_FDD_DL_CodeInformation_item },
};

static int
dissect_rnsap_FDD_DL_CodeInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_FDD_DL_CodeInformation, FDD_DL_CodeInformation_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_id_FDD_DL_CodeInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_DL_CodeInformation(tvb, offset, pinfo, tree, hf_rnsap_id_FDD_DL_CodeInformation);
}
static int dissect_dl_CodeInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_DL_CodeInformation(tvb, offset, pinfo, tree, hf_rnsap_dl_CodeInformation);
}



static int
dissect_rnsap_DL_DPCH_SlotFormat(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 16U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_dl_DPCH_SlotFormat(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_SlotFormat(tvb, offset, pinfo, tree, hf_rnsap_dl_DPCH_SlotFormat);
}



static int
dissect_rnsap_NrOfDLchannelisationcodes(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 8U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_nrOfDLchannelisationcodes(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NrOfDLchannelisationcodes(tvb, offset, pinfo, tree, hf_rnsap_nrOfDLchannelisationcodes);
}


static const value_string rnsap_TFCI_SignallingMode_vals[] = {
  {   0, "normal" },
  {   1, "not-Used-split" },
  { 0, NULL }
};


static int
dissect_rnsap_TFCI_SignallingMode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tFCI_SignallingMode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TFCI_SignallingMode(tvb, offset, pinfo, tree, hf_rnsap_tFCI_SignallingMode);
}


static const value_string rnsap_TFCI_Presence_vals[] = {
  {   0, "present" },
  {   1, "not-present" },
  { 0, NULL }
};


static int
dissect_rnsap_TFCI_Presence(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tFCI_Presence(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TFCI_Presence(tvb, offset, pinfo, tree, hf_rnsap_tFCI_Presence);
}


static const value_string rnsap_MultiplexingPosition_vals[] = {
  {   0, "fixed" },
  {   1, "flexible" },
  { 0, NULL }
};


static int
dissect_rnsap_MultiplexingPosition(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_multiplexingPosition(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MultiplexingPosition(tvb, offset, pinfo, tree, hf_rnsap_multiplexingPosition);
}


static const value_string rnsap_LimitedPowerIncrease_vals[] = {
  {   0, "used" },
  {   1, "not-used" },
  { 0, NULL }
};


static int
dissect_rnsap_LimitedPowerIncrease(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_limitedPowerIncrease(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_LimitedPowerIncrease(tvb, offset, pinfo, tree, hf_rnsap_limitedPowerIncrease);
}


static const per_sequence_t DL_DPCH_Information_RL_ReconfPrepFDD_sequence[] = {
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCS },
  { "dl-DPCH-SlotFormat"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_DPCH_SlotFormat },
  { "nrOfDLchannelisationcodes"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_nrOfDLchannelisationcodes },
  { "tFCI-SignallingMode"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_SignallingMode },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Presence },
  { "multiplexingPosition"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_multiplexingPosition },
  { "limitedPowerIncrease"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_limitedPowerIncrease },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_Information_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_Information_RL_ReconfPrepFDD, DL_DPCH_Information_RL_ReconfPrepFDD_sequence);

  return offset;
}
static int dissect_id_DL_DPCH_Information_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_Information_RL_ReconfPrepFDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_DPCH_Information_RL_ReconfPrepFDD);
}



static int
dissect_rnsap_PowerOffset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 24U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_po1_ForTFCI_Bits(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerOffset(tvb, offset, pinfo, tree, hf_rnsap_po1_ForTFCI_Bits);
}
static int dissect_po2_ForTPC_Bits(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerOffset(tvb, offset, pinfo, tree, hf_rnsap_po2_ForTPC_Bits);
}
static int dissect_po3_ForPilotBits(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerOffset(tvb, offset, pinfo, tree, hf_rnsap_po3_ForPilotBits);
}
static int dissect_pO1_ForTFCI_Bits(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerOffset(tvb, offset, pinfo, tree, hf_rnsap_pO1_ForTFCI_Bits);
}
static int dissect_pO2_ForTPC_Bits(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerOffset(tvb, offset, pinfo, tree, hf_rnsap_pO2_ForTPC_Bits);
}
static int dissect_pO3_ForPilotBits(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerOffset(tvb, offset, pinfo, tree, hf_rnsap_pO3_ForPilotBits);
}


static const per_sequence_t PowerOffsetInformation_RL_SetupRqstFDD_sequence[] = {
  { "po1-ForTFCI-Bits"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_po1_ForTFCI_Bits },
  { "po2-ForTPC-Bits"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_po2_ForTPC_Bits },
  { "po3-ForPilotBits"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_po3_ForPilotBits },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PowerOffsetInformation_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PowerOffsetInformation_RL_SetupRqstFDD, PowerOffsetInformation_RL_SetupRqstFDD_sequence);

  return offset;
}
static int dissect_powerOffsetInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerOffsetInformation_RL_SetupRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_powerOffsetInformation);
}


static const value_string rnsap_FDD_TPC_DownlinkStepSize_vals[] = {
  {   0, "step-size0-5" },
  {   1, "step-size1" },
  {   2, "step-size1-5" },
  {   3, "step-size2" },
  { 0, NULL }
};


static int
dissect_rnsap_FDD_TPC_DownlinkStepSize(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 3, NULL, NULL, TRUE);

  return offset;
}
static int dissect_fdd_dl_TPC_DownlinkStepSize(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_TPC_DownlinkStepSize(tvb, offset, pinfo, tree, hf_rnsap_fdd_dl_TPC_DownlinkStepSize);
}
static int dissect_fdd_TPC_DownlinkStepSize(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FDD_TPC_DownlinkStepSize(tvb, offset, pinfo, tree, hf_rnsap_fdd_TPC_DownlinkStepSize);
}


static const value_string rnsap_InnerLoopDLPCStatus_vals[] = {
  {   0, "active" },
  {   1, "inactive" },
  { 0, NULL }
};


static int
dissect_rnsap_InnerLoopDLPCStatus(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_innerLoopDLPCStatus(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_InnerLoopDLPCStatus(tvb, offset, pinfo, tree, hf_rnsap_innerLoopDLPCStatus);
}


static const per_sequence_t DL_DPCH_Information_RL_SetupRqstFDD_sequence[] = {
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCS },
  { "dl-DPCH-SlotFormat"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_DPCH_SlotFormat },
  { "nrOfDLchannelisationcodes"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_nrOfDLchannelisationcodes },
  { "tFCI-SignallingMode"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_SignallingMode },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Presence },
  { "multiplexingPosition"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_multiplexingPosition },
  { "powerOffsetInformation"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_powerOffsetInformation },
  { "fdd-dl-TPC-DownlinkStepSize" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fdd_dl_TPC_DownlinkStepSize },
  { "limitedPowerIncrease"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_limitedPowerIncrease },
  { "innerLoopDLPCStatus"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_innerLoopDLPCStatus },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_Information_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_Information_RL_SetupRqstFDD, DL_DPCH_Information_RL_SetupRqstFDD_sequence);

  return offset;
}
static int dissect_id_DL_DPCH_Information_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_Information_RL_SetupRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_DPCH_Information_RL_SetupRqstFDD);
}


static const per_sequence_t DL_DPCH_Information_RL_ReconfRqstFDD_sequence[] = {
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCS },
  { "tFCI-SignallingMode"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_SignallingMode },
  { "limitedPowerIncrease"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_limitedPowerIncrease },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_Information_RL_ReconfRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_Information_RL_ReconfRqstFDD, DL_DPCH_Information_RL_ReconfRqstFDD_sequence);

  return offset;
}
static int dissect_id_DL_DPCH_Information_RL_ReconfRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_Information_RL_ReconfRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_DPCH_Information_RL_ReconfRqstFDD);
}


static const value_string rnsap_RepetitionPeriod_vals[] = {
  {   0, "v1" },
  {   1, "v2" },
  {   2, "v4" },
  {   3, "v8" },
  {   4, "v16" },
  {   5, "v32" },
  {   6, "v64" },
  { 0, NULL }
};


static int
dissect_rnsap_RepetitionPeriod(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 6, NULL, NULL, FALSE);

  return offset;
}
static int dissect_repetitionPeriod(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RepetitionPeriod(tvb, offset, pinfo, tree, hf_rnsap_repetitionPeriod);
}



static int
dissect_rnsap_RepetitionLength(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 63U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_repetitionLength(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RepetitionLength(tvb, offset, pinfo, tree, hf_rnsap_repetitionLength);
}


static const value_string rnsap_TDD_DPCHOffset_vals[] = {
  {   0, "initialOffset" },
  {   1, "noinitialOffset" },
  { 0, NULL }
};

static const per_choice_t TDD_DPCHOffset_choice[] = {
  {   0, "initialOffset"               , ASN1_NO_EXTENSIONS     , dissect_initialOffset },
  {   1, "noinitialOffset"             , ASN1_NO_EXTENSIONS     , dissect_noinitialOffset },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_TDD_DPCHOffset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_TDD_DPCHOffset, TDD_DPCHOffset_choice,
                                 NULL);

  return offset;
}
static int dissect_tDD_DPCHOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DPCHOffset(tvb, offset, pinfo, tree, hf_rnsap_tDD_DPCHOffset);
}



static int
dissect_rnsap_TimeSlot(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 14U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_timeSlot(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TimeSlot(tvb, offset, pinfo, tree, hf_rnsap_timeSlot);
}
static int dissect_timeslot(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TimeSlot(tvb, offset, pinfo, tree, hf_rnsap_timeslot);
}


static const value_string rnsap_MidambleConfigurationBurstType1And3_vals[] = {
  {   0, "v4" },
  {   1, "v8" },
  {   2, "v16" },
  { 0, NULL }
};


static int
dissect_rnsap_MidambleConfigurationBurstType1And3(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, FALSE);

  return offset;
}
static int dissect_midambleConfigurationBurstType1And3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MidambleConfigurationBurstType1And3(tvb, offset, pinfo, tree, hf_rnsap_midambleConfigurationBurstType1And3);
}



static int
dissect_rnsap_MidambleShiftLong(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ueSpecificMidamble(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MidambleShiftLong(tvb, offset, pinfo, tree, hf_rnsap_ueSpecificMidamble);
}
static int dissect_midambleShift(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MidambleShiftLong(tvb, offset, pinfo, tree, hf_rnsap_midambleShift);
}


static const value_string rnsap_T_midambleAllocationMode_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode_choice[] = {
  {   0, "defaultMidamble"             , ASN1_EXTENSION_ROOT    , dissect_defaultMidamble },
  {   1, "commonMidamble"              , ASN1_EXTENSION_ROOT    , dissect_commonMidamble },
  {   2, "ueSpecificMidamble"          , ASN1_EXTENSION_ROOT    , dissect_ueSpecificMidamble },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_T_midambleAllocationMode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_T_midambleAllocationMode, T_midambleAllocationMode_choice,
                                 NULL);

  return offset;
}
static int dissect_midambleAllocationMode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_midambleAllocationMode(tvb, offset, pinfo, tree, hf_rnsap_midambleAllocationMode);
}


static const per_sequence_t T_type1_sequence[] = {
  { "midambleConfigurationBurstType1And3", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleConfigurationBurstType1And3 },
  { "midambleAllocationMode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleAllocationMode },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_T_type1(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_T_type1, T_type1_sequence);

  return offset;
}
static int dissect_type1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_type1(tvb, offset, pinfo, tree, hf_rnsap_type1);
}


static const value_string rnsap_MidambleConfigurationBurstType2_vals[] = {
  {   0, "v3" },
  {   1, "v6" },
  { 0, NULL }
};


static int
dissect_rnsap_MidambleConfigurationBurstType2(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_midambleConfigurationBurstType2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MidambleConfigurationBurstType2(tvb, offset, pinfo, tree, hf_rnsap_midambleConfigurationBurstType2);
}



static int
dissect_rnsap_MidambleShiftShort(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 5U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ueSpecificMidamble1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MidambleShiftShort(tvb, offset, pinfo, tree, hf_rnsap_ueSpecificMidamble1);
}


static const value_string rnsap_T_midambleAllocationMode1_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode1_choice[] = {
  {   0, "defaultMidamble"             , ASN1_EXTENSION_ROOT    , dissect_defaultMidamble },
  {   1, "commonMidamble"              , ASN1_EXTENSION_ROOT    , dissect_commonMidamble },
  {   2, "ueSpecificMidamble"          , ASN1_EXTENSION_ROOT    , dissect_ueSpecificMidamble1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_T_midambleAllocationMode1(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_T_midambleAllocationMode1, T_midambleAllocationMode1_choice,
                                 NULL);

  return offset;
}
static int dissect_midambleAllocationMode1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_midambleAllocationMode1(tvb, offset, pinfo, tree, hf_rnsap_midambleAllocationMode1);
}


static const per_sequence_t T_type2_sequence[] = {
  { "midambleConfigurationBurstType2", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleConfigurationBurstType2 },
  { "midambleAllocationMode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleAllocationMode1 },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_T_type2(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_T_type2, T_type2_sequence);

  return offset;
}
static int dissect_type2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_type2(tvb, offset, pinfo, tree, hf_rnsap_type2);
}


static const value_string rnsap_T_midambleAllocationMode2_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "ueSpecificMidamble" },
  { 0, NULL }
};

static const per_choice_t T_midambleAllocationMode2_choice[] = {
  {   0, "defaultMidamble"             , ASN1_EXTENSION_ROOT    , dissect_defaultMidamble },
  {   1, "ueSpecificMidamble"          , ASN1_EXTENSION_ROOT    , dissect_ueSpecificMidamble },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_T_midambleAllocationMode2(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_T_midambleAllocationMode2, T_midambleAllocationMode2_choice,
                                 NULL);

  return offset;
}
static int dissect_midambleAllocationMode2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_midambleAllocationMode2(tvb, offset, pinfo, tree, hf_rnsap_midambleAllocationMode2);
}


static const per_sequence_t T_type3_sequence[] = {
  { "midambleConfigurationBurstType1And3", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleConfigurationBurstType1And3 },
  { "midambleAllocationMode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleAllocationMode2 },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_T_type3(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_T_type3, T_type3_sequence);

  return offset;
}
static int dissect_type3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_type3(tvb, offset, pinfo, tree, hf_rnsap_type3);
}


static const value_string rnsap_MidambleShiftAndBurstType_vals[] = {
  {   0, "type1" },
  {   1, "type2" },
  {   2, "type3" },
  { 0, NULL }
};

static const per_choice_t MidambleShiftAndBurstType_choice[] = {
  {   0, "type1"                       , ASN1_EXTENSION_ROOT    , dissect_type1 },
  {   1, "type2"                       , ASN1_EXTENSION_ROOT    , dissect_type2 },
  {   2, "type3"                       , ASN1_EXTENSION_ROOT    , dissect_type3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_MidambleShiftAndBurstType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_MidambleShiftAndBurstType, MidambleShiftAndBurstType_choice,
                                 NULL);

  return offset;
}
static int dissect_midambleShiftAndBurstType(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MidambleShiftAndBurstType(tvb, offset, pinfo, tree, hf_rnsap_midambleShiftAndBurstType);
}



static int
dissect_rnsap_DPCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 239U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_dPCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DPCH_ID(tvb, offset, pinfo, tree, hf_rnsap_dPCH_ID);
}


static const value_string rnsap_TDD_ChannelisationCode_vals[] = {
  {   0, "chCode1div1" },
  {   1, "chCode2div1" },
  {   2, "chCode2div2" },
  {   3, "chCode4div1" },
  {   4, "chCode4div2" },
  {   5, "chCode4div3" },
  {   6, "chCode4div4" },
  {   7, "chCode8div1" },
  {   8, "chCode8div2" },
  {   9, "chCode8div3" },
  {  10, "chCode8div4" },
  {  11, "chCode8div5" },
  {  12, "chCode8div6" },
  {  13, "chCode8div7" },
  {  14, "chCode8div8" },
  {  15, "chCode16div1" },
  {  16, "chCode16div2" },
  {  17, "chCode16div3" },
  {  18, "chCode16div4" },
  {  19, "chCode16div5" },
  {  20, "chCode16div6" },
  {  21, "chCode16div7" },
  {  22, "chCode16div8" },
  {  23, "chCode16div9" },
  {  24, "chCode16div10" },
  {  25, "chCode16div11" },
  {  26, "chCode16div12" },
  {  27, "chCode16div13" },
  {  28, "chCode16div14" },
  {  29, "chCode16div15" },
  {  30, "chCode16div16" },
  { 0, NULL }
};


static int
dissect_rnsap_TDD_ChannelisationCode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 30, NULL, NULL, TRUE);

  return offset;
}
static int dissect_tDD_ChannelisationCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_ChannelisationCode(tvb, offset, pinfo, tree, hf_rnsap_tDD_ChannelisationCode);
}
static int dissect_first_TDD_ChannelisationCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_ChannelisationCode(tvb, offset, pinfo, tree, hf_rnsap_first_TDD_ChannelisationCode);
}
static int dissect_second_TDD_ChannelisationCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_ChannelisationCode(tvb, offset, pinfo, tree, hf_rnsap_second_TDD_ChannelisationCode);
}


static const per_sequence_t TDD_DL_Code_InformationItem_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "tDD-ChannelisationCode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_ChannelisationCode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_DL_Code_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_DL_Code_InformationItem, TDD_DL_Code_InformationItem_sequence);

  return offset;
}
static int dissect_TDD_DL_Code_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DL_Code_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_TDD_DL_Code_Information_item);
}


static const per_sequence_t TDD_DL_Code_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TDD_DL_Code_Information_item },
};

static int
dissect_rnsap_TDD_DL_Code_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TDD_DL_Code_Information, TDD_DL_Code_Information_sequence_of,
                                                  1, 240);

  return offset;
}
static int dissect_dL_Code_Information1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DL_Code_Information(tvb, offset, pinfo, tree, hf_rnsap_dL_Code_Information1);
}


static const per_sequence_t DL_Timeslot_InformationItem_PhyChReconfRqstTDD_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShiftAndBurstType },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Presence },
  { "dL-Code-Information"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_Code_Information1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_Timeslot_InformationItem_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_Timeslot_InformationItem_PhyChReconfRqstTDD, DL_Timeslot_InformationItem_PhyChReconfRqstTDD_sequence);

  return offset;
}
static int dissect_DL_Timeslot_InformationList_PhyChReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Timeslot_InformationItem_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_Timeslot_InformationList_PhyChReconfRqstTDD_item);
}


static const per_sequence_t DL_Timeslot_InformationList_PhyChReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_Timeslot_InformationList_PhyChReconfRqstTDD_item },
};

static int
dissect_rnsap_DL_Timeslot_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_Timeslot_InformationList_PhyChReconfRqstTDD, DL_Timeslot_InformationList_PhyChReconfRqstTDD_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_dL_Timeslot_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Timeslot_InformationList_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_dL_Timeslot_InformationList_PhyChReconfRqstTDD);
}


static const per_sequence_t DL_DPCH_InformationItem_PhyChReconfRqstTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDD_DPCHOffset },
  { "dL-Timeslot-InformationList-PhyChReconfRqstTDD", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_Timeslot_InformationList_PhyChReconfRqstTDD },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_InformationItem_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_InformationItem_PhyChReconfRqstTDD, DL_DPCH_InformationItem_PhyChReconfRqstTDD_sequence);

  return offset;
}
static int dissect_id_DL_DPCH_InformationItem_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationItem_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_DPCH_InformationItem_PhyChReconfRqstTDD);
}


static const per_sequence_t DL_Timeslot_InformationItem_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftAndBurstType },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Presence },
  { "dL-Code-Information"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_Code_Information1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_Timeslot_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_Timeslot_InformationItem, DL_Timeslot_InformationItem_sequence);

  return offset;
}
static int dissect_DL_Timeslot_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Timeslot_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_DL_Timeslot_Information_item);
}


static const per_sequence_t DL_Timeslot_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_Timeslot_Information_item },
};

static int
dissect_rnsap_DL_Timeslot_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_Timeslot_Information, DL_Timeslot_Information_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_dL_Timeslot_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Timeslot_Information(tvb, offset, pinfo, tree, hf_rnsap_dL_Timeslot_Information);
}


static const per_sequence_t DL_DPCH_InformationItem_RL_AdditionRspTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "dL-Timeslot-Information"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_Timeslot_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_InformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_InformationItem_RL_AdditionRspTDD, DL_DPCH_InformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_id_DL_DPCH_InformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationItem_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_DPCH_InformationItem_RL_AdditionRspTDD);
}


static const per_sequence_t DL_DPCH_InformationItem_RL_SetupRspTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "dL-Timeslot-Information"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_Timeslot_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_InformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_InformationItem_RL_SetupRspTDD, DL_DPCH_InformationItem_RL_SetupRspTDD_sequence);

  return offset;
}
static int dissect_id_DL_DPCH_InformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationItem_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_id_DL_DPCH_InformationItem_RL_SetupRspTDD);
}


static const value_string rnsap_DL_DPCH_TimingAdjustment_vals[] = {
  {   0, "timing-advance" },
  {   1, "timing-delay" },
  { 0, NULL }
};


static int
dissect_rnsap_DL_DPCH_TimingAdjustment(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_DL_DPCH_TimingAdjustment(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_TimingAdjustment(tvb, offset, pinfo, tree, hf_rnsap_id_DL_DPCH_TimingAdjustment);
}
static int dissect_id_Initial_DL_DPCH_TimingAdjustment(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_TimingAdjustment(tvb, offset, pinfo, tree, hf_rnsap_id_Initial_DL_DPCH_TimingAdjustment);
}



static int
dissect_rnsap_DL_Power(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -350, 150U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_DLReferencePower(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_id_DLReferencePower);
}
static int dissect_dl_InitialTX_Power(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_dl_InitialTX_Power);
}
static int dissect_maximumDLTxPower(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_maximumDLTxPower);
}
static int dissect_minimumDLTxPower(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_minimumDLTxPower);
}
static int dissect_cCTrCH_Maximum_DL_Power(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_cCTrCH_Maximum_DL_Power);
}
static int dissect_cCTrCH_Minimum_DL_Power(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_cCTrCH_Minimum_DL_Power);
}
static int dissect_maxPowerLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_maxPowerLCR);
}
static int dissect_minPowerLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_minPowerLCR);
}
static int dissect_dl_Reference_Power(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_dl_Reference_Power);
}
static int dissect_initial_dl_tx_power(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_initial_dl_tx_power);
}
static int dissect_dLReferencePower(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_dLReferencePower);
}
static int dissect_common_DL_ReferencePowerInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Power(tvb, offset, pinfo, tree, hf_rnsap_common_DL_ReferencePowerInformation);
}


static const per_sequence_t DL_ReferencePowerInformationList_DL_PC_Rqst_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_ReferencePowerInformationList_DL_PC_Rqst_item },
};

static int
dissect_rnsap_DL_ReferencePowerInformationList_DL_PC_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_ReferencePowerInformationList_DL_PC_Rqst, DL_ReferencePowerInformationList_DL_PC_Rqst_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_id_DLReferencePowerList_DL_PC_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_ReferencePowerInformationList_DL_PC_Rqst(tvb, offset, pinfo, tree, hf_rnsap_id_DLReferencePowerList_DL_PC_Rqst);
}



static int
dissect_rnsap_RL_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 31U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_rL_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_ID(tvb, offset, pinfo, tree, hf_rnsap_rL_ID);
}
static int dissect_e_DCH_Serving_RL_Id(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_ID(tvb, offset, pinfo, tree, hf_rnsap_e_DCH_Serving_RL_Id);
}


static const per_sequence_t DL_ReferencePowerInformation_DL_PC_Rqst_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "dl-Reference-Power"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_Reference_Power },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_ReferencePowerInformation_DL_PC_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_ReferencePowerInformation_DL_PC_Rqst, DL_ReferencePowerInformation_DL_PC_Rqst_sequence);

  return offset;
}
static int dissect_id_DL_ReferencePowerInformation_DL_PC_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_ReferencePowerInformation_DL_PC_Rqst(tvb, offset, pinfo, tree, hf_rnsap_id_DL_ReferencePowerInformation_DL_PC_Rqst);
}


static const value_string rnsap_DPC_Mode_vals[] = {
  {   0, "mode0" },
  {   1, "mode1" },
  { 0, NULL }
};


static int
dissect_rnsap_DPC_Mode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_id_DPC_Mode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DPC_Mode(tvb, offset, pinfo, tree, hf_rnsap_id_DPC_Mode);
}



static int
dissect_rnsap_DRXCycleLengthCoefficient(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              3U, 9U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_DRXCycleLengthCoefficient(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DRXCycleLengthCoefficient(tvb, offset, pinfo, tree, hf_rnsap_id_DRXCycleLengthCoefficient);
}


static const per_sequence_t RL_Unsuccessful_InformationRespList_DM_Fail_Ind_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Unsuccessful_InformationRespList_DM_Fail_Ind_item },
};

static int
dissect_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_Ind, RL_Unsuccessful_InformationRespList_DM_Fail_Ind_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_unsuccessful_InformationRespList_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_Ind(tvb, offset, pinfo, tree, hf_rnsap_rL_unsuccessful_InformationRespList_DM_Fail_Ind);
}


static const per_sequence_t RL_DM_Fail_Ind_sequence[] = {
  { "rL-unsuccessful-InformationRespList-DM-Fail-Ind", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_unsuccessful_InformationRespList_DM_Fail_Ind },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_DM_Fail_Ind, RL_DM_Fail_Ind_sequence);

  return offset;
}
static int dissect_rL4(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_DM_Fail_Ind(tvb, offset, pinfo, tree, hf_rnsap_rL4);
}
static int dissect_allRL4(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_DM_Fail_Ind(tvb, offset, pinfo, tree, hf_rnsap_allRL4);
}


static const per_sequence_t RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind_item },
};

static int
dissect_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind, RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_Set_unsuccessful_InformationRespList_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind(tvb, offset, pinfo, tree, hf_rnsap_rL_Set_unsuccessful_InformationRespList_DM_Fail_Ind);
}


static const per_sequence_t RL_Set_DM_Fail_Ind_sequence[] = {
  { "rL-Set-unsuccessful-InformationRespList-DM-Fail-Ind", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_unsuccessful_InformationRespList_DM_Fail_Ind },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_DM_Fail_Ind, RL_Set_DM_Fail_Ind_sequence);

  return offset;
}
static int dissect_rLS4(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_DM_Fail_Ind(tvb, offset, pinfo, tree, hf_rnsap_rLS4);
}
static int dissect_allRLS4(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_DM_Fail_Ind(tvb, offset, pinfo, tree, hf_rnsap_allRLS4);
}


static const value_string rnsap_DedicatedMeasurementObjectType_DM_Fail_Ind_vals[] = {
  {   0, "rL" },
  {   1, "rLS" },
  {   2, "allRL" },
  {   3, "allRLS" },
  { 0, NULL }
};

static const per_choice_t DedicatedMeasurementObjectType_DM_Fail_Ind_choice[] = {
  {   0, "rL"                          , ASN1_EXTENSION_ROOT    , dissect_rL4 },
  {   1, "rLS"                         , ASN1_EXTENSION_ROOT    , dissect_rLS4 },
  {   2, "allRL"                       , ASN1_EXTENSION_ROOT    , dissect_allRL4 },
  {   3, "allRLS"                      , ASN1_EXTENSION_ROOT    , dissect_allRLS4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementObjectType_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DedicatedMeasurementObjectType_DM_Fail_Ind, DedicatedMeasurementObjectType_DM_Fail_Ind_choice,
                                 NULL);

  return offset;
}
static int dissect_id_DedicatedMeasurementObjectType_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementObjectType_DM_Fail_Ind(tvb, offset, pinfo, tree, hf_rnsap_id_DedicatedMeasurementObjectType_DM_Fail_Ind);
}


static const per_sequence_t RL_Unsuccessful_InformationRespList_DM_Fail_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Unsuccessful_InformationRespList_DM_Fail_item },
};

static int
dissect_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail, RL_Unsuccessful_InformationRespList_DM_Fail_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_unsuccessful_InformationRespList_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_rL_unsuccessful_InformationRespList_DM_Fail);
}


static const per_sequence_t RL_Successful_InformationRespList_DM_Fail_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Successful_InformationRespList_DM_Fail_item },
};

static int
dissect_rnsap_RL_Successful_InformationRespList_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Successful_InformationRespList_DM_Fail, RL_Successful_InformationRespList_DM_Fail_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_rL_successful_InformationRespList_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Successful_InformationRespList_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_rL_successful_InformationRespList_DM_Fail);
}


static const per_sequence_t RL_DM_Fail_sequence[] = {
  { "rL-unsuccessful-InformationRespList-DM-Fail", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_unsuccessful_InformationRespList_DM_Fail },
  { "rL-successful-InformationRespList-DM-Fail", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_rL_successful_InformationRespList_DM_Fail },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_DM_Fail, RL_DM_Fail_sequence);

  return offset;
}
static int dissect_rL3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_rL3);
}
static int dissect_allRL2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_allRL2);
}


static const per_sequence_t RL_Set_Unsuccessful_InformationRespList_DM_Fail_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Set_Unsuccessful_InformationRespList_DM_Fail_item },
};

static int
dissect_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail, RL_Set_Unsuccessful_InformationRespList_DM_Fail_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_Set_unsuccessful_InformationRespList_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_rL_Set_unsuccessful_InformationRespList_DM_Fail);
}


static const per_sequence_t RL_Set_Successful_InformationRespList_DM_Fail_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Set_Successful_InformationRespList_DM_Fail_item },
};

static int
dissect_rnsap_RL_Set_Successful_InformationRespList_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Set_Successful_InformationRespList_DM_Fail, RL_Set_Successful_InformationRespList_DM_Fail_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_rL_Set_successful_InformationRespList_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_Successful_InformationRespList_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_rL_Set_successful_InformationRespList_DM_Fail);
}


static const per_sequence_t RL_Set_DM_Fail_sequence[] = {
  { "rL-Set-unsuccessful-InformationRespList-DM-Fail", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_unsuccessful_InformationRespList_DM_Fail },
  { "rL-Set-successful-InformationRespList-DM-Fail", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_rL_Set_successful_InformationRespList_DM_Fail },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_DM_Fail, RL_Set_DM_Fail_sequence);

  return offset;
}
static int dissect_rLS2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_rLS2);
}
static int dissect_allRLS2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_allRLS2);
}


static const value_string rnsap_DedicatedMeasurementObjectType_DM_Fail_vals[] = {
  {   0, "rL" },
  {   1, "rLS" },
  {   2, "allRL" },
  {   3, "allRLS" },
  { 0, NULL }
};

static const per_choice_t DedicatedMeasurementObjectType_DM_Fail_choice[] = {
  {   0, "rL"                          , ASN1_EXTENSION_ROOT    , dissect_rL3 },
  {   1, "rLS"                         , ASN1_EXTENSION_ROOT    , dissect_rLS2 },
  {   2, "allRL"                       , ASN1_EXTENSION_ROOT    , dissect_allRL2 },
  {   3, "allRLS"                      , ASN1_EXTENSION_ROOT    , dissect_allRLS2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementObjectType_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DedicatedMeasurementObjectType_DM_Fail, DedicatedMeasurementObjectType_DM_Fail_choice,
                                 NULL);

  return offset;
}
static int dissect_id_DedicatedMeasurementObjectType_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementObjectType_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_id_DedicatedMeasurementObjectType_DM_Fail);
}


static const per_sequence_t RL_InformationList_DM_Rprt_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_DM_Rprt_item },
};

static int
dissect_rnsap_RL_InformationList_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_DM_Rprt, RL_InformationList_DM_Rprt_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_InformationList_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_DM_Rprt(tvb, offset, pinfo, tree, hf_rnsap_rL_InformationList_DM_Rprt);
}


static const per_sequence_t RL_DM_Rprt_sequence[] = {
  { "rL-InformationList-DM-Rprt"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_InformationList_DM_Rprt },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_DM_Rprt, RL_DM_Rprt_sequence);

  return offset;
}
static int dissect_rLs1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_DM_Rprt(tvb, offset, pinfo, tree, hf_rnsap_rLs1);
}
static int dissect_allRL3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_DM_Rprt(tvb, offset, pinfo, tree, hf_rnsap_allRL3);
}


static const per_sequence_t RL_Set_InformationList_DM_Rprt_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Set_InformationList_DM_Rprt_item },
};

static int
dissect_rnsap_RL_Set_InformationList_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Set_InformationList_DM_Rprt, RL_Set_InformationList_DM_Rprt_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_Set_InformationList_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_InformationList_DM_Rprt(tvb, offset, pinfo, tree, hf_rnsap_rL_Set_InformationList_DM_Rprt);
}


static const per_sequence_t RL_Set_DM_Rprt_sequence[] = {
  { "rL-Set-InformationList-DM-Rprt", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_InformationList_DM_Rprt },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_DM_Rprt, RL_Set_DM_Rprt_sequence);

  return offset;
}
static int dissect_rLS3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_DM_Rprt(tvb, offset, pinfo, tree, hf_rnsap_rLS3);
}
static int dissect_allRLS3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_DM_Rprt(tvb, offset, pinfo, tree, hf_rnsap_allRLS3);
}


static const value_string rnsap_DedicatedMeasurementObjectType_DM_Rprt_vals[] = {
  {   0, "rLs" },
  {   1, "rLS" },
  {   2, "allRL" },
  {   3, "allRLS" },
  { 0, NULL }
};

static const per_choice_t DedicatedMeasurementObjectType_DM_Rprt_choice[] = {
  {   0, "rLs"                         , ASN1_EXTENSION_ROOT    , dissect_rLs1 },
  {   1, "rLS"                         , ASN1_EXTENSION_ROOT    , dissect_rLS3 },
  {   2, "allRL"                       , ASN1_EXTENSION_ROOT    , dissect_allRL3 },
  {   3, "allRLS"                      , ASN1_EXTENSION_ROOT    , dissect_allRLS3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementObjectType_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DedicatedMeasurementObjectType_DM_Rprt, DedicatedMeasurementObjectType_DM_Rprt_choice,
                                 NULL);

  return offset;
}
static int dissect_id_DedicatedMeasurementObjectType_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementObjectType_DM_Rprt(tvb, offset, pinfo, tree, hf_rnsap_id_DedicatedMeasurementObjectType_DM_Rprt);
}


static const per_sequence_t RL_InformationList_DM_Rqst_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_DM_Rqst_item },
};

static int
dissect_rnsap_RL_InformationList_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_DM_Rqst, RL_InformationList_DM_Rqst_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_InformationList_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_DM_Rqst(tvb, offset, pinfo, tree, hf_rnsap_rL_InformationList_DM_Rqst);
}


static const per_sequence_t RL_DM_Rqst_sequence[] = {
  { "rL-InformationList-DM-Rqst"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_InformationList_DM_Rqst },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_DM_Rqst, RL_DM_Rqst_sequence);

  return offset;
}
static int dissect_rL2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_DM_Rqst(tvb, offset, pinfo, tree, hf_rnsap_rL2);
}


static const per_sequence_t RL_Set_InformationList_DM_Rqst_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Set_InformationList_DM_Rqst_item },
};

static int
dissect_rnsap_RL_Set_InformationList_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Set_InformationList_DM_Rqst, RL_Set_InformationList_DM_Rqst_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_Set_InformationList_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_InformationList_DM_Rqst(tvb, offset, pinfo, tree, hf_rnsap_rL_Set_InformationList_DM_Rqst);
}


static const per_sequence_t RL_Set_DM_Rqst_sequence[] = {
  { "rL-Set-InformationList-DM-Rqst", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_InformationList_DM_Rqst },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_DM_Rqst, RL_Set_DM_Rqst_sequence);

  return offset;
}
static int dissect_rLS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_DM_Rqst(tvb, offset, pinfo, tree, hf_rnsap_rLS);
}



static int
dissect_rnsap_All_RL_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_null(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_allRL(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_All_RL_DM_Rqst(tvb, offset, pinfo, tree, hf_rnsap_allRL);
}



static int
dissect_rnsap_All_RL_Set_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_null(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_allRLS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_All_RL_Set_DM_Rqst(tvb, offset, pinfo, tree, hf_rnsap_allRLS);
}


static const value_string rnsap_DedicatedMeasurementObjectType_DM_Rqst_vals[] = {
  {   0, "rL" },
  {   1, "rLS" },
  {   2, "allRL" },
  {   3, "allRLS" },
  { 0, NULL }
};

static const per_choice_t DedicatedMeasurementObjectType_DM_Rqst_choice[] = {
  {   0, "rL"                          , ASN1_EXTENSION_ROOT    , dissect_rL2 },
  {   1, "rLS"                         , ASN1_EXTENSION_ROOT    , dissect_rLS },
  {   2, "allRL"                       , ASN1_EXTENSION_ROOT    , dissect_allRL },
  {   3, "allRLS"                      , ASN1_EXTENSION_ROOT    , dissect_allRLS },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementObjectType_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DedicatedMeasurementObjectType_DM_Rqst, DedicatedMeasurementObjectType_DM_Rqst_choice,
                                 NULL);

  return offset;
}
static int dissect_id_DedicatedMeasurementObjectType_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementObjectType_DM_Rqst(tvb, offset, pinfo, tree, hf_rnsap_id_DedicatedMeasurementObjectType_DM_Rqst);
}


static const per_sequence_t RL_InformationList_DM_Rsp_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_DM_Rsp_item },
};

static int
dissect_rnsap_RL_InformationList_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_DM_Rsp, RL_InformationList_DM_Rsp_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_InformationList_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_rL_InformationList_DM_Rsp);
}


static const per_sequence_t RL_DM_Rsp_sequence[] = {
  { "rL-InformationList-DM-Rsp"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_InformationList_DM_Rsp },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_DM_Rsp, RL_DM_Rsp_sequence);

  return offset;
}
static int dissect_rLs(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_rLs);
}
static int dissect_allRL1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_allRL1);
}


static const per_sequence_t RL_Set_InformationList_DM_Rsp_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Set_InformationList_DM_Rsp_item },
};

static int
dissect_rnsap_RL_Set_InformationList_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Set_InformationList_DM_Rsp, RL_Set_InformationList_DM_Rsp_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_Set_InformationList_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_InformationList_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_rL_Set_InformationList_DM_Rsp);
}


static const per_sequence_t RL_Set_DM_Rsp_sequence[] = {
  { "rL-Set-InformationList-DM-Rsp", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_InformationList_DM_Rsp },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_DM_Rsp, RL_Set_DM_Rsp_sequence);

  return offset;
}
static int dissect_rLS1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_rLS1);
}
static int dissect_allRLS1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_allRLS1);
}


static const value_string rnsap_DedicatedMeasurementObjectType_DM_Rsp_vals[] = {
  {   0, "rLs" },
  {   1, "rLS" },
  {   2, "allRL" },
  {   3, "allRLS" },
  { 0, NULL }
};

static const per_choice_t DedicatedMeasurementObjectType_DM_Rsp_choice[] = {
  {   0, "rLs"                         , ASN1_EXTENSION_ROOT    , dissect_rLs },
  {   1, "rLS"                         , ASN1_EXTENSION_ROOT    , dissect_rLS1 },
  {   2, "allRL"                       , ASN1_EXTENSION_ROOT    , dissect_allRL1 },
  {   3, "allRLS"                      , ASN1_EXTENSION_ROOT    , dissect_allRLS1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementObjectType_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DedicatedMeasurementObjectType_DM_Rsp, DedicatedMeasurementObjectType_DM_Rsp_choice,
                                 NULL);

  return offset;
}
static int dissect_id_DedicatedMeasurementObjectType_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementObjectType_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_id_DedicatedMeasurementObjectType_DM_Rsp);
}


static const value_string rnsap_DedicatedMeasurementType_vals[] = {
  {   0, "sir" },
  {   1, "sir-error" },
  {   2, "transmitted-code-power" },
  {   3, "rSCP" },
  {   4, "rx-timing-deviation" },
  {   5, "round-trip-time" },
  {   6, "rx-timing-deviation-LCR" },
  {   6, "angle-Of-Arrival-LCR" },
  {   6, "hs-sich-quality" },
  { 0, NULL }
};


static int
dissect_rnsap_DedicatedMeasurementType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 6, NULL, NULL, TRUE);

  return offset;
}
static int dissect_id_DedicatedMeasurementType(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementType(tvb, offset, pinfo, tree, hf_rnsap_id_DedicatedMeasurementType);
}



static int
dissect_rnsap_FACH_FlowControlInformation_CTCH_ResourceRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_fACH_FlowControlInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FACH_FlowControlInformation_CTCH_ResourceRspFDD(tvb, offset, pinfo, tree, hf_rnsap_fACH_FlowControlInformation);
}


static const per_sequence_t FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_sequence[] = {
  { "fACH-FlowControlInformation" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fACH_FlowControlInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD, FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_sequence);

  return offset;
}
static int dissect_id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD(tvb, offset, pinfo, tree, hf_rnsap_id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD);
}



static int
dissect_rnsap_FACH_FlowControlInformation_CTCH_ResourceRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_fACH_FlowControlInformation1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FACH_FlowControlInformation_CTCH_ResourceRspTDD(tvb, offset, pinfo, tree, hf_rnsap_fACH_FlowControlInformation1);
}


static const per_sequence_t FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_sequence[] = {
  { "fACH-FlowControlInformation" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fACH_FlowControlInformation1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD, FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_sequence);

  return offset;
}
static int dissect_id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD(tvb, offset, pinfo, tree, hf_rnsap_id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD);
}



static int
dissect_rnsap_Guaranteed_Rate(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 32U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_guaranteed_UL_Rate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Guaranteed_Rate(tvb, offset, pinfo, tree, hf_rnsap_guaranteed_UL_Rate);
}
static int dissect_guaranteed_DL_Rate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Guaranteed_Rate(tvb, offset, pinfo, tree, hf_rnsap_guaranteed_DL_Rate);
}


static const per_sequence_t Guaranteed_Rate_Information_sequence[] = {
  { "guaranteed-UL-Rate"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_guaranteed_UL_Rate },
  { "guaranteed-DL-Rate"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_guaranteed_DL_Rate },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Guaranteed_Rate_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Guaranteed_Rate_Information, Guaranteed_Rate_Information_sequence);

  return offset;
}
static int dissect_id_Guaranteed_Rate_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Guaranteed_Rate_Information(tvb, offset, pinfo, tree, hf_rnsap_id_Guaranteed_Rate_Information);
}



static int
dissect_rnsap_IMSI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       3, 8, NULL);

  return offset;
}
static int dissect_id_IMSI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IMSI(tvb, offset, pinfo, tree, hf_rnsap_id_IMSI);
}
static int dissect_imsi(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IMSI(tvb, offset, pinfo, tree, hf_rnsap_imsi);
}



static int
dissect_rnsap_HCS_Prio(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 7U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_HCS_Prio(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HCS_Prio(tvb, offset, pinfo, tree, hf_rnsap_id_HCS_Prio);
}



static int
dissect_rnsap_L3_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     NO_BOUND, NO_BOUND, FALSE);

  return offset;
}
static int dissect_id_L3_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_L3_Information(tvb, offset, pinfo, tree, hf_rnsap_id_L3_Information);
}



static int
dissect_rnsap_AdjustmentPeriod(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 256U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_AdjustmentPeriod(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AdjustmentPeriod(tvb, offset, pinfo, tree, hf_rnsap_id_AdjustmentPeriod);
}
static int dissect_adjustmentPeriod(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AdjustmentPeriod(tvb, offset, pinfo, tree, hf_rnsap_adjustmentPeriod);
}



static int
dissect_rnsap_MaxAdjustmentStep(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 10U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_MaxAdjustmentStep(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MaxAdjustmentStep(tvb, offset, pinfo, tree, hf_rnsap_id_MaxAdjustmentStep);
}
static int dissect_maxAdjustmentStep(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MaxAdjustmentStep(tvb, offset, pinfo, tree, hf_rnsap_maxAdjustmentStep);
}


static const value_string rnsap_MeasurementFilterCoefficient_vals[] = {
  {   0, "k0" },
  {   1, "k1" },
  {   2, "k2" },
  {   3, "k3" },
  {   4, "k4" },
  {   5, "k5" },
  {   6, "k6" },
  {   7, "k7" },
  {   8, "k8" },
  {   9, "k9" },
  {  10, "k11" },
  {  11, "k13" },
  {  12, "k15" },
  {  13, "k17" },
  {  14, "k19" },
  { 0, NULL }
};


static int
dissect_rnsap_MeasurementFilterCoefficient(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 14, NULL, NULL, TRUE);

  return offset;
}
static int dissect_id_MeasurementFilterCoefficient(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MeasurementFilterCoefficient(tvb, offset, pinfo, tree, hf_rnsap_id_MeasurementFilterCoefficient);
}



static int
dissect_rnsap_RepetitionNumber1(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 256U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_repetitionNumber1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RepetitionNumber1(tvb, offset, pinfo, tree, hf_rnsap_repetitionNumber1);
}


static const per_sequence_t MessageStructure_item_sequence[] = {
  { "iE-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iE_ID },
  { "repetitionNumber"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_repetitionNumber1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MessageStructure_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MessageStructure_item, MessageStructure_item_sequence);

  return offset;
}
static int dissect_MessageStructure_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MessageStructure_item(tvb, offset, pinfo, tree, hf_rnsap_MessageStructure_item);
}


static const per_sequence_t MessageStructure_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_MessageStructure_item },
};

static int
dissect_rnsap_MessageStructure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_MessageStructure, MessageStructure_sequence_of,
                                                  1, 256);

  return offset;
}
static int dissect_id_MessageStructure(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MessageStructure(tvb, offset, pinfo, tree, hf_rnsap_id_MessageStructure);
}



static int
dissect_rnsap_MeasurementID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 1048575U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_MeasurementID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MeasurementID(tvb, offset, pinfo, tree, hf_rnsap_id_MeasurementID);
}



static int
dissect_rnsap_Neighbouring_GSM_CellInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_id_Neighbouring_GSM_CellInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Neighbouring_GSM_CellInformation(tvb, offset, pinfo, tree, hf_rnsap_id_Neighbouring_GSM_CellInformation);
}
static int dissect_neighbouring_GSM_CellInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Neighbouring_GSM_CellInformation(tvb, offset, pinfo, tree, hf_rnsap_neighbouring_GSM_CellInformation);
}



static int
dissect_rnsap_RNC_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 4095U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_RNC_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RNC_ID(tvb, offset, pinfo, tree, hf_rnsap_id_RNC_ID);
}
static int dissect_id_SRNC_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RNC_ID(tvb, offset, pinfo, tree, hf_rnsap_id_SRNC_ID);
}
static int dissect_rNC_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RNC_ID(tvb, offset, pinfo, tree, hf_rnsap_rNC_ID);
}
static int dissect_srnc_id(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RNC_ID(tvb, offset, pinfo, tree, hf_rnsap_srnc_id);
}



static int
dissect_rnsap_UARFCN(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 16383U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_uL_UARFCN(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UARFCN(tvb, offset, pinfo, tree, hf_rnsap_uL_UARFCN);
}
static int dissect_dL_UARFCN(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UARFCN(tvb, offset, pinfo, tree, hf_rnsap_dL_UARFCN);
}
static int dissect_uARFCNforNt(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UARFCN(tvb, offset, pinfo, tree, hf_rnsap_uARFCNforNt);
}
static int dissect_preferredFrequencyLayer(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UARFCN(tvb, offset, pinfo, tree, hf_rnsap_preferredFrequencyLayer);
}
static int dissect_uARFCNforNu(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UARFCN(tvb, offset, pinfo, tree, hf_rnsap_uARFCNforNu);
}
static int dissect_uARFCNforNd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UARFCN(tvb, offset, pinfo, tree, hf_rnsap_uARFCNforNd);
}
static int dissect_uARFCN(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UARFCN(tvb, offset, pinfo, tree, hf_rnsap_uARFCN);
}
static int dissect_defaultPreferredFrequency(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UARFCN(tvb, offset, pinfo, tree, hf_rnsap_defaultPreferredFrequency);
}



static int
dissect_rnsap_FrameOffset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_frameOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FrameOffset(tvb, offset, pinfo, tree, hf_rnsap_frameOffset);
}



static int
dissect_rnsap_PrimaryScramblingCode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 511U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_primaryScramblingCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PrimaryScramblingCode(tvb, offset, pinfo, tree, hf_rnsap_primaryScramblingCode);
}



static int
dissect_rnsap_PrimaryCPICH_Power(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -100, 500U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_primaryCPICH_Power(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PrimaryCPICH_Power(tvb, offset, pinfo, tree, hf_rnsap_primaryCPICH_Power);
}



static int
dissect_rnsap_CellIndividualOffset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -20, 20U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_cellIndividualOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CellIndividualOffset(tvb, offset, pinfo, tree, hf_rnsap_cellIndividualOffset);
}


static const value_string rnsap_TxDiversityIndicator_vals[] = {
  {   0, "true" },
  {   1, "false" },
  { 0, NULL }
};


static int
dissect_rnsap_TxDiversityIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_txDiversityIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TxDiversityIndicator(tvb, offset, pinfo, tree, hf_rnsap_txDiversityIndicator);
}


static const value_string rnsap_STTD_SupportIndicator_vals[] = {
  {   0, "sTTD-Supported" },
  {   1, "sTTD-not-Supported" },
  { 0, NULL }
};


static int
dissect_rnsap_STTD_SupportIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sTTD_SupportIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_STTD_SupportIndicator(tvb, offset, pinfo, tree, hf_rnsap_sTTD_SupportIndicator);
}


static const value_string rnsap_ClosedLoopMode1_SupportIndicator_vals[] = {
  {   0, "closedLoop-Mode1-Supported" },
  {   1, "closedLoop-Mode1-not-Supported" },
  { 0, NULL }
};


static int
dissect_rnsap_ClosedLoopMode1_SupportIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_closedLoopMode1_SupportIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ClosedLoopMode1_SupportIndicator(tvb, offset, pinfo, tree, hf_rnsap_closedLoopMode1_SupportIndicator);
}


static const per_sequence_t Neighbouring_FDD_CellInformationItem_sequence[] = {
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "uARFCNforNu"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uARFCNforNu },
  { "uARFCNforNd"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uARFCNforNd },
  { "frameOffset"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_frameOffset },
  { "primaryScramblingCode"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_primaryScramblingCode },
  { "primaryCPICH-Power"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primaryCPICH_Power },
  { "cellIndividualOffset"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cellIndividualOffset },
  { "txDiversityIndicator"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_txDiversityIndicator },
  { "sTTD-SupportIndicator"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_sTTD_SupportIndicator },
  { "closedLoopMode1-SupportIndicator", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_closedLoopMode1_SupportIndicator },
  { "not-used-closedLoopMode2-SupportIndicator", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_used_closedLoopMode2_SupportIndicator },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Neighbouring_FDD_CellInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Neighbouring_FDD_CellInformationItem, Neighbouring_FDD_CellInformationItem_sequence);

  return offset;
}
static int dissect_Neighbouring_FDD_CellInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Neighbouring_FDD_CellInformationItem(tvb, offset, pinfo, tree, hf_rnsap_Neighbouring_FDD_CellInformation_item);
}


static const per_sequence_t Neighbouring_FDD_CellInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Neighbouring_FDD_CellInformation_item },
};

static int
dissect_rnsap_Neighbouring_FDD_CellInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Neighbouring_FDD_CellInformation, Neighbouring_FDD_CellInformation_sequence_of,
                                                  1, 256);

  return offset;
}
static int dissect_neighbouring_FDD_CellInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Neighbouring_FDD_CellInformation(tvb, offset, pinfo, tree, hf_rnsap_neighbouring_FDD_CellInformation);
}



static int
dissect_rnsap_CellParameterID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 127U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_cellParameterID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CellParameterID(tvb, offset, pinfo, tree, hf_rnsap_cellParameterID);
}



static int
dissect_rnsap_SyncCase(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 2U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_syncCase(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SyncCase(tvb, offset, pinfo, tree, hf_rnsap_syncCase);
}



static int
dissect_rnsap_SCH_TimeSlot(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 6U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sCH_TimeSlot(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SCH_TimeSlot(tvb, offset, pinfo, tree, hf_rnsap_sCH_TimeSlot);
}


static const value_string rnsap_SCTD_Indicator_vals[] = {
  {   0, "active" },
  {   1, "inactive" },
  { 0, NULL }
};


static int
dissect_rnsap_SCTD_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sCTD_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SCTD_Indicator(tvb, offset, pinfo, tree, hf_rnsap_sCTD_Indicator);
}



static int
dissect_rnsap_DPCHConstantValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -10, 10U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_dPCHConstantValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DPCHConstantValue(tvb, offset, pinfo, tree, hf_rnsap_dPCHConstantValue);
}



static int
dissect_rnsap_PCCPCH_Power(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -150, 400U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_pCCPCH_Power(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PCCPCH_Power(tvb, offset, pinfo, tree, hf_rnsap_pCCPCH_Power);
}


static const per_sequence_t Neighbouring_TDD_CellInformationItem_sequence[] = {
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "uARFCNforNt"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uARFCNforNt },
  { "frameOffset"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_frameOffset },
  { "cellParameterID"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cellParameterID },
  { "syncCase"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_syncCase },
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_timeSlot },
  { "sCH-TimeSlot"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_sCH_TimeSlot },
  { "sCTD-Indicator"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sCTD_Indicator },
  { "cellIndividualOffset"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cellIndividualOffset },
  { "dPCHConstantValue"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dPCHConstantValue },
  { "pCCPCH-Power"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_pCCPCH_Power },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Neighbouring_TDD_CellInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Neighbouring_TDD_CellInformationItem, Neighbouring_TDD_CellInformationItem_sequence);

  return offset;
}
static int dissect_Neighbouring_TDD_CellInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Neighbouring_TDD_CellInformationItem(tvb, offset, pinfo, tree, hf_rnsap_Neighbouring_TDD_CellInformation_item);
}


static const per_sequence_t Neighbouring_TDD_CellInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Neighbouring_TDD_CellInformation_item },
};

static int
dissect_rnsap_Neighbouring_TDD_CellInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Neighbouring_TDD_CellInformation, Neighbouring_TDD_CellInformation_sequence_of,
                                                  1, 256);

  return offset;
}
static int dissect_neighbouring_TDD_CellInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Neighbouring_TDD_CellInformation(tvb, offset, pinfo, tree, hf_rnsap_neighbouring_TDD_CellInformation);
}


static const per_sequence_t Neighbouring_UMTS_CellInformationItem_sequence[] = {
  { "rNC-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rNC_ID },
  { "cN-PS-DomainIdentifier"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cN_PS_DomainIdentifier },
  { "cN-CS-DomainIdentifier"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cN_CS_DomainIdentifier },
  { "neighbouring-FDD-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_FDD_CellInformation },
  { "neighbouring-TDD-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_TDD_CellInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Neighbouring_UMTS_CellInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Neighbouring_UMTS_CellInformationItem, Neighbouring_UMTS_CellInformationItem_sequence);

  return offset;
}
static int dissect_id_Neighbouring_UMTS_CellInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Neighbouring_UMTS_CellInformationItem(tvb, offset, pinfo, tree, hf_rnsap_id_Neighbouring_UMTS_CellInformationItem);
}



static int
dissect_rnsap_NRT_Load_Information_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 3U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_NRT_Load_Information_Value(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NRT_Load_Information_Value(tvb, offset, pinfo, tree, hf_rnsap_id_NRT_Load_Information_Value);
}



static int
dissect_rnsap_NRT_Load_Information_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 3U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_NRT_Load_Information_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NRT_Load_Information_Value_IncrDecrThres(tvb, offset, pinfo, tree, hf_rnsap_id_NRT_Load_Information_Value_IncrDecrThres);
}



static int
dissect_rnsap_URA_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 65535U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_Old_URA_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_URA_ID(tvb, offset, pinfo, tree, hf_rnsap_id_Old_URA_ID);
}
static int dissect_id_URA_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_URA_ID(tvb, offset, pinfo, tree, hf_rnsap_id_URA_ID);
}
static int dissect_uRA_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_URA_ID(tvb, offset, pinfo, tree, hf_rnsap_uRA_ID);
}
static int dissect_ura_id(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_URA_ID(tvb, offset, pinfo, tree, hf_rnsap_ura_id);
}


static const per_sequence_t URA_PagingRqst_sequence[] = {
  { "uRA-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uRA_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_URA_PagingRqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_URA_PagingRqst, URA_PagingRqst_sequence);

  return offset;
}
static int dissect_uRA(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_URA_PagingRqst(tvb, offset, pinfo, tree, hf_rnsap_uRA);
}


static const per_sequence_t Cell_PagingRqst_sequence[] = {
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Cell_PagingRqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Cell_PagingRqst, Cell_PagingRqst_sequence);

  return offset;
}
static int dissect_cell(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cell_PagingRqst(tvb, offset, pinfo, tree, hf_rnsap_cell);
}


static const value_string rnsap_PagingArea_PagingRqst_vals[] = {
  {   0, "uRA" },
  {   1, "cell" },
  { 0, NULL }
};

static const per_choice_t PagingArea_PagingRqst_choice[] = {
  {   0, "uRA"                         , ASN1_EXTENSION_ROOT    , dissect_uRA },
  {   1, "cell"                        , ASN1_EXTENSION_ROOT    , dissect_cell },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_PagingArea_PagingRqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_PagingArea_PagingRqst, PagingArea_PagingRqst_choice,
                                 NULL);

  return offset;
}
static int dissect_id_PagingArea_PagingRqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PagingArea_PagingRqst(tvb, offset, pinfo, tree, hf_rnsap_id_PagingArea_PagingRqst);
}


static const value_string rnsap_SchedulingPriorityIndicator_vals[] = {
  {   0, "lowest" },
  {  15, "highest" },
  { 0, NULL }
};


static int
dissect_rnsap_SchedulingPriorityIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_schedulingPriorityIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SchedulingPriorityIndicator(tvb, offset, pinfo, tree, hf_rnsap_schedulingPriorityIndicator);
}
static int dissect_dSCH_SchedulingPriority(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SchedulingPriorityIndicator(tvb, offset, pinfo, tree, hf_rnsap_dSCH_SchedulingPriority);
}
static int dissect_fACH_SchedulingPriority(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SchedulingPriorityIndicator(tvb, offset, pinfo, tree, hf_rnsap_fACH_SchedulingPriority);
}



static int
dissect_rnsap_MAC_c_sh_SDU_Length(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 5000U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_MAC_c_sh_SDU_LengthList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MAC_c_sh_SDU_Length(tvb, offset, pinfo, tree, hf_rnsap_MAC_c_sh_SDU_LengthList_item);
}


static const per_sequence_t MAC_c_sh_SDU_LengthList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_MAC_c_sh_SDU_LengthList_item },
};

static int
dissect_rnsap_MAC_c_sh_SDU_LengthList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_MAC_c_sh_SDU_LengthList, MAC_c_sh_SDU_LengthList_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_mAC_c_sh_SDU_Lengths(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MAC_c_sh_SDU_LengthList(tvb, offset, pinfo, tree, hf_rnsap_mAC_c_sh_SDU_Lengths);
}


static const value_string rnsap_FACH_InitialWindowSize_vals[] = {
  { 255, "unlimited" },
  { 0, NULL }
};


static int
dissect_rnsap_FACH_InitialWindowSize(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_fACH_InitialWindowSize(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FACH_InitialWindowSize(tvb, offset, pinfo, tree, hf_rnsap_fACH_InitialWindowSize);
}


static const per_sequence_t FACH_FlowControlInformationItem_sequence[] = {
  { "fACH-SchedulingPriority"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fACH_SchedulingPriority },
  { "mAC-c-sh-SDU-Lengths"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mAC_c_sh_SDU_Lengths },
  { "fACH-InitialWindowSize"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fACH_InitialWindowSize },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_FACH_FlowControlInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_FACH_FlowControlInformationItem, FACH_FlowControlInformationItem_sequence);

  return offset;
}
static int dissect_FACH_FlowControlInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FACH_FlowControlInformationItem(tvb, offset, pinfo, tree, hf_rnsap_FACH_FlowControlInformation_item);
}


static const per_sequence_t FACH_FlowControlInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_FACH_FlowControlInformation_item },
};

static int
dissect_rnsap_FACH_FlowControlInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_FACH_FlowControlInformation, FACH_FlowControlInformation_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_id_FACH_FlowControlInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FACH_FlowControlInformation(tvb, offset, pinfo, tree, hf_rnsap_id_FACH_FlowControlInformation);
}


static const value_string rnsap_PartialReportingIndicator_vals[] = {
  {   0, "partial-reporting-allowed" },
  { 0, NULL }
};


static int
dissect_rnsap_PartialReportingIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_PartialReportingIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PartialReportingIndicator(tvb, offset, pinfo, tree, hf_rnsap_id_PartialReportingIndicator);
}


static const value_string rnsap_Permanent_NAS_UE_Identity_vals[] = {
  {   0, "imsi" },
  { 0, NULL }
};

static const per_choice_t Permanent_NAS_UE_Identity_choice[] = {
  {   0, "imsi"                        , ASN1_EXTENSION_ROOT    , dissect_imsi },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_Permanent_NAS_UE_Identity(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_Permanent_NAS_UE_Identity, Permanent_NAS_UE_Identity_choice,
                                 NULL);

  return offset;
}
static int dissect_id_Permanent_NAS_UE_Identity(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Permanent_NAS_UE_Identity(tvb, offset, pinfo, tree, hf_rnsap_id_Permanent_NAS_UE_Identity);
}


static const value_string rnsap_PowerAdjustmentType_vals[] = {
  {   0, "none" },
  {   1, "common" },
  {   2, "individual" },
  { 0, NULL }
};


static int
dissect_rnsap_PowerAdjustmentType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_PowerAdjustmentType(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerAdjustmentType(tvb, offset, pinfo, tree, hf_rnsap_id_PowerAdjustmentType);
}
static int dissect_powerAdjustmentType(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerAdjustmentType(tvb, offset, pinfo, tree, hf_rnsap_powerAdjustmentType);
}



static int
dissect_rnsap_RANAP_RelocationInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     NO_BOUND, NO_BOUND, FALSE);

  return offset;
}
static int dissect_id_RANAP_RelocationInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RANAP_RelocationInformation(tvb, offset, pinfo, tree, hf_rnsap_id_RANAP_RelocationInformation);
}



static int
dissect_rnsap_DL_CodeInformationList_PhyChReconfRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_CodeInformation3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CodeInformationList_PhyChReconfRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_dl_CodeInformation3);
}


static const per_sequence_t RL_Information_PhyChReconfRqstFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "dl-CodeInformation"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_CodeInformation3 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Information_PhyChReconfRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Information_PhyChReconfRqstFDD, RL_Information_PhyChReconfRqstFDD_sequence);

  return offset;
}
static int dissect_id_RL_Information_PhyChReconfRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Information_PhyChReconfRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Information_PhyChReconfRqstFDD);
}



static int
dissect_rnsap_UL_CCTrCH_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_CCTrCH_Information1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_CCTrCH_InformationList_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_CCTrCH_Information1);
}



static int
dissect_rnsap_DL_CCTrCH_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_CCTrCH_Information1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationList_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_CCTrCH_Information1);
}


static const per_sequence_t RL_Information_PhyChReconfRqstTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "ul-CCTrCH-Information"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_CCTrCH_Information1 },
  { "dl-CCTrCH-Information"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_CCTrCH_Information1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Information_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Information_PhyChReconfRqstTDD, RL_Information_PhyChReconfRqstTDD_sequence);

  return offset;
}
static int dissect_id_RL_Information_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Information_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Information_PhyChReconfRqstTDD);
}



static int
dissect_rnsap_ChipOffset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 38399U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_chipOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ChipOffset(tvb, offset, pinfo, tree, hf_rnsap_chipOffset);
}


static const value_string rnsap_DiversityControlField_vals[] = {
  {   0, "may" },
  {   1, "must" },
  {   2, "must-not" },
  { 0, NULL }
};


static int
dissect_rnsap_DiversityControlField(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, FALSE);

  return offset;
}
static int dissect_diversityControlField(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DiversityControlField(tvb, offset, pinfo, tree, hf_rnsap_diversityControlField);
}



static int
dissect_rnsap_PrimaryCPICH_EcNo(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -30, 30U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_primaryCPICH_EcNo(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PrimaryCPICH_EcNo(tvb, offset, pinfo, tree, hf_rnsap_primaryCPICH_EcNo);
}


static const value_string rnsap_TransmitDiversityIndicator_vals[] = {
  {   0, "active" },
  {   1, "inactive" },
  { 0, NULL }
};


static int
dissect_rnsap_TransmitDiversityIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_transmitDiversityIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransmitDiversityIndicator(tvb, offset, pinfo, tree, hf_rnsap_transmitDiversityIndicator);
}


static const per_sequence_t RL_Information_RL_AdditionRqstFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "frameOffset"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_frameOffset },
  { "chipOffset"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_chipOffset },
  { "diversityControlField"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_diversityControlField },
  { "primaryCPICH-EcNo"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primaryCPICH_EcNo },
  { "not-Used-sSDT-CellID"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_sSDT_CellID },
  { "transmitDiversityIndicator"  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transmitDiversityIndicator },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Information_RL_AdditionRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Information_RL_AdditionRqstFDD, RL_Information_RL_AdditionRqstFDD_sequence);

  return offset;
}
static int dissect_id_RL_Information_RL_AdditionRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Information_RL_AdditionRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Information_RL_AdditionRqstFDD);
}



static int
dissect_rnsap_PrimaryCCPCH_RSCP(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 91U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_primaryCCPCH_RSCP(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PrimaryCCPCH_RSCP(tvb, offset, pinfo, tree, hf_rnsap_primaryCCPCH_RSCP);
}



static int
dissect_rnsap_DL_TimeslotISCP(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 91U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_dL_TimeslotISCP(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeslotISCP(tvb, offset, pinfo, tree, hf_rnsap_dL_TimeslotISCP);
}


static const per_sequence_t DL_TimeSlot_ISCP_InfoItem_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "dL-TimeslotISCP"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_TimeslotISCP },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_TimeSlot_ISCP_InfoItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_TimeSlot_ISCP_InfoItem, DL_TimeSlot_ISCP_InfoItem_sequence);

  return offset;
}
static int dissect_DL_TimeSlot_ISCP_Info_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeSlot_ISCP_InfoItem(tvb, offset, pinfo, tree, hf_rnsap_DL_TimeSlot_ISCP_Info_item);
}


static const per_sequence_t DL_TimeSlot_ISCP_Info_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_TimeSlot_ISCP_Info_item },
};

static int
dissect_rnsap_DL_TimeSlot_ISCP_Info(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_TimeSlot_ISCP_Info, DL_TimeSlot_ISCP_Info_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_dL_TimeSlot_ISCP(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeSlot_ISCP_Info(tvb, offset, pinfo, tree, hf_rnsap_dL_TimeSlot_ISCP);
}
static int dissect_dL_TimeSlot_ISCP_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeSlot_ISCP_Info(tvb, offset, pinfo, tree, hf_rnsap_dL_TimeSlot_ISCP_Info);
}


static const per_sequence_t RL_Information_RL_AdditionRqstTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "frameOffset"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_frameOffset },
  { "diversityControlField"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_diversityControlField },
  { "primaryCCPCH-RSCP"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primaryCCPCH_RSCP },
  { "dL-TimeSlot-ISCP-Info"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_TimeSlot_ISCP_Info },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Information_RL_AdditionRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Information_RL_AdditionRqstTDD, RL_Information_RL_AdditionRqstTDD_sequence);

  return offset;
}
static int dissect_id_RL_Information_RL_AdditionRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Information_RL_AdditionRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Information_RL_AdditionRqstTDD);
}


static const per_sequence_t RL_Information_RL_DeletionRqst_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Information_RL_DeletionRqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Information_RL_DeletionRqst, RL_Information_RL_DeletionRqst_sequence);

  return offset;
}
static int dissect_id_RL_Information_RL_DeletionRqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Information_RL_DeletionRqst(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Information_RL_DeletionRqst);
}


static const per_sequence_t RL_Information_RL_FailureInd_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Information_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Information_RL_FailureInd, RL_Information_RL_FailureInd_sequence);

  return offset;
}
static int dissect_id_RL_Information_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Information_RL_FailureInd(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Information_RL_FailureInd);
}


static const per_sequence_t RL_Information_RL_ReconfPrepFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "not-Used-sSDT-Indication"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_sSDT_Indication },
  { "not-Used-sSDT-CellIdentity"  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_sSDT_CellIdentity },
  { "transmitDiversityIndicator"  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transmitDiversityIndicator },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Information_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Information_RL_ReconfPrepFDD, RL_Information_RL_ReconfPrepFDD_sequence);

  return offset;
}
static int dissect_id_RL_Information_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Information_RL_ReconfPrepFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Information_RL_ReconfPrepFDD);
}


static const per_sequence_t RL_Information_RL_RestoreInd_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Information_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Information_RL_RestoreInd, RL_Information_RL_RestoreInd_sequence);

  return offset;
}
static int dissect_id_RL_Information_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Information_RL_RestoreInd(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Information_RL_RestoreInd);
}


static const per_sequence_t RL_InformationList_RL_SetupRqstFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_RL_SetupRqstFDD_item },
};

static int
dissect_rnsap_RL_InformationList_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_RL_SetupRqstFDD, RL_InformationList_RL_SetupRqstFDD_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_id_RL_Information_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_RL_SetupRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Information_RL_SetupRqstFDD);
}



static int
dissect_rnsap_SpecialBurstScheduling(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 256U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_specialBurstScheduling(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SpecialBurstScheduling(tvb, offset, pinfo, tree, hf_rnsap_specialBurstScheduling);
}


static const per_sequence_t RL_Information_RL_SetupRqstTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "frameOffset"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_frameOffset },
  { "specialBurstScheduling"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_specialBurstScheduling },
  { "primaryCCPCH-RSCP"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primaryCCPCH_RSCP },
  { "dL-TimeSlot-ISCP"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_TimeSlot_ISCP },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Information_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Information_RL_SetupRqstTDD, RL_Information_RL_SetupRqstTDD_sequence);

  return offset;
}
static int dissect_id_RL_Information_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Information_RL_SetupRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Information_RL_SetupRqstTDD);
}


static const per_sequence_t DCH_Rate_Information_RL_CongestInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DCH_Rate_Information_RL_CongestInd_item },
};

static int
dissect_rnsap_DCH_Rate_Information_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DCH_Rate_Information_RL_CongestInd, DCH_Rate_Information_RL_CongestInd_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_dCH_Rate_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_Rate_Information_RL_CongestInd(tvb, offset, pinfo, tree, hf_rnsap_dCH_Rate_Information);
}


static const per_sequence_t RL_InformationItem_RL_CongestInd_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "dCH-Rate-Information"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_Rate_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationItem_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationItem_RL_CongestInd, RL_InformationItem_RL_CongestInd_sequence);

  return offset;
}
static int dissect_id_RL_InformationItem_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationItem_RL_CongestInd(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationItem_RL_CongestInd);
}



static int
dissect_rnsap_SIR_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 63U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sIR_Value(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SIR_Value(tvb, offset, pinfo, tree, hf_rnsap_sIR_Value);
}
static int dissect_sir1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SIR_Value(tvb, offset, pinfo, tree, hf_rnsap_sir1);
}



static int
dissect_rnsap_SIR_Error_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 125U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sIR_ErrorValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SIR_Error_Value(tvb, offset, pinfo, tree, hf_rnsap_sIR_ErrorValue);
}
static int dissect_sir_error1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SIR_Error_Value(tvb, offset, pinfo, tree, hf_rnsap_sir_error1);
}



static int
dissect_rnsap_Transmitted_Code_Power_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 127U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_transmittedCodePowerValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Transmitted_Code_Power_Value(tvb, offset, pinfo, tree, hf_rnsap_transmittedCodePowerValue);
}
static int dissect_transmitted_code_power1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Transmitted_Code_Power_Value(tvb, offset, pinfo, tree, hf_rnsap_transmitted_code_power1);
}



static int
dissect_rnsap_RSCP_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 127U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_rSCP(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RSCP_Value(tvb, offset, pinfo, tree, hf_rnsap_rSCP);
}
static int dissect_rscp1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RSCP_Value(tvb, offset, pinfo, tree, hf_rnsap_rscp1);
}



static int
dissect_rnsap_Rx_Timing_Deviation_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 8191U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_rxTimingDeviationValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Rx_Timing_Deviation_Value(tvb, offset, pinfo, tree, hf_rnsap_rxTimingDeviationValue);
}
static int dissect_rx_timing_deviation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Rx_Timing_Deviation_Value(tvb, offset, pinfo, tree, hf_rnsap_rx_timing_deviation);
}



static int
dissect_rnsap_Round_Trip_Time_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 32767U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_roundTripTime(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Round_Trip_Time_Value(tvb, offset, pinfo, tree, hf_rnsap_roundTripTime);
}
static int dissect_round_trip_time1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Round_Trip_Time_Value(tvb, offset, pinfo, tree, hf_rnsap_round_trip_time1);
}



static int
dissect_rnsap_Extension_DedicatedMeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_DedicatedMeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Extension_DedicatedMeasurementValue(tvb, offset, pinfo, tree, hf_rnsap_extension_DedicatedMeasurementValue);
}


static const value_string rnsap_DedicatedMeasurementValue_vals[] = {
  {   0, "sIR-Value" },
  {   1, "sIR-ErrorValue" },
  {   2, "transmittedCodePowerValue" },
  {   3, "rSCP" },
  {   4, "rxTimingDeviationValue" },
  {   5, "roundTripTime" },
  {   6, "extension-DedicatedMeasurementValue" },
  { 0, NULL }
};

static const per_choice_t DedicatedMeasurementValue_choice[] = {
  {   0, "sIR-Value"                   , ASN1_EXTENSION_ROOT    , dissect_sIR_Value },
  {   1, "sIR-ErrorValue"              , ASN1_EXTENSION_ROOT    , dissect_sIR_ErrorValue },
  {   2, "transmittedCodePowerValue"   , ASN1_EXTENSION_ROOT    , dissect_transmittedCodePowerValue },
  {   3, "rSCP"                        , ASN1_EXTENSION_ROOT    , dissect_rSCP },
  {   4, "rxTimingDeviationValue"      , ASN1_EXTENSION_ROOT    , dissect_rxTimingDeviationValue },
  {   5, "roundTripTime"               , ASN1_EXTENSION_ROOT    , dissect_roundTripTime },
  {   6, "extension-DedicatedMeasurementValue", ASN1_NOT_EXTENSION_ROOT, dissect_extension_DedicatedMeasurementValue },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DedicatedMeasurementValue, DedicatedMeasurementValue_choice,
                                 NULL);

  return offset;
}
static int dissect_dedicatedMeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementValue(tvb, offset, pinfo, tree, hf_rnsap_dedicatedMeasurementValue);
}
static int dissect_dedicatedmeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementValue(tvb, offset, pinfo, tree, hf_rnsap_dedicatedmeasurementValue);
}


static const per_sequence_t DedicatedMeasurementAvailable_sequence[] = {
  { "dedicatedmeasurementValue"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dedicatedmeasurementValue },
  { "cFN"                         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cFN },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DedicatedMeasurementAvailable, DedicatedMeasurementAvailable_sequence);

  return offset;
}
static int dissect_measurementAvailable1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementAvailable(tvb, offset, pinfo, tree, hf_rnsap_measurementAvailable1);
}



static int
dissect_rnsap_DedicatedMeasurementnotAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_null(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_measurementnotAvailable1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementnotAvailable(tvb, offset, pinfo, tree, hf_rnsap_measurementnotAvailable1);
}


static const value_string rnsap_DedicatedMeasurementValueInformation_vals[] = {
  {   0, "measurementAvailable" },
  {   1, "measurementnotAvailable" },
  { 0, NULL }
};

static const per_choice_t DedicatedMeasurementValueInformation_choice[] = {
  {   0, "measurementAvailable"        , ASN1_NO_EXTENSIONS     , dissect_measurementAvailable1 },
  {   1, "measurementnotAvailable"     , ASN1_NO_EXTENSIONS     , dissect_measurementnotAvailable1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DedicatedMeasurementValueInformation, DedicatedMeasurementValueInformation_choice,
                                 NULL);

  return offset;
}
static int dissect_dedicatedMeasurementValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DedicatedMeasurementValueInformation(tvb, offset, pinfo, tree, hf_rnsap_dedicatedMeasurementValueInformation);
}


static const per_sequence_t RL_InformationItem_DM_Rprt_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dPCH_ID },
  { "dedicatedMeasurementValueInformation", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dedicatedMeasurementValueInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationItem_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationItem_DM_Rprt, RL_InformationItem_DM_Rprt_sequence);

  return offset;
}
static int dissect_id_RL_InformationItem_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationItem_DM_Rprt(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationItem_DM_Rprt);
}


static const per_sequence_t RL_InformationItem_DM_Rqst_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dPCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationItem_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationItem_DM_Rqst, RL_InformationItem_DM_Rqst_sequence);

  return offset;
}
static int dissect_id_RL_InformationItem_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationItem_DM_Rqst(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationItem_DM_Rqst);
}


static const per_sequence_t RL_InformationItem_DM_Rsp_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dPCH_ID },
  { "dedicatedMeasurementValue"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dedicatedMeasurementValue },
  { "cFN"                         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cFN },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationItem_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationItem_DM_Rsp, RL_InformationItem_DM_Rsp_sequence);

  return offset;
}
static int dissect_id_RL_InformationItem_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationItem_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationItem_DM_Rsp);
}


static const per_sequence_t RL_InformationItem_RL_PreemptRequiredInd_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationItem_RL_PreemptRequiredInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationItem_RL_PreemptRequiredInd, RL_InformationItem_RL_PreemptRequiredInd_sequence);

  return offset;
}
static int dissect_id_RL_InformationItem_RL_PreemptRequiredInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationItem_RL_PreemptRequiredInd(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationItem_RL_PreemptRequiredInd);
}


static const value_string rnsap_FirstRLS_Indicator_vals[] = {
  {   0, "first-RLS" },
  {   1, "not-first-RLS" },
  { 0, NULL }
};


static int
dissect_rnsap_FirstRLS_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_firstRLS_indicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FirstRLS_Indicator(tvb, offset, pinfo, tree, hf_rnsap_firstRLS_indicator);
}
static int dissect_firstRLS_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FirstRLS_Indicator(tvb, offset, pinfo, tree, hf_rnsap_firstRLS_Indicator);
}



static int
dissect_rnsap_PropagationDelay(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_propagationDelay(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PropagationDelay(tvb, offset, pinfo, tree, hf_rnsap_propagationDelay);
}
static int dissect_propagation_delay(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PropagationDelay(tvb, offset, pinfo, tree, hf_rnsap_propagation_delay);
}


static const per_sequence_t RL_InformationItem_RL_SetupRqstFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "firstRLS-indicator"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_firstRLS_indicator },
  { "frameOffset"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_frameOffset },
  { "chipOffset"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_chipOffset },
  { "propagationDelay"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_propagationDelay },
  { "diversityControlField"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_diversityControlField },
  { "dl-InitialTX-Power"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_InitialTX_Power },
  { "primaryCPICH-EcNo"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primaryCPICH_EcNo },
  { "not-Used-sSDT-CellID"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_sSDT_CellID },
  { "transmitDiversityIndicator"  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transmitDiversityIndicator },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationItem_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationItem_RL_SetupRqstFDD, RL_InformationItem_RL_SetupRqstFDD_sequence);

  return offset;
}
static int dissect_id_RL_InformationItem_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationItem_RL_SetupRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationItem_RL_SetupRqstFDD);
}


static const per_sequence_t RL_InformationList_RL_CongestInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_RL_CongestInd_item },
};

static int
dissect_rnsap_RL_InformationList_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_RL_CongestInd, RL_InformationList_RL_CongestInd_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_id_RL_InformationList_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_RL_CongestInd(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationList_RL_CongestInd);
}


static const per_sequence_t RL_InformationList_RL_AdditionRqstFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_RL_AdditionRqstFDD_item },
};

static int
dissect_rnsap_RL_InformationList_RL_AdditionRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_RL_AdditionRqstFDD, RL_InformationList_RL_AdditionRqstFDD_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_id_RL_InformationList_RL_AdditionRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_RL_AdditionRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationList_RL_AdditionRqstFDD);
}


static const per_sequence_t RL_InformationList_RL_DeletionRqst_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_RL_DeletionRqst_item },
};

static int
dissect_rnsap_RL_InformationList_RL_DeletionRqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_RL_DeletionRqst, RL_InformationList_RL_DeletionRqst_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_id_RL_InformationList_RL_DeletionRqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_RL_DeletionRqst(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationList_RL_DeletionRqst);
}


static const per_sequence_t RL_InformationList_RL_PreemptRequiredInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_RL_PreemptRequiredInd_item },
};

static int
dissect_rnsap_RL_InformationList_RL_PreemptRequiredInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_RL_PreemptRequiredInd, RL_InformationList_RL_PreemptRequiredInd_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_id_RL_InformationList_RL_PreemptRequiredInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_RL_PreemptRequiredInd(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationList_RL_PreemptRequiredInd);
}


static const per_sequence_t RL_InformationList_RL_ReconfPrepFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_RL_ReconfPrepFDD_item },
};

static int
dissect_rnsap_RL_InformationList_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_RL_ReconfPrepFDD, RL_InformationList_RL_ReconfPrepFDD_sequence_of,
                                                  0, 16);

  return offset;
}
static int dissect_id_RL_InformationList_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_RL_ReconfPrepFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationList_RL_ReconfPrepFDD);
}


static const value_string rnsap_MultipleURAsIndicator_vals[] = {
  {   0, "multiple-URAs-exist" },
  {   1, "single-URA-exists" },
  { 0, NULL }
};


static int
dissect_rnsap_MultipleURAsIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_multipleURAsIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MultipleURAsIndicator(tvb, offset, pinfo, tree, hf_rnsap_multipleURAsIndicator);
}


static const per_sequence_t RNCsWithCellsInTheAccessedURA_Item_sequence[] = {
  { "rNC-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rNC_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RNCsWithCellsInTheAccessedURA_Item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RNCsWithCellsInTheAccessedURA_Item, RNCsWithCellsInTheAccessedURA_Item_sequence);

  return offset;
}
static int dissect_RNCsWithCellsInTheAccessedURA_List_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RNCsWithCellsInTheAccessedURA_Item(tvb, offset, pinfo, tree, hf_rnsap_RNCsWithCellsInTheAccessedURA_List_item);
}


static const per_sequence_t RNCsWithCellsInTheAccessedURA_List_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RNCsWithCellsInTheAccessedURA_List_item },
};

static int
dissect_rnsap_RNCsWithCellsInTheAccessedURA_List(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RNCsWithCellsInTheAccessedURA_List, RNCsWithCellsInTheAccessedURA_List_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_rNCsWithCellsInTheAccessedURA_List(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RNCsWithCellsInTheAccessedURA_List(tvb, offset, pinfo, tree, hf_rnsap_rNCsWithCellsInTheAccessedURA_List);
}


static const per_sequence_t URA_Information_sequence[] = {
  { "uRA-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uRA_ID },
  { "multipleURAsIndicator"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_multipleURAsIndicator },
  { "rNCsWithCellsInTheAccessedURA-List", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_rNCsWithCellsInTheAccessedURA_List },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_URA_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_URA_Information, URA_Information_sequence);

  return offset;
}
static int dissect_uRA_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_URA_Information(tvb, offset, pinfo, tree, hf_rnsap_uRA_Information);
}



static int
dissect_rnsap_SAC(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       2, 2, NULL);

  return offset;
}
static int dissect_sAC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SAC(tvb, offset, pinfo, tree, hf_rnsap_sAC);
}


static const per_sequence_t SAI_sequence[] = {
  { "pLMN-Identity"               , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_pLMN_Identity },
  { "lAC"                         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_lAC },
  { "sAC"                         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_sAC },
  { "iE-Extensions"               , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_SAI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_SAI, SAI_sequence);

  return offset;
}
static int dissect_id_SAI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SAI(tvb, offset, pinfo, tree, hf_rnsap_id_SAI);
}
static int dissect_sAI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SAI(tvb, offset, pinfo, tree, hf_rnsap_sAI);
}


static const value_string rnsap_T_latitudeSign_vals[] = {
  {   0, "north" },
  {   1, "south" },
  { 0, NULL }
};


static int
dissect_rnsap_T_latitudeSign(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_latitudeSign(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_latitudeSign(tvb, offset, pinfo, tree, hf_rnsap_latitudeSign);
}



static int
dissect_rnsap_INTEGER_0_8388607(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 8388607U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_latitude(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_8388607(tvb, offset, pinfo, tree, hf_rnsap_latitude);
}



static int
dissect_rnsap_INTEGER_M8388608_8388607(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -8388608, 8388607U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_longitude(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_M8388608_8388607(tvb, offset, pinfo, tree, hf_rnsap_longitude);
}


static const per_sequence_t GeographicalCoordinate_sequence[] = {
  { "latitudeSign"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_latitudeSign },
  { "latitude"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_latitude },
  { "longitude"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_longitude },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GeographicalCoordinate(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GeographicalCoordinate, GeographicalCoordinate_sequence);

  return offset;
}
static int dissect_cell_GAIgeographicalCoordinate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GeographicalCoordinate(tvb, offset, pinfo, tree, hf_rnsap_cell_GAIgeographicalCoordinate);
}
static int dissect_geographicalCoordinates(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GeographicalCoordinate(tvb, offset, pinfo, tree, hf_rnsap_geographicalCoordinates);
}
static int dissect_geographicalCoordinate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GeographicalCoordinate(tvb, offset, pinfo, tree, hf_rnsap_geographicalCoordinate);
}


static const per_sequence_t GA_Cell_item_sequence[] = {
  { "cell-GAIgeographicalCoordinate", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cell_GAIgeographicalCoordinate },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GA_Cell_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GA_Cell_item, GA_Cell_item_sequence);

  return offset;
}
static int dissect_GA_Cell_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_Cell_item(tvb, offset, pinfo, tree, hf_rnsap_GA_Cell_item);
}


static const per_sequence_t GA_Cell_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_GA_Cell_item },
};

static int
dissect_rnsap_GA_Cell(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_GA_Cell, GA_Cell_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_gA_Cell(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_Cell(tvb, offset, pinfo, tree, hf_rnsap_gA_Cell);
}


static const per_sequence_t GA_AccessPointPosition_sequence[] = {
  { "geographicalCoordinate"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_geographicalCoordinate },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GA_AccessPointPosition(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GA_AccessPointPosition, GA_AccessPointPosition_sequence);

  return offset;
}
static int dissect_gA_AccessPointPosition(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_AccessPointPosition(tvb, offset, pinfo, tree, hf_rnsap_gA_AccessPointPosition);
}



static int
dissect_rnsap_UL_TimeslotISCP(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 127U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_uplinkTimeslotISCPValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeslotISCP(tvb, offset, pinfo, tree, hf_rnsap_uplinkTimeslotISCPValue);
}
static int dissect_uL_TimeslotISCP(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeslotISCP(tvb, offset, pinfo, tree, hf_rnsap_uL_TimeslotISCP);
}


static const per_sequence_t UL_TimeSlot_ISCP_InfoItem_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "uL-TimeslotISCP"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_TimeslotISCP },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_TimeSlot_ISCP_InfoItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_TimeSlot_ISCP_InfoItem, UL_TimeSlot_ISCP_InfoItem_sequence);

  return offset;
}
static int dissect_UL_TimeSlot_ISCP_Info_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeSlot_ISCP_InfoItem(tvb, offset, pinfo, tree, hf_rnsap_UL_TimeSlot_ISCP_Info_item);
}


static const per_sequence_t UL_TimeSlot_ISCP_Info_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_TimeSlot_ISCP_Info_item },
};

static int
dissect_rnsap_UL_TimeSlot_ISCP_Info(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_TimeSlot_ISCP_Info, UL_TimeSlot_ISCP_Info_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_ul_TimeSlot_ISCP_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeSlot_ISCP_Info(tvb, offset, pinfo, tree, hf_rnsap_ul_TimeSlot_ISCP_Info);
}



static int
dissect_rnsap_UL_SIR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -82, 173U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ul_SIRTarget(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_SIR(tvb, offset, pinfo, tree, hf_rnsap_ul_SIRTarget);
}
static int dissect_maxUL_SIR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_SIR(tvb, offset, pinfo, tree, hf_rnsap_maxUL_SIR);
}
static int dissect_minUL_SIR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_SIR(tvb, offset, pinfo, tree, hf_rnsap_minUL_SIR);
}
static int dissect_max_UL_SIR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_SIR(tvb, offset, pinfo, tree, hf_rnsap_max_UL_SIR);
}
static int dissect_min_UL_SIR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_SIR(tvb, offset, pinfo, tree, hf_rnsap_min_UL_SIR);
}



static int
dissect_rnsap_MaximumAllowedULTxPower(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -50, 33U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_maximumAllowedULTxPower(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MaximumAllowedULTxPower(tvb, offset, pinfo, tree, hf_rnsap_maximumAllowedULTxPower);
}


static const value_string rnsap_TimingAdvanceApplied_vals[] = {
  {   0, "yes" },
  {   1, "no" },
  { 0, NULL }
};


static int
dissect_rnsap_TimingAdvanceApplied(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_timingAdvanceApplied(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TimingAdvanceApplied(tvb, offset, pinfo, tree, hf_rnsap_timingAdvanceApplied);
}



static int
dissect_rnsap_AlphaValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 8U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_alphaValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AlphaValue(tvb, offset, pinfo, tree, hf_rnsap_alphaValue);
}


static const value_string rnsap_UL_PhysCH_SF_Variation_vals[] = {
  {   0, "sf-variation-supported" },
  {   1, "sf-variation-not-supported" },
  { 0, NULL }
};


static int
dissect_rnsap_UL_PhysCH_SF_Variation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ul_PhysCH_SF_Variation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_PhysCH_SF_Variation(tvb, offset, pinfo, tree, hf_rnsap_ul_PhysCH_SF_Variation);
}



static int
dissect_rnsap_INTEGER_1_256(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 256U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_n_INSYNC_IND(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_256(tvb, offset, pinfo, tree, hf_rnsap_n_INSYNC_IND);
}
static int dissect_n_OUTSYNC_IND(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_256(tvb, offset, pinfo, tree, hf_rnsap_n_OUTSYNC_IND);
}


static const per_sequence_t SynchronisationConfiguration_sequence[] = {
  { "n-INSYNC-IND"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_n_INSYNC_IND },
  { "n-OUTSYNC-IND"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_n_OUTSYNC_IND },
  { "t-RLFAILURE"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_t_RLFAILURE },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_SynchronisationConfiguration(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_SynchronisationConfiguration, SynchronisationConfiguration_sequence);

  return offset;
}
static int dissect_synchronisationConfiguration(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SynchronisationConfiguration(tvb, offset, pinfo, tree, hf_rnsap_synchronisationConfiguration);
}


static const per_sequence_t Secondary_CCPCH_TDD_Code_InformationItem_sequence[] = {
  { "tDD-ChannelisationCode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_ChannelisationCode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Secondary_CCPCH_TDD_Code_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Secondary_CCPCH_TDD_Code_InformationItem, Secondary_CCPCH_TDD_Code_InformationItem_sequence);

  return offset;
}
static int dissect_Secondary_CCPCH_TDD_Code_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_CCPCH_TDD_Code_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_Secondary_CCPCH_TDD_Code_Information_item);
}


static const per_sequence_t Secondary_CCPCH_TDD_Code_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Secondary_CCPCH_TDD_Code_Information_item },
};

static int
dissect_rnsap_Secondary_CCPCH_TDD_Code_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Secondary_CCPCH_TDD_Code_Information, Secondary_CCPCH_TDD_Code_Information_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_secondary_CCPCH_TDD_Code_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_CCPCH_TDD_Code_Information(tvb, offset, pinfo, tree, hf_rnsap_secondary_CCPCH_TDD_Code_Information);
}



static int
dissect_rnsap_TDD_PhysicalChannelOffset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 63U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tDD_PhysicalChannelOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_PhysicalChannelOffset(tvb, offset, pinfo, tree, hf_rnsap_tDD_PhysicalChannelOffset);
}


static const per_sequence_t Secondary_CCPCH_TDD_InformationItem_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftAndBurstType },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Presence },
  { "secondary-CCPCH-TDD-Code-Information", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_secondary_CCPCH_TDD_Code_Information },
  { "tDD-PhysicalChannelOffset"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_PhysicalChannelOffset },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Secondary_CCPCH_TDD_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Secondary_CCPCH_TDD_InformationItem, Secondary_CCPCH_TDD_InformationItem_sequence);

  return offset;
}
static int dissect_Secondary_CCPCH_TDD_InformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_CCPCH_TDD_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_Secondary_CCPCH_TDD_InformationList_item);
}


static const per_sequence_t Secondary_CCPCH_TDD_InformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Secondary_CCPCH_TDD_InformationList_item },
};

static int
dissect_rnsap_Secondary_CCPCH_TDD_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Secondary_CCPCH_TDD_InformationList, Secondary_CCPCH_TDD_InformationList_sequence_of,
                                                  0, 8);

  return offset;
}
static int dissect_secondary_CCPCH_TDD_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_CCPCH_TDD_InformationList(tvb, offset, pinfo, tree, hf_rnsap_secondary_CCPCH_TDD_InformationList);
}


static const per_sequence_t FACH_InformationItem_sequence[] = {
  { "transportFormatSet"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatSet },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_FACH_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_FACH_InformationItem, FACH_InformationItem_sequence);

  return offset;
}
static int dissect_FACH_InformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FACH_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_FACH_InformationList_item);
}


static const per_sequence_t FACH_InformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_FACH_InformationList_item },
};

static int
dissect_rnsap_FACH_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_FACH_InformationList, FACH_InformationList_sequence_of,
                                                  0, 8);

  return offset;
}
static int dissect_fACH_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FACH_InformationList(tvb, offset, pinfo, tree, hf_rnsap_fACH_InformationList);
}


static const per_sequence_t PCH_InformationItem_sequence[] = {
  { "transportFormatSet"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatSet },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PCH_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PCH_InformationItem, PCH_InformationItem_sequence);

  return offset;
}
static int dissect_PCH_InformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PCH_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_PCH_InformationList_item);
}


static const per_sequence_t PCH_InformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_PCH_InformationList_item },
};

static int
dissect_rnsap_PCH_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_PCH_InformationList, PCH_InformationList_sequence_of,
                                                  0, 1);

  return offset;
}
static int dissect_pCH_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PCH_InformationList(tvb, offset, pinfo, tree, hf_rnsap_pCH_InformationList);
}


static const per_sequence_t Secondary_CCPCH_Info_TDD_sequence[] = {
  { "dl-TFCS"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_TFCS },
  { "tFCI-Coding"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Coding },
  { "secondary-CCPCH-TDD-InformationList", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_secondary_CCPCH_TDD_InformationList },
  { "fACH-InformationList"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fACH_InformationList },
  { "pCH-InformationList"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pCH_InformationList },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Secondary_CCPCH_Info_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Secondary_CCPCH_Info_TDD, Secondary_CCPCH_Info_TDD_sequence);

  return offset;
}
static int dissect_secondary_CCPCH_Info_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_CCPCH_Info_TDD(tvb, offset, pinfo, tree, hf_rnsap_secondary_CCPCH_Info_TDD);
}



static int
dissect_rnsap_UL_CCTrCHInformationList_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_CCTrCHInformation1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_CCTrCHInformationList_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_CCTrCHInformation1);
}



static int
dissect_rnsap_DL_CCTrCHInformationList_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_CCTrCHInformation1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCHInformationList_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_CCTrCHInformation1);
}


static const per_sequence_t Combining_RL_AdditionRspTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Combining_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Combining_RL_AdditionRspTDD, Combining_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_combining3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Combining_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_combining3);
}


static const per_sequence_t NonCombining_RL_AdditionRspTDD_sequence[] = {
  { "dCH-InformationResponse"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_InformationResponse },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_NonCombining_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_NonCombining_RL_AdditionRspTDD, NonCombining_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_nonCombining1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NonCombining_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_nonCombining1);
}


static const value_string rnsap_DiversityIndication_RL_AdditionRspTDD_vals[] = {
  {   0, "combining" },
  {   1, "nonCombining" },
  { 0, NULL }
};

static const per_choice_t DiversityIndication_RL_AdditionRspTDD_choice[] = {
  {   0, "combining"                   , ASN1_NO_EXTENSIONS     , dissect_combining3 },
  {   1, "nonCombining"                , ASN1_NO_EXTENSIONS     , dissect_nonCombining1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DiversityIndication_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DiversityIndication_RL_AdditionRspTDD, DiversityIndication_RL_AdditionRspTDD_choice,
                                 NULL);

  return offset;
}
static int dissect_diversityIndication3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DiversityIndication_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_diversityIndication3);
}


static const per_sequence_t DCH_Information_RL_AdditionRspTDD_sequence[] = {
  { "diversityIndication"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_diversityIndication3 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DCH_Information_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DCH_Information_RL_AdditionRspTDD, DCH_Information_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_dCH_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_Information_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dCH_Information);
}



static int
dissect_rnsap_DSCH_InformationResponse_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dSCH_InformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_InformationResponse_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dSCH_InformationResponse);
}



static int
dissect_rnsap_USCH_InformationResponse_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_uSCH_InformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_InformationResponse_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_uSCH_InformationResponse);
}


static const per_sequence_t Neighbouring_UMTS_CellInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Neighbouring_UMTS_CellInformation_item },
};

static int
dissect_rnsap_Neighbouring_UMTS_CellInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Neighbouring_UMTS_CellInformation, Neighbouring_UMTS_CellInformation_sequence_of,
                                                  1, 10);

  return offset;
}
static int dissect_neighbouring_UMTS_CellInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Neighbouring_UMTS_CellInformation(tvb, offset, pinfo, tree, hf_rnsap_neighbouring_UMTS_CellInformation);
}


static const per_sequence_t RL_InformationResponse_RL_AdditionRspTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "uRA-Information"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uRA_Information },
  { "sAI"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAI },
  { "gA-Cell"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_Cell },
  { "gA-AccessPointPosition"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_AccessPointPosition },
  { "ul-TimeSlot-ISCP-Info"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_TimeSlot_ISCP_Info },
  { "minUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minUL_SIR },
  { "maxUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxUL_SIR },
  { "maximumAllowedULTxPower"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumAllowedULTxPower },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minimumDLTxPower },
  { "pCCPCH-Power"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pCCPCH_Power },
  { "timingAdvanceApplied"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timingAdvanceApplied },
  { "alphaValue"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_alphaValue },
  { "ul-PhysCH-SF-Variation"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_PhysCH_SF_Variation },
  { "synchronisationConfiguration", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_synchronisationConfiguration },
  { "secondary-CCPCH-Info-TDD"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_secondary_CCPCH_Info_TDD },
  { "ul-CCTrCHInformation"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_CCTrCHInformation1 },
  { "dl-CCTrCHInformation"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_CCTrCHInformation1 },
  { "dCH-Information"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dCH_Information },
  { "dSCH-InformationResponse"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dSCH_InformationResponse },
  { "uSCH-InformationResponse"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uSCH_InformationResponse },
  { "neighbouring-UMTS-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_UMTS_CellInformation },
  { "neighbouring-GSM-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_GSM_CellInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationResponse_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationResponse_RL_AdditionRspTDD, RL_InformationResponse_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_id_RL_InformationResponse_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponse_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponse_RL_AdditionRspTDD);
}



static int
dissect_rnsap_UL_CCTrCH_InformationList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_CCTrCH_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_CCTrCH_InformationList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_CCTrCH_Information);
}



static int
dissect_rnsap_DL_CCTrCH_InformationList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_CCTrCH_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_CCTrCH_Information);
}



static int
dissect_rnsap_DCH_InformationResponseList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dCHInformationResponse1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_InformationResponseList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_dCHInformationResponse1);
}



static int
dissect_rnsap_DSCHToBeAddedOrModified_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dSCHsToBeAddedOrModified(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCHToBeAddedOrModified_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_dSCHsToBeAddedOrModified);
}



static int
dissect_rnsap_USCHToBeAddedOrModified_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_uSCHsToBeAddedOrModified(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCHToBeAddedOrModified_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_uSCHsToBeAddedOrModified);
}


static const per_sequence_t RL_InformationResponse_RL_ReconfReadyTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "max-UL-SIR"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_max_UL_SIR },
  { "min-UL-SIR"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_min_UL_SIR },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_minimumDLTxPower },
  { "secondary-CCPCH-Info-TDD"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_secondary_CCPCH_Info_TDD },
  { "ul-CCTrCH-Information"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_CCTrCH_Information },
  { "dl-CCTrCH-Information"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_CCTrCH_Information },
  { "dCHInformationResponse"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dCHInformationResponse1 },
  { "dSCHsToBeAddedOrModified"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dSCHsToBeAddedOrModified },
  { "uSCHsToBeAddedOrModified"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uSCHsToBeAddedOrModified },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationResponse_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationResponse_RL_ReconfReadyTDD, RL_InformationResponse_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_id_RL_InformationResponse_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponse_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponse_RL_ReconfReadyTDD);
}
static int dissect_Multiple_RL_InformationResponse_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponse_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_Multiple_RL_InformationResponse_RL_ReconfReadyTDD_item);
}



static int
dissect_rnsap_UL_CCTrCHInformationList_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_CCTrCHInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_CCTrCHInformationList_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_CCTrCHInformation);
}



static int
dissect_rnsap_DL_CCTrCHInformationList_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_CCTrCHInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCHInformationList_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_CCTrCHInformation);
}



static int
dissect_rnsap_DCH_InformationResponseList_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dCH_InformationResponse1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_InformationResponseList_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dCH_InformationResponse1);
}



static int
dissect_rnsap_DSCH_InformationResponse_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dsch_InformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_InformationResponse_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dsch_InformationResponse);
}



static int
dissect_rnsap_USCH_InformationResponse_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_usch_InformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_InformationResponse_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_usch_InformationResponse);
}


static const per_sequence_t RL_InformationResponse_RL_SetupRspTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "uRA-Information"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uRA_Information },
  { "sAI"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAI },
  { "gA-Cell"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_Cell },
  { "gA-AccessPointPosition"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_AccessPointPosition },
  { "ul-TimeSlot-ISCP-Info"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_TimeSlot_ISCP_Info },
  { "maxUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxUL_SIR },
  { "minUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minUL_SIR },
  { "maximumAllowedULTxPower"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumAllowedULTxPower },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minimumDLTxPower },
  { "uARFCNforNt"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uARFCNforNt },
  { "cellParameterID"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cellParameterID },
  { "syncCase"                    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_syncCase },
  { "sCH-TimeSlot"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_sCH_TimeSlot },
  { "sCTD-Indicator"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_sCTD_Indicator },
  { "pCCPCH-Power"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pCCPCH_Power },
  { "timingAdvanceApplied"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timingAdvanceApplied },
  { "alphaValue"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_alphaValue },
  { "ul-PhysCH-SF-Variation"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_PhysCH_SF_Variation },
  { "synchronisationConfiguration", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_synchronisationConfiguration },
  { "secondary-CCPCH-Info-TDD"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_secondary_CCPCH_Info_TDD },
  { "ul-CCTrCHInformation"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_CCTrCHInformation },
  { "dl-CCTrCHInformation"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_CCTrCHInformation },
  { "dCH-InformationResponse"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dCH_InformationResponse1 },
  { "dsch-InformationResponse"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dsch_InformationResponse },
  { "usch-InformationResponse"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_usch_InformationResponse },
  { "neighbouring-UMTS-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_UMTS_CellInformation },
  { "neighbouring-GSM-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_GSM_CellInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationResponse_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationResponse_RL_SetupRspTDD, RL_InformationResponse_RL_SetupRspTDD_sequence);

  return offset;
}
static int dissect_id_RL_InformationResponse_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponse_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponse_RL_SetupRspTDD);
}



static int
dissect_rnsap_RL_Set_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 31U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_rL_Set_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_ID(tvb, offset, pinfo, tree, hf_rnsap_rL_Set_ID);
}



static int
dissect_rnsap_Received_total_wide_band_power(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 621U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_received_total_wide_band_power(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Received_total_wide_band_power(tvb, offset, pinfo, tree, hf_rnsap_received_total_wide_band_power);
}



static int
dissect_rnsap_DL_CodeInformationList_RL_AdditionRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_CodeInformation1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CodeInformationList_RL_AdditionRspFDD(tvb, offset, pinfo, tree, hf_rnsap_dl_CodeInformation1);
}


static const per_sequence_t Combining_RL_AdditionRspFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Combining_RL_AdditionRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Combining_RL_AdditionRspFDD, Combining_RL_AdditionRspFDD_sequence);

  return offset;
}
static int dissect_combining2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Combining_RL_AdditionRspFDD(tvb, offset, pinfo, tree, hf_rnsap_combining2);
}


static const per_sequence_t NonCombining_RL_AdditionRspFDD_sequence[] = {
  { "dCH-InformationResponse"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_InformationResponse },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_NonCombining_RL_AdditionRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_NonCombining_RL_AdditionRspFDD, NonCombining_RL_AdditionRspFDD_sequence);

  return offset;
}
static int dissect_nonCombining(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NonCombining_RL_AdditionRspFDD(tvb, offset, pinfo, tree, hf_rnsap_nonCombining);
}


static const value_string rnsap_DiversityIndication_RL_AdditionRspFDD_vals[] = {
  {   0, "combining" },
  {   1, "nonCombining" },
  { 0, NULL }
};

static const per_choice_t DiversityIndication_RL_AdditionRspFDD_choice[] = {
  {   0, "combining"                   , ASN1_NO_EXTENSIONS     , dissect_combining2 },
  {   1, "nonCombining"                , ASN1_NO_EXTENSIONS     , dissect_nonCombining },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DiversityIndication_RL_AdditionRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DiversityIndication_RL_AdditionRspFDD, DiversityIndication_RL_AdditionRspFDD_choice,
                                 NULL);

  return offset;
}
static int dissect_diversityIndication2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DiversityIndication_RL_AdditionRspFDD(tvb, offset, pinfo, tree, hf_rnsap_diversityIndication2);
}


static const value_string rnsap_SSDT_SupportIndicator_vals[] = {
  {   0, "not-Used-sSDT-supported" },
  {   1, "sSDT-not-supported" },
  { 0, NULL }
};


static int
dissect_rnsap_SSDT_SupportIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sSDT_SupportIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SSDT_SupportIndicator(tvb, offset, pinfo, tree, hf_rnsap_sSDT_SupportIndicator);
}


static const value_string rnsap_Closedlooptimingadjustmentmode_vals[] = {
  {   0, "adj-1-slot" },
  {   1, "adj-2-slot" },
  { 0, NULL }
};


static int
dissect_rnsap_Closedlooptimingadjustmentmode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_closedlooptimingadjustmentmode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Closedlooptimingadjustmentmode(tvb, offset, pinfo, tree, hf_rnsap_closedlooptimingadjustmentmode);
}



static int
dissect_rnsap_PC_Preamble(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 7U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_pC_Preamble(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PC_Preamble(tvb, offset, pinfo, tree, hf_rnsap_pC_Preamble);
}



static int
dissect_rnsap_SRB_Delay(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 7U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_sRB_Delay(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SRB_Delay(tvb, offset, pinfo, tree, hf_rnsap_sRB_Delay);
}


static const per_sequence_t RL_InformationResponseItem_RL_AdditionRspFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "uRA-Information"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uRA_Information },
  { "sAI"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAI },
  { "gA-Cell"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_Cell },
  { "gA-AccessPointPosition"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_AccessPointPosition },
  { "received-total-wide-band-power", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_received_total_wide_band_power },
  { "not-Used-secondary-CCPCH-Info", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_secondary_CCPCH_Info },
  { "dl-CodeInformation"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_CodeInformation1 },
  { "diversityIndication"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_diversityIndication2 },
  { "sSDT-SupportIndicator"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sSDT_SupportIndicator },
  { "minUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minUL_SIR },
  { "maxUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxUL_SIR },
  { "closedlooptimingadjustmentmode", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_closedlooptimingadjustmentmode },
  { "maximumAllowedULTxPower"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumAllowedULTxPower },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minimumDLTxPower },
  { "neighbouring-UMTS-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_UMTS_CellInformation },
  { "neighbouring-GSM-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_GSM_CellInformation },
  { "pC-Preamble"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pC_Preamble },
  { "sRB-Delay"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sRB_Delay },
  { "primaryCPICH-Power"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_primaryCPICH_Power },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationResponseItem_RL_AdditionRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationResponseItem_RL_AdditionRspFDD, RL_InformationResponseItem_RL_AdditionRspFDD_sequence);

  return offset;
}
static int dissect_id_RL_InformationResponseItem_RL_AdditionRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponseItem_RL_AdditionRspFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponseItem_RL_AdditionRspFDD);
}



static int
dissect_rnsap_DL_CodeInformationList_RL_ReconfReadyFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_CodeInformationList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CodeInformationList_RL_ReconfReadyFDD(tvb, offset, pinfo, tree, hf_rnsap_dl_CodeInformationList);
}



static int
dissect_rnsap_DCH_InformationResponseList_RL_ReconfReadyFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dCHInformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_InformationResponseList_RL_ReconfReadyFDD(tvb, offset, pinfo, tree, hf_rnsap_dCHInformationResponse);
}


static const per_sequence_t RL_InformationResponseItem_RL_ReconfReadyFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "max-UL-SIR"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_max_UL_SIR },
  { "min-UL-SIR"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_min_UL_SIR },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_minimumDLTxPower },
  { "not-Used-secondary-CCPCH-Info", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_secondary_CCPCH_Info },
  { "dl-CodeInformationList"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_CodeInformationList },
  { "dCHInformationResponse"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dCHInformationResponse },
  { "not-Used-dSCHsToBeAddedOrModified", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_dSCHsToBeAddedOrModified },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationResponseItem_RL_ReconfReadyFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationResponseItem_RL_ReconfReadyFDD, RL_InformationResponseItem_RL_ReconfReadyFDD_sequence);

  return offset;
}
static int dissect_id_RL_InformationResponseItem_RL_ReconfReadyFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponseItem_RL_ReconfReadyFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponseItem_RL_ReconfReadyFDD);
}



static int
dissect_rnsap_DCH_InformationResponseList_RL_ReconfRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dCHsInformationResponseList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_InformationResponseList_RL_ReconfRspFDD(tvb, offset, pinfo, tree, hf_rnsap_dCHsInformationResponseList);
}



static int
dissect_rnsap_DL_CodeInformationList_RL_ReconfRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dL_CodeInformationList_RL_ReconfResp(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CodeInformationList_RL_ReconfRspFDD(tvb, offset, pinfo, tree, hf_rnsap_dL_CodeInformationList_RL_ReconfResp);
}


static const per_sequence_t RL_InformationResponseItem_RL_ReconfRspFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "max-UL-SIR"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_max_UL_SIR },
  { "min-UL-SIR"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_min_UL_SIR },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_minimumDLTxPower },
  { "not-Used-secondary-CCPCH-Info", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_secondary_CCPCH_Info },
  { "dCHsInformationResponseList" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dCHsInformationResponseList },
  { "dL-CodeInformationList-RL-ReconfResp", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_CodeInformationList_RL_ReconfResp },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationResponseItem_RL_ReconfRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationResponseItem_RL_ReconfRspFDD, RL_InformationResponseItem_RL_ReconfRspFDD_sequence);

  return offset;
}
static int dissect_id_RL_InformationResponseItem_RL_ReconfRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponseItem_RL_ReconfRspFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponseItem_RL_ReconfRspFDD);
}


static const per_sequence_t Combining_RL_SetupRspFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Combining_RL_SetupRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Combining_RL_SetupRspFDD, Combining_RL_SetupRspFDD_sequence);

  return offset;
}
static int dissect_combining(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Combining_RL_SetupRspFDD(tvb, offset, pinfo, tree, hf_rnsap_combining);
}


static const per_sequence_t NonCombiningOrFirstRL_RL_SetupRspFDD_sequence[] = {
  { "dCH-InformationResponse"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_InformationResponse },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_NonCombiningOrFirstRL_RL_SetupRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_NonCombiningOrFirstRL_RL_SetupRspFDD, NonCombiningOrFirstRL_RL_SetupRspFDD_sequence);

  return offset;
}
static int dissect_nonCombiningOrFirstRL(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NonCombiningOrFirstRL_RL_SetupRspFDD(tvb, offset, pinfo, tree, hf_rnsap_nonCombiningOrFirstRL);
}


static const value_string rnsap_DiversityIndication_RL_SetupRspFDD_vals[] = {
  {   0, "combining" },
  {   1, "nonCombiningOrFirstRL" },
  { 0, NULL }
};

static const per_choice_t DiversityIndication_RL_SetupRspFDD_choice[] = {
  {   0, "combining"                   , ASN1_NO_EXTENSIONS     , dissect_combining },
  {   1, "nonCombiningOrFirstRL"       , ASN1_NO_EXTENSIONS     , dissect_nonCombiningOrFirstRL },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DiversityIndication_RL_SetupRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DiversityIndication_RL_SetupRspFDD, DiversityIndication_RL_SetupRspFDD_choice,
                                 NULL);

  return offset;
}
static int dissect_diversityIndication(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DiversityIndication_RL_SetupRspFDD(tvb, offset, pinfo, tree, hf_rnsap_diversityIndication);
}


static const per_sequence_t RL_InformationResponseItem_RL_SetupRspFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "uRA-Information"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uRA_Information },
  { "sAI"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAI },
  { "gA-Cell"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_Cell },
  { "gA-AccessPointPosition"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_AccessPointPosition },
  { "received-total-wide-band-power", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_received_total_wide_band_power },
  { "not-Used-secondary-CCPCH-Info", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_secondary_CCPCH_Info },
  { "dl-CodeInformation"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_CodeInformation },
  { "diversityIndication"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_diversityIndication },
  { "sSDT-SupportIndicator"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sSDT_SupportIndicator },
  { "maxUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxUL_SIR },
  { "minUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minUL_SIR },
  { "closedlooptimingadjustmentmode", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_closedlooptimingadjustmentmode },
  { "maximumAllowedULTxPower"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumAllowedULTxPower },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minimumDLTxPower },
  { "primaryScramblingCode"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primaryScramblingCode },
  { "uL-UARFCN"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uL_UARFCN },
  { "dL-UARFCN"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_UARFCN },
  { "primaryCPICH-Power"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_primaryCPICH_Power },
  { "not-Used-dSCHInformationResponse", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_dSCHInformationResponse },
  { "neighbouring-UMTS-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_UMTS_CellInformation },
  { "neighbouring-GSM-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_GSM_CellInformation },
  { "pC-Preamble"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pC_Preamble },
  { "sRB-Delay"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sRB_Delay },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationResponseItem_RL_SetupRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationResponseItem_RL_SetupRspFDD, RL_InformationResponseItem_RL_SetupRspFDD_sequence);

  return offset;
}
static int dissect_id_RL_InformationResponseItem_RL_SetupRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponseItem_RL_SetupRspFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponseItem_RL_SetupRspFDD);
}


static const per_sequence_t RL_InformationResponseList_RL_AdditionRspFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationResponseList_RL_AdditionRspFDD_item },
};

static int
dissect_rnsap_RL_InformationResponseList_RL_AdditionRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationResponseList_RL_AdditionRspFDD, RL_InformationResponseList_RL_AdditionRspFDD_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_id_RL_InformationResponseList_RL_AdditionRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponseList_RL_AdditionRspFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponseList_RL_AdditionRspFDD);
}


static const per_sequence_t RL_InformationResponseList_RL_ReconfReadyFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationResponseList_RL_ReconfReadyFDD_item },
};

static int
dissect_rnsap_RL_InformationResponseList_RL_ReconfReadyFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationResponseList_RL_ReconfReadyFDD, RL_InformationResponseList_RL_ReconfReadyFDD_sequence_of,
                                                  0, 16);

  return offset;
}
static int dissect_id_RL_InformationResponseList_RL_ReconfReadyFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponseList_RL_ReconfReadyFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponseList_RL_ReconfReadyFDD);
}


static const per_sequence_t RL_InformationResponseList_RL_ReconfRspFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationResponseList_RL_ReconfRspFDD_item },
};

static int
dissect_rnsap_RL_InformationResponseList_RL_ReconfRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationResponseList_RL_ReconfRspFDD, RL_InformationResponseList_RL_ReconfRspFDD_sequence_of,
                                                  0, 16);

  return offset;
}
static int dissect_id_RL_InformationResponseList_RL_ReconfRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponseList_RL_ReconfRspFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponseList_RL_ReconfRspFDD);
}



static int
dissect_rnsap_DCH_InformationResponseList_RL_ReconfRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dCHsInformationResponseList1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_InformationResponseList_RL_ReconfRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dCHsInformationResponseList1);
}


static const per_sequence_t RL_InformationResponse_RL_ReconfRspTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "max-UL-SIR"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_max_UL_SIR },
  { "min-UL-SIR"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_min_UL_SIR },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_minimumDLTxPower },
  { "dCHsInformationResponseList" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dCHsInformationResponseList1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationResponse_RL_ReconfRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationResponse_RL_ReconfRspTDD, RL_InformationResponse_RL_ReconfRspTDD_sequence);

  return offset;
}
static int dissect_id_RL_InformationResponse_RL_ReconfRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponse_RL_ReconfRspTDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponse_RL_ReconfRspTDD);
}
static int dissect_Multiple_RL_InformationResponse_RL_ReconfRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponse_RL_ReconfRspTDD(tvb, offset, pinfo, tree, hf_rnsap_Multiple_RL_InformationResponse_RL_ReconfRspTDD_item);
}


static const per_sequence_t RL_InformationResponseList_RL_SetupRspFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationResponseList_RL_SetupRspFDD_item },
};

static int
dissect_rnsap_RL_InformationResponseList_RL_SetupRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationResponseList_RL_SetupRspFDD, RL_InformationResponseList_RL_SetupRspFDD_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_id_RL_InformationResponseList_RL_SetupRspFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationResponseList_RL_SetupRspFDD(tvb, offset, pinfo, tree, hf_rnsap_id_RL_InformationResponseList_RL_SetupRspFDD);
}


static const per_sequence_t RL_ReconfigurationFailure_RL_ReconfFail_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_ReconfigurationFailure_RL_ReconfFail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_ReconfigurationFailure_RL_ReconfFail, RL_ReconfigurationFailure_RL_ReconfFail_sequence);

  return offset;
}
static int dissect_id_RL_ReconfigurationFailure_RL_ReconfFail(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_ReconfigurationFailure_RL_ReconfFail(tvb, offset, pinfo, tree, hf_rnsap_id_RL_ReconfigurationFailure_RL_ReconfFail);
}


static const per_sequence_t RL_Set_InformationItem_DM_Rprt_sequence[] = {
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "dedicatedMeasurementValueInformation", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dedicatedMeasurementValueInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_InformationItem_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_InformationItem_DM_Rprt, RL_Set_InformationItem_DM_Rprt_sequence);

  return offset;
}
static int dissect_id_RL_Set_InformationItem_DM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_InformationItem_DM_Rprt(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Set_InformationItem_DM_Rprt);
}


static const per_sequence_t RL_Set_InformationItem_DM_Rqst_sequence[] = {
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_InformationItem_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_InformationItem_DM_Rqst, RL_Set_InformationItem_DM_Rqst_sequence);

  return offset;
}
static int dissect_id_RL_Set_InformationItem_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_InformationItem_DM_Rqst(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Set_InformationItem_DM_Rqst);
}


static const per_sequence_t RL_Set_InformationItem_DM_Rsp_sequence[] = {
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "dedicatedMeasurementValue"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dedicatedMeasurementValue },
  { "cFN"                         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cFN },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_InformationItem_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_InformationItem_DM_Rsp, RL_Set_InformationItem_DM_Rsp_sequence);

  return offset;
}
static int dissect_id_RL_Set_InformationItem_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_InformationItem_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Set_InformationItem_DM_Rsp);
}


static const per_sequence_t RL_Set_Information_RL_FailureInd_sequence[] = {
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_Information_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_Information_RL_FailureInd, RL_Set_Information_RL_FailureInd_sequence);

  return offset;
}
static int dissect_id_RL_Set_Information_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_Information_RL_FailureInd(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Set_Information_RL_FailureInd);
}


static const per_sequence_t RL_Set_Information_RL_RestoreInd_sequence[] = {
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_Information_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_Information_RL_RestoreInd, RL_Set_Information_RL_RestoreInd_sequence);

  return offset;
}
static int dissect_id_RL_Set_Information_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_Information_RL_RestoreInd(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Set_Information_RL_RestoreInd);
}


static const per_sequence_t RL_Set_Successful_InformationItem_DM_Fail_sequence[] = {
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "dedicatedMeasurementValue"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dedicatedMeasurementValue },
  { "cFN"                         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cFN },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_Successful_InformationItem_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_Successful_InformationItem_DM_Fail, RL_Set_Successful_InformationItem_DM_Fail_sequence);

  return offset;
}
static int dissect_id_RL_Set_Successful_InformationItem_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_Successful_InformationItem_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Set_Successful_InformationItem_DM_Fail);
}


static const per_sequence_t RL_Set_Unsuccessful_InformationItem_DM_Fail_sequence[] = {
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "individualcause"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_individualcause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_Unsuccessful_InformationItem_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_Unsuccessful_InformationItem_DM_Fail, RL_Set_Unsuccessful_InformationItem_DM_Fail_sequence);

  return offset;
}
static int dissect_id_RL_Set_Unsuccessful_InformationItem_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_Unsuccessful_InformationItem_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Set_Unsuccessful_InformationItem_DM_Fail);
}


static const per_sequence_t RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_sequence[] = {
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "individualcause"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_individualcause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind, RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_sequence);

  return offset;
}
static int dissect_id_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind);
}


static const per_sequence_t RL_Successful_InformationItem_DM_Fail_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dPCH_ID },
  { "dedicatedMeasurementValue"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dedicatedMeasurementValue },
  { "cFN"                         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cFN },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Successful_InformationItem_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Successful_InformationItem_DM_Fail, RL_Successful_InformationItem_DM_Fail_sequence);

  return offset;
}
static int dissect_id_RL_Successful_InformationItem_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Successful_InformationItem_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Successful_InformationItem_DM_Fail);
}


static const per_sequence_t RL_Unsuccessful_InformationItem_DM_Fail_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "individualcause"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_individualcause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Unsuccessful_InformationItem_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Unsuccessful_InformationItem_DM_Fail, RL_Unsuccessful_InformationItem_DM_Fail_sequence);

  return offset;
}
static int dissect_id_RL_Unsuccessful_InformationItem_DM_Fail(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Unsuccessful_InformationItem_DM_Fail(tvb, offset, pinfo, tree, hf_rnsap_id_RL_Unsuccessful_InformationItem_DM_Fail);
}



static int
dissect_rnsap_RT_Load_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 100U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_RT_Load_Value(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RT_Load_Value(tvb, offset, pinfo, tree, hf_rnsap_id_RT_Load_Value);
}



static int
dissect_rnsap_RT_Load_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 100U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_RT_Load_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RT_Load_Value_IncrDecrThres(tvb, offset, pinfo, tree, hf_rnsap_id_RT_Load_Value_IncrDecrThres);
}


static const per_sequence_t ContextInfoList_Reset_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ContextInfoList_Reset_item },
};

static int
dissect_rnsap_ContextInfoList_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_ContextInfoList_Reset, ContextInfoList_Reset_sequence_of,
                                                  1, 250);

  return offset;
}
static int dissect_contextInfoList_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ContextInfoList_Reset(tvb, offset, pinfo, tree, hf_rnsap_contextInfoList_Reset);
}


static const per_sequence_t ContextList_Reset_sequence[] = {
  { "contextInfoList-Reset"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_contextInfoList_Reset },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ContextList_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ContextList_Reset, ContextList_Reset_sequence);

  return offset;
}
static int dissect_context(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ContextList_Reset(tvb, offset, pinfo, tree, hf_rnsap_context);
}


static const per_sequence_t ContextGroupInfoList_Reset_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ContextGroupInfoList_Reset_item },
};

static int
dissect_rnsap_ContextGroupInfoList_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_ContextGroupInfoList_Reset, ContextGroupInfoList_Reset_sequence_of,
                                                  1, 32);

  return offset;
}
static int dissect_contextGroupInfoList_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ContextGroupInfoList_Reset(tvb, offset, pinfo, tree, hf_rnsap_contextGroupInfoList_Reset);
}


static const per_sequence_t ContextGroupList_Reset_sequence[] = {
  { "contextGroupInfoList-Reset"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_contextGroupInfoList_Reset },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ContextGroupList_Reset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ContextGroupList_Reset, ContextGroupList_Reset_sequence);

  return offset;
}
static int dissect_contextGroup(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ContextGroupList_Reset(tvb, offset, pinfo, tree, hf_rnsap_contextGroup);
}


static const value_string rnsap_ResetIndicator_vals[] = {
  {   0, "context" },
  {   1, "all-contexts" },
  {   2, "contextGroup" },
  { 0, NULL }
};

static const per_choice_t ResetIndicator_choice[] = {
  {   0, "context"                     , ASN1_EXTENSION_ROOT    , dissect_context },
  {   1, "all-contexts"                , ASN1_EXTENSION_ROOT    , dissect_all_contexts },
  {   2, "contextGroup"                , ASN1_NOT_EXTENSION_ROOT, dissect_contextGroup },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_ResetIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_ResetIndicator, ResetIndicator_choice,
                                 NULL);

  return offset;
}
static int dissect_id_ResetIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ResetIndicator(tvb, offset, pinfo, tree, hf_rnsap_id_ResetIndicator);
}



static int
dissect_rnsap_UL_ScramblingCodeNumber(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 16777215U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ul_ScramblingCodeNumber(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_ScramblingCodeNumber(tvb, offset, pinfo, tree, hf_rnsap_ul_ScramblingCodeNumber);
}


static const value_string rnsap_UL_ScramblingCodeLength_vals[] = {
  {   0, "short" },
  {   1, "long" },
  { 0, NULL }
};


static int
dissect_rnsap_UL_ScramblingCodeLength(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ul_ScramblingCodeLength(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_ScramblingCodeLength(tvb, offset, pinfo, tree, hf_rnsap_ul_ScramblingCodeLength);
}


static const per_sequence_t UL_ScramblingCode_sequence[] = {
  { "ul-ScramblingCodeNumber"     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ul_ScramblingCodeNumber },
  { "ul-ScramblingCodeLength"     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ul_ScramblingCodeLength },
  { "iE-Extensions"               , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_ScramblingCode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_ScramblingCode, UL_ScramblingCode_sequence);

  return offset;
}
static int dissect_ul_ScramblingCode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_ScramblingCode(tvb, offset, pinfo, tree, hf_rnsap_ul_ScramblingCode);
}


static const value_string rnsap_MinUL_ChannelisationCodeLength_vals[] = {
  {   0, "v4" },
  {   1, "v8" },
  {   2, "v16" },
  {   3, "v32" },
  {   4, "v64" },
  {   5, "v128" },
  {   6, "v256" },
  { 0, NULL }
};


static int
dissect_rnsap_MinUL_ChannelisationCodeLength(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 6, NULL, NULL, FALSE);

  return offset;
}
static int dissect_minUL_ChannelisationCodeLength(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MinUL_ChannelisationCodeLength(tvb, offset, pinfo, tree, hf_rnsap_minUL_ChannelisationCodeLength);
}



static int
dissect_rnsap_MaxNrOfUL_DPCHs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 6U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_maxNrOfUL_DPCHs(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MaxNrOfUL_DPCHs(tvb, offset, pinfo, tree, hf_rnsap_maxNrOfUL_DPCHs);
}
static int dissect_maxNrOfUL_DPDCHs(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MaxNrOfUL_DPCHs(tvb, offset, pinfo, tree, hf_rnsap_maxNrOfUL_DPDCHs);
}



static int
dissect_rnsap_UL_DPCCH_SlotFormat(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 5U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_ul_DPCCH_SlotFormat(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCCH_SlotFormat(tvb, offset, pinfo, tree, hf_rnsap_ul_DPCCH_SlotFormat);
}


static const value_string rnsap_DiversityMode_vals[] = {
  {   0, "none" },
  {   1, "sTTD" },
  {   2, "closedLoopMode1" },
  {   3, "not-used-closedLoopMode2" },
  { 0, NULL }
};


static int
dissect_rnsap_DiversityMode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 3, NULL, NULL, TRUE);

  return offset;
}
static int dissect_diversityMode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DiversityMode(tvb, offset, pinfo, tree, hf_rnsap_diversityMode);
}


static const per_sequence_t UL_DPCH_Information_RL_SetupRqstFDD_sequence[] = {
  { "ul-ScramblingCode"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_ScramblingCode },
  { "minUL-ChannelisationCodeLength", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minUL_ChannelisationCodeLength },
  { "maxNrOfUL-DPCHs"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_maxNrOfUL_DPCHs },
  { "ul-PunctureLimit"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_PunctureLimit },
  { "ul-TFCS"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_TFCS },
  { "ul-DPCCH-SlotFormat"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_DPCCH_SlotFormat },
  { "ul-SIRTarget"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_SIRTarget },
  { "diversityMode"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_diversityMode },
  { "not-Used-sSDT-CellIdLength"  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_sSDT_CellIdLength },
  { "not-Used-s-FieldLength"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_s_FieldLength },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_Information_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_Information_RL_SetupRqstFDD, UL_DPCH_Information_RL_SetupRqstFDD_sequence);

  return offset;
}
static int dissect_id_UL_DPCH_Information_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCH_Information_RL_SetupRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_id_UL_DPCH_Information_RL_SetupRqstFDD);
}


static const per_sequence_t Cell_Fach_Pch_State_sequence[] = {
  { "d-RNTI"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_d_RNTI },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Cell_Fach_Pch_State(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Cell_Fach_Pch_State, Cell_Fach_Pch_State_sequence);

  return offset;
}
static int dissect_cell_fach_pch(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cell_Fach_Pch_State(tvb, offset, pinfo, tree, hf_rnsap_cell_fach_pch);
}


static const per_sequence_t Ura_Pch_State_sequence[] = {
  { "srnc-id"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_srnc_id },
  { "ura-id"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ura_id },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Ura_Pch_State(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Ura_Pch_State, Ura_Pch_State_sequence);

  return offset;
}
static int dissect_ura_pch(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Ura_Pch_State(tvb, offset, pinfo, tree, hf_rnsap_ura_pch);
}


static const value_string rnsap_UE_State_vals[] = {
  {   0, "cell-fach-pch" },
  {   1, "ura-pch" },
  { 0, NULL }
};

static const per_choice_t UE_State_choice[] = {
  {   0, "cell-fach-pch"               , ASN1_EXTENSION_ROOT    , dissect_cell_fach_pch },
  {   1, "ura-pch"                     , ASN1_EXTENSION_ROOT    , dissect_ura_pch },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_UE_State(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_UE_State, UE_State_choice,
                                 NULL);

  return offset;
}
static int dissect_id_UE_State(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UE_State(tvb, offset, pinfo, tree, hf_rnsap_id_UE_State);
}


static const value_string rnsap_HARQ_Preamble_Mode_vals[] = {
  {   0, "mode0" },
  {   1, "mode1" },
  { 0, NULL }
};


static int
dissect_rnsap_HARQ_Preamble_Mode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_HARQ_Preamble_Mode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HARQ_Preamble_Mode(tvb, offset, pinfo, tree, hf_rnsap_id_HARQ_Preamble_Mode);
}


static const value_string rnsap_SynchronisationIndicator_vals[] = {
  {   0, "timingMaintainedSynchronisation" },
  { 0, NULL }
};


static int
dissect_rnsap_SynchronisationIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, TRUE);

  return offset;
}
static int dissect_id_SynchronisationIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SynchronisationIndicator(tvb, offset, pinfo, tree, hf_rnsap_id_SynchronisationIndicator);
}


static const value_string rnsap_UL_DPDCHIndicatorEDCH_vals[] = {
  {   0, "uL-DPDCH-present" },
  {   1, "uL-DPDCH-not-present" },
  { 0, NULL }
};


static int
dissect_rnsap_UL_DPDCHIndicatorEDCH(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_UL_DPDCHIndicatorEDCH(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPDCHIndicatorEDCH(tvb, offset, pinfo, tree, hf_rnsap_id_UL_DPDCHIndicatorEDCH);
}



static int
dissect_rnsap_E_DCH_TFCI_Table_Index(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 1U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_e_DCH_TFCI_Table_Index(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_TFCI_Table_Index(tvb, offset, pinfo, tree, hf_rnsap_e_DCH_TFCI_Table_Index);
}



static int
dissect_rnsap_E_TFCI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 127U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_e_DCH_Min_Set_E_TFCI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_TFCI(tvb, offset, pinfo, tree, hf_rnsap_e_DCH_Min_Set_E_TFCI);
}
static int dissect_reference_E_TFCI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_TFCI(tvb, offset, pinfo, tree, hf_rnsap_reference_E_TFCI);
}



static int
dissect_rnsap_Reference_E_TFCI_PO(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 29U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_reference_E_TFCI_PO(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Reference_E_TFCI_PO(tvb, offset, pinfo, tree, hf_rnsap_reference_E_TFCI_PO);
}


static const per_sequence_t Reference_E_TFCI_Information_Item_sequence[] = {
  { "reference-E-TFCI"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_reference_E_TFCI },
  { "reference-E-TFCI-PO"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_reference_E_TFCI_PO },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Reference_E_TFCI_Information_Item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Reference_E_TFCI_Information_Item, Reference_E_TFCI_Information_Item_sequence);

  return offset;
}
static int dissect_Reference_E_TFCI_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Reference_E_TFCI_Information_Item(tvb, offset, pinfo, tree, hf_rnsap_Reference_E_TFCI_Information_item);
}


static const per_sequence_t Reference_E_TFCI_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Reference_E_TFCI_Information_item },
};

static int
dissect_rnsap_Reference_E_TFCI_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Reference_E_TFCI_Information, Reference_E_TFCI_Information_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_reference_E_TFCI_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Reference_E_TFCI_Information(tvb, offset, pinfo, tree, hf_rnsap_reference_E_TFCI_Information);
}


static const per_sequence_t E_TFCS_Information_sequence[] = {
  { "e-DCH-TFCI-Table-Index"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_e_DCH_TFCI_Table_Index },
  { "e-DCH-Min-Set-E-TFCI"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_e_DCH_Min_Set_E_TFCI },
  { "reference-E-TFCI-Information", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_reference_E_TFCI_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_E_TFCS_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_E_TFCS_Information, E_TFCS_Information_sequence);

  return offset;
}
static int dissect_e_TFCS_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_TFCS_Information(tvb, offset, pinfo, tree, hf_rnsap_e_TFCS_Information);
}



static int
dissect_rnsap_E_DPCCH_PO(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 8U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_e_DPCCH_PO(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DPCCH_PO(tvb, offset, pinfo, tree, hf_rnsap_e_DPCCH_PO);
}


static const per_sequence_t EDPCH_Information_RLReconfRequest_FDD_sequence[] = {
  { "e-TFCS-Information"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_e_TFCS_Information },
  { "e-DPCCH-PO"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_e_DPCCH_PO },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDPCH_Information_RLReconfRequest_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDPCH_Information_RLReconfRequest_FDD, EDPCH_Information_RLReconfRequest_FDD_sequence);

  return offset;
}
static int dissect_id_EDPCH_Information_RLReconfRequest_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDPCH_Information_RLReconfRequest_FDD(tvb, offset, pinfo, tree, hf_rnsap_id_EDPCH_Information_RLReconfRequest_FDD);
}


static const per_sequence_t EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd_item },
};

static int
dissect_rnsap_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd, EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_id_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd(tvb, offset, pinfo, tree, hf_rnsap_id_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd);
}



static int
dissect_rnsap_EDCH_MACdFlow_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 7U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_eDCH_MACdFlow_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MACdFlow_ID(tvb, offset, pinfo, tree, hf_rnsap_eDCH_MACdFlow_ID);
}
static int dissect_eDSCH_MACdFlow_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MACdFlow_ID(tvb, offset, pinfo, tree, hf_rnsap_eDSCH_MACdFlow_ID);
}


static const per_sequence_t EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_sequence[] = {
  { "eDCH-MACdFlow-ID"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDCH_MACdFlow_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd, EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_sequence);

  return offset;
}
static int dissect_id_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd(tvb, offset, pinfo, tree, hf_rnsap_id_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd);
}


static const per_sequence_t EDCH_MacdFlowSpecificInformationList_RL_CongestInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_EDCH_MacdFlowSpecificInformationList_RL_CongestInd_item },
};

static int
dissect_rnsap_EDCH_MacdFlowSpecificInformationList_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_EDCH_MacdFlowSpecificInformationList_RL_CongestInd, EDCH_MacdFlowSpecificInformationList_RL_CongestInd_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_id_EDCH_MacdFlowSpecificInformationList_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MacdFlowSpecificInformationList_RL_CongestInd(tvb, offset, pinfo, tree, hf_rnsap_id_EDCH_MacdFlowSpecificInformationList_RL_CongestInd);
}


static const per_sequence_t EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_sequence[] = {
  { "eDCH-MACdFlow-ID"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDCH_MACdFlow_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd, EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_sequence);

  return offset;
}
static int dissect_id_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd(tvb, offset, pinfo, tree, hf_rnsap_id_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd);
}



static int
dissect_rnsap_AccessPointName(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       1, 255, NULL);

  return offset;
}
static int dissect_accessPointName(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AccessPointName(tvb, offset, pinfo, tree, hf_rnsap_accessPointName);
}



static int
dissect_rnsap_IPMulticastAddress(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       4, 16, NULL);

  return offset;
}
static int dissect_iPMulticastAddress(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPMulticastAddress(tvb, offset, pinfo, tree, hf_rnsap_iPMulticastAddress);
}


static const per_sequence_t MBMS_Bearer_Service_Full_Address_sequence[] = {
  { "accessPointName"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_accessPointName },
  { "iPMulticastAddress"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iPMulticastAddress },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMS_Bearer_Service_Full_Address(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMS_Bearer_Service_Full_Address, MBMS_Bearer_Service_Full_Address_sequence);

  return offset;
}
static int dissect_id_MBMS_Bearer_Service_Full_Address(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMS_Bearer_Service_Full_Address(tvb, offset, pinfo, tree, hf_rnsap_id_MBMS_Bearer_Service_Full_Address);
}


static const value_string rnsap_Initial_DL_DPCH_TimingAdjustment_Allowed_vals[] = {
  {   0, "initial-DL-DPCH-TimingAdjustment-Allowed" },
  { 0, NULL }
};


static int
dissect_rnsap_Initial_DL_DPCH_TimingAdjustment_Allowed(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_Initial_DL_DPCH_TimingAdjustment_Allowed(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Initial_DL_DPCH_TimingAdjustment_Allowed(tvb, offset, pinfo, tree, hf_rnsap_id_Initial_DL_DPCH_TimingAdjustment_Allowed);
}


static const value_string rnsap_User_Plane_Congestion_Fields_Inclusion_vals[] = {
  {   0, "shall-be-included" },
  { 0, NULL }
};


static int
dissect_rnsap_User_Plane_Congestion_Fields_Inclusion(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_User_Plane_Congestion_Fields_Inclusion(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_User_Plane_Congestion_Fields_Inclusion(tvb, offset, pinfo, tree, hf_rnsap_id_User_Plane_Congestion_Fields_Inclusion);
}


static const value_string rnsap_HARQ_Preamble_Mode_Activation_Indicator_vals[] = {
  {   0, "harqPreambleModeSupported" },
  { 0, NULL }
};


static int
dissect_rnsap_HARQ_Preamble_Mode_Activation_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}
static int dissect_id_HARQ_Preamble_Mode_Activation_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HARQ_Preamble_Mode_Activation_Indicator(tvb, offset, pinfo, tree, hf_rnsap_id_HARQ_Preamble_Mode_Activation_Indicator);
}


static const per_sequence_t Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "dedicatedMeasurementValue"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dedicatedMeasurementValue },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp, Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_sequence);

  return offset;
}
static int dissect_Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp_item);
}


static const per_sequence_t Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp_item },
};

static int
dissect_rnsap_Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp, Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp_sequence_of,
                                                  1, 239);

  return offset;
}
static int dissect_id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp);
}


static const per_sequence_t Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "dedicatedMeasurementValue"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dedicatedMeasurementValue },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp, Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_sequence);

  return offset;
}
static int dissect_Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp_item);
}


static const per_sequence_t Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp_item },
};

static int
dissect_rnsap_Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp, Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp_sequence_of,
                                                  1, 239);

  return offset;
}
static int dissect_id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp);
}



static int
dissect_rnsap_Service_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       3, 3, NULL);

  return offset;
}
static int dissect_service_id(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Service_ID(tvb, offset, pinfo, tree, hf_rnsap_service_id);
}


static const per_sequence_t TMGI_sequence[] = {
  { "plmn-id"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_plmn_id },
  { "service-id"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_service_id },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TMGI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TMGI, TMGI_sequence);

  return offset;
}
static int dissect_tmgi(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TMGI(tvb, offset, pinfo, tree, hf_rnsap_tmgi);
}
static int dissect_MBMS_Bearer_Service_List_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TMGI(tvb, offset, pinfo, tree, hf_rnsap_MBMS_Bearer_Service_List_item);
}
static int dissect_tMGI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TMGI(tvb, offset, pinfo, tree, hf_rnsap_tMGI);
}


static const per_sequence_t AffectedUEInformationForMBMS_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_AffectedUEInformationForMBMS_item },
};

static int
dissect_rnsap_AffectedUEInformationForMBMS(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_AffectedUEInformationForMBMS, AffectedUEInformationForMBMS_sequence_of,
                                                  1, 4096);

  return offset;
}
static int dissect_affectedUEInformationForMBMS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AffectedUEInformationForMBMS(tvb, offset, pinfo, tree, hf_rnsap_affectedUEInformationForMBMS);
}


static const per_sequence_t MBMSChannelTypeCellList_sequence[] = {
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "affectedUEInformationForMBMS", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_affectedUEInformationForMBMS },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMSChannelTypeCellList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMSChannelTypeCellList, MBMSChannelTypeCellList_sequence);

  return offset;
}
static int dissect_NotProvidedCellList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMSChannelTypeCellList(tvb, offset, pinfo, tree, hf_rnsap_NotProvidedCellList_item);
}
static int dissect_PTMCellList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMSChannelTypeCellList(tvb, offset, pinfo, tree, hf_rnsap_PTMCellList_item);
}
static int dissect_PTPCellList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMSChannelTypeCellList(tvb, offset, pinfo, tree, hf_rnsap_PTPCellList_item);
}


static const per_sequence_t PTMCellList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_PTMCellList_item },
};

static int
dissect_rnsap_PTMCellList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_PTMCellList, PTMCellList_sequence_of,
                                                  1, 65536);

  return offset;
}
static int dissect_pTM_Cell_List(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PTMCellList(tvb, offset, pinfo, tree, hf_rnsap_pTM_Cell_List);
}


static const per_sequence_t PTPCellList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_PTPCellList_item },
};

static int
dissect_rnsap_PTPCellList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_PTPCellList, PTPCellList_sequence_of,
                                                  1, 65536);

  return offset;
}
static int dissect_pTP_Cell_List(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PTPCellList(tvb, offset, pinfo, tree, hf_rnsap_pTP_Cell_List);
}


static const per_sequence_t NotProvidedCellList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_NotProvidedCellList_item },
};

static int
dissect_rnsap_NotProvidedCellList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_NotProvidedCellList, NotProvidedCellList_sequence_of,
                                                  1, 65536);

  return offset;
}
static int dissect_not_Provided_Cell_List(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NotProvidedCellList(tvb, offset, pinfo, tree, hf_rnsap_not_Provided_Cell_List);
}


static const per_sequence_t MBMSChannelTypeInfo_sequence[] = {
  { "tMGI"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tMGI },
  { "pTM-Cell-List"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_pTM_Cell_List },
  { "pTP-Cell-List"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_pTP_Cell_List },
  { "not-Provided-Cell-List"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Provided_Cell_List },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMSChannelTypeInfo(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMSChannelTypeInfo, MBMSChannelTypeInfo_sequence);

  return offset;
}
static int dissect_mBMSChannelTypeInfo(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMSChannelTypeInfo(tvb, offset, pinfo, tree, hf_rnsap_mBMSChannelTypeInfo);
}


static const per_sequence_t CorrespondingCells_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_CorrespondingCells_item },
};

static int
dissect_rnsap_CorrespondingCells(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_CorrespondingCells, CorrespondingCells_sequence_of,
                                                  1, 65536);

  return offset;
}
static int dissect_correspondingCells(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CorrespondingCells(tvb, offset, pinfo, tree, hf_rnsap_correspondingCells);
}


static const per_sequence_t AdditionalPreferredFrequencyItem_sequence[] = {
  { "dL-UARFCN"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_UARFCN },
  { "correspondingCells"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_correspondingCells },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_AdditionalPreferredFrequencyItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_AdditionalPreferredFrequencyItem, AdditionalPreferredFrequencyItem_sequence);

  return offset;
}
static int dissect_AdditionalPreferredFrequency_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AdditionalPreferredFrequencyItem(tvb, offset, pinfo, tree, hf_rnsap_AdditionalPreferredFrequency_item);
}


static const per_sequence_t AdditionalPreferredFrequency_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_AdditionalPreferredFrequency_item },
};

static int
dissect_rnsap_AdditionalPreferredFrequency(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_AdditionalPreferredFrequency, AdditionalPreferredFrequency_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_additionalPreferredFrequency(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AdditionalPreferredFrequency(tvb, offset, pinfo, tree, hf_rnsap_additionalPreferredFrequency);
}


static const per_sequence_t PreferredFrequencyLayerInfo_sequence[] = {
  { "defaultPreferredFrequency"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_defaultPreferredFrequency },
  { "additionalPreferredFrequency", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_additionalPreferredFrequency },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PreferredFrequencyLayerInfo(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PreferredFrequencyLayerInfo, PreferredFrequencyLayerInfo_sequence);

  return offset;
}
static int dissect_preferredFrequencyLayerInfo(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PreferredFrequencyLayerInfo(tvb, offset, pinfo, tree, hf_rnsap_preferredFrequencyLayerInfo);
}


static const per_sequence_t MBMSPreferredFreqLayerInfo_sequence[] = {
  { "tMGI"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tMGI },
  { "preferredFrequencyLayerInfo" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_preferredFrequencyLayerInfo },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMSPreferredFreqLayerInfo(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMSPreferredFreqLayerInfo, MBMSPreferredFreqLayerInfo_sequence);

  return offset;
}
static int dissect_mBMSPreferredFreqLayerInfo(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMSPreferredFreqLayerInfo(tvb, offset, pinfo, tree, hf_rnsap_mBMSPreferredFreqLayerInfo);
}


static const per_sequence_t ProvidedInformation_sequence[] = {
  { "mBMSChannelTypeInfo"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mBMSChannelTypeInfo },
  { "mBMSPreferredFreqLayerInfo"  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mBMSPreferredFreqLayerInfo },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ProvidedInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ProvidedInformation, ProvidedInformation_sequence);

  return offset;
}
static int dissect_id_ProvidedInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProvidedInformation(tvb, offset, pinfo, tree, hf_rnsap_id_ProvidedInformation);
}


static const value_string rnsap_TransmissionMode_vals[] = {
  {   0, "p-t-p" },
  {   1, "p-t-m" },
  {   2, "not-provided" },
  { 0, NULL }
};


static int
dissect_rnsap_TransmissionMode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_transmissionMode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransmissionMode(tvb, offset, pinfo, tree, hf_rnsap_transmissionMode);
}


static const per_sequence_t MBMS_Bearer_ServiceItemTDD_PFL_sequence[] = {
  { "tmgi"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tmgi },
  { "transmissionMode"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transmissionMode },
  { "preferredFrequencyLayer"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_preferredFrequencyLayer },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMS_Bearer_ServiceItemTDD_PFL(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMS_Bearer_ServiceItemTDD_PFL, MBMS_Bearer_ServiceItemTDD_PFL_sequence);

  return offset;
}
static int dissect_Active_MBMS_Bearer_Service_ListTDD_PFL_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMS_Bearer_ServiceItemTDD_PFL(tvb, offset, pinfo, tree, hf_rnsap_Active_MBMS_Bearer_Service_ListTDD_PFL_item);
}


static const per_sequence_t Active_MBMS_Bearer_Service_ListTDD_PFL_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Active_MBMS_Bearer_Service_ListTDD_PFL_item },
};

static int
dissect_rnsap_Active_MBMS_Bearer_Service_ListTDD_PFL(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Active_MBMS_Bearer_Service_ListTDD_PFL, Active_MBMS_Bearer_Service_ListTDD_PFL_sequence_of,
                                                  1, 256);

  return offset;
}
static int dissect_id_Active_MBMS_Bearer_ServiceFDD_PFL(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Active_MBMS_Bearer_Service_ListTDD_PFL(tvb, offset, pinfo, tree, hf_rnsap_id_Active_MBMS_Bearer_ServiceFDD_PFL);
}
static int dissect_id_Active_MBMS_Bearer_ServiceTDD_PFL(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Active_MBMS_Bearer_Service_ListTDD_PFL(tvb, offset, pinfo, tree, hf_rnsap_id_Active_MBMS_Bearer_ServiceTDD_PFL);
}


static const value_string rnsap_FrequencyBandIndicator_vals[] = {
  {   0, "bandI" },
  {   1, "bandII" },
  {   2, "bandIII" },
  {   3, "bandIV" },
  {   4, "bandV" },
  {   5, "bandVI" },
  {   6, "bandVII" },
  {   7, "bandVIII" },
  {   8, "bandIX" },
  {   9, "bandX" },
  {  10, "bandXI" },
  {  11, "bandXII" },
  {  12, "bandXIII" },
  {  13, "bandXIV" },
  {  14, "bandXV" },
  {  15, "bandXVI" },
  {  16, "bandXVII" },
  {  17, "bandXVIII" },
  {  18, "bandXIX" },
  {  19, "bandXX" },
  {  20, "bandXXI" },
  {  21, "bandXXII" },
  { 0, NULL }
};


static int
dissect_rnsap_FrequencyBandIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 21, NULL, NULL, TRUE);

  return offset;
}
static int dissect_id_FrequencyBandIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FrequencyBandIndicator(tvb, offset, pinfo, tree, hf_rnsap_id_FrequencyBandIndicator);
}


static const value_string rnsap_DummyProtocolIE_vals[] = {
  {   0, "id-AllowedQueuingTime" },
  {   1, "id-Allowed-Rate-Information" },
  {   2, "id-AntennaColocationIndicator" },
  {   3, "id-BindingID" },
  {   4, "id-C-ID" },
  {   5, "id-C-RNTI" },
  {   6, "id-Cell-Capacity-Class-Value" },
  {   7, "id-CFN" },
  {   8, "id-CN-CS-DomainIdentifier" },
  {   9, "id-CN-PS-DomainIdentifier" },
  {  10, "id-Cause" },
  {  11, "id-CoverageIndicator" },
  {  12, "id-CriticalityDiagnostics" },
  {  13, "id-ContextInfoItem-Reset" },
  {  14, "id-ContextGroupInfoItem-Reset" },
  {  15, "id-D-RNTI" },
  {  16, "id-D-RNTI-ReleaseIndication" },
  {  17, "id-DCHs-to-Add-FDD" },
  {  18, "id-DCHs-to-Add-TDD" },
  {  19, "id-DCH-DeleteList-RL-ReconfPrepFDD" },
  {  20, "id-DCH-DeleteList-RL-ReconfPrepTDD" },
  {  21, "id-DCH-DeleteList-RL-ReconfRqstFDD" },
  {  22, "id-DCH-DeleteList-RL-ReconfRqstTDD" },
  {  23, "id-DCH-FDD-Information" },
  {  24, "id-DCH-TDD-Information" },
  {  25, "id-FDD-DCHs-to-Modify" },
  {  26, "id-TDD-DCHs-to-Modify" },
  {  27, "id-DCH-InformationResponse" },
  {  28, "id-DCH-Rate-InformationItem-RL-CongestInd" },
  {  29, "id-DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD" },
  {  30, "id-DL-CCTrCH-InformationListIE-RL-ReconfReadyTDD" },
  {  31, "id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD" },
  {  32, "id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD" },
  {  33, "id-DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD" },
  {  34, "id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD" },
  {  35, "id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD" },
  {  36, "id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD" },
  {  37, "id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD" },
  {  38, "id-DL-CCTrCH-InformationList-RL-SetupRqstTDD" },
  {  39, "id-FDD-DL-CodeInformation" },
  {  40, "id-DL-DPCH-Information-RL-ReconfPrepFDD" },
  {  41, "id-DL-DPCH-Information-RL-SetupRqstFDD" },
  {  42, "id-DL-DPCH-Information-RL-ReconfRqstFDD" },
  {  43, "id-DL-DPCH-InformationItem-PhyChReconfRqstTDD" },
  {  44, "id-DL-DPCH-InformationItem-RL-AdditionRspTDD" },
  {  45, "id-DL-DPCH-InformationItem-RL-SetupRspTDD" },
  {  46, "id-DL-DPCH-TimingAdjustment" },
  {  47, "id-DLReferencePower" },
  {  48, "id-DLReferencePowerList-DL-PC-Rqst" },
  {  49, "id-DL-ReferencePowerInformation-DL-PC-Rqst" },
  {  50, "id-DPC-Mode" },
  {  51, "id-DRXCycleLengthCoefficient" },
  {  52, "id-DedicatedMeasurementObjectType-DM-Fail-Ind" },
  {  53, "id-DedicatedMeasurementObjectType-DM-Fail" },
  {  54, "id-DedicatedMeasurementObjectType-DM-Rprt" },
  {  55, "id-DedicatedMeasurementObjectType-DM-Rqst" },
  {  56, "id-DedicatedMeasurementObjectType-DM-Rsp" },
  {  57, "id-DedicatedMeasurementType" },
  {  58, "id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD" },
  {  59, "id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD" },
  {  60, "id-Guaranteed-Rate-Information" },
  {  61, "id-IMSI" },
  {  62, "id-HCS-Prio" },
  {  63, "id-L3-Information" },
  {  64, "id-AdjustmentPeriod" },
  {  65, "id-MaxAdjustmentStep" },
  {  66, "id-MeasurementFilterCoefficient" },
  {  67, "id-MessageStructure" },
  {  68, "id-MeasurementID" },
  {  69, "id-Neighbouring-GSM-CellInformation" },
  {  70, "id-Neighbouring-UMTS-CellInformationItem" },
  {  71, "id-NRT-Load-Information-Value" },
  {  72, "id-NRT-Load-Information-Value-IncrDecrThres" },
  {  73, "id-PagingArea-PagingRqst" },
  {  74, "id-FACH-FlowControlInformation" },
  {  75, "id-PartialReportingIndicator" },
  {  76, "id-Permanent-NAS-UE-Identity" },
  {  77, "id-PowerAdjustmentType" },
  {  78, "id-RANAP-RelocationInformation" },
  {  79, "id-RL-Information-PhyChReconfRqstFDD" },
  {  80, "id-RL-Information-PhyChReconfRqstTDD" },
  {  81, "id-RL-Information-RL-AdditionRqstFDD" },
  {  82, "id-RL-Information-RL-AdditionRqstTDD" },
  {  83, "id-RL-Information-RL-DeletionRqst" },
  {  84, "id-RL-Information-RL-FailureInd" },
  {  85, "id-RL-Information-RL-ReconfPrepFDD" },
  {  86, "id-RL-Information-RL-RestoreInd" },
  {  87, "id-RL-Information-RL-SetupRqstFDD" },
  {  88, "id-RL-Information-RL-SetupRqstTDD" },
  {  89, "id-RL-InformationItem-RL-CongestInd" },
  {  90, "id-RL-InformationItem-DM-Rprt" },
  {  91, "id-RL-InformationItem-DM-Rqst" },
  {  92, "id-RL-InformationItem-DM-Rsp" },
  {  93, "id-RL-InformationItem-RL-PreemptRequiredInd" },
  {  94, "id-RL-InformationItem-RL-SetupRqstFDD" },
  {  95, "id-RL-InformationList-RL-CongestInd" },
  {  96, "id-RL-InformationList-RL-AdditionRqstFDD" },
  {  97, "id-RL-InformationList-RL-DeletionRqst" },
  {  98, "id-RL-InformationList-RL-PreemptRequiredInd" },
  {  99, "id-RL-InformationList-RL-ReconfPrepFDD" },
  { 100, "id-RL-InformationResponse-RL-AdditionRspTDD" },
  { 101, "id-RL-InformationResponse-RL-ReconfReadyTDD" },
  { 102, "id-RL-InformationResponse-RL-SetupRspTDD" },
  { 103, "id-RL-InformationResponseItem-RL-AdditionRspFDD" },
  { 104, "id-RL-InformationResponseItem-RL-ReconfReadyFDD" },
  { 105, "id-RL-InformationResponseItem-RL-ReconfRspFDD" },
  { 106, "id-RL-InformationResponseItem-RL-SetupRspFDD" },
  { 107, "id-RL-InformationResponseList-RL-AdditionRspFDD" },
  { 108, "id-RL-InformationResponseList-RL-ReconfReadyFDD" },
  { 109, "id-RL-InformationResponseList-RL-ReconfRspFDD" },
  { 110, "id-RL-InformationResponse-RL-ReconfRspTDD" },
  { 111, "id-RL-InformationResponseList-RL-SetupRspFDD" },
  { 112, "id-RL-ReconfigurationFailure-RL-ReconfFail" },
  { 113, "id-RL-Set-InformationItem-DM-Rprt" },
  { 114, "id-RL-Set-InformationItem-DM-Rqst" },
  { 115, "id-RL-Set-InformationItem-DM-Rsp" },
  { 116, "id-RL-Set-Information-RL-FailureInd" },
  { 117, "id-RL-Set-Information-RL-RestoreInd" },
  { 118, "id-RL-Set-Successful-InformationItem-DM-Fail" },
  { 119, "id-RL-Set-Unsuccessful-InformationItem-DM-Fail" },
  { 120, "id-RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind" },
  { 121, "id-RL-Successful-InformationItem-DM-Fail" },
  { 122, "id-RL-Unsuccessful-InformationItem-DM-Fail" },
  { 123, "id-RT-Load-Value" },
  { 124, "id-RT-Load-Value-IncrDecrThres" },
  { 125, "id-S-RNTI" },
  { 126, "id-ResetIndicator" },
  { 127, "id-RNC-ID" },
  { 128, "id-SAI" },
  { 129, "id-SRNC-ID" },
  { 130, "id-UL-DPCH-Information-RL-SetupRqstFDD" },
  { 131, "id-Old-URA-ID" },
  { 132, "id-UE-State" },
  { 133, "id-URA-ID" },
  { 134, "id-HARQ-Preamble-Mode" },
  { 135, "id-SynchronisationIndicator" },
  { 136, "id-UL-DPDCHIndicatorEDCH" },
  { 137, "id-EDPCH-Information-RLReconfRequest-FDD" },
  { 138, "id-EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd" },
  { 139, "id-EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd" },
  { 140, "id-EDCH-MacdFlowSpecificInformationList-RL-CongestInd" },
  { 141, "id-EDCH-MacdFlowSpecificInformationItem-RL-CongestInd" },
  { 142, "id-MBMS-Bearer-Service-Full-Address" },
  { 143, "id-Initial-DL-DPCH-TimingAdjustment" },
  { 144, "id-Initial-DL-DPCH-TimingAdjustment-Allowed" },
  { 145, "id-User-Plane-Congestion-Fields-Inclusion" },
  { 146, "id-HARQ-Preamble-Mode-Activation-Indicator" },
  { 147, "id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp" },
  { 148, "id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp" },
  { 149, "id-ProvidedInformation" },
  { 150, "id-Active-MBMS-Bearer-ServiceFDD-PFL" },
  { 151, "id-Active-MBMS-Bearer-ServiceTDD-PFL" },
  { 152, "id-FrequencyBandIndicator" },
  { 0, NULL }
};

static const per_choice_t DummyProtocolIE_choice[] = {
  {   0, "id-AllowedQueuingTime"       , ASN1_EXTENSION_ROOT    , dissect_id_AllowedQueuingTime },
  {   1, "id-Allowed-Rate-Information" , ASN1_EXTENSION_ROOT    , dissect_id_Allowed_Rate_Information },
  {   2, "id-AntennaColocationIndicator", ASN1_EXTENSION_ROOT    , dissect_id_AntennaColocationIndicator },
  {   3, "id-BindingID"                , ASN1_EXTENSION_ROOT    , dissect_id_BindingID },
  {   4, "id-C-ID"                     , ASN1_EXTENSION_ROOT    , dissect_id_C_ID },
  {   5, "id-C-RNTI"                   , ASN1_EXTENSION_ROOT    , dissect_id_C_RNTI },
  {   6, "id-Cell-Capacity-Class-Value", ASN1_EXTENSION_ROOT    , dissect_id_Cell_Capacity_Class_Value },
  {   7, "id-CFN"                      , ASN1_EXTENSION_ROOT    , dissect_id_CFN },
  {   8, "id-CN-CS-DomainIdentifier"   , ASN1_EXTENSION_ROOT    , dissect_id_CN_CS_DomainIdentifier },
  {   9, "id-CN-PS-DomainIdentifier"   , ASN1_EXTENSION_ROOT    , dissect_id_CN_PS_DomainIdentifier },
  {  10, "id-Cause"                    , ASN1_EXTENSION_ROOT    , dissect_id_Cause },
  {  11, "id-CoverageIndicator"        , ASN1_EXTENSION_ROOT    , dissect_id_CoverageIndicator },
  {  12, "id-CriticalityDiagnostics"   , ASN1_EXTENSION_ROOT    , dissect_id_CriticalityDiagnostics },
  {  13, "id-ContextInfoItem-Reset"    , ASN1_EXTENSION_ROOT    , dissect_id_ContextInfoItem_Reset },
  {  14, "id-ContextGroupInfoItem-Reset", ASN1_EXTENSION_ROOT    , dissect_id_ContextGroupInfoItem_Reset },
  {  15, "id-D-RNTI"                   , ASN1_EXTENSION_ROOT    , dissect_id_D_RNTI },
  {  16, "id-D-RNTI-ReleaseIndication" , ASN1_EXTENSION_ROOT    , dissect_id_D_RNTI_ReleaseIndication },
  {  17, "id-DCHs-to-Add-FDD"          , ASN1_EXTENSION_ROOT    , dissect_id_DCHs_to_Add_FDD },
  {  18, "id-DCHs-to-Add-TDD"          , ASN1_EXTENSION_ROOT    , dissect_id_DCHs_to_Add_TDD },
  {  19, "id-DCH-DeleteList-RL-ReconfPrepFDD", ASN1_EXTENSION_ROOT    , dissect_id_DCH_DeleteList_RL_ReconfPrepFDD },
  {  20, "id-DCH-DeleteList-RL-ReconfPrepTDD", ASN1_EXTENSION_ROOT    , dissect_id_DCH_DeleteList_RL_ReconfPrepTDD },
  {  21, "id-DCH-DeleteList-RL-ReconfRqstFDD", ASN1_EXTENSION_ROOT    , dissect_id_DCH_DeleteList_RL_ReconfRqstFDD },
  {  22, "id-DCH-DeleteList-RL-ReconfRqstTDD", ASN1_EXTENSION_ROOT    , dissect_id_DCH_DeleteList_RL_ReconfRqstTDD },
  {  23, "id-DCH-FDD-Information"      , ASN1_EXTENSION_ROOT    , dissect_id_DCH_FDD_Information },
  {  24, "id-DCH-TDD-Information"      , ASN1_EXTENSION_ROOT    , dissect_id_DCH_TDD_Information },
  {  25, "id-FDD-DCHs-to-Modify"       , ASN1_EXTENSION_ROOT    , dissect_id_FDD_DCHs_to_Modify },
  {  26, "id-TDD-DCHs-to-Modify"       , ASN1_EXTENSION_ROOT    , dissect_id_TDD_DCHs_to_Modify },
  {  27, "id-DCH-InformationResponse"  , ASN1_EXTENSION_ROOT    , dissect_id_DCH_InformationResponse },
  {  28, "id-DCH-Rate-InformationItem-RL-CongestInd", ASN1_EXTENSION_ROOT    , dissect_id_DCH_Rate_InformationItem_RL_CongestInd },
  {  29, "id-DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD },
  {  30, "id-DL-CCTrCH-InformationListIE-RL-ReconfReadyTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_CCTrCH_InformationListIE_RL_ReconfReadyTDD },
  {  31, "id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD },
  {  32, "id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD },
  {  33, "id-DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD },
  {  34, "id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD },
  {  35, "id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD },
  {  36, "id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD },
  {  37, "id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD },
  {  38, "id-DL-CCTrCH-InformationList-RL-SetupRqstTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_CCTrCH_InformationList_RL_SetupRqstTDD },
  {  39, "id-FDD-DL-CodeInformation"   , ASN1_EXTENSION_ROOT    , dissect_id_FDD_DL_CodeInformation },
  {  40, "id-DL-DPCH-Information-RL-ReconfPrepFDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_DPCH_Information_RL_ReconfPrepFDD },
  {  41, "id-DL-DPCH-Information-RL-SetupRqstFDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_DPCH_Information_RL_SetupRqstFDD },
  {  42, "id-DL-DPCH-Information-RL-ReconfRqstFDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_DPCH_Information_RL_ReconfRqstFDD },
  {  43, "id-DL-DPCH-InformationItem-PhyChReconfRqstTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_DPCH_InformationItem_PhyChReconfRqstTDD },
  {  44, "id-DL-DPCH-InformationItem-RL-AdditionRspTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_DPCH_InformationItem_RL_AdditionRspTDD },
  {  45, "id-DL-DPCH-InformationItem-RL-SetupRspTDD", ASN1_EXTENSION_ROOT    , dissect_id_DL_DPCH_InformationItem_RL_SetupRspTDD },
  {  46, "id-DL-DPCH-TimingAdjustment" , ASN1_EXTENSION_ROOT    , dissect_id_DL_DPCH_TimingAdjustment },
  {  47, "id-DLReferencePower"         , ASN1_EXTENSION_ROOT    , dissect_id_DLReferencePower },
  {  48, "id-DLReferencePowerList-DL-PC-Rqst", ASN1_EXTENSION_ROOT    , dissect_id_DLReferencePowerList_DL_PC_Rqst },
  {  49, "id-DL-ReferencePowerInformation-DL-PC-Rqst", ASN1_EXTENSION_ROOT    , dissect_id_DL_ReferencePowerInformation_DL_PC_Rqst },
  {  50, "id-DPC-Mode"                 , ASN1_EXTENSION_ROOT    , dissect_id_DPC_Mode },
  {  51, "id-DRXCycleLengthCoefficient", ASN1_EXTENSION_ROOT    , dissect_id_DRXCycleLengthCoefficient },
  {  52, "id-DedicatedMeasurementObjectType-DM-Fail-Ind", ASN1_EXTENSION_ROOT    , dissect_id_DedicatedMeasurementObjectType_DM_Fail_Ind },
  {  53, "id-DedicatedMeasurementObjectType-DM-Fail", ASN1_EXTENSION_ROOT    , dissect_id_DedicatedMeasurementObjectType_DM_Fail },
  {  54, "id-DedicatedMeasurementObjectType-DM-Rprt", ASN1_EXTENSION_ROOT    , dissect_id_DedicatedMeasurementObjectType_DM_Rprt },
  {  55, "id-DedicatedMeasurementObjectType-DM-Rqst", ASN1_EXTENSION_ROOT    , dissect_id_DedicatedMeasurementObjectType_DM_Rqst },
  {  56, "id-DedicatedMeasurementObjectType-DM-Rsp", ASN1_EXTENSION_ROOT    , dissect_id_DedicatedMeasurementObjectType_DM_Rsp },
  {  57, "id-DedicatedMeasurementType" , ASN1_EXTENSION_ROOT    , dissect_id_DedicatedMeasurementType },
  {  58, "id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD", ASN1_EXTENSION_ROOT    , dissect_id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD },
  {  59, "id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD", ASN1_EXTENSION_ROOT    , dissect_id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD },
  {  60, "id-Guaranteed-Rate-Information", ASN1_EXTENSION_ROOT    , dissect_id_Guaranteed_Rate_Information },
  {  61, "id-IMSI"                     , ASN1_EXTENSION_ROOT    , dissect_id_IMSI },
  {  62, "id-HCS-Prio"                 , ASN1_EXTENSION_ROOT    , dissect_id_HCS_Prio },
  {  63, "id-L3-Information"           , ASN1_EXTENSION_ROOT    , dissect_id_L3_Information },
  {  64, "id-AdjustmentPeriod"         , ASN1_EXTENSION_ROOT    , dissect_id_AdjustmentPeriod },
  {  65, "id-MaxAdjustmentStep"        , ASN1_EXTENSION_ROOT    , dissect_id_MaxAdjustmentStep },
  {  66, "id-MeasurementFilterCoefficient", ASN1_EXTENSION_ROOT    , dissect_id_MeasurementFilterCoefficient },
  {  67, "id-MessageStructure"         , ASN1_EXTENSION_ROOT    , dissect_id_MessageStructure },
  {  68, "id-MeasurementID"            , ASN1_EXTENSION_ROOT    , dissect_id_MeasurementID },
  {  69, "id-Neighbouring-GSM-CellInformation", ASN1_EXTENSION_ROOT    , dissect_id_Neighbouring_GSM_CellInformation },
  {  70, "id-Neighbouring-UMTS-CellInformationItem", ASN1_EXTENSION_ROOT    , dissect_id_Neighbouring_UMTS_CellInformationItem },
  {  71, "id-NRT-Load-Information-Value", ASN1_EXTENSION_ROOT    , dissect_id_NRT_Load_Information_Value },
  {  72, "id-NRT-Load-Information-Value-IncrDecrThres", ASN1_EXTENSION_ROOT    , dissect_id_NRT_Load_Information_Value_IncrDecrThres },
  {  73, "id-PagingArea-PagingRqst"    , ASN1_EXTENSION_ROOT    , dissect_id_PagingArea_PagingRqst },
  {  74, "id-FACH-FlowControlInformation", ASN1_EXTENSION_ROOT    , dissect_id_FACH_FlowControlInformation },
  {  75, "id-PartialReportingIndicator", ASN1_EXTENSION_ROOT    , dissect_id_PartialReportingIndicator },
  {  76, "id-Permanent-NAS-UE-Identity", ASN1_EXTENSION_ROOT    , dissect_id_Permanent_NAS_UE_Identity },
  {  77, "id-PowerAdjustmentType"      , ASN1_EXTENSION_ROOT    , dissect_id_PowerAdjustmentType },
  {  78, "id-RANAP-RelocationInformation", ASN1_EXTENSION_ROOT    , dissect_id_RANAP_RelocationInformation },
  {  79, "id-RL-Information-PhyChReconfRqstFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_Information_PhyChReconfRqstFDD },
  {  80, "id-RL-Information-PhyChReconfRqstTDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_Information_PhyChReconfRqstTDD },
  {  81, "id-RL-Information-RL-AdditionRqstFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_Information_RL_AdditionRqstFDD },
  {  82, "id-RL-Information-RL-AdditionRqstTDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_Information_RL_AdditionRqstTDD },
  {  83, "id-RL-Information-RL-DeletionRqst", ASN1_EXTENSION_ROOT    , dissect_id_RL_Information_RL_DeletionRqst },
  {  84, "id-RL-Information-RL-FailureInd", ASN1_EXTENSION_ROOT    , dissect_id_RL_Information_RL_FailureInd },
  {  85, "id-RL-Information-RL-ReconfPrepFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_Information_RL_ReconfPrepFDD },
  {  86, "id-RL-Information-RL-RestoreInd", ASN1_EXTENSION_ROOT    , dissect_id_RL_Information_RL_RestoreInd },
  {  87, "id-RL-Information-RL-SetupRqstFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_Information_RL_SetupRqstFDD },
  {  88, "id-RL-Information-RL-SetupRqstTDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_Information_RL_SetupRqstTDD },
  {  89, "id-RL-InformationItem-RL-CongestInd", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationItem_RL_CongestInd },
  {  90, "id-RL-InformationItem-DM-Rprt", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationItem_DM_Rprt },
  {  91, "id-RL-InformationItem-DM-Rqst", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationItem_DM_Rqst },
  {  92, "id-RL-InformationItem-DM-Rsp", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationItem_DM_Rsp },
  {  93, "id-RL-InformationItem-RL-PreemptRequiredInd", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationItem_RL_PreemptRequiredInd },
  {  94, "id-RL-InformationItem-RL-SetupRqstFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationItem_RL_SetupRqstFDD },
  {  95, "id-RL-InformationList-RL-CongestInd", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationList_RL_CongestInd },
  {  96, "id-RL-InformationList-RL-AdditionRqstFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationList_RL_AdditionRqstFDD },
  {  97, "id-RL-InformationList-RL-DeletionRqst", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationList_RL_DeletionRqst },
  {  98, "id-RL-InformationList-RL-PreemptRequiredInd", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationList_RL_PreemptRequiredInd },
  {  99, "id-RL-InformationList-RL-ReconfPrepFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationList_RL_ReconfPrepFDD },
  { 100, "id-RL-InformationResponse-RL-AdditionRspTDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponse_RL_AdditionRspTDD },
  { 101, "id-RL-InformationResponse-RL-ReconfReadyTDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponse_RL_ReconfReadyTDD },
  { 102, "id-RL-InformationResponse-RL-SetupRspTDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponse_RL_SetupRspTDD },
  { 103, "id-RL-InformationResponseItem-RL-AdditionRspFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponseItem_RL_AdditionRspFDD },
  { 104, "id-RL-InformationResponseItem-RL-ReconfReadyFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponseItem_RL_ReconfReadyFDD },
  { 105, "id-RL-InformationResponseItem-RL-ReconfRspFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponseItem_RL_ReconfRspFDD },
  { 106, "id-RL-InformationResponseItem-RL-SetupRspFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponseItem_RL_SetupRspFDD },
  { 107, "id-RL-InformationResponseList-RL-AdditionRspFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponseList_RL_AdditionRspFDD },
  { 108, "id-RL-InformationResponseList-RL-ReconfReadyFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponseList_RL_ReconfReadyFDD },
  { 109, "id-RL-InformationResponseList-RL-ReconfRspFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponseList_RL_ReconfRspFDD },
  { 110, "id-RL-InformationResponse-RL-ReconfRspTDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponse_RL_ReconfRspTDD },
  { 111, "id-RL-InformationResponseList-RL-SetupRspFDD", ASN1_EXTENSION_ROOT    , dissect_id_RL_InformationResponseList_RL_SetupRspFDD },
  { 112, "id-RL-ReconfigurationFailure-RL-ReconfFail", ASN1_EXTENSION_ROOT    , dissect_id_RL_ReconfigurationFailure_RL_ReconfFail },
  { 113, "id-RL-Set-InformationItem-DM-Rprt", ASN1_EXTENSION_ROOT    , dissect_id_RL_Set_InformationItem_DM_Rprt },
  { 114, "id-RL-Set-InformationItem-DM-Rqst", ASN1_EXTENSION_ROOT    , dissect_id_RL_Set_InformationItem_DM_Rqst },
  { 115, "id-RL-Set-InformationItem-DM-Rsp", ASN1_EXTENSION_ROOT    , dissect_id_RL_Set_InformationItem_DM_Rsp },
  { 116, "id-RL-Set-Information-RL-FailureInd", ASN1_EXTENSION_ROOT    , dissect_id_RL_Set_Information_RL_FailureInd },
  { 117, "id-RL-Set-Information-RL-RestoreInd", ASN1_EXTENSION_ROOT    , dissect_id_RL_Set_Information_RL_RestoreInd },
  { 118, "id-RL-Set-Successful-InformationItem-DM-Fail", ASN1_EXTENSION_ROOT    , dissect_id_RL_Set_Successful_InformationItem_DM_Fail },
  { 119, "id-RL-Set-Unsuccessful-InformationItem-DM-Fail", ASN1_EXTENSION_ROOT    , dissect_id_RL_Set_Unsuccessful_InformationItem_DM_Fail },
  { 120, "id-RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind", ASN1_EXTENSION_ROOT    , dissect_id_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind },
  { 121, "id-RL-Successful-InformationItem-DM-Fail", ASN1_EXTENSION_ROOT    , dissect_id_RL_Successful_InformationItem_DM_Fail },
  { 122, "id-RL-Unsuccessful-InformationItem-DM-Fail", ASN1_EXTENSION_ROOT    , dissect_id_RL_Unsuccessful_InformationItem_DM_Fail },
  { 123, "id-RT-Load-Value"            , ASN1_EXTENSION_ROOT    , dissect_id_RT_Load_Value },
  { 124, "id-RT-Load-Value-IncrDecrThres", ASN1_EXTENSION_ROOT    , dissect_id_RT_Load_Value_IncrDecrThres },
  { 125, "id-S-RNTI"                   , ASN1_EXTENSION_ROOT    , dissect_id_S_RNTI },
  { 126, "id-ResetIndicator"           , ASN1_EXTENSION_ROOT    , dissect_id_ResetIndicator },
  { 127, "id-RNC-ID"                   , ASN1_EXTENSION_ROOT    , dissect_id_RNC_ID },
  { 128, "id-SAI"                      , ASN1_EXTENSION_ROOT    , dissect_id_SAI },
  { 129, "id-SRNC-ID"                  , ASN1_EXTENSION_ROOT    , dissect_id_SRNC_ID },
  { 130, "id-UL-DPCH-Information-RL-SetupRqstFDD", ASN1_EXTENSION_ROOT    , dissect_id_UL_DPCH_Information_RL_SetupRqstFDD },
  { 131, "id-Old-URA-ID"               , ASN1_EXTENSION_ROOT    , dissect_id_Old_URA_ID },
  { 132, "id-UE-State"                 , ASN1_EXTENSION_ROOT    , dissect_id_UE_State },
  { 133, "id-URA-ID"                   , ASN1_EXTENSION_ROOT    , dissect_id_URA_ID },
  { 134, "id-HARQ-Preamble-Mode"       , ASN1_EXTENSION_ROOT    , dissect_id_HARQ_Preamble_Mode },
  { 135, "id-SynchronisationIndicator" , ASN1_EXTENSION_ROOT    , dissect_id_SynchronisationIndicator },
  { 136, "id-UL-DPDCHIndicatorEDCH"    , ASN1_EXTENSION_ROOT    , dissect_id_UL_DPDCHIndicatorEDCH },
  { 137, "id-EDPCH-Information-RLReconfRequest-FDD", ASN1_EXTENSION_ROOT    , dissect_id_EDPCH_Information_RLReconfRequest_FDD },
  { 138, "id-EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd", ASN1_EXTENSION_ROOT    , dissect_id_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd },
  { 139, "id-EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd", ASN1_EXTENSION_ROOT    , dissect_id_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd },
  { 140, "id-EDCH-MacdFlowSpecificInformationList-RL-CongestInd", ASN1_EXTENSION_ROOT    , dissect_id_EDCH_MacdFlowSpecificInformationList_RL_CongestInd },
  { 141, "id-EDCH-MacdFlowSpecificInformationItem-RL-CongestInd", ASN1_EXTENSION_ROOT    , dissect_id_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd },
  { 142, "id-MBMS-Bearer-Service-Full-Address", ASN1_EXTENSION_ROOT    , dissect_id_MBMS_Bearer_Service_Full_Address },
  { 143, "id-Initial-DL-DPCH-TimingAdjustment", ASN1_EXTENSION_ROOT    , dissect_id_Initial_DL_DPCH_TimingAdjustment },
  { 144, "id-Initial-DL-DPCH-TimingAdjustment-Allowed", ASN1_EXTENSION_ROOT    , dissect_id_Initial_DL_DPCH_TimingAdjustment_Allowed },
  { 145, "id-User-Plane-Congestion-Fields-Inclusion", ASN1_EXTENSION_ROOT    , dissect_id_User_Plane_Congestion_Fields_Inclusion },
  { 146, "id-HARQ-Preamble-Mode-Activation-Indicator", ASN1_EXTENSION_ROOT    , dissect_id_HARQ_Preamble_Mode_Activation_Indicator },
  { 147, "id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp", ASN1_EXTENSION_ROOT    , dissect_id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp },
  { 148, "id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp", ASN1_EXTENSION_ROOT    , dissect_id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp },
  { 149, "id-ProvidedInformation"      , ASN1_EXTENSION_ROOT    , dissect_id_ProvidedInformation },
  { 150, "id-Active-MBMS-Bearer-ServiceFDD-PFL", ASN1_EXTENSION_ROOT    , dissect_id_Active_MBMS_Bearer_ServiceFDD_PFL },
  { 151, "id-Active-MBMS-Bearer-ServiceTDD-PFL", ASN1_EXTENSION_ROOT    , dissect_id_Active_MBMS_Bearer_ServiceTDD_PFL },
  { 152, "id-FrequencyBandIndicator"   , ASN1_EXTENSION_ROOT    , dissect_id_FrequencyBandIndicator },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DummyProtocolIE(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DummyProtocolIE, DummyProtocolIE_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_sequence[] = {
  { "po2-ForTPC-Bits"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_po2_ForTPC_Bits },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD, PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_sequence);

  return offset;
}
static int dissect_powerOffsetInformation1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD(tvb, offset, pinfo, tree, hf_rnsap_powerOffsetInformation1);
}


static const per_sequence_t F_DPCH_Information_RL_SetupRqstFDD_sequence[] = {
  { "powerOffsetInformation"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_powerOffsetInformation1 },
  { "fdd-dl-TPC-DownlinkStepSize" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fdd_dl_TPC_DownlinkStepSize },
  { "limitedPowerIncrease"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_limitedPowerIncrease },
  { "innerLoopDLPCStatus"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_innerLoopDLPCStatus },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_F_DPCH_Information_RL_SetupRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_F_DPCH_Information_RL_SetupRqstFDD, F_DPCH_Information_RL_SetupRqstFDD_sequence);

  return offset;
}



static int
dissect_rnsap_MaxNrTimeslots(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 14U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_maxNrTimeslots_UL(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MaxNrTimeslots(tvb, offset, pinfo, tree, hf_rnsap_maxNrTimeslots_UL);
}
static int dissect_maxNrTimeslots_DL(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MaxNrTimeslots(tvb, offset, pinfo, tree, hf_rnsap_maxNrTimeslots_DL);
}



static int
dissect_rnsap_MinimumSpreadingFactor(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 16U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_minimumSpreadingFactor_UL(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MinimumSpreadingFactor(tvb, offset, pinfo, tree, hf_rnsap_minimumSpreadingFactor_UL);
}
static int dissect_minimumSpreadingFactor_DL(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MinimumSpreadingFactor(tvb, offset, pinfo, tree, hf_rnsap_minimumSpreadingFactor_DL);
}



static int
dissect_rnsap_MaxNrULPhysicalchannels(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 2U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_maxNrULPhysicalchannels(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MaxNrULPhysicalchannels(tvb, offset, pinfo, tree, hf_rnsap_maxNrULPhysicalchannels);
}


static const per_sequence_t UL_Physical_Channel_Information_RL_SetupRqstTDD_sequence[] = {
  { "maxNrTimeslots-UL"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxNrTimeslots_UL },
  { "minimumSpreadingFactor-UL"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minimumSpreadingFactor_UL },
  { "maxNrULPhysicalchannels"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxNrULPhysicalchannels },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_Physical_Channel_Information_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_Physical_Channel_Information_RL_SetupRqstTDD, UL_Physical_Channel_Information_RL_SetupRqstTDD_sequence);

  return offset;
}



static int
dissect_rnsap_MaxNrDLPhysicalchannels(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 224U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_maxNrDLPhysicalchannels(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MaxNrDLPhysicalchannels(tvb, offset, pinfo, tree, hf_rnsap_maxNrDLPhysicalchannels);
}


static const per_sequence_t DL_Physical_Channel_Information_RL_SetupRqstTDD_sequence[] = {
  { "maxNrTimeslots-DL"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxNrTimeslots_DL },
  { "minimumSpreadingFactor-DL"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minimumSpreadingFactor_DL },
  { "maxNrDLPhysicalchannels"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxNrDLPhysicalchannels },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_Physical_Channel_Information_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_Physical_Channel_Information_RL_SetupRqstTDD, DL_Physical_Channel_Information_RL_SetupRqstTDD_sequence);

  return offset;
}


static const per_sequence_t UL_CCTrCH_InformationList_RL_SetupRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCH_InformationList_RL_SetupRqstTDD_item },
};

static int
dissect_rnsap_UL_CCTrCH_InformationList_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCH_InformationList_RL_SetupRqstTDD, UL_CCTrCH_InformationList_RL_SetupRqstTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t UL_CCTrCH_InformationItem_RL_SetupRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "ul-TFCS"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_TFCS },
  { "tFCI-Coding"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Coding },
  { "ul-PunctureLimit"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_PunctureLimit },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCH_InformationItem_RL_SetupRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCH_InformationItem_RL_SetupRqstTDD, UL_CCTrCH_InformationItem_RL_SetupRqstTDD_sequence);

  return offset;
}



static int
dissect_rnsap_UL_DPCH_InformationList_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_DPCH_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCH_InformationList_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_DPCH_Information);
}


static const per_sequence_t UL_CCTrCHInformationItem_RL_SetupRspTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "ul-DPCH-Information"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_DPCH_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCHInformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCHInformationItem_RL_SetupRspTDD, UL_CCTrCHInformationItem_RL_SetupRspTDD_sequence);

  return offset;
}
static int dissect_UL_CCTrCHInformationListIE_RL_SetupRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_CCTrCHInformationItem_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCHInformationListIE_RL_SetupRspTDD_item);
}


static const per_sequence_t UL_CCTrCHInformationListIE_RL_SetupRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCHInformationListIE_RL_SetupRspTDD_item },
};

static int
dissect_rnsap_UL_CCTrCHInformationListIE_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCHInformationListIE_RL_SetupRspTDD, UL_CCTrCHInformationListIE_RL_SetupRspTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t TDD_UL_Code_InformationItem_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "tDD-ChannelisationCode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_ChannelisationCode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_UL_Code_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_UL_Code_InformationItem, TDD_UL_Code_InformationItem_sequence);

  return offset;
}
static int dissect_TDD_UL_Code_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_UL_Code_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_TDD_UL_Code_Information_item);
}


static const per_sequence_t TDD_UL_Code_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TDD_UL_Code_Information_item },
};

static int
dissect_rnsap_TDD_UL_Code_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TDD_UL_Code_Information, TDD_UL_Code_Information_sequence_of,
                                                  1, 240);

  return offset;
}
static int dissect_uL_Code_Information1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_UL_Code_Information(tvb, offset, pinfo, tree, hf_rnsap_uL_Code_Information1);
}


static const per_sequence_t UL_Timeslot_InformationItem_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftAndBurstType },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Presence },
  { "uL-Code-Information"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_Code_Information1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_Timeslot_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_Timeslot_InformationItem, UL_Timeslot_InformationItem_sequence);

  return offset;
}
static int dissect_UL_Timeslot_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_Timeslot_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_UL_Timeslot_Information_item);
}


static const per_sequence_t UL_Timeslot_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_Timeslot_Information_item },
};

static int
dissect_rnsap_UL_Timeslot_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_Timeslot_Information, UL_Timeslot_Information_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_uL_Timeslot_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_Timeslot_Information(tvb, offset, pinfo, tree, hf_rnsap_uL_Timeslot_Information);
}


static const per_sequence_t UL_DPCH_InformationItem_RL_SetupRspTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "uL-Timeslot-Information"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_Timeslot_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_InformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_InformationItem_RL_SetupRspTDD, UL_DPCH_InformationItem_RL_SetupRspTDD_sequence);

  return offset;
}



static int
dissect_rnsap_DL_DPCH_InformationList_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_DPCH_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationList_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_DPCH_Information);
}


static const per_sequence_t DL_CCTrCHInformationItem_RL_SetupRspTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "dl-DPCH-Information"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_DPCH_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCHInformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCHInformationItem_RL_SetupRspTDD, DL_CCTrCHInformationItem_RL_SetupRspTDD_sequence);

  return offset;
}
static int dissect_DL_CCTrCHInformationListIE_RL_SetupRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCHInformationItem_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCHInformationListIE_RL_SetupRspTDD_item);
}


static const per_sequence_t DL_CCTrCHInformationListIE_RL_SetupRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCHInformationListIE_RL_SetupRspTDD_item },
};

static int
dissect_rnsap_DL_CCTrCHInformationListIE_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCHInformationListIE_RL_SetupRspTDD, DL_CCTrCHInformationListIE_RL_SetupRspTDD_sequence_of,
                                                  1, 16);

  return offset;
}



static int
dissect_rnsap_DSCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_dsch_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_ID(tvb, offset, pinfo, tree, hf_rnsap_dsch_ID);
}
static int dissect_dSCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_ID(tvb, offset, pinfo, tree, hf_rnsap_dSCH_ID);
}


static const per_sequence_t DSCH_FlowControlItem_sequence[] = {
  { "dSCH-SchedulingPriority"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dSCH_SchedulingPriority },
  { "mAC-c-sh-SDU-Lengths"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mAC_c_sh_SDU_Lengths },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DSCH_FlowControlItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DSCH_FlowControlItem, DSCH_FlowControlItem_sequence);

  return offset;
}
static int dissect_DSCH_FlowControlInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_FlowControlItem(tvb, offset, pinfo, tree, hf_rnsap_DSCH_FlowControlInformation_item);
}


static const per_sequence_t DSCH_FlowControlInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DSCH_FlowControlInformation_item },
};

static int
dissect_rnsap_DSCH_FlowControlInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DSCH_FlowControlInformation, DSCH_FlowControlInformation_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_dSCH_FlowControlInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_FlowControlInformation(tvb, offset, pinfo, tree, hf_rnsap_dSCH_FlowControlInformation);
}


static const value_string rnsap_TransportFormatManagement_vals[] = {
  {   0, "cell-based" },
  {   1, "ue-based" },
  { 0, NULL }
};


static int
dissect_rnsap_TransportFormatManagement(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_transportFormatManagement(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TransportFormatManagement(tvb, offset, pinfo, tree, hf_rnsap_transportFormatManagement);
}


static const per_sequence_t DSCHInformationItem_RL_SetupRspTDD_sequence[] = {
  { "dsch-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dsch_ID },
  { "dSCH-FlowControlInformation" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dSCH_FlowControlInformation },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "transportFormatManagement"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatManagement },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DSCHInformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DSCHInformationItem_RL_SetupRspTDD, DSCHInformationItem_RL_SetupRspTDD_sequence);

  return offset;
}
static int dissect_DSCH_InformationListIEs_RL_SetupRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCHInformationItem_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_DSCH_InformationListIEs_RL_SetupRspTDD_item);
}


static const per_sequence_t DSCH_InformationListIEs_RL_SetupRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DSCH_InformationListIEs_RL_SetupRspTDD_item },
};

static int
dissect_rnsap_DSCH_InformationListIEs_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DSCH_InformationListIEs_RL_SetupRspTDD, DSCH_InformationListIEs_RL_SetupRspTDD_sequence_of,
                                                  0, 10);

  return offset;
}



static int
dissect_rnsap_USCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_usch_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_ID(tvb, offset, pinfo, tree, hf_rnsap_usch_ID);
}
static int dissect_uSCH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_ID(tvb, offset, pinfo, tree, hf_rnsap_uSCH_ID);
}


static const per_sequence_t USCHInformationItem_RL_SetupRspTDD_sequence[] = {
  { "usch-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_usch_ID },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "transportFormatManagement"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatManagement },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_USCHInformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_USCHInformationItem_RL_SetupRspTDD, USCHInformationItem_RL_SetupRspTDD_sequence);

  return offset;
}
static int dissect_USCH_InformationListIEs_RL_SetupRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCHInformationItem_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_USCH_InformationListIEs_RL_SetupRspTDD_item);
}


static const per_sequence_t USCH_InformationListIEs_RL_SetupRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_USCH_InformationListIEs_RL_SetupRspTDD_item },
};

static int
dissect_rnsap_USCH_InformationListIEs_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_USCH_InformationListIEs_RL_SetupRspTDD, USCH_InformationListIEs_RL_SetupRspTDD_sequence_of,
                                                  0, 10);

  return offset;
}



static int
dissect_rnsap_TimeSlotLCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 6U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_timeSlotLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TimeSlotLCR(tvb, offset, pinfo, tree, hf_rnsap_timeSlotLCR);
}
static int dissect_timeslotLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TimeSlotLCR(tvb, offset, pinfo, tree, hf_rnsap_timeslotLCR);
}
static int dissect_timeSlot1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TimeSlotLCR(tvb, offset, pinfo, tree, hf_rnsap_timeSlot1);
}



static int
dissect_rnsap_UL_Timeslot_ISCP_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_UL_TimeslotISCP(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_iSCP(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_Timeslot_ISCP_Value(tvb, offset, pinfo, tree, hf_rnsap_iSCP);
}


static const per_sequence_t UL_TimeSlot_ISCP_LCR_InfoItem_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "iSCP"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iSCP },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_TimeSlot_ISCP_LCR_InfoItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_TimeSlot_ISCP_LCR_InfoItem, UL_TimeSlot_ISCP_LCR_InfoItem_sequence);

  return offset;
}
static int dissect_UL_TimeSlot_ISCP_LCR_Info_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeSlot_ISCP_LCR_InfoItem(tvb, offset, pinfo, tree, hf_rnsap_UL_TimeSlot_ISCP_LCR_Info_item);
}


static const per_sequence_t UL_TimeSlot_ISCP_LCR_Info_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_TimeSlot_ISCP_LCR_Info_item },
};

static int
dissect_rnsap_UL_TimeSlot_ISCP_LCR_Info(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_TimeSlot_ISCP_LCR_Info, UL_TimeSlot_ISCP_LCR_Info_sequence_of,
                                                  1, 6);

  return offset;
}
static int dissect_ul_TimeSlot_ISCP_LCR_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeSlot_ISCP_LCR_Info(tvb, offset, pinfo, tree, hf_rnsap_ul_TimeSlot_ISCP_LCR_Info);
}


static const value_string rnsap_MidambleAllocationMode_vals[] = {
  {   0, "defaultMidamble" },
  {   1, "commonMidamble" },
  {   2, "uESpecificMidamble" },
  { 0, NULL }
};


static int
dissect_rnsap_MidambleAllocationMode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_midambleAllocationMode3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MidambleAllocationMode(tvb, offset, pinfo, tree, hf_rnsap_midambleAllocationMode3);
}


static const value_string rnsap_MidambleConfigurationLCR_vals[] = {
  {   0, "v2" },
  {   1, "v4" },
  {   2, "v6" },
  {   3, "v8" },
  {   4, "v10" },
  {   5, "v12" },
  {   6, "v14" },
  {   7, "v16" },
  { 0, NULL }
};


static int
dissect_rnsap_MidambleConfigurationLCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 7, NULL, NULL, TRUE);

  return offset;
}
static int dissect_midambleConfigurationLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MidambleConfigurationLCR(tvb, offset, pinfo, tree, hf_rnsap_midambleConfigurationLCR);
}


static const per_sequence_t MidambleShiftLCR_sequence[] = {
  { "midambleAllocationMode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleAllocationMode3 },
  { "midambleShift"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShift },
  { "midambleConfigurationLCR"    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleConfigurationLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MidambleShiftLCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MidambleShiftLCR, MidambleShiftLCR_sequence);

  return offset;
}
static int dissect_midambleShiftLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MidambleShiftLCR(tvb, offset, pinfo, tree, hf_rnsap_midambleShiftLCR);
}


static const value_string rnsap_Modulation_vals[] = {
  {   0, "qPSK" },
  {   1, "eightPSK" },
  { 0, NULL }
};


static int
dissect_rnsap_Modulation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_modulation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Modulation(tvb, offset, pinfo, tree, hf_rnsap_modulation);
}


static const per_sequence_t TDD_ChannelisationCodeLCR_sequence[] = {
  { "tDD-ChannelisationCode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_ChannelisationCode },
  { "modulation"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_modulation },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_ChannelisationCodeLCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_ChannelisationCodeLCR, TDD_ChannelisationCodeLCR_sequence);

  return offset;
}
static int dissect_tDD_ChannelisationCodeLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_ChannelisationCodeLCR(tvb, offset, pinfo, tree, hf_rnsap_tDD_ChannelisationCodeLCR);
}
static int dissect_tdd_ChannelisationCodeLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_ChannelisationCodeLCR(tvb, offset, pinfo, tree, hf_rnsap_tdd_ChannelisationCodeLCR);
}



static int
dissect_rnsap_QPSK_DL_DPCH_TimeSlotFormatTDD_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 24U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_qPSK(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_QPSK_DL_DPCH_TimeSlotFormatTDD_LCR(tvb, offset, pinfo, tree, hf_rnsap_qPSK);
}



static int
dissect_rnsap_EightPSK_DL_DPCH_TimeSlotFormatTDD_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 24U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_eightPSK(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EightPSK_DL_DPCH_TimeSlotFormatTDD_LCR(tvb, offset, pinfo, tree, hf_rnsap_eightPSK);
}


static const value_string rnsap_TDD_DL_DPCH_TimeSlotFormat_LCR_vals[] = {
  {   0, "qPSK" },
  {   1, "eightPSK" },
  { 0, NULL }
};

static const per_choice_t TDD_DL_DPCH_TimeSlotFormat_LCR_choice[] = {
  {   0, "qPSK"                        , ASN1_EXTENSION_ROOT    , dissect_qPSK },
  {   1, "eightPSK"                    , ASN1_EXTENSION_ROOT    , dissect_eightPSK },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_TDD_DL_DPCH_TimeSlotFormat_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_TDD_DL_DPCH_TimeSlotFormat_LCR, TDD_DL_DPCH_TimeSlotFormat_LCR_choice,
                                 NULL);

  return offset;
}
static int dissect_s_CCPCH_TimeSlotFormat_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DL_DPCH_TimeSlotFormat_LCR(tvb, offset, pinfo, tree, hf_rnsap_s_CCPCH_TimeSlotFormat_LCR);
}
static int dissect_tdd_DL_DPCH_TimeSlotFormat_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DL_DPCH_TimeSlotFormat_LCR(tvb, offset, pinfo, tree, hf_rnsap_tdd_DL_DPCH_TimeSlotFormat_LCR);
}


static const per_sequence_t Secondary_LCR_CCPCH_TDD_Code_InformationItem_sequence[] = {
  { "tDD-ChannelisationCodeLCR"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_ChannelisationCodeLCR },
  { "s-CCPCH-TimeSlotFormat-LCR"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_s_CCPCH_TimeSlotFormat_LCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Secondary_LCR_CCPCH_TDD_Code_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Secondary_LCR_CCPCH_TDD_Code_InformationItem, Secondary_LCR_CCPCH_TDD_Code_InformationItem_sequence);

  return offset;
}
static int dissect_Secondary_LCR_CCPCH_TDD_Code_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_LCR_CCPCH_TDD_Code_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_Secondary_LCR_CCPCH_TDD_Code_Information_item);
}


static const per_sequence_t Secondary_LCR_CCPCH_TDD_Code_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Secondary_LCR_CCPCH_TDD_Code_Information_item },
};

static int
dissect_rnsap_Secondary_LCR_CCPCH_TDD_Code_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Secondary_LCR_CCPCH_TDD_Code_Information, Secondary_LCR_CCPCH_TDD_Code_Information_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_secondary_LCR_CCPCH_TDD_Code_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_LCR_CCPCH_TDD_Code_Information(tvb, offset, pinfo, tree, hf_rnsap_secondary_LCR_CCPCH_TDD_Code_Information);
}


static const per_sequence_t Secondary_LCR_CCPCH_TDD_InformationItem_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftLCR },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Presence },
  { "secondary-LCR-CCPCH-TDD-Code-Information", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_secondary_LCR_CCPCH_TDD_Code_Information },
  { "tDD-PhysicalChannelOffset"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_PhysicalChannelOffset },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Secondary_LCR_CCPCH_TDD_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Secondary_LCR_CCPCH_TDD_InformationItem, Secondary_LCR_CCPCH_TDD_InformationItem_sequence);

  return offset;
}
static int dissect_Secondary_LCR_CCPCH_TDD_InformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_LCR_CCPCH_TDD_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_Secondary_LCR_CCPCH_TDD_InformationList_item);
}


static const per_sequence_t Secondary_LCR_CCPCH_TDD_InformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Secondary_LCR_CCPCH_TDD_InformationList_item },
};

static int
dissect_rnsap_Secondary_LCR_CCPCH_TDD_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Secondary_LCR_CCPCH_TDD_InformationList, Secondary_LCR_CCPCH_TDD_InformationList_sequence_of,
                                                  0, 8);

  return offset;
}
static int dissect_secondary_LCR_CCPCH_TDD_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_LCR_CCPCH_TDD_InformationList(tvb, offset, pinfo, tree, hf_rnsap_secondary_LCR_CCPCH_TDD_InformationList);
}


static const per_sequence_t Secondary_LCR_CCPCH_Info_TDD_sequence[] = {
  { "dl-TFCS"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_TFCS },
  { "tFCI-Coding"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Coding },
  { "secondary-LCR-CCPCH-TDD-InformationList", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_secondary_LCR_CCPCH_TDD_InformationList },
  { "fACH-InformationList"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fACH_InformationList },
  { "pCH-InformationList"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pCH_InformationList },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Secondary_LCR_CCPCH_Info_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Secondary_LCR_CCPCH_Info_TDD, Secondary_LCR_CCPCH_Info_TDD_sequence);

  return offset;
}
static int dissect_secondary_LCR_CCPCH_Info_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_LCR_CCPCH_Info_TDD(tvb, offset, pinfo, tree, hf_rnsap_secondary_LCR_CCPCH_Info_TDD);
}



static int
dissect_rnsap_UL_LCR_CCTrCHInformationList_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_LCR_CCTrCHInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_LCR_CCTrCHInformationList_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_LCR_CCTrCHInformation);
}



static int
dissect_rnsap_DL_LCR_CCTrCHInformationList_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_LCR_CCTrCHInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_LCR_CCTrCHInformationList_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_LCR_CCTrCHInformation);
}



static int
dissect_rnsap_DSCH_LCR_InformationResponse_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dsch_LCR_InformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_LCR_InformationResponse_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dsch_LCR_InformationResponse);
}



static int
dissect_rnsap_USCH_LCR_InformationResponse_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_usch_LCR_InformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_LCR_InformationResponse_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_usch_LCR_InformationResponse);
}


static const per_sequence_t RL_LCR_InformationResponse_RL_SetupRspTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "uRA-Information"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uRA_Information },
  { "sAI"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAI },
  { "gA-Cell"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_Cell },
  { "gA-AccessPointPosition"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_AccessPointPosition },
  { "ul-TimeSlot-ISCP-LCR-Info"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_TimeSlot_ISCP_LCR_Info },
  { "maxUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxUL_SIR },
  { "minUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minUL_SIR },
  { "maximumAllowedULTxPower"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumAllowedULTxPower },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minimumDLTxPower },
  { "uARFCNforNt"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uARFCNforNt },
  { "cellParameterID"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cellParameterID },
  { "sCTD-Indicator"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_sCTD_Indicator },
  { "pCCPCH-Power"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pCCPCH_Power },
  { "alphaValue"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_alphaValue },
  { "ul-PhysCH-SF-Variation"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_PhysCH_SF_Variation },
  { "synchronisationConfiguration", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_synchronisationConfiguration },
  { "secondary-LCR-CCPCH-Info-TDD", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_secondary_LCR_CCPCH_Info_TDD },
  { "ul-LCR-CCTrCHInformation"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_LCR_CCTrCHInformation },
  { "dl-LCR-CCTrCHInformation"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_LCR_CCTrCHInformation },
  { "dCH-InformationResponse"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dCH_InformationResponse1 },
  { "dsch-LCR-InformationResponse", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dsch_LCR_InformationResponse },
  { "usch-LCR-InformationResponse", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_usch_LCR_InformationResponse },
  { "neighbouring-UMTS-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_UMTS_CellInformation },
  { "neighbouring-GSM-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_GSM_CellInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_LCR_InformationResponse_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_LCR_InformationResponse_RL_SetupRspTDD, RL_LCR_InformationResponse_RL_SetupRspTDD_sequence);

  return offset;
}



static int
dissect_rnsap_UL_DPCH_LCR_InformationList_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_DPCH_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCH_LCR_InformationList_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_DPCH_LCR_Information);
}


static const per_sequence_t UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "ul-DPCH-LCR-Information"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_DPCH_LCR_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD, UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_sequence);

  return offset;
}
static int dissect_UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD_item);
}


static const per_sequence_t UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD_item },
};

static int
dissect_rnsap_UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD, UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD_sequence_of,
                                                  1, 16);

  return offset;
}



static int
dissect_rnsap_QPSK_UL_DPCH_TimeSlotFormatTDD_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 69U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_qPSK1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_QPSK_UL_DPCH_TimeSlotFormatTDD_LCR(tvb, offset, pinfo, tree, hf_rnsap_qPSK1);
}



static int
dissect_rnsap_EightPSK_UL_DPCH_TimeSlotFormatTDD_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 24U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_eightPSK1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EightPSK_UL_DPCH_TimeSlotFormatTDD_LCR(tvb, offset, pinfo, tree, hf_rnsap_eightPSK1);
}


static const value_string rnsap_TDD_UL_DPCH_TimeSlotFormat_LCR_vals[] = {
  {   0, "qPSK" },
  {   1, "eightPSK" },
  { 0, NULL }
};

static const per_choice_t TDD_UL_DPCH_TimeSlotFormat_LCR_choice[] = {
  {   0, "qPSK"                        , ASN1_EXTENSION_ROOT    , dissect_qPSK1 },
  {   1, "eightPSK"                    , ASN1_EXTENSION_ROOT    , dissect_eightPSK1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_TDD_UL_DPCH_TimeSlotFormat_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_TDD_UL_DPCH_TimeSlotFormat_LCR, TDD_UL_DPCH_TimeSlotFormat_LCR_choice,
                                 NULL);

  return offset;
}
static int dissect_tdd_UL_DPCH_TimeSlotFormat_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_UL_DPCH_TimeSlotFormat_LCR(tvb, offset, pinfo, tree, hf_rnsap_tdd_UL_DPCH_TimeSlotFormat_LCR);
}


static const per_sequence_t TDD_UL_Code_LCR_InformationItem_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "tdd-ChannelisationCodeLCR"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tdd_ChannelisationCodeLCR },
  { "tdd-UL-DPCH-TimeSlotFormat-LCR", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tdd_UL_DPCH_TimeSlotFormat_LCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_UL_Code_LCR_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_UL_Code_LCR_InformationItem, TDD_UL_Code_LCR_InformationItem_sequence);

  return offset;
}
static int dissect_TDD_UL_Code_LCR_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_UL_Code_LCR_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_TDD_UL_Code_LCR_Information_item);
}


static const per_sequence_t TDD_UL_Code_LCR_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TDD_UL_Code_LCR_Information_item },
};

static int
dissect_rnsap_TDD_UL_Code_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TDD_UL_Code_LCR_Information, TDD_UL_Code_LCR_Information_sequence_of,
                                                  1, 240);

  return offset;
}
static int dissect_uL_Code_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_UL_Code_LCR_Information(tvb, offset, pinfo, tree, hf_rnsap_uL_Code_LCR_Information);
}
static int dissect_uL_Code_LCR_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_UL_Code_LCR_Information(tvb, offset, pinfo, tree, hf_rnsap_uL_Code_LCR_InformationList);
}


static const per_sequence_t UL_TimeslotLCR_InformationItem_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftLCR },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Presence },
  { "uL-Code-LCR-InformationList" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_Code_LCR_InformationList },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_TimeslotLCR_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_TimeslotLCR_InformationItem, UL_TimeslotLCR_InformationItem_sequence);

  return offset;
}
static int dissect_UL_TimeslotLCR_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeslotLCR_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_UL_TimeslotLCR_Information_item);
}


static const per_sequence_t UL_TimeslotLCR_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_TimeslotLCR_Information_item },
};

static int
dissect_rnsap_UL_TimeslotLCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_TimeslotLCR_Information, UL_TimeslotLCR_Information_sequence_of,
                                                  1, 6);

  return offset;
}
static int dissect_uL_TimeslotLCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeslotLCR_Information(tvb, offset, pinfo, tree, hf_rnsap_uL_TimeslotLCR_Information);
}
static int dissect_uL_TimeslotLCR_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeslotLCR_Information(tvb, offset, pinfo, tree, hf_rnsap_uL_TimeslotLCR_Info);
}


static const per_sequence_t UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "uL-TimeslotLCR-Information"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_TimeslotLCR_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_LCR_InformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_LCR_InformationItem_RL_SetupRspTDD, UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_sequence);

  return offset;
}



static int
dissect_rnsap_DL_DPCH_LCR_InformationList_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_DPCH_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_LCR_InformationList_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_DPCH_LCR_Information);
}


static const per_sequence_t DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "dl-DPCH-LCR-Information"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_DPCH_LCR_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD, DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_sequence);

  return offset;
}
static int dissect_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD_item);
}


static const per_sequence_t DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD, DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t TDD_DL_Code_LCR_InformationItem_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "tdd-ChannelisationCodeLCR"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tdd_ChannelisationCodeLCR },
  { "tdd-DL-DPCH-TimeSlotFormat-LCR", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tdd_DL_DPCH_TimeSlotFormat_LCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_DL_Code_LCR_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_DL_Code_LCR_InformationItem, TDD_DL_Code_LCR_InformationItem_sequence);

  return offset;
}
static int dissect_TDD_DL_Code_LCR_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DL_Code_LCR_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_TDD_DL_Code_LCR_Information_item);
}


static const per_sequence_t TDD_DL_Code_LCR_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TDD_DL_Code_LCR_Information_item },
};

static int
dissect_rnsap_TDD_DL_Code_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TDD_DL_Code_LCR_Information, TDD_DL_Code_LCR_Information_sequence_of,
                                                  1, 240);

  return offset;
}
static int dissect_dL_Code_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DL_Code_LCR_Information(tvb, offset, pinfo, tree, hf_rnsap_dL_Code_LCR_Information);
}


static const per_sequence_t DL_TimeslotLCR_InformationItem_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftLCR },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Presence },
  { "dL-Code-LCR-Information"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_Code_LCR_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_TimeslotLCR_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_TimeslotLCR_InformationItem, DL_TimeslotLCR_InformationItem_sequence);

  return offset;
}
static int dissect_DL_TimeslotLCR_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeslotLCR_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_DL_TimeslotLCR_Information_item);
}


static const per_sequence_t DL_TimeslotLCR_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_TimeslotLCR_Information_item },
};

static int
dissect_rnsap_DL_TimeslotLCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_TimeslotLCR_Information, DL_TimeslotLCR_Information_sequence_of,
                                                  1, 6);

  return offset;
}
static int dissect_dL_Timeslot_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeslotLCR_Information(tvb, offset, pinfo, tree, hf_rnsap_dL_Timeslot_LCR_Information);
}
static int dissect_dL_TimeslotLCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeslotLCR_Information(tvb, offset, pinfo, tree, hf_rnsap_dL_TimeslotLCR_Information);
}
static int dissect_dL_TimeslotLCR_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeslotLCR_Information(tvb, offset, pinfo, tree, hf_rnsap_dL_TimeslotLCR_Info);
}


static const value_string rnsap_TSTD_Indicator_vals[] = {
  {   0, "active" },
  {   1, "inactive" },
  { 0, NULL }
};


static int
dissect_rnsap_TSTD_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tSTD_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TSTD_Indicator(tvb, offset, pinfo, tree, hf_rnsap_tSTD_Indicator);
}


static const per_sequence_t DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "dL-Timeslot-LCR-Information" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_Timeslot_LCR_Information },
  { "tSTD-Indicator"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tSTD_Indicator },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_LCR_InformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_LCR_InformationItem_RL_SetupRspTDD, DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_sequence);

  return offset;
}


static const per_sequence_t DSCH_LCR_InformationItem_RL_SetupRspTDD_sequence[] = {
  { "dsch-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dsch_ID },
  { "dSCH-FlowControlInformation" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dSCH_FlowControlInformation },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "transportFormatManagement"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatManagement },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DSCH_LCR_InformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DSCH_LCR_InformationItem_RL_SetupRspTDD, DSCH_LCR_InformationItem_RL_SetupRspTDD_sequence);

  return offset;
}
static int dissect_DSCH_LCR_InformationListIEs_RL_SetupRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_LCR_InformationItem_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_DSCH_LCR_InformationListIEs_RL_SetupRspTDD_item);
}


static const per_sequence_t DSCH_LCR_InformationListIEs_RL_SetupRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DSCH_LCR_InformationListIEs_RL_SetupRspTDD_item },
};

static int
dissect_rnsap_DSCH_LCR_InformationListIEs_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DSCH_LCR_InformationListIEs_RL_SetupRspTDD, DSCH_LCR_InformationListIEs_RL_SetupRspTDD_sequence_of,
                                                  0, 10);

  return offset;
}


static const per_sequence_t USCH_LCR_InformationItem_RL_SetupRspTDD_sequence[] = {
  { "usch-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_usch_ID },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "transportFormatManagement"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatManagement },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_USCH_LCR_InformationItem_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_USCH_LCR_InformationItem_RL_SetupRspTDD, USCH_LCR_InformationItem_RL_SetupRspTDD_sequence);

  return offset;
}
static int dissect_USCH_LCR_InformationListIEs_RL_SetupRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_LCR_InformationItem_RL_SetupRspTDD(tvb, offset, pinfo, tree, hf_rnsap_USCH_LCR_InformationListIEs_RL_SetupRspTDD_item);
}


static const per_sequence_t USCH_LCR_InformationListIEs_RL_SetupRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_USCH_LCR_InformationListIEs_RL_SetupRspTDD_item },
};

static int
dissect_rnsap_USCH_LCR_InformationListIEs_RL_SetupRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_USCH_LCR_InformationListIEs_RL_SetupRspTDD, USCH_LCR_InformationListIEs_RL_SetupRspTDD_sequence_of,
                                                  0, 10);

  return offset;
}


static const per_sequence_t GeneralCauseList_RL_SetupFailureFDD_sequence[] = {
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GeneralCauseList_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GeneralCauseList_RL_SetupFailureFDD, GeneralCauseList_RL_SetupFailureFDD_sequence);

  return offset;
}
static int dissect_generalCause(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GeneralCauseList_RL_SetupFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_generalCause);
}


static const per_sequence_t UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item },
};

static int
dissect_rnsap_UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD, UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD);
}


static const per_sequence_t SuccessfulRL_InformationResponseList_RL_SetupFailureFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_SuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item },
};

static int
dissect_rnsap_SuccessfulRL_InformationResponseList_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_SuccessfulRL_InformationResponseList_RL_SetupFailureFDD, SuccessfulRL_InformationResponseList_RL_SetupFailureFDD_sequence_of,
                                                  0, 15);

  return offset;
}
static int dissect_successful_RL_InformationRespList_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SuccessfulRL_InformationResponseList_RL_SetupFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_successful_RL_InformationRespList_RL_SetupFailureFDD);
}


static const per_sequence_t RLSpecificCauseList_RL_SetupFailureFDD_sequence[] = {
  { "unsuccessful-RL-InformationRespList-RL-SetupFailureFDD", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD },
  { "successful-RL-InformationRespList-RL-SetupFailureFDD", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_successful_RL_InformationRespList_RL_SetupFailureFDD },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RLSpecificCauseList_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RLSpecificCauseList_RL_SetupFailureFDD, RLSpecificCauseList_RL_SetupFailureFDD_sequence);

  return offset;
}
static int dissect_rLSpecificCause(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RLSpecificCauseList_RL_SetupFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_rLSpecificCause);
}


static const value_string rnsap_CauseLevel_RL_SetupFailureFDD_vals[] = {
  {   0, "generalCause" },
  {   1, "rLSpecificCause" },
  { 0, NULL }
};

static const per_choice_t CauseLevel_RL_SetupFailureFDD_choice[] = {
  {   0, "generalCause"                , ASN1_EXTENSION_ROOT    , dissect_generalCause },
  {   1, "rLSpecificCause"             , ASN1_EXTENSION_ROOT    , dissect_rLSpecificCause },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CauseLevel_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CauseLevel_RL_SetupFailureFDD, CauseLevel_RL_SetupFailureFDD_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD, UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_sequence);

  return offset;
}


static const per_sequence_t Combining_RL_SetupFailureFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Combining_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Combining_RL_SetupFailureFDD, Combining_RL_SetupFailureFDD_sequence);

  return offset;
}
static int dissect_combining1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Combining_RL_SetupFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_combining1);
}


static const per_sequence_t NonCombiningOrFirstRL_RL_SetupFailureFDD_sequence[] = {
  { "dCH-InformationResponse"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_InformationResponse },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_NonCombiningOrFirstRL_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_NonCombiningOrFirstRL_RL_SetupFailureFDD, NonCombiningOrFirstRL_RL_SetupFailureFDD_sequence);

  return offset;
}
static int dissect_nonCombiningOrFirstRL1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NonCombiningOrFirstRL_RL_SetupFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_nonCombiningOrFirstRL1);
}


static const value_string rnsap_DiversityIndication_RL_SetupFailureFDD_vals[] = {
  {   0, "combining" },
  {   1, "nonCombiningOrFirstRL" },
  { 0, NULL }
};

static const per_choice_t DiversityIndication_RL_SetupFailureFDD_choice[] = {
  {   0, "combining"                   , ASN1_NO_EXTENSIONS     , dissect_combining1 },
  {   1, "nonCombiningOrFirstRL"       , ASN1_NO_EXTENSIONS     , dissect_nonCombiningOrFirstRL1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DiversityIndication_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DiversityIndication_RL_SetupFailureFDD, DiversityIndication_RL_SetupFailureFDD_choice,
                                 NULL);

  return offset;
}
static int dissect_diversityIndication1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DiversityIndication_RL_SetupFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_diversityIndication1);
}


static const per_sequence_t SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "uRA-Information"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uRA_Information },
  { "sAI"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAI },
  { "gA-Cell"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_Cell },
  { "gA-AccessPointPosition"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_AccessPointPosition },
  { "received-total-wide-band-power", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_received_total_wide_band_power },
  { "not-Used-secondary-CCPCH-Info", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_secondary_CCPCH_Info },
  { "dl-CodeInformation"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_CodeInformation },
  { "diversityIndication"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_diversityIndication1 },
  { "sSDT-SupportIndicator"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sSDT_SupportIndicator },
  { "maxUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxUL_SIR },
  { "minUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minUL_SIR },
  { "closedlooptimingadjustmentmode", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_closedlooptimingadjustmentmode },
  { "maximumAllowedULTxPower"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumAllowedULTxPower },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minimumDLTxPower },
  { "primaryCPICH-Power"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_primaryCPICH_Power },
  { "primaryScramblingCode"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primaryScramblingCode },
  { "uL-UARFCN"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uL_UARFCN },
  { "dL-UARFCN"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_UARFCN },
  { "not-Used-dSCH-InformationResponse-RL-SetupFailureFDD", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_dSCH_InformationResponse_RL_SetupFailureFDD },
  { "neighbouring-UMTS-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_UMTS_CellInformation },
  { "neighbouring-GSM-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_GSM_CellInformation },
  { "pC-Preamble"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pC_Preamble },
  { "sRB-Delay"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sRB_Delay },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_SuccessfulRL_InformationResponse_RL_SetupFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_SuccessfulRL_InformationResponse_RL_SetupFailureFDD, SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sequence);

  return offset;
}


static const per_sequence_t GeneralCauseList_RL_SetupFailureTDD_sequence[] = {
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GeneralCauseList_RL_SetupFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GeneralCauseList_RL_SetupFailureTDD, GeneralCauseList_RL_SetupFailureTDD_sequence);

  return offset;
}
static int dissect_generalCause1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GeneralCauseList_RL_SetupFailureTDD(tvb, offset, pinfo, tree, hf_rnsap_generalCause1);
}



static int
dissect_rnsap_Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD(tvb, offset, pinfo, tree, hf_rnsap_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD);
}


static const per_sequence_t RLSpecificCauseList_RL_SetupFailureTDD_sequence[] = {
  { "unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RLSpecificCauseList_RL_SetupFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RLSpecificCauseList_RL_SetupFailureTDD, RLSpecificCauseList_RL_SetupFailureTDD_sequence);

  return offset;
}
static int dissect_rLSpecificCause1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RLSpecificCauseList_RL_SetupFailureTDD(tvb, offset, pinfo, tree, hf_rnsap_rLSpecificCause1);
}


static const value_string rnsap_CauseLevel_RL_SetupFailureTDD_vals[] = {
  {   0, "generalCause" },
  {   1, "rLSpecificCause" },
  { 0, NULL }
};

static const per_choice_t CauseLevel_RL_SetupFailureTDD_choice[] = {
  {   0, "generalCause"                , ASN1_EXTENSION_ROOT    , dissect_generalCause1 },
  {   1, "rLSpecificCause"             , ASN1_EXTENSION_ROOT    , dissect_rLSpecificCause1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CauseLevel_RL_SetupFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CauseLevel_RL_SetupFailureTDD, CauseLevel_RL_SetupFailureTDD_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD, UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_sequence);

  return offset;
}


static const per_sequence_t UL_CCTrCH_InformationList_RL_AdditionRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCH_InformationList_RL_AdditionRqstTDD_item },
};

static int
dissect_rnsap_UL_CCTrCH_InformationList_RL_AdditionRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCH_InformationList_RL_AdditionRqstTDD, UL_CCTrCH_InformationList_RL_AdditionRqstTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const value_string rnsap_TDD_TPC_UplinkStepSize_LCR_vals[] = {
  {   0, "step-size1" },
  {   1, "step-size2" },
  {   2, "step-size3" },
  { 0, NULL }
};


static int
dissect_rnsap_TDD_TPC_UplinkStepSize_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_uplinkStepSizeLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_TPC_UplinkStepSize_LCR(tvb, offset, pinfo, tree, hf_rnsap_uplinkStepSizeLCR);
}


static const per_sequence_t UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "uplinkStepSizeLCR"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uplinkStepSizeLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCH_InformationItem_RL_AdditionRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCH_InformationItem_RL_AdditionRqstTDD, UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_sequence);

  return offset;
}


static const per_sequence_t DL_CCTrCH_InformationList_RL_AdditionRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_InformationList_RL_AdditionRqstTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_InformationList_RL_AdditionRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_InformationList_RL_AdditionRqstTDD, DL_CCTrCH_InformationList_RL_AdditionRqstTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "downlinkStepSize"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_downlinkStepSize },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_InformationItem_RL_AdditionRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_InformationItem_RL_AdditionRqstTDD, DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_sequence);

  return offset;
}



static int
dissect_rnsap_UL_DPCH_InformationList_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_DPCH_Information1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCH_InformationList_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_DPCH_Information1);
}


static const per_sequence_t UL_CCTrCHInformationItem_RL_AdditionRspTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "ul-DPCH-Information"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_DPCH_Information1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCHInformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCHInformationItem_RL_AdditionRspTDD, UL_CCTrCHInformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_UL_CCTrCHInformationListIE_RL_AdditionRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_CCTrCHInformationItem_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCHInformationListIE_RL_AdditionRspTDD_item);
}


static const per_sequence_t UL_CCTrCHInformationListIE_RL_AdditionRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCHInformationListIE_RL_AdditionRspTDD_item },
};

static int
dissect_rnsap_UL_CCTrCHInformationListIE_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCHInformationListIE_RL_AdditionRspTDD, UL_CCTrCHInformationListIE_RL_AdditionRspTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t UL_DPCH_InformationItem_RL_AdditionRspTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "uL-Timeslot-Information"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_Timeslot_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_InformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_InformationItem_RL_AdditionRspTDD, UL_DPCH_InformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}


static const per_sequence_t DiversityIndication_RL_AdditionRspTDD2_sequence[] = {
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DiversityIndication_RL_AdditionRspTDD2(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DiversityIndication_RL_AdditionRspTDD2, DiversityIndication_RL_AdditionRspTDD2_sequence);

  return offset;
}
static int dissect_diversityIndication4(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DiversityIndication_RL_AdditionRspTDD2(tvb, offset, pinfo, tree, hf_rnsap_diversityIndication4);
}


static const per_sequence_t DSCHInformationItem_RL_AdditionRspTDD_sequence[] = {
  { "dsch-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dsch_ID },
  { "transportFormatManagement"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatManagement },
  { "dSCH-FlowControlInformation" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dSCH_FlowControlInformation },
  { "diversityIndication"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_diversityIndication4 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DSCHInformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DSCHInformationItem_RL_AdditionRspTDD, DSCHInformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_DSCH_InformationListIE_RL_AdditionRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCHInformationItem_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_DSCH_InformationListIE_RL_AdditionRspTDD_item);
}


static const per_sequence_t DSCH_InformationListIE_RL_AdditionRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DSCH_InformationListIE_RL_AdditionRspTDD_item },
};

static int
dissect_rnsap_DSCH_InformationListIE_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DSCH_InformationListIE_RL_AdditionRspTDD, DSCH_InformationListIE_RL_AdditionRspTDD_sequence_of,
                                                  0, 10);

  return offset;
}


static const per_sequence_t USCHInformationItem_RL_AdditionRspTDD_sequence[] = {
  { "uSCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uSCH_ID },
  { "transportFormatManagement"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatManagement },
  { "diversityIndication"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_diversityIndication4 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_USCHInformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_USCHInformationItem_RL_AdditionRspTDD, USCHInformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_USCH_InformationListIE_RL_AdditionRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCHInformationItem_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_USCH_InformationListIE_RL_AdditionRspTDD_item);
}


static const per_sequence_t USCH_InformationListIE_RL_AdditionRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_USCH_InformationListIE_RL_AdditionRspTDD_item },
};

static int
dissect_rnsap_USCH_InformationListIE_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_USCH_InformationListIE_RL_AdditionRspTDD, USCH_InformationListIE_RL_AdditionRspTDD_sequence_of,
                                                  0, 10);

  return offset;
}



static int
dissect_rnsap_UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_CCTrCH_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_CCTrCH_LCR_Information);
}



static int
dissect_rnsap_DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_CCTrCH_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_CCTrCH_LCR_Information);
}



static int
dissect_rnsap_DCH_InformationResponseList_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dCH_InformationResponse2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DCH_InformationResponseList_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dCH_InformationResponse2);
}



static int
dissect_rnsap_DSCH_LCR_InformationResponse_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dsch_LCR_InformationResponse1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_LCR_InformationResponse_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dsch_LCR_InformationResponse1);
}



static int
dissect_rnsap_USCH_LCR_InformationResponse_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_usch_LCR_InformationResponse1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_LCR_InformationResponse_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_usch_LCR_InformationResponse1);
}


static const per_sequence_t RL_LCR_InformationResponse_RL_AdditionRspTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "uRA-Information"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uRA_Information },
  { "sAI"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAI },
  { "gA-Cell"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_Cell },
  { "gA-AccessPointPosition"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_AccessPointPosition },
  { "ul-TimeSlot-ISCP-LCR-Info"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_TimeSlot_ISCP_LCR_Info },
  { "maxUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxUL_SIR },
  { "minUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minUL_SIR },
  { "pCCPCH-Power"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pCCPCH_Power },
  { "maximumAllowedULTxPower"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumAllowedULTxPower },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minimumDLTxPower },
  { "alphaValue"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_alphaValue },
  { "ul-PhysCH-SF-Variation"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_PhysCH_SF_Variation },
  { "synchronisationConfiguration", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_synchronisationConfiguration },
  { "secondary-LCR-CCPCH-Info-TDD", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_secondary_LCR_CCPCH_Info_TDD },
  { "ul-CCTrCH-LCR-Information"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_CCTrCH_LCR_Information },
  { "dl-CCTrCH-LCR-Information"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_CCTrCH_LCR_Information },
  { "dCH-InformationResponse"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dCH_InformationResponse2 },
  { "dsch-LCR-InformationResponse", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dsch_LCR_InformationResponse1 },
  { "usch-LCR-InformationResponse", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_usch_LCR_InformationResponse1 },
  { "neighbouring-UMTS-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_UMTS_CellInformation },
  { "neighbouring-GSM-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_GSM_CellInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_LCR_InformationResponse_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_LCR_InformationResponse_RL_AdditionRspTDD, RL_LCR_InformationResponse_RL_AdditionRspTDD_sequence);

  return offset;
}



static int
dissect_rnsap_UL_DPCH_LCR_InformationList_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_DPCH_LCR_Information1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCH_LCR_InformationList_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_DPCH_LCR_Information1);
}


static const per_sequence_t UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "ul-DPCH-LCR-Information"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_DPCH_LCR_Information1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD, UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item);
}


static const per_sequence_t UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item },
};

static int
dissect_rnsap_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD, UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "uL-TimeslotLCR-Information"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_TimeslotLCR_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD, UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}



static int
dissect_rnsap_DL_DPCH_LCR_InformationList_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_DPCH_LCR_Information1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_LCR_InformationList_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_DPCH_LCR_Information1);
}


static const per_sequence_t DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "dl-DPCH-LCR-Information"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_DPCH_LCR_Information1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD, DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item);
}


static const per_sequence_t DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD, DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "dL-TimeslotLCR-Information"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_TimeslotLCR_Information },
  { "tSTD-Indicator"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tSTD_Indicator },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD, DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}


static const per_sequence_t DSCH_LCR_InformationItem_RL_AdditionRspTDD_sequence[] = {
  { "dsch-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dsch_ID },
  { "dSCH-FlowControlInformation" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dSCH_FlowControlInformation },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "transportFormatManagement"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatManagement },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DSCH_LCR_InformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DSCH_LCR_InformationItem_RL_AdditionRspTDD, DSCH_LCR_InformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_LCR_InformationItem_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD_item);
}


static const per_sequence_t DSCH_LCR_InformationListIEs_RL_AdditionRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD_item },
};

static int
dissect_rnsap_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD, DSCH_LCR_InformationListIEs_RL_AdditionRspTDD_sequence_of,
                                                  0, 10);

  return offset;
}


static const per_sequence_t USCH_LCR_InformationItem_RL_AdditionRspTDD_sequence[] = {
  { "usch-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_usch_ID },
  { "transportFormatManagement"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatManagement },
  { "diversityIndication"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_diversityIndication4 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_USCH_LCR_InformationItem_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_USCH_LCR_InformationItem_RL_AdditionRspTDD, USCH_LCR_InformationItem_RL_AdditionRspTDD_sequence);

  return offset;
}
static int dissect_USCH_LCR_InformationListIEs_RL_AdditionRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_LCR_InformationItem_RL_AdditionRspTDD(tvb, offset, pinfo, tree, hf_rnsap_USCH_LCR_InformationListIEs_RL_AdditionRspTDD_item);
}


static const per_sequence_t USCH_LCR_InformationListIEs_RL_AdditionRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_USCH_LCR_InformationListIEs_RL_AdditionRspTDD_item },
};

static int
dissect_rnsap_USCH_LCR_InformationListIEs_RL_AdditionRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_USCH_LCR_InformationListIEs_RL_AdditionRspTDD, USCH_LCR_InformationListIEs_RL_AdditionRspTDD_sequence_of,
                                                  0, 10);

  return offset;
}


static const per_sequence_t GeneralCauseList_RL_AdditionFailureFDD_sequence[] = {
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GeneralCauseList_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GeneralCauseList_RL_AdditionFailureFDD, GeneralCauseList_RL_AdditionFailureFDD_sequence);

  return offset;
}
static int dissect_generalCause2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GeneralCauseList_RL_AdditionFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_generalCause2);
}


static const per_sequence_t UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item },
};

static int
dissect_rnsap_UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD, UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD);
}


static const per_sequence_t SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item },
};

static int
dissect_rnsap_SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD, SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_sequence_of,
                                                  0, 14);

  return offset;
}
static int dissect_successful_RL_InformationRespList_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_successful_RL_InformationRespList_RL_AdditionFailureFDD);
}


static const per_sequence_t RLSpecificCauseList_RL_AdditionFailureFDD_sequence[] = {
  { "unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD },
  { "successful-RL-InformationRespList-RL-AdditionFailureFDD", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_successful_RL_InformationRespList_RL_AdditionFailureFDD },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RLSpecificCauseList_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RLSpecificCauseList_RL_AdditionFailureFDD, RLSpecificCauseList_RL_AdditionFailureFDD_sequence);

  return offset;
}
static int dissect_rLSpecificCause2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RLSpecificCauseList_RL_AdditionFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_rLSpecificCause2);
}


static const value_string rnsap_CauseLevel_RL_AdditionFailureFDD_vals[] = {
  {   0, "generalCause" },
  {   1, "rLSpecificCause" },
  { 0, NULL }
};

static const per_choice_t CauseLevel_RL_AdditionFailureFDD_choice[] = {
  {   0, "generalCause"                , ASN1_EXTENSION_ROOT    , dissect_generalCause2 },
  {   1, "rLSpecificCause"             , ASN1_EXTENSION_ROOT    , dissect_rLSpecificCause2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CauseLevel_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CauseLevel_RL_AdditionFailureFDD, CauseLevel_RL_AdditionFailureFDD_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD, UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sequence);

  return offset;
}



static int
dissect_rnsap_DL_CodeInformationList_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_CodeInformation2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CodeInformationList_RL_AdditionFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_dl_CodeInformation2);
}


static const per_sequence_t Combining_RL_AdditionFailureFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Combining_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Combining_RL_AdditionFailureFDD, Combining_RL_AdditionFailureFDD_sequence);

  return offset;
}
static int dissect_combining4(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Combining_RL_AdditionFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_combining4);
}


static const per_sequence_t NonCombining_RL_AdditionFailureFDD_sequence[] = {
  { "dCH-InformationResponse"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_InformationResponse },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_NonCombining_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_NonCombining_RL_AdditionFailureFDD, NonCombining_RL_AdditionFailureFDD_sequence);

  return offset;
}
static int dissect_nonCombining2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NonCombining_RL_AdditionFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_nonCombining2);
}


static const value_string rnsap_DiversityIndication_RL_AdditionFailureFDD_vals[] = {
  {   0, "combining" },
  {   1, "nonCombining" },
  { 0, NULL }
};

static const per_choice_t DiversityIndication_RL_AdditionFailureFDD_choice[] = {
  {   0, "combining"                   , ASN1_NO_EXTENSIONS     , dissect_combining4 },
  {   1, "nonCombining"                , ASN1_NO_EXTENSIONS     , dissect_nonCombining2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DiversityIndication_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DiversityIndication_RL_AdditionFailureFDD, DiversityIndication_RL_AdditionFailureFDD_choice,
                                 NULL);

  return offset;
}
static int dissect_diversityIndication5(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DiversityIndication_RL_AdditionFailureFDD(tvb, offset, pinfo, tree, hf_rnsap_diversityIndication5);
}


static const per_sequence_t SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "rL-Set-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_ID },
  { "uRA-Information"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uRA_Information },
  { "sAI"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAI },
  { "gA-Cell"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_Cell },
  { "gA-AccessPointPosition"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_AccessPointPosition },
  { "received-total-wide-band-power", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_received_total_wide_band_power },
  { "not-Used-secondary-CCPCH-Info", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_secondary_CCPCH_Info },
  { "dl-CodeInformation"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_CodeInformation2 },
  { "diversityIndication"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_diversityIndication5 },
  { "sSDT-SupportIndicator"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sSDT_SupportIndicator },
  { "minUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minUL_SIR },
  { "maxUL-SIR"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxUL_SIR },
  { "closedlooptimingadjustmentmode", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_closedlooptimingadjustmentmode },
  { "maximumAllowedULTxPower"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumAllowedULTxPower },
  { "maximumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximumDLTxPower },
  { "minimumDLTxPower"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_minimumDLTxPower },
  { "neighbouring-UMTS-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_UMTS_CellInformation },
  { "neighbouring-GSM-CellInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouring_GSM_CellInformation },
  { "primaryCPICH-Power"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_primaryCPICH_Power },
  { "pC-Preamble"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pC_Preamble },
  { "sRB-Delay"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sRB_Delay },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_SuccessfulRL_InformationResponse_RL_AdditionFailureFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_SuccessfulRL_InformationResponse_RL_AdditionFailureFDD, SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sequence);

  return offset;
}


static const per_sequence_t GeneralCauseList_RL_AdditionFailureTDD_sequence[] = {
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GeneralCauseList_RL_AdditionFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GeneralCauseList_RL_AdditionFailureTDD, GeneralCauseList_RL_AdditionFailureTDD_sequence);

  return offset;
}
static int dissect_generalCause3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GeneralCauseList_RL_AdditionFailureTDD(tvb, offset, pinfo, tree, hf_rnsap_generalCause3);
}



static int
dissect_rnsap_Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD(tvb, offset, pinfo, tree, hf_rnsap_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD);
}


static const per_sequence_t RLSpecificCauseList_RL_AdditionFailureTDD_sequence[] = {
  { "unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RLSpecificCauseList_RL_AdditionFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RLSpecificCauseList_RL_AdditionFailureTDD, RLSpecificCauseList_RL_AdditionFailureTDD_sequence);

  return offset;
}
static int dissect_rLSpecificCause3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RLSpecificCauseList_RL_AdditionFailureTDD(tvb, offset, pinfo, tree, hf_rnsap_rLSpecificCause3);
}


static const value_string rnsap_CauseLevel_RL_AdditionFailureTDD_vals[] = {
  {   0, "generalCause" },
  {   1, "rLSpecificCause" },
  { 0, NULL }
};

static const per_choice_t CauseLevel_RL_AdditionFailureTDD_choice[] = {
  {   0, "generalCause"                , ASN1_EXTENSION_ROOT    , dissect_generalCause3 },
  {   1, "rLSpecificCause"             , ASN1_EXTENSION_ROOT    , dissect_rLSpecificCause3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CauseLevel_RL_AdditionFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CauseLevel_RL_AdditionFailureTDD, CauseLevel_RL_AdditionFailureTDD_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD, UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_sequence);

  return offset;
}


static const per_sequence_t UL_DPCH_Information_RL_ReconfPrepFDD_sequence[] = {
  { "ul-ScramblingCode"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_ScramblingCode },
  { "ul-SIRTarget"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_SIRTarget },
  { "minUL-ChannelisationCodeLength", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_minUL_ChannelisationCodeLength },
  { "maxNrOfUL-DPDCHs"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_maxNrOfUL_DPDCHs },
  { "ul-PunctureLimit"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_PunctureLimit },
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCS },
  { "ul-DPCCH-SlotFormat"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_DPCCH_SlotFormat },
  { "diversityMode"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_diversityMode },
  { "not-Used-sSDT-CellIDLength"  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_sSDT_CellIDLength },
  { "not-Used-s-FieldLength"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_Used_s_FieldLength },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_Information_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_Information_RL_ReconfPrepFDD, UL_DPCH_Information_RL_ReconfPrepFDD_sequence);

  return offset;
}


static const per_sequence_t PowerOffsetInformation_RL_ReconfPrepFDD_sequence[] = {
  { "pO1-ForTFCI-Bits"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pO1_ForTFCI_Bits },
  { "pO2-ForTPC-Bits"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pO2_ForTPC_Bits },
  { "pO3-ForPilotBits"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pO3_ForPilotBits },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PowerOffsetInformation_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PowerOffsetInformation_RL_ReconfPrepFDD, PowerOffsetInformation_RL_ReconfPrepFDD_sequence);

  return offset;
}
static int dissect_powerOffsetInformation2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerOffsetInformation_RL_ReconfPrepFDD(tvb, offset, pinfo, tree, hf_rnsap_powerOffsetInformation2);
}


static const per_sequence_t DL_DPCH_Power_Information_RL_ReconfPrepFDD_sequence[] = {
  { "powerOffsetInformation"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_powerOffsetInformation2 },
  { "fdd-TPC-DownlinkStepSize"    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fdd_TPC_DownlinkStepSize },
  { "innerLoopDLPCStatus"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_innerLoopDLPCStatus },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_Power_Information_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_Power_Information_RL_ReconfPrepFDD, DL_DPCH_Power_Information_RL_ReconfPrepFDD_sequence);

  return offset;
}


static const per_sequence_t PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_sequence[] = {
  { "po2-ForTPC-Bits"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_po2_ForTPC_Bits },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD, PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_sequence);

  return offset;
}
static int dissect_powerOffsetInformation3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD(tvb, offset, pinfo, tree, hf_rnsap_powerOffsetInformation3);
}


static const per_sequence_t F_DPCH_Information_RL_ReconfPrepFDD_sequence[] = {
  { "powerOffsetInformation"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_powerOffsetInformation3 },
  { "fdd-dl-TPC-DownlinkStepSize" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fdd_dl_TPC_DownlinkStepSize },
  { "limitedPowerIncrease"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_limitedPowerIncrease },
  { "innerLoopDLPCStatus"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_innerLoopDLPCStatus },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_F_DPCH_Information_RL_ReconfPrepFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_F_DPCH_Information_RL_ReconfPrepFDD, F_DPCH_Information_RL_ReconfPrepFDD_sequence);

  return offset;
}


static const per_sequence_t RadioLinkReconfigurationPrepareTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationPrepareTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationPrepareTDD, RadioLinkReconfigurationPrepareTDD_sequence);

  return offset;
}


static const per_sequence_t UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD, UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 16);

  return offset;
}


static const per_sequence_t UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCS },
  { "tFCI-Coding"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tFCI_Coding },
  { "punctureLimit"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_punctureLimit },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCH_AddInformation_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCH_AddInformation_RL_ReconfPrepTDD, UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_sequence);

  return offset;
}


static const per_sequence_t UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD, UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 16);

  return offset;
}


static const per_sequence_t UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCS },
  { "tFCI-Coding"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Coding },
  { "punctureLimit"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_punctureLimit },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD, UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_sequence);

  return offset;
}


static const per_sequence_t UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD, UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 16);

  return offset;
}


static const per_sequence_t UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD, UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_sequence);

  return offset;
}


static const per_sequence_t DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD, DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 16);

  return offset;
}


static const per_sequence_t CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CCTrCH_TPCModifyItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CCTrCH_TPCModifyItem_RL_ReconfPrepTDD, CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_sequence);

  return offset;
}
static int dissect_CCTrCH_TPCModifyList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_TPCModifyItem_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_CCTrCH_TPCModifyList_RL_ReconfPrepTDD_item);
}


static const per_sequence_t CCTrCH_TPCModifyList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_CCTrCH_TPCModifyList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_CCTrCH_TPCModifyList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_CCTrCH_TPCModifyList_RL_ReconfPrepTDD, CCTrCH_TPCModifyList_RL_ReconfPrepTDD_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_cCTrCH_TPCList2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_TPCModifyList_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_cCTrCH_TPCList2);
}


static const per_sequence_t DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCS },
  { "tFCI-Coding"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Coding },
  { "punctureLimit"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_punctureLimit },
  { "cCTrCH-TPCList"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cCTrCH_TPCList2 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD, DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_sequence);

  return offset;
}


static const per_sequence_t DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD, DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 16);

  return offset;
}


static const per_sequence_t DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD, DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_sequence);

  return offset;
}


static const per_sequence_t DSCH_ModifyItem_RL_ReconfPrepTDD_sequence[] = {
  { "dSCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dSCH_ID },
  { "dl-ccTrCHID"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_ccTrCHID },
  { "trChSourceStatisticsDescriptor", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_trChSourceStatisticsDescriptor },
  { "transportFormatSet"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportFormatSet },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_allocationRetentionPriority },
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_schedulingPriorityIndicator },
  { "bLER"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bLER },
  { "transportBearerRequestIndicator", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportBearerRequestIndicator },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DSCH_ModifyItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DSCH_ModifyItem_RL_ReconfPrepTDD, DSCH_ModifyItem_RL_ReconfPrepTDD_sequence);

  return offset;
}
static int dissect_DSCH_ModifyList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_ModifyItem_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_DSCH_ModifyList_RL_ReconfPrepTDD_item);
}


static const per_sequence_t DSCH_ModifyList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DSCH_ModifyList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_DSCH_ModifyList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DSCH_ModifyList_RL_ReconfPrepTDD, DSCH_ModifyList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 128);

  return offset;
}


static const per_sequence_t DSCH_DeleteItem_RL_ReconfPrepTDD_sequence[] = {
  { "dSCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dSCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DSCH_DeleteItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DSCH_DeleteItem_RL_ReconfPrepTDD, DSCH_DeleteItem_RL_ReconfPrepTDD_sequence);

  return offset;
}
static int dissect_DSCH_DeleteList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_DeleteItem_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_DSCH_DeleteList_RL_ReconfPrepTDD_item);
}


static const per_sequence_t DSCH_DeleteList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DSCH_DeleteList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_DSCH_DeleteList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DSCH_DeleteList_RL_ReconfPrepTDD, DSCH_DeleteList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 128);

  return offset;
}



static int
dissect_rnsap_RB_Identity(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 31U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_RB_Info_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RB_Identity(tvb, offset, pinfo, tree, hf_rnsap_RB_Info_item);
}


static const per_sequence_t RB_Info_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RB_Info_item },
};

static int
dissect_rnsap_RB_Info(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RB_Info, RB_Info_sequence_of,
                                                  1, 32);

  return offset;
}
static int dissect_rb_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RB_Info(tvb, offset, pinfo, tree, hf_rnsap_rb_Info);
}


static const per_sequence_t USCH_ModifyItem_RL_ReconfPrepTDD_sequence[] = {
  { "uSCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uSCH_ID },
  { "ul-ccTrCHID"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_ccTrCHID },
  { "trChSourceStatisticsDescriptor", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_trChSourceStatisticsDescriptor },
  { "transportFormatSet"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportFormatSet },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_allocationRetentionPriority },
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_schedulingPriorityIndicator },
  { "bLER"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bLER },
  { "transportBearerRequestIndicator", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportBearerRequestIndicator },
  { "rb-Info"                     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_rb_Info },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_USCH_ModifyItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_USCH_ModifyItem_RL_ReconfPrepTDD, USCH_ModifyItem_RL_ReconfPrepTDD_sequence);

  return offset;
}
static int dissect_USCH_ModifyList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_ModifyItem_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_USCH_ModifyList_RL_ReconfPrepTDD_item);
}


static const per_sequence_t USCH_ModifyList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_USCH_ModifyList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_USCH_ModifyList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_USCH_ModifyList_RL_ReconfPrepTDD, USCH_ModifyList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 10);

  return offset;
}


static const per_sequence_t USCH_DeleteItem_RL_ReconfPrepTDD_sequence[] = {
  { "uSCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uSCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_USCH_DeleteItem_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_USCH_DeleteItem_RL_ReconfPrepTDD, USCH_DeleteItem_RL_ReconfPrepTDD_sequence);

  return offset;
}
static int dissect_USCH_DeleteList_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_DeleteItem_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_USCH_DeleteList_RL_ReconfPrepTDD_item);
}


static const per_sequence_t USCH_DeleteList_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_USCH_DeleteList_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_USCH_DeleteList_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_USCH_DeleteList_RL_ReconfPrepTDD, USCH_DeleteList_RL_ReconfPrepTDD_sequence_of,
                                                  0, 10);

  return offset;
}


static const per_sequence_t RL_Specific_DCH_Info_Item_sequence[] = {
  { "dCH-id"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dCH_id },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Specific_DCH_Info_Item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Specific_DCH_Info_Item, RL_Specific_DCH_Info_Item_sequence);

  return offset;
}
static int dissect_RL_Specific_DCH_Info_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Specific_DCH_Info_Item(tvb, offset, pinfo, tree, hf_rnsap_RL_Specific_DCH_Info_item);
}


static const per_sequence_t RL_Specific_DCH_Info_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Specific_DCH_Info_item },
};

static int
dissect_rnsap_RL_Specific_DCH_Info(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Specific_DCH_Info, RL_Specific_DCH_Info_sequence_of,
                                                  1, 128);

  return offset;
}
static int dissect_rL_Specific_DCH_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Specific_DCH_Info(tvb, offset, pinfo, tree, hf_rnsap_rL_Specific_DCH_Info);
}


static const per_sequence_t RL_InformationIE_RL_ReconfPrepTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "rL-Specific-DCH-Info"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_rL_Specific_DCH_Info },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_InformationIE_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_InformationIE_RL_ReconfPrepTDD, RL_InformationIE_RL_ReconfPrepTDD_sequence);

  return offset;
}
static int dissect_RL_Information_RL_ReconfPrepTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationIE_RL_ReconfPrepTDD(tvb, offset, pinfo, tree, hf_rnsap_RL_Information_RL_ReconfPrepTDD_item);
}


static const per_sequence_t RL_Information_RL_ReconfPrepTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Information_RL_ReconfPrepTDD_item },
};

static int
dissect_rnsap_RL_Information_RL_ReconfPrepTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Information_RL_ReconfPrepTDD, RL_Information_RL_ReconfPrepTDD_sequence_of,
                                                  1, 16);

  return offset;
}



static int
dissect_rnsap_UL_DPCH_InformationAddList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_DPCH_AddInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCH_InformationAddList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_DPCH_AddInformation);
}



static int
dissect_rnsap_UL_DPCH_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_DPCH_ModifyInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCH_InformationModifyList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_DPCH_ModifyInformation);
}



static int
dissect_rnsap_UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_DPCH_DeleteInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_DPCH_DeleteInformation);
}


static const per_sequence_t UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "ul-DPCH-AddInformation"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_DPCH_AddInformation },
  { "ul-DPCH-ModifyInformation"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_DPCH_ModifyInformation },
  { "ul-DPCH-DeleteInformation"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ul_DPCH_DeleteInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCH_InformationItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCH_InformationItem_RL_ReconfReadyTDD, UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_UL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_CCTrCH_InformationItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item);
}


static const per_sequence_t UL_CCTrCHInformationListIE_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_UL_CCTrCHInformationListIE_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCHInformationListIE_RL_ReconfReadyTDD, UL_CCTrCHInformationListIE_RL_ReconfReadyTDD_sequence_of,
                                                  0, 16);

  return offset;
}


static const per_sequence_t UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "uL-TimeslotLCR-Info"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_TimeslotLCR_Info },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD, UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_sequence);

  return offset;
}



static int
dissect_rnsap_RxTimingDeviationForTA(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 127U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_rxTimingDeviationForTA(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RxTimingDeviationForTA(tvb, offset, pinfo, tree, hf_rnsap_rxTimingDeviationForTA);
}


static const per_sequence_t UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "rxTimingDeviationForTA"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_rxTimingDeviationForTA },
  { "uL-Timeslot-Information"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_Timeslot_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD, UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_sequence);

  return offset;
}


static const per_sequence_t TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "tDD-ChannelisationCode"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDD_ChannelisationCode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD, TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD_item);
}


static const per_sequence_t TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD, TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD_sequence_of,
                                                  1, 240);

  return offset;
}
static int dissect_uL_Code_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_uL_Code_Information);
}


static const per_sequence_t UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShiftAndBurstType },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Presence },
  { "uL-Code-Information"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uL_Code_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD, UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item);
}


static const per_sequence_t UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD, UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_uL_Timeslot_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_uL_Timeslot_InformationModifyList_RL_ReconfReadyTDD);
}


static const per_sequence_t UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDD_DPCHOffset },
  { "uL-Timeslot-InformationModifyList-RL-ReconfReadyTDD", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uL_Timeslot_InformationModifyList_RL_ReconfReadyTDD },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD, UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_sequence);

  return offset;
}


static const per_sequence_t TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "tDD-ChannelisationCodeLCR"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDD_ChannelisationCodeLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD, TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item);
}


static const per_sequence_t TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD, TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_sequence_of,
                                                  1, 240);

  return offset;
}
static int dissect_tDD_uL_Code_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_tDD_uL_Code_LCR_Information);
}


static const per_sequence_t UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShiftLCR },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Presence },
  { "tDD-uL-Code-LCR-Information" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDD_uL_Code_LCR_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD, UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item);
}


static const per_sequence_t UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD, UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_sequence_of,
                                                  1, 6);

  return offset;
}


static const per_sequence_t UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD, UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item);
}


static const per_sequence_t UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD, UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_sequence_of,
                                                  0, 240);

  return offset;
}


static const per_sequence_t DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "dL-TimeslotLCR-Info"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_TimeslotLCR_Info },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD, DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_sequence);

  return offset;
}


static const per_sequence_t DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_DPCHOffset },
  { "dL-Timeslot-Information"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_Timeslot_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD, DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_sequence);

  return offset;
}


static const per_sequence_t TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "tDD-ChannelisationCode"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDD_ChannelisationCode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD, TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD_item);
}


static const per_sequence_t TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD, TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD_sequence_of,
                                                  1, 240);

  return offset;
}
static int dissect_dL_Code_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_dL_Code_Information);
}


static const per_sequence_t DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShiftAndBurstType },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Presence },
  { "dL-Code-Information"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_Code_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD, DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item);
}


static const per_sequence_t DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD, DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_dL_Timeslot_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_dL_Timeslot_InformationModifyList_RL_ReconfReadyTDD);
}


static const per_sequence_t DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDD_DPCHOffset },
  { "dL-Timeslot-InformationModifyList-RL-ReconfReadyTDD", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_Timeslot_InformationModifyList_RL_ReconfReadyTDD },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD, DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_sequence);

  return offset;
}


static const per_sequence_t TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "tDD-ChannelisationCodeLCR"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDD_ChannelisationCodeLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD, TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item);
}


static const per_sequence_t TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD, TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_sequence_of,
                                                  1, 240);

  return offset;
}
static int dissect_tDD_dL_Code_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_tDD_dL_Code_LCR_Information);
}


static const per_sequence_t DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShiftLCR },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Presence },
  { "tDD-dL-Code-LCR-Information" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDD_dL_Code_LCR_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD, DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item);
}


static const per_sequence_t DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD, DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_sequence_of,
                                                  1, 6);

  return offset;
}


static const per_sequence_t DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_sequence[] = {
  { "dPCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dPCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD, DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item);
}


static const per_sequence_t DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD, DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_sequence_of,
                                                  0, 240);

  return offset;
}


static const per_sequence_t DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_sequence[] = {
  { "dsch-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dsch_ID },
  { "transportFormatManagement"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatManagement },
  { "dSCH-FlowControlInformation" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dSCH_FlowControlInformation },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD, DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item);
}


static const per_sequence_t DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD, DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_sequence_of,
                                                  0, 10);

  return offset;
}


static const per_sequence_t USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_sequence[] = {
  { "uSCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uSCH_ID },
  { "transportFormatManagement"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatManagement },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD, USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_sequence);

  return offset;
}
static int dissect_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD(tvb, offset, pinfo, tree, hf_rnsap_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item);
}


static const per_sequence_t USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD, USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_sequence_of,
                                                  0, 10);

  return offset;
}


static const per_sequence_t Multiple_RL_InformationResponse_RL_ReconfReadyTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Multiple_RL_InformationResponse_RL_ReconfReadyTDD_item },
};

static int
dissect_rnsap_Multiple_RL_InformationResponse_RL_ReconfReadyTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Multiple_RL_InformationResponse_RL_ReconfReadyTDD, Multiple_RL_InformationResponse_RL_ReconfReadyTDD_sequence_of,
                                                  1, 15);

  return offset;
}


static const per_sequence_t RadioLinkReconfigurationCommit_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationCommit(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationCommit, RadioLinkReconfigurationCommit_sequence);

  return offset;
}


static const per_sequence_t GeneralCauseList_RL_ReconfFailure_sequence[] = {
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GeneralCauseList_RL_ReconfFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GeneralCauseList_RL_ReconfFailure, GeneralCauseList_RL_ReconfFailure_sequence);

  return offset;
}
static int dissect_generalCause4(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GeneralCauseList_RL_ReconfFailure(tvb, offset, pinfo, tree, hf_rnsap_generalCause4);
}


static const per_sequence_t RL_ReconfigurationFailureList_RL_ReconfFailure_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_ReconfigurationFailureList_RL_ReconfFailure_item },
};

static int
dissect_rnsap_RL_ReconfigurationFailureList_RL_ReconfFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_ReconfigurationFailureList_RL_ReconfFailure, RL_ReconfigurationFailureList_RL_ReconfFailure_sequence_of,
                                                  0, 16);

  return offset;
}
static int dissect_rL_ReconfigurationFailureList_RL_ReconfFailure(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_ReconfigurationFailureList_RL_ReconfFailure(tvb, offset, pinfo, tree, hf_rnsap_rL_ReconfigurationFailureList_RL_ReconfFailure);
}


static const per_sequence_t RLSpecificCauseList_RL_ReconfFailure_sequence[] = {
  { "rL-ReconfigurationFailureList-RL-ReconfFailure", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_rL_ReconfigurationFailureList_RL_ReconfFailure },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RLSpecificCauseList_RL_ReconfFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RLSpecificCauseList_RL_ReconfFailure, RLSpecificCauseList_RL_ReconfFailure_sequence);

  return offset;
}
static int dissect_rLSpecificCause4(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RLSpecificCauseList_RL_ReconfFailure(tvb, offset, pinfo, tree, hf_rnsap_rLSpecificCause4);
}


static const value_string rnsap_CauseLevel_RL_ReconfFailure_vals[] = {
  {   0, "generalCause" },
  {   1, "rLSpecificCause" },
  { 0, NULL }
};

static const per_choice_t CauseLevel_RL_ReconfFailure_choice[] = {
  {   0, "generalCause"                , ASN1_EXTENSION_ROOT    , dissect_generalCause4 },
  {   1, "rLSpecificCause"             , ASN1_EXTENSION_ROOT    , dissect_rLSpecificCause4 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CauseLevel_RL_ReconfFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CauseLevel_RL_ReconfFailure, CauseLevel_RL_ReconfFailure_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t RadioLinkReconfigurationCancel_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkReconfigurationCancel(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkReconfigurationCancel, RadioLinkReconfigurationCancel_sequence);

  return offset;
}


static const per_sequence_t UL_DPCH_Information_RL_ReconfRqstFDD_sequence[] = {
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCS },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_Information_RL_ReconfRqstFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_Information_RL_ReconfRqstFDD, UL_DPCH_Information_RL_ReconfRqstFDD_sequence);

  return offset;
}


static const per_sequence_t RL_ReconfigurationRequestFDD_RL_InformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_ReconfigurationRequestFDD_RL_InformationList_item },
};

static int
dissect_rnsap_RL_ReconfigurationRequestFDD_RL_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_ReconfigurationRequestFDD_RL_InformationList, RL_ReconfigurationRequestFDD_RL_InformationList_sequence_of,
                                                  0, 16);

  return offset;
}


static const per_sequence_t RL_ReconfigurationRequestFDD_RL_Information_IEs_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "rL-Specific-DCH-Info"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_rL_Specific_DCH_Info },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_ReconfigurationRequestFDD_RL_Information_IEs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_ReconfigurationRequestFDD_RL_Information_IEs, RL_ReconfigurationRequestFDD_RL_Information_IEs_sequence);

  return offset;
}


static const per_sequence_t UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item },
};

static int
dissect_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD, UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_sequence_of,
                                                  0, 16);

  return offset;
}


static const per_sequence_t UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCS },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD, UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_sequence);

  return offset;
}


static const per_sequence_t UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item },
};

static int
dissect_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD, UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_sequence_of,
                                                  0, 16);

  return offset;
}


static const per_sequence_t UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD, UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_sequence);

  return offset;
}


static const per_sequence_t DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD, DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_sequence_of,
                                                  0, 16);

  return offset;
}


static const per_sequence_t DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "tFCS"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCS },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD, DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_sequence);

  return offset;
}


static const per_sequence_t RL_ReconfigurationRequestTDD_RL_Information_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "rL-Specific-DCH-Info"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_rL_Specific_DCH_Info },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_ReconfigurationRequestTDD_RL_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_ReconfigurationRequestTDD_RL_Information, RL_ReconfigurationRequestTDD_RL_Information_sequence);

  return offset;
}
static int dissect_Multiple_RL_ReconfigurationRequestTDD_RL_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_ReconfigurationRequestTDD_RL_Information(tvb, offset, pinfo, tree, hf_rnsap_Multiple_RL_ReconfigurationRequestTDD_RL_Information_item);
}


static const per_sequence_t Multiple_RL_ReconfigurationRequestTDD_RL_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Multiple_RL_ReconfigurationRequestTDD_RL_Information_item },
};

static int
dissect_rnsap_Multiple_RL_ReconfigurationRequestTDD_RL_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Multiple_RL_ReconfigurationRequestTDD_RL_Information, Multiple_RL_ReconfigurationRequestTDD_RL_Information_sequence_of,
                                                  1, 16);

  return offset;
}



static int
dissect_rnsap_DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_dl_DPCH_ModifyInformation_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dl_DPCH_ModifyInformation_LCR);
}


static const per_sequence_t DL_CCTrCH_InformationItem_RL_ReconfRspTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "dl-DPCH-ModifyInformation-LCR", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dl_DPCH_ModifyInformation_LCR },
  { "cCTrCH-Maximum-DL-Power"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cCTrCH_Maximum_DL_Power },
  { "cCTrCH-Minimum-DL-Power"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cCTrCH_Minimum_DL_Power },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_CCTrCH_InformationItem_RL_ReconfRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_CCTrCH_InformationItem_RL_ReconfRspTDD, DL_CCTrCH_InformationItem_RL_ReconfRspTDD_sequence);

  return offset;
}
static int dissect_DL_CCTrCH_InformationList_RL_ReconfRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_CCTrCH_InformationItem_RL_ReconfRspTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_CCTrCH_InformationList_RL_ReconfRspTDD_item);
}


static const per_sequence_t DL_CCTrCH_InformationList_RL_ReconfRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_CCTrCH_InformationList_RL_ReconfRspTDD_item },
};

static int
dissect_rnsap_DL_CCTrCH_InformationList_RL_ReconfRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_CCTrCH_InformationList_RL_ReconfRspTDD, DL_CCTrCH_InformationList_RL_ReconfRspTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "maxPowerLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_maxPowerLCR },
  { "minPowerLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_minPowerLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD, DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_sequence);

  return offset;
}
static int dissect_DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD_item);
}


static const per_sequence_t DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD_item },
};

static int
dissect_rnsap_DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD, DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD_sequence_of,
                                                  1, 6);

  return offset;
}
static int dissect_dL_Timeslot_LCR_InformationModifyList_RL_ReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD(tvb, offset, pinfo, tree, hf_rnsap_dL_Timeslot_LCR_InformationModifyList_RL_ReconfRqstTDD);
}


static const per_sequence_t DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_sequence[] = {
  { "dL-Timeslot-LCR-InformationModifyList-RL-ReconfRqstTDD", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_Timeslot_LCR_InformationModifyList_RL_ReconfRqstTDD },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD, DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_sequence);

  return offset;
}


static const per_sequence_t Multiple_RL_InformationResponse_RL_ReconfRspTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Multiple_RL_InformationResponse_RL_ReconfRspTDD_item },
};

static int
dissect_rnsap_Multiple_RL_InformationResponse_RL_ReconfRspTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Multiple_RL_InformationResponse_RL_ReconfRspTDD, Multiple_RL_InformationResponse_RL_ReconfRspTDD_sequence_of,
                                                  1, 15);

  return offset;
}


static const per_sequence_t RadioLinkFailureIndication_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkFailureIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkFailureIndication, RadioLinkFailureIndication_sequence);

  return offset;
}


static const per_sequence_t RL_InformationList_RL_FailureInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_RL_FailureInd_item },
};

static int
dissect_rnsap_RL_InformationList_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_RL_FailureInd, RL_InformationList_RL_FailureInd_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_InformationList_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_RL_FailureInd(tvb, offset, pinfo, tree, hf_rnsap_rL_InformationList_RL_FailureInd);
}


static const per_sequence_t RL_RL_FailureInd_sequence[] = {
  { "rL-InformationList-RL-FailureInd", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_InformationList_RL_FailureInd },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_RL_FailureInd, RL_RL_FailureInd_sequence);

  return offset;
}
static int dissect_rL(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_RL_FailureInd(tvb, offset, pinfo, tree, hf_rnsap_rL);
}


static const per_sequence_t RL_Set_InformationList_RL_FailureInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Set_InformationList_RL_FailureInd_item },
};

static int
dissect_rnsap_RL_Set_InformationList_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Set_InformationList_RL_FailureInd, RL_Set_InformationList_RL_FailureInd_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_Set_InformationList_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_InformationList_RL_FailureInd(tvb, offset, pinfo, tree, hf_rnsap_rL_Set_InformationList_RL_FailureInd);
}


static const per_sequence_t RL_Set_RL_FailureInd_sequence[] = {
  { "rL-Set-InformationList-RL-FailureInd", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_InformationList_RL_FailureInd },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_RL_FailureInd, RL_Set_RL_FailureInd_sequence);

  return offset;
}
static int dissect_rL_Set(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_RL_FailureInd(tvb, offset, pinfo, tree, hf_rnsap_rL_Set);
}


static const per_sequence_t CCTrCH_InformationList_RL_FailureInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_CCTrCH_InformationList_RL_FailureInd_item },
};

static int
dissect_rnsap_CCTrCH_InformationList_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_CCTrCH_InformationList_RL_FailureInd, CCTrCH_InformationList_RL_FailureInd_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_cCTrCH_InformationList_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_InformationList_RL_FailureInd(tvb, offset, pinfo, tree, hf_rnsap_cCTrCH_InformationList_RL_FailureInd);
}


static const per_sequence_t CCTrCH_RL_FailureInd_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "cCTrCH-InformationList-RL-FailureInd", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_InformationList_RL_FailureInd },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CCTrCH_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CCTrCH_RL_FailureInd, CCTrCH_RL_FailureInd_sequence);

  return offset;
}
static int dissect_cCTrCH(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_RL_FailureInd(tvb, offset, pinfo, tree, hf_rnsap_cCTrCH);
}


static const value_string rnsap_Reporting_Object_RL_FailureInd_vals[] = {
  {   0, "rL" },
  {   1, "rL-Set" },
  {   2, "cCTrCH" },
  { 0, NULL }
};

static const per_choice_t Reporting_Object_RL_FailureInd_choice[] = {
  {   0, "rL"                          , ASN1_EXTENSION_ROOT    , dissect_rL },
  {   1, "rL-Set"                      , ASN1_EXTENSION_ROOT    , dissect_rL_Set },
  {   2, "cCTrCH"                      , ASN1_NOT_EXTENSION_ROOT, dissect_cCTrCH },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_Reporting_Object_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_Reporting_Object_RL_FailureInd, Reporting_Object_RL_FailureInd_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CCTrCH_InformationItem_RL_FailureInd_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "cause"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CCTrCH_InformationItem_RL_FailureInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CCTrCH_InformationItem_RL_FailureInd, CCTrCH_InformationItem_RL_FailureInd_sequence);

  return offset;
}


static const per_sequence_t RadioLinkPreemptionRequiredIndication_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkPreemptionRequiredIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkPreemptionRequiredIndication, RadioLinkPreemptionRequiredIndication_sequence);

  return offset;
}


static const per_sequence_t HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd_item },
};

static int
dissect_rnsap_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd, HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd_sequence_of,
                                                  1, 8);

  return offset;
}



static int
dissect_rnsap_HSDSCH_MACdFlow_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 7U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_hSDSCH_MACdFlow_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlow_ID(tvb, offset, pinfo, tree, hf_rnsap_hSDSCH_MACdFlow_ID);
}
static int dissect_hsDSCH_MACdFlow_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlow_ID(tvb, offset, pinfo, tree, hf_rnsap_hsDSCH_MACdFlow_ID);
}
static int dissect_associatedHSDSCH_MACdFlow(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlow_ID(tvb, offset, pinfo, tree, hf_rnsap_associatedHSDSCH_MACdFlow);
}


static const per_sequence_t HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_sequence[] = {
  { "hSDSCH-MACdFlow-ID"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSDSCH_MACdFlow_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd, HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_sequence);

  return offset;
}


static const per_sequence_t RadioLinkRestoreIndication_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkRestoreIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkRestoreIndication, RadioLinkRestoreIndication_sequence);

  return offset;
}


static const per_sequence_t RL_InformationList_RL_RestoreInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_InformationList_RL_RestoreInd_item },
};

static int
dissect_rnsap_RL_InformationList_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_InformationList_RL_RestoreInd, RL_InformationList_RL_RestoreInd_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_InformationList_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_InformationList_RL_RestoreInd(tvb, offset, pinfo, tree, hf_rnsap_rL_InformationList_RL_RestoreInd);
}


static const per_sequence_t RL_RL_RestoreInd_sequence[] = {
  { "rL-InformationList-RL-RestoreInd", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_InformationList_RL_RestoreInd },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_RL_RestoreInd, RL_RL_RestoreInd_sequence);

  return offset;
}
static int dissect_rL1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_RL_RestoreInd(tvb, offset, pinfo, tree, hf_rnsap_rL1);
}


static const per_sequence_t RL_Set_InformationList_RL_RestoreInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Set_InformationList_RL_RestoreInd_item },
};

static int
dissect_rnsap_RL_Set_InformationList_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Set_InformationList_RL_RestoreInd, RL_Set_InformationList_RL_RestoreInd_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_rL_Set_InformationList_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_InformationList_RL_RestoreInd(tvb, offset, pinfo, tree, hf_rnsap_rL_Set_InformationList_RL_RestoreInd);
}


static const per_sequence_t RL_Set_RL_RestoreInd_sequence[] = {
  { "rL-Set-InformationList-RL-RestoreInd", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_Set_InformationList_RL_RestoreInd },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Set_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Set_RL_RestoreInd, RL_Set_RL_RestoreInd_sequence);

  return offset;
}
static int dissect_rL_Set1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Set_RL_RestoreInd(tvb, offset, pinfo, tree, hf_rnsap_rL_Set1);
}


static const per_sequence_t CCTrCH_InformationList_RL_RestoreInd_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_CCTrCH_InformationList_RL_RestoreInd_item },
};

static int
dissect_rnsap_CCTrCH_InformationList_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_CCTrCH_InformationList_RL_RestoreInd, CCTrCH_InformationList_RL_RestoreInd_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_cCTrCH_InformationList_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_InformationList_RL_RestoreInd(tvb, offset, pinfo, tree, hf_rnsap_cCTrCH_InformationList_RL_RestoreInd);
}


static const per_sequence_t CCTrCH_RL_RestoreInd_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "cCTrCH-InformationList-RL-RestoreInd", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_InformationList_RL_RestoreInd },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CCTrCH_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CCTrCH_RL_RestoreInd, CCTrCH_RL_RestoreInd_sequence);

  return offset;
}
static int dissect_cCTrCH1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CCTrCH_RL_RestoreInd(tvb, offset, pinfo, tree, hf_rnsap_cCTrCH1);
}


static const value_string rnsap_Reporting_Object_RL_RestoreInd_vals[] = {
  {   0, "rL" },
  {   1, "rL-Set" },
  {   2, "cCTrCH" },
  { 0, NULL }
};

static const per_choice_t Reporting_Object_RL_RestoreInd_choice[] = {
  {   0, "rL"                          , ASN1_EXTENSION_ROOT    , dissect_rL1 },
  {   1, "rL-Set"                      , ASN1_EXTENSION_ROOT    , dissect_rL_Set1 },
  {   2, "cCTrCH"                      , ASN1_NOT_EXTENSION_ROOT, dissect_cCTrCH1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_Reporting_Object_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_Reporting_Object_RL_RestoreInd, Reporting_Object_RL_RestoreInd_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CCTrCH_InformationItem_RL_RestoreInd_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CCTrCH_InformationItem_RL_RestoreInd(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CCTrCH_InformationItem_RL_RestoreInd, CCTrCH_InformationItem_RL_RestoreInd_sequence);

  return offset;
}


static const per_sequence_t DL_PowerControlRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_PowerControlRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_PowerControlRequest, DL_PowerControlRequest_sequence);

  return offset;
}


static const per_sequence_t DL_PowerTimeslotControlRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_PowerTimeslotControlRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_PowerTimeslotControlRequest, DL_PowerTimeslotControlRequest_sequence);

  return offset;
}


static const per_sequence_t PhysicalChannelReconfigurationRequestFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PhysicalChannelReconfigurationRequestFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PhysicalChannelReconfigurationRequestFDD, PhysicalChannelReconfigurationRequestFDD_sequence);

  return offset;
}



static int
dissect_rnsap_UL_DPCH_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_ul_DPCH_Information2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DPCH_InformationList_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_ul_DPCH_Information2);
}


static const per_sequence_t UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_sequence[] = {
  { "cCTrCH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cCTrCH_ID },
  { "ul-DPCH-Information"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_DPCH_Information2 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_CCTrCH_InformationItem_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_CCTrCH_InformationItem_PhyChReconfRqstTDD, UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_sequence);

  return offset;
}
static int dissect_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_CCTrCH_InformationItem_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item);
}


static const per_sequence_t UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item },
};

static int
dissect_rnsap_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD, UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t UL_Timeslot_InformationItem_PhyChReconfRqstTDD_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShiftAndBurstType },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Presence },
  { "uL-Code-Information"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uL_Code_Information1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_Timeslot_InformationItem_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_Timeslot_InformationItem_PhyChReconfRqstTDD, UL_Timeslot_InformationItem_PhyChReconfRqstTDD_sequence);

  return offset;
}
static int dissect_UL_Timeslot_InformationList_PhyChReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_Timeslot_InformationItem_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_Timeslot_InformationList_PhyChReconfRqstTDD_item);
}


static const per_sequence_t UL_Timeslot_InformationList_PhyChReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_Timeslot_InformationList_PhyChReconfRqstTDD_item },
};

static int
dissect_rnsap_UL_Timeslot_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_Timeslot_InformationList_PhyChReconfRqstTDD, UL_Timeslot_InformationList_PhyChReconfRqstTDD_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_uL_Timeslot_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_Timeslot_InformationList_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_uL_Timeslot_InformationList_PhyChReconfRqstTDD);
}


static const per_sequence_t UL_DPCH_InformationItem_PhyChReconfRqstTDD_sequence[] = {
  { "repetitionPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_repetitionPeriod },
  { "repetitionLength"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_repetitionLength },
  { "tDD-DPCHOffset"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDD_DPCHOffset },
  { "uL-Timeslot-InformationList-PhyChReconfRqstTDD", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uL_Timeslot_InformationList_PhyChReconfRqstTDD },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_DPCH_InformationItem_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_DPCH_InformationItem_PhyChReconfRqstTDD, UL_DPCH_InformationItem_PhyChReconfRqstTDD_sequence);

  return offset;
}


static const per_sequence_t UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShiftLCR },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Presence },
  { "uL-Code-LCR-Information"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uL_Code_LCR_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD, UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_sequence);

  return offset;
}
static int dissect_UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item);
}


static const per_sequence_t UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item },
};

static int
dissect_rnsap_UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD, UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_sequence_of,
                                                  1, 6);

  return offset;
}


static const per_sequence_t DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShiftLCR },
  { "tFCI-Presence"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tFCI_Presence },
  { "dL-Code-LCR-Information"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dL_Code_LCR_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD, DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_sequence);

  return offset;
}
static int dissect_DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item);
}


static const per_sequence_t DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item },
};

static int
dissect_rnsap_DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD, DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_sequence_of,
                                                  1, 6);

  return offset;
}


static const per_sequence_t HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_sequence[] = {
  { "timeslot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeslot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftAndBurstType },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD, HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_sequence);

  return offset;
}
static int dissect_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD_item);
}


static const per_sequence_t HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD_item },
};

static int
dissect_rnsap_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD, HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD_sequence_of,
                                                  1, 15);

  return offset;
}


static const per_sequence_t HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_sequence[] = {
  { "timeslotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeslotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD, HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_sequence);

  return offset;
}
static int dissect_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD(tvb, offset, pinfo, tree, hf_rnsap_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD_item);
}


static const per_sequence_t HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD_item },
};

static int
dissect_rnsap_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD, HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD_sequence_of,
                                                  1, 6);

  return offset;
}


static const per_sequence_t RadioLinkCongestionIndication_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkCongestionIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkCongestionIndication, RadioLinkCongestionIndication_sequence);

  return offset;
}


static const per_sequence_t UplinkSignallingTransferIndicationFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UplinkSignallingTransferIndicationFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UplinkSignallingTransferIndicationFDD, UplinkSignallingTransferIndicationFDD_sequence);

  return offset;
}


static const per_sequence_t UplinkSignallingTransferIndicationTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UplinkSignallingTransferIndicationTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UplinkSignallingTransferIndicationTDD, UplinkSignallingTransferIndicationTDD_sequence);

  return offset;
}


static const per_sequence_t RelocationCommit_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RelocationCommit(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RelocationCommit, RelocationCommit_sequence);

  return offset;
}


static const per_sequence_t PagingRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PagingRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PagingRequest, PagingRequest_sequence);

  return offset;
}


static const value_string rnsap_PagingCause_vals[] = {
  {   0, "terminating-conversational-call" },
  {   1, "terminating-streaming-call" },
  {   2, "terminating-interactive-call" },
  {   3, "terminating-background-call" },
  {   4, "terminating-low-priority-signalling" },
  {   5, "terminating-high-priority-signalling" },
  {   5, "terminating-cause-unknown" },
  { 0, NULL }
};


static int
dissect_rnsap_PagingCause(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 5, NULL, NULL, TRUE);

  return offset;
}
static int dissect_pagingCause(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PagingCause(tvb, offset, pinfo, tree, hf_rnsap_pagingCause);
}


static const value_string rnsap_CNDomainType_vals[] = {
  {   0, "cs-domain" },
  {   1, "ps-domain" },
  {   2, "dont-care" },
  { 0, NULL }
};


static int
dissect_rnsap_CNDomainType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_cNDomainType(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CNDomainType(tvb, offset, pinfo, tree, hf_rnsap_cNDomainType);
}


static const value_string rnsap_PagingRecordType_vals[] = {
  {   0, "imsi-gsm-map" },
  {   1, "tmsi-gsm-map" },
  {   2, "p-tmsi-gsm-map" },
  {   3, "imsi-ds-41" },
  {   4, "tmsi-ds-41" },
  { 0, NULL }
};


static int
dissect_rnsap_PagingRecordType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 4, NULL, NULL, TRUE);

  return offset;
}
static int dissect_pagingRecordType(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PagingRecordType(tvb, offset, pinfo, tree, hf_rnsap_pagingRecordType);
}


static const per_sequence_t CNOriginatedPage_PagingRqst_sequence[] = {
  { "pagingCause"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pagingCause },
  { "cNDomainType"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cNDomainType },
  { "pagingRecordType"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pagingRecordType },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CNOriginatedPage_PagingRqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CNOriginatedPage_PagingRqst, CNOriginatedPage_PagingRqst_sequence);

  return offset;
}


static const per_sequence_t DedicatedMeasurementInitiationRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementInitiationRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DedicatedMeasurementInitiationRequest, DedicatedMeasurementInitiationRequest_sequence);

  return offset;
}



static int
dissect_rnsap_HS_SICH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 31U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_HSSICH_Info_DM_Rqst_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HS_SICH_ID(tvb, offset, pinfo, tree, hf_rnsap_HSSICH_Info_DM_Rqst_item);
}
static int dissect_hsSICH_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HS_SICH_ID(tvb, offset, pinfo, tree, hf_rnsap_hsSICH_ID);
}


static const per_sequence_t HSSICH_Info_DM_Rqst_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSSICH_Info_DM_Rqst_item },
};

static int
dissect_rnsap_HSSICH_Info_DM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSSICH_Info_DM_Rqst, HSSICH_Info_DM_Rqst_sequence_of,
                                                  1, 4);

  return offset;
}


static const per_sequence_t DedicatedMeasurementInitiationResponse_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementInitiationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DedicatedMeasurementInitiationResponse, DedicatedMeasurementInitiationResponse_sequence);

  return offset;
}


static const per_sequence_t DedicatedMeasurementInitiationFailure_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementInitiationFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DedicatedMeasurementInitiationFailure, DedicatedMeasurementInitiationFailure_sequence);

  return offset;
}


static const per_sequence_t DedicatedMeasurementReport_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementReport(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DedicatedMeasurementReport, DedicatedMeasurementReport_sequence);

  return offset;
}


static const per_sequence_t DedicatedMeasurementTerminationRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementTerminationRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DedicatedMeasurementTerminationRequest, DedicatedMeasurementTerminationRequest_sequence);

  return offset;
}


static const per_sequence_t DedicatedMeasurementFailureIndication_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DedicatedMeasurementFailureIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DedicatedMeasurementFailureIndication, DedicatedMeasurementFailureIndication_sequence);

  return offset;
}


static const per_sequence_t RL_Unsuccessful_InformationItem_DM_Fail_Ind_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "individualcause"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_individualcause },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Unsuccessful_InformationItem_DM_Fail_Ind(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Unsuccessful_InformationItem_DM_Fail_Ind, RL_Unsuccessful_InformationItem_DM_Fail_Ind_sequence);

  return offset;
}


static const per_sequence_t CommonTransportChannelResourcesReleaseRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonTransportChannelResourcesReleaseRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonTransportChannelResourcesReleaseRequest, CommonTransportChannelResourcesReleaseRequest_sequence);

  return offset;
}


static const per_sequence_t CommonTransportChannelResourcesRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonTransportChannelResourcesRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonTransportChannelResourcesRequest, CommonTransportChannelResourcesRequest_sequence);

  return offset;
}


static const per_sequence_t CommonTransportChannelResourcesResponseFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonTransportChannelResourcesResponseFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonTransportChannelResourcesResponseFDD, CommonTransportChannelResourcesResponseFDD_sequence);

  return offset;
}


static const per_sequence_t CommonTransportChannelResourcesResponseTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonTransportChannelResourcesResponseTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonTransportChannelResourcesResponseTDD, CommonTransportChannelResourcesResponseTDD_sequence);

  return offset;
}


static const per_sequence_t CommonTransportChannelResourcesFailure_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonTransportChannelResourcesFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonTransportChannelResourcesFailure, CommonTransportChannelResourcesFailure_sequence);

  return offset;
}


static const per_sequence_t CompressedModeCommand_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CompressedModeCommand(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CompressedModeCommand, CompressedModeCommand_sequence);

  return offset;
}


static const per_sequence_t ErrorIndication_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ErrorIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ErrorIndication, ErrorIndication_sequence);

  return offset;
}


static const per_sequence_t CommonMeasurementInitiationRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementInitiationRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonMeasurementInitiationRequest, CommonMeasurementInitiationRequest_sequence);

  return offset;
}


static const per_sequence_t UC_ID_sequence[] = {
  { "rNC-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rNC_ID },
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UC_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UC_ID, UC_ID_sequence);

  return offset;
}
static int dissect_uC_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UC_ID(tvb, offset, pinfo, tree, hf_rnsap_uC_ID);
}


static const per_sequence_t NeighbouringFDDCellMeasurementInformation_sequence[] = {
  { "uC-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uC_ID },
  { "uARFCN"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uARFCN },
  { "primaryScramblingCode"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_primaryScramblingCode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_NeighbouringFDDCellMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_NeighbouringFDDCellMeasurementInformation, NeighbouringFDDCellMeasurementInformation_sequence);

  return offset;
}
static int dissect_neighbouringFDDCellMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NeighbouringFDDCellMeasurementInformation(tvb, offset, pinfo, tree, hf_rnsap_neighbouringFDDCellMeasurementInformation);
}


static const per_sequence_t NeighbouringTDDCellMeasurementInformation_sequence[] = {
  { "uC-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uC_ID },
  { "uARFCN"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uARFCN },
  { "cellParameterID"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cellParameterID },
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_timeSlot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShiftAndBurstType },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_NeighbouringTDDCellMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_NeighbouringTDDCellMeasurementInformation, NeighbouringTDDCellMeasurementInformation_sequence);

  return offset;
}
static int dissect_neighbouringTDDCellMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NeighbouringTDDCellMeasurementInformation(tvb, offset, pinfo, tree, hf_rnsap_neighbouringTDDCellMeasurementInformation);
}



static int
dissect_rnsap_Extension_neighbouringCellMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_neighbouringCellMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Extension_neighbouringCellMeasurementInformation(tvb, offset, pinfo, tree, hf_rnsap_extension_neighbouringCellMeasurementInformation);
}


static const value_string rnsap_NeighbouringCellMeasurementInfo_item_vals[] = {
  {   0, "neighbouringFDDCellMeasurementInformation" },
  {   1, "neighbouringTDDCellMeasurementInformation" },
  {   2, "extension-neighbouringCellMeasurementInformation" },
  { 0, NULL }
};

static const per_choice_t NeighbouringCellMeasurementInfo_item_choice[] = {
  {   0, "neighbouringFDDCellMeasurementInformation", ASN1_EXTENSION_ROOT    , dissect_neighbouringFDDCellMeasurementInformation },
  {   1, "neighbouringTDDCellMeasurementInformation", ASN1_EXTENSION_ROOT    , dissect_neighbouringTDDCellMeasurementInformation },
  {   2, "extension-neighbouringCellMeasurementInformation", ASN1_NOT_EXTENSION_ROOT, dissect_extension_neighbouringCellMeasurementInformation },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_NeighbouringCellMeasurementInfo_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_NeighbouringCellMeasurementInfo_item, NeighbouringCellMeasurementInfo_item_choice,
                                 NULL);

  return offset;
}
static int dissect_NeighbouringCellMeasurementInfo_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NeighbouringCellMeasurementInfo_item(tvb, offset, pinfo, tree, hf_rnsap_NeighbouringCellMeasurementInfo_item);
}


static const per_sequence_t NeighbouringCellMeasurementInfo_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_NeighbouringCellMeasurementInfo_item },
};

static int
dissect_rnsap_NeighbouringCellMeasurementInfo(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_NeighbouringCellMeasurementInfo, NeighbouringCellMeasurementInfo_sequence_of,
                                                  1, 96);

  return offset;
}
static int dissect_neighbouringCellMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NeighbouringCellMeasurementInfo(tvb, offset, pinfo, tree, hf_rnsap_neighbouringCellMeasurementInformation);
}


static const per_sequence_t Cell_CM_Rqst_sequence[] = {
  { "uC-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uC_ID },
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_timeSlot },
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_timeSlotLCR },
  { "neighbouringCellMeasurementInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_neighbouringCellMeasurementInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Cell_CM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Cell_CM_Rqst, Cell_CM_Rqst_sequence);

  return offset;
}
static int dissect_cell1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cell_CM_Rqst(tvb, offset, pinfo, tree, hf_rnsap_cell1);
}


static const value_string rnsap_CommonMeasurementObjectType_CM_Rqst_vals[] = {
  {   0, "cell" },
  { 0, NULL }
};

static const per_choice_t CommonMeasurementObjectType_CM_Rqst_choice[] = {
  {   0, "cell"                        , ASN1_EXTENSION_ROOT    , dissect_cell1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementObjectType_CM_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CommonMeasurementObjectType_CM_Rqst, CommonMeasurementObjectType_CM_Rqst_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CommonMeasurementInitiationResponse_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementInitiationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonMeasurementInitiationResponse, CommonMeasurementInitiationResponse_sequence);

  return offset;
}



static int
dissect_rnsap_INTEGER_0_16383(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 16383U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ms_part(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_16383(tvb, offset, pinfo, tree, hf_rnsap_ms_part);
}



static int
dissect_rnsap_INTEGER_0_4294967295(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 4294967295U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ls_part(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_4294967295(tvb, offset, pinfo, tree, hf_rnsap_ls_part);
}


static const per_sequence_t TUTRANGPS_sequence[] = {
  { "ms-part"                     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ms_part },
  { "ls-part"                     , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ls_part },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TUTRANGPS(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TUTRANGPS, TUTRANGPS_sequence);

  return offset;
}
static int dissect_tUTRANGPS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TUTRANGPS(tvb, offset, pinfo, tree, hf_rnsap_tUTRANGPS);
}



static int
dissect_rnsap_TUTRANGPSQuality(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tUTRANGPSQuality(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TUTRANGPSQuality(tvb, offset, pinfo, tree, hf_rnsap_tUTRANGPSQuality);
}



static int
dissect_rnsap_TUTRANGPSDriftRate(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -50, 50U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tUTRANGPSDriftRate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TUTRANGPSDriftRate(tvb, offset, pinfo, tree, hf_rnsap_tUTRANGPSDriftRate);
}



static int
dissect_rnsap_TUTRANGPSDriftRateQuality(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 50U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tUTRANGPSDriftRateQuality(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TUTRANGPSDriftRateQuality(tvb, offset, pinfo, tree, hf_rnsap_tUTRANGPSDriftRateQuality);
}


static const per_sequence_t TUTRANGPSMeasurementValueInformation_sequence[] = {
  { "tUTRANGPS"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tUTRANGPS },
  { "tUTRANGPSQuality"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tUTRANGPSQuality },
  { "tUTRANGPSDriftRate"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tUTRANGPSDriftRate },
  { "tUTRANGPSDriftRateQuality"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tUTRANGPSDriftRateQuality },
  { "iEe-Extensions"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iEe_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TUTRANGPSMeasurementValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TUTRANGPSMeasurementValueInformation, TUTRANGPSMeasurementValueInformation_sequence);

  return offset;
}
static int dissect_tUTRANGPSMeasurementValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TUTRANGPSMeasurementValueInformation(tvb, offset, pinfo, tree, hf_rnsap_tUTRANGPSMeasurementValueInformation);
}



static int
dissect_rnsap_SFNSFN_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 614399U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sFNSFN_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFNSFN_FDD(tvb, offset, pinfo, tree, hf_rnsap_sFNSFN_FDD);
}



static int
dissect_rnsap_SFNSFN_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 40961U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sFNSFN_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFNSFN_TDD(tvb, offset, pinfo, tree, hf_rnsap_sFNSFN_TDD);
}


static const value_string rnsap_SFNSFNValue_vals[] = {
  {   0, "sFNSFN-FDD" },
  {   1, "sFNSFN-TDD" },
  { 0, NULL }
};

static const per_choice_t SFNSFNValue_choice[] = {
  {   0, "sFNSFN-FDD"                  , ASN1_EXTENSION_ROOT    , dissect_sFNSFN_FDD },
  {   1, "sFNSFN-TDD"                  , ASN1_EXTENSION_ROOT    , dissect_sFNSFN_TDD },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_SFNSFNValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_SFNSFNValue, SFNSFNValue_choice,
                                 NULL);

  return offset;
}
static int dissect_sFNSFNValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFNSFNValue(tvb, offset, pinfo, tree, hf_rnsap_sFNSFNValue);
}



static int
dissect_rnsap_SFNSFNQuality(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sFNSFNQuality(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFNSFNQuality(tvb, offset, pinfo, tree, hf_rnsap_sFNSFNQuality);
}



static int
dissect_rnsap_SFNSFNDriftRate(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -100, 100U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sFNSFNDriftRate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFNSFNDriftRate(tvb, offset, pinfo, tree, hf_rnsap_sFNSFNDriftRate);
}



static int
dissect_rnsap_SFNSFNDriftRateQuality(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 100U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sFNSFNDriftRateQuality(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFNSFNDriftRateQuality(tvb, offset, pinfo, tree, hf_rnsap_sFNSFNDriftRateQuality);
}



static int
dissect_rnsap_SFN(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 4095U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sFNSFNTimeStamp_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFN(tvb, offset, pinfo, tree, hf_rnsap_sFNSFNTimeStamp_FDD);
}
static int dissect_sFN(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFN(tvb, offset, pinfo, tree, hf_rnsap_sFN);
}


static const per_sequence_t SFNSFNTimeStamp_TDD_sequence[] = {
  { "sFN"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sFN },
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_SFNSFNTimeStamp_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_SFNSFNTimeStamp_TDD, SFNSFNTimeStamp_TDD_sequence);

  return offset;
}
static int dissect_sFNSFNTimeStamp_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFNSFNTimeStamp_TDD(tvb, offset, pinfo, tree, hf_rnsap_sFNSFNTimeStamp_TDD);
}


static const value_string rnsap_SFNSFNTimeStampInformation_vals[] = {
  {   0, "sFNSFNTimeStamp-FDD" },
  {   1, "sFNSFNTimeStamp-TDD" },
  { 0, NULL }
};

static const per_choice_t SFNSFNTimeStampInformation_choice[] = {
  {   0, "sFNSFNTimeStamp-FDD"         , ASN1_EXTENSION_ROOT    , dissect_sFNSFNTimeStamp_FDD },
  {   1, "sFNSFNTimeStamp-TDD"         , ASN1_EXTENSION_ROOT    , dissect_sFNSFNTimeStamp_TDD },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_SFNSFNTimeStampInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_SFNSFNTimeStampInformation, SFNSFNTimeStampInformation_choice,
                                 NULL);

  return offset;
}
static int dissect_sFNSFNTimeStampInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFNSFNTimeStampInformation(tvb, offset, pinfo, tree, hf_rnsap_sFNSFNTimeStampInformation);
}


static const per_sequence_t T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item_sequence[] = {
  { "uC-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uC_ID },
  { "sFNSFNValue"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sFNSFNValue },
  { "sFNSFNQuality"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_sFNSFNQuality },
  { "sFNSFNDriftRate"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sFNSFNDriftRate },
  { "sFNSFNDriftRateQuality"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_sFNSFNDriftRateQuality },
  { "sFNSFNTimeStampInformation"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sFNSFNTimeStampInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item, T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item_sequence);

  return offset;
}
static int dissect_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item(tvb, offset, pinfo, tree, hf_rnsap_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item);
}


static const per_sequence_t T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item },
};

static int
dissect_rnsap_T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation, T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_sequence_of,
                                                  1, 96);

  return offset;
}
static int dissect_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation(tvb, offset, pinfo, tree, hf_rnsap_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation);
}


static const per_sequence_t T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item_sequence[] = {
  { "uC-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uC_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item, T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item_sequence);

  return offset;
}
static int dissect_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item(tvb, offset, pinfo, tree, hf_rnsap_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item);
}


static const per_sequence_t T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item },
};

static int
dissect_rnsap_T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation, T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_sequence_of,
                                                  0, 95);

  return offset;
}
static int dissect_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation(tvb, offset, pinfo, tree, hf_rnsap_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation);
}


static const per_sequence_t SFNSFNMeasurementValueInformation_sequence[] = {
  { "successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation },
  { "unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_SFNSFNMeasurementValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_SFNSFNMeasurementValueInformation, SFNSFNMeasurementValueInformation_sequence);

  return offset;
}
static int dissect_sFNSFNMeasurementValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFNSFNMeasurementValueInformation(tvb, offset, pinfo, tree, hf_rnsap_sFNSFNMeasurementValueInformation);
}



static int
dissect_rnsap_INTEGER_0_100(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 100U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_transmittedCarrierPowerValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_100(tvb, offset, pinfo, tree, hf_rnsap_transmittedCarrierPowerValue);
}
static int dissect_uplinkLoadValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_100(tvb, offset, pinfo, tree, hf_rnsap_uplinkLoadValue);
}
static int dissect_downlinkLoadValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_100(tvb, offset, pinfo, tree, hf_rnsap_downlinkLoadValue);
}
static int dissect_uplinkRTLoadValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_100(tvb, offset, pinfo, tree, hf_rnsap_uplinkRTLoadValue);
}
static int dissect_downlinkRTLoadValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_100(tvb, offset, pinfo, tree, hf_rnsap_downlinkRTLoadValue);
}


static const per_sequence_t LoadValue_sequence[] = {
  { "uplinkLoadValue"             , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_uplinkLoadValue },
  { "downlinkLoadValue"           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_downlinkLoadValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_LoadValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_LoadValue, LoadValue_sequence);

  return offset;
}
static int dissect_loadValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_LoadValue(tvb, offset, pinfo, tree, hf_rnsap_loadValue);
}



static int
dissect_rnsap_INTEGER_0_621(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 621U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_receivedTotalWideBandPowerValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_621(tvb, offset, pinfo, tree, hf_rnsap_receivedTotalWideBandPowerValue);
}



static int
dissect_rnsap_Extension_CommonMeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_CommonMeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Extension_CommonMeasurementValue(tvb, offset, pinfo, tree, hf_rnsap_extension_CommonMeasurementValue);
}


static const value_string rnsap_CommonMeasurementValue_vals[] = {
  {   0, "tUTRANGPSMeasurementValueInformation" },
  {   1, "sFNSFNMeasurementValueInformation" },
  {   2, "loadValue" },
  {   3, "transmittedCarrierPowerValue" },
  {   4, "receivedTotalWideBandPowerValue" },
  {   5, "uplinkTimeslotISCPValue" },
  {   6, "extension-CommonMeasurementValue" },
  { 0, NULL }
};

static const per_choice_t CommonMeasurementValue_choice[] = {
  {   0, "tUTRANGPSMeasurementValueInformation", ASN1_EXTENSION_ROOT    , dissect_tUTRANGPSMeasurementValueInformation },
  {   1, "sFNSFNMeasurementValueInformation", ASN1_EXTENSION_ROOT    , dissect_sFNSFNMeasurementValueInformation },
  {   2, "loadValue"                   , ASN1_EXTENSION_ROOT    , dissect_loadValue },
  {   3, "transmittedCarrierPowerValue", ASN1_EXTENSION_ROOT    , dissect_transmittedCarrierPowerValue },
  {   4, "receivedTotalWideBandPowerValue", ASN1_EXTENSION_ROOT    , dissect_receivedTotalWideBandPowerValue },
  {   5, "uplinkTimeslotISCPValue"     , ASN1_EXTENSION_ROOT    , dissect_uplinkTimeslotISCPValue },
  {   6, "extension-CommonMeasurementValue", ASN1_NOT_EXTENSION_ROOT, dissect_extension_CommonMeasurementValue },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CommonMeasurementValue, CommonMeasurementValue_choice,
                                 NULL);

  return offset;
}
static int dissect_commonMeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CommonMeasurementValue(tvb, offset, pinfo, tree, hf_rnsap_commonMeasurementValue);
}


static const per_sequence_t Cell_CM_Rsp_sequence[] = {
  { "commonMeasurementValue"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_commonMeasurementValue },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Cell_CM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Cell_CM_Rsp, Cell_CM_Rsp_sequence);

  return offset;
}
static int dissect_cell2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cell_CM_Rsp(tvb, offset, pinfo, tree, hf_rnsap_cell2);
}


static const value_string rnsap_CommonMeasurementObjectType_CM_Rsp_vals[] = {
  {   0, "cell" },
  { 0, NULL }
};

static const per_choice_t CommonMeasurementObjectType_CM_Rsp_choice[] = {
  {   0, "cell"                        , ASN1_EXTENSION_ROOT    , dissect_cell2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementObjectType_CM_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CommonMeasurementObjectType_CM_Rsp, CommonMeasurementObjectType_CM_Rsp_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CommonMeasurementInitiationFailure_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementInitiationFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonMeasurementInitiationFailure, CommonMeasurementInitiationFailure_sequence);

  return offset;
}


static const per_sequence_t CommonMeasurementReport_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementReport(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonMeasurementReport, CommonMeasurementReport_sequence);

  return offset;
}


static const per_sequence_t CommonMeasurementAvailable_sequence[] = {
  { "commonMeasurementValue"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_commonMeasurementValue },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonMeasurementAvailable, CommonMeasurementAvailable_sequence);

  return offset;
}
static int dissect_measurementAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CommonMeasurementAvailable(tvb, offset, pinfo, tree, hf_rnsap_measurementAvailable);
}


static const value_string rnsap_CommonMeasurementValueInformation_vals[] = {
  {   0, "measurementAvailable" },
  {   1, "measurementnotAvailable" },
  { 0, NULL }
};

static const per_choice_t CommonMeasurementValueInformation_choice[] = {
  {   0, "measurementAvailable"        , ASN1_NO_EXTENSIONS     , dissect_measurementAvailable },
  {   1, "measurementnotAvailable"     , ASN1_NO_EXTENSIONS     , dissect_measurementnotAvailable },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CommonMeasurementValueInformation, CommonMeasurementValueInformation_choice,
                                 NULL);

  return offset;
}
static int dissect_commonMeasurementValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CommonMeasurementValueInformation(tvb, offset, pinfo, tree, hf_rnsap_commonMeasurementValueInformation);
}


static const per_sequence_t Cell_CM_Rprt_sequence[] = {
  { "commonMeasurementValueInformation", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_commonMeasurementValueInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Cell_CM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Cell_CM_Rprt, Cell_CM_Rprt_sequence);

  return offset;
}
static int dissect_cell3(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cell_CM_Rprt(tvb, offset, pinfo, tree, hf_rnsap_cell3);
}


static const value_string rnsap_CommonMeasurementObjectType_CM_Rprt_vals[] = {
  {   0, "cell" },
  { 0, NULL }
};

static const per_choice_t CommonMeasurementObjectType_CM_Rprt_choice[] = {
  {   0, "cell"                        , ASN1_EXTENSION_ROOT    , dissect_cell3 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementObjectType_CM_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CommonMeasurementObjectType_CM_Rprt, CommonMeasurementObjectType_CM_Rprt_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t CommonMeasurementTerminationRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementTerminationRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonMeasurementTerminationRequest, CommonMeasurementTerminationRequest_sequence);

  return offset;
}


static const per_sequence_t CommonMeasurementFailureIndication_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementFailureIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CommonMeasurementFailureIndication, CommonMeasurementFailureIndication_sequence);

  return offset;
}


static const per_sequence_t InformationExchangeInitiationRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_InformationExchangeInitiationRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_InformationExchangeInitiationRequest, InformationExchangeInitiationRequest_sequence);

  return offset;
}


static const per_sequence_t Cell_InfEx_Rqst_sequence[] = {
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Cell_InfEx_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Cell_InfEx_Rqst, Cell_InfEx_Rqst_sequence);

  return offset;
}
static int dissect_cell4(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cell_InfEx_Rqst(tvb, offset, pinfo, tree, hf_rnsap_cell4);
}



static int
dissect_rnsap_Extension_InformationExchangeObjectType_InfEx_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_InformationExchangeObjectType_InfEx_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Extension_InformationExchangeObjectType_InfEx_Rqst(tvb, offset, pinfo, tree, hf_rnsap_extension_InformationExchangeObjectType_InfEx_Rqst);
}


static const value_string rnsap_InformationExchangeObjectType_InfEx_Rqst_vals[] = {
  {   0, "cell" },
  {   1, "extension-InformationExchangeObjectType-InfEx-Rqst" },
  { 0, NULL }
};

static const per_choice_t InformationExchangeObjectType_InfEx_Rqst_choice[] = {
  {   0, "cell"                        , ASN1_EXTENSION_ROOT    , dissect_cell4 },
  {   1, "extension-InformationExchangeObjectType-InfEx-Rqst", ASN1_NOT_EXTENSION_ROOT, dissect_extension_InformationExchangeObjectType_InfEx_Rqst },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_InformationExchangeObjectType_InfEx_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_InformationExchangeObjectType_InfEx_Rqst, InformationExchangeObjectType_InfEx_Rqst_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t T_lAI_sequence[] = {
  { "pLMN-Identity"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pLMN_Identity },
  { "lAC"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_lAC },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_T_lAI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_T_lAI, T_lAI_sequence);

  return offset;
}
static int dissect_lAI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_lAI(tvb, offset, pinfo, tree, hf_rnsap_lAI);
}



static int
dissect_rnsap_CI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       2, 2, NULL);

  return offset;
}
static int dissect_cI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CI(tvb, offset, pinfo, tree, hf_rnsap_cI);
}


static const per_sequence_t CGI_sequence[] = {
  { "lAI"                         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_lAI },
  { "cI"                          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_cI },
  { "iE-Extensions"               , ASN1_NO_EXTENSIONS     , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_CGI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_CGI, CGI_sequence);

  return offset;
}
static int dissect_cGI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CGI(tvb, offset, pinfo, tree, hf_rnsap_cGI);
}


static const per_sequence_t GSM_Cell_InfEx_Rqst_sequence[] = {
  { "cGI"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cGI },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GSM_Cell_InfEx_Rqst(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GSM_Cell_InfEx_Rqst, GSM_Cell_InfEx_Rqst_sequence);

  return offset;
}


static const per_sequence_t InformationExchangeInitiationResponse_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_InformationExchangeInitiationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_InformationExchangeInitiationResponse, InformationExchangeInitiationResponse_sequence);

  return offset;
}


static const value_string rnsap_T_directionOfAltitude_vals[] = {
  {   0, "height" },
  {   1, "depth" },
  { 0, NULL }
};


static int
dissect_rnsap_T_directionOfAltitude(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_directionOfAltitude(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_directionOfAltitude(tvb, offset, pinfo, tree, hf_rnsap_directionOfAltitude);
}


static const per_sequence_t GA_AltitudeAndDirection_sequence[] = {
  { "directionOfAltitude"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_directionOfAltitude },
  { "altitude"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_altitude },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GA_AltitudeAndDirection(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GA_AltitudeAndDirection, GA_AltitudeAndDirection_sequence);

  return offset;
}
static int dissect_altitudeAndDirection(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_AltitudeAndDirection(tvb, offset, pinfo, tree, hf_rnsap_altitudeAndDirection);
}


static const per_sequence_t GA_AccessPointPositionwithOptionalAltitude_sequence[] = {
  { "geographicalCoordinate"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_geographicalCoordinate },
  { "altitudeAndDirection"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_altitudeAndDirection },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GA_AccessPointPositionwithOptionalAltitude(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GA_AccessPointPositionwithOptionalAltitude, GA_AccessPointPositionwithOptionalAltitude_sequence);

  return offset;
}
static int dissect_gA_AccessPointPositionwithAltitude(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_AccessPointPositionwithOptionalAltitude(tvb, offset, pinfo, tree, hf_rnsap_gA_AccessPointPositionwithAltitude);
}
static int dissect_sFNSFN_GA_AccessPointPosition(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_AccessPointPositionwithOptionalAltitude(tvb, offset, pinfo, tree, hf_rnsap_sFNSFN_GA_AccessPointPosition);
}


static const value_string rnsap_IPSpacingFDD_vals[] = {
  {   0, "ipsF5" },
  {   1, "ipsF7" },
  {   2, "ipsF10" },
  {   3, "ipsF15" },
  {   4, "ipsF20" },
  {   5, "ipsF30" },
  {   6, "ipsF40" },
  {   7, "ipsF50" },
  { 0, NULL }
};


static int
dissect_rnsap_IPSpacingFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 7, NULL, NULL, TRUE);

  return offset;
}
static int dissect_iPSpacingFDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPSpacingFDD(tvb, offset, pinfo, tree, hf_rnsap_iPSpacingFDD);
}


static const value_string rnsap_IPLength_vals[] = {
  {   0, "ipl5" },
  {   1, "ipl10" },
  { 0, NULL }
};


static int
dissect_rnsap_IPLength(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_iPLength(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPLength(tvb, offset, pinfo, tree, hf_rnsap_iPLength);
}



static int
dissect_rnsap_IPOffset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 9U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_iPOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPOffset(tvb, offset, pinfo, tree, hf_rnsap_iPOffset);
}



static int
dissect_rnsap_Seed(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 63U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_seed(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Seed(tvb, offset, pinfo, tree, hf_rnsap_seed);
}



static int
dissect_rnsap_INTEGER_10_25(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              10U, 25U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_burstLength(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_10_25(tvb, offset, pinfo, tree, hf_rnsap_burstLength);
}



static int
dissect_rnsap_INTEGER_1_16(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 16U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_burstFreq(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_16(tvb, offset, pinfo, tree, hf_rnsap_burstFreq);
}


static const per_sequence_t BurstModeParameters_sequence[] = {
  { "burstStart"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_burstStart },
  { "burstLength"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_burstLength },
  { "burstFreq"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_burstFreq },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_BurstModeParameters(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_BurstModeParameters, BurstModeParameters_sequence);

  return offset;
}
static int dissect_burstModeParameters(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BurstModeParameters(tvb, offset, pinfo, tree, hf_rnsap_burstModeParameters);
}


static const per_sequence_t IPDL_FDD_Parameters_sequence[] = {
  { "iPSpacingFDD"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iPSpacingFDD },
  { "iPLength"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iPLength },
  { "iPOffset"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iPOffset },
  { "seed"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_seed },
  { "burstModeParameters"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_burstModeParameters },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_IPDL_FDD_Parameters(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_IPDL_FDD_Parameters, IPDL_FDD_Parameters_sequence);

  return offset;
}
static int dissect_iPDL_FDD_Parameters(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPDL_FDD_Parameters(tvb, offset, pinfo, tree, hf_rnsap_iPDL_FDD_Parameters);
}


static const value_string rnsap_IPSpacingTDD_vals[] = {
  {   0, "ipsT30" },
  {   1, "ipsT40" },
  {   2, "ipsT50" },
  {   3, "ipsT70" },
  {   4, "ipsT100" },
  { 0, NULL }
};


static int
dissect_rnsap_IPSpacingTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 4, NULL, NULL, TRUE);

  return offset;
}
static int dissect_iPSpacingTDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPSpacingTDD(tvb, offset, pinfo, tree, hf_rnsap_iPSpacingTDD);
}



static int
dissect_rnsap_IPStart(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 4095U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_iPStart(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPStart(tvb, offset, pinfo, tree, hf_rnsap_iPStart);
}



static int
dissect_rnsap_IPSlot(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 14U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_iPSlot(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPSlot(tvb, offset, pinfo, tree, hf_rnsap_iPSlot);
}


static const value_string rnsap_IP_P_CCPCH_vals[] = {
  {   0, "switchOff-1-Frame" },
  {   1, "switchOff-2-Frames" },
  { 0, NULL }
};


static int
dissect_rnsap_IP_P_CCPCH(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_iP_P_CCPCH(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IP_P_CCPCH(tvb, offset, pinfo, tree, hf_rnsap_iP_P_CCPCH);
}


static const per_sequence_t IPDL_TDD_Parameters_sequence[] = {
  { "iPSpacingTDD"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iPSpacingTDD },
  { "iPStart"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iPStart },
  { "iPSlot"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iPSlot },
  { "iP-P-CCPCH"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iP_P_CCPCH },
  { "burstModeParameters"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_burstModeParameters },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_IPDL_TDD_Parameters(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_IPDL_TDD_Parameters, IPDL_TDD_Parameters_sequence);

  return offset;
}
static int dissect_iPDL_TDD_Parameters(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPDL_TDD_Parameters(tvb, offset, pinfo, tree, hf_rnsap_iPDL_TDD_Parameters);
}



static int
dissect_rnsap_Extension_IPDLParameters(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_IPDLParameters(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Extension_IPDLParameters(tvb, offset, pinfo, tree, hf_rnsap_extension_IPDLParameters);
}


static const value_string rnsap_IPDLParameters_vals[] = {
  {   0, "iPDL-FDD-Parameters" },
  {   1, "iPDL-TDD-Parameters" },
  {   2, "extension-IPDLParameters" },
  { 0, NULL }
};

static const per_choice_t IPDLParameters_choice[] = {
  {   0, "iPDL-FDD-Parameters"         , ASN1_EXTENSION_ROOT    , dissect_iPDL_FDD_Parameters },
  {   1, "iPDL-TDD-Parameters"         , ASN1_EXTENSION_ROOT    , dissect_iPDL_TDD_Parameters },
  {   2, "extension-IPDLParameters"    , ASN1_NOT_EXTENSION_ROOT, dissect_extension_IPDLParameters },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_IPDLParameters(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_IPDLParameters, IPDLParameters_choice,
                                 NULL);

  return offset;
}
static int dissect_iPDLParameters(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPDLParameters(tvb, offset, pinfo, tree, hf_rnsap_iPDLParameters);
}



static int
dissect_rnsap_GPSTOW(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 604799U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_gPSTOW(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPSTOW(tvb, offset, pinfo, tree, hf_rnsap_gPSTOW);
}


static const value_string rnsap_GPS_Status_Health_vals[] = {
  {   0, "udre-1-0" },
  {   1, "udre-0-75" },
  {   2, "udre-0-5" },
  {   3, "udre-0-3" },
  {   4, "udre-0-1" },
  {   5, "no-data" },
  {   6, "invalid-data" },
  { 0, NULL }
};


static int
dissect_rnsap_GPS_Status_Health(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 6, NULL, NULL, FALSE);

  return offset;
}
static int dissect_gPS_Status_Health(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPS_Status_Health(tvb, offset, pinfo, tree, hf_rnsap_gPS_Status_Health);
}



static int
dissect_rnsap_SAT_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 63U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_badSAT_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SAT_ID(tvb, offset, pinfo, tree, hf_rnsap_badSAT_ID);
}
static int dissect_sAT_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SAT_ID(tvb, offset, pinfo, tree, hf_rnsap_sAT_ID);
}



static int
dissect_rnsap_BIT_STRING_SIZE_8(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     8, 8, FALSE);

  return offset;
}
static int dissect_iode_dgps(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_iode_dgps);
}
static int dissect_wna_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_wna_alm);
}
static int dissect_gps_toa_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_gps_toa_alm);
}
static int dissect_svhealth_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_svhealth_alm);
}
static int dissect_alpha_zero_ionos(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_alpha_zero_ionos);
}
static int dissect_alpha_one_ionos(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_alpha_one_ionos);
}
static int dissect_alpha_two_ionos(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_alpha_two_ionos);
}
static int dissect_alpha_three_ionos(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_alpha_three_ionos);
}
static int dissect_beta_zero_ionos(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_beta_zero_ionos);
}
static int dissect_beta_one_ionos(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_beta_one_ionos);
}
static int dissect_beta_two_ionos(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_beta_two_ionos);
}
static int dissect_beta_three_ionos(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_beta_three_ionos);
}
static int dissect_t_gd_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_t_gd_nav);
}
static int dissect_a_f_2_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_a_f_2_nav);
}
static int dissect_t_ot_utc(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_t_ot_utc);
}
static int dissect_delta_t_ls_utc(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_delta_t_ls_utc);
}
static int dissect_w_n_t_utc(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_w_n_t_utc);
}
static int dissect_w_n_lsf_utc(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_w_n_lsf_utc);
}
static int dissect_dn_utc(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_dn_utc);
}
static int dissect_delta_t_lsf_utc(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_delta_t_lsf_utc);
}
static int dissect_sync_UL_codes_bitmap(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_8(tvb, offset, pinfo, tree, hf_rnsap_sync_UL_codes_bitmap);
}


static const value_string rnsap_UDRE_vals[] = {
  {   0, "lessThan1" },
  {   1, "between1-and-4" },
  {   2, "between4-and-8" },
  {   3, "over8" },
  { 0, NULL }
};


static int
dissect_rnsap_UDRE(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 3, NULL, NULL, TRUE);

  return offset;
}
static int dissect_uDRE(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UDRE(tvb, offset, pinfo, tree, hf_rnsap_uDRE);
}



static int
dissect_rnsap_PRC(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -2047, 2047U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_pRC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PRC(tvb, offset, pinfo, tree, hf_rnsap_pRC);
}



static int
dissect_rnsap_Range_Correction_Rate(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -127, 127U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_range_Correction_Rate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Range_Correction_Rate(tvb, offset, pinfo, tree, hf_rnsap_range_Correction_Rate);
}


static const per_sequence_t T_satellite_DGPSCorrections_Information_item_sequence[] = {
  { "sAT-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAT_ID },
  { "iode-dgps"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iode_dgps },
  { "uDRE"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uDRE },
  { "pRC"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pRC },
  { "range-Correction-Rate"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_range_Correction_Rate },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_T_satellite_DGPSCorrections_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_T_satellite_DGPSCorrections_Information_item, T_satellite_DGPSCorrections_Information_item_sequence);

  return offset;
}
static int dissect_satellite_DGPSCorrections_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_satellite_DGPSCorrections_Information_item(tvb, offset, pinfo, tree, hf_rnsap_satellite_DGPSCorrections_Information_item);
}


static const per_sequence_t T_satellite_DGPSCorrections_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_satellite_DGPSCorrections_Information_item },
};

static int
dissect_rnsap_T_satellite_DGPSCorrections_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_T_satellite_DGPSCorrections_Information, T_satellite_DGPSCorrections_Information_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_satellite_DGPSCorrections_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_satellite_DGPSCorrections_Information(tvb, offset, pinfo, tree, hf_rnsap_satellite_DGPSCorrections_Information);
}


static const per_sequence_t DGPSCorrections_sequence[] = {
  { "gPSTOW"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gPSTOW },
  { "gPS-Status-Health"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gPS_Status_Health },
  { "satellite-DGPSCorrections-Information", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_satellite_DGPSCorrections_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DGPSCorrections(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DGPSCorrections, DGPSCorrections_sequence);

  return offset;
}
static int dissect_dGPSCorrections(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DGPSCorrections(tvb, offset, pinfo, tree, hf_rnsap_dGPSCorrections);
}



static int
dissect_rnsap_INTEGER_0_1048575(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 1048575U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tx_tow_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_1048575(tvb, offset, pinfo, tree, hf_rnsap_tx_tow_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_14(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     14, 14, FALSE);

  return offset;
}
static int dissect_tlm_message_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_14(tvb, offset, pinfo, tree, hf_rnsap_tlm_message_nav);
}
static int dissect_idot_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_14(tvb, offset, pinfo, tree, hf_rnsap_idot_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_2(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     2, 2, FALSE);

  return offset;
}
static int dissect_tlm_revd_c_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_2(tvb, offset, pinfo, tree, hf_rnsap_tlm_revd_c_nav);
}
static int dissect_ca_or_p_on_l2_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_2(tvb, offset, pinfo, tree, hf_rnsap_ca_or_p_on_l2_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_22(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     22, 22, FALSE);

  return offset;
}
static int dissect_ho_word_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_22(tvb, offset, pinfo, tree, hf_rnsap_ho_word_nav);
}
static int dissect_a_f_zero_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_22(tvb, offset, pinfo, tree, hf_rnsap_a_f_zero_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_10(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     10, 10, FALSE);

  return offset;
}
static int dissect_w_n_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_10(tvb, offset, pinfo, tree, hf_rnsap_w_n_nav);
}
static int dissect_iodc_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_10(tvb, offset, pinfo, tree, hf_rnsap_iodc_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_4(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     4, 4, FALSE);

  return offset;
}
static int dissect_user_range_accuracy_index_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_4(tvb, offset, pinfo, tree, hf_rnsap_user_range_accuracy_index_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_6(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     6, 6, FALSE);

  return offset;
}
static int dissect_sv_health_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_6(tvb, offset, pinfo, tree, hf_rnsap_sv_health_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_1(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     1, 1, FALSE);

  return offset;
}
static int dissect_l2_p_dataflag_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_1(tvb, offset, pinfo, tree, hf_rnsap_l2_p_dataflag_nav);
}
static int dissect_fit_interval_flag_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_1(tvb, offset, pinfo, tree, hf_rnsap_fit_interval_flag_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_87(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     87, 87, FALSE);

  return offset;
}
static int dissect_sf1_reserved_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_87(tvb, offset, pinfo, tree, hf_rnsap_sf1_reserved_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_16(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     16, 16, FALSE);

  return offset;
}
static int dissect_gps_e_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_gps_e_alm);
}
static int dissect_gps_delta_I_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_gps_delta_I_alm);
}
static int dissect_omegadot_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_omegadot_alm);
}
static int dissect_t_oc_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_t_oc_nav);
}
static int dissect_a_f_1_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_a_f_1_nav);
}
static int dissect_c_rs_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_c_rs_nav);
}
static int dissect_delta_n_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_delta_n_nav);
}
static int dissect_c_uc_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_c_uc_nav);
}
static int dissect_c_us_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_c_us_nav);
}
static int dissect_t_oe_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_t_oe_nav);
}
static int dissect_c_ic_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_c_ic_nav);
}
static int dissect_c_is_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_c_is_nav);
}
static int dissect_c_rc_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_16(tvb, offset, pinfo, tree, hf_rnsap_c_rc_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_32(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     32, 32, FALSE);

  return offset;
}
static int dissect_m_zero_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_32(tvb, offset, pinfo, tree, hf_rnsap_m_zero_nav);
}
static int dissect_gps_e_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_32(tvb, offset, pinfo, tree, hf_rnsap_gps_e_nav);
}
static int dissect_a_sqrt_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_32(tvb, offset, pinfo, tree, hf_rnsap_a_sqrt_nav);
}
static int dissect_omega_zero_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_32(tvb, offset, pinfo, tree, hf_rnsap_omega_zero_nav);
}
static int dissect_i_zero_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_32(tvb, offset, pinfo, tree, hf_rnsap_i_zero_nav);
}
static int dissect_gps_omega_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_32(tvb, offset, pinfo, tree, hf_rnsap_gps_omega_nav);
}
static int dissect_a_zero_utc(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_32(tvb, offset, pinfo, tree, hf_rnsap_a_zero_utc);
}



static int
dissect_rnsap_BIT_STRING_SIZE_5(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     5, 5, FALSE);

  return offset;
}
static int dissect_aodo_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_5(tvb, offset, pinfo, tree, hf_rnsap_aodo_nav);
}



static int
dissect_rnsap_BIT_STRING_SIZE_24(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     24, 24, FALSE);

  return offset;
}
static int dissect_gps_a_sqrt_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_24(tvb, offset, pinfo, tree, hf_rnsap_gps_a_sqrt_alm);
}
static int dissect_omegazero_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_24(tvb, offset, pinfo, tree, hf_rnsap_omegazero_alm);
}
static int dissect_m_zero_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_24(tvb, offset, pinfo, tree, hf_rnsap_m_zero_alm);
}
static int dissect_gps_omega_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_24(tvb, offset, pinfo, tree, hf_rnsap_gps_omega_alm);
}
static int dissect_omegadot_nav(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_24(tvb, offset, pinfo, tree, hf_rnsap_omegadot_nav);
}
static int dissect_a_one_utc(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_24(tvb, offset, pinfo, tree, hf_rnsap_a_one_utc);
}



static int
dissect_rnsap_BIT_STRING_SIZE_20(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     20, 20, FALSE);

  return offset;
}
static int dissect_spare_zero_fill(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_20(tvb, offset, pinfo, tree, hf_rnsap_spare_zero_fill);
}


static const per_sequence_t GPS_NavigationModel_and_TimeRecovery_item_sequence[] = {
  { "tx-tow-nav"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tx_tow_nav },
  { "sAT-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAT_ID },
  { "tlm-message-nav"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tlm_message_nav },
  { "tlm-revd-c-nav"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tlm_revd_c_nav },
  { "ho-word-nav"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ho_word_nav },
  { "w-n-nav"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_w_n_nav },
  { "ca-or-p-on-l2-nav"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ca_or_p_on_l2_nav },
  { "user-range-accuracy-index-nav", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_user_range_accuracy_index_nav },
  { "sv-health-nav"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sv_health_nav },
  { "iodc-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iodc_nav },
  { "l2-p-dataflag-nav"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_l2_p_dataflag_nav },
  { "sf1-reserved-nav"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sf1_reserved_nav },
  { "t-gd-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_t_gd_nav },
  { "t-oc-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_t_oc_nav },
  { "a-f-2-nav"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_a_f_2_nav },
  { "a-f-1-nav"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_a_f_1_nav },
  { "a-f-zero-nav"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_a_f_zero_nav },
  { "c-rs-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_rs_nav },
  { "delta-n-nav"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_delta_n_nav },
  { "m-zero-nav"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_m_zero_nav },
  { "c-uc-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_uc_nav },
  { "gps-e-nav"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_e_nav },
  { "c-us-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_us_nav },
  { "a-sqrt-nav"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_a_sqrt_nav },
  { "t-oe-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_t_oe_nav },
  { "fit-interval-flag-nav"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fit_interval_flag_nav },
  { "aodo-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_aodo_nav },
  { "c-ic-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ic_nav },
  { "omega-zero-nav"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_omega_zero_nav },
  { "c-is-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_is_nav },
  { "i-zero-nav"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_i_zero_nav },
  { "c-rc-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_rc_nav },
  { "gps-omega-nav"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_omega_nav },
  { "omegadot-nav"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_omegadot_nav },
  { "idot-nav"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_idot_nav },
  { "spare-zero-fill"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_spare_zero_fill },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GPS_NavigationModel_and_TimeRecovery_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GPS_NavigationModel_and_TimeRecovery_item, GPS_NavigationModel_and_TimeRecovery_item_sequence);

  return offset;
}
static int dissect_GPS_NavigationModel_and_TimeRecovery_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPS_NavigationModel_and_TimeRecovery_item(tvb, offset, pinfo, tree, hf_rnsap_GPS_NavigationModel_and_TimeRecovery_item);
}


static const per_sequence_t GPS_NavigationModel_and_TimeRecovery_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_GPS_NavigationModel_and_TimeRecovery_item },
};

static int
dissect_rnsap_GPS_NavigationModel_and_TimeRecovery(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_GPS_NavigationModel_and_TimeRecovery, GPS_NavigationModel_and_TimeRecovery_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_gPS_NavigationModel_and_TimeRecovery(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPS_NavigationModel_and_TimeRecovery(tvb, offset, pinfo, tree, hf_rnsap_gPS_NavigationModel_and_TimeRecovery);
}


static const per_sequence_t GPS_Ionospheric_Model_sequence[] = {
  { "alpha-zero-ionos"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_alpha_zero_ionos },
  { "alpha-one-ionos"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_alpha_one_ionos },
  { "alpha-two-ionos"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_alpha_two_ionos },
  { "alpha-three-ionos"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_alpha_three_ionos },
  { "beta-zero-ionos"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_beta_zero_ionos },
  { "beta-one-ionos"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_beta_one_ionos },
  { "beta-two-ionos"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_beta_two_ionos },
  { "beta-three-ionos"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_beta_three_ionos },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GPS_Ionospheric_Model(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GPS_Ionospheric_Model, GPS_Ionospheric_Model_sequence);

  return offset;
}
static int dissect_gPS_Ionospheric_Model(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPS_Ionospheric_Model(tvb, offset, pinfo, tree, hf_rnsap_gPS_Ionospheric_Model);
}


static const per_sequence_t GPS_UTC_Model_sequence[] = {
  { "a-one-utc"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_a_one_utc },
  { "a-zero-utc"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_a_zero_utc },
  { "t-ot-utc"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_t_ot_utc },
  { "delta-t-ls-utc"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_delta_t_ls_utc },
  { "w-n-t-utc"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_w_n_t_utc },
  { "w-n-lsf-utc"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_w_n_lsf_utc },
  { "dn-utc"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dn_utc },
  { "delta-t-lsf-utc"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_delta_t_lsf_utc },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GPS_UTC_Model(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GPS_UTC_Model, GPS_UTC_Model_sequence);

  return offset;
}
static int dissect_gPS_UTC_Model(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPS_UTC_Model(tvb, offset, pinfo, tree, hf_rnsap_gPS_UTC_Model);
}



static int
dissect_rnsap_DATA_ID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 3U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_dATA_ID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DATA_ID(tvb, offset, pinfo, tree, hf_rnsap_dATA_ID);
}



static int
dissect_rnsap_BIT_STRING_SIZE_11(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     11, 11, FALSE);

  return offset;
}
static int dissect_gps_af_zero_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_11(tvb, offset, pinfo, tree, hf_rnsap_gps_af_zero_alm);
}
static int dissect_gps_af_one_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_11(tvb, offset, pinfo, tree, hf_rnsap_gps_af_one_alm);
}


static const per_sequence_t T_satellite_Almanac_Information_item_sequence[] = {
  { "dATA-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dATA_ID },
  { "sAT-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAT_ID },
  { "gps-e-alm"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_e_alm },
  { "gps-toa-alm"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_toa_alm },
  { "gps-delta-I-alm"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_delta_I_alm },
  { "omegadot-alm"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_omegadot_alm },
  { "svhealth-alm"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_svhealth_alm },
  { "gps-a-sqrt-alm"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_a_sqrt_alm },
  { "omegazero-alm"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_omegazero_alm },
  { "m-zero-alm"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_m_zero_alm },
  { "gps-omega-alm"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_omega_alm },
  { "gps-af-zero-alm"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_af_zero_alm },
  { "gps-af-one-alm"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_af_one_alm },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_T_satellite_Almanac_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_T_satellite_Almanac_Information_item, T_satellite_Almanac_Information_item_sequence);

  return offset;
}
static int dissect_satellite_Almanac_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_satellite_Almanac_Information_item(tvb, offset, pinfo, tree, hf_rnsap_satellite_Almanac_Information_item);
}


static const per_sequence_t T_satellite_Almanac_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_satellite_Almanac_Information_item },
};

static int
dissect_rnsap_T_satellite_Almanac_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_T_satellite_Almanac_Information, T_satellite_Almanac_Information_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_satellite_Almanac_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_satellite_Almanac_Information(tvb, offset, pinfo, tree, hf_rnsap_satellite_Almanac_Information);
}



static int
dissect_rnsap_BIT_STRING_SIZE_364(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     364, 364, FALSE);

  return offset;
}
static int dissect_sVGlobalHealth_alm(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BIT_STRING_SIZE_364(tvb, offset, pinfo, tree, hf_rnsap_sVGlobalHealth_alm);
}


static const per_sequence_t GPS_Almanac_sequence[] = {
  { "wna-alm"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_wna_alm },
  { "satellite-Almanac-Information", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_satellite_Almanac_Information },
  { "sVGlobalHealth-alm"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_sVGlobalHealth_alm },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GPS_Almanac(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GPS_Almanac, GPS_Almanac_sequence);

  return offset;
}
static int dissect_gPS_Almanac(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPS_Almanac(tvb, offset, pinfo, tree, hf_rnsap_gPS_Almanac);
}


static const per_sequence_t T_badSatelliteInformation_item_sequence[] = {
  { "badSAT-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_badSAT_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_T_badSatelliteInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_T_badSatelliteInformation_item, T_badSatelliteInformation_item_sequence);

  return offset;
}
static int dissect_badSatelliteInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_badSatelliteInformation_item(tvb, offset, pinfo, tree, hf_rnsap_badSatelliteInformation_item);
}


static const per_sequence_t T_badSatelliteInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_badSatelliteInformation_item },
};

static int
dissect_rnsap_T_badSatelliteInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_T_badSatelliteInformation, T_badSatelliteInformation_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_badSatelliteInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_badSatelliteInformation(tvb, offset, pinfo, tree, hf_rnsap_badSatelliteInformation);
}


static const per_sequence_t BadSatellites_sequence[] = {
  { "badSatelliteInformation"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_badSatelliteInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_BadSatellites(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_BadSatellites, BadSatellites_sequence);

  return offset;
}
static int dissect_badSatellites(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BadSatellites(tvb, offset, pinfo, tree, hf_rnsap_badSatellites);
}


static const value_string rnsap_GPS_RealTime_Integrity_vals[] = {
  {   0, "badSatellites" },
  {   1, "noBadSatellite" },
  { 0, NULL }
};

static const per_choice_t GPS_RealTime_Integrity_choice[] = {
  {   0, "badSatellites"               , ASN1_NO_EXTENSIONS     , dissect_badSatellites },
  {   1, "noBadSatellite"              , ASN1_NO_EXTENSIONS     , dissect_noBadSatellite },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_GPS_RealTime_Integrity(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_GPS_RealTime_Integrity, GPS_RealTime_Integrity_choice,
                                 NULL);

  return offset;
}
static int dissect_gPS_RealTime_Integrity(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPS_RealTime_Integrity(tvb, offset, pinfo, tree, hf_rnsap_gPS_RealTime_Integrity);
}


static const per_sequence_t GPS_RX_POS_sequence[] = {
  { "geographicalCoordinate"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_geographicalCoordinate },
  { "altitudeAndDirection"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_altitudeAndDirection },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GPS_RX_POS(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GPS_RX_POS, GPS_RX_POS_sequence);

  return offset;
}
static int dissect_gPS_RX_POS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPS_RX_POS(tvb, offset, pinfo, tree, hf_rnsap_gPS_RX_POS);
}


static const per_sequence_t RequestedDataValue_sequence[] = {
  { "gA-AccessPointPositionwithAltitude", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gA_AccessPointPositionwithAltitude },
  { "iPDLParameters"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iPDLParameters },
  { "dGPSCorrections"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dGPSCorrections },
  { "gPS-NavigationModel-and-TimeRecovery", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gPS_NavigationModel_and_TimeRecovery },
  { "gPS-Ionospheric-Model"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gPS_Ionospheric_Model },
  { "gPS-UTC-Model"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gPS_UTC_Model },
  { "gPS-Almanac"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gPS_Almanac },
  { "gPS-RealTime-Integrity"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gPS_RealTime_Integrity },
  { "gPS-RX-POS"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gPS_RX_POS },
  { "sFNSFN-GA-AccessPointPosition", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_sFNSFN_GA_AccessPointPosition },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RequestedDataValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RequestedDataValue, RequestedDataValue_sequence);

  return offset;
}
static int dissect_requestedDataValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RequestedDataValue(tvb, offset, pinfo, tree, hf_rnsap_requestedDataValue);
}


static const per_sequence_t Cell_InfEx_Rsp_sequence[] = {
  { "requestedDataValue"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_requestedDataValue },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Cell_InfEx_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Cell_InfEx_Rsp, Cell_InfEx_Rsp_sequence);

  return offset;
}
static int dissect_cell5(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cell_InfEx_Rsp(tvb, offset, pinfo, tree, hf_rnsap_cell5);
}



static int
dissect_rnsap_Extension_InformationExchangeObjectType_InfEx_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_InformationExchangeObjectType_InfEx_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Extension_InformationExchangeObjectType_InfEx_Rsp(tvb, offset, pinfo, tree, hf_rnsap_extension_InformationExchangeObjectType_InfEx_Rsp);
}


static const value_string rnsap_InformationExchangeObjectType_InfEx_Rsp_vals[] = {
  {   0, "cell" },
  {   1, "extension-InformationExchangeObjectType-InfEx-Rsp" },
  { 0, NULL }
};

static const per_choice_t InformationExchangeObjectType_InfEx_Rsp_choice[] = {
  {   0, "cell"                        , ASN1_EXTENSION_ROOT    , dissect_cell5 },
  {   1, "extension-InformationExchangeObjectType-InfEx-Rsp", ASN1_NOT_EXTENSION_ROOT, dissect_extension_InformationExchangeObjectType_InfEx_Rsp },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_InformationExchangeObjectType_InfEx_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_InformationExchangeObjectType_InfEx_Rsp, InformationExchangeObjectType_InfEx_Rsp_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_sequence[] = {
  { "tmgi"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tmgi },
  { "requestedDataValue"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_requestedDataValue },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMS_Bearer_ServiceItemIEs_InfEx_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMS_Bearer_ServiceItemIEs_InfEx_Rsp, MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_sequence);

  return offset;
}
static int dissect_MBMS_Bearer_Service_List_InfEx_Rsp_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMS_Bearer_ServiceItemIEs_InfEx_Rsp(tvb, offset, pinfo, tree, hf_rnsap_MBMS_Bearer_Service_List_InfEx_Rsp_item);
}


static const per_sequence_t MBMS_Bearer_Service_List_InfEx_Rsp_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_MBMS_Bearer_Service_List_InfEx_Rsp_item },
};

static int
dissect_rnsap_MBMS_Bearer_Service_List_InfEx_Rsp(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_MBMS_Bearer_Service_List_InfEx_Rsp, MBMS_Bearer_Service_List_InfEx_Rsp_sequence_of,
                                                  1, 128);

  return offset;
}


static const per_sequence_t InformationExchangeInitiationFailure_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_InformationExchangeInitiationFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_InformationExchangeInitiationFailure, InformationExchangeInitiationFailure_sequence);

  return offset;
}


static const per_sequence_t InformationReport_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_InformationReport(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_InformationReport, InformationReport_sequence);

  return offset;
}


static const per_sequence_t InformationAvailable_sequence[] = {
  { "requestedDataValue"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_requestedDataValue },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_InformationAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_InformationAvailable, InformationAvailable_sequence);

  return offset;
}
static int dissect_informationAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_InformationAvailable(tvb, offset, pinfo, tree, hf_rnsap_informationAvailable);
}



static int
dissect_rnsap_InformationNotAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_null(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_informationNotAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_InformationNotAvailable(tvb, offset, pinfo, tree, hf_rnsap_informationNotAvailable);
}


static const value_string rnsap_RequestedDataValueInformation_vals[] = {
  {   0, "informationAvailable" },
  {   1, "informationNotAvailable" },
  { 0, NULL }
};

static const per_choice_t RequestedDataValueInformation_choice[] = {
  {   0, "informationAvailable"        , ASN1_NO_EXTENSIONS     , dissect_informationAvailable },
  {   1, "informationNotAvailable"     , ASN1_NO_EXTENSIONS     , dissect_informationNotAvailable },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_RequestedDataValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_RequestedDataValueInformation, RequestedDataValueInformation_choice,
                                 NULL);

  return offset;
}
static int dissect_requestedDataValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RequestedDataValueInformation(tvb, offset, pinfo, tree, hf_rnsap_requestedDataValueInformation);
}


static const per_sequence_t Cell_InfEx_Rprt_sequence[] = {
  { "requestedDataValueInformation", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_requestedDataValueInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Cell_InfEx_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Cell_InfEx_Rprt, Cell_InfEx_Rprt_sequence);

  return offset;
}
static int dissect_cell6(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Cell_InfEx_Rprt(tvb, offset, pinfo, tree, hf_rnsap_cell6);
}


static const value_string rnsap_InformationExchangeObjectType_InfEx_Rprt_vals[] = {
  {   0, "cell" },
  { 0, NULL }
};

static const per_choice_t InformationExchangeObjectType_InfEx_Rprt_choice[] = {
  {   0, "cell"                        , ASN1_EXTENSION_ROOT    , dissect_cell6 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_InformationExchangeObjectType_InfEx_Rprt(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_InformationExchangeObjectType_InfEx_Rprt, InformationExchangeObjectType_InfEx_Rprt_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t InformationExchangeTerminationRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_InformationExchangeTerminationRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_InformationExchangeTerminationRequest, InformationExchangeTerminationRequest_sequence);

  return offset;
}


static const per_sequence_t InformationExchangeFailureIndication_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_InformationExchangeFailureIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_InformationExchangeFailureIndication, InformationExchangeFailureIndication_sequence);

  return offset;
}


static const per_sequence_t ResetRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ResetRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ResetRequest, ResetRequest_sequence);

  return offset;
}


static const per_sequence_t ResetResponse_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ResetResponse(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ResetResponse, ResetResponse_sequence);

  return offset;
}


static const per_sequence_t RadioLinkActivationCommandFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkActivationCommandFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkActivationCommandFDD, RadioLinkActivationCommandFDD_sequence);

  return offset;
}


static const per_sequence_t DelayedActivationInformationList_RL_ActivationCmdFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DelayedActivationInformationList_RL_ActivationCmdFDD_item },
};

static int
dissect_rnsap_DelayedActivationInformationList_RL_ActivationCmdFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DelayedActivationInformationList_RL_ActivationCmdFDD, DelayedActivationInformationList_RL_ActivationCmdFDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const value_string rnsap_Execution_Type_vals[] = {
  {   0, "synchronised" },
  {   1, "unsynchronised" },
  { 0, NULL }
};

static const per_choice_t Execution_Type_choice[] = {
  {   0, "synchronised"                , ASN1_NO_EXTENSIONS     , dissect_synchronised },
  {   1, "unsynchronised"              , ASN1_NO_EXTENSIONS     , dissect_unsynchronised },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_Execution_Type(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_Execution_Type, Execution_Type_choice,
                                 NULL);

  return offset;
}
static int dissect_activation_type(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Execution_Type(tvb, offset, pinfo, tree, hf_rnsap_activation_type);
}
static int dissect_deactivation_type(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Execution_Type(tvb, offset, pinfo, tree, hf_rnsap_deactivation_type);
}


static const per_sequence_t Activate_Info_sequence[] = {
  { "activation-type"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_activation_type },
  { "initial-dl-tx-power"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_initial_dl_tx_power },
  { "firstRLS-Indicator"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_firstRLS_Indicator },
  { "propagation-delay"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_propagation_delay },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Activate_Info(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Activate_Info, Activate_Info_sequence);

  return offset;
}
static int dissect_activate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Activate_Info(tvb, offset, pinfo, tree, hf_rnsap_activate);
}


static const per_sequence_t Deactivate_Info_sequence[] = {
  { "deactivation-type"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_deactivation_type },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Deactivate_Info(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Deactivate_Info, Deactivate_Info_sequence);

  return offset;
}
static int dissect_deactivate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Deactivate_Info(tvb, offset, pinfo, tree, hf_rnsap_deactivate);
}


static const value_string rnsap_DelayedActivationUpdate_vals[] = {
  {   0, "activate" },
  {   1, "deactivate" },
  { 0, NULL }
};

static const per_choice_t DelayedActivationUpdate_choice[] = {
  {   0, "activate"                    , ASN1_NO_EXTENSIONS     , dissect_activate },
  {   1, "deactivate"                  , ASN1_NO_EXTENSIONS     , dissect_deactivate },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DelayedActivationUpdate(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DelayedActivationUpdate, DelayedActivationUpdate_choice,
                                 NULL);

  return offset;
}
static int dissect_delayed_activation_update(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DelayedActivationUpdate(tvb, offset, pinfo, tree, hf_rnsap_delayed_activation_update);
}


static const per_sequence_t DelayedActivationInformation_RL_ActivationCmdFDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "delayed-activation-update"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_delayed_activation_update },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DelayedActivationInformation_RL_ActivationCmdFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DelayedActivationInformation_RL_ActivationCmdFDD, DelayedActivationInformation_RL_ActivationCmdFDD_sequence);

  return offset;
}


static const per_sequence_t RadioLinkActivationCommandTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkActivationCommandTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkActivationCommandTDD, RadioLinkActivationCommandTDD_sequence);

  return offset;
}


static const per_sequence_t DelayedActivationInformationList_RL_ActivationCmdTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DelayedActivationInformationList_RL_ActivationCmdTDD_item },
};

static int
dissect_rnsap_DelayedActivationInformationList_RL_ActivationCmdTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DelayedActivationInformationList_RL_ActivationCmdTDD, DelayedActivationInformationList_RL_ActivationCmdTDD_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t DelayedActivationInformation_RL_ActivationCmdTDD_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "delayed-activation-update"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_delayed_activation_update },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DelayedActivationInformation_RL_ActivationCmdTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DelayedActivationInformation_RL_ActivationCmdTDD, DelayedActivationInformation_RL_ActivationCmdTDD_sequence);

  return offset;
}


static const per_sequence_t GERANUplinkSignallingTransferIndication_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GERANUplinkSignallingTransferIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GERANUplinkSignallingTransferIndication, GERANUplinkSignallingTransferIndication_sequence);

  return offset;
}


static const per_sequence_t RadioLinkParameterUpdateIndicationFDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkParameterUpdateIndicationFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkParameterUpdateIndicationFDD, RadioLinkParameterUpdateIndicationFDD_sequence);

  return offset;
}


static const per_sequence_t RL_ParameterUpdateIndicationFDD_RL_InformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_ParameterUpdateIndicationFDD_RL_InformationList_item },
};

static int
dissect_rnsap_RL_ParameterUpdateIndicationFDD_RL_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_ParameterUpdateIndicationFDD_RL_InformationList, RL_ParameterUpdateIndicationFDD_RL_InformationList_sequence_of,
                                                  1, 16);

  return offset;
}


static const value_string rnsap_Phase_Reference_Update_Indicator_vals[] = {
  {   0, "phase-reference-needs-to-be-changed" },
  { 0, NULL }
};


static int
dissect_rnsap_Phase_Reference_Update_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}
static int dissect_phase_Reference_Update_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Phase_Reference_Update_Indicator(tvb, offset, pinfo, tree, hf_rnsap_phase_Reference_Update_Indicator);
}


static const per_sequence_t RL_ParameterUpdateIndicationFDD_RL_Information_Item_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "phase-Reference-Update-Indicator", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_phase_Reference_Update_Indicator },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_ParameterUpdateIndicationFDD_RL_Information_Item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_ParameterUpdateIndicationFDD_RL_Information_Item, RL_ParameterUpdateIndicationFDD_RL_Information_Item_sequence);

  return offset;
}


static const per_sequence_t RadioLinkParameterUpdateIndicationTDD_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RadioLinkParameterUpdateIndicationTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RadioLinkParameterUpdateIndicationTDD, RadioLinkParameterUpdateIndicationTDD_sequence);

  return offset;
}


static const per_sequence_t UEMeasurementInitiationRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementInitiationRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementInitiationRequest, UEMeasurementInitiationRequest_sequence);

  return offset;
}


static const per_sequence_t UEMeasurementInitiationResponse_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementInitiationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementInitiationResponse, UEMeasurementInitiationResponse_sequence);

  return offset;
}


static const per_sequence_t UEMeasurementInitiationFailure_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementInitiationFailure(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementInitiationFailure, UEMeasurementInitiationFailure_sequence);

  return offset;
}


static const per_sequence_t UEMeasurementReport_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementReport(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementReport, UEMeasurementReport_sequence);

  return offset;
}


static const per_sequence_t UEMeasurementTerminationRequest_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementTerminationRequest(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementTerminationRequest, UEMeasurementTerminationRequest_sequence);

  return offset;
}


static const per_sequence_t UEMeasurementFailureIndication_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementFailureIndication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementFailureIndication, UEMeasurementFailureIndication_sequence);

  return offset;
}


static const per_sequence_t IurInvokeTrace_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_IurInvokeTrace(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_IurInvokeTrace, IurInvokeTrace_sequence);

  return offset;
}


static const per_sequence_t ListOfInterfacesToTrace_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ListOfInterfacesToTrace_item },
};

static int
dissect_rnsap_ListOfInterfacesToTrace(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_ListOfInterfacesToTrace, ListOfInterfacesToTrace_sequence_of,
                                                  1, 16);

  return offset;
}


static const value_string rnsap_T_interface_vals[] = {
  {   0, "iub" },
  {   1, "iur" },
  { 0, NULL }
};


static int
dissect_rnsap_T_interface(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_interface(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_interface(tvb, offset, pinfo, tree, hf_rnsap_interface);
}


static const per_sequence_t InterfacesToTraceItem_sequence[] = {
  { "interface"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_interface },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_InterfacesToTraceItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_InterfacesToTraceItem, InterfacesToTraceItem_sequence);

  return offset;
}


static const per_sequence_t IurDeactivateTrace_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_IurDeactivateTrace(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_IurDeactivateTrace, IurDeactivateTrace_sequence);

  return offset;
}


static const per_sequence_t MBMSAttachCommand_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMSAttachCommand(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMSAttachCommand, MBMSAttachCommand_sequence);

  return offset;
}


static const per_sequence_t MBMSDetachCommand_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMSDetachCommand(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMSDetachCommand, MBMSDetachCommand_sequence);

  return offset;
}


static const per_sequence_t DirectInformationTransfer_sequence[] = {
  { "protocolIEs"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_protocolIEs },
  { "protocolExtensions"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_protocolExtensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DirectInformationTransfer(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DirectInformationTransfer, DirectInformationTransfer_sequence);

  return offset;
}



static int
dissect_rnsap_AckNack_RepetitionFactor(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 4U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_ackNackRepetitionFactor(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AckNack_RepetitionFactor(tvb, offset, pinfo, tree, hf_rnsap_ackNackRepetitionFactor);
}



static int
dissect_rnsap_Ack_Power_Offset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 8U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_ackPowerOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Ack_Power_Offset(tvb, offset, pinfo, tree, hf_rnsap_ackPowerOffset);
}


static const per_sequence_t MBMS_Bearer_ServiceItemFDD_sequence[] = {
  { "tmgi"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tmgi },
  { "transmissionMode"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transmissionMode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMS_Bearer_ServiceItemFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMS_Bearer_ServiceItemFDD, MBMS_Bearer_ServiceItemFDD_sequence);

  return offset;
}
static int dissect_Active_MBMS_Bearer_Service_ListFDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMS_Bearer_ServiceItemFDD(tvb, offset, pinfo, tree, hf_rnsap_Active_MBMS_Bearer_Service_ListFDD_item);
}


static const per_sequence_t Active_MBMS_Bearer_Service_ListFDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Active_MBMS_Bearer_Service_ListFDD_item },
};

static int
dissect_rnsap_Active_MBMS_Bearer_Service_ListFDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Active_MBMS_Bearer_Service_ListFDD, Active_MBMS_Bearer_Service_ListFDD_sequence_of,
                                                  1, 256);

  return offset;
}


static const per_sequence_t MBMS_Bearer_ServiceItemFDD_PFL_sequence[] = {
  { "tmgi"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tmgi },
  { "transmissionMode"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transmissionMode },
  { "preferredFrequencyLayer"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_preferredFrequencyLayer },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMS_Bearer_ServiceItemFDD_PFL(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMS_Bearer_ServiceItemFDD_PFL, MBMS_Bearer_ServiceItemFDD_PFL_sequence);

  return offset;
}
static int dissect_Active_MBMS_Bearer_Service_ListFDD_PFL_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMS_Bearer_ServiceItemFDD_PFL(tvb, offset, pinfo, tree, hf_rnsap_Active_MBMS_Bearer_Service_ListFDD_PFL_item);
}


static const per_sequence_t Active_MBMS_Bearer_Service_ListFDD_PFL_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Active_MBMS_Bearer_Service_ListFDD_PFL_item },
};

static int
dissect_rnsap_Active_MBMS_Bearer_Service_ListFDD_PFL(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Active_MBMS_Bearer_Service_ListFDD_PFL, Active_MBMS_Bearer_Service_ListFDD_PFL_sequence_of,
                                                  1, 256);

  return offset;
}


static const per_sequence_t MBMS_Bearer_ServiceItemTDD_sequence[] = {
  { "tmgi"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tmgi },
  { "transmissionMode"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transmissionMode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MBMS_Bearer_ServiceItemTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MBMS_Bearer_ServiceItemTDD, MBMS_Bearer_ServiceItemTDD_sequence);

  return offset;
}
static int dissect_Active_MBMS_Bearer_Service_ListTDD_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MBMS_Bearer_ServiceItemTDD(tvb, offset, pinfo, tree, hf_rnsap_Active_MBMS_Bearer_Service_ListTDD_item);
}


static const per_sequence_t Active_MBMS_Bearer_Service_ListTDD_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Active_MBMS_Bearer_Service_ListTDD_item },
};

static int
dissect_rnsap_Active_MBMS_Bearer_Service_ListTDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Active_MBMS_Bearer_Service_ListTDD, Active_MBMS_Bearer_Service_ListTDD_sequence_of,
                                                  1, 256);

  return offset;
}



static int
dissect_rnsap_TGPSID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 6U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tGPSID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TGPSID(tvb, offset, pinfo, tree, hf_rnsap_tGPSID);
}



static int
dissect_rnsap_TGPRC(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 511U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tGPRC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TGPRC(tvb, offset, pinfo, tree, hf_rnsap_tGPRC);
}


static const per_sequence_t Transmission_Gap_Pattern_Sequence_Status_List_item_sequence[] = {
  { "tGPSID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tGPSID },
  { "tGPRC"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tGPRC },
  { "tGCFN"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tGCFN },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Transmission_Gap_Pattern_Sequence_Status_List_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Transmission_Gap_Pattern_Sequence_Status_List_item, Transmission_Gap_Pattern_Sequence_Status_List_item_sequence);

  return offset;
}
static int dissect_Transmission_Gap_Pattern_Sequence_Status_List_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Transmission_Gap_Pattern_Sequence_Status_List_item(tvb, offset, pinfo, tree, hf_rnsap_Transmission_Gap_Pattern_Sequence_Status_List_item);
}


static const per_sequence_t Transmission_Gap_Pattern_Sequence_Status_List_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Transmission_Gap_Pattern_Sequence_Status_List_item },
};

static int
dissect_rnsap_Transmission_Gap_Pattern_Sequence_Status_List(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Transmission_Gap_Pattern_Sequence_Status_List, Transmission_Gap_Pattern_Sequence_Status_List_sequence_of,
                                                  0, 6);

  return offset;
}
static int dissect_transmission_Gap_Pattern_Sequence_Status(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Transmission_Gap_Pattern_Sequence_Status_List(tvb, offset, pinfo, tree, hf_rnsap_transmission_Gap_Pattern_Sequence_Status);
}


static const per_sequence_t Active_Pattern_Sequence_Information_sequence[] = {
  { "cMConfigurationChangeCFN"    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cMConfigurationChangeCFN },
  { "transmission-Gap-Pattern-Sequence-Status", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transmission_Gap_Pattern_Sequence_Status },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Active_Pattern_Sequence_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Active_Pattern_Sequence_Information, Active_Pattern_Sequence_Information_sequence);

  return offset;
}



static int
dissect_rnsap_AOA_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 719U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_aOA_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AOA_LCR(tvb, offset, pinfo, tree, hf_rnsap_aOA_LCR);
}


static const value_string rnsap_AOA_LCR_Accuracy_Class_vals[] = {
  {   0, "a" },
  {   1, "b" },
  {   2, "c" },
  {   3, "d" },
  {   4, "e" },
  {   5, "f" },
  {   6, "g" },
  {   7, "h" },
  { 0, NULL }
};


static int
dissect_rnsap_AOA_LCR_Accuracy_Class(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 7, NULL, NULL, TRUE);

  return offset;
}
static int dissect_aOA_LCR_Accuracy_Class(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_AOA_LCR_Accuracy_Class(tvb, offset, pinfo, tree, hf_rnsap_aOA_LCR_Accuracy_Class);
}


static const per_sequence_t Angle_Of_Arrival_Value_LCR_sequence[] = {
  { "aOA-LCR"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_aOA_LCR },
  { "aOA-LCR-Accuracy-Class"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_aOA_LCR_Accuracy_Class },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Angle_Of_Arrival_Value_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Angle_Of_Arrival_Value_LCR, Angle_Of_Arrival_Value_LCR_sequence);

  return offset;
}


static const value_string rnsap_Band_Indicator_vals[] = {
  {   0, "dcs1800Band" },
  {   1, "pcs1900Band" },
  { 0, NULL }
};


static int
dissect_rnsap_Band_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_band_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Band_Indicator(tvb, offset, pinfo, tree, hf_rnsap_band_Indicator);
}



static int
dissect_rnsap_BCC(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     3, 3, FALSE);

  return offset;
}
static int dissect_bCC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BCC(tvb, offset, pinfo, tree, hf_rnsap_bCC);
}



static int
dissect_rnsap_BCCH_ARFCN(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 1023U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_bCCH_ARFCN(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BCCH_ARFCN(tvb, offset, pinfo, tree, hf_rnsap_bCCH_ARFCN);
}



static int
dissect_rnsap_NCC(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     3, 3, FALSE);

  return offset;
}
static int dissect_nCC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_NCC(tvb, offset, pinfo, tree, hf_rnsap_nCC);
}


static const per_sequence_t BSIC_sequence[] = {
  { "nCC"                         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_nCC },
  { "bCC"                         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_bCC },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_BSIC(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_BSIC, BSIC_sequence);

  return offset;
}
static int dissect_bSIC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BSIC(tvb, offset, pinfo, tree, hf_rnsap_bSIC);
}


static const value_string rnsap_BundlingModeIndicator_vals[] = {
  {   0, "bundling" },
  {   1, "no-bundling" },
  { 0, NULL }
};


static int
dissect_rnsap_BundlingModeIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_bundlingModeIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_BundlingModeIndicator(tvb, offset, pinfo, tree, hf_rnsap_bundlingModeIndicator);
}



static int
dissect_rnsap_CellCapabilityContainer_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     32, 32, FALSE);

  return offset;
}



static int
dissect_rnsap_CellCapabilityContainer_TDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     32, 32, FALSE);

  return offset;
}



static int
dissect_rnsap_CellCapabilityContainer_TDD_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     32, 32, FALSE);

  return offset;
}



static int
dissect_rnsap_CellPortionID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 63U, NULL, NULL, TRUE);

  return offset;
}


static const value_string rnsap_TUTRANGPSAccuracyClass_vals[] = {
  {   0, "accuracy-class-A" },
  {   1, "accuracy-class-B" },
  {   2, "accuracy-class-C" },
  { 0, NULL }
};


static int
dissect_rnsap_TUTRANGPSAccuracyClass(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_tUTRANGPSMeasurementAccuracyClass(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TUTRANGPSAccuracyClass(tvb, offset, pinfo, tree, hf_rnsap_tUTRANGPSMeasurementAccuracyClass);
}


static const value_string rnsap_CommonMeasurementAccuracy_vals[] = {
  {   0, "tUTRANGPSMeasurementAccuracyClass" },
  { 0, NULL }
};

static const per_choice_t CommonMeasurementAccuracy_choice[] = {
  {   0, "tUTRANGPSMeasurementAccuracyClass", ASN1_EXTENSION_ROOT    , dissect_tUTRANGPSMeasurementAccuracyClass },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_CommonMeasurementAccuracy(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_CommonMeasurementAccuracy, CommonMeasurementAccuracy_choice,
                                 NULL);

  return offset;
}


static const value_string rnsap_CommonMeasurementType_vals[] = {
  {   0, "uTRAN-GPS-timing-of-cell-frames-for-UE-Positioning" },
  {   1, "sFN-SFN-observerd-time-difference" },
  {   2, "load" },
  {   3, "transmitted-carrier-power" },
  {   4, "received-total-wide-band-power" },
  {   5, "uplink-timeslot-iscp" },
  {   6, "rT-load" },
  {   6, "nRT-load-Information" },
  {   6, "upPTSInterference" },
  { 0, NULL }
};


static int
dissect_rnsap_CommonMeasurementType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 6, NULL, NULL, TRUE);

  return offset;
}


static const value_string rnsap_CongestionCause_vals[] = {
  {   0, "uTRAN-dynamic-resources" },
  {   1, "uTRAN-semistatic-resources" },
  { 0, NULL }
};


static int
dissect_rnsap_CongestionCause(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}


static const value_string rnsap_CommonTransportChannelResourcesInitialisationNotRequired_vals[] = {
  {   0, "not-Required" },
  { 0, NULL }
};


static int
dissect_rnsap_CommonTransportChannelResourcesInitialisationNotRequired(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}


static const value_string rnsap_CQI_Feedback_Cycle_vals[] = {
  {   0, "v0" },
  {   1, "v2" },
  {   2, "v4" },
  {   3, "v8" },
  {   4, "v10" },
  {   5, "v20" },
  {   6, "v40" },
  {   7, "v80" },
  {   8, "v160" },
  { 0, NULL }
};


static int
dissect_rnsap_CQI_Feedback_Cycle(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 8, NULL, NULL, TRUE);

  return offset;
}
static int dissect_cqiFeedback_CycleK(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CQI_Feedback_Cycle(tvb, offset, pinfo, tree, hf_rnsap_cqiFeedback_CycleK);
}



static int
dissect_rnsap_CQI_Power_Offset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 8U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_cqiPowerOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CQI_Power_Offset(tvb, offset, pinfo, tree, hf_rnsap_cqiPowerOffset);
}



static int
dissect_rnsap_CQI_RepetitionFactor(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 4U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_cqiRepetitionFactor(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_CQI_RepetitionFactor(tvb, offset, pinfo, tree, hf_rnsap_cqiRepetitionFactor);
}


static const value_string rnsap_DelayedActivation_vals[] = {
  {   0, "cfn" },
  {   1, "separate-indication" },
  { 0, NULL }
};

static const per_choice_t DelayedActivation_choice[] = {
  {   0, "cfn"                         , ASN1_NO_EXTENSIONS     , dissect_cfn },
  {   1, "separate-indication"         , ASN1_NO_EXTENSIONS     , dissect_separate_indication },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_DelayedActivation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_DelayedActivation, DelayedActivation_choice,
                                 NULL);

  return offset;
}



static int
dissect_rnsap_DeltaSIR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 30U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_delta_SIR1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DeltaSIR(tvb, offset, pinfo, tree, hf_rnsap_delta_SIR1);
}
static int dissect_delta_SIR_after1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DeltaSIR(tvb, offset, pinfo, tree, hf_rnsap_delta_SIR_after1);
}
static int dissect_delta_SIR2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DeltaSIR(tvb, offset, pinfo, tree, hf_rnsap_delta_SIR2);
}
static int dissect_delta_SIR_after2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DeltaSIR(tvb, offset, pinfo, tree, hf_rnsap_delta_SIR_after2);
}


static const value_string rnsap_PRCDeviation_vals[] = {
  {   0, "prcd1" },
  {   1, "prcd2" },
  {   2, "prcd5" },
  {   3, "prcd10" },
  { 0, NULL }
};


static int
dissect_rnsap_PRCDeviation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 3, NULL, NULL, TRUE);

  return offset;
}
static int dissect_pRCDeviation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PRCDeviation(tvb, offset, pinfo, tree, hf_rnsap_pRCDeviation);
}


static const per_sequence_t DGPSThreshold_sequence[] = {
  { "pRCDeviation"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pRCDeviation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DGPSThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DGPSThreshold, DGPSThreshold_sequence);

  return offset;
}
static int dissect_dGPSThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DGPSThreshold(tvb, offset, pinfo, tree, hf_rnsap_dGPSThreshold);
}


static const value_string rnsap_DiscardTimer_vals[] = {
  {   0, "v20" },
  {   1, "v40" },
  {   2, "v60" },
  {   3, "v80" },
  {   4, "v100" },
  {   5, "v120" },
  {   6, "v140" },
  {   7, "v160" },
  {   8, "v180" },
  {   9, "v200" },
  {  10, "v250" },
  {  11, "v300" },
  {  12, "v400" },
  {  13, "v500" },
  {  14, "v750" },
  {  15, "v1000" },
  {  16, "v1250" },
  {  17, "v1500" },
  {  18, "v1750" },
  {  19, "v2000" },
  {  20, "v2500" },
  {  21, "v3000" },
  {  22, "v3500" },
  {  23, "v4000" },
  {  24, "v4500" },
  {  25, "v5000" },
  {  26, "v7500" },
  { 0, NULL }
};


static int
dissect_rnsap_DiscardTimer(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 26, NULL, NULL, TRUE);

  return offset;
}
static int dissect_discardTimer(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DiscardTimer(tvb, offset, pinfo, tree, hf_rnsap_discardTimer);
}


static const per_sequence_t DL_ReferencePowerInformationItem_sequence[] = {
  { "rL-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rL_ID },
  { "dl-Reference-Power"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_Reference_Power },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_ReferencePowerInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_ReferencePowerInformationItem, DL_ReferencePowerInformationItem_sequence);

  return offset;
}
static int dissect_DL_ReferencePowerInformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_ReferencePowerInformationItem(tvb, offset, pinfo, tree, hf_rnsap_DL_ReferencePowerInformationList_item);
}


static const per_sequence_t DL_ReferencePowerInformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_ReferencePowerInformationList_item },
};

static int
dissect_rnsap_DL_ReferencePowerInformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_ReferencePowerInformationList, DL_ReferencePowerInformationList_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_dLReferencePowerList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_ReferencePowerInformationList(tvb, offset, pinfo, tree, hf_rnsap_dLReferencePowerList);
}
static int dissect_individual_DL_ReferencePowerInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_ReferencePowerInformationList(tvb, offset, pinfo, tree, hf_rnsap_individual_DL_ReferencePowerInformation);
}



static int
dissect_rnsap_ScaledAdjustmentRatio(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 100U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_adjustmentRatio(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ScaledAdjustmentRatio(tvb, offset, pinfo, tree, hf_rnsap_adjustmentRatio);
}


static const per_sequence_t DL_PowerBalancing_Information_sequence[] = {
  { "powerAdjustmentType"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_powerAdjustmentType },
  { "dLReferencePower"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dLReferencePower },
  { "dLReferencePowerList"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dLReferencePowerList },
  { "maxAdjustmentStep"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_maxAdjustmentStep },
  { "adjustmentPeriod"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_adjustmentPeriod },
  { "adjustmentRatio"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_adjustmentRatio },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_PowerBalancing_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_PowerBalancing_Information, DL_PowerBalancing_Information_sequence);

  return offset;
}


static const value_string rnsap_DL_PowerBalancing_ActivationIndicator_vals[] = {
  {   0, "dL-PowerBalancing-Activated" },
  { 0, NULL }
};


static int
dissect_rnsap_DL_PowerBalancing_ActivationIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}


static const value_string rnsap_DL_PowerBalancing_UpdatedIndicator_vals[] = {
  {   0, "dL-PowerBalancing-Updated" },
  { 0, NULL }
};


static int
dissect_rnsap_DL_PowerBalancing_UpdatedIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}


static const per_sequence_t DL_ReferencePowerInformation_sequence[] = {
  { "common-DL-ReferencePowerInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_common_DL_ReferencePowerInformation },
  { "individual-DL-ReferencePowerInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_individual_DL_ReferencePowerInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_ReferencePowerInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_ReferencePowerInformation, DL_ReferencePowerInformation_sequence);

  return offset;
}


static const value_string rnsap_DL_FrameType_vals[] = {
  {   0, "typeA" },
  {   1, "typeB" },
  { 0, NULL }
};


static int
dissect_rnsap_DL_FrameType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_dL_FrameType(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_FrameType(tvb, offset, pinfo, tree, hf_rnsap_dL_FrameType);
}


static const per_sequence_t DL_TimeSlot_ISCP_LCR_InfoItem_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "dL-TimeslotISCP"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_TimeslotISCP },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DL_TimeSlot_ISCP_LCR_InfoItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DL_TimeSlot_ISCP_LCR_InfoItem, DL_TimeSlot_ISCP_LCR_InfoItem_sequence);

  return offset;
}
static int dissect_DL_TimeSlot_ISCP_LCR_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DL_TimeSlot_ISCP_LCR_InfoItem(tvb, offset, pinfo, tree, hf_rnsap_DL_TimeSlot_ISCP_LCR_Information_item);
}


static const per_sequence_t DL_TimeSlot_ISCP_LCR_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DL_TimeSlot_ISCP_LCR_Information_item },
};

static int
dissect_rnsap_DL_TimeSlot_ISCP_LCR_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DL_TimeSlot_ISCP_LCR_Information, DL_TimeSlot_ISCP_LCR_Information_sequence_of,
                                                  1, 6);

  return offset;
}


static const value_string rnsap_Downlink_Compressed_Mode_Method_vals[] = {
  {   0, "not-Used-puncturing" },
  {   1, "sFdiv2" },
  {   2, "higher-layer-scheduling" },
  { 0, NULL }
};


static int
dissect_rnsap_Downlink_Compressed_Mode_Method(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_downlink_Compressed_Mode_Method(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Downlink_Compressed_Mode_Method(tvb, offset, pinfo, tree, hf_rnsap_downlink_Compressed_Mode_Method);
}


static const value_string rnsap_DPC_Mode_Change_SupportIndicator_vals[] = {
  {   0, "dPC-ModeChangeSupported" },
  { 0, NULL }
};


static int
dissect_rnsap_DPC_Mode_Change_SupportIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_DSCH_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 65535U, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_DSCH_InitialWindowSize(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 255U, NULL, NULL, FALSE);

  return offset;
}


static const per_sequence_t DSCH_TDD_InformationItem_sequence[] = {
  { "dSCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dSCH_ID },
  { "dl-ccTrCHID"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_ccTrCHID },
  { "trChSourceStatisticsDescriptor", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_trChSourceStatisticsDescriptor },
  { "transportFormatSet"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatSet },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_allocationRetentionPriority },
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_schedulingPriorityIndicator },
  { "bLER"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_bLER },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_DSCH_TDD_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_DSCH_TDD_InformationItem, DSCH_TDD_InformationItem_sequence);

  return offset;
}
static int dissect_DSCH_TDD_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DSCH_TDD_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_DSCH_TDD_Information_item);
}


static const per_sequence_t DSCH_TDD_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_DSCH_TDD_Information_item },
};

static int
dissect_rnsap_DSCH_TDD_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_DSCH_TDD_Information, DSCH_TDD_Information_sequence_of,
                                                  1, 10);

  return offset;
}



static int
dissect_rnsap_DsField(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     8, 8, FALSE);

  return offset;
}
static int dissect_dsField(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_DsField(tvb, offset, pinfo, tree, hf_rnsap_dsField);
}



static int
dissect_rnsap_EDCH_DDI_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 63U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_eDCH_DDI_Value(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_DDI_Value(tvb, offset, pinfo, tree, hf_rnsap_eDCH_DDI_Value);
}



static int
dissect_rnsap_E_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 65535U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_primary_e_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_RNTI(tvb, offset, pinfo, tree, hf_rnsap_primary_e_RNTI);
}
static int dissect_secondary_e_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_RNTI(tvb, offset, pinfo, tree, hf_rnsap_secondary_e_RNTI);
}



static int
dissect_rnsap_ERGCH_SignatureSequence(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 39U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_eRGCH_SignatureSequence(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ERGCH_SignatureSequence(tvb, offset, pinfo, tree, hf_rnsap_eRGCH_SignatureSequence);
}



static int
dissect_rnsap_EHICH_SignatureSequence(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 39U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_eHICH_SignatureSequence(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EHICH_SignatureSequence(tvb, offset, pinfo, tree, hf_rnsap_eHICH_SignatureSequence);
}



static int
dissect_rnsap_E_Serving_Grant_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 31U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_serving_Grant_Value(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_Serving_Grant_Value(tvb, offset, pinfo, tree, hf_rnsap_serving_Grant_Value);
}


static const value_string rnsap_E_Primary_Secondary_Grant_Selector_vals[] = {
  {   0, "primary" },
  {   1, "secondary" },
  { 0, NULL }
};


static int
dissect_rnsap_E_Primary_Secondary_Grant_Selector(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_primary_Secondary_Grant_Selector(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_Primary_Secondary_Grant_Selector(tvb, offset, pinfo, tree, hf_rnsap_primary_Secondary_Grant_Selector);
}


static const value_string rnsap_E_RGCH_Release_Indicator_vals[] = {
  {   0, "e-RGCHreleased" },
  { 0, NULL }
};


static int
dissect_rnsap_E_RGCH_Release_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}
static int dissect_e_RGCH_Release_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_RGCH_Release_Indicator(tvb, offset, pinfo, tree, hf_rnsap_e_RGCH_Release_Indicator);
}


static const per_sequence_t EDCH_FDD_DL_ControlChannelInformation_sequence[] = {
  { "eAGCH-ERGCH-EHICH-FDD-ScramblingCode", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eAGCH_ERGCH_EHICH_FDD_ScramblingCode },
  { "eAGCH-ChannelisationCode"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eAGCH_ChannelisationCode },
  { "primary-e-RNTI"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primary_e_RNTI },
  { "secondary-e-RNTI"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_secondary_e_RNTI },
  { "eRGCH-EHICH-ChannelisationCode", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eRGCH_EHICH_ChannelisationCode },
  { "eRGCH-SignatureSequence"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eRGCH_SignatureSequence },
  { "eHICH-SignatureSequence"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eHICH_SignatureSequence },
  { "serving-Grant-Value"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_serving_Grant_Value },
  { "primary-Secondary-Grant-Selector", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primary_Secondary_Grant_Selector },
  { "e-RGCH-Release-Indicator"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_e_RGCH_Release_Indicator },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_FDD_DL_ControlChannelInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_FDD_DL_ControlChannelInformation, EDCH_FDD_DL_ControlChannelInformation_sequence);

  return offset;
}
static int dissect_eDCH_FDD_DL_ControlChannelInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_FDD_DL_ControlChannelInformation(tvb, offset, pinfo, tree, hf_rnsap_eDCH_FDD_DL_ControlChannelInformation);
}



static int
dissect_rnsap_GenericTrafficCategory(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     8, 8, FALSE);

  return offset;
}
static int dissect_genericTrafficCategory(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GenericTrafficCategory(tvb, offset, pinfo, tree, hf_rnsap_genericTrafficCategory);
}


static const value_string rnsap_TnlQos_vals[] = {
  {   0, "dsField" },
  {   1, "genericTrafficCategory" },
  { 0, NULL }
};

static const per_choice_t TnlQos_choice[] = {
  {   0, "dsField"                     , ASN1_EXTENSION_ROOT    , dissect_dsField },
  {   1, "genericTrafficCategory"      , ASN1_EXTENSION_ROOT    , dissect_genericTrafficCategory },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_TnlQos(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_TnlQos, TnlQos_choice,
                                 NULL);

  return offset;
}
static int dissect_tnlQoS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TnlQos(tvb, offset, pinfo, tree, hf_rnsap_tnlQoS);
}



static int
dissect_rnsap_MaxNr_Retransmissions_EDCH(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_maxNr_Retransmissions_EDCH(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MaxNr_Retransmissions_EDCH(tvb, offset, pinfo, tree, hf_rnsap_maxNr_Retransmissions_EDCH);
}


static const value_string rnsap_TrafficClass_vals[] = {
  {   0, "conversational" },
  {   1, "streaming" },
  {   2, "interactive" },
  {   3, "background" },
  { 0, NULL }
};


static int
dissect_rnsap_TrafficClass(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 3, NULL, NULL, TRUE);

  return offset;
}
static int dissect_trafficClass(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TrafficClass(tvb, offset, pinfo, tree, hf_rnsap_trafficClass);
}



static int
dissect_rnsap_E_DCH_HARQ_PO_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 6U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_eDCH_HARQ_PO_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_HARQ_PO_FDD(tvb, offset, pinfo, tree, hf_rnsap_eDCH_HARQ_PO_FDD);
}



static int
dissect_rnsap_E_DCH_MACdFlow_Multiplexing_List(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     8, 8, FALSE);

  return offset;
}
static int dissect_eDCH_MACdFlow_Multiplexing_List(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_MACdFlow_Multiplexing_List(tvb, offset, pinfo, tree, hf_rnsap_eDCH_MACdFlow_Multiplexing_List);
}



static int
dissect_rnsap_Max_Bits_MACe_PDU_non_scheduled(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 19982U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_maxBits_MACe_PDU_non_scheduled(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Max_Bits_MACe_PDU_non_scheduled(tvb, offset, pinfo, tree, hf_rnsap_maxBits_MACe_PDU_non_scheduled);
}



static int
dissect_rnsap_HARQ_Process_Allocation_2ms_EDCH(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     8, 8, FALSE);

  return offset;
}
static int dissect_hARQ_Process_Allocation_2ms(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HARQ_Process_Allocation_2ms_EDCH(tvb, offset, pinfo, tree, hf_rnsap_hARQ_Process_Allocation_2ms);
}


static const per_sequence_t E_DCH_Non_Scheduled_Transmission_Grant_Items_sequence[] = {
  { "maxBits-MACe-PDU-non-scheduled", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxBits_MACe_PDU_non_scheduled },
  { "hARQ-Process-Allocation-2ms" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hARQ_Process_Allocation_2ms },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_E_DCH_Non_Scheduled_Transmission_Grant_Items(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_E_DCH_Non_Scheduled_Transmission_Grant_Items, E_DCH_Non_Scheduled_Transmission_Grant_Items_sequence);

  return offset;
}
static int dissect_e_DCH_Non_Scheduled_Transmission_Grant(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_Non_Scheduled_Transmission_Grant_Items(tvb, offset, pinfo, tree, hf_rnsap_e_DCH_Non_Scheduled_Transmission_Grant);
}


static const value_string rnsap_E_DCH_Grant_Type_Information_vals[] = {
  {   0, "e-DCH-Non-Scheduled-Transmission-Grant" },
  {   1, "e-DCH-Scheduled-Transmission-Grant" },
  { 0, NULL }
};

static const per_choice_t E_DCH_Grant_Type_Information_choice[] = {
  {   0, "e-DCH-Non-Scheduled-Transmission-Grant", ASN1_EXTENSION_ROOT    , dissect_e_DCH_Non_Scheduled_Transmission_Grant },
  {   1, "e-DCH-Scheduled-Transmission-Grant", ASN1_EXTENSION_ROOT    , dissect_e_DCH_Scheduled_Transmission_Grant },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_E_DCH_Grant_Type_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_E_DCH_Grant_Type_Information, E_DCH_Grant_Type_Information_choice,
                                 NULL);

  return offset;
}
static int dissect_eDCH_Grant_Type_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_Grant_Type_Information(tvb, offset, pinfo, tree, hf_rnsap_eDCH_Grant_Type_Information);
}



static int
dissect_rnsap_LogicalChannelID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_logicalChannelId(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_LogicalChannelID(tvb, offset, pinfo, tree, hf_rnsap_logicalChannelId);
}



static int
dissect_rnsap_MACes_Guaranteed_Bitrate(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 16777215U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_mACes_GuaranteedBitRate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MACes_Guaranteed_Bitrate(tvb, offset, pinfo, tree, hf_rnsap_mACes_GuaranteedBitRate);
}



static int
dissect_rnsap_MACdPDU_Size(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 5000U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_mACdPDU_Size(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MACdPDU_Size(tvb, offset, pinfo, tree, hf_rnsap_mACdPDU_Size);
}
static int dissect_maximum_MACdPDU_Size(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MACdPDU_Size(tvb, offset, pinfo, tree, hf_rnsap_maximum_MACdPDU_Size);
}


static const per_sequence_t E_DCH_MACdPDU_SizeListItem_sequence[] = {
  { "mACdPDU-Size"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mACdPDU_Size },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_E_DCH_MACdPDU_SizeListItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_E_DCH_MACdPDU_SizeListItem, E_DCH_MACdPDU_SizeListItem_sequence);

  return offset;
}
static int dissect_E_DCH_MACdPDU_SizeList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_MACdPDU_SizeListItem(tvb, offset, pinfo, tree, hf_rnsap_E_DCH_MACdPDU_SizeList_item);
}
static int dissect_E_DCH_MACdPDU_SizeToModifyList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_MACdPDU_SizeListItem(tvb, offset, pinfo, tree, hf_rnsap_E_DCH_MACdPDU_SizeToModifyList_item);
}


static const per_sequence_t E_DCH_MACdPDU_SizeList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_E_DCH_MACdPDU_SizeList_item },
};

static int
dissect_rnsap_E_DCH_MACdPDU_SizeList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_E_DCH_MACdPDU_SizeList, E_DCH_MACdPDU_SizeList_sequence_of,
                                                  1, 64);

  return offset;
}
static int dissect_mACd_PDU_Size_List(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_MACdPDU_SizeList(tvb, offset, pinfo, tree, hf_rnsap_mACd_PDU_Size_List);
}


static const per_sequence_t E_DCH_LogicalChannelInformationItem_sequence[] = {
  { "logicalChannelId"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_logicalChannelId },
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_schedulingPriorityIndicator },
  { "mACes-GuaranteedBitRate"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mACes_GuaranteedBitRate },
  { "eDCH-DDI-Value"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDCH_DDI_Value },
  { "mACd-PDU-Size-List"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mACd_PDU_Size_List },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_E_DCH_LogicalChannelInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_E_DCH_LogicalChannelInformationItem, E_DCH_LogicalChannelInformationItem_sequence);

  return offset;
}
static int dissect_E_DCH_LogicalChannelInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_LogicalChannelInformationItem(tvb, offset, pinfo, tree, hf_rnsap_E_DCH_LogicalChannelInformation_item);
}


static const per_sequence_t E_DCH_LogicalChannelInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_E_DCH_LogicalChannelInformation_item },
};

static int
dissect_rnsap_E_DCH_LogicalChannelInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_E_DCH_LogicalChannelInformation, E_DCH_LogicalChannelInformation_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_eDCHLogicalChannelInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_LogicalChannelInformation(tvb, offset, pinfo, tree, hf_rnsap_eDCHLogicalChannelInformation);
}
static int dissect_eDCH_LogicalChannelToAdd(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_LogicalChannelInformation(tvb, offset, pinfo, tree, hf_rnsap_eDCH_LogicalChannelToAdd);
}


static const per_sequence_t EDCH_MACdFlow_Specific_InfoItem_sequence[] = {
  { "eDSCH-MACdFlow-ID"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDSCH_MACdFlow_ID },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_allocationRetentionPriority },
  { "tnlQoS"                      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tnlQoS },
  { "payloadCRC-PresenceIndicator", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_payloadCRC_PresenceIndicator },
  { "maxNr-Retransmissions-EDCH"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxNr_Retransmissions_EDCH },
  { "trafficClass"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_trafficClass },
  { "eDCH-HARQ-PO-FDD"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDCH_HARQ_PO_FDD },
  { "eDCH-MACdFlow-Multiplexing-List", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eDCH_MACdFlow_Multiplexing_List },
  { "eDCH-Grant-Type-Information" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eDCH_Grant_Type_Information },
  { "bundlingModeIndicator"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bundlingModeIndicator },
  { "eDCHLogicalChannelInformation", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDCHLogicalChannelInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_MACdFlow_Specific_InfoItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_MACdFlow_Specific_InfoItem, EDCH_MACdFlow_Specific_InfoItem_sequence);

  return offset;
}
static int dissect_EDCH_MACdFlow_Specific_InfoList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MACdFlow_Specific_InfoItem(tvb, offset, pinfo, tree, hf_rnsap_EDCH_MACdFlow_Specific_InfoList_item);
}


static const per_sequence_t EDCH_MACdFlow_Specific_InfoList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_EDCH_MACdFlow_Specific_InfoList_item },
};

static int
dissect_rnsap_EDCH_MACdFlow_Specific_InfoList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_EDCH_MACdFlow_Specific_InfoList, EDCH_MACdFlow_Specific_InfoList_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_eDCH_MACdFlow_Specific_Information1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MACdFlow_Specific_InfoList(tvb, offset, pinfo, tree, hf_rnsap_eDCH_MACdFlow_Specific_Information1);
}


static const per_sequence_t EDCH_MACdFlows_Information_sequence[] = {
  { "eDCH-MACdFlow-Specific-Information", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDCH_MACdFlow_Specific_Information1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_MACdFlows_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_MACdFlows_Information, EDCH_MACdFlows_Information_sequence);

  return offset;
}
static int dissect_eDCH_MACdFlows_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MACdFlows_Information(tvb, offset, pinfo, tree, hf_rnsap_eDCH_MACdFlows_Information);
}


static const per_sequence_t EDCH_FDD_Information_sequence[] = {
  { "eDCH-MACdFlows-Information"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDCH_MACdFlows_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_FDD_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_FDD_Information, EDCH_FDD_Information_sequence);

  return offset;
}


static const per_sequence_t EDCH_FDD_InformationResponseItem_sequence[] = {
  { "eDCH-MACdFlow-ID"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDCH_MACdFlow_ID },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_FDD_InformationResponseItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_FDD_InformationResponseItem, EDCH_FDD_InformationResponseItem_sequence);

  return offset;
}
static int dissect_EDCH_FDD_InformationResponse_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_FDD_InformationResponseItem(tvb, offset, pinfo, tree, hf_rnsap_EDCH_FDD_InformationResponse_item);
}


static const per_sequence_t EDCH_FDD_InformationResponse_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_EDCH_FDD_InformationResponse_item },
};

static int
dissect_rnsap_EDCH_FDD_InformationResponse(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_EDCH_FDD_InformationResponse, EDCH_FDD_InformationResponse_sequence_of,
                                                  1, 8);

  return offset;
}


static const per_sequence_t E_DCH_MACdPDU_SizeToModifyList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_E_DCH_MACdPDU_SizeToModifyList_item },
};

static int
dissect_rnsap_E_DCH_MACdPDU_SizeToModifyList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_E_DCH_MACdPDU_SizeToModifyList, E_DCH_MACdPDU_SizeToModifyList_sequence_of,
                                                  0, 64);

  return offset;
}
static int dissect_mACd_PDU_Size_List1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_MACdPDU_SizeToModifyList(tvb, offset, pinfo, tree, hf_rnsap_mACd_PDU_Size_List1);
}


static const per_sequence_t E_DCH_LogicalChannelToModifyItem_sequence[] = {
  { "logicalChannelId"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_logicalChannelId },
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_schedulingPriorityIndicator },
  { "mACes-GuaranteedBitRate"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mACes_GuaranteedBitRate },
  { "eDCH-DDI-Value"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eDCH_DDI_Value },
  { "mACd-PDU-Size-List"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mACd_PDU_Size_List1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_E_DCH_LogicalChannelToModifyItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_E_DCH_LogicalChannelToModifyItem, E_DCH_LogicalChannelToModifyItem_sequence);

  return offset;
}
static int dissect_E_DCH_LogicalChannelToModify_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_LogicalChannelToModifyItem(tvb, offset, pinfo, tree, hf_rnsap_E_DCH_LogicalChannelToModify_item);
}


static const per_sequence_t E_DCH_LogicalChannelToModify_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_E_DCH_LogicalChannelToModify_item },
};

static int
dissect_rnsap_E_DCH_LogicalChannelToModify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_E_DCH_LogicalChannelToModify, E_DCH_LogicalChannelToModify_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_eDCH_LogicalChannelToModify(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_LogicalChannelToModify(tvb, offset, pinfo, tree, hf_rnsap_eDCH_LogicalChannelToModify);
}


static const per_sequence_t E_DCH_LogicalChannelToDeleteItem_sequence[] = {
  { "logicalChannelId"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_logicalChannelId },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_E_DCH_LogicalChannelToDeleteItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_E_DCH_LogicalChannelToDeleteItem, E_DCH_LogicalChannelToDeleteItem_sequence);

  return offset;
}
static int dissect_E_DCH_LogicalChannelToDelete_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_LogicalChannelToDeleteItem(tvb, offset, pinfo, tree, hf_rnsap_E_DCH_LogicalChannelToDelete_item);
}


static const per_sequence_t E_DCH_LogicalChannelToDelete_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_E_DCH_LogicalChannelToDelete_item },
};

static int
dissect_rnsap_E_DCH_LogicalChannelToDelete(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_E_DCH_LogicalChannelToDelete, E_DCH_LogicalChannelToDelete_sequence_of,
                                                  1, 16);

  return offset;
}
static int dissect_eDCH_LogicalChannelToDelete(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_DCH_LogicalChannelToDelete(tvb, offset, pinfo, tree, hf_rnsap_eDCH_LogicalChannelToDelete);
}


static const per_sequence_t EDCH_MACdFlow_Specific_InfoToModifyItem_sequence[] = {
  { "eDSCH-MACdFlow-ID"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDSCH_MACdFlow_ID },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_allocationRetentionPriority },
  { "transportBearerRequestIndicator", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportBearerRequestIndicator },
  { "tnlQoS"                      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tnlQoS },
  { "maxNr-Retransmissions-EDCH"  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_maxNr_Retransmissions_EDCH },
  { "trafficClass"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_trafficClass },
  { "eDCH-HARQ-PO-FDD"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eDCH_HARQ_PO_FDD },
  { "eDCH-MACdFlow-Multiplexing-List", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eDCH_MACdFlow_Multiplexing_List },
  { "eDCH-Grant-Type-Information" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eDCH_Grant_Type_Information },
  { "bundlingModeIndicator"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bundlingModeIndicator },
  { "eDCH-LogicalChannelToAdd"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eDCH_LogicalChannelToAdd },
  { "eDCH-LogicalChannelToModify" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eDCH_LogicalChannelToModify },
  { "eDCH-LogicalChannelToDelete" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eDCH_LogicalChannelToDelete },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_MACdFlow_Specific_InfoToModifyItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_MACdFlow_Specific_InfoToModifyItem, EDCH_MACdFlow_Specific_InfoToModifyItem_sequence);

  return offset;
}
static int dissect_EDCH_MACdFlow_Specific_InfoToModifyList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MACdFlow_Specific_InfoToModifyItem(tvb, offset, pinfo, tree, hf_rnsap_EDCH_MACdFlow_Specific_InfoToModifyList_item);
}


static const per_sequence_t EDCH_MACdFlow_Specific_InfoToModifyList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_EDCH_MACdFlow_Specific_InfoToModifyList_item },
};

static int
dissect_rnsap_EDCH_MACdFlow_Specific_InfoToModifyList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_EDCH_MACdFlow_Specific_InfoToModifyList, EDCH_MACdFlow_Specific_InfoToModifyList_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_eDCH_MACdFlow_Specific_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MACdFlow_Specific_InfoToModifyList(tvb, offset, pinfo, tree, hf_rnsap_eDCH_MACdFlow_Specific_Information);
}


static const per_sequence_t EDCH_FDD_Information_To_Modify_sequence[] = {
  { "eDCH-MACdFlow-Specific-Information", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDCH_MACdFlow_Specific_Information },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_FDD_Information_To_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_FDD_Information_To_Modify, EDCH_FDD_Information_To_Modify_sequence);

  return offset;
}


static const per_sequence_t EDCH_FDD_Update_InfoItem_sequence[] = {
  { "eDCH-FDD-DL-ControlChannelInformation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_eDCH_FDD_DL_ControlChannelInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_FDD_Update_InfoItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_FDD_Update_InfoItem, EDCH_FDD_Update_InfoItem_sequence);

  return offset;
}
static int dissect_EDCH_FDD_Update_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_FDD_Update_InfoItem(tvb, offset, pinfo, tree, hf_rnsap_EDCH_FDD_Update_Information_item);
}


static const per_sequence_t EDCH_FDD_Update_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_EDCH_FDD_Update_Information_item },
};

static int
dissect_rnsap_EDCH_FDD_Update_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_EDCH_FDD_Update_Information, EDCH_FDD_Update_Information_sequence_of,
                                                  1, 16);

  return offset;
}


static const per_sequence_t EDCH_MACdFlows_To_Delete_Item_sequence[] = {
  { "eDSCH-MACdFlow-ID"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDSCH_MACdFlow_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_MACdFlows_To_Delete_Item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_MACdFlows_To_Delete_Item, EDCH_MACdFlows_To_Delete_Item_sequence);

  return offset;
}
static int dissect_EDCH_MACdFlows_To_Delete_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_MACdFlows_To_Delete_Item(tvb, offset, pinfo, tree, hf_rnsap_EDCH_MACdFlows_To_Delete_item);
}


static const per_sequence_t EDCH_MACdFlows_To_Delete_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_EDCH_MACdFlows_To_Delete_item },
};

static int
dissect_rnsap_EDCH_MACdFlows_To_Delete(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_EDCH_MACdFlows_To_Delete, EDCH_MACdFlows_To_Delete_sequence_of,
                                                  1, 8);

  return offset;
}



static int
dissect_rnsap_EDCH_Physical_Layer_Category(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_integer(tvb, offset, pinfo, tree, hf_index,
                                  NULL, NULL);

  return offset;
}


static const value_string rnsap_EDCH_RL_Indication_vals[] = {
  {   0, "eDCH" },
  {   1, "non-EDCH" },
  { 0, NULL }
};


static int
dissect_rnsap_EDCH_RL_Indication(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}


static const value_string rnsap_Max_Set_E_DPDCHs_vals[] = {
  {   0, "vN64" },
  {   1, "vN32" },
  {   2, "vN16" },
  {   3, "vN8" },
  {   4, "vN4" },
  {   5, "v2xN4" },
  {   6, "v2xN2" },
  {   7, "v2xN2plus2xN4" },
  { 0, NULL }
};


static int
dissect_rnsap_Max_Set_E_DPDCHs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 7, NULL, NULL, TRUE);

  return offset;
}
static int dissect_maxSet_E_DPDCHs(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Max_Set_E_DPDCHs(tvb, offset, pinfo, tree, hf_rnsap_maxSet_E_DPDCHs);
}


static const value_string rnsap_E_TTI_vals[] = {
  {   0, "tti10" },
  {   1, "tti2" },
  { 0, NULL }
};


static int
dissect_rnsap_E_TTI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}
static int dissect_e_TTI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_E_TTI(tvb, offset, pinfo, tree, hf_rnsap_e_TTI);
}


static const per_sequence_t EDPCH_Information_FDD_sequence[] = {
  { "maxSet-E-DPDCHs"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxSet_E_DPDCHs },
  { "punctureLimit"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_punctureLimit },
  { "e-TFCS-Information"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_e_TFCS_Information },
  { "e-TTI"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_e_TTI },
  { "e-DPCCH-PO"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_e_DPCCH_PO },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDPCH_Information_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDPCH_Information_FDD, EDPCH_Information_FDD_sequence);

  return offset;
}


static const per_sequence_t EDPCH_Information_RLReconfPrepare_FDD_sequence[] = {
  { "maxSet-E-DPDCHs"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_maxSet_E_DPDCHs },
  { "punctureLimit"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_punctureLimit },
  { "e-TFCS-Information"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_e_TFCS_Information },
  { "e-TTI"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_e_TTI },
  { "e-DPCCH-PO"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_e_DPCCH_PO },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDPCH_Information_RLReconfPrepare_FDD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDPCH_Information_RLReconfPrepare_FDD, EDPCH_Information_RLReconfPrepare_FDD_sequence);

  return offset;
}


static const per_sequence_t EDCH_Serving_RL_in_this_DRNS_sequence[] = {
  { "e-DCH-Serving-RL-Id"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_e_DCH_Serving_RL_Id },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EDCH_Serving_RL_in_this_DRNS(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EDCH_Serving_RL_in_this_DRNS, EDCH_Serving_RL_in_this_DRNS_sequence);

  return offset;
}
static int dissect_e_DCH_Serving_RL_in_this_DRNS(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EDCH_Serving_RL_in_this_DRNS(tvb, offset, pinfo, tree, hf_rnsap_e_DCH_Serving_RL_in_this_DRNS);
}


static const value_string rnsap_EDCH_Serving_RL_vals[] = {
  {   0, "e-DCH-Serving-RL-in-this-DRNS" },
  {   1, "e-DCH-Serving-RL-not-in-this-DRNS" },
  { 0, NULL }
};

static const per_choice_t EDCH_Serving_RL_choice[] = {
  {   0, "e-DCH-Serving-RL-in-this-DRNS", ASN1_EXTENSION_ROOT    , dissect_e_DCH_Serving_RL_in_this_DRNS },
  {   1, "e-DCH-Serving-RL-not-in-this-DRNS", ASN1_EXTENSION_ROOT    , dissect_e_DCH_Serving_RL_not_in_this_DRNS },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_EDCH_Serving_RL(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_EDCH_Serving_RL, EDCH_Serving_RL_choice,
                                 NULL);

  return offset;
}



static int
dissect_rnsap_Enhanced_PrimaryCPICH_EcNo(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 49U, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_Extension_MeasurementThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_MeasurementThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Extension_MeasurementThreshold(tvb, offset, pinfo, tree, hf_rnsap_extension_MeasurementThreshold);
}


static const value_string rnsap_MeasurementThreshold_vals[] = {
  {   0, "sir" },
  {   1, "sir-error" },
  {   2, "transmitted-code-power" },
  {   3, "rscp" },
  {   4, "rx-timing-deviation" },
  {   5, "round-trip-time" },
  {   6, "extension-MeasurementThreshold" },
  { 0, NULL }
};

static const per_choice_t MeasurementThreshold_choice[] = {
  {   0, "sir"                         , ASN1_EXTENSION_ROOT    , dissect_sir1 },
  {   1, "sir-error"                   , ASN1_EXTENSION_ROOT    , dissect_sir_error1 },
  {   2, "transmitted-code-power"      , ASN1_EXTENSION_ROOT    , dissect_transmitted_code_power1 },
  {   3, "rscp"                        , ASN1_EXTENSION_ROOT    , dissect_rscp1 },
  {   4, "rx-timing-deviation"         , ASN1_EXTENSION_ROOT    , dissect_rx_timing_deviation },
  {   5, "round-trip-time"             , ASN1_EXTENSION_ROOT    , dissect_round_trip_time1 },
  {   6, "extension-MeasurementThreshold", ASN1_NOT_EXTENSION_ROOT, dissect_extension_MeasurementThreshold },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_MeasurementThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_MeasurementThreshold, MeasurementThreshold_choice,
                                 NULL);

  return offset;
}
static int dissect_measurementTreshold(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MeasurementThreshold(tvb, offset, pinfo, tree, hf_rnsap_measurementTreshold);
}
static int dissect_measurementThreshold1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MeasurementThreshold(tvb, offset, pinfo, tree, hf_rnsap_measurementThreshold1);
}
static int dissect_measurementThreshold2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MeasurementThreshold(tvb, offset, pinfo, tree, hf_rnsap_measurementThreshold2);
}
static int dissect_measurementThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MeasurementThreshold(tvb, offset, pinfo, tree, hf_rnsap_measurementThreshold);
}



static int
dissect_rnsap_MeasurementHysteresisTime(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 6000U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_measurementHysteresisTime(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MeasurementHysteresisTime(tvb, offset, pinfo, tree, hf_rnsap_measurementHysteresisTime);
}


static const per_sequence_t EventA_sequence[] = {
  { "measurementTreshold"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_measurementTreshold },
  { "measurementHysteresisTime"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_measurementHysteresisTime },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EventA(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EventA, EventA_sequence);

  return offset;
}
static int dissect_eventA(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EventA(tvb, offset, pinfo, tree, hf_rnsap_eventA);
}


static const per_sequence_t EventB_sequence[] = {
  { "measurementTreshold"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_measurementTreshold },
  { "measurementHysteresisTime"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_measurementHysteresisTime },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EventB(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EventB, EventB_sequence);

  return offset;
}
static int dissect_eventB(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EventB(tvb, offset, pinfo, tree, hf_rnsap_eventB);
}



static int
dissect_rnsap_SIR_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 62U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sir(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SIR_Value_IncrDecrThres(tvb, offset, pinfo, tree, hf_rnsap_sir);
}



static int
dissect_rnsap_SIR_Error_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 124U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sir_error(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SIR_Error_Value_IncrDecrThres(tvb, offset, pinfo, tree, hf_rnsap_sir_error);
}



static int
dissect_rnsap_Transmitted_Code_Power_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 112U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_transmitted_code_power(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Transmitted_Code_Power_Value_IncrDecrThres(tvb, offset, pinfo, tree, hf_rnsap_transmitted_code_power);
}



static int
dissect_rnsap_RSCP_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 126U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_rscp(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RSCP_Value_IncrDecrThres(tvb, offset, pinfo, tree, hf_rnsap_rscp);
}



static int
dissect_rnsap_Round_Trip_Time_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 32766U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_round_trip_time(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Round_Trip_Time_IncrDecrThres(tvb, offset, pinfo, tree, hf_rnsap_round_trip_time);
}



static int
dissect_rnsap_Extension_MeasurementIncreaseDecreaseThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_MeasurementIncreaseDecreaseThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Extension_MeasurementIncreaseDecreaseThreshold(tvb, offset, pinfo, tree, hf_rnsap_extension_MeasurementIncreaseDecreaseThreshold);
}


static const value_string rnsap_MeasurementIncreaseDecreaseThreshold_vals[] = {
  {   0, "sir" },
  {   1, "sir-error" },
  {   2, "transmitted-code-power" },
  {   3, "rscp" },
  {   4, "round-trip-time" },
  {   5, "extension-MeasurementIncreaseDecreaseThreshold" },
  { 0, NULL }
};

static const per_choice_t MeasurementIncreaseDecreaseThreshold_choice[] = {
  {   0, "sir"                         , ASN1_EXTENSION_ROOT    , dissect_sir },
  {   1, "sir-error"                   , ASN1_EXTENSION_ROOT    , dissect_sir_error },
  {   2, "transmitted-code-power"      , ASN1_EXTENSION_ROOT    , dissect_transmitted_code_power },
  {   3, "rscp"                        , ASN1_EXTENSION_ROOT    , dissect_rscp },
  {   4, "round-trip-time"             , ASN1_EXTENSION_ROOT    , dissect_round_trip_time },
  {   5, "extension-MeasurementIncreaseDecreaseThreshold", ASN1_NOT_EXTENSION_ROOT, dissect_extension_MeasurementIncreaseDecreaseThreshold },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_MeasurementIncreaseDecreaseThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_MeasurementIncreaseDecreaseThreshold, MeasurementIncreaseDecreaseThreshold_choice,
                                 NULL);

  return offset;
}
static int dissect_measurementIncreaseDecreaseThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MeasurementIncreaseDecreaseThreshold(tvb, offset, pinfo, tree, hf_rnsap_measurementIncreaseDecreaseThreshold);
}



static int
dissect_rnsap_MeasurementChangeTime(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 6000U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_measurementChangeTime(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MeasurementChangeTime(tvb, offset, pinfo, tree, hf_rnsap_measurementChangeTime);
}


static const per_sequence_t EventC_sequence[] = {
  { "measurementIncreaseDecreaseThreshold", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_measurementIncreaseDecreaseThreshold },
  { "measurementChangeTime"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_measurementChangeTime },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EventC(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EventC, EventC_sequence);

  return offset;
}
static int dissect_eventC(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EventC(tvb, offset, pinfo, tree, hf_rnsap_eventC);
}


static const per_sequence_t EventD_sequence[] = {
  { "measurementIncreaseDecreaseThreshold", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_measurementIncreaseDecreaseThreshold },
  { "measurementChangeTime"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_measurementChangeTime },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EventD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EventD, EventD_sequence);

  return offset;
}
static int dissect_eventD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EventD(tvb, offset, pinfo, tree, hf_rnsap_eventD);
}



static int
dissect_rnsap_INTEGER_1_6000_(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 6000U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_ten_msec(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_6000_(tvb, offset, pinfo, tree, hf_rnsap_ten_msec);
}



static int
dissect_rnsap_INTEGER_1_60_(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 60U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_min(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_60_(tvb, offset, pinfo, tree, hf_rnsap_min);
}


static const value_string rnsap_ReportPeriodicity_vals[] = {
  {   0, "ten-msec" },
  {   1, "min" },
  { 0, NULL }
};

static const per_choice_t ReportPeriodicity_choice[] = {
  {   0, "ten-msec"                    , ASN1_EXTENSION_ROOT    , dissect_ten_msec },
  {   1, "min"                         , ASN1_EXTENSION_ROOT    , dissect_min },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_ReportPeriodicity(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_ReportPeriodicity, ReportPeriodicity_choice,
                                 NULL);

  return offset;
}
static int dissect_reportPeriodicity(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ReportPeriodicity(tvb, offset, pinfo, tree, hf_rnsap_reportPeriodicity);
}


static const per_sequence_t EventE_sequence[] = {
  { "measurementThreshold1"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_measurementThreshold1 },
  { "measurementThreshold2"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_measurementThreshold2 },
  { "measurementHysteresisTime"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_measurementHysteresisTime },
  { "reportPeriodicity"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_reportPeriodicity },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EventE(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EventE, EventE_sequence);

  return offset;
}
static int dissect_eventE(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EventE(tvb, offset, pinfo, tree, hf_rnsap_eventE);
}


static const per_sequence_t EventF_sequence[] = {
  { "measurementThreshold1"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_measurementThreshold1 },
  { "measurementThreshold2"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_measurementThreshold2 },
  { "measurementHysteresisTime"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_measurementHysteresisTime },
  { "reportPeriodicity"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_reportPeriodicity },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_EventF(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_EventF, EventF_sequence);

  return offset;
}
static int dissect_eventF(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_EventF(tvb, offset, pinfo, tree, hf_rnsap_eventF);
}



static int
dissect_rnsap_ExtendedGSMCellIndividualOffset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -50, 50U, NULL, NULL, FALSE);

  return offset;
}


static const per_sequence_t FACH_PCH_InformationItem_sequence[] = {
  { "transportFormatSet"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatSet },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_FACH_PCH_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_FACH_PCH_InformationItem, FACH_PCH_InformationItem_sequence);

  return offset;
}
static int dissect_FACH_PCH_InformationList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FACH_PCH_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_FACH_PCH_InformationList_item);
}


static const per_sequence_t FACH_PCH_InformationList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_FACH_PCH_InformationList_item },
};

static int
dissect_rnsap_FACH_PCH_InformationList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_FACH_PCH_InformationList, FACH_PCH_InformationList_sequence_of,
                                                  1, 10);

  return offset;
}


static const value_string rnsap_FNReportingIndicator_vals[] = {
  {   0, "fN-reporting-required" },
  {   1, "fN-reporting-not-required" },
  { 0, NULL }
};


static int
dissect_rnsap_FNReportingIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_INTEGER_1_4(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 4U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_wT(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_4(tvb, offset, pinfo, tree, hf_rnsap_wT);
}


static const per_sequence_t FPACH_Information_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "tDD-ChannelisationCodeLCR"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_ChannelisationCodeLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftLCR },
  { "wT"                          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_wT },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_FPACH_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_FPACH_Information, FPACH_Information_sequence);

  return offset;
}
static int dissect_fPACH_info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FPACH_Information(tvb, offset, pinfo, tree, hf_rnsap_fPACH_info);
}



static int
dissect_rnsap_GapLength(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 14U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tGL1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GapLength(tvb, offset, pinfo, tree, hf_rnsap_tGL1);
}
static int dissect_tGL2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GapLength(tvb, offset, pinfo, tree, hf_rnsap_tGL2);
}



static int
dissect_rnsap_GapDuration(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 144U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_tGPL1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GapDuration(tvb, offset, pinfo, tree, hf_rnsap_tGPL1);
}
static int dissect_not_to_be_used_1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GapDuration(tvb, offset, pinfo, tree, hf_rnsap_not_to_be_used_1);
}


static const per_sequence_t GA_PointWithUnCertainty_sequence[] = {
  { "geographicalCoordinates"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_geographicalCoordinates },
  { "uncertaintyCode"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uncertaintyCode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GA_PointWithUnCertainty(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GA_PointWithUnCertainty, GA_PointWithUnCertainty_sequence);

  return offset;
}
static int dissect_pointWithUncertainty(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_PointWithUnCertainty(tvb, offset, pinfo, tree, hf_rnsap_pointWithUncertainty);
}



static int
dissect_rnsap_INTEGER_0_179(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 179U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_offsetAngle(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_179(tvb, offset, pinfo, tree, hf_rnsap_offsetAngle);
}
static int dissect_includedAngle(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_179(tvb, offset, pinfo, tree, hf_rnsap_includedAngle);
}
static int dissect_orientationOfMajorAxis(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_179(tvb, offset, pinfo, tree, hf_rnsap_orientationOfMajorAxis);
}


static const per_sequence_t GA_UncertaintyEllipse_sequence[] = {
  { "uncertaintySemi-major"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uncertaintySemi_major },
  { "uncertaintySemi-minor"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uncertaintySemi_minor },
  { "orientationOfMajorAxis"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_orientationOfMajorAxis },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GA_UncertaintyEllipse(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GA_UncertaintyEllipse, GA_UncertaintyEllipse_sequence);

  return offset;
}
static int dissect_uncertaintyEllipse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_UncertaintyEllipse(tvb, offset, pinfo, tree, hf_rnsap_uncertaintyEllipse);
}


static const per_sequence_t GA_PointWithUnCertaintyEllipse_sequence[] = {
  { "geographicalCoordinates"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_geographicalCoordinates },
  { "uncertaintyEllipse"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uncertaintyEllipse },
  { "confidence"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_confidence },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GA_PointWithUnCertaintyEllipse(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GA_PointWithUnCertaintyEllipse, GA_PointWithUnCertaintyEllipse_sequence);

  return offset;
}
static int dissect_pointWithUncertaintyEllipse(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_PointWithUnCertaintyEllipse(tvb, offset, pinfo, tree, hf_rnsap_pointWithUncertaintyEllipse);
}


static const per_sequence_t GA_PointWithAltitude_sequence[] = {
  { "geographicalCoordinates"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_geographicalCoordinates },
  { "altitudeAndDirection"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_altitudeAndDirection },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GA_PointWithAltitude(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GA_PointWithAltitude, GA_PointWithAltitude_sequence);

  return offset;
}
static int dissect_pointWithAltitude(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_PointWithAltitude(tvb, offset, pinfo, tree, hf_rnsap_pointWithAltitude);
}


static const per_sequence_t GA_PointWithAltitudeAndUncertaintyEllipsoid_sequence[] = {
  { "geographicalCoordinates"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_geographicalCoordinates },
  { "altitudeAndDirection"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_altitudeAndDirection },
  { "uncertaintyEllipse"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uncertaintyEllipse },
  { "uncertaintyAltitude"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uncertaintyAltitude },
  { "confidence"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_confidence },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GA_PointWithAltitudeAndUncertaintyEllipsoid(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GA_PointWithAltitudeAndUncertaintyEllipsoid, GA_PointWithAltitudeAndUncertaintyEllipsoid_sequence);

  return offset;
}
static int dissect_pointWithAltitudeAndUncertaintyEllipsoid(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_PointWithAltitudeAndUncertaintyEllipsoid(tvb, offset, pinfo, tree, hf_rnsap_pointWithAltitudeAndUncertaintyEllipsoid);
}


static const per_sequence_t GA_EllipsoidArc_sequence[] = {
  { "geographicalCoordinates"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_geographicalCoordinates },
  { "innerRadius"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_innerRadius },
  { "uncertaintyRadius"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uncertaintyRadius },
  { "offsetAngle"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_offsetAngle },
  { "includedAngle"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_includedAngle },
  { "confidence"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_confidence },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GA_EllipsoidArc(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GA_EllipsoidArc, GA_EllipsoidArc_sequence);

  return offset;
}
static int dissect_ellipsoidArc(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GA_EllipsoidArc(tvb, offset, pinfo, tree, hf_rnsap_ellipsoidArc);
}


static const value_string rnsap_GA_CellAdditionalShapes_vals[] = {
  {   0, "pointWithUncertainty" },
  {   1, "pointWithUncertaintyEllipse" },
  {   2, "pointWithAltitude" },
  {   3, "pointWithAltitudeAndUncertaintyEllipsoid" },
  {   4, "ellipsoidArc" },
  { 0, NULL }
};

static const per_choice_t GA_CellAdditionalShapes_choice[] = {
  {   0, "pointWithUncertainty"        , ASN1_EXTENSION_ROOT    , dissect_pointWithUncertainty },
  {   1, "pointWithUncertaintyEllipse" , ASN1_EXTENSION_ROOT    , dissect_pointWithUncertaintyEllipse },
  {   2, "pointWithAltitude"           , ASN1_EXTENSION_ROOT    , dissect_pointWithAltitude },
  {   3, "pointWithAltitudeAndUncertaintyEllipsoid", ASN1_EXTENSION_ROOT    , dissect_pointWithAltitudeAndUncertaintyEllipsoid },
  {   4, "ellipsoidArc"                , ASN1_EXTENSION_ROOT    , dissect_ellipsoidArc },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_GA_CellAdditionalShapes(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_GA_CellAdditionalShapes, GA_CellAdditionalShapes_choice,
                                 NULL);

  return offset;
}



static int
dissect_rnsap_GERAN_Cell_Capability(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_bit_string(tvb, offset, pinfo, tree, hf_index,
                                     16, 16, FALSE);

  return offset;
}



static int
dissect_rnsap_GERAN_Classmark(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       NO_BOUND, NO_BOUND, NULL);

  return offset;
}



static int
dissect_rnsap_OCTET_STRING_SIZE_1_23(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       1, 23, NULL);

  return offset;
}
static int dissect_gERAN_SI_block(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_OCTET_STRING_SIZE_1_23(tvb, offset, pinfo, tree, hf_rnsap_gERAN_SI_block);
}


static const per_sequence_t GERAN_SystemInfo_item_sequence[] = {
  { "gERAN-SI-block"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gERAN_SI_block },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GERAN_SystemInfo_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GERAN_SystemInfo_item, GERAN_SystemInfo_item_sequence);

  return offset;
}
static int dissect_GERAN_SystemInfo_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GERAN_SystemInfo_item(tvb, offset, pinfo, tree, hf_rnsap_GERAN_SystemInfo_item);
}


static const per_sequence_t GERAN_SystemInfo_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_GERAN_SystemInfo_item },
};

static int
dissect_rnsap_GERAN_SystemInfo(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_GERAN_SystemInfo, GERAN_SystemInfo_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_sI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GERAN_SystemInfo(tvb, offset, pinfo, tree, hf_rnsap_sI);
}
static int dissect_pSI(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GERAN_SystemInfo(tvb, offset, pinfo, tree, hf_rnsap_pSI);
}


static const value_string rnsap_GERAN_SI_Type_vals[] = {
  {   0, "sI" },
  {   1, "pSI" },
  { 0, NULL }
};

static const per_choice_t GERAN_SI_Type_choice[] = {
  {   0, "sI"                          , ASN1_EXTENSION_ROOT    , dissect_sI },
  {   1, "pSI"                         , ASN1_EXTENSION_ROOT    , dissect_pSI },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_GERAN_SI_Type(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_GERAN_SI_Type, GERAN_SI_Type_choice,
                                 NULL);

  return offset;
}
static int dissect_gERAN_SI_Type(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GERAN_SI_Type(tvb, offset, pinfo, tree, hf_rnsap_gERAN_SI_Type);
}


static const per_sequence_t Satellite_Almanac_Information_ExtItem_item_sequence[] = {
  { "dATA-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dATA_ID },
  { "sAT-ID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sAT_ID },
  { "gps-e-alm"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_e_alm },
  { "gps-toa-alm"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_toa_alm },
  { "gps-delta-I-alm"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_delta_I_alm },
  { "omegadot-alm"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_omegadot_alm },
  { "svhealth-alm"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_svhealth_alm },
  { "gps-a-sqrt-alm"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_a_sqrt_alm },
  { "omegazero-alm"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_omegazero_alm },
  { "m-zero-alm"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_m_zero_alm },
  { "gps-omega-alm"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_omega_alm },
  { "gps-af-zero-alm"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_af_zero_alm },
  { "gps-af-one-alm"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gps_af_one_alm },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Satellite_Almanac_Information_ExtItem_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Satellite_Almanac_Information_ExtItem_item, Satellite_Almanac_Information_ExtItem_item_sequence);

  return offset;
}
static int dissect_Satellite_Almanac_Information_ExtItem_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Satellite_Almanac_Information_ExtItem_item(tvb, offset, pinfo, tree, hf_rnsap_Satellite_Almanac_Information_ExtItem_item);
}


static const per_sequence_t Satellite_Almanac_Information_ExtItem_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Satellite_Almanac_Information_ExtItem_item },
};

static int
dissect_rnsap_Satellite_Almanac_Information_ExtItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Satellite_Almanac_Information_ExtItem, Satellite_Almanac_Information_ExtItem_sequence_of,
                                                  1, 16);

  return offset;
}


static const value_string rnsap_T_gPSInformationItem_vals[] = {
  {   0, "gPS-NavigationModel-and-TimeRecovery" },
  {   1, "gPS-Ionospheric-Model" },
  {   2, "gPS-UTC-Model" },
  {   3, "gPS-Almanac" },
  {   4, "gPS-RealTime-Integrity" },
  { 0, NULL }
};


static int
dissect_rnsap_T_gPSInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 4, NULL, NULL, TRUE);

  return offset;
}
static int dissect_gPSInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_gPSInformationItem(tvb, offset, pinfo, tree, hf_rnsap_gPSInformationItem);
}


static const per_sequence_t GPSInformation_item_sequence[] = {
  { "gPSInformationItem"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gPSInformationItem },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_GPSInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_GPSInformation_item, GPSInformation_item_sequence);

  return offset;
}
static int dissect_GPSInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPSInformation_item(tvb, offset, pinfo, tree, hf_rnsap_GPSInformation_item);
}


static const per_sequence_t GPSInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_GPSInformation_item },
};

static int
dissect_rnsap_GPSInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_GPSInformation, GPSInformation_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_gPSInformation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_GPSInformation(tvb, offset, pinfo, tree, hf_rnsap_gPSInformation);
}



static int
dissect_rnsap_INTEGER_1_8_(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 8U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_number_of_Processes(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_8_(tvb, offset, pinfo, tree, hf_rnsap_number_of_Processes);
}


static const per_sequence_t HARQ_MemoryPartitioning_Implicit_sequence[] = {
  { "number-of-Processes"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_number_of_Processes },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HARQ_MemoryPartitioning_Implicit(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HARQ_MemoryPartitioning_Implicit, HARQ_MemoryPartitioning_Implicit_sequence);

  return offset;
}
static int dissect_implicit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HARQ_MemoryPartitioning_Implicit(tvb, offset, pinfo, tree, hf_rnsap_implicit);
}


static const value_string rnsap_T_process_Memory_Size_vals[] = {
  {   0, "hms800" },
  {   1, "hms1600" },
  {   2, "hms2400" },
  {   3, "hms3200" },
  {   4, "hms4000" },
  {   5, "hms4800" },
  {   6, "hms5600" },
  {   7, "hms6400" },
  {   8, "hms7200" },
  {   9, "hms8000" },
  {  10, "hms8800" },
  {  11, "hms9600" },
  {  12, "hms10400" },
  {  13, "hms11200" },
  {  14, "hms12000" },
  {  15, "hms12800" },
  {  16, "hms13600" },
  {  17, "hms14400" },
  {  18, "hms15200" },
  {  19, "hms16000" },
  {  20, "hms17600" },
  {  21, "hms19200" },
  {  22, "hms20800" },
  {  23, "hms22400" },
  {  24, "hms24000" },
  {  25, "hms25600" },
  {  26, "hms27200" },
  {  27, "hms28800" },
  {  28, "hms30400" },
  {  29, "hms32000" },
  {  30, "hms36000" },
  {  31, "hms40000" },
  {  32, "hms44000" },
  {  33, "hms48000" },
  {  34, "hms52000" },
  {  35, "hms56000" },
  {  36, "hms60000" },
  {  37, "hms64000" },
  {  38, "hms68000" },
  {  39, "hms72000" },
  {  40, "hms76000" },
  {  41, "hms80000" },
  {  42, "hms88000" },
  {  43, "hms96000" },
  {  44, "hms104000" },
  {  45, "hms112000" },
  {  46, "hms120000" },
  {  47, "hms128000" },
  {  48, "hms136000" },
  {  49, "hms144000" },
  {  50, "hms152000" },
  {  51, "hms160000" },
  {  52, "hms176000" },
  {  53, "hms192000" },
  {  54, "hms208000" },
  {  55, "hms224000" },
  {  56, "hms240000" },
  {  57, "hms256000" },
  {  58, "hms272000" },
  {  59, "hms288000" },
  {  60, "hms304000" },
  { 0, NULL }
};


static int
dissect_rnsap_T_process_Memory_Size(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 60, NULL, NULL, TRUE);

  return offset;
}
static int dissect_process_Memory_Size(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_process_Memory_Size(tvb, offset, pinfo, tree, hf_rnsap_process_Memory_Size);
}


static const per_sequence_t HARQ_MemoryPartitioningItem_sequence[] = {
  { "process-Memory-Size"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_process_Memory_Size },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HARQ_MemoryPartitioningItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HARQ_MemoryPartitioningItem, HARQ_MemoryPartitioningItem_sequence);

  return offset;
}
static int dissect_HARQ_MemoryPartitioningList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HARQ_MemoryPartitioningItem(tvb, offset, pinfo, tree, hf_rnsap_HARQ_MemoryPartitioningList_item);
}


static const per_sequence_t HARQ_MemoryPartitioningList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HARQ_MemoryPartitioningList_item },
};

static int
dissect_rnsap_HARQ_MemoryPartitioningList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HARQ_MemoryPartitioningList, HARQ_MemoryPartitioningList_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_hARQ_MemoryPartitioningList(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HARQ_MemoryPartitioningList(tvb, offset, pinfo, tree, hf_rnsap_hARQ_MemoryPartitioningList);
}


static const per_sequence_t HARQ_MemoryPartitioning_Explicit_sequence[] = {
  { "hARQ-MemoryPartitioningList" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hARQ_MemoryPartitioningList },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HARQ_MemoryPartitioning_Explicit(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HARQ_MemoryPartitioning_Explicit, HARQ_MemoryPartitioning_Explicit_sequence);

  return offset;
}
static int dissect_explicit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HARQ_MemoryPartitioning_Explicit(tvb, offset, pinfo, tree, hf_rnsap_explicit);
}


static const value_string rnsap_HARQ_MemoryPartitioning_vals[] = {
  {   0, "implicit" },
  {   1, "explicit" },
  { 0, NULL }
};

static const per_choice_t HARQ_MemoryPartitioning_choice[] = {
  {   0, "implicit"                    , ASN1_EXTENSION_ROOT    , dissect_implicit },
  {   1, "explicit"                    , ASN1_EXTENSION_ROOT    , dissect_explicit },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_HARQ_MemoryPartitioning(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_HARQ_MemoryPartitioning, HARQ_MemoryPartitioning_choice,
                                 NULL);

  return offset;
}
static int dissect_hARQ_MemoryPartitioning(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HARQ_MemoryPartitioning(tvb, offset, pinfo, tree, hf_rnsap_hARQ_MemoryPartitioning);
}


static const per_sequence_t HSDSCH_MACdFlow_Specific_InfoItem_sequence[] = {
  { "hSDSCH-MACdFlow-ID"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSDSCH_MACdFlow_ID },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_allocationRetentionPriority },
  { "trafficClass"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_trafficClass },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_MACdFlow_Specific_InfoItem, HSDSCH_MACdFlow_Specific_InfoItem_sequence);

  return offset;
}
static int dissect_HSDSCH_MACdFlow_Specific_InfoList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoItem(tvb, offset, pinfo, tree, hf_rnsap_HSDSCH_MACdFlow_Specific_InfoList_item);
}


static const per_sequence_t HSDSCH_MACdFlow_Specific_InfoList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSDSCH_MACdFlow_Specific_InfoList_item },
};

static int
dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSDSCH_MACdFlow_Specific_InfoList, HSDSCH_MACdFlow_Specific_InfoList_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_hSDSCH_MACdFlow_Specific_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoList(tvb, offset, pinfo, tree, hf_rnsap_hSDSCH_MACdFlow_Specific_Info);
}



static int
dissect_rnsap_PriorityQueue_Id(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 7U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_deletePriorityQueue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityQueue_Id(tvb, offset, pinfo, tree, hf_rnsap_deletePriorityQueue);
}
static int dissect_priorityQueue_Id(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityQueue_Id(tvb, offset, pinfo, tree, hf_rnsap_priorityQueue_Id);
}
static int dissect_priorityQueueId(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityQueue_Id(tvb, offset, pinfo, tree, hf_rnsap_priorityQueueId);
}


static const value_string rnsap_T1_vals[] = {
  {   0, "v10" },
  {   1, "v20" },
  {   2, "v30" },
  {   3, "v40" },
  {   4, "v50" },
  {   5, "v60" },
  {   6, "v70" },
  {   7, "v80" },
  {   8, "v90" },
  {   9, "v100" },
  {  10, "v120" },
  {  11, "v140" },
  {  12, "v160" },
  {  13, "v200" },
  {  14, "v300" },
  {  15, "v400" },
  { 0, NULL }
};


static int
dissect_rnsap_T1(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 15, NULL, NULL, TRUE);

  return offset;
}
static int dissect_t1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T1(tvb, offset, pinfo, tree, hf_rnsap_t1);
}


static const value_string rnsap_MAC_hsWindowSize_vals[] = {
  {   0, "v4" },
  {   1, "v6" },
  {   2, "v8" },
  {   3, "v12" },
  {   4, "v16" },
  {   5, "v24" },
  {   6, "v32" },
  { 0, NULL }
};


static int
dissect_rnsap_MAC_hsWindowSize(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 6, NULL, NULL, TRUE);

  return offset;
}
static int dissect_mAC_hsWindowSize(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MAC_hsWindowSize(tvb, offset, pinfo, tree, hf_rnsap_mAC_hsWindowSize);
}



static int
dissect_rnsap_MAChsGuaranteedBitRate(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 16777215U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_mAChsGuaranteedBitRate(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MAChsGuaranteedBitRate(tvb, offset, pinfo, tree, hf_rnsap_mAChsGuaranteedBitRate);
}



static int
dissect_rnsap_SID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 7U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sID(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SID(tvb, offset, pinfo, tree, hf_rnsap_sID);
}


static const per_sequence_t MACdPDU_Size_IndexItem_sequence[] = {
  { "sID"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sID },
  { "mACdPDU-Size"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mACdPDU_Size },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MACdPDU_Size_IndexItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MACdPDU_Size_IndexItem, MACdPDU_Size_IndexItem_sequence);

  return offset;
}
static int dissect_MACdPDU_Size_IndexList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MACdPDU_Size_IndexItem(tvb, offset, pinfo, tree, hf_rnsap_MACdPDU_Size_IndexList_item);
}


static const per_sequence_t MACdPDU_Size_IndexList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_MACdPDU_Size_IndexList_item },
};

static int
dissect_rnsap_MACdPDU_Size_IndexList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_MACdPDU_Size_IndexList, MACdPDU_Size_IndexList_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_mACdPDU_Size_Index(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MACdPDU_Size_IndexList(tvb, offset, pinfo, tree, hf_rnsap_mACdPDU_Size_Index);
}


static const value_string rnsap_RLC_Mode_vals[] = {
  {   0, "rLC-AM" },
  {   1, "rLC-UM" },
  { 0, NULL }
};


static int
dissect_rnsap_RLC_Mode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_rLC_Mode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RLC_Mode(tvb, offset, pinfo, tree, hf_rnsap_rLC_Mode);
}


static const per_sequence_t PriorityQueue_InfoItem_sequence[] = {
  { "priorityQueue-Id"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_priorityQueue_Id },
  { "associatedHSDSCH-MACdFlow"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_associatedHSDSCH_MACdFlow },
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_schedulingPriorityIndicator },
  { "t1"                          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_t1 },
  { "discardTimer"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_discardTimer },
  { "mAC-hsWindowSize"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mAC_hsWindowSize },
  { "mAChsGuaranteedBitRate"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mAChsGuaranteedBitRate },
  { "mACdPDU-Size-Index"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mACdPDU_Size_Index },
  { "rLC-Mode"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rLC_Mode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PriorityQueue_InfoItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PriorityQueue_InfoItem, PriorityQueue_InfoItem_sequence);

  return offset;
}
static int dissect_PriorityQueue_InfoList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityQueue_InfoItem(tvb, offset, pinfo, tree, hf_rnsap_PriorityQueue_InfoList_item);
}


static const per_sequence_t PriorityQueue_InfoList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_PriorityQueue_InfoList_item },
};

static int
dissect_rnsap_PriorityQueue_InfoList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_PriorityQueue_InfoList, PriorityQueue_InfoList_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_priorityQueue_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityQueue_InfoList(tvb, offset, pinfo, tree, hf_rnsap_priorityQueue_Info);
}


static const per_sequence_t HSDSCH_MACdFlows_Information_sequence[] = {
  { "hSDSCH-MACdFlow-Specific-Info", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSDSCH_MACdFlow_Specific_Info },
  { "priorityQueue-Info"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_priorityQueue_Info },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_MACdFlows_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_MACdFlows_Information, HSDSCH_MACdFlows_Information_sequence);

  return offset;
}
static int dissect_hSDSCH_MACdFlows_Information(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlows_Information(tvb, offset, pinfo, tree, hf_rnsap_hSDSCH_MACdFlows_Information);
}



static int
dissect_rnsap_INTEGER_1_64_(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 64U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_hSDSCH_Physical_Layer_Category(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_64_(tvb, offset, pinfo, tree, hf_rnsap_hSDSCH_Physical_Layer_Category);
}


static const per_sequence_t UE_Capabilities_Info_sequence[] = {
  { "hSDSCH-Physical-Layer-Category", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSDSCH_Physical_Layer_Category },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UE_Capabilities_Info(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UE_Capabilities_Info, UE_Capabilities_Info_sequence);

  return offset;
}
static int dissect_uE_Capabilities_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UE_Capabilities_Info(tvb, offset, pinfo, tree, hf_rnsap_uE_Capabilities_Info);
}



static int
dissect_rnsap_MAChsReorderingBufferSize_for_RLC_UM(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 300U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_mAChs_Reordering_Buffer_Size_for_RLC_UM(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MAChsReorderingBufferSize_for_RLC_UM(tvb, offset, pinfo, tree, hf_rnsap_mAChs_Reordering_Buffer_Size_for_RLC_UM);
}



static int
dissect_rnsap_Nack_Power_Offset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 8U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_nackPowerOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Nack_Power_Offset(tvb, offset, pinfo, tree, hf_rnsap_nackPowerOffset);
}



static int
dissect_rnsap_HSSCCH_PowerOffset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_hsscch_PowerOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSCCH_PowerOffset(tvb, offset, pinfo, tree, hf_rnsap_hsscch_PowerOffset);
}


static const per_sequence_t HSDSCH_FDD_Information_sequence[] = {
  { "hSDSCH-MACdFlows-Information", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSDSCH_MACdFlows_Information },
  { "uE-Capabilities-Info"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uE_Capabilities_Info },
  { "mAChs-Reordering-Buffer-Size-for-RLC-UM", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mAChs_Reordering_Buffer_Size_for_RLC_UM },
  { "cqiFeedback-CycleK"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cqiFeedback_CycleK },
  { "cqiRepetitionFactor"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cqiRepetitionFactor },
  { "ackNackRepetitionFactor"     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ackNackRepetitionFactor },
  { "cqiPowerOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cqiPowerOffset },
  { "ackPowerOffset"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ackPowerOffset },
  { "nackPowerOffset"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_nackPowerOffset },
  { "hsscch-PowerOffset"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hsscch_PowerOffset },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_FDD_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_FDD_Information, HSDSCH_FDD_Information_sequence);

  return offset;
}



static int
dissect_rnsap_HSDSCH_InitialWindowSize(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 255U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_hSDSCH_InitialWindowSize(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_InitialWindowSize(tvb, offset, pinfo, tree, hf_rnsap_hSDSCH_InitialWindowSize);
}


static const per_sequence_t HSDSCH_Initial_Capacity_AllocationItem_sequence[] = {
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_schedulingPriorityIndicator },
  { "maximum-MACdPDU-Size"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maximum_MACdPDU_Size },
  { "hSDSCH-InitialWindowSize"    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSDSCH_InitialWindowSize },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_Initial_Capacity_AllocationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_Initial_Capacity_AllocationItem, HSDSCH_Initial_Capacity_AllocationItem_sequence);

  return offset;
}
static int dissect_HSDSCH_Initial_Capacity_Allocation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_Initial_Capacity_AllocationItem(tvb, offset, pinfo, tree, hf_rnsap_HSDSCH_Initial_Capacity_Allocation_item);
}


static const per_sequence_t HSDSCH_Initial_Capacity_Allocation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSDSCH_Initial_Capacity_Allocation_item },
};

static int
dissect_rnsap_HSDSCH_Initial_Capacity_Allocation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSDSCH_Initial_Capacity_Allocation, HSDSCH_Initial_Capacity_Allocation_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_hSDSCH_Initial_Capacity_Allocation(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_Initial_Capacity_Allocation(tvb, offset, pinfo, tree, hf_rnsap_hSDSCH_Initial_Capacity_Allocation);
}


static const per_sequence_t HSDSCH_MACdFlow_Specific_InfoItem_Response_sequence[] = {
  { "hSDSCH-MACdFlow-ID"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSDSCH_MACdFlow_ID },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "hSDSCH-Initial-Capacity-Allocation", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSDSCH_Initial_Capacity_Allocation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoItem_Response(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_MACdFlow_Specific_InfoItem_Response, HSDSCH_MACdFlow_Specific_InfoItem_Response_sequence);

  return offset;
}
static int dissect_HSDSCH_MACdFlow_Specific_InfoList_Response_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoItem_Response(tvb, offset, pinfo, tree, hf_rnsap_HSDSCH_MACdFlow_Specific_InfoList_Response_item);
}


static const per_sequence_t HSDSCH_MACdFlow_Specific_InfoList_Response_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSDSCH_MACdFlow_Specific_InfoList_Response_item },
};

static int
dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoList_Response(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSDSCH_MACdFlow_Specific_InfoList_Response, HSDSCH_MACdFlow_Specific_InfoList_Response_sequence_of,
                                                  0, 8);

  return offset;
}
static int dissect_hSDSCH_MACdFlow_Specific_InfoList_Response(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoList_Response(tvb, offset, pinfo, tree, hf_rnsap_hSDSCH_MACdFlow_Specific_InfoList_Response);
}


static const per_sequence_t HSSCCH_FDD_Specific_InfoItem_Response_sequence[] = {
  { "code-Number"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_code_Number },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSSCCH_FDD_Specific_InfoItem_Response(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSSCCH_FDD_Specific_InfoItem_Response, HSSCCH_FDD_Specific_InfoItem_Response_sequence);

  return offset;
}
static int dissect_HSSCCH_FDD_Specific_InfoList_Response_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSCCH_FDD_Specific_InfoItem_Response(tvb, offset, pinfo, tree, hf_rnsap_HSSCCH_FDD_Specific_InfoList_Response_item);
}


static const per_sequence_t HSSCCH_FDD_Specific_InfoList_Response_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSSCCH_FDD_Specific_InfoList_Response_item },
};

static int
dissect_rnsap_HSSCCH_FDD_Specific_InfoList_Response(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSSCCH_FDD_Specific_InfoList_Response, HSSCCH_FDD_Specific_InfoList_Response_sequence_of,
                                                  0, 4);

  return offset;
}
static int dissect_hSSCCH_Specific_InfoList_Response(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSCCH_FDD_Specific_InfoList_Response(tvb, offset, pinfo, tree, hf_rnsap_hSSCCH_Specific_InfoList_Response);
}



static int
dissect_rnsap_Measurement_Power_Offset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -12, 26U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_measurement_Power_Offset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Measurement_Power_Offset(tvb, offset, pinfo, tree, hf_rnsap_measurement_Power_Offset);
}


static const per_sequence_t HSDSCH_FDD_Information_Response_sequence[] = {
  { "hSDSCH-MACdFlow-Specific-InfoList-Response", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSDSCH_MACdFlow_Specific_InfoList_Response },
  { "hSSCCH-Specific-InfoList-Response", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSSCCH_Specific_InfoList_Response },
  { "hSPDSCH-and-HSSCCH-ScramblingCode", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSPDSCH_and_HSSCCH_ScramblingCode },
  { "measurement-Power-Offset"    , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_measurement_Power_Offset },
  { "hARQ-MemoryPartitioning"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hARQ_MemoryPartitioning },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_FDD_Information_Response(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_FDD_Information_Response, HSDSCH_FDD_Information_Response_sequence);

  return offset;
}


static const per_sequence_t HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_sequence[] = {
  { "hSDSCH-MACdFlow-ID"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSDSCH_MACdFlow_ID },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_allocationRetentionPriority },
  { "transportBearerRequestIndicator", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportBearerRequestIndicator },
  { "trafficClass"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_trafficClass },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoItem_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_MACdFlow_Specific_InfoItem_to_Modify, HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_sequence);

  return offset;
}
static int dissect_HSDSCH_MACdFlow_Specific_InfoList_to_Modify_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoItem_to_Modify(tvb, offset, pinfo, tree, hf_rnsap_HSDSCH_MACdFlow_Specific_InfoList_to_Modify_item);
}


static const per_sequence_t HSDSCH_MACdFlow_Specific_InfoList_to_Modify_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSDSCH_MACdFlow_Specific_InfoList_to_Modify_item },
};

static int
dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoList_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSDSCH_MACdFlow_Specific_InfoList_to_Modify, HSDSCH_MACdFlow_Specific_InfoList_to_Modify_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_hSDSCH_MACdFlow_Specific_InfoList_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlow_Specific_InfoList_to_Modify(tvb, offset, pinfo, tree, hf_rnsap_hSDSCH_MACdFlow_Specific_InfoList_to_Modify);
}


static const per_sequence_t PriorityQueue_InfoItem_to_Add_sequence[] = {
  { "priorityQueue-Id"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_priorityQueue_Id },
  { "associatedHSDSCH-MACdFlow"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_associatedHSDSCH_MACdFlow },
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_schedulingPriorityIndicator },
  { "t1"                          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_t1 },
  { "discardTimer"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_discardTimer },
  { "mAC-hsWindowSize"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mAC_hsWindowSize },
  { "mAChsGuaranteedBitRate"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mAChsGuaranteedBitRate },
  { "mACdPDU-Size-Index"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mACdPDU_Size_Index },
  { "rLC-Mode"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rLC_Mode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PriorityQueue_InfoItem_to_Add(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PriorityQueue_InfoItem_to_Add, PriorityQueue_InfoItem_to_Add_sequence);

  return offset;
}
static int dissect_addPriorityQueue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityQueue_InfoItem_to_Add(tvb, offset, pinfo, tree, hf_rnsap_addPriorityQueue);
}


static const per_sequence_t MACdPDU_Size_IndexItem_to_Modify_sequence[] = {
  { "sID"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sID },
  { "mACdPDU-Size"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mACdPDU_Size },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_MACdPDU_Size_IndexItem_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_MACdPDU_Size_IndexItem_to_Modify, MACdPDU_Size_IndexItem_to_Modify_sequence);

  return offset;
}
static int dissect_MACdPDU_Size_IndexList_to_Modify_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MACdPDU_Size_IndexItem_to_Modify(tvb, offset, pinfo, tree, hf_rnsap_MACdPDU_Size_IndexList_to_Modify_item);
}


static const per_sequence_t MACdPDU_Size_IndexList_to_Modify_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_MACdPDU_Size_IndexList_to_Modify_item },
};

static int
dissect_rnsap_MACdPDU_Size_IndexList_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_MACdPDU_Size_IndexList_to_Modify, MACdPDU_Size_IndexList_to_Modify_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_mACdPDU_Size_Index_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_MACdPDU_Size_IndexList_to_Modify(tvb, offset, pinfo, tree, hf_rnsap_mACdPDU_Size_Index_to_Modify);
}


static const per_sequence_t PriorityQueue_InfoItem_to_Modify_sequence[] = {
  { "priorityQueue-Id"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_priorityQueue_Id },
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_schedulingPriorityIndicator },
  { "t1"                          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_t1 },
  { "discardTimer"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_discardTimer },
  { "mAC-hsWindowSize"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mAC_hsWindowSize },
  { "mAChsGuaranteedBitRate"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mAChsGuaranteedBitRate },
  { "mACdPDU-Size-Index-to-Modify", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mACdPDU_Size_Index_to_Modify },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PriorityQueue_InfoItem_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PriorityQueue_InfoItem_to_Modify, PriorityQueue_InfoItem_to_Modify_sequence);

  return offset;
}
static int dissect_modifyPriorityQueue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityQueue_InfoItem_to_Modify(tvb, offset, pinfo, tree, hf_rnsap_modifyPriorityQueue);
}


static const value_string rnsap_ModifyPriorityQueue_vals[] = {
  {   0, "addPriorityQueue" },
  {   1, "modifyPriorityQueue" },
  {   2, "deletePriorityQueue" },
  { 0, NULL }
};

static const per_choice_t ModifyPriorityQueue_choice[] = {
  {   0, "addPriorityQueue"            , ASN1_EXTENSION_ROOT    , dissect_addPriorityQueue },
  {   1, "modifyPriorityQueue"         , ASN1_EXTENSION_ROOT    , dissect_modifyPriorityQueue },
  {   2, "deletePriorityQueue"         , ASN1_EXTENSION_ROOT    , dissect_deletePriorityQueue },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_ModifyPriorityQueue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_ModifyPriorityQueue, ModifyPriorityQueue_choice,
                                 NULL);

  return offset;
}
static int dissect_PriorityQueue_InfoList_to_Modify_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ModifyPriorityQueue(tvb, offset, pinfo, tree, hf_rnsap_PriorityQueue_InfoList_to_Modify_item);
}


static const per_sequence_t PriorityQueue_InfoList_to_Modify_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_PriorityQueue_InfoList_to_Modify_item },
};

static int
dissect_rnsap_PriorityQueue_InfoList_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_PriorityQueue_InfoList_to_Modify, PriorityQueue_InfoList_to_Modify_sequence_of,
                                                  1, 8);

  return offset;
}
static int dissect_priorityQueue_Info_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityQueue_InfoList_to_Modify(tvb, offset, pinfo, tree, hf_rnsap_priorityQueue_Info_to_Modify);
}


static const value_string rnsap_HSSCCH_Code_Change_Grant_vals[] = {
  {   0, "changeGranted" },
  { 0, NULL }
};


static int
dissect_rnsap_HSSCCH_Code_Change_Grant(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}
static int dissect_hSSCCH_CodeChangeGrant(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSCCH_Code_Change_Grant(tvb, offset, pinfo, tree, hf_rnsap_hSSCCH_CodeChangeGrant);
}



static int
dissect_rnsap_TDD_AckNack_Power_Offset(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -7, 8U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_tDDAckNackPowerOffset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_AckNack_Power_Offset(tvb, offset, pinfo, tree, hf_rnsap_tDDAckNackPowerOffset);
}
static int dissect_tDD_AckNack_Power_Offset(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TDD_AckNack_Power_Offset(tvb, offset, pinfo, tree, hf_rnsap_tDD_AckNack_Power_Offset);
}


static const per_sequence_t HSDSCH_Information_to_Modify_sequence[] = {
  { "hSDSCH-MACdFlow-Specific-InfoList-to-Modify", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSDSCH_MACdFlow_Specific_InfoList_to_Modify },
  { "priorityQueue-Info-to-Modify", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_priorityQueue_Info_to_Modify },
  { "mAChs-Reordering-Buffer-Size-for-RLC-UM", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mAChs_Reordering_Buffer_Size_for_RLC_UM },
  { "cqiFeedback-CycleK"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cqiFeedback_CycleK },
  { "cqiRepetitionFactor"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cqiRepetitionFactor },
  { "ackNackRepetitionFactor"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ackNackRepetitionFactor },
  { "cqiPowerOffset"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cqiPowerOffset },
  { "ackPowerOffset"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ackPowerOffset },
  { "nackPowerOffset"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_nackPowerOffset },
  { "hsscch-PowerOffset"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hsscch_PowerOffset },
  { "hSSCCH-CodeChangeGrant"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSSCCH_CodeChangeGrant },
  { "tDDAckNackPowerOffset"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDDAckNackPowerOffset },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_Information_to_Modify(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_Information_to_Modify, HSDSCH_Information_to_Modify_sequence);

  return offset;
}


static const per_sequence_t PriorityQueue_InfoItem_to_Modify_Unsynchronised_sequence[] = {
  { "priorityQueueId"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_priorityQueueId },
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_schedulingPriorityIndicator },
  { "discardTimer"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_discardTimer },
  { "mAChsGuaranteedBitRate"      , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_mAChsGuaranteedBitRate },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PriorityQueue_InfoItem_to_Modify_Unsynchronised(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PriorityQueue_InfoItem_to_Modify_Unsynchronised, PriorityQueue_InfoItem_to_Modify_Unsynchronised_sequence);

  return offset;
}
static int dissect_PriorityQueue_InfoList_to_Modify_Unsynchronised_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityQueue_InfoItem_to_Modify_Unsynchronised(tvb, offset, pinfo, tree, hf_rnsap_PriorityQueue_InfoList_to_Modify_Unsynchronised_item);
}


static const per_sequence_t PriorityQueue_InfoList_to_Modify_Unsynchronised_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_PriorityQueue_InfoList_to_Modify_Unsynchronised_item },
};

static int
dissect_rnsap_PriorityQueue_InfoList_to_Modify_Unsynchronised(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_PriorityQueue_InfoList_to_Modify_Unsynchronised, PriorityQueue_InfoList_to_Modify_Unsynchronised_sequence_of,
                                                  0, 8);

  return offset;
}
static int dissect_priorityQueueInfotoModifyUnsynchronised(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PriorityQueue_InfoList_to_Modify_Unsynchronised(tvb, offset, pinfo, tree, hf_rnsap_priorityQueueInfotoModifyUnsynchronised);
}


static const per_sequence_t HSDSCH_Information_to_Modify_Unsynchronised_sequence[] = {
  { "hSDSCH-MACdFlow-Specific-InfoList-to-Modify", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSDSCH_MACdFlow_Specific_InfoList_to_Modify },
  { "priorityQueueInfotoModifyUnsynchronised", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_priorityQueueInfotoModifyUnsynchronised },
  { "cqiPowerOffset"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cqiPowerOffset },
  { "ackPowerOffset"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ackPowerOffset },
  { "nackPowerOffset"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_nackPowerOffset },
  { "hsscch-PowerOffset"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hsscch_PowerOffset },
  { "tDDAckNackPowerOffset"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDDAckNackPowerOffset },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_Information_to_Modify_Unsynchronised(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_Information_to_Modify_Unsynchronised, HSDSCH_Information_to_Modify_Unsynchronised_sequence);

  return offset;
}


static const per_sequence_t HSDSCH_MACdFlows_to_Delete_Item_sequence[] = {
  { "hsDSCH-MACdFlow-ID"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hsDSCH_MACdFlow_ID },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_MACdFlows_to_Delete_Item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_MACdFlows_to_Delete_Item, HSDSCH_MACdFlows_to_Delete_Item_sequence);

  return offset;
}
static int dissect_HSDSCH_MACdFlows_to_Delete_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSDSCH_MACdFlows_to_Delete_Item(tvb, offset, pinfo, tree, hf_rnsap_HSDSCH_MACdFlows_to_Delete_item);
}


static const per_sequence_t HSDSCH_MACdFlows_to_Delete_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSDSCH_MACdFlows_to_Delete_item },
};

static int
dissect_rnsap_HSDSCH_MACdFlows_to_Delete(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSDSCH_MACdFlows_to_Delete, HSDSCH_MACdFlows_to_Delete_sequence_of,
                                                  1, 8);

  return offset;
}



static int
dissect_rnsap_HSDSCH_RNTI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 65535U, NULL, NULL, FALSE);

  return offset;
}


static const per_sequence_t HSDSCH_TDD_Information_sequence[] = {
  { "hSDSCH-MACdFlows-Information", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSDSCH_MACdFlows_Information },
  { "uE-Capabilities-Info"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uE_Capabilities_Info },
  { "mAChs-Reordering-Buffer-Size-for-RLC-UM", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mAChs_Reordering_Buffer_Size_for_RLC_UM },
  { "tDD-AckNack-Power-Offset"    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_AckNack_Power_Offset },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_TDD_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_TDD_Information, HSDSCH_TDD_Information_sequence);

  return offset;
}


static const per_sequence_t HSSICH_Info_sequence[] = {
  { "hsSICH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hsSICH_ID },
  { "timeslot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeslot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftAndBurstType },
  { "tDD-ChannelisationCode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_ChannelisationCode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSSICH_Info(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSSICH_Info, HSSICH_Info_sequence);

  return offset;
}
static int dissect_hSSICH_Info(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSICH_Info(tvb, offset, pinfo, tree, hf_rnsap_hSSICH_Info);
}


static const per_sequence_t HSSCCH_TDD_Specific_InfoItem_Response_sequence[] = {
  { "timeslot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeslot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftAndBurstType },
  { "tDD-ChannelisationCode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_ChannelisationCode },
  { "hSSICH-Info"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSSICH_Info },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSSCCH_TDD_Specific_InfoItem_Response(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSSCCH_TDD_Specific_InfoItem_Response, HSSCCH_TDD_Specific_InfoItem_Response_sequence);

  return offset;
}
static int dissect_HSSCCH_TDD_Specific_InfoList_Response_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSCCH_TDD_Specific_InfoItem_Response(tvb, offset, pinfo, tree, hf_rnsap_HSSCCH_TDD_Specific_InfoList_Response_item);
}


static const per_sequence_t HSSCCH_TDD_Specific_InfoList_Response_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSSCCH_TDD_Specific_InfoList_Response_item },
};

static int
dissect_rnsap_HSSCCH_TDD_Specific_InfoList_Response(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSSCCH_TDD_Specific_InfoList_Response, HSSCCH_TDD_Specific_InfoList_Response_sequence_of,
                                                  0, 4);

  return offset;
}
static int dissect_hSSCCH_TDD_Specific_InfoList_Response(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSCCH_TDD_Specific_InfoList_Response(tvb, offset, pinfo, tree, hf_rnsap_hSSCCH_TDD_Specific_InfoList_Response);
}


static const per_sequence_t HSSICH_InfoLCR_sequence[] = {
  { "hsSICH-ID"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hsSICH_ID },
  { "timeslotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeslotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftLCR },
  { "tDD-ChannelisationCode"      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tDD_ChannelisationCode },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSSICH_InfoLCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSSICH_InfoLCR, HSSICH_InfoLCR_sequence);

  return offset;
}
static int dissect_hSSICH_InfoLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSICH_InfoLCR(tvb, offset, pinfo, tree, hf_rnsap_hSSICH_InfoLCR);
}


static const per_sequence_t HSSCCH_TDD_Specific_InfoItem_Response_LCR_sequence[] = {
  { "timeslotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeslotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftLCR },
  { "first-TDD-ChannelisationCode", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_first_TDD_ChannelisationCode },
  { "second-TDD-ChannelisationCode", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_second_TDD_ChannelisationCode },
  { "hSSICH-InfoLCR"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_hSSICH_InfoLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSSCCH_TDD_Specific_InfoItem_Response_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSSCCH_TDD_Specific_InfoItem_Response_LCR, HSSCCH_TDD_Specific_InfoItem_Response_LCR_sequence);

  return offset;
}
static int dissect_HSSCCH_TDD_Specific_InfoList_Response_LCR_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSCCH_TDD_Specific_InfoItem_Response_LCR(tvb, offset, pinfo, tree, hf_rnsap_HSSCCH_TDD_Specific_InfoList_Response_LCR_item);
}


static const per_sequence_t HSSCCH_TDD_Specific_InfoList_Response_LCR_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSSCCH_TDD_Specific_InfoList_Response_LCR_item },
};

static int
dissect_rnsap_HSSCCH_TDD_Specific_InfoList_Response_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSSCCH_TDD_Specific_InfoList_Response_LCR, HSSCCH_TDD_Specific_InfoList_Response_LCR_sequence_of,
                                                  0, 4);

  return offset;
}
static int dissect_hSSCCH_TDD_Specific_InfoList_Response_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSCCH_TDD_Specific_InfoList_Response_LCR(tvb, offset, pinfo, tree, hf_rnsap_hSSCCH_TDD_Specific_InfoList_Response_LCR);
}


static const per_sequence_t HSPDSCH_TDD_Specific_InfoItem_Response_sequence[] = {
  { "timeslot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeslot },
  { "midambleShiftAndBurstType"   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftAndBurstType },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSPDSCH_TDD_Specific_InfoItem_Response(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSPDSCH_TDD_Specific_InfoItem_Response, HSPDSCH_TDD_Specific_InfoItem_Response_sequence);

  return offset;
}
static int dissect_HSPDSCH_TDD_Specific_InfoList_Response_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSPDSCH_TDD_Specific_InfoItem_Response(tvb, offset, pinfo, tree, hf_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_item);
}


static const per_sequence_t HSPDSCH_TDD_Specific_InfoList_Response_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSPDSCH_TDD_Specific_InfoList_Response_item },
};

static int
dissect_rnsap_HSPDSCH_TDD_Specific_InfoList_Response(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSPDSCH_TDD_Specific_InfoList_Response, HSPDSCH_TDD_Specific_InfoList_Response_sequence_of,
                                                  0, 15);

  return offset;
}
static int dissect_hSPDSCH_TDD_Specific_InfoList_Response(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSPDSCH_TDD_Specific_InfoList_Response(tvb, offset, pinfo, tree, hf_rnsap_hSPDSCH_TDD_Specific_InfoList_Response);
}


static const per_sequence_t HSPDSCH_TDD_Specific_InfoItem_Response_LCR_sequence[] = {
  { "timeslotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeslotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_midambleShiftLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSPDSCH_TDD_Specific_InfoItem_Response_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSPDSCH_TDD_Specific_InfoItem_Response_LCR, HSPDSCH_TDD_Specific_InfoItem_Response_LCR_sequence);

  return offset;
}
static int dissect_HSPDSCH_TDD_Specific_InfoList_Response_LCR_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSPDSCH_TDD_Specific_InfoItem_Response_LCR(tvb, offset, pinfo, tree, hf_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_LCR_item);
}


static const per_sequence_t HSPDSCH_TDD_Specific_InfoList_Response_LCR_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_HSPDSCH_TDD_Specific_InfoList_Response_LCR_item },
};

static int
dissect_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_LCR, HSPDSCH_TDD_Specific_InfoList_Response_LCR_sequence_of,
                                                  1, 6);

  return offset;
}
static int dissect_hSPDSCH_TDD_Specific_InfoList_Response_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_LCR(tvb, offset, pinfo, tree, hf_rnsap_hSPDSCH_TDD_Specific_InfoList_Response_LCR);
}


static const per_sequence_t HSDSCH_TDD_Information_Response_sequence[] = {
  { "hSDSCH-MACdFlow-Specific-InfoList-Response", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSDSCH_MACdFlow_Specific_InfoList_Response },
  { "hSSCCH-TDD-Specific-InfoList-Response", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSSCCH_TDD_Specific_InfoList_Response },
  { "hSSCCH-TDD-Specific-InfoList-Response-LCR", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSSCCH_TDD_Specific_InfoList_Response_LCR },
  { "hSPDSCH-TDD-Specific-InfoList-Response", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSPDSCH_TDD_Specific_InfoList_Response },
  { "hSPDSCH-TDD-Specific-InfoList-Response-LCR", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hSPDSCH_TDD_Specific_InfoList_Response_LCR },
  { "hARQ-MemoryPartitioning"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hARQ_MemoryPartitioning },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_TDD_Information_Response(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_TDD_Information_Response, HSDSCH_TDD_Information_Response_sequence);

  return offset;
}



static int
dissect_rnsap_HS_SICH_failed(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 20U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_failed_HS_SICH(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HS_SICH_failed(tvb, offset, pinfo, tree, hf_rnsap_failed_HS_SICH);
}



static int
dissect_rnsap_HS_SICH_missed(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 20U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_missed_HS_SICH(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HS_SICH_missed(tvb, offset, pinfo, tree, hf_rnsap_missed_HS_SICH);
}



static int
dissect_rnsap_HS_SICH_total(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 20U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_total_HS_SICH(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HS_SICH_total(tvb, offset, pinfo, tree, hf_rnsap_total_HS_SICH);
}


static const per_sequence_t HS_SICH_Reception_Quality_Value_sequence[] = {
  { "failed-HS-SICH"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_failed_HS_SICH },
  { "missed-HS-SICH"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_missed_HS_SICH },
  { "total-HS-SICH"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_total_HS_SICH },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HS_SICH_Reception_Quality_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HS_SICH_Reception_Quality_Value, HS_SICH_Reception_Quality_Value_sequence);

  return offset;
}



static int
dissect_rnsap_HS_SICH_Reception_Quality_Measurement_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 20U, NULL, NULL, FALSE);

  return offset;
}


static const value_string rnsap_HSSCCH_CodeChangeIndicator_vals[] = {
  {   0, "hsSCCHCodeChangeNeeded" },
  { 0, NULL }
};


static int
dissect_rnsap_HSSCCH_CodeChangeIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}
static int dissect_hsSCCHCodeChangeIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_HSSCCH_CodeChangeIndicator(tvb, offset, pinfo, tree, hf_rnsap_hsSCCHCodeChangeIndicator);
}


static const per_sequence_t HSDSCH_FDD_Update_Information_sequence[] = {
  { "hsSCCHCodeChangeIndicator"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hsSCCHCodeChangeIndicator },
  { "cqiFeedback-CycleK"          , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cqiFeedback_CycleK },
  { "cqiRepetitionFactor"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cqiRepetitionFactor },
  { "ackNackRepetitionFactor"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ackNackRepetitionFactor },
  { "cqiPowerOffset"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cqiPowerOffset },
  { "ackPowerOffset"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_ackPowerOffset },
  { "nackPowerOffset"             , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_nackPowerOffset },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_FDD_Update_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_FDD_Update_Information, HSDSCH_FDD_Update_Information_sequence);

  return offset;
}


static const per_sequence_t HSDSCH_TDD_Update_Information_sequence[] = {
  { "hsSCCHCodeChangeIndicator"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_hsSCCHCodeChangeIndicator },
  { "tDDAckNackPowerOffset"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tDDAckNackPowerOffset },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_HSDSCH_TDD_Update_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_HSDSCH_TDD_Update_Information, HSDSCH_TDD_Update_Information_sequence);

  return offset;
}



static int
dissect_rnsap_IMEI(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       8, 8, NULL);

  return offset;
}
static int dissect_imei(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IMEI(tvb, offset, pinfo, tree, hf_rnsap_imei);
}



static int
dissect_rnsap_IMEISV(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       8, 8, NULL);

  return offset;
}
static int dissect_imeisv(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IMEISV(tvb, offset, pinfo, tree, hf_rnsap_imeisv);
}



static int
dissect_rnsap_InformationExchangeID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 1048575U, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_INTEGER_1_24_(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 24U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_hour(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_24_(tvb, offset, pinfo, tree, hf_rnsap_hour);
}


static const value_string rnsap_InformationReportPeriodicity_vals[] = {
  {   0, "min" },
  {   1, "hour" },
  { 0, NULL }
};

static const per_choice_t InformationReportPeriodicity_choice[] = {
  {   0, "min"                         , ASN1_EXTENSION_ROOT    , dissect_min },
  {   1, "hour"                        , ASN1_EXTENSION_ROOT    , dissect_hour },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_InformationReportPeriodicity(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_InformationReportPeriodicity, InformationReportPeriodicity_choice,
                                 NULL);

  return offset;
}
static int dissect_informationReportPeriodicity(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_InformationReportPeriodicity(tvb, offset, pinfo, tree, hf_rnsap_informationReportPeriodicity);
}


static const per_sequence_t PeriodicInformation_sequence[] = {
  { "informationReportPeriodicity", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_informationReportPeriodicity },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_PeriodicInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_PeriodicInformation, PeriodicInformation_sequence);

  return offset;
}
static int dissect_periodic(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PeriodicInformation(tvb, offset, pinfo, tree, hf_rnsap_periodic);
}


static const value_string rnsap_InformationThreshold_vals[] = {
  {   0, "dGPSThreshold" },
  { 0, NULL }
};

static const per_choice_t InformationThreshold_choice[] = {
  {   0, "dGPSThreshold"               , ASN1_EXTENSION_ROOT    , dissect_dGPSThreshold },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_InformationThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_InformationThreshold, InformationThreshold_choice,
                                 NULL);

  return offset;
}
static int dissect_informationThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_InformationThreshold(tvb, offset, pinfo, tree, hf_rnsap_informationThreshold);
}


static const per_sequence_t OnModificationInformation_sequence[] = {
  { "informationThreshold"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_informationThreshold },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_OnModificationInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_OnModificationInformation, OnModificationInformation_sequence);

  return offset;
}
static int dissect_onModification(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_OnModificationInformation(tvb, offset, pinfo, tree, hf_rnsap_onModification);
}


static const value_string rnsap_InformationReportCharacteristics_vals[] = {
  {   0, "onDemand" },
  {   1, "periodic" },
  {   2, "onModification" },
  { 0, NULL }
};

static const per_choice_t InformationReportCharacteristics_choice[] = {
  {   0, "onDemand"                    , ASN1_EXTENSION_ROOT    , dissect_onDemand },
  {   1, "periodic"                    , ASN1_EXTENSION_ROOT    , dissect_periodic },
  {   2, "onModification"              , ASN1_EXTENSION_ROOT    , dissect_onModification },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_InformationReportCharacteristics(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_InformationReportCharacteristics, InformationReportCharacteristics_choice,
                                 NULL);

  return offset;
}


static const value_string rnsap_T_informationTypeItem_vals[] = {
  {   0, "gA-AccessPointPositionwithAltitude" },
  {   1, "gA-AccessPointPosition" },
  {   2, "iPDLParameters" },
  {   3, "gPSInformation" },
  {   4, "dGPSCorrections" },
  {   5, "gPS-RX-POS" },
  {   6, "sFNSFN-GA-AccessPointPosition" },
  {   7, "cell-Capacity-Class" },
  {   7, "nACC-Related-Data" },
  {   7, "mBMSBearerServiceFullAddress" },
  { 0, NULL }
};


static int
dissect_rnsap_T_informationTypeItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 7, NULL, NULL, TRUE);

  return offset;
}
static int dissect_informationTypeItem(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_informationTypeItem(tvb, offset, pinfo, tree, hf_rnsap_informationTypeItem);
}


static const per_sequence_t InformationType_sequence[] = {
  { "informationTypeItem"         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_informationTypeItem },
  { "gPSInformation"              , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_gPSInformation },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_InformationType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_InformationType, InformationType_sequence);

  return offset;
}


static const value_string rnsap_IPSub_vals[] = {
  {   0, "first" },
  {   1, "second" },
  {   2, "both" },
  { 0, NULL }
};


static int
dissect_rnsap_IPSub(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, FALSE);

  return offset;
}
static int dissect_iPSub(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_IPSub(tvb, offset, pinfo, tree, hf_rnsap_iPSub);
}


static const per_sequence_t IPDL_TDD_ParametersLCR_sequence[] = {
  { "iPSpacingTDD"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iPSpacingTDD },
  { "iPStart"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iPStart },
  { "iPSub"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_iPSub },
  { "burstModeParameters"         , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_burstModeParameters },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_IPDL_TDD_ParametersLCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_IPDL_TDD_ParametersLCR, IPDL_TDD_ParametersLCR_sequence);

  return offset;
}



static int
dissect_rnsap_Load_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 100U, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_Load_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 100U, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_MaxNrDLPhysicalchannelsTS(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 16U, NULL, NULL, FALSE);

  return offset;
}


static const per_sequence_t MBMS_Bearer_Service_List_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_MBMS_Bearer_Service_List_item },
};

static int
dissect_rnsap_MBMS_Bearer_Service_List(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_MBMS_Bearer_Service_List, MBMS_Bearer_Service_List_sequence_of,
                                                  1, 128);

  return offset;
}



static int
dissect_rnsap_MeasurementRecoveryBehavior(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_null(tvb, offset, pinfo, tree, hf_index);

  return offset;
}



static int
dissect_rnsap_MeasurementRecoveryReportingIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_null(tvb, offset, pinfo, tree, hf_index);

  return offset;
}



static int
dissect_rnsap_MeasurementRecoverySupportIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_null(tvb, offset, pinfo, tree, hf_index);

  return offset;
}


static const value_string rnsap_MAChs_ResetIndicator_vals[] = {
  {   0, "mAChs-NotReset" },
  { 0, NULL }
};


static int
dissect_rnsap_MAChs_ResetIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}


static const per_sequence_t NACC_Related_Data_sequence[] = {
  { "gERAN-SI-Type"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_gERAN_SI_Type },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_NACC_Related_Data(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_NACC_Related_Data, NACC_Related_Data_sequence);

  return offset;
}


static const per_sequence_t Neighbouring_GSM_CellInformationItem_sequence[] = {
  { "cGI"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cGI },
  { "cellIndividualOffset"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cellIndividualOffset },
  { "bSIC"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_bSIC },
  { "band-Indicator"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_band_Indicator },
  { "bCCH-ARFCN"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_bCCH_ARFCN },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Neighbouring_GSM_CellInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Neighbouring_GSM_CellInformationItem, Neighbouring_GSM_CellInformationItem_sequence);

  return offset;
}
static int dissect_Neighbouring_GSM_CellInformationIEs_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Neighbouring_GSM_CellInformationItem(tvb, offset, pinfo, tree, hf_rnsap_Neighbouring_GSM_CellInformationIEs_item);
}


static const per_sequence_t Neighbouring_GSM_CellInformationIEs_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Neighbouring_GSM_CellInformationIEs_item },
};

static int
dissect_rnsap_Neighbouring_GSM_CellInformationIEs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Neighbouring_GSM_CellInformationIEs, Neighbouring_GSM_CellInformationIEs_sequence_of,
                                                  1, 256);

  return offset;
}


static const per_sequence_t NeighbouringTDDCellMeasurementInformationLCR_sequence[] = {
  { "uC-ID"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uC_ID },
  { "uARFCN"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uARFCN },
  { "cellParameterID"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cellParameterID },
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_timeSlotLCR },
  { "midambleShiftLCR"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_midambleShiftLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_NeighbouringTDDCellMeasurementInformationLCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_NeighbouringTDDCellMeasurementInformationLCR, NeighbouringTDDCellMeasurementInformationLCR_sequence);

  return offset;
}


static const value_string rnsap_RestrictionStateIndicator_vals[] = {
  {   0, "cellNotResevedForOperatorUse" },
  {   1, "cellResevedForOperatorUse" },
  { 0, NULL }
};


static int
dissect_rnsap_RestrictionStateIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_restrictionStateIndicator(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RestrictionStateIndicator(tvb, offset, pinfo, tree, hf_rnsap_restrictionStateIndicator);
}


static const per_sequence_t Neighbouring_LCR_TDD_CellInformationItem_sequence[] = {
  { "c-ID"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_c_ID },
  { "uARFCNforNt"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uARFCNforNt },
  { "frameOffset"                 , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_frameOffset },
  { "cellParameterID"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_cellParameterID },
  { "sCTD-Indicator"              , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sCTD_Indicator },
  { "cellIndividualOffset"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_cellIndividualOffset },
  { "dPCHConstantValue"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_dPCHConstantValue },
  { "pCCPCH-Power"                , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_pCCPCH_Power },
  { "restrictionStateIndicator"   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_restrictionStateIndicator },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Neighbouring_LCR_TDD_CellInformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Neighbouring_LCR_TDD_CellInformationItem, Neighbouring_LCR_TDD_CellInformationItem_sequence);

  return offset;
}
static int dissect_Neighbouring_LCR_TDD_CellInformation_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Neighbouring_LCR_TDD_CellInformationItem(tvb, offset, pinfo, tree, hf_rnsap_Neighbouring_LCR_TDD_CellInformation_item);
}


static const per_sequence_t Neighbouring_LCR_TDD_CellInformation_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Neighbouring_LCR_TDD_CellInformation_item },
};

static int
dissect_rnsap_Neighbouring_LCR_TDD_CellInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Neighbouring_LCR_TDD_CellInformation, Neighbouring_LCR_TDD_CellInformation_sequence_of,
                                                  1, 256);

  return offset;
}


static const per_sequence_t NRTLoadInformationValue_sequence[] = {
  { "uplinkNRTLoadInformationValue", ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_uplinkNRTLoadInformationValue },
  { "downlinkNRTLoadInformationValue", ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_downlinkNRTLoadInformationValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_NRTLoadInformationValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_NRTLoadInformationValue, NRTLoadInformationValue_sequence);

  return offset;
}


static const per_sequence_t OnModification_sequence[] = {
  { "measurementThreshold"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_measurementThreshold },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_OnModification(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_OnModification, OnModification_sequence);

  return offset;
}


static const per_sequence_t Periodic_sequence[] = {
  { "reportPeriodicity"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_reportPeriodicity },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Periodic(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Periodic, Periodic_sequence);

  return offset;
}
static int dissect_periodic1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Periodic(tvb, offset, pinfo, tree, hf_rnsap_periodic1);
}



static int
dissect_rnsap_PredictedSFNSFNDeviationLimit(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 256U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_predictedSFNSFNDeviationLimit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PredictedSFNSFNDeviationLimit(tvb, offset, pinfo, tree, hf_rnsap_predictedSFNSFNDeviationLimit);
}



static int
dissect_rnsap_PredictedTUTRANGPSDeviationLimit(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 256U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_predictedTUTRANGPSDeviationLimit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PredictedTUTRANGPSDeviationLimit(tvb, offset, pinfo, tree, hf_rnsap_predictedTUTRANGPSDeviationLimit);
}


static const value_string rnsap_Primary_CPICH_Usage_For_Channel_Estimation_vals[] = {
  {   0, "primary-CPICH-may-be-used" },
  {   1, "primary-CPICH-shall-not-be-used" },
  { 0, NULL }
};


static int
dissect_rnsap_Primary_CPICH_Usage_For_Channel_Estimation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_PrimaryCCPCH_RSCP_Delta(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -5, -1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_primaryCCPCH_RSCP_Delta(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_PrimaryCCPCH_RSCP_Delta(tvb, offset, pinfo, tree, hf_rnsap_primaryCCPCH_RSCP_Delta);
}



static int
dissect_rnsap_Received_Total_Wideband_Power_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_Received_total_wide_band_power(tvb, offset, pinfo, tree, hf_index);

  return offset;
}



static int
dissect_rnsap_Received_Total_Wideband_Power_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 620U, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_Extension_ReportCharacteristics(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_ReportCharacteristics(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Extension_ReportCharacteristics(tvb, offset, pinfo, tree, hf_rnsap_extension_ReportCharacteristics);
}


static const value_string rnsap_ReportCharacteristics_vals[] = {
  {   0, "onDemand" },
  {   1, "periodic" },
  {   2, "eventA" },
  {   3, "eventB" },
  {   4, "eventC" },
  {   5, "eventD" },
  {   6, "eventE" },
  {   7, "eventF" },
  {   8, "extension-ReportCharacteristics" },
  { 0, NULL }
};

static const per_choice_t ReportCharacteristics_choice[] = {
  {   0, "onDemand"                    , ASN1_EXTENSION_ROOT    , dissect_onDemand },
  {   1, "periodic"                    , ASN1_EXTENSION_ROOT    , dissect_periodic1 },
  {   2, "eventA"                      , ASN1_EXTENSION_ROOT    , dissect_eventA },
  {   3, "eventB"                      , ASN1_EXTENSION_ROOT    , dissect_eventB },
  {   4, "eventC"                      , ASN1_EXTENSION_ROOT    , dissect_eventC },
  {   5, "eventD"                      , ASN1_EXTENSION_ROOT    , dissect_eventD },
  {   6, "eventE"                      , ASN1_EXTENSION_ROOT    , dissect_eventE },
  {   7, "eventF"                      , ASN1_EXTENSION_ROOT    , dissect_eventF },
  {   8, "extension-ReportCharacteristics", ASN1_NOT_EXTENSION_ROOT, dissect_extension_ReportCharacteristics },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_ReportCharacteristics(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_ReportCharacteristics, ReportCharacteristics_choice,
                                 NULL);

  return offset;
}


static const per_sequence_t RL_Specific_EDCH_InfoItem_sequence[] = {
  { "eDCH-MACdFlow-ID"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_eDCH_MACdFlow_ID },
  { "bindingID"                   , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_bindingID },
  { "transportLayerAddress"       , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_transportLayerAddress },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RL_Specific_EDCH_InfoItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RL_Specific_EDCH_InfoItem, RL_Specific_EDCH_InfoItem_sequence);

  return offset;
}
static int dissect_RL_Specific_EDCH_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_RL_Specific_EDCH_InfoItem(tvb, offset, pinfo, tree, hf_rnsap_RL_Specific_EDCH_Information_item);
}


static const per_sequence_t RL_Specific_EDCH_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_RL_Specific_EDCH_Information_item },
};

static int
dissect_rnsap_RL_Specific_EDCH_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_RL_Specific_EDCH_Information, RL_Specific_EDCH_Information_sequence_of,
                                                  1, 8);

  return offset;
}


static const per_sequence_t RTLoadValue_sequence[] = {
  { "uplinkRTLoadValue"           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_uplinkRTLoadValue },
  { "downlinkRTLoadValue"         , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_downlinkRTLoadValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_RTLoadValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_RTLoadValue, RTLoadValue_sequence);

  return offset;
}



static int
dissect_rnsap_Rx_Timing_Deviation_Value_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 511U, NULL, NULL, FALSE);

  return offset;
}


static const per_sequence_t Secondary_CPICH_Information_sequence[] = {
  { "dl-ScramblingCode"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dl_ScramblingCode },
  { "fDD-DL-ChannelisationCodeNumber", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fDD_DL_ChannelisationCodeNumber },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Secondary_CPICH_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Secondary_CPICH_Information, Secondary_CPICH_Information_sequence);

  return offset;
}
static int dissect_new_secondary_CPICH(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Secondary_CPICH_Information(tvb, offset, pinfo, tree, hf_rnsap_new_secondary_CPICH);
}


static const value_string rnsap_Secondary_CPICH_Information_Change_vals[] = {
  {   0, "new-secondary-CPICH" },
  {   1, "secondary-CPICH-shall-not-be-used" },
  { 0, NULL }
};

static const per_choice_t Secondary_CPICH_Information_Change_choice[] = {
  {   0, "new-secondary-CPICH"         , ASN1_EXTENSION_ROOT    , dissect_new_secondary_CPICH },
  {   1, "secondary-CPICH-shall-not-be-used", ASN1_EXTENSION_ROOT    , dissect_secondary_CPICH_shall_not_be_used },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_Secondary_CPICH_Information_Change(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_Secondary_CPICH_Information_Change, Secondary_CPICH_Information_Change_choice,
                                 NULL);

  return offset;
}



static int
dissect_rnsap_SFNSFNChangeLimit(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 256U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_sFNSFNChangeLimit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SFNSFNChangeLimit(tvb, offset, pinfo, tree, hf_rnsap_sFNSFNChangeLimit);
}


static const per_sequence_t SFNSFNMeasurementThresholdInformation_sequence[] = {
  { "sFNSFNChangeLimit"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_sFNSFNChangeLimit },
  { "predictedSFNSFNDeviationLimit", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_predictedSFNSFNDeviationLimit },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_SFNSFNMeasurementThresholdInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_SFNSFNMeasurementThresholdInformation, SFNSFNMeasurementThresholdInformation_sequence);

  return offset;
}



static int
dissect_rnsap_SNACode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 65535U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_ListOfSNAs_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SNACode(tvb, offset, pinfo, tree, hf_rnsap_ListOfSNAs_item);
}


static const per_sequence_t ListOfSNAs_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ListOfSNAs_item },
};

static int
dissect_rnsap_ListOfSNAs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_ListOfSNAs, ListOfSNAs_sequence_of,
                                                  1, 65536);

  return offset;
}
static int dissect_listOfSNAs(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ListOfSNAs(tvb, offset, pinfo, tree, hf_rnsap_listOfSNAs);
}


static const per_sequence_t SNA_Information_sequence[] = {
  { "pLMN-Identity"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_pLMN_Identity },
  { "listOfSNAs"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_listOfSNAs },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_SNA_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_SNA_Information, SNA_Information_sequence);

  return offset;
}


static const value_string rnsap_Support_8PSK_vals[] = {
  {   0, "v8PSK-Supported" },
  { 0, NULL }
};


static int
dissect_rnsap_Support_8PSK(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, FALSE);

  return offset;
}


static const value_string rnsap_T_maxSYNC_UL_transmissions_vals[] = {
  {   0, "v1" },
  {   1, "v2" },
  {   2, "v4" },
  {   3, "v8" },
  { 0, NULL }
};


static int
dissect_rnsap_T_maxSYNC_UL_transmissions(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 3, NULL, NULL, TRUE);

  return offset;
}
static int dissect_maxSYNC_UL_transmissions(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_T_maxSYNC_UL_transmissions(tvb, offset, pinfo, tree, hf_rnsap_maxSYNC_UL_transmissions);
}



static int
dissect_rnsap_INTEGER_0_3_(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 3U, NULL, NULL, TRUE);

  return offset;
}
static int dissect_powerRampStep(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_3_(tvb, offset, pinfo, tree, hf_rnsap_powerRampStep);
}


static const per_sequence_t SYNC_UL_ProcParameters_sequence[] = {
  { "maxSYNC-UL-transmissions"    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_maxSYNC_UL_transmissions },
  { "powerRampStep"               , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_powerRampStep },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_SYNC_UL_ProcParameters(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_SYNC_UL_ProcParameters, SYNC_UL_ProcParameters_sequence);

  return offset;
}
static int dissect_syncUL_procParameter(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SYNC_UL_ProcParameters(tvb, offset, pinfo, tree, hf_rnsap_syncUL_procParameter);
}



static int
dissect_rnsap_TGD(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 269U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tGD(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TGD(tvb, offset, pinfo, tree, hf_rnsap_tGD);
}



static int
dissect_rnsap_TGSN(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 14U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tGSN(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TGSN(tvb, offset, pinfo, tree, hf_rnsap_tGSN);
}


static const value_string rnsap_TraceDepth_vals[] = {
  {   0, "minimum" },
  {   1, "medium" },
  {   2, "maximum" },
  { 0, NULL }
};


static int
dissect_rnsap_TraceDepth(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}



static int
dissect_rnsap_TraceRecordingSessionReference(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 65535U, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_TraceReference(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_octet_string(tvb, offset, pinfo, tree, hf_index,
                                       2, 3, NULL);

  return offset;
}


static const value_string rnsap_UL_DL_mode_vals[] = {
  {   0, "ul-only" },
  {   1, "dl-only" },
  {   2, "both-ul-and-dl" },
  { 0, NULL }
};


static int
dissect_rnsap_UL_DL_mode(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, FALSE);

  return offset;
}
static int dissect_uL_DL_mode(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_DL_mode(tvb, offset, pinfo, tree, hf_rnsap_uL_DL_mode);
}


static const value_string rnsap_Uplink_Compressed_Mode_Method_vals[] = {
  {   0, "sFdiv2" },
  {   1, "higher-layer-scheduling" },
  { 0, NULL }
};


static int
dissect_rnsap_Uplink_Compressed_Mode_Method(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}
static int dissect_uplink_Compressed_Mode_Method(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Uplink_Compressed_Mode_Method(tvb, offset, pinfo, tree, hf_rnsap_uplink_Compressed_Mode_Method);
}


static const per_sequence_t Transmission_Gap_Pattern_Sequence_Information_item_sequence[] = {
  { "tGPSID"                      , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tGPSID },
  { "tGSN"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tGSN },
  { "tGL1"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tGL1 },
  { "tGL2"                        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tGL2 },
  { "tGD"                         , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tGD },
  { "tGPL1"                       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_tGPL1 },
  { "not-to-be-used-1"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_not_to_be_used_1 },
  { "uL-DL-mode"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_DL_mode },
  { "downlink-Compressed-Mode-Method", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_downlink_Compressed_Mode_Method },
  { "uplink-Compressed-Mode-Method", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uplink_Compressed_Mode_Method },
  { "dL-FrameType"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_FrameType },
  { "delta-SIR1"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_delta_SIR1 },
  { "delta-SIR-after1"            , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_delta_SIR_after1 },
  { "delta-SIR2"                  , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_delta_SIR2 },
  { "delta-SIR-after2"            , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_delta_SIR_after2 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_Transmission_Gap_Pattern_Sequence_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_Transmission_Gap_Pattern_Sequence_Information_item, Transmission_Gap_Pattern_Sequence_Information_item_sequence);

  return offset;
}
static int dissect_Transmission_Gap_Pattern_Sequence_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_Transmission_Gap_Pattern_Sequence_Information_item(tvb, offset, pinfo, tree, hf_rnsap_Transmission_Gap_Pattern_Sequence_Information_item);
}


static const per_sequence_t Transmission_Gap_Pattern_Sequence_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_Transmission_Gap_Pattern_Sequence_Information_item },
};

static int
dissect_rnsap_Transmission_Gap_Pattern_Sequence_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_Transmission_Gap_Pattern_Sequence_Information, Transmission_Gap_Pattern_Sequence_Information_sequence_of,
                                                  1, 6);

  return offset;
}



static int
dissect_rnsap_Transmitted_Carrier_Power_Value(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 100U, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_Transmitted_Carrier_Power_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 100U, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_TUTRANGPSChangeLimit(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 256U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_tUTRANGPSChangeLimit(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_TUTRANGPSChangeLimit(tvb, offset, pinfo, tree, hf_rnsap_tUTRANGPSChangeLimit);
}


static const per_sequence_t TUTRANGPSMeasurementThresholdInformation_sequence[] = {
  { "tUTRANGPSChangeLimit"        , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_tUTRANGPSChangeLimit },
  { "predictedTUTRANGPSDeviationLimit", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_predictedTUTRANGPSDeviationLimit },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_TUTRANGPSMeasurementThresholdInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_TUTRANGPSMeasurementThresholdInformation, TUTRANGPSMeasurementThresholdInformation_sequence);

  return offset;
}



static int
dissect_rnsap_TransportBearerID(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 4095U, NULL, NULL, FALSE);

  return offset;
}


static const value_string rnsap_TSTD_Support_Indicator_vals[] = {
  {   0, "tSTD-supported" },
  {   1, "tSTD-not-supported" },
  { 0, NULL }
};


static int
dissect_rnsap_TSTD_Support_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}


static const value_string rnsap_TypeOfError_vals[] = {
  {   0, "not-understood" },
  {   1, "missing" },
  { 0, NULL }
};


static int
dissect_rnsap_TypeOfError(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, TRUE);

  return offset;
}


static const value_string rnsap_UEIdentity_vals[] = {
  {   0, "imsi" },
  {   1, "imei" },
  {   2, "imeisv" },
  { 0, NULL }
};

static const per_choice_t UEIdentity_choice[] = {
  {   0, "imsi"                        , ASN1_EXTENSION_ROOT    , dissect_imsi },
  {   1, "imei"                        , ASN1_EXTENSION_ROOT    , dissect_imei },
  {   2, "imeisv"                      , ASN1_EXTENSION_ROOT    , dissect_imeisv },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_UEIdentity(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_UEIdentity, UEIdentity_choice,
                                 NULL);

  return offset;
}



static int
dissect_rnsap_UEMeasurementHysteresisTime(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 15U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_uEMeasurementHysteresisTime(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementHysteresisTime(tvb, offset, pinfo, tree, hf_rnsap_uEMeasurementHysteresisTime);
}


static const value_string rnsap_UEMeasurementParameterModAllow_vals[] = {
  {   0, "parameterModificationAllowed" },
  { 0, NULL }
};


static int
dissect_rnsap_UEMeasurementParameterModAllow(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 0, NULL, NULL, TRUE);

  return offset;
}


static const value_string rnsap_UEMeasurementReportCharacteristicsPeriodicAmountofReporting_vals[] = {
  {   0, "r1" },
  {   1, "r2" },
  {   2, "r4" },
  {   3, "r8" },
  {   4, "r16" },
  {   5, "r32" },
  {   6, "r64" },
  {   7, "rInfinity" },
  { 0, NULL }
};


static int
dissect_rnsap_UEMeasurementReportCharacteristicsPeriodicAmountofReporting(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 7, NULL, NULL, FALSE);

  return offset;
}
static int dissect_amountofReporting(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementReportCharacteristicsPeriodicAmountofReporting(tvb, offset, pinfo, tree, hf_rnsap_amountofReporting);
}


static const value_string rnsap_UEMeasurementReportCharacteristicsPeriodicReportingInterval_vals[] = {
  {   0, "r250" },
  {   1, "r500" },
  {   2, "r1000" },
  {   3, "r2000" },
  {   4, "r3000" },
  {   5, "r4000" },
  {   6, "r6000" },
  {   7, "r8000" },
  {   8, "r12000" },
  {   9, "r16000" },
  {  10, "r20000" },
  {  11, "r24000" },
  {  12, "r28000" },
  {  13, "r32000" },
  {  14, "r64000" },
  { 0, NULL }
};


static int
dissect_rnsap_UEMeasurementReportCharacteristicsPeriodicReportingInterval(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 14, NULL, NULL, FALSE);

  return offset;
}
static int dissect_reportingInterval(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementReportCharacteristicsPeriodicReportingInterval(tvb, offset, pinfo, tree, hf_rnsap_reportingInterval);
}


static const per_sequence_t UEMeasurementReportCharacteristicsPeriodic_sequence[] = {
  { "amountofReporting"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_amountofReporting },
  { "reportingInterval"           , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_reportingInterval },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementReportCharacteristicsPeriodic(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementReportCharacteristicsPeriodic, UEMeasurementReportCharacteristicsPeriodic_sequence);

  return offset;
}
static int dissect_periodic2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementReportCharacteristicsPeriodic(tvb, offset, pinfo, tree, hf_rnsap_periodic2);
}



static int
dissect_rnsap_UEMeasurementThresholdDLTimeslotISCP(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -115, -25, NULL, NULL, FALSE);

  return offset;
}
static int dissect_timeslotISCP(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementThresholdDLTimeslotISCP(tvb, offset, pinfo, tree, hf_rnsap_timeslotISCP);
}



static int
dissect_rnsap_UEMeasurementThresholdUETransmitPower(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -50, 33U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_uETransmitPower(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementThresholdUETransmitPower(tvb, offset, pinfo, tree, hf_rnsap_uETransmitPower);
}



static int
dissect_rnsap_UEMeasurementThreshold_Extension(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_UEMeasurementThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementThreshold_Extension(tvb, offset, pinfo, tree, hf_rnsap_extension_UEMeasurementThreshold);
}


static const value_string rnsap_UEMeasurementThreshold_vals[] = {
  {   0, "timeslotISCP" },
  {   1, "uETransmitPower" },
  {   2, "extension-UEMeasurementThreshold" },
  { 0, NULL }
};

static const per_choice_t UEMeasurementThreshold_choice[] = {
  {   0, "timeslotISCP"                , ASN1_EXTENSION_ROOT    , dissect_timeslotISCP },
  {   1, "uETransmitPower"             , ASN1_EXTENSION_ROOT    , dissect_uETransmitPower },
  {   2, "extension-UEMeasurementThreshold", ASN1_NOT_EXTENSION_ROOT, dissect_extension_UEMeasurementThreshold },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementThreshold(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_UEMeasurementThreshold, UEMeasurementThreshold_choice,
                                 NULL);

  return offset;
}
static int dissect_uEMeasurementTreshold(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementThreshold(tvb, offset, pinfo, tree, hf_rnsap_uEMeasurementTreshold);
}


static const value_string rnsap_UEMeasurementTimeToTrigger_vals[] = {
  {   0, "r0" },
  {   1, "r10" },
  {   2, "r20" },
  {   3, "r40" },
  {   4, "r60" },
  {   5, "r80" },
  {   6, "r100" },
  {   7, "r120" },
  {   8, "r160" },
  {   9, "r200" },
  {  10, "r240" },
  {  11, "r320" },
  {  12, "r640" },
  {  13, "r1280" },
  {  14, "r2560" },
  {  15, "r5000" },
  { 0, NULL }
};


static int
dissect_rnsap_UEMeasurementTimeToTrigger(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 15, NULL, NULL, FALSE);

  return offset;
}
static int dissect_uEMeasurementTimeToTrigger(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementTimeToTrigger(tvb, offset, pinfo, tree, hf_rnsap_uEMeasurementTimeToTrigger);
}


static const per_sequence_t UEMeasurementReportCharacteristicsEvent1h_sequence[] = {
  { "uEMeasurementTreshold"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementTreshold },
  { "uEMeasurementTimeToTrigger"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementTimeToTrigger },
  { "uEMeasurementHysteresisTime" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementHysteresisTime },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementReportCharacteristicsEvent1h(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementReportCharacteristicsEvent1h, UEMeasurementReportCharacteristicsEvent1h_sequence);

  return offset;
}
static int dissect_event1h(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementReportCharacteristicsEvent1h(tvb, offset, pinfo, tree, hf_rnsap_event1h);
}


static const per_sequence_t UEMeasurementReportCharacteristicsEvent1i_sequence[] = {
  { "uEMeasurementTreshold"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementTreshold },
  { "uEMeasurementTimeToTrigger"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementTimeToTrigger },
  { "uEMeasurementHysteresisTime" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementHysteresisTime },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementReportCharacteristicsEvent1i(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementReportCharacteristicsEvent1i, UEMeasurementReportCharacteristicsEvent1i_sequence);

  return offset;
}
static int dissect_event1i(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementReportCharacteristicsEvent1i(tvb, offset, pinfo, tree, hf_rnsap_event1i);
}


static const per_sequence_t UEMeasurementReportCharacteristicsEvent6a_sequence[] = {
  { "uEMeasurementTreshold"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementTreshold },
  { "uEMeasurementTimeToTrigger"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementTimeToTrigger },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementReportCharacteristicsEvent6a(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementReportCharacteristicsEvent6a, UEMeasurementReportCharacteristicsEvent6a_sequence);

  return offset;
}
static int dissect_event6a(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementReportCharacteristicsEvent6a(tvb, offset, pinfo, tree, hf_rnsap_event6a);
}


static const per_sequence_t UEMeasurementReportCharacteristicsEvent6b_sequence[] = {
  { "uEMeasurementTreshold"       , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementTreshold },
  { "uEMeasurementTimeToTrigger"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementTimeToTrigger },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementReportCharacteristicsEvent6b(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementReportCharacteristicsEvent6b, UEMeasurementReportCharacteristicsEvent6b_sequence);

  return offset;
}
static int dissect_event6b(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementReportCharacteristicsEvent6b(tvb, offset, pinfo, tree, hf_rnsap_event6b);
}


static const per_sequence_t UEMeasurementReportCharacteristicsEvent6c_sequence[] = {
  { "uEMeasurementTimeToTrigger"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementTimeToTrigger },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementReportCharacteristicsEvent6c(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementReportCharacteristicsEvent6c, UEMeasurementReportCharacteristicsEvent6c_sequence);

  return offset;
}
static int dissect_event6c(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementReportCharacteristicsEvent6c(tvb, offset, pinfo, tree, hf_rnsap_event6c);
}


static const per_sequence_t UEMeasurementReportCharacteristicsEvent6d_sequence[] = {
  { "uEMeasurementTimeToTrigger"  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEMeasurementTimeToTrigger },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementReportCharacteristicsEvent6d(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementReportCharacteristicsEvent6d, UEMeasurementReportCharacteristicsEvent6d_sequence);

  return offset;
}
static int dissect_event6d(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementReportCharacteristicsEvent6d(tvb, offset, pinfo, tree, hf_rnsap_event6d);
}



static int
dissect_rnsap_UEMeasurementReportCharacteristics_Extension(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_ReportCharacteristics1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementReportCharacteristics_Extension(tvb, offset, pinfo, tree, hf_rnsap_extension_ReportCharacteristics1);
}


static const value_string rnsap_UEMeasurementReportCharacteristics_vals[] = {
  {   0, "periodic" },
  {   1, "event1h" },
  {   2, "event1i" },
  {   3, "event6a" },
  {   4, "event6b" },
  {   5, "event6c" },
  {   6, "event6d" },
  {   7, "extension-ReportCharacteristics" },
  { 0, NULL }
};

static const per_choice_t UEMeasurementReportCharacteristics_choice[] = {
  {   0, "periodic"                    , ASN1_EXTENSION_ROOT    , dissect_periodic2 },
  {   1, "event1h"                     , ASN1_EXTENSION_ROOT    , dissect_event1h },
  {   2, "event1i"                     , ASN1_EXTENSION_ROOT    , dissect_event1i },
  {   3, "event6a"                     , ASN1_EXTENSION_ROOT    , dissect_event6a },
  {   4, "event6b"                     , ASN1_EXTENSION_ROOT    , dissect_event6b },
  {   5, "event6c"                     , ASN1_EXTENSION_ROOT    , dissect_event6c },
  {   6, "event6d"                     , ASN1_EXTENSION_ROOT    , dissect_event6d },
  {   7, "extension-ReportCharacteristics", ASN1_NOT_EXTENSION_ROOT, dissect_extension_ReportCharacteristics1 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementReportCharacteristics(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_UEMeasurementReportCharacteristics, UEMeasurementReportCharacteristics_choice,
                                 NULL);

  return offset;
}


static const value_string rnsap_UEMeasurementTimeslotInfoHCRBurstType_vals[] = {
  {   0, "type1" },
  {   1, "type2" },
  {   2, "type3" },
  { 0, NULL }
};


static int
dissect_rnsap_UEMeasurementTimeslotInfoHCRBurstType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}
static int dissect_burstType(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementTimeslotInfoHCRBurstType(tvb, offset, pinfo, tree, hf_rnsap_burstType);
}


static const per_sequence_t UEMeasurementTimeslotInfoHCR_IEs_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "burstType"                   , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_burstType },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementTimeslotInfoHCR_IEs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementTimeslotInfoHCR_IEs, UEMeasurementTimeslotInfoHCR_IEs_sequence);

  return offset;
}
static int dissect_UEMeasurementTimeslotInfoHCR_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementTimeslotInfoHCR_IEs(tvb, offset, pinfo, tree, hf_rnsap_UEMeasurementTimeslotInfoHCR_item);
}


static const per_sequence_t UEMeasurementTimeslotInfoHCR_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UEMeasurementTimeslotInfoHCR_item },
};

static int
dissect_rnsap_UEMeasurementTimeslotInfoHCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UEMeasurementTimeslotInfoHCR, UEMeasurementTimeslotInfoHCR_sequence_of,
                                                  1, 15);

  return offset;
}


static const per_sequence_t UEMeasurementTimeslotInfoLCR_IEs_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementTimeslotInfoLCR_IEs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementTimeslotInfoLCR_IEs, UEMeasurementTimeslotInfoLCR_IEs_sequence);

  return offset;
}
static int dissect_UEMeasurementTimeslotInfoLCR_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementTimeslotInfoLCR_IEs(tvb, offset, pinfo, tree, hf_rnsap_UEMeasurementTimeslotInfoLCR_item);
}


static const per_sequence_t UEMeasurementTimeslotInfoLCR_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UEMeasurementTimeslotInfoLCR_item },
};

static int
dissect_rnsap_UEMeasurementTimeslotInfoLCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UEMeasurementTimeslotInfoLCR, UEMeasurementTimeslotInfoLCR_sequence_of,
                                                  1, 6);

  return offset;
}


static const value_string rnsap_UEMeasurementType_vals[] = {
  {   0, "primary-CCPCH-RSCP" },
  {   1, "dL-Timeslot-ISCP" },
  {   2, "uE-Transmitted-power" },
  { 0, NULL }
};


static int
dissect_rnsap_UEMeasurementType(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, TRUE);

  return offset;
}



static int
dissect_rnsap_INTEGER_0_104(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 104U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_uETransmitPower1(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_0_104(tvb, offset, pinfo, tree, hf_rnsap_uETransmitPower1);
}


static const per_sequence_t UEMeasurementValueTransmittedPowerListHCR_IEs_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "uETransmitPower"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uETransmitPower1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementValueTransmittedPowerListHCR_IEs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementValueTransmittedPowerListHCR_IEs, UEMeasurementValueTransmittedPowerListHCR_IEs_sequence);

  return offset;
}
static int dissect_UEMeasurementValueTransmittedPowerListHCR_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValueTransmittedPowerListHCR_IEs(tvb, offset, pinfo, tree, hf_rnsap_UEMeasurementValueTransmittedPowerListHCR_item);
}


static const per_sequence_t UEMeasurementValueTransmittedPowerListHCR_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UEMeasurementValueTransmittedPowerListHCR_item },
};

static int
dissect_rnsap_UEMeasurementValueTransmittedPowerListHCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UEMeasurementValueTransmittedPowerListHCR, UEMeasurementValueTransmittedPowerListHCR_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_uEMeasurementTransmittedPowerListHCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValueTransmittedPowerListHCR(tvb, offset, pinfo, tree, hf_rnsap_uEMeasurementTransmittedPowerListHCR);
}


static const per_sequence_t UEMeasurementValueTransmittedPowerListLCR_IEs_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "uETransmitPower"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uETransmitPower1 },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementValueTransmittedPowerListLCR_IEs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementValueTransmittedPowerListLCR_IEs, UEMeasurementValueTransmittedPowerListLCR_IEs_sequence);

  return offset;
}
static int dissect_UEMeasurementValueTransmittedPowerListLCR_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValueTransmittedPowerListLCR_IEs(tvb, offset, pinfo, tree, hf_rnsap_UEMeasurementValueTransmittedPowerListLCR_item);
}


static const per_sequence_t UEMeasurementValueTransmittedPowerListLCR_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UEMeasurementValueTransmittedPowerListLCR_item },
};

static int
dissect_rnsap_UEMeasurementValueTransmittedPowerListLCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UEMeasurementValueTransmittedPowerListLCR, UEMeasurementValueTransmittedPowerListLCR_sequence_of,
                                                  1, 6);

  return offset;
}
static int dissect_uEMeasurementTransmittedPowerListLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValueTransmittedPowerListLCR(tvb, offset, pinfo, tree, hf_rnsap_uEMeasurementTransmittedPowerListLCR);
}


static const per_sequence_t UE_MeasurementValue_UE_Transmitted_Power_sequence[] = {
  { "uEMeasurementTransmittedPowerListHCR", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uEMeasurementTransmittedPowerListHCR },
  { "uEMeasurementTransmittedPowerListLCR", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uEMeasurementTransmittedPowerListLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UE_MeasurementValue_UE_Transmitted_Power(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UE_MeasurementValue_UE_Transmitted_Power, UE_MeasurementValue_UE_Transmitted_Power_sequence);

  return offset;
}
static int dissect_uE_Transmitted_Power(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UE_MeasurementValue_UE_Transmitted_Power(tvb, offset, pinfo, tree, hf_rnsap_uE_Transmitted_Power);
}


static const per_sequence_t UE_MeasurementValue_Primary_CCPCH_RSCP_sequence[] = {
  { "primaryCCPCH-RSCP"           , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primaryCCPCH_RSCP },
  { "primaryCCPCH-RSCP-Delta"     , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_primaryCCPCH_RSCP_Delta },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UE_MeasurementValue_Primary_CCPCH_RSCP(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UE_MeasurementValue_Primary_CCPCH_RSCP, UE_MeasurementValue_Primary_CCPCH_RSCP_sequence);

  return offset;
}
static int dissect_primary_CCPCH_RSCP(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UE_MeasurementValue_Primary_CCPCH_RSCP(tvb, offset, pinfo, tree, hf_rnsap_primary_CCPCH_RSCP);
}


static const per_sequence_t UEMeasurementValueTimeslotISCPListHCR_IEs_sequence[] = {
  { "timeSlot"                    , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlot },
  { "dL-TimeslotISCP"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_TimeslotISCP },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementValueTimeslotISCPListHCR_IEs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementValueTimeslotISCPListHCR_IEs, UEMeasurementValueTimeslotISCPListHCR_IEs_sequence);

  return offset;
}
static int dissect_UEMeasurementValueTimeslotISCPListHCR_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValueTimeslotISCPListHCR_IEs(tvb, offset, pinfo, tree, hf_rnsap_UEMeasurementValueTimeslotISCPListHCR_item);
}


static const per_sequence_t UEMeasurementValueTimeslotISCPListHCR_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UEMeasurementValueTimeslotISCPListHCR_item },
};

static int
dissect_rnsap_UEMeasurementValueTimeslotISCPListHCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UEMeasurementValueTimeslotISCPListHCR, UEMeasurementValueTimeslotISCPListHCR_sequence_of,
                                                  1, 15);

  return offset;
}
static int dissect_uEMeasurementTimeslotISCPListHCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValueTimeslotISCPListHCR(tvb, offset, pinfo, tree, hf_rnsap_uEMeasurementTimeslotISCPListHCR);
}


static const per_sequence_t UEMeasurementValueTimeslotISCPListLCR_IEs_sequence[] = {
  { "timeSlotLCR"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_timeSlotLCR },
  { "dL-TimeslotISCP"             , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_dL_TimeslotISCP },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementValueTimeslotISCPListLCR_IEs(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementValueTimeslotISCPListLCR_IEs, UEMeasurementValueTimeslotISCPListLCR_IEs_sequence);

  return offset;
}
static int dissect_UEMeasurementValueTimeslotISCPListLCR_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValueTimeslotISCPListLCR_IEs(tvb, offset, pinfo, tree, hf_rnsap_UEMeasurementValueTimeslotISCPListLCR_item);
}


static const per_sequence_t UEMeasurementValueTimeslotISCPListLCR_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_UEMeasurementValueTimeslotISCPListLCR_item },
};

static int
dissect_rnsap_UEMeasurementValueTimeslotISCPListLCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_UEMeasurementValueTimeslotISCPListLCR, UEMeasurementValueTimeslotISCPListLCR_sequence_of,
                                                  1, 6);

  return offset;
}
static int dissect_uEMeasurementTimeslotISCPListLCR(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValueTimeslotISCPListLCR(tvb, offset, pinfo, tree, hf_rnsap_uEMeasurementTimeslotISCPListLCR);
}


static const per_sequence_t UE_MeasurementValue_DL_Timeslot_ISCP_sequence[] = {
  { "uEMeasurementTimeslotISCPListHCR", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uEMeasurementTimeslotISCPListHCR },
  { "uEMeasurementTimeslotISCPListLCR", ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_uEMeasurementTimeslotISCPListLCR },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UE_MeasurementValue_DL_Timeslot_ISCP(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UE_MeasurementValue_DL_Timeslot_ISCP, UE_MeasurementValue_DL_Timeslot_ISCP_sequence);

  return offset;
}
static int dissect_dL_Timeslot_ISCP(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UE_MeasurementValue_DL_Timeslot_ISCP(tvb, offset, pinfo, tree, hf_rnsap_dL_Timeslot_ISCP);
}



static int
dissect_rnsap_UEMeasurementValue_Extension(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_rnsap_ProtocolIE_Single_Container(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_extension_UEMeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValue_Extension(tvb, offset, pinfo, tree, hf_rnsap_extension_UEMeasurementValue);
}


static const value_string rnsap_UEMeasurementValue_vals[] = {
  {   0, "uE-Transmitted-Power" },
  {   1, "primary-CCPCH-RSCP" },
  {   2, "dL-Timeslot-ISCP" },
  {   3, "extension-UEMeasurementValue" },
  { 0, NULL }
};

static const per_choice_t UEMeasurementValue_choice[] = {
  {   0, "uE-Transmitted-Power"        , ASN1_EXTENSION_ROOT    , dissect_uE_Transmitted_Power },
  {   1, "primary-CCPCH-RSCP"          , ASN1_EXTENSION_ROOT    , dissect_primary_CCPCH_RSCP },
  {   2, "dL-Timeslot-ISCP"            , ASN1_EXTENSION_ROOT    , dissect_dL_Timeslot_ISCP },
  {   3, "extension-UEMeasurementValue", ASN1_NOT_EXTENSION_ROOT, dissect_extension_UEMeasurementValue },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_UEMeasurementValue, UEMeasurementValue_choice,
                                 NULL);

  return offset;
}
static int dissect_uEmeasurementValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValue(tvb, offset, pinfo, tree, hf_rnsap_uEmeasurementValue);
}


static const per_sequence_t UEMeasurementValueInformationAvailable_sequence[] = {
  { "uEmeasurementValue"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uEmeasurementValue },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementValueInformationAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UEMeasurementValueInformationAvailable, UEMeasurementValueInformationAvailable_sequence);

  return offset;
}
static int dissect_measurementAvailable2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValueInformationAvailable(tvb, offset, pinfo, tree, hf_rnsap_measurementAvailable2);
}



static int
dissect_rnsap_UEMeasurementValueInformationnotAvailable(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_null(tvb, offset, pinfo, tree, hf_index);

  return offset;
}
static int dissect_measurementnotAvailable2(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UEMeasurementValueInformationnotAvailable(tvb, offset, pinfo, tree, hf_rnsap_measurementnotAvailable2);
}


static const value_string rnsap_UEMeasurementValueInformation_vals[] = {
  {   0, "measurementAvailable" },
  {   1, "measurementnotAvailable" },
  { 0, NULL }
};

static const per_choice_t UEMeasurementValueInformation_choice[] = {
  {   0, "measurementAvailable"        , ASN1_NO_EXTENSIONS     , dissect_measurementAvailable2 },
  {   1, "measurementnotAvailable"     , ASN1_NO_EXTENSIONS     , dissect_measurementnotAvailable2 },
  { 0, NULL, 0, NULL }
};

static int
dissect_rnsap_UEMeasurementValueInformation(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_choice(tvb, offset, pinfo, tree, hf_index,
                                 ett_rnsap_UEMeasurementValueInformation, UEMeasurementValueInformation_choice,
                                 NULL);

  return offset;
}



static int
dissect_rnsap_UL_Timeslot_ISCP_Value_IncrDecrThres(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 126U, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_INTEGER_M120_M58_(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              -120, -58, NULL, NULL, TRUE);

  return offset;
}
static int dissect_prxUpPCHdes(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_M120_M58_(tvb, offset, pinfo, tree, hf_rnsap_prxUpPCHdes);
}



static int
dissect_rnsap_INTEGER_1_32(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 32U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_mMax(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_INTEGER_1_32(tvb, offset, pinfo, tree, hf_rnsap_mMax);
}


static const per_sequence_t UL_TimingAdvanceCtrl_LCR_sequence[] = {
  { "sync-UL-codes-bitmap"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_sync_UL_codes_bitmap },
  { "fPACH-info"                  , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_fPACH_info },
  { "prxUpPCHdes"                 , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_prxUpPCHdes },
  { "syncUL-procParameter"        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_syncUL_procParameter },
  { "mMax"                        , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_mMax },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_TimingAdvanceCtrl_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_TimingAdvanceCtrl_LCR, UL_TimingAdvanceCtrl_LCR_sequence);

  return offset;
}



static int
dissect_rnsap_UL_Synchronisation_StepSize(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 8U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_uL_Synchronisation_StepSize(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_Synchronisation_StepSize(tvb, offset, pinfo, tree, hf_rnsap_uL_Synchronisation_StepSize);
}



static int
dissect_rnsap_UL_Synchronisation_Frequency(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              1U, 8U, NULL, NULL, FALSE);

  return offset;
}
static int dissect_uL_Synchronisation_Frequency(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_UL_Synchronisation_Frequency(tvb, offset, pinfo, tree, hf_rnsap_uL_Synchronisation_Frequency);
}


static const per_sequence_t UL_Synchronisation_Parameters_LCR_sequence[] = {
  { "uL-Synchronisation-StepSize" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_Synchronisation_StepSize },
  { "uL-Synchronisation-Frequency", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uL_Synchronisation_Frequency },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_UL_Synchronisation_Parameters_LCR(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_UL_Synchronisation_Parameters_LCR, UL_Synchronisation_Parameters_LCR_sequence);

  return offset;
}



static int
dissect_rnsap_UpPTSInterferenceValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0U, 127U, NULL, NULL, TRUE);

  return offset;
}


static const value_string rnsap_Unidirectional_DCH_Indicator_vals[] = {
  {   0, "downlink-DCH-only" },
  {   1, "uplink-DCH-only" },
  { 0, NULL }
};


static int
dissect_rnsap_Unidirectional_DCH_Indicator(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 1, NULL, NULL, FALSE);

  return offset;
}


static const per_sequence_t USCH_InformationItem_sequence[] = {
  { "uSCH-ID"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_uSCH_ID },
  { "ul-CCTrCH-ID"                , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_ul_CCTrCH_ID },
  { "trChSourceStatisticsDescriptor", ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_trChSourceStatisticsDescriptor },
  { "transportFormatSet"          , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_transportFormatSet },
  { "allocationRetentionPriority" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_allocationRetentionPriority },
  { "schedulingPriorityIndicator" , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_schedulingPriorityIndicator },
  { "rb-Info"                     , ASN1_EXTENSION_ROOT    , ASN1_NOT_OPTIONAL, dissect_rb_Info },
  { "iE-Extensions"               , ASN1_EXTENSION_ROOT    , ASN1_OPTIONAL    , dissect_iE_Extensions },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_USCH_InformationItem(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_USCH_InformationItem, USCH_InformationItem_sequence);

  return offset;
}
static int dissect_USCH_Information_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_USCH_InformationItem(tvb, offset, pinfo, tree, hf_rnsap_USCH_Information_item);
}


static const per_sequence_t USCH_Information_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_USCH_Information_item },
};

static int
dissect_rnsap_USCH_Information(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_USCH_Information, USCH_Information_sequence_of,
                                                  1, 10);

  return offset;
}


static const value_string rnsap_Presence_vals[] = {
  {   0, "optional" },
  {   1, "conditional" },
  {   2, "mandatory" },
  { 0, NULL }
};


static int
dissect_rnsap_Presence(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_integer(tvb, offset, pinfo, tree, hf_index,
                                              0, 2, NULL, NULL, FALSE);

  return offset;
}



static int
dissect_rnsap_FirstValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
#line 59 "rnsap.cnf"
	/* FIX ME */
	guint length;

	offset = dissect_per_length_determinant(tvb, offset, pinfo, tree, hf_rnsap_IE_length, &length);
	offset = offset + length;
	BYTE_ALIGN_OFFSET(offset)



  return offset;
}
static int dissect_firstValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_FirstValue(tvb, offset, pinfo, tree, hf_rnsap_firstValue);
}



static int
dissect_rnsap_SecondValue(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
#line 67 "rnsap.cnf"
	/* FIX ME */
	guint length;

	offset = dissect_per_length_determinant(tvb, offset, pinfo, tree, hf_rnsap_IE_length, &length);
	offset = offset + length;
	BYTE_ALIGN_OFFSET(offset)




  return offset;
}
static int dissect_secondValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_SecondValue(tvb, offset, pinfo, tree, hf_rnsap_secondValue);
}


static const per_sequence_t ProtocolIE_FieldPair_sequence[] = {
  { "id"                          , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_id },
  { "firstCriticality"            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_firstCriticality },
  { "firstValue"                  , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_firstValue },
  { "secondCriticality"           , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_secondCriticality },
  { "secondValue"                 , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_secondValue },
  { NULL, 0, 0, NULL }
};

static int
dissect_rnsap_ProtocolIE_FieldPair(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_sequence(tvb, offset, pinfo, tree, hf_index,
                                   ett_rnsap_ProtocolIE_FieldPair, ProtocolIE_FieldPair_sequence);

  return offset;
}
static int dissect_ProtocolIE_ContainerPair_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_FieldPair(tvb, offset, pinfo, tree, hf_rnsap_ProtocolIE_ContainerPair_item);
}


static const per_sequence_t ProtocolIE_ContainerPair_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ProtocolIE_ContainerPair_item },
};

static int
dissect_rnsap_ProtocolIE_ContainerPair(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_ProtocolIE_ContainerPair, ProtocolIE_ContainerPair_sequence_of,
                                                  0, 65535);

  return offset;
}
static int dissect_ProtocolIE_ContainerPairList_item(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree) {
  return dissect_rnsap_ProtocolIE_ContainerPair(tvb, offset, pinfo, tree, hf_rnsap_ProtocolIE_ContainerPairList_item);
}


static const per_sequence_t ProtocolIE_ContainerList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ProtocolIE_ContainerList_item },
};

static int
dissect_rnsap_ProtocolIE_ContainerList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_ProtocolIE_ContainerList, ProtocolIE_ContainerList_sequence_of,
                                                  0, 65535);

  return offset;
}


static const per_sequence_t ProtocolIE_ContainerPairList_sequence_of[1] = {
  { ""                            , ASN1_NO_EXTENSIONS     , ASN1_NOT_OPTIONAL, dissect_ProtocolIE_ContainerPairList_item },
};

static int
dissect_rnsap_ProtocolIE_ContainerPairList(tvbuff_t *tvb, int offset, packet_info *pinfo _U_, proto_tree *tree, int hf_index) {
  offset = dissect_per_constrained_sequence_of(tvb, offset, pinfo, tree, hf_index,
                                                  ett_rnsap_ProtocolIE_ContainerPairList, ProtocolIE_ContainerPairList_sequence_of,
                                                  0, 65535);

  return offset;
}

/*--- PDUs ---*/

static void dissect_RNSAP_PDU_PDU(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree) {
  dissect_rnsap_RNSAP_PDU(tvb, 0, pinfo, tree, hf_rnsap_RNSAP_PDU_PDU);
}


/*--- End of included file: packet-rnsap-fn.c ---*/
#line 589 "packet-rnsap-template.c"


static int dissect_rnsap_InitiatingMessageValueValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree){
	proto_item	*value_item = NULL;
	proto_tree	*value_tree = NULL;
	guint length;

    value_item = proto_tree_add_item(tree, hf_rnsap_initiatingMessageValue, tvb, 0, -1, FALSE);
    value_tree = proto_item_add_subtree(value_item, ett_rnsap_initiatingMessageValue);

	offset = dissect_per_length_determinant(tvb, offset, pinfo, value_tree, hf_rnsap_pdu_length, &length);
	proto_item_set_len(value_item,length);

	
	switch(ProcedureCode){
	case RNSAP_ID_COMMONTRANSPORTCHANNELRESOURCESINITIALISATION:	/* 0 */
	case RNSAP_ID_COMMONTRANSPORTCHANNELRESOURCESRELEASE:			/* 1 */
	case RNSAP_ID_COMPRESSEDMODECOMMAND:							 /* 2 */
	case RNSAP_ID_DOWNLINKPOWERCONTROL:								 /* 3 */
	case RNSAP_ID_DOWNLINKPOWERTIMESLOTCONTROL:						 /* 4 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_DOWNLINKSIGNALLINGTRANSFER:						 /* 5 */
		offset = dissect_id_downlinkSignallingTransfer(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_ERRORINDICATION:									 /* 6 */
	case RNSAP_ID_DEDICATEDMEASUREMENTFAILURE:						 /* 7 */
	case RNSAP_ID_DEDICATEDMEASUREMENTINITIATION:					 /* 8 */
	case RNSAP_ID_DEDICATEDMEASUREMENTREPORTING:					 /* 9 */
	case RNSAP_ID_DEDICATEDMEASUREMENTTERMINATION:					 /* 10 */
	case RNSAP_ID_PAGING:											 /* 11 */
	case RNSAP_ID_PHYSICALCHANNELRECONFIGURATION:					 /* 12 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_PRIVATEMESSAGE:									 /* 13 */
		offset = dissect_id_privateMessage(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_RADIOLINKADDITION:								 /* 14 */
		if (ddMode==RNSAP_FDD){
			offset = dissect_id_radioLinkAddition(tvb, offset, pinfo, value_tree);
		}else{
			offset = dissect_id_radioLinkAddition_TDD(tvb, offset, pinfo, value_tree);
		}
		break;
	case RNSAP_ID_RADIOLINKCONGESTION:								 /* 34 */
	case RNSAP_ID_RADIOLINKDELETION:								 /* 15 */
	case RNSAP_ID_RADIOLINKFAILURE:									 /* 16 */
	case RNSAP_ID_RADIOLINKPREEMPTION:								 /* 17 */
	case RNSAP_ID_RADIOLINKRESTORATION:								 /* 18 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_RADIOLINKSETUP:									 /* 19 */
		if (ddMode==RNSAP_FDD){
			offset = dissect_id_radioLinkSetup(tvb, offset, pinfo, value_tree);
		}else{
			offset = dissect_id_radioLinkSetupTdd(tvb, offset, pinfo, value_tree);
		}
		break;
	case RNSAP_ID_RELOCATIONCOMMIT:									 /* 20 */
	case RNSAP_ID_SYNCHRONISEDRADIOLINKRECONFIGURATIONCANCELLATION:	 /* 21 */
	case RNSAP_ID_SYNCHRONISEDRADIOLINKRECONFIGURATIONCOMMIT:		 /* 22 */
	case RNSAP_ID_SYNCHRONISEDRADIOLINKRECONFIGURATIONPREPARATION:	 /* 23 */
	case RNSAP_ID_UNSYNCHRONISEDRADIOLINKRECONFIGURATION:			 /* 24 */
	case RNSAP_ID_UPLINKSIGNALLINGTRANSFER:							 /* 25 */
	case RNSAP_ID_COMMONMEASUREMENTFAILURE:							 /* 26 */
	case RNSAP_ID_COMMONMEASUREMENTINITIATION:						 /* 27 */
	case RNSAP_ID_COMMONMEASUREMENTREPORTING:						 /* 28 */
	case RNSAP_ID_COMMONMEASUREMENTTERMINATION:						 /* 29 */
	case RNSAP_ID_INFORMATIONEXCHANGEFAILURE:						 /* 30 */
	case RNSAP_ID_INFORMATIONEXCHANGEINITIATION:					 /* 31 */
	case RNSAP_ID_INFORMATIONREPORTING:								 /* 32 */
	case RNSAP_ID_INFORMATIONEXCHANGETERMINATION:					 /* 33 */
	case RNSAP_ID_RESET:											 /* 35 */
	case RNSAP_ID_RADIOLINKACTIVATION: 								 /* 36 */
	case RNSAP_ID_GERANUPLINKSIGNALLINGTRANSFER:					 /* 37 */
	case RNSAP_ID_RADIOLINKPARAMETERUPDATE:							 /* 38 */
	case RNSAP_ID_UEMEASUREMENTFAILURE:								 /* 39 */
	case RNSAP_ID_UEMEASUREMENTINITIATION:							 /* 40 */
	case RNSAP_ID_UEMEASUREMENTREPORTING:							 /* 41 */
	case RNSAP_ID_UEMEASUREMENTTERMINATION:							 /* 42 */
	case RNSAP_ID_IURDEACTIVATETRACE:								 /* 43 */
	case RNSAP_ID_IURINVOKETRACE:									 /* 44 */
	case RNSAP_ID_MBMSATTACH:										 /* 45 */
	case RNSAP_ID_MBMSDETACH:										 /* 46 */
	case RNSAP_ID_DIRECTINFORMATIONTRANSFER:						 /* 48 */
		offset = offset + (length<<3);
		break;
	default:
		offset = offset + (length<<3);
		break;
	}
	BYTE_ALIGN_OFFSET(offset)
	return offset;
}

static int dissect_rnsap_SuccessfulOutcomeValueValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree){
	proto_item	*value_item = NULL;
	proto_tree	*value_tree = NULL;
	guint length;

    value_item = proto_tree_add_item(tree, hf_rnsap_successfulOutcomeValue, tvb, 0, -1, FALSE);
    value_tree = proto_item_add_subtree(value_item, ett_rnsap_initiatingMessageValue);

	offset = dissect_per_length_determinant(tvb, offset, pinfo, value_tree, hf_rnsap_pdu_length, &length);
	proto_item_set_len(value_item,length);

	
	switch(ProcedureCode){

	default:
		offset = offset + (length<<3);
		break;
	}
	BYTE_ALIGN_OFFSET(offset)
	return offset;
}

static int dissect_rnsap_UnsuccessfulOutcomeValueValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree){
	proto_item	*value_item = NULL;
	proto_tree	*value_tree = NULL;
	guint length;

    value_item = proto_tree_add_item(tree, hf_rnsap_unsuccessfulOutcomeValue, tvb, 0, -1, FALSE);
    value_tree = proto_item_add_subtree(value_item, ett_rnsap_UnsuccessfulOutcomeValue);

	offset = dissect_per_length_determinant(tvb, offset, pinfo, value_tree, hf_rnsap_pdu_length, &length);
	proto_item_set_len(value_item,length);

	
	switch(ProcedureCode){

	default:
		offset = offset + (length<<3);
		break;
	}
	BYTE_ALIGN_OFFSET(offset)
	return offset;
}

static int dissect_rnsap_ProtocolIEValueValue(tvbuff_t *tvb, int offset, packet_info *pinfo, proto_tree *tree){
	proto_item	*value_item = NULL;
	proto_tree	*value_tree = NULL;
	guint length;

    value_item = proto_tree_add_item(tree, hf_rnsap_value, tvb, 0, -1, FALSE);
    value_tree = proto_item_add_subtree(value_item, ett_rnsap_ProtocolIEValueValue);

	offset = dissect_per_length_determinant(tvb, offset, pinfo, value_tree, hf_rnsap_IE_length, &length);
	proto_item_set_len(value_item,length);

	
	switch(ProtocolIE_ID){

	case RNSAP_ID_ALLOWEDQUEUINGTIME:											/*  4 */
		offset = dissect_id_AllowedQueuingTime(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_ALLOWED_RATE_INFORMATION:										/*  42 */
		offset = dissect_id_Allowed_Rate_Information(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_ANTENNACOLOCATIONINDICATOR:									/*  309 */
		offset = dissect_id_AntennaColocationIndicator(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_BINDINGID:													/*  5 */
		offset = dissect_id_BindingID(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_C_ID:															/*  6 */
		offset = dissect_id_C_ID(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_C_RNTI:														/*  7 */
		offset = dissect_id_C_RNTI(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_CELL_CAPACITY_CLASS_VALUE:									/*  303 */
		offset = dissect_id_Cell_Capacity_Class_Value(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_CFN:															/*  8 */
		offset = dissect_id_CFN(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_CN_CS_DOMAINIDENTIFIER:										/*  9 */
		offset = dissect_id_CN_CS_DomainIdentifier(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_CN_PS_DOMAINIDENTIFIER:										/*  10 */
		offset = dissect_id_CN_PS_DomainIdentifier(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_CAUSE:														/*  11 */
		offset = dissect_id_Cause(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_COVERAGEINDICATOR:											/*  310 */
		offset = dissect_id_CoverageIndicator(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_CRITICALITYDIAGNOSTICS:										/*  20 */
		offset = dissect_id_CriticalityDiagnostics(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_CONTEXTINFOITEM_RESET:										/*  211 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_CONTEXTGROUPINFOITEM_RESET:									/*  515 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_D_RNTI:														/*  21 */
		offset = dissect_id_D_RNTI(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_D_RNTI_RELEASEINDICATION:										/*  22 */
		offset = dissect_id_D_RNTI_ReleaseIndication(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_DCHS_TO_ADD_FDD:												/*  26 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_DCHS_TO_ADD_TDD:												/*  27 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_DCH_DELETELIST_RL_RECONFPREPFDD:								/*  30 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_DCH_DELETELIST_RL_RECONFPREPTDD:								/*  31 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_DCH_DELETELIST_RL_RECONFRQSTFDD:								/*  32 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_DCH_DELETELIST_RL_RECONFRQSTTDD:								/*  33 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_DCH_FDD_INFORMATION:											/*  34 */
		offset = dissect_id_DCH_FDD_Information(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_DCH_TDD_INFORMATION:											/*  35 */
		offset = dissect_id_DCH_TDD_Information(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_FDD_DCHS_TO_MODIFY:											/*  39 */
	case RNSAP_ID_TDD_DCHS_TO_MODIFY:											/*  40 */
	case RNSAP_ID_DCH_INFORMATIONRESPONSE:										/*  43 */
	case RNSAP_ID_DCH_RATE_INFORMATIONITEM_RL_CONGESTIND:						/*  38 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONADDITEM_RL_RECONFPREPTDD:				/*  44 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONLISTIE_RL_RECONFREADYTDD:				/*  45 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONDELETEITEM_RL_RECONFRQSTTDD:				/*  46 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONITEM_RL_SETUPRQSTTDD:					/*  47 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONLISTIE_PHYCHRECONFRQSTTDD:				/*  48 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONLISTIE_RL_ADDITIONRSPTDD:				/*  49 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONLISTIE_RL_SETUPRSPTDD:					/*  50 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONADDLIST_RL_RECONFPREPTDD:				/*  51 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONDELETELIST_RL_RECONFRQSTTDD:				/*  52 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONLIST_RL_SETUPRQSTTDD:					/*  53 */
	case RNSAP_ID_FDD_DL_CODEINFORMATION:										/*  54 */
	case RNSAP_ID_DL_DPCH_INFORMATION_RL_RECONFPREPFDD:							/*  59 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_DL_DPCH_INFORMATION_RL_SETUPRQSTFDD:							/*  60 */
		offset = dissect_id_DL_DPCH_Information_RL_SetupRqstFDD(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_DL_DPCH_INFORMATION_RL_RECONFRQSTFDD:							/*  61 */
	case RNSAP_ID_DL_DPCH_INFORMATIONITEM_PHYCHRECONFRQSTTDD:					/*  62 */
	case RNSAP_ID_DL_DPCH_INFORMATIONITEM_RL_ADDITIONRSPTDD:					/*  63 */
	case RNSAP_ID_DL_DPCH_INFORMATIONITEM_RL_SETUPRSPTDD:						/*  64 */
	case RNSAP_ID_DL_DPCH_TIMINGADJUSTMENT:										/*  278 */
	case RNSAP_ID_DLREFERENCEPOWER:												/*  67 */
	case RNSAP_ID_DLREFERENCEPOWERLIST_DL_PC_RQST:								/*  68 */
	case RNSAP_ID_DL_REFERENCEPOWERINFORMATION_DL_PC_RQST:						/*  69 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_DPC_MODE:														/*  12 */
		offset = dissect_id_DPC_Mode(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_DRXCYCLELENGTHCOEFFICIENT:									/*  70 */
	case RNSAP_ID_DEDICATEDMEASUREMENTOBJECTTYPE_DM_FAIL_IND:					/*  470 */
	case RNSAP_ID_DEDICATEDMEASUREMENTOBJECTTYPE_DM_FAIL:						/*  471 */
	case RNSAP_ID_DEDICATEDMEASUREMENTOBJECTTYPE_DM_RPRT:						/*  71 */
	case RNSAP_ID_DEDICATEDMEASUREMENTOBJECTTYPE_DM_RQST:						/*  72 */
	case RNSAP_ID_DEDICATEDMEASUREMENTOBJECTTYPE_DM_RSP:						/*  73 */
	case RNSAP_ID_DEDICATEDMEASUREMENTTYPE:										/*  74 */
	case RNSAP_ID_FACH_INFOFORUESELECTEDS_CCPCH_CTCH_RESOURCERSPFDD:			/*  82 */
	case RNSAP_ID_FACH_INFOFORUESELECTEDS_CCPCH_CTCH_RESOURCERSPTDD:			/*  83 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_GUARANTEED_RATE_INFORMATION:									/*  41 */
		offset = dissect_id_Guaranteed_Rate_Information(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_IMSI:															/*  84 */
		offset = dissect_id_IMSI(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_HCS_PRIO:														/*  311 */
		offset = dissect_id_HCS_Prio(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_L3_INFORMATION:												/*  85 */
		offset = dissect_id_L3_Information(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_ADJUSTMENTPERIOD:												/*  90 */
		offset = dissect_id_AdjustmentPeriod(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_MAXADJUSTMENTSTEP:											/*  91 */
	case RNSAP_ID_MEASUREMENTFILTERCOEFFICIENT:									/*  92 */
	case RNSAP_ID_MESSAGESTRUCTURE:												/*  57 */
	case RNSAP_ID_MEASUREMENTID:												/*  93 */
	case RNSAP_ID_NEIGHBOURING_GSM_CELLINFORMATION:								/*  13 */
	case RNSAP_ID_NEIGHBOURING_UMTS_CELLINFORMATIONITEM:						/*  95 */
	case RNSAP_ID_NRT_LOAD_INFORMATION_VALUE:									/*  305 */
	case RNSAP_ID_NRT_LOAD_INFORMATION_VALUE_INCRDECRTHRES:						/*  306 */
	case RNSAP_ID_PAGINGAREA_PAGINGRQST:										/*  102 */
	case RNSAP_ID_FACH_FLOWCONTROLINFORMATION:									/*  103 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_PARTIALREPORTINGINDICATOR:									/*  472 */
		offset = dissect_id_PartialReportingIndicator(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_PERMANENT_NAS_UE_IDENTITY:									/*  17 */
		offset = dissect_id_Permanent_NAS_UE_Identity(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_POWERADJUSTMENTTYPE:											/*  107 */
	case RNSAP_ID_RANAP_RELOCATIONINFORMATION:									/*  109 */
	case RNSAP_ID_RL_INFORMATION_PHYCHRECONFRQSTFDD:							/*  110 */
	case RNSAP_ID_RL_INFORMATION_PHYCHRECONFRQSTTDD:							/*  111 */
	case RNSAP_ID_RL_INFORMATION_RL_ADDITIONRQSTFDD:							/*  112 */
	case RNSAP_ID_RL_INFORMATION_RL_ADDITIONRQSTTDD:							/*  113 */
	case RNSAP_ID_RL_INFORMATION_RL_DELETIONRQST:								/*  114 */
	case RNSAP_ID_RL_INFORMATION_RL_FAILUREIND:									/*  115 */
	case RNSAP_ID_RL_INFORMATION_RL_RECONFPREPFDD:								/*  116 */
	case RNSAP_ID_RL_INFORMATION_RL_RESTOREIND:									/*  117 */
	case RNSAP_ID_RL_INFORMATION_RL_SETUPRQSTFDD:								/*  118 */
	case RNSAP_ID_RL_INFORMATION_RL_SETUPRQSTTDD:								/*  119 */
	case RNSAP_ID_RL_INFORMATIONITEM_RL_CONGESTIND:								/*  55 */
	case RNSAP_ID_RL_INFORMATIONITEM_DM_RPRT:									/*  120 */
	case RNSAP_ID_RL_INFORMATIONITEM_DM_RQST:									/*  121 */
	case RNSAP_ID_RL_INFORMATIONITEM_DM_RSP:									/*  122 */
	case RNSAP_ID_RL_INFORMATIONITEM_RL_PREEMPTREQUIREDIND:						/*  2 */
	case RNSAP_ID_RL_INFORMATIONITEM_RL_SETUPRQSTFDD:							/*  123 */
	case RNSAP_ID_RL_INFORMATIONLIST_RL_CONGESTIND:								/*  56 */
	case RNSAP_ID_RL_INFORMATIONLIST_RL_ADDITIONRQSTFDD:						/*  124 */
	case RNSAP_ID_RL_INFORMATIONLIST_RL_DELETIONRQST:							/*  125 */
	case RNSAP_ID_RL_INFORMATIONLIST_RL_PREEMPTREQUIREDIND:						/*  1 */
	case RNSAP_ID_RL_INFORMATIONLIST_RL_RECONFPREPFDD:							/*  126 */
	case RNSAP_ID_RL_INFORMATIONRESPONSE_RL_ADDITIONRSPTDD:						/*  127 */
	case RNSAP_ID_RL_INFORMATIONRESPONSE_RL_RECONFREADYTDD:						/*  128 */
	case RNSAP_ID_RL_INFORMATIONRESPONSE_RL_SETUPRSPTDD:						/*  129 */
	case RNSAP_ID_RL_INFORMATIONRESPONSEITEM_RL_ADDITIONRSPFDD:					/*  130 */
	case RNSAP_ID_RL_INFORMATIONRESPONSEITEM_RL_RECONFREADYFDD:					/*  131 */
	case RNSAP_ID_RL_INFORMATIONRESPONSEITEM_RL_RECONFRSPFDD:					/*  132 */
	case RNSAP_ID_RL_INFORMATIONRESPONSEITEM_RL_SETUPRSPFDD:					/*  133 */
	case RNSAP_ID_RL_INFORMATIONRESPONSELIST_RL_ADDITIONRSPFDD:					/*  134 */
	case RNSAP_ID_RL_INFORMATIONRESPONSELIST_RL_RECONFREADYFDD:					/*  135 */
	case RNSAP_ID_RL_INFORMATIONRESPONSELIST_RL_RECONFRSPFDD:					/*  136 */
	case RNSAP_ID_RL_INFORMATIONRESPONSE_RL_RECONFRSPTDD:						/*  28 */
	case RNSAP_ID_RL_INFORMATIONRESPONSELIST_RL_SETUPRSPFDD:					/*  137 */
	case RNSAP_ID_RL_RECONFIGURATIONFAILURE_RL_RECONFFAIL:						/*  141 */
	case RNSAP_ID_RL_SET_INFORMATIONITEM_DM_RPRT:								/*  143 */
	case RNSAP_ID_RL_SET_INFORMATIONITEM_DM_RQST:								/*  144 */
	case RNSAP_ID_RL_SET_INFORMATIONITEM_DM_RSP:								/*  145 */
	case RNSAP_ID_RL_SET_INFORMATION_RL_FAILUREIND:								/*  146 */
	case RNSAP_ID_RL_SET_INFORMATION_RL_RESTOREIND:								/*  147 */
	case RNSAP_ID_RL_SET_SUCCESSFUL_INFORMATIONITEM_DM_FAIL:					/*  473 */
	case RNSAP_ID_RL_SET_UNSUCCESSFUL_INFORMATIONITEM_DM_FAIL:					/*  474 */
	case RNSAP_ID_RL_SET_UNSUCCESSFUL_INFORMATIONITEM_DM_FAIL_IND:				/*  475 */
	case RNSAP_ID_RL_SUCCESSFUL_INFORMATIONITEM_DM_FAIL:						/*  476 */
	case RNSAP_ID_RL_UNSUCCESSFUL_INFORMATIONITEM_DM_FAIL:						/*  477 */
	case RNSAP_ID_RL_UNSUCCESSFUL_INFORMATIONITEM_DM_FAIL_IND:					/*  478 */
	case RNSAP_ID_REPORTCHARACTERISTICS:										/*  152 */
	case RNSAP_ID_REPORTING_OBJECT_RL_FAILUREIND:								/*  153 */
	case RNSAP_ID_REPORING_OBJECT_RL_RESTOREIND:								/*  154 */
	case RNSAP_ID_RT_LOAD_VALUE:												/*  307 */
	case RNSAP_ID_RT_LOAD_VALUE_INCRDECRTHRES:									/*  308 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_S_RNTI:														/*  155 */
		offset = dissect_id_S_RNTI(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_RESETINDICATOR:												/*  244 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_RNC_ID:														/*  245 */
		offset = dissect_id_RNC_ID(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_SAI:															/*  156 */
		offset = dissect_id_SAI(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_SRNC_ID:														/*  157 */
		offset = dissect_id_SRNC_ID(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_SUCCESSFULRL_INFORMATIONRESPONSE_RL_ADDITIONFAILUREFDD:		/*  159 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_SUCCESSFULRL_INFORMATIONRESPONSE_RL_SETUPFAILUREFDD:			/*  160 */
	case RNSAP_ID_TRANSPORTBEARERID:											/*  163 */
	case RNSAP_ID_TRANSPORTBEARERREQUESTINDICATOR:								/*  164 */
	case RNSAP_ID_TRANSPORTLAYERADDRESS:										/*  165 */
	case RNSAP_ID_TYPEOFERROR:													/*  140 */
	case RNSAP_ID_UC_ID:														/*  166 */
	case RNSAP_ID_UL_CCTRCH_ADDINFORMATION_RL_RECONFPREPTDD:					/*  167 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONADDLIST_RL_RECONFPREPTDD:				/*  169 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONITEM_RL_SETUPRQSTTDD:					/*  171 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONLIST_RL_SETUPRQSTTDD:					/*  172 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONLISTIE_PHYCHRECONFRQSTTDD:				/*  173 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONLISTIE_RL_ADDITIONRSPTDD:				/*  174 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONLISTIE_RL_RECONFREADYTDD:				/*  175 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONLISTIE_RL_SETUPRSPTDD:					/*  176 */
	case RNSAP_ID_UL_DPCH_INFORMATION_RL_RECONFPREPFDD:							/*  177 */
	case RNSAP_ID_UL_DPCH_INFORMATION_RL_RECONFRQSTFDD:							/*  178 */
	case RNSAP_ID_UL_DPCH_INFORMATION_RL_SETUPRQSTFDD:							/*  179 */
		offset = dissect_id_UL_DPCH_Information_RL_SetupRqstFDD(tvb, offset, pinfo, value_tree);
		break;
	case RNSAP_ID_UL_DPCH_INFORMATIONITEM_PHYCHRECONFRQSTTDD:					/*  180 */
		offset = offset + (length<<3);
		break;
	case RNSAP_ID_UL_DPCH_INFORMATIONITEM_RL_ADDITIONRSPTDD:					/*  181 */
	case RNSAP_ID_UL_DPCH_INFORMATIONITEM_RL_SETUPRSPTDD:						/*  182 */
	case RNSAP_ID_UL_DPCH_INFORMATIONADDLISTIE_RL_RECONFREADYTDD:				/*  183 */
	case RNSAP_ID_UL_SIRTARGET:													/*  184 */
	case RNSAP_ID_URA_INFORMATION:												/*  185 */
	case RNSAP_ID_UNSUCCESSFULRL_INFORMATIONRESPONSE_RL_ADDITIONFAILUREFDD:		/*  188 */
	case RNSAP_ID_UNSUCCESSFULRL_INFORMATIONRESPONSE_RL_SETUPFAILUREFDD:		/*  189 */
	case RNSAP_ID_UNSUCCESSFULRL_INFORMATIONRESPONSE_RL_SETUPFAILURETDD:		/*  190 */
	case RNSAP_ID_ACTIVE_PATTERN_SEQUENCE_INFORMATION:							/*  193 */
	case RNSAP_ID_ADJUSTMENTRATIO:												/*  194 */
	case RNSAP_ID_CAUSELEVEL_RL_ADDITIONFAILUREFDD:								/*  197 */
	case RNSAP_ID_CAUSELEVEL_RL_ADDITIONFAILURETDD:								/*  198 */
	case RNSAP_ID_CAUSELEVEL_RL_RECONFFAILURE:									/*  199 */
	case RNSAP_ID_CAUSELEVEL_RL_SETUPFAILUREFDD:								/*  200 */
	case RNSAP_ID_CAUSELEVEL_RL_SETUPFAILURETDD:								/*  201 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONDELETEITEM_RL_RECONFPREPTDD:				/*  205 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONMODIFYITEM_RL_RECONFPREPTDD:				/*  206 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONMODIFYITEM_RL_RECONFRQSTTDD:				/*  207 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONDELETELIST_RL_RECONFPREPTDD:				/*  208 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONMODIFYLIST_RL_RECONFPREPTDD:				/*  209 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONMODIFYLIST_RL_RECONFRQSTTDD:				/*  210 */
	case RNSAP_ID_DL_DPCH_INFORMATIONADDLISTIE_RL_RECONFREADYTDD:				/*  212 */
	case RNSAP_ID_DL_DPCH_INFORMATIONDELETELISTIE_RL_RECONFREADYTDD:			/*  213 */
	case RNSAP_ID_DL_DPCH_INFORMATIONMODIFYLISTIE_RL_RECONFREADYTDD:			/*  214 */
	case RNSAP_ID_DSCHS_TO_ADD_TDD:												/*  215 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_216:								/*  216 */
	case RNSAP_ID_DSCH_DELETELIST_RL_RECONFPREPTDD:								/*  217 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_218:								/*  218 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_219:								/*  219 */
	case RNSAP_ID_DSCH_INFORMATIONLISTIE_RL_ADDITIONRSPTDD:						/*  220 */
	case RNSAP_ID_DSCH_INFORMATIONLISTIES_RL_SETUPRSPTDD:						/*  221 */
	case RNSAP_ID_DSCH_TDD_INFORMATION:											/*  222 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_223:								/*  223 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_226:								/*  226 */
	case RNSAP_ID_DSCH_MODIFYLIST_RL_RECONFPREPTDD:								/*  227 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_228:								/*  228 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_324:								/*  324 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_229:								/*  229 */
	case RNSAP_ID_DSCHTOBEADDEDORMODIFIEDLIST_RL_RECONFREADYTDD:				/*  230 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_29:								/*  29 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_225:								/*  225 */
	case RNSAP_ID_GA_CELL:														/*  232 */
	case RNSAP_ID_GA_CELLADDITIONALSHAPES:										/*  3 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_246:								/*  246 */
	case RNSAP_ID_TRANSMISSION_GAP_PATTERN_SEQUENCE_INFORMATION:				/*  255 */
	case RNSAP_ID_UL_CCTRCH_DELETEINFORMATION_RL_RECONFPREPTDD:					/*  256 */
	case RNSAP_ID_UL_CCTRCH_MODIFYINFORMATION_RL_RECONFPREPTDD:					/*  257 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONMODIFYITEM_RL_RECONFRQSTTDD:				/*  258 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONDELETELIST_RL_RECONFPREPTDD:				/*  259 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONMODIFYLIST_RL_RECONFPREPTDD:				/*  260 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONMODIFYLIST_RL_RECONFRQSTTDD:				/*  261 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONDELETEITEM_RL_RECONFRQSTTDD:				/*  262 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONDELETELIST_RL_RECONFRQSTTDD:				/*  263 */
	case RNSAP_ID_UL_DPCH_INFORMATIONDELETELISTIE_RL_RECONFREADYTDD:			/*  264 */
	case RNSAP_ID_UL_DPCH_INFORMATIONMODIFYLISTIE_RL_RECONFREADYTDD:			/*  265 */
	case RNSAP_ID_UNSUCCESSFULRL_INFORMATIONRESPONSE_RL_ADDITIONFAILURETDD:		/*  266 */
	case RNSAP_ID_USCHS_TO_ADD:													/*  267 */
	case RNSAP_ID_USCH_DELETELIST_RL_RECONFPREPTDD:								/*  268 */
	case RNSAP_ID_USCH_INFORMATIONLISTIE_RL_ADDITIONRSPTDD:						/*  269 */
	case RNSAP_ID_USCH_INFORMATIONLISTIES_RL_SETUPRSPTDD:						/*  270 */
	case RNSAP_ID_USCH_INFORMATION:												/*  271 */
	case RNSAP_ID_USCH_MODIFYLIST_RL_RECONFPREPTDD:								/*  272 */
	case RNSAP_ID_USCHTOBEADDEDORMODIFIEDLIST_RL_RECONFREADYTDD:				/*  273 */
	case RNSAP_ID_DL_PHYSICAL_CHANNEL_INFORMATION_RL_SETUPRQSTTDD:				/*  274 */
	case RNSAP_ID_UL_PHYSICAL_CHANNEL_INFORMATION_RL_SETUPRQSTTDD:				/*  275 */
	case RNSAP_ID_CLOSEDLOOPMODE1_SUPPORTINDICATOR:								/*  276 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_277:								/*  277 */
	case RNSAP_ID_STTD_SUPPORTINDICATOR:										/*  279 */
	case RNSAP_ID_CFNREPORTINGINDICATOR:   										/*  14 */
	case RNSAP_ID_CNORIGINATEDPAGE_PAGINGRQST:									/*  23 */
	case RNSAP_ID_INNERLOOPDLPCSTATUS:											/*  24 */
	case RNSAP_ID_PROPAGATIONDELAY:												/*  25 */
	case RNSAP_ID_RXTIMINGDEVIATIONFORTA:										/*  36 */
	case RNSAP_ID_TIMESLOT_ISCP:												/*  37 */
	case RNSAP_ID_CCTRCH_INFORMATIONITEM_RL_FAILUREIND:							/*  15 */
	case RNSAP_ID_CCTRCH_INFORMATIONITEM_RL_RESTOREIND:							/*  16 */
	case RNSAP_ID_COMMONMEASUREMENTACCURACY:									/*  280 */
	case RNSAP_ID_COMMONMEASUREMENTOBJECTTYPE_CM_RPRT:							/*  281 */
	case RNSAP_ID_COMMONMEASUREMENTOBJECTTYPE_CM_RQST:							/*  282 */
	case RNSAP_ID_COMMONMEASUREMENTOBJECTTYPE_CM_RSP:							/*  283 */
	case RNSAP_ID_COMMONMEASUREMENTTYPE:										/*  284 */
	case RNSAP_ID_CONGESTIONCAUSE:												/*  18 */
	case RNSAP_ID_SFN:															/*  285 */
	case RNSAP_ID_SFNREPORTINGINDICATOR:										/*  286 */
	case RNSAP_ID_INFORMATIONEXCHANGEID:										/*  287 */
	case RNSAP_ID_INFORMATIONEXCHANGEOBJECTTYPE_INFEX_RPRT:						/*  288 */
	case RNSAP_ID_INFORMATIONEXCHANGEOBJECTTYPE_INFEX_RQST:						/*  289 */
	case RNSAP_ID_INFORMATIONEXCHANGEOBJECTTYPE_INFEX_RSP:						/*  290 */
	case RNSAP_ID_INFORMATIONREPORTCHARACTERISTICS:								/*  291 */
	case RNSAP_ID_INFORMATIONTYPE:												/*  292 */
	case RNSAP_ID_NEIGHBOURING_LCR_TDD_CELLINFORMATION:							/*  58 */
	case RNSAP_ID_DL_TIMESLOT_ISCP_LCR_INFORMATION_RL_SETUPRQSTTDD:				/*  65 */
	case RNSAP_ID_RL_LCR_INFORMATIONRESPONSE_RL_SETUPRSPTDD:					/*  66 */
	case RNSAP_ID_UL_CCTRCH_LCR_INFORMATIONLISTIE_RL_SETUPRSPTDD:				/*  75 */
	case RNSAP_ID_UL_DPCH_LCR_INFORMATIONITEM_RL_SETUPRSPTDD:					/*  76 */
	case RNSAP_ID_DL_CCTRCH_LCR_INFORMATIONLISTIE_RL_SETUPRSPTDD:				/*  77 */
	case RNSAP_ID_DL_DPCH_LCR_INFORMATIONITEM_RL_SETUPRSPTDD:					/*  78 */
	case RNSAP_ID_DSCH_LCR_INFORMATIONLISTIES_RL_SETUPRSPTDD:					/*  79 */
	case RNSAP_ID_USCH_LCR_INFORMATIONLISTIES_RL_SETUPRSPTDD:					/*  80 */
	case RNSAP_ID_DL_TIMESLOT_ISCP_LCR_INFORMATION_RL_ADDITIONRQSTTDD:			/*  81 */
	case RNSAP_ID_RL_LCR_INFORMATIONRESPONSE_RL_ADDITIONRSPTDD:					/*  86 */
	case RNSAP_ID_UL_CCTRCH_LCR_INFORMATIONLISTIE_RL_ADDITIONRSPTDD:			/*  87 */
	case RNSAP_ID_UL_DPCH_LCR_INFORMATIONITEM_RL_ADDITIONRSPTDD:				/*  88 */
	case RNSAP_ID_DL_CCTRCH_LCR_INFORMATIONLISTIE_RL_ADDITIONRSPTDD:			/*  89 */
	case RNSAP_ID_DL_DPCH_LCR_INFORMATIONITEM_RL_ADDITIONRSPTDD:				/*  94 */
	case RNSAP_ID_DSCH_LCR_INFORMATIONLISTIES_RL_ADDITIONRSPTDD:				/*  96 */
	case RNSAP_ID_USCH_LCR_INFORMATIONLISTIES_RL_ADDITIONRSPTDD:				/*  97 */
	case RNSAP_ID_UL_DPCH_LCR_INFORMATIONADDLISTIE_RL_RECONFREADYTDD:			/*  98 */
	case RNSAP_ID_UL_TIMESLOT_LCR_INFORMATIONMODIFYLIST_RL_RECONFREADYTDD:		/*  100 */
	case RNSAP_ID_DL_DPCH_LCR_INFORMATIONADDLISTIE_RL_RECONFREADYTDD:			/*  101 */
	case RNSAP_ID_DL_TIMESLOT_LCR_INFORMATIONMODIFYLIST_RL_RECONFREADYTDD:		/*  104 */
	case RNSAP_ID_UL_TIMESLOT_LCR_INFORMATIONLIST_PHYCHRECONFRQSTTDD:			/*  105 */
	case RNSAP_ID_DL_TIMESLOT_LCR_INFORMATIONLIST_PHYCHRECONFRQSTTDD:			/*  106 */
	case RNSAP_ID_TIMESLOT_ISCP_LCR_LIST_DL_PC_RQST_TDD:						/*  138 */
	case RNSAP_ID_TSTD_SUPPORT_INDICATOR_RL_SETUPRQSTTDD:						/*  139 */
	case RNSAP_ID_RESTRICTIONSTATEINDICATOR:									/*  142 */
	case RNSAP_ID_LOAD_VALUE:													/*  233 */
	case RNSAP_ID_LOAD_VALUE_INCRDECRTHRES:										/*  234 */
	case RNSAP_ID_ONMODIFICATION:												/*  235 */
	case RNSAP_ID_RECEIVED_TOTAL_WIDEBAND_POWER_VALUE:							/*  236 */
	case RNSAP_ID_RECEIVED_TOTAL_WIDEBAND_POWER_VALUE_INCRDECRTHRES:			/*  237 */
	case RNSAP_ID_SFNSFNMEASUREMENTTHRESHOLDINFORMATION:						/*  238 */
	case RNSAP_ID_TRANSMITTED_CARRIER_POWER_VALUE:								/*  239 */
	case RNSAP_ID_TRANSMITTED_CARRIER_POWER_VALUE_INCRDECRTHRES:				/*  240 */
	case RNSAP_ID_TUTRANGPSMEASUREMENTTHRESHOLDINFORMATION:						/*  241 */
	case RNSAP_ID_UL_TIMESLOT_ISCP_VALUE:										/*  242 */
	case RNSAP_ID_UL_TIMESLOT_ISCP_VALUE_INCRDECRTHRES:							/*  243 */
	case RNSAP_ID_RX_TIMING_DEVIATION_VALUE_LCR:								/*  293 */
	case RNSAP_ID_DPC_MODE_CHANGE_SUPPORTINDICATOR:								/*  19 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_247:								/*  247 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_295:								/*  295 */
	case RNSAP_ID_PRIMARYCCPCH_RSCP_RL_RECONFPREPTDD:							/*  202 */
	case RNSAP_ID_DL_TIMESLOT_ISCP_INFO_RL_RECONFPREPTDD:						/*  203 */
	case RNSAP_ID_DL_TIMESLOT_ISCP_LCR_INFORMATION_RL_RECONFPREPTDD:			/*  204 */
	case RNSAP_ID_DSCH_RNTI:													/*  249 */
	case RNSAP_ID_DL_POWERBALANCING_INFORMATION:								/*  296 */
	case RNSAP_ID_DL_POWERBALANCING_ACTIVATIONINDICATOR:						/*  297 */
	case RNSAP_ID_DL_POWERBALANCING_UPDATEDINDICATOR:							/*  298 */
	case RNSAP_ID_DL_REFERENCEPOWERINFORMATION:									/*  299 */
	case RNSAP_ID_ENHANCED_PRIMARYCPICH_ECNO:									/*  224 */
	case RNSAP_ID_IPDL_TDD_PARAMETERSLCR:										/*  252 */
	case RNSAP_ID_CELLCAPABILITYCONTAINER_FDD:									/*  300 */
	case RNSAP_ID_CELLCAPABILITYCONTAINER_TDD:									/*  301 */
	case RNSAP_ID_CELLCAPABILITYCONTAINER_TDD_LCR:								/*  302 */
	case RNSAP_ID_RL_SPECIFIC_DCH_INFO:											/*  317 */
	case RNSAP_ID_RL_RECONFIGURATIONREQUESTFDD_RL_INFORMATIONLIST:				/*  318 */
	case RNSAP_ID_RL_RECONFIGURATIONREQUESTFDD_RL_INFORMATION_IES:				/*  319 */
	case RNSAP_ID_RL_RECONFIGURATIONREQUESTTDD_RL_INFORMATION:					/*  321 */
	case RNSAP_ID_COMMONTRANSPORTCHANNELRESOURCESINITIALISATIONNOTREQUIRED:		/*  250 */
	case RNSAP_ID_DELAYEDACTIVATION:											/*  312 */
	case RNSAP_ID_DELAYEDACTIVATIONLIST_RL_ACTIVATIONCMDFDD:					/*  313 */
	case RNSAP_ID_DELAYEDACTIVATIONINFORMATION_RL_ACTIVATIONCMDFDD:				/*  314 */
	case RNSAP_ID_DELAYEDACTIVATIONLIST_RL_ACTIVATIONCMDTDD:					/*  315 */
	case RNSAP_ID_DELAYEDACTIVATIONINFORMATION_RL_ACTIVATIONCMDTDD:				/*  316 */
	case RNSAP_ID_NEIGHBOURINGTDDCELLMEASUREMENTINFORMATIONLCR:					/*  251 */
	case RNSAP_ID_UL_SIR_TARGET_CCTRCH_INFORMATIONITEM_RL_SETUPRSPTDD:			/*  150 */
	case RNSAP_ID_UL_SIR_TARGET_CCTRCH_LCR_INFORMATIONITEM_RL_SETUPRSPTDD:		/*  151 */
	case RNSAP_ID_PRIMCCPCH_RSCP_DL_PC_RQSTTDD:									/*  451 */
	case RNSAP_ID_HSDSCH_FDD_INFORMATION:										/*  452 */
	case RNSAP_ID_HSDSCH_FDD_INFORMATION_RESPONSE:								/*  453 */
	case RNSAP_ID_HSDSCH_FDD_UPDATE_INFORMATION:								/*  466 */
	case RNSAP_ID_HSDSCH_INFORMATION_TO_MODIFY:									/*  456 */
	case RNSAP_ID_HSDSCHMACDFLOWSPECIFICINFORMATIONLIST_RL_PREEMPTREQUIREDIND:	/*  516 */
	case RNSAP_ID_HSDSCHMACDFLOWSPECIFICINFORMATIONITEM_RL_PREEMPTREQUIREDIND:	/*  517 */
	case RNSAP_ID_HSDSCH_RNTI:													/*  457 */
	case RNSAP_ID_HSDSCH_TDD_INFORMATION:										/*  458 */
	case RNSAP_ID_HSDSCH_TDD_INFORMATION_RESPONSE:								/*  459 */
	case RNSAP_ID_HSDSCH_TDD_UPDATE_INFORMATION:								/*  467 */
	case RNSAP_ID_HSPDSCH_RL_ID:												/*  463 */
	case RNSAP_ID_HSDSCH_MACDFLOWS_TO_ADD:										/*  531 */
	case RNSAP_ID_HSDSCH_MACDFLOWS_TO_DELETE:									/*  532 */
	case RNSAP_ID_ANGLE_OF_ARRIVAL_VALUE_LCR:									/*  148 */
	case RNSAP_ID_TRAFFICCLASS:													/*  158 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_248:								/*  248 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_253:								/*  253 */
	case RNSAP_ID_PDSCH_RL_ID:													/*  323 */
	case RNSAP_ID_TIMESLOT_RL_SETUPRSPTDD:										/*  325 */
	case RNSAP_ID_GERAN_CELL_CAPABILITY:										/*  468 */
	case RNSAP_ID_GERAN_CLASSMARK:												/*  469 */
	case RNSAP_ID_DSCH_INITIALWINDOWSIZE:										/*  480 */
	case RNSAP_ID_UL_SYNCHRONISATION_PARAMETERS_LCR:							/*  464 */
	case RNSAP_ID_SNA_INFORMATION:												/*  479 */
	case RNSAP_ID_MACHS_RESETINDICATOR:											/*  465 */
	case RNSAP_ID_TDD_DL_DPCH_TIMESLOTFORMATMODIFYITEM_LCR_RL_RECONFREADYTDD:	/*  481 */
	case RNSAP_ID_TDD_UL_DPCH_TIMESLOTFORMATMODIFYITEM_LCR_RL_RECONFREADYTDD:	/*  482 */
	case RNSAP_ID_TDD_TPC_UPLINKSTEPSIZE_LCR_RL_SETUPRQSTTDD:					/*  483 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONLIST_RL_ADDITIONRQSTTDD:					/*  484 */
	case RNSAP_ID_UL_CCTRCH_INFORMATIONITEM_RL_ADDITIONRQSTTDD:					/*  485 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONLIST_RL_ADDITIONRQSTTDD:					/*  486 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONITEM_RL_ADDITIONRQSTTDD:					/*  487 */
	case RNSAP_ID_TDD_TPC_UPLINKSTEPSIZE_INFORMATIONADD_LCR_RL_RECONFPREPTDD:	/*  488 */
	case RNSAP_ID_TDD_TPC_UPLINKSTEPSIZE_INFORMATIONMODIFY_LCR_RL_RECONFPREPTDD:/*  489 */
	case RNSAP_ID_TDD_TPC_DOWNLINKSTEPSIZE_INFORMATIONADD_RL_RECONFPREPTDD:		/*  490 */
	case RNSAP_ID_TDD_TPC_DOWNLINKSTEPSIZE_INFORMATIONMODIFY_RL_RECONFPREPTDD:	/*  491 */
	case RNSAP_ID_UL_TIMINGADVANCECTRL_LCR:										/*  492 */
	case RNSAP_ID_HSPDSCH_TIMESLOT_INFORMATIONLIST_PHYCHRECONFRQSTTDD:			/*  493 */
	case RNSAP_ID_HSPDSCH_TIMESLOT_INFORMATIONLISTLCR_PHYCHRECONFRQSTTDD:		/*  494 */
	case RNSAP_ID_HS_SICH_RECEPTION_QUALITY: 									/*  495 */
	case RNSAP_ID_HS_SICH_RECEPTION_QUALITY_MEASUREMENT_VALUE:					/*  496 */
	case RNSAP_ID_HSSICH_INFO_DM_RPRT:											/*  497 */
	case RNSAP_ID_HSSICH_INFO_DM_RQST:											/*  498 */
	case RNSAP_ID_HSSICH_INFO_DM:												/*  499 */
	case RNSAP_ID_CCTRCH_MAXIMUM_DL_POWER_RL_SETUPRSPTDD:						/*  500 */
	case RNSAP_ID_CCTRCH_MINIMUM_DL_POWER_RL_SETUPRSPTDD:						/*  501 */
	case RNSAP_ID_CCTRCH_MAXIMUM_DL_POWER_RL_ADDITIONRSPTDD:					/*  502 */
	case RNSAP_ID_CCTRCH_MINIMUM_DL_POWER_RL_ADDITIONRSPTDD:					/*  503 */
	case RNSAP_ID_CCTRCH_MAXIMUM_DL_POWER_RL_RECONFREADYTDD:					/*  504 */
	case RNSAP_ID_CCTRCH_MINIMUM_DL_POWER_RL_RECONFREADYTDD:					/*  505 */
	case RNSAP_ID_MAXIMUM_DL_POWER_TIMESLOTLCR_INFORMATIONMODIFYITEM_RL_RECONFREADYTDD:	/*  506 */
	case RNSAP_ID_MINIMUM_DL_POWER_TIMESLOTLCR_INFORMATIONMODIFYITEM_RL_RECONFREADYTDD:	/*  507 */
	case RNSAP_ID_DL_CCTRCH_INFORMATIONLIST_RL_RECONFRSPTDD:					/*  508 */
	case RNSAP_ID_DL_DPCH_INFORMATIONMODIFYITEM_LCR_RL_RECONFRSPTDD:			/*  509 */
	case RNSAP_ID_MAXIMUM_DL_POWER_TIMESLOTLCR_INFORMATIONITEM:					/*  510 */
	case RNSAP_ID_MINIMUM_DL_POWER_TIMESLOTLCR_INFORMATIONITEM:					/*  511 */
	case RNSAP_ID_TDD_SUPPORT_8PSK:												/*  512 */
	case RNSAP_ID_TDD_MAXNRDLPHYSICALCHANNELS:									/*  513 */
	case RNSAP_ID_EXTENDEDGSMCELLINDIVIDUALOFFSET:								/*  514 */
	case RNSAP_ID_RL_PARAMETERUPDATEINDICATIONFDD_RL_INFORMATIONLIST:			/*  518 */
	case RNSAP_ID_PRIMARY_CPICH_USAGE_FOR_CHANNEL_ESTIMATION:					/*  519 */
	case RNSAP_ID_SECONDARY_CPICH_INFORMATION:									/*  520 */
	case RNSAP_ID_SECONDARY_CPICH_INFORMATION_CHANGE:							/*  521 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_522:								/*  522 */
	case RNSAP_ID_UNUSED_PROTOCOLIE_RNSAP_ID_523:								/*  523 */
	case RNSAP_ID_RL_PARAMETERUPDATEINDICATIONFDD_RL_INFORMATION_ITEM:			/*  524 */
	case RNSAP_ID_PHASE_REFERENCE_UPDATE_INDICATOR:								/*  525 */
	case RNSAP_ID_UNIDIRECTIONAL_DCH_INDICATOR:									/*  526 */
	case RNSAP_ID_RL_INFORMATION_RL_RECONFPREPTDD:								/*  527 */
	case RNSAP_ID_MULTIPLE_RL_INFORMATIONRESPONSE_RL_RECONFREADYTDD:			/*  528 */
	case RNSAP_ID_RL_RECONFIGURATIONRESPONSETDD_RL_INFORMATION:					/*  529 */
	case RNSAP_ID_SATELLITE_ALMANAC_INFORMATION_EXTITEM:						/*  530 */
	case RNSAP_ID_HSDSCH_INFORMATION_TO_MODIFY_UNSYNCHRONISED:					/*  533 */
	case RNSAP_ID_TNLQOS:														/*  534 */
	case RNSAP_ID_RTLOADVALUE:													/*  535 */
	case RNSAP_ID_NRTLOADINFORMATIONVALUE:										/*  536 */
	case RNSAP_ID_CELLPORTIONID:												/*  537 */
	case RNSAP_ID_UPPTSINTERFERENCEVALUE:										/*  538 */
	case RNSAP_ID_PRIMARYCCPCH_RSCP_DELTA:										/*  539 */
	case RNSAP_ID_UEMEASUREMENTTYPE:											/*  540 */
	case RNSAP_ID_UEMEASUREMENTTIMESLOTINFOHCR:									/*  541 */
	case RNSAP_ID_UEMEASUREMENTTIMESLOTINFOLCR:									/*  542 */
	case RNSAP_ID_UEMEASUREMENTREPORTCHARACTERISTICS:							/*  543 */
	case RNSAP_ID_UEMEASUREMENTPARAMETERMODALLOW:								/*  544 */
	case RNSAP_ID_UEMEASUREMENTVALUEINFORMATION:								/*  545 */
	case RNSAP_ID_INTERFACESTOTRACEITEM:										/*  546 */
	case RNSAP_ID_LISTOFINTERFACESTOTRACE:										/*  547 */
	case RNSAP_ID_TRACEDEPTH:													/*  548 */
	case RNSAP_ID_TRACERECORDINGSESSIONREFERENCE:								/*  549 */
	case RNSAP_ID_TRACEREFERENCE:												/*  550 */
	case RNSAP_ID_UEIDENTITY:													/*  551 */
	case RNSAP_ID_NACC_RELATED_DATA:											/*  552 */
	case RNSAP_ID_GSM_CELL_INFEX_RQST:											/*  553 */
	case RNSAP_ID_MEASUREMENTRECOVERYBEHAVIOR:									/*  554 */
	case RNSAP_ID_MEASUREMENTRECOVERYREPORTINGINDICATOR:						/*  555 */
	case RNSAP_ID_MEASUREMENTRECOVERYSUPPORTINDICATOR:							/*  556 */
	case RNSAP_ID_DL_DPCH_POWER_INFORMATION_RL_RECONFPREPFDD:					/*  557 */
	case RNSAP_ID_F_DPCH_INFORMATION_RL_RECONFPREPFDD:							/*  558 */
	case RNSAP_ID_F_DPCH_INFORMATION_RL_SETUPRQSTFDD:							/*  559 */
	case RNSAP_ID_MBMS_BEARER_SERVICE_LIST:										/*  560 */
	case RNSAP_ID_MBMS_BEARER_SERVICE_LIST_INFEX_RSP:							/*  561 */
	case RNSAP_ID_ACTIVE_MBMS_BEARER_SERVICEFDD:								/*  562 */
	case RNSAP_ID_ACTIVE_MBMS_BEARER_SERVICETDD:								/*  563 */
	case RNSAP_ID_OLD_URA_ID:													/*  564 */
	case RNSAP_ID_UE_STATE:														/*  568 */
	case RNSAP_ID_URA_ID:														/*  569 */
	case RNSAP_ID_HARQ_PREAMBLE_MODE:											/*  571 */
	case RNSAP_ID_SYNCHRONISATIONINDICATOR:										/*  572 */
	case RNSAP_ID_UL_DPDCHINDICATOREDCH:										/*  573 */
	case RNSAP_ID_EDPCH_INFORMATION:											/*  574 */
	case RNSAP_ID_RL_SPECIFIC_EDCH_INFORMATION:									/*  575 */
	case RNSAP_ID_EDCH_RL_INDICATION:											/*  576 */
	case RNSAP_ID_EDCH_FDD_INFORMATION:											/*  577 */
	case RNSAP_ID_EDCH_RLSET_ID:												/*  578 */
	case RNSAP_ID_SERVING_EDCHRL_ID:											/*  579 */
	case RNSAP_ID_EDCH_FDD_DL_CONTROLCHANNELINFORMATION:						/*  580 */
	case RNSAP_ID_EDCH_FDD_INFORMATIONRESPONSE:									/*  581 */
	case RNSAP_ID_EDCH_MACDFLOWS_TO_ADD:										/*  582 */
	case RNSAP_ID_EDCH_FDD_INFORMATION_TO_MODIFY:								/*  583 */
	case RNSAP_ID_EDCH_MACDFLOWS_TO_DELETE:										/*  584 */
	case RNSAP_ID_EDPCH_INFORMATION_RLRECONFREQUEST_FDD:						/*  585 */
	case RNSAP_ID_EDCH_MACDFLOWSPECIFICINFORMATIONLIST_RL_PREEMPTREQUIREDIND:	/*  586 */
	case RNSAP_ID_EDCH_MACDFLOWSPECIFICINFORMATIONITEM_RL_PREEMPTREQUIREDIND:	/*  587 */
	case RNSAP_ID_EDCH_MACDFLOWSPECIFICINFORMATIONLIST_RL_CONGESTIND:			/*  588 */
	case RNSAP_ID_EDCH_MACDFLOWSPECIFICINFORMATIONITEM_RL_CONGESTIND:			/*  589 */
	case RNSAP_ID_MBMS_BEARER_SERVICE_FULL_ADDRESS:								/*  590 */
	case RNSAP_ID_INITIAL_DL_DPCH_TIMINGADJUSTMENT:								/*  591 */
	case RNSAP_ID_INITIAL_DL_DPCH_TIMINGADJUSTMENT_ALLOWED:						/*  592 */
	case RNSAP_ID_USER_PLANE_CONGESTION_FIELDS_INCLUSION:						/*  593 */
	case RNSAP_ID_HARQ_PREAMBLE_MODE_ACTIVATION_INDICATOR:						/*  594 */
	case RNSAP_ID_MULTIPLE_DEDICATEDMEASUREMENTVALUELIST_TDD_DM_RSP:			/*  595 */
	case RNSAP_ID_MULTIPLE_DEDICATEDMEASUREMENTVALUELIST_LCR_TDD_DM_RSP:		/*  596 */
	case RNSAP_ID_PROVIDEDINFORMATION:											/*  597 */
	case RNSAP_ID_ACTIVE_MBMS_BEARER_SERVICEFDD_PFL:							/*  598 */
	case RNSAP_ID_ACTIVE_MBMS_BEARER_SERVICETDD_PFL:							/*  599 */
	case RNSAP_ID_FREQUENCYBANDINDICATOR:										/*  600	*/
		offset = offset + (length<<3);
		break;
	default:
		offset = offset + (length<<3);
		break;
	}
	BYTE_ALIGN_OFFSET(offset);	
	return offset;
}
static void
dissect_rnsap(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree)
{
	proto_item	*rnsap_item = NULL;
	proto_tree	*rnsap_tree = NULL;
	int			offset = 0;

	top_tree = tree;

	/* make entry in the Protocol column on summary display */
	if (check_col(pinfo->cinfo, COL_PROTOCOL))
		col_set_str(pinfo->cinfo, COL_PROTOCOL, "RNSAP");

    /* create the rnsap protocol tree */
    rnsap_item = proto_tree_add_item(tree, proto_rnsap, tvb, 0, -1, FALSE);
    rnsap_tree = proto_item_add_subtree(rnsap_item, ett_rnsap);

	dissect_RNSAP_PDU_PDU(tvb, pinfo, rnsap_tree);
}
/*--- proto_register_rnsap -------------------------------------------*/
void proto_register_rnsap(void) {

  /* List of fields */

  static hf_register_info hf[] = {
	{ &hf_rnsap_pdu_length,
		{ "PDU Length", "rnsap.pdu_length", FT_UINT32, BASE_DEC,
		NULL, 0, "Number of octets in the PDU", HFILL }},
	{ &hf_rnsap_IE_length,
		{ "IE Length", "rnsap.ie_length", FT_UINT32, BASE_DEC,
		NULL, 0, "Number of octets in the IE", HFILL }},

/*--- Included file: packet-rnsap-hfarr.c ---*/
#line 1 "packet-rnsap-hfarr.c"
    { &hf_rnsap_RNSAP_PDU_PDU,
      { "RNSAP-PDU", "rnsap.RNSAP_PDU",
        FT_UINT32, BASE_DEC, VALS(rnsap_RNSAP_PDU_vals), 0,
        "RNSAP-PDU", HFILL }},
    { &hf_rnsap_initiatingMessage,
      { "initiatingMessage", "rnsap.initiatingMessage",
        FT_NONE, BASE_NONE, NULL, 0,
        "RNSAP-PDU/initiatingMessage", HFILL }},
    { &hf_rnsap_successfulOutcome,
      { "successfulOutcome", "rnsap.successfulOutcome",
        FT_NONE, BASE_NONE, NULL, 0,
        "RNSAP-PDU/successfulOutcome", HFILL }},
    { &hf_rnsap_unsuccessfulOutcome,
      { "unsuccessfulOutcome", "rnsap.unsuccessfulOutcome",
        FT_NONE, BASE_NONE, NULL, 0,
        "RNSAP-PDU/unsuccessfulOutcome", HFILL }},
    { &hf_rnsap_outcome,
      { "outcome", "rnsap.outcome",
        FT_NONE, BASE_NONE, NULL, 0,
        "RNSAP-PDU/outcome", HFILL }},
    { &hf_rnsap_procedureID,
      { "procedureID", "rnsap.procedureID",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_criticality,
      { "criticality", "rnsap.criticality",
        FT_UINT32, BASE_DEC, VALS(rnsap_Criticality_vals), 0,
        "", HFILL }},
    { &hf_rnsap_transactionID,
      { "transactionID", "rnsap.transactionID",
        FT_UINT32, BASE_DEC, VALS(rnsap_TransactionID_vals), 0,
        "", HFILL }},
    { &hf_rnsap_initiatingMessageValue,
      { "initiatingMessageValue", "rnsap.initiatingMessageValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "InitiatingMessage/initiatingMessageValue", HFILL }},
    { &hf_rnsap_successfulOutcomeValue,
      { "successfulOutcomeValue", "rnsap.successfulOutcomeValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "SuccessfulOutcome/successfulOutcomeValue", HFILL }},
    { &hf_rnsap_unsuccessfulOutcomeValue,
      { "unsuccessfulOutcomeValue", "rnsap.unsuccessfulOutcomeValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "UnsuccessfulOutcome/unsuccessfulOutcomeValue", HFILL }},
    { &hf_rnsap_outcomeValue,
      { "outcomeValue", "rnsap.outcomeValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "Outcome/outcomeValue", HFILL }},
    { &hf_rnsap_id_downlinkSignallingTransfer,
      { "id-downlinkSignallingTransfer", "rnsap.id_downlinkSignallingTransfer",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-downlinkSignallingTransfer", HFILL }},
    { &hf_rnsap_id_physicalChannelReconfiguration,
      { "id-physicalChannelReconfiguration", "rnsap.id_physicalChannelReconfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-physicalChannelReconfiguration", HFILL }},
    { &hf_rnsap_id_privateMessage,
      { "id-privateMessage", "rnsap.id_privateMessage",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-privateMessage", HFILL }},
    { &hf_rnsap_id_radioLinkAddition,
      { "id-radioLinkAddition", "rnsap.id_radioLinkAddition",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-radioLinkAddition", HFILL }},
    { &hf_rnsap_id_radioLinkAddition_TDD,
      { "id-radioLinkAddition-TDD", "rnsap.id_radioLinkAddition_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-radioLinkAddition-TDD", HFILL }},
    { &hf_rnsap_id_radioLinkDeletion,
      { "id-radioLinkDeletion", "rnsap.id_radioLinkDeletion",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-radioLinkDeletion", HFILL }},
    { &hf_rnsap_id_radioLinkSetup,
      { "id-radioLinkSetup", "rnsap.id_radioLinkSetup",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-radioLinkSetup", HFILL }},
    { &hf_rnsap_id_radioLinkSetupTdd,
      { "id-radioLinkSetupTdd", "rnsap.id_radioLinkSetupTdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-radioLinkSetupTdd", HFILL }},
    { &hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation,
      { "id-synchronisedRadioLinkReconfigurationPreparation", "rnsap.id_synchronisedRadioLinkReconfigurationPreparation",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-synchronisedRadioLinkReconfigurationPreparation", HFILL }},
    { &hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation_TDD,
      { "id-synchronisedRadioLinkReconfigurationPreparation-TDD", "rnsap.id_synchronisedRadioLinkReconfigurationPreparation_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_id_unSynchronisedRadioLinkReconfiguration,
      { "id-unSynchronisedRadioLinkReconfiguration", "rnsap.id_unSynchronisedRadioLinkReconfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-unSynchronisedRadioLinkReconfiguration", HFILL }},
    { &hf_rnsap_id_unSynchronisedRadioLinkReconfiguration_TDD,
      { "id-unSynchronisedRadioLinkReconfiguration-TDD", "rnsap.id_unSynchronisedRadioLinkReconfiguration_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyInitiatingValue/id-unSynchronisedRadioLinkReconfiguration-TDD", HFILL }},
    { &hf_rnsap_id_physicalChannelReconfiguration1,
      { "id-physicalChannelReconfiguration", "rnsap.id_physicalChannelReconfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummySuccessfulOutcomeValue/id-physicalChannelReconfiguration", HFILL }},
    { &hf_rnsap_id_radioLinkAddition1,
      { "id-radioLinkAddition", "rnsap.id_radioLinkAddition",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummySuccessfulOutcomeValue/id-radioLinkAddition", HFILL }},
    { &hf_rnsap_id_radioLinkAddition_TDD1,
      { "id-radioLinkAddition-TDD", "rnsap.id_radioLinkAddition_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummySuccessfulOutcomeValue/id-radioLinkAddition-TDD", HFILL }},
    { &hf_rnsap_id_radioLinkDeletion1,
      { "id-radioLinkDeletion", "rnsap.id_radioLinkDeletion",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummySuccessfulOutcomeValue/id-radioLinkDeletion", HFILL }},
    { &hf_rnsap_id_radioLinkSetup1,
      { "id-radioLinkSetup", "rnsap.id_radioLinkSetup",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummySuccessfulOutcomeValue/id-radioLinkSetup", HFILL }},
    { &hf_rnsap_id_radioLinkSetupTdd1,
      { "id-radioLinkSetupTdd", "rnsap.id_radioLinkSetupTdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummySuccessfulOutcomeValue/id-radioLinkSetupTdd", HFILL }},
    { &hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation1,
      { "id-synchronisedRadioLinkReconfigurationPreparation", "rnsap.id_synchronisedRadioLinkReconfigurationPreparation",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummySuccessfulOutcomeValue/id-synchronisedRadioLinkReconfigurationPreparation", HFILL }},
    { &hf_rnsap_id_unSynchronisedRadioLinkReconfiguration1,
      { "id-unSynchronisedRadioLinkReconfiguration", "rnsap.id_unSynchronisedRadioLinkReconfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummySuccessfulOutcomeValue/id-unSynchronisedRadioLinkReconfiguration", HFILL }},
    { &hf_rnsap_id_unSynchronisedRadioLinkReconfiguration_TDD1,
      { "id-unSynchronisedRadioLinkReconfiguration-TDD", "rnsap.id_unSynchronisedRadioLinkReconfiguration_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummySuccessfulOutcomeValue/id-unSynchronisedRadioLinkReconfiguration-TDD", HFILL }},
    { &hf_rnsap_id_physicalChannelReconfiguration2,
      { "id-physicalChannelReconfiguration", "rnsap.id_physicalChannelReconfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyUnSuccessfulOutcomeValue/id-physicalChannelReconfiguration", HFILL }},
    { &hf_rnsap_id_radioLinkAddition2,
      { "id-radioLinkAddition", "rnsap.id_radioLinkAddition",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyUnSuccessfulOutcomeValue/id-radioLinkAddition", HFILL }},
    { &hf_rnsap_id_radioLinkAddition_TDD2,
      { "id-radioLinkAddition-TDD", "rnsap.id_radioLinkAddition_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyUnSuccessfulOutcomeValue/id-radioLinkAddition-TDD", HFILL }},
    { &hf_rnsap_id_radioLinkSetup2,
      { "id-radioLinkSetup", "rnsap.id_radioLinkSetup",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyUnSuccessfulOutcomeValue/id-radioLinkSetup", HFILL }},
    { &hf_rnsap_id_radioLinkSetupTdd2,
      { "id-radioLinkSetupTdd", "rnsap.id_radioLinkSetupTdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyUnSuccessfulOutcomeValue/id-radioLinkSetupTdd", HFILL }},
    { &hf_rnsap_id_synchronisedRadioLinkReconfigurationPreparation2,
      { "id-synchronisedRadioLinkReconfigurationPreparation", "rnsap.id_synchronisedRadioLinkReconfigurationPreparation",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyUnSuccessfulOutcomeValue/id-synchronisedRadioLinkReconfigurationPreparation", HFILL }},
    { &hf_rnsap_id_unSynchronisedRadioLinkReconfiguration2,
      { "id-unSynchronisedRadioLinkReconfiguration", "rnsap.id_unSynchronisedRadioLinkReconfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyUnSuccessfulOutcomeValue/id-unSynchronisedRadioLinkReconfiguration", HFILL }},
    { &hf_rnsap_id_unSynchronisedRadioLinkReconfiguration_TDD2,
      { "id-unSynchronisedRadioLinkReconfiguration-TDD", "rnsap.id_unSynchronisedRadioLinkReconfiguration_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyUnSuccessfulOutcomeValue/id-unSynchronisedRadioLinkReconfiguration-TDD", HFILL }},
    { &hf_rnsap_id_AllowedQueuingTime,
      { "id-AllowedQueuingTime", "rnsap.id_AllowedQueuingTime",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-AllowedQueuingTime", HFILL }},
    { &hf_rnsap_id_Allowed_Rate_Information,
      { "id-Allowed-Rate-Information", "rnsap.id_Allowed_Rate_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-Allowed-Rate-Information", HFILL }},
    { &hf_rnsap_id_AntennaColocationIndicator,
      { "id-AntennaColocationIndicator", "rnsap.id_AntennaColocationIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_AntennaColocationIndicator_vals), 0,
        "DummyProtocolIE/id-AntennaColocationIndicator", HFILL }},
    { &hf_rnsap_id_BindingID,
      { "id-BindingID", "rnsap.id_BindingID",
        FT_BYTES, BASE_HEX, NULL, 0,
        "DummyProtocolIE/id-BindingID", HFILL }},
    { &hf_rnsap_id_C_ID,
      { "id-C-ID", "rnsap.id_C_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-C-ID", HFILL }},
    { &hf_rnsap_id_C_RNTI,
      { "id-C-RNTI", "rnsap.id_C_RNTI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-C-RNTI", HFILL }},
    { &hf_rnsap_id_Cell_Capacity_Class_Value,
      { "id-Cell-Capacity-Class-Value", "rnsap.id_Cell_Capacity_Class_Value",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-Cell-Capacity-Class-Value", HFILL }},
    { &hf_rnsap_id_CFN,
      { "id-CFN", "rnsap.id_CFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-CFN", HFILL }},
    { &hf_rnsap_id_CN_CS_DomainIdentifier,
      { "id-CN-CS-DomainIdentifier", "rnsap.id_CN_CS_DomainIdentifier",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-CN-CS-DomainIdentifier", HFILL }},
    { &hf_rnsap_id_CN_PS_DomainIdentifier,
      { "id-CN-PS-DomainIdentifier", "rnsap.id_CN_PS_DomainIdentifier",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-CN-PS-DomainIdentifier", HFILL }},
    { &hf_rnsap_id_Cause,
      { "id-Cause", "rnsap.id_Cause",
        FT_UINT32, BASE_DEC, VALS(rnsap_Cause_vals), 0,
        "DummyProtocolIE/id-Cause", HFILL }},
    { &hf_rnsap_id_CoverageIndicator,
      { "id-CoverageIndicator", "rnsap.id_CoverageIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_CoverageIndicator_vals), 0,
        "DummyProtocolIE/id-CoverageIndicator", HFILL }},
    { &hf_rnsap_id_CriticalityDiagnostics,
      { "id-CriticalityDiagnostics", "rnsap.id_CriticalityDiagnostics",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-CriticalityDiagnostics", HFILL }},
    { &hf_rnsap_id_ContextInfoItem_Reset,
      { "id-ContextInfoItem-Reset", "rnsap.id_ContextInfoItem_Reset",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-ContextInfoItem-Reset", HFILL }},
    { &hf_rnsap_id_ContextGroupInfoItem_Reset,
      { "id-ContextGroupInfoItem-Reset", "rnsap.id_ContextGroupInfoItem_Reset",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-ContextGroupInfoItem-Reset", HFILL }},
    { &hf_rnsap_id_D_RNTI,
      { "id-D-RNTI", "rnsap.id_D_RNTI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-D-RNTI", HFILL }},
    { &hf_rnsap_id_D_RNTI_ReleaseIndication,
      { "id-D-RNTI-ReleaseIndication", "rnsap.id_D_RNTI_ReleaseIndication",
        FT_UINT32, BASE_DEC, VALS(rnsap_D_RNTI_ReleaseIndication_vals), 0,
        "DummyProtocolIE/id-D-RNTI-ReleaseIndication", HFILL }},
    { &hf_rnsap_id_DCHs_to_Add_FDD,
      { "id-DCHs-to-Add-FDD", "rnsap.id_DCHs_to_Add_FDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DCHs-to-Add-FDD", HFILL }},
    { &hf_rnsap_id_DCHs_to_Add_TDD,
      { "id-DCHs-to-Add-TDD", "rnsap.id_DCHs_to_Add_TDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DCHs-to-Add-TDD", HFILL }},
    { &hf_rnsap_id_DCH_DeleteList_RL_ReconfPrepFDD,
      { "id-DCH-DeleteList-RL-ReconfPrepFDD", "rnsap.id_DCH_DeleteList_RL_ReconfPrepFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DCH-DeleteList-RL-ReconfPrepFDD", HFILL }},
    { &hf_rnsap_id_DCH_DeleteList_RL_ReconfPrepTDD,
      { "id-DCH-DeleteList-RL-ReconfPrepTDD", "rnsap.id_DCH_DeleteList_RL_ReconfPrepTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DCH-DeleteList-RL-ReconfPrepTDD", HFILL }},
    { &hf_rnsap_id_DCH_DeleteList_RL_ReconfRqstFDD,
      { "id-DCH-DeleteList-RL-ReconfRqstFDD", "rnsap.id_DCH_DeleteList_RL_ReconfRqstFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DCH-DeleteList-RL-ReconfRqstFDD", HFILL }},
    { &hf_rnsap_id_DCH_DeleteList_RL_ReconfRqstTDD,
      { "id-DCH-DeleteList-RL-ReconfRqstTDD", "rnsap.id_DCH_DeleteList_RL_ReconfRqstTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DCH-DeleteList-RL-ReconfRqstTDD", HFILL }},
    { &hf_rnsap_id_DCH_FDD_Information,
      { "id-DCH-FDD-Information", "rnsap.id_DCH_FDD_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DCH-FDD-Information", HFILL }},
    { &hf_rnsap_id_DCH_TDD_Information,
      { "id-DCH-TDD-Information", "rnsap.id_DCH_TDD_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DCH-TDD-Information", HFILL }},
    { &hf_rnsap_id_FDD_DCHs_to_Modify,
      { "id-FDD-DCHs-to-Modify", "rnsap.id_FDD_DCHs_to_Modify",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-FDD-DCHs-to-Modify", HFILL }},
    { &hf_rnsap_id_TDD_DCHs_to_Modify,
      { "id-TDD-DCHs-to-Modify", "rnsap.id_TDD_DCHs_to_Modify",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-TDD-DCHs-to-Modify", HFILL }},
    { &hf_rnsap_id_DCH_InformationResponse,
      { "id-DCH-InformationResponse", "rnsap.id_DCH_InformationResponse",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DCH-InformationResponse", HFILL }},
    { &hf_rnsap_id_DCH_Rate_InformationItem_RL_CongestInd,
      { "id-DCH-Rate-InformationItem-RL-CongestInd", "rnsap.id_DCH_Rate_InformationItem_RL_CongestInd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DCH-Rate-InformationItem-RL-CongestInd", HFILL }},
    { &hf_rnsap_id_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD,
      { "id-DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD", "rnsap.id_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD", HFILL }},
    { &hf_rnsap_id_DL_CCTrCH_InformationListIE_RL_ReconfReadyTDD,
      { "id-DL-CCTrCH-InformationListIE-RL-ReconfReadyTDD", "rnsap.id_DL_CCTrCH_InformationListIE_RL_ReconfReadyTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DL-CCTrCH-InformationListIE-RL-ReconfReadyTDD", HFILL }},
    { &hf_rnsap_id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
      { "id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD", "rnsap.id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD", HFILL }},
    { &hf_rnsap_id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD,
      { "id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD", "rnsap.id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD", HFILL }},
    { &hf_rnsap_id_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD,
      { "id-DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD", "rnsap.id_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD", HFILL }},
    { &hf_rnsap_id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD,
      { "id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD", "rnsap.id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD", HFILL }},
    { &hf_rnsap_id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD,
      { "id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD", "rnsap.id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD", HFILL }},
    { &hf_rnsap_id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
      { "id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD", "rnsap.id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD", HFILL }},
    { &hf_rnsap_id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
      { "id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD", "rnsap.id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD", HFILL }},
    { &hf_rnsap_id_DL_CCTrCH_InformationList_RL_SetupRqstTDD,
      { "id-DL-CCTrCH-InformationList-RL-SetupRqstTDD", "rnsap.id_DL_CCTrCH_InformationList_RL_SetupRqstTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DL-CCTrCH-InformationList-RL-SetupRqstTDD", HFILL }},
    { &hf_rnsap_id_FDD_DL_CodeInformation,
      { "id-FDD-DL-CodeInformation", "rnsap.id_FDD_DL_CodeInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-FDD-DL-CodeInformation", HFILL }},
    { &hf_rnsap_id_DL_DPCH_Information_RL_ReconfPrepFDD,
      { "id-DL-DPCH-Information-RL-ReconfPrepFDD", "rnsap.id_DL_DPCH_Information_RL_ReconfPrepFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-DPCH-Information-RL-ReconfPrepFDD", HFILL }},
    { &hf_rnsap_id_DL_DPCH_Information_RL_SetupRqstFDD,
      { "id-DL-DPCH-Information-RL-SetupRqstFDD", "rnsap.id_DL_DPCH_Information_RL_SetupRqstFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-DPCH-Information-RL-SetupRqstFDD", HFILL }},
    { &hf_rnsap_id_DL_DPCH_Information_RL_ReconfRqstFDD,
      { "id-DL-DPCH-Information-RL-ReconfRqstFDD", "rnsap.id_DL_DPCH_Information_RL_ReconfRqstFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-DPCH-Information-RL-ReconfRqstFDD", HFILL }},
    { &hf_rnsap_id_DL_DPCH_InformationItem_PhyChReconfRqstTDD,
      { "id-DL-DPCH-InformationItem-PhyChReconfRqstTDD", "rnsap.id_DL_DPCH_InformationItem_PhyChReconfRqstTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-DPCH-InformationItem-PhyChReconfRqstTDD", HFILL }},
    { &hf_rnsap_id_DL_DPCH_InformationItem_RL_AdditionRspTDD,
      { "id-DL-DPCH-InformationItem-RL-AdditionRspTDD", "rnsap.id_DL_DPCH_InformationItem_RL_AdditionRspTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-DPCH-InformationItem-RL-AdditionRspTDD", HFILL }},
    { &hf_rnsap_id_DL_DPCH_InformationItem_RL_SetupRspTDD,
      { "id-DL-DPCH-InformationItem-RL-SetupRspTDD", "rnsap.id_DL_DPCH_InformationItem_RL_SetupRspTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-DPCH-InformationItem-RL-SetupRspTDD", HFILL }},
    { &hf_rnsap_id_DL_DPCH_TimingAdjustment,
      { "id-DL-DPCH-TimingAdjustment", "rnsap.id_DL_DPCH_TimingAdjustment",
        FT_UINT32, BASE_DEC, VALS(rnsap_DL_DPCH_TimingAdjustment_vals), 0,
        "DummyProtocolIE/id-DL-DPCH-TimingAdjustment", HFILL }},
    { &hf_rnsap_id_DLReferencePower,
      { "id-DLReferencePower", "rnsap.id_DLReferencePower",
        FT_INT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DLReferencePower", HFILL }},
    { &hf_rnsap_id_DLReferencePowerList_DL_PC_Rqst,
      { "id-DLReferencePowerList-DL-PC-Rqst", "rnsap.id_DLReferencePowerList_DL_PC_Rqst",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DLReferencePowerList-DL-PC-Rqst", HFILL }},
    { &hf_rnsap_id_DL_ReferencePowerInformation_DL_PC_Rqst,
      { "id-DL-ReferencePowerInformation-DL-PC-Rqst", "rnsap.id_DL_ReferencePowerInformation_DL_PC_Rqst",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-DL-ReferencePowerInformation-DL-PC-Rqst", HFILL }},
    { &hf_rnsap_id_DPC_Mode,
      { "id-DPC-Mode", "rnsap.id_DPC_Mode",
        FT_UINT32, BASE_DEC, VALS(rnsap_DPC_Mode_vals), 0,
        "DummyProtocolIE/id-DPC-Mode", HFILL }},
    { &hf_rnsap_id_DRXCycleLengthCoefficient,
      { "id-DRXCycleLengthCoefficient", "rnsap.id_DRXCycleLengthCoefficient",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-DRXCycleLengthCoefficient", HFILL }},
    { &hf_rnsap_id_DedicatedMeasurementObjectType_DM_Fail_Ind,
      { "id-DedicatedMeasurementObjectType-DM-Fail-Ind", "rnsap.id_DedicatedMeasurementObjectType_DM_Fail_Ind",
        FT_UINT32, BASE_DEC, VALS(rnsap_DedicatedMeasurementObjectType_DM_Fail_Ind_vals), 0,
        "DummyProtocolIE/id-DedicatedMeasurementObjectType-DM-Fail-Ind", HFILL }},
    { &hf_rnsap_id_DedicatedMeasurementObjectType_DM_Fail,
      { "id-DedicatedMeasurementObjectType-DM-Fail", "rnsap.id_DedicatedMeasurementObjectType_DM_Fail",
        FT_UINT32, BASE_DEC, VALS(rnsap_DedicatedMeasurementObjectType_DM_Fail_vals), 0,
        "DummyProtocolIE/id-DedicatedMeasurementObjectType-DM-Fail", HFILL }},
    { &hf_rnsap_id_DedicatedMeasurementObjectType_DM_Rprt,
      { "id-DedicatedMeasurementObjectType-DM-Rprt", "rnsap.id_DedicatedMeasurementObjectType_DM_Rprt",
        FT_UINT32, BASE_DEC, VALS(rnsap_DedicatedMeasurementObjectType_DM_Rprt_vals), 0,
        "DummyProtocolIE/id-DedicatedMeasurementObjectType-DM-Rprt", HFILL }},
    { &hf_rnsap_id_DedicatedMeasurementObjectType_DM_Rqst,
      { "id-DedicatedMeasurementObjectType-DM-Rqst", "rnsap.id_DedicatedMeasurementObjectType_DM_Rqst",
        FT_UINT32, BASE_DEC, VALS(rnsap_DedicatedMeasurementObjectType_DM_Rqst_vals), 0,
        "DummyProtocolIE/id-DedicatedMeasurementObjectType-DM-Rqst", HFILL }},
    { &hf_rnsap_id_DedicatedMeasurementObjectType_DM_Rsp,
      { "id-DedicatedMeasurementObjectType-DM-Rsp", "rnsap.id_DedicatedMeasurementObjectType_DM_Rsp",
        FT_UINT32, BASE_DEC, VALS(rnsap_DedicatedMeasurementObjectType_DM_Rsp_vals), 0,
        "DummyProtocolIE/id-DedicatedMeasurementObjectType-DM-Rsp", HFILL }},
    { &hf_rnsap_id_DedicatedMeasurementType,
      { "id-DedicatedMeasurementType", "rnsap.id_DedicatedMeasurementType",
        FT_UINT32, BASE_DEC, VALS(rnsap_DedicatedMeasurementType_vals), 0,
        "DummyProtocolIE/id-DedicatedMeasurementType", HFILL }},
    { &hf_rnsap_id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD,
      { "id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD", "rnsap.id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD", HFILL }},
    { &hf_rnsap_id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD,
      { "id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD", "rnsap.id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD", HFILL }},
    { &hf_rnsap_id_Guaranteed_Rate_Information,
      { "id-Guaranteed-Rate-Information", "rnsap.id_Guaranteed_Rate_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-Guaranteed-Rate-Information", HFILL }},
    { &hf_rnsap_id_IMSI,
      { "id-IMSI", "rnsap.id_IMSI",
        FT_BYTES, BASE_HEX, NULL, 0,
        "DummyProtocolIE/id-IMSI", HFILL }},
    { &hf_rnsap_id_HCS_Prio,
      { "id-HCS-Prio", "rnsap.id_HCS_Prio",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-HCS-Prio", HFILL }},
    { &hf_rnsap_id_L3_Information,
      { "id-L3-Information", "rnsap.id_L3_Information",
        FT_BYTES, BASE_HEX, NULL, 0,
        "DummyProtocolIE/id-L3-Information", HFILL }},
    { &hf_rnsap_id_AdjustmentPeriod,
      { "id-AdjustmentPeriod", "rnsap.id_AdjustmentPeriod",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-AdjustmentPeriod", HFILL }},
    { &hf_rnsap_id_MaxAdjustmentStep,
      { "id-MaxAdjustmentStep", "rnsap.id_MaxAdjustmentStep",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-MaxAdjustmentStep", HFILL }},
    { &hf_rnsap_id_MeasurementFilterCoefficient,
      { "id-MeasurementFilterCoefficient", "rnsap.id_MeasurementFilterCoefficient",
        FT_UINT32, BASE_DEC, VALS(rnsap_MeasurementFilterCoefficient_vals), 0,
        "DummyProtocolIE/id-MeasurementFilterCoefficient", HFILL }},
    { &hf_rnsap_id_MessageStructure,
      { "id-MessageStructure", "rnsap.id_MessageStructure",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-MessageStructure", HFILL }},
    { &hf_rnsap_id_MeasurementID,
      { "id-MeasurementID", "rnsap.id_MeasurementID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-MeasurementID", HFILL }},
    { &hf_rnsap_id_Neighbouring_GSM_CellInformation,
      { "id-Neighbouring-GSM-CellInformation", "rnsap.id_Neighbouring_GSM_CellInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-Neighbouring-GSM-CellInformation", HFILL }},
    { &hf_rnsap_id_Neighbouring_UMTS_CellInformationItem,
      { "id-Neighbouring-UMTS-CellInformationItem", "rnsap.id_Neighbouring_UMTS_CellInformationItem",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-Neighbouring-UMTS-CellInformationItem", HFILL }},
    { &hf_rnsap_id_NRT_Load_Information_Value,
      { "id-NRT-Load-Information-Value", "rnsap.id_NRT_Load_Information_Value",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-NRT-Load-Information-Value", HFILL }},
    { &hf_rnsap_id_NRT_Load_Information_Value_IncrDecrThres,
      { "id-NRT-Load-Information-Value-IncrDecrThres", "rnsap.id_NRT_Load_Information_Value_IncrDecrThres",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-NRT-Load-Information-Value-IncrDecrThres", HFILL }},
    { &hf_rnsap_id_PagingArea_PagingRqst,
      { "id-PagingArea-PagingRqst", "rnsap.id_PagingArea_PagingRqst",
        FT_UINT32, BASE_DEC, VALS(rnsap_PagingArea_PagingRqst_vals), 0,
        "DummyProtocolIE/id-PagingArea-PagingRqst", HFILL }},
    { &hf_rnsap_id_FACH_FlowControlInformation,
      { "id-FACH-FlowControlInformation", "rnsap.id_FACH_FlowControlInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-FACH-FlowControlInformation", HFILL }},
    { &hf_rnsap_id_PartialReportingIndicator,
      { "id-PartialReportingIndicator", "rnsap.id_PartialReportingIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_PartialReportingIndicator_vals), 0,
        "DummyProtocolIE/id-PartialReportingIndicator", HFILL }},
    { &hf_rnsap_id_Permanent_NAS_UE_Identity,
      { "id-Permanent-NAS-UE-Identity", "rnsap.id_Permanent_NAS_UE_Identity",
        FT_UINT32, BASE_DEC, VALS(rnsap_Permanent_NAS_UE_Identity_vals), 0,
        "DummyProtocolIE/id-Permanent-NAS-UE-Identity", HFILL }},
    { &hf_rnsap_id_PowerAdjustmentType,
      { "id-PowerAdjustmentType", "rnsap.id_PowerAdjustmentType",
        FT_UINT32, BASE_DEC, VALS(rnsap_PowerAdjustmentType_vals), 0,
        "DummyProtocolIE/id-PowerAdjustmentType", HFILL }},
    { &hf_rnsap_id_RANAP_RelocationInformation,
      { "id-RANAP-RelocationInformation", "rnsap.id_RANAP_RelocationInformation",
        FT_BYTES, BASE_HEX, NULL, 0,
        "DummyProtocolIE/id-RANAP-RelocationInformation", HFILL }},
    { &hf_rnsap_id_RL_Information_PhyChReconfRqstFDD,
      { "id-RL-Information-PhyChReconfRqstFDD", "rnsap.id_RL_Information_PhyChReconfRqstFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Information-PhyChReconfRqstFDD", HFILL }},
    { &hf_rnsap_id_RL_Information_PhyChReconfRqstTDD,
      { "id-RL-Information-PhyChReconfRqstTDD", "rnsap.id_RL_Information_PhyChReconfRqstTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Information-PhyChReconfRqstTDD", HFILL }},
    { &hf_rnsap_id_RL_Information_RL_AdditionRqstFDD,
      { "id-RL-Information-RL-AdditionRqstFDD", "rnsap.id_RL_Information_RL_AdditionRqstFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Information-RL-AdditionRqstFDD", HFILL }},
    { &hf_rnsap_id_RL_Information_RL_AdditionRqstTDD,
      { "id-RL-Information-RL-AdditionRqstTDD", "rnsap.id_RL_Information_RL_AdditionRqstTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Information-RL-AdditionRqstTDD", HFILL }},
    { &hf_rnsap_id_RL_Information_RL_DeletionRqst,
      { "id-RL-Information-RL-DeletionRqst", "rnsap.id_RL_Information_RL_DeletionRqst",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Information-RL-DeletionRqst", HFILL }},
    { &hf_rnsap_id_RL_Information_RL_FailureInd,
      { "id-RL-Information-RL-FailureInd", "rnsap.id_RL_Information_RL_FailureInd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Information-RL-FailureInd", HFILL }},
    { &hf_rnsap_id_RL_Information_RL_ReconfPrepFDD,
      { "id-RL-Information-RL-ReconfPrepFDD", "rnsap.id_RL_Information_RL_ReconfPrepFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Information-RL-ReconfPrepFDD", HFILL }},
    { &hf_rnsap_id_RL_Information_RL_RestoreInd,
      { "id-RL-Information-RL-RestoreInd", "rnsap.id_RL_Information_RL_RestoreInd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Information-RL-RestoreInd", HFILL }},
    { &hf_rnsap_id_RL_Information_RL_SetupRqstFDD,
      { "id-RL-Information-RL-SetupRqstFDD", "rnsap.id_RL_Information_RL_SetupRqstFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RL-Information-RL-SetupRqstFDD", HFILL }},
    { &hf_rnsap_id_RL_Information_RL_SetupRqstTDD,
      { "id-RL-Information-RL-SetupRqstTDD", "rnsap.id_RL_Information_RL_SetupRqstTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Information-RL-SetupRqstTDD", HFILL }},
    { &hf_rnsap_id_RL_InformationItem_RL_CongestInd,
      { "id-RL-InformationItem-RL-CongestInd", "rnsap.id_RL_InformationItem_RL_CongestInd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationItem-RL-CongestInd", HFILL }},
    { &hf_rnsap_id_RL_InformationItem_DM_Rprt,
      { "id-RL-InformationItem-DM-Rprt", "rnsap.id_RL_InformationItem_DM_Rprt",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationItem-DM-Rprt", HFILL }},
    { &hf_rnsap_id_RL_InformationItem_DM_Rqst,
      { "id-RL-InformationItem-DM-Rqst", "rnsap.id_RL_InformationItem_DM_Rqst",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationItem-DM-Rqst", HFILL }},
    { &hf_rnsap_id_RL_InformationItem_DM_Rsp,
      { "id-RL-InformationItem-DM-Rsp", "rnsap.id_RL_InformationItem_DM_Rsp",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationItem-DM-Rsp", HFILL }},
    { &hf_rnsap_id_RL_InformationItem_RL_PreemptRequiredInd,
      { "id-RL-InformationItem-RL-PreemptRequiredInd", "rnsap.id_RL_InformationItem_RL_PreemptRequiredInd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationItem-RL-PreemptRequiredInd", HFILL }},
    { &hf_rnsap_id_RL_InformationItem_RL_SetupRqstFDD,
      { "id-RL-InformationItem-RL-SetupRqstFDD", "rnsap.id_RL_InformationItem_RL_SetupRqstFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationItem-RL-SetupRqstFDD", HFILL }},
    { &hf_rnsap_id_RL_InformationList_RL_CongestInd,
      { "id-RL-InformationList-RL-CongestInd", "rnsap.id_RL_InformationList_RL_CongestInd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RL-InformationList-RL-CongestInd", HFILL }},
    { &hf_rnsap_id_RL_InformationList_RL_AdditionRqstFDD,
      { "id-RL-InformationList-RL-AdditionRqstFDD", "rnsap.id_RL_InformationList_RL_AdditionRqstFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RL-InformationList-RL-AdditionRqstFDD", HFILL }},
    { &hf_rnsap_id_RL_InformationList_RL_DeletionRqst,
      { "id-RL-InformationList-RL-DeletionRqst", "rnsap.id_RL_InformationList_RL_DeletionRqst",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RL-InformationList-RL-DeletionRqst", HFILL }},
    { &hf_rnsap_id_RL_InformationList_RL_PreemptRequiredInd,
      { "id-RL-InformationList-RL-PreemptRequiredInd", "rnsap.id_RL_InformationList_RL_PreemptRequiredInd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RL-InformationList-RL-PreemptRequiredInd", HFILL }},
    { &hf_rnsap_id_RL_InformationList_RL_ReconfPrepFDD,
      { "id-RL-InformationList-RL-ReconfPrepFDD", "rnsap.id_RL_InformationList_RL_ReconfPrepFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RL-InformationList-RL-ReconfPrepFDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponse_RL_AdditionRspTDD,
      { "id-RL-InformationResponse-RL-AdditionRspTDD", "rnsap.id_RL_InformationResponse_RL_AdditionRspTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponse-RL-AdditionRspTDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponse_RL_ReconfReadyTDD,
      { "id-RL-InformationResponse-RL-ReconfReadyTDD", "rnsap.id_RL_InformationResponse_RL_ReconfReadyTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponse-RL-ReconfReadyTDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponse_RL_SetupRspTDD,
      { "id-RL-InformationResponse-RL-SetupRspTDD", "rnsap.id_RL_InformationResponse_RL_SetupRspTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponse-RL-SetupRspTDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponseItem_RL_AdditionRspFDD,
      { "id-RL-InformationResponseItem-RL-AdditionRspFDD", "rnsap.id_RL_InformationResponseItem_RL_AdditionRspFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponseItem-RL-AdditionRspFDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponseItem_RL_ReconfReadyFDD,
      { "id-RL-InformationResponseItem-RL-ReconfReadyFDD", "rnsap.id_RL_InformationResponseItem_RL_ReconfReadyFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponseItem-RL-ReconfReadyFDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponseItem_RL_ReconfRspFDD,
      { "id-RL-InformationResponseItem-RL-ReconfRspFDD", "rnsap.id_RL_InformationResponseItem_RL_ReconfRspFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponseItem-RL-ReconfRspFDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponseItem_RL_SetupRspFDD,
      { "id-RL-InformationResponseItem-RL-SetupRspFDD", "rnsap.id_RL_InformationResponseItem_RL_SetupRspFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponseItem-RL-SetupRspFDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponseList_RL_AdditionRspFDD,
      { "id-RL-InformationResponseList-RL-AdditionRspFDD", "rnsap.id_RL_InformationResponseList_RL_AdditionRspFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponseList-RL-AdditionRspFDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponseList_RL_ReconfReadyFDD,
      { "id-RL-InformationResponseList-RL-ReconfReadyFDD", "rnsap.id_RL_InformationResponseList_RL_ReconfReadyFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponseList-RL-ReconfReadyFDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponseList_RL_ReconfRspFDD,
      { "id-RL-InformationResponseList-RL-ReconfRspFDD", "rnsap.id_RL_InformationResponseList_RL_ReconfRspFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponseList-RL-ReconfRspFDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponse_RL_ReconfRspTDD,
      { "id-RL-InformationResponse-RL-ReconfRspTDD", "rnsap.id_RL_InformationResponse_RL_ReconfRspTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponse-RL-ReconfRspTDD", HFILL }},
    { &hf_rnsap_id_RL_InformationResponseList_RL_SetupRspFDD,
      { "id-RL-InformationResponseList-RL-SetupRspFDD", "rnsap.id_RL_InformationResponseList_RL_SetupRspFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RL-InformationResponseList-RL-SetupRspFDD", HFILL }},
    { &hf_rnsap_id_RL_ReconfigurationFailure_RL_ReconfFail,
      { "id-RL-ReconfigurationFailure-RL-ReconfFail", "rnsap.id_RL_ReconfigurationFailure_RL_ReconfFail",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-ReconfigurationFailure-RL-ReconfFail", HFILL }},
    { &hf_rnsap_id_RL_Set_InformationItem_DM_Rprt,
      { "id-RL-Set-InformationItem-DM-Rprt", "rnsap.id_RL_Set_InformationItem_DM_Rprt",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Set-InformationItem-DM-Rprt", HFILL }},
    { &hf_rnsap_id_RL_Set_InformationItem_DM_Rqst,
      { "id-RL-Set-InformationItem-DM-Rqst", "rnsap.id_RL_Set_InformationItem_DM_Rqst",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Set-InformationItem-DM-Rqst", HFILL }},
    { &hf_rnsap_id_RL_Set_InformationItem_DM_Rsp,
      { "id-RL-Set-InformationItem-DM-Rsp", "rnsap.id_RL_Set_InformationItem_DM_Rsp",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Set-InformationItem-DM-Rsp", HFILL }},
    { &hf_rnsap_id_RL_Set_Information_RL_FailureInd,
      { "id-RL-Set-Information-RL-FailureInd", "rnsap.id_RL_Set_Information_RL_FailureInd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Set-Information-RL-FailureInd", HFILL }},
    { &hf_rnsap_id_RL_Set_Information_RL_RestoreInd,
      { "id-RL-Set-Information-RL-RestoreInd", "rnsap.id_RL_Set_Information_RL_RestoreInd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Set-Information-RL-RestoreInd", HFILL }},
    { &hf_rnsap_id_RL_Set_Successful_InformationItem_DM_Fail,
      { "id-RL-Set-Successful-InformationItem-DM-Fail", "rnsap.id_RL_Set_Successful_InformationItem_DM_Fail",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Set-Successful-InformationItem-DM-Fail", HFILL }},
    { &hf_rnsap_id_RL_Set_Unsuccessful_InformationItem_DM_Fail,
      { "id-RL-Set-Unsuccessful-InformationItem-DM-Fail", "rnsap.id_RL_Set_Unsuccessful_InformationItem_DM_Fail",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Set-Unsuccessful-InformationItem-DM-Fail", HFILL }},
    { &hf_rnsap_id_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind,
      { "id-RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind", "rnsap.id_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind", HFILL }},
    { &hf_rnsap_id_RL_Successful_InformationItem_DM_Fail,
      { "id-RL-Successful-InformationItem-DM-Fail", "rnsap.id_RL_Successful_InformationItem_DM_Fail",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Successful-InformationItem-DM-Fail", HFILL }},
    { &hf_rnsap_id_RL_Unsuccessful_InformationItem_DM_Fail,
      { "id-RL-Unsuccessful-InformationItem-DM-Fail", "rnsap.id_RL_Unsuccessful_InformationItem_DM_Fail",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-RL-Unsuccessful-InformationItem-DM-Fail", HFILL }},
    { &hf_rnsap_id_RT_Load_Value,
      { "id-RT-Load-Value", "rnsap.id_RT_Load_Value",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RT-Load-Value", HFILL }},
    { &hf_rnsap_id_RT_Load_Value_IncrDecrThres,
      { "id-RT-Load-Value-IncrDecrThres", "rnsap.id_RT_Load_Value_IncrDecrThres",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RT-Load-Value-IncrDecrThres", HFILL }},
    { &hf_rnsap_id_S_RNTI,
      { "id-S-RNTI", "rnsap.id_S_RNTI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-S-RNTI", HFILL }},
    { &hf_rnsap_id_ResetIndicator,
      { "id-ResetIndicator", "rnsap.id_ResetIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_ResetIndicator_vals), 0,
        "DummyProtocolIE/id-ResetIndicator", HFILL }},
    { &hf_rnsap_id_RNC_ID,
      { "id-RNC-ID", "rnsap.id_RNC_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-RNC-ID", HFILL }},
    { &hf_rnsap_id_SAI,
      { "id-SAI", "rnsap.id_SAI",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-SAI", HFILL }},
    { &hf_rnsap_id_SRNC_ID,
      { "id-SRNC-ID", "rnsap.id_SRNC_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-SRNC-ID", HFILL }},
    { &hf_rnsap_id_UL_DPCH_Information_RL_SetupRqstFDD,
      { "id-UL-DPCH-Information-RL-SetupRqstFDD", "rnsap.id_UL_DPCH_Information_RL_SetupRqstFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-UL-DPCH-Information-RL-SetupRqstFDD", HFILL }},
    { &hf_rnsap_id_Old_URA_ID,
      { "id-Old-URA-ID", "rnsap.id_Old_URA_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-Old-URA-ID", HFILL }},
    { &hf_rnsap_id_UE_State,
      { "id-UE-State", "rnsap.id_UE_State",
        FT_UINT32, BASE_DEC, VALS(rnsap_UE_State_vals), 0,
        "DummyProtocolIE/id-UE-State", HFILL }},
    { &hf_rnsap_id_URA_ID,
      { "id-URA-ID", "rnsap.id_URA_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-URA-ID", HFILL }},
    { &hf_rnsap_id_HARQ_Preamble_Mode,
      { "id-HARQ-Preamble-Mode", "rnsap.id_HARQ_Preamble_Mode",
        FT_UINT32, BASE_DEC, VALS(rnsap_HARQ_Preamble_Mode_vals), 0,
        "DummyProtocolIE/id-HARQ-Preamble-Mode", HFILL }},
    { &hf_rnsap_id_SynchronisationIndicator,
      { "id-SynchronisationIndicator", "rnsap.id_SynchronisationIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_SynchronisationIndicator_vals), 0,
        "DummyProtocolIE/id-SynchronisationIndicator", HFILL }},
    { &hf_rnsap_id_UL_DPDCHIndicatorEDCH,
      { "id-UL-DPDCHIndicatorEDCH", "rnsap.id_UL_DPDCHIndicatorEDCH",
        FT_UINT32, BASE_DEC, VALS(rnsap_UL_DPDCHIndicatorEDCH_vals), 0,
        "DummyProtocolIE/id-UL-DPDCHIndicatorEDCH", HFILL }},
    { &hf_rnsap_id_EDPCH_Information_RLReconfRequest_FDD,
      { "id-EDPCH-Information-RLReconfRequest-FDD", "rnsap.id_EDPCH_Information_RLReconfRequest_FDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-EDPCH-Information-RLReconfRequest-FDD", HFILL }},
    { &hf_rnsap_id_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd,
      { "id-EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd", "rnsap.id_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd", HFILL }},
    { &hf_rnsap_id_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd,
      { "id-EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd", "rnsap.id_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd", HFILL }},
    { &hf_rnsap_id_EDCH_MacdFlowSpecificInformationList_RL_CongestInd,
      { "id-EDCH-MacdFlowSpecificInformationList-RL-CongestInd", "rnsap.id_EDCH_MacdFlowSpecificInformationList_RL_CongestInd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-EDCH-MacdFlowSpecificInformationList-RL-CongestInd", HFILL }},
    { &hf_rnsap_id_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd,
      { "id-EDCH-MacdFlowSpecificInformationItem-RL-CongestInd", "rnsap.id_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-EDCH-MacdFlowSpecificInformationItem-RL-CongestInd", HFILL }},
    { &hf_rnsap_id_MBMS_Bearer_Service_Full_Address,
      { "id-MBMS-Bearer-Service-Full-Address", "rnsap.id_MBMS_Bearer_Service_Full_Address",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-MBMS-Bearer-Service-Full-Address", HFILL }},
    { &hf_rnsap_id_Initial_DL_DPCH_TimingAdjustment,
      { "id-Initial-DL-DPCH-TimingAdjustment", "rnsap.id_Initial_DL_DPCH_TimingAdjustment",
        FT_UINT32, BASE_DEC, VALS(rnsap_DL_DPCH_TimingAdjustment_vals), 0,
        "DummyProtocolIE/id-Initial-DL-DPCH-TimingAdjustment", HFILL }},
    { &hf_rnsap_id_Initial_DL_DPCH_TimingAdjustment_Allowed,
      { "id-Initial-DL-DPCH-TimingAdjustment-Allowed", "rnsap.id_Initial_DL_DPCH_TimingAdjustment_Allowed",
        FT_UINT32, BASE_DEC, VALS(rnsap_Initial_DL_DPCH_TimingAdjustment_Allowed_vals), 0,
        "DummyProtocolIE/id-Initial-DL-DPCH-TimingAdjustment-Allowed", HFILL }},
    { &hf_rnsap_id_User_Plane_Congestion_Fields_Inclusion,
      { "id-User-Plane-Congestion-Fields-Inclusion", "rnsap.id_User_Plane_Congestion_Fields_Inclusion",
        FT_UINT32, BASE_DEC, VALS(rnsap_User_Plane_Congestion_Fields_Inclusion_vals), 0,
        "DummyProtocolIE/id-User-Plane-Congestion-Fields-Inclusion", HFILL }},
    { &hf_rnsap_id_HARQ_Preamble_Mode_Activation_Indicator,
      { "id-HARQ-Preamble-Mode-Activation-Indicator", "rnsap.id_HARQ_Preamble_Mode_Activation_Indicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_HARQ_Preamble_Mode_Activation_Indicator_vals), 0,
        "DummyProtocolIE/id-HARQ-Preamble-Mode-Activation-Indicator", HFILL }},
    { &hf_rnsap_id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp,
      { "id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp", "rnsap.id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp", HFILL }},
    { &hf_rnsap_id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp,
      { "id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp", "rnsap.id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp", HFILL }},
    { &hf_rnsap_id_ProvidedInformation,
      { "id-ProvidedInformation", "rnsap.id_ProvidedInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "DummyProtocolIE/id-ProvidedInformation", HFILL }},
    { &hf_rnsap_id_Active_MBMS_Bearer_ServiceFDD_PFL,
      { "id-Active-MBMS-Bearer-ServiceFDD-PFL", "rnsap.id_Active_MBMS_Bearer_ServiceFDD_PFL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-Active-MBMS-Bearer-ServiceFDD-PFL", HFILL }},
    { &hf_rnsap_id_Active_MBMS_Bearer_ServiceTDD_PFL,
      { "id-Active-MBMS-Bearer-ServiceTDD-PFL", "rnsap.id_Active_MBMS_Bearer_ServiceTDD_PFL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DummyProtocolIE/id-Active-MBMS-Bearer-ServiceTDD-PFL", HFILL }},
    { &hf_rnsap_id_FrequencyBandIndicator,
      { "id-FrequencyBandIndicator", "rnsap.id_FrequencyBandIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_FrequencyBandIndicator_vals), 0,
        "DummyProtocolIE/id-FrequencyBandIndicator", HFILL }},
    { &hf_rnsap_protocolIEs,
      { "protocolIEs", "rnsap.protocolIEs",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_protocolExtensions,
      { "protocolExtensions", "rnsap.protocolExtensions",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_ScramblingCode,
      { "ul-ScramblingCode", "rnsap.ul_ScramblingCode",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_minUL_ChannelisationCodeLength,
      { "minUL-ChannelisationCodeLength", "rnsap.minUL_ChannelisationCodeLength",
        FT_UINT32, BASE_DEC, VALS(rnsap_MinUL_ChannelisationCodeLength_vals), 0,
        "", HFILL }},
    { &hf_rnsap_maxNrOfUL_DPCHs,
      { "maxNrOfUL-DPCHs", "rnsap.maxNrOfUL_DPCHs",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-DPCH-Information-RL-SetupRqstFDD/maxNrOfUL-DPCHs", HFILL }},
    { &hf_rnsap_ul_PunctureLimit,
      { "ul-PunctureLimit", "rnsap.ul_PunctureLimit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_TFCS,
      { "ul-TFCS", "rnsap.ul_TFCS",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_DPCCH_SlotFormat,
      { "ul-DPCCH-SlotFormat", "rnsap.ul_DPCCH_SlotFormat",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_SIRTarget,
      { "ul-SIRTarget", "rnsap.ul_SIRTarget",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_diversityMode,
      { "diversityMode", "rnsap.diversityMode",
        FT_UINT32, BASE_DEC, VALS(rnsap_DiversityMode_vals), 0,
        "", HFILL }},
    { &hf_rnsap_not_Used_sSDT_CellIdLength,
      { "not-Used-sSDT-CellIdLength", "rnsap.not_Used_sSDT_CellIdLength",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-DPCH-Information-RL-SetupRqstFDD/not-Used-sSDT-CellIdLength", HFILL }},
    { &hf_rnsap_not_Used_s_FieldLength,
      { "not-Used-s-FieldLength", "rnsap.not_Used_s_FieldLength",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_iE_Extensions,
      { "iE-Extensions", "rnsap.iE_Extensions",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tFCS,
      { "tFCS", "rnsap.tFCS",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dl_DPCH_SlotFormat,
      { "dl-DPCH-SlotFormat", "rnsap.dl_DPCH_SlotFormat",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_nrOfDLchannelisationcodes,
      { "nrOfDLchannelisationcodes", "rnsap.nrOfDLchannelisationcodes",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tFCI_SignallingMode,
      { "tFCI-SignallingMode", "rnsap.tFCI_SignallingMode",
        FT_UINT32, BASE_DEC, VALS(rnsap_TFCI_SignallingMode_vals), 0,
        "", HFILL }},
    { &hf_rnsap_tFCI_Presence,
      { "tFCI-Presence", "rnsap.tFCI_Presence",
        FT_UINT32, BASE_DEC, VALS(rnsap_TFCI_Presence_vals), 0,
        "", HFILL }},
    { &hf_rnsap_multiplexingPosition,
      { "multiplexingPosition", "rnsap.multiplexingPosition",
        FT_UINT32, BASE_DEC, VALS(rnsap_MultiplexingPosition_vals), 0,
        "", HFILL }},
    { &hf_rnsap_powerOffsetInformation,
      { "powerOffsetInformation", "rnsap.powerOffsetInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-DPCH-Information-RL-SetupRqstFDD/powerOffsetInformation", HFILL }},
    { &hf_rnsap_fdd_dl_TPC_DownlinkStepSize,
      { "fdd-dl-TPC-DownlinkStepSize", "rnsap.fdd_dl_TPC_DownlinkStepSize",
        FT_UINT32, BASE_DEC, VALS(rnsap_FDD_TPC_DownlinkStepSize_vals), 0,
        "", HFILL }},
    { &hf_rnsap_limitedPowerIncrease,
      { "limitedPowerIncrease", "rnsap.limitedPowerIncrease",
        FT_UINT32, BASE_DEC, VALS(rnsap_LimitedPowerIncrease_vals), 0,
        "", HFILL }},
    { &hf_rnsap_innerLoopDLPCStatus,
      { "innerLoopDLPCStatus", "rnsap.innerLoopDLPCStatus",
        FT_UINT32, BASE_DEC, VALS(rnsap_InnerLoopDLPCStatus_vals), 0,
        "", HFILL }},
    { &hf_rnsap_po1_ForTFCI_Bits,
      { "po1-ForTFCI-Bits", "rnsap.po1_ForTFCI_Bits",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PowerOffsetInformation-RL-SetupRqstFDD/po1-ForTFCI-Bits", HFILL }},
    { &hf_rnsap_po2_ForTPC_Bits,
      { "po2-ForTPC-Bits", "rnsap.po2_ForTPC_Bits",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_po3_ForPilotBits,
      { "po3-ForPilotBits", "rnsap.po3_ForPilotBits",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PowerOffsetInformation-RL-SetupRqstFDD/po3-ForPilotBits", HFILL }},
    { &hf_rnsap_RL_InformationList_RL_SetupRqstFDD_item,
      { "Item", "rnsap.RL_InformationList_RL_SetupRqstFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-RL-SetupRqstFDD/_item", HFILL }},
    { &hf_rnsap_rL_ID,
      { "rL-ID", "rnsap.rL_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_c_ID,
      { "c-ID", "rnsap.c_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_firstRLS_indicator,
      { "firstRLS-indicator", "rnsap.firstRLS_indicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_FirstRLS_Indicator_vals), 0,
        "RL-InformationItem-RL-SetupRqstFDD/firstRLS-indicator", HFILL }},
    { &hf_rnsap_frameOffset,
      { "frameOffset", "rnsap.frameOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_chipOffset,
      { "chipOffset", "rnsap.chipOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_propagationDelay,
      { "propagationDelay", "rnsap.propagationDelay",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-InformationItem-RL-SetupRqstFDD/propagationDelay", HFILL }},
    { &hf_rnsap_diversityControlField,
      { "diversityControlField", "rnsap.diversityControlField",
        FT_UINT32, BASE_DEC, VALS(rnsap_DiversityControlField_vals), 0,
        "", HFILL }},
    { &hf_rnsap_dl_InitialTX_Power,
      { "dl-InitialTX-Power", "rnsap.dl_InitialTX_Power",
        FT_INT32, BASE_DEC, NULL, 0,
        "RL-InformationItem-RL-SetupRqstFDD/dl-InitialTX-Power", HFILL }},
    { &hf_rnsap_primaryCPICH_EcNo,
      { "primaryCPICH-EcNo", "rnsap.primaryCPICH_EcNo",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_not_Used_sSDT_CellID,
      { "not-Used-sSDT-CellID", "rnsap.not_Used_sSDT_CellID",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_transmitDiversityIndicator,
      { "transmitDiversityIndicator", "rnsap.transmitDiversityIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_TransmitDiversityIndicator_vals), 0,
        "", HFILL }},
    { &hf_rnsap_powerOffsetInformation1,
      { "powerOffsetInformation", "rnsap.powerOffsetInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "F-DPCH-Information-RL-SetupRqstFDD/powerOffsetInformation", HFILL }},
    { &hf_rnsap_maxNrTimeslots_UL,
      { "maxNrTimeslots-UL", "rnsap.maxNrTimeslots_UL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-Physical-Channel-Information-RL-SetupRqstTDD/maxNrTimeslots-UL", HFILL }},
    { &hf_rnsap_minimumSpreadingFactor_UL,
      { "minimumSpreadingFactor-UL", "rnsap.minimumSpreadingFactor_UL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-Physical-Channel-Information-RL-SetupRqstTDD/minimumSpreadingFactor-UL", HFILL }},
    { &hf_rnsap_maxNrULPhysicalchannels,
      { "maxNrULPhysicalchannels", "rnsap.maxNrULPhysicalchannels",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-Physical-Channel-Information-RL-SetupRqstTDD/maxNrULPhysicalchannels", HFILL }},
    { &hf_rnsap_maxNrTimeslots_DL,
      { "maxNrTimeslots-DL", "rnsap.maxNrTimeslots_DL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-Physical-Channel-Information-RL-SetupRqstTDD/maxNrTimeslots-DL", HFILL }},
    { &hf_rnsap_minimumSpreadingFactor_DL,
      { "minimumSpreadingFactor-DL", "rnsap.minimumSpreadingFactor_DL",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-Physical-Channel-Information-RL-SetupRqstTDD/minimumSpreadingFactor-DL", HFILL }},
    { &hf_rnsap_maxNrDLPhysicalchannels,
      { "maxNrDLPhysicalchannels", "rnsap.maxNrDLPhysicalchannels",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-Physical-Channel-Information-RL-SetupRqstTDD/maxNrDLPhysicalchannels", HFILL }},
    { &hf_rnsap_UL_CCTrCH_InformationList_RL_SetupRqstTDD_item,
      { "Item", "rnsap.UL_CCTrCH_InformationList_RL_SetupRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationList-RL-SetupRqstTDD/_item", HFILL }},
    { &hf_rnsap_cCTrCH_ID,
      { "cCTrCH-ID", "rnsap.cCTrCH_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tFCI_Coding,
      { "tFCI-Coding", "rnsap.tFCI_Coding",
        FT_UINT32, BASE_DEC, VALS(rnsap_TFCI_Coding_vals), 0,
        "", HFILL }},
    { &hf_rnsap_DL_CCTrCH_InformationList_RL_SetupRqstTDD_item,
      { "Item", "rnsap.DL_CCTrCH_InformationList_RL_SetupRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationList-RL-SetupRqstTDD/_item", HFILL }},
    { &hf_rnsap_dl_TFCS,
      { "dl-TFCS", "rnsap.dl_TFCS",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dl_PunctureLimit,
      { "dl-PunctureLimit", "rnsap.dl_PunctureLimit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-CCTrCH-InformationItem-RL-SetupRqstTDD/dl-PunctureLimit", HFILL }},
    { &hf_rnsap_tdd_TPC_DownlinkStepSize,
      { "tdd-TPC-DownlinkStepSize", "rnsap.tdd_TPC_DownlinkStepSize",
        FT_UINT32, BASE_DEC, VALS(rnsap_TDD_TPC_DownlinkStepSize_vals), 0,
        "DL-CCTrCH-InformationItem-RL-SetupRqstTDD/tdd-TPC-DownlinkStepSize", HFILL }},
    { &hf_rnsap_cCTrCH_TPCList,
      { "cCTrCH-TPCList", "rnsap.cCTrCH_TPCList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-CCTrCH-InformationItem-RL-SetupRqstTDD/cCTrCH-TPCList", HFILL }},
    { &hf_rnsap_CCTrCH_TPCList_RL_SetupRqstTDD_item,
      { "Item", "rnsap.CCTrCH_TPCList_RL_SetupRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "CCTrCH-TPCList-RL-SetupRqstTDD/_item", HFILL }},
    { &hf_rnsap_specialBurstScheduling,
      { "specialBurstScheduling", "rnsap.specialBurstScheduling",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Information-RL-SetupRqstTDD/specialBurstScheduling", HFILL }},
    { &hf_rnsap_primaryCCPCH_RSCP,
      { "primaryCCPCH-RSCP", "rnsap.primaryCCPCH_RSCP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dL_TimeSlot_ISCP,
      { "dL-TimeSlot-ISCP", "rnsap.dL_TimeSlot_ISCP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Information-RL-SetupRqstTDD/dL-TimeSlot-ISCP", HFILL }},
    { &hf_rnsap_RL_InformationResponseList_RL_SetupRspFDD_item,
      { "Item", "rnsap.RL_InformationResponseList_RL_SetupRspFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseList-RL-SetupRspFDD/_item", HFILL }},
    { &hf_rnsap_rL_Set_ID,
      { "rL-Set-ID", "rnsap.rL_Set_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_uRA_Information,
      { "uRA-Information", "rnsap.uRA_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_sAI,
      { "sAI", "rnsap.sAI",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_gA_Cell,
      { "gA-Cell", "rnsap.gA_Cell",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_gA_AccessPointPosition,
      { "gA-AccessPointPosition", "rnsap.gA_AccessPointPosition",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_received_total_wide_band_power,
      { "received-total-wide-band-power", "rnsap.received_total_wide_band_power",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_not_Used_secondary_CCPCH_Info,
      { "not-Used-secondary-CCPCH-Info", "rnsap.not_Used_secondary_CCPCH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dl_CodeInformation,
      { "dl-CodeInformation", "rnsap.dl_CodeInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_diversityIndication,
      { "diversityIndication", "rnsap.diversityIndication",
        FT_UINT32, BASE_DEC, VALS(rnsap_DiversityIndication_RL_SetupRspFDD_vals), 0,
        "RL-InformationResponseItem-RL-SetupRspFDD/diversityIndication", HFILL }},
    { &hf_rnsap_sSDT_SupportIndicator,
      { "sSDT-SupportIndicator", "rnsap.sSDT_SupportIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_SSDT_SupportIndicator_vals), 0,
        "", HFILL }},
    { &hf_rnsap_maxUL_SIR,
      { "maxUL-SIR", "rnsap.maxUL_SIR",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_minUL_SIR,
      { "minUL-SIR", "rnsap.minUL_SIR",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_closedlooptimingadjustmentmode,
      { "closedlooptimingadjustmentmode", "rnsap.closedlooptimingadjustmentmode",
        FT_UINT32, BASE_DEC, VALS(rnsap_Closedlooptimingadjustmentmode_vals), 0,
        "", HFILL }},
    { &hf_rnsap_maximumAllowedULTxPower,
      { "maximumAllowedULTxPower", "rnsap.maximumAllowedULTxPower",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_maximumDLTxPower,
      { "maximumDLTxPower", "rnsap.maximumDLTxPower",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_minimumDLTxPower,
      { "minimumDLTxPower", "rnsap.minimumDLTxPower",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_primaryScramblingCode,
      { "primaryScramblingCode", "rnsap.primaryScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_uL_UARFCN,
      { "uL-UARFCN", "rnsap.uL_UARFCN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dL_UARFCN,
      { "dL-UARFCN", "rnsap.dL_UARFCN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_primaryCPICH_Power,
      { "primaryCPICH-Power", "rnsap.primaryCPICH_Power",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_not_Used_dSCHInformationResponse,
      { "not-Used-dSCHInformationResponse", "rnsap.not_Used_dSCHInformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseItem-RL-SetupRspFDD/not-Used-dSCHInformationResponse", HFILL }},
    { &hf_rnsap_neighbouring_UMTS_CellInformation,
      { "neighbouring-UMTS-CellInformation", "rnsap.neighbouring_UMTS_CellInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_neighbouring_GSM_CellInformation,
      { "neighbouring-GSM-CellInformation", "rnsap.neighbouring_GSM_CellInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_pC_Preamble,
      { "pC-Preamble", "rnsap.pC_Preamble",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_sRB_Delay,
      { "sRB-Delay", "rnsap.sRB_Delay",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_combining,
      { "combining", "rnsap.combining",
        FT_NONE, BASE_NONE, NULL, 0,
        "DiversityIndication-RL-SetupRspFDD/combining", HFILL }},
    { &hf_rnsap_nonCombiningOrFirstRL,
      { "nonCombiningOrFirstRL", "rnsap.nonCombiningOrFirstRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "DiversityIndication-RL-SetupRspFDD/nonCombiningOrFirstRL", HFILL }},
    { &hf_rnsap_dCH_InformationResponse,
      { "dCH-InformationResponse", "rnsap.dCH_InformationResponse",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_TimeSlot_ISCP_Info,
      { "ul-TimeSlot-ISCP-Info", "rnsap.ul_TimeSlot_ISCP_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_uARFCNforNt,
      { "uARFCNforNt", "rnsap.uARFCNforNt",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_cellParameterID,
      { "cellParameterID", "rnsap.cellParameterID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_syncCase,
      { "syncCase", "rnsap.syncCase",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_sCH_TimeSlot,
      { "sCH-TimeSlot", "rnsap.sCH_TimeSlot",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_sCTD_Indicator,
      { "sCTD-Indicator", "rnsap.sCTD_Indicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_SCTD_Indicator_vals), 0,
        "", HFILL }},
    { &hf_rnsap_pCCPCH_Power,
      { "pCCPCH-Power", "rnsap.pCCPCH_Power",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_timingAdvanceApplied,
      { "timingAdvanceApplied", "rnsap.timingAdvanceApplied",
        FT_UINT32, BASE_DEC, VALS(rnsap_TimingAdvanceApplied_vals), 0,
        "", HFILL }},
    { &hf_rnsap_alphaValue,
      { "alphaValue", "rnsap.alphaValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_PhysCH_SF_Variation,
      { "ul-PhysCH-SF-Variation", "rnsap.ul_PhysCH_SF_Variation",
        FT_UINT32, BASE_DEC, VALS(rnsap_UL_PhysCH_SF_Variation_vals), 0,
        "", HFILL }},
    { &hf_rnsap_synchronisationConfiguration,
      { "synchronisationConfiguration", "rnsap.synchronisationConfiguration",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_secondary_CCPCH_Info_TDD,
      { "secondary-CCPCH-Info-TDD", "rnsap.secondary_CCPCH_Info_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_CCTrCHInformation,
      { "ul-CCTrCHInformation", "rnsap.ul_CCTrCHInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-SetupRspTDD/ul-CCTrCHInformation", HFILL }},
    { &hf_rnsap_dl_CCTrCHInformation,
      { "dl-CCTrCHInformation", "rnsap.dl_CCTrCHInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-SetupRspTDD/dl-CCTrCHInformation", HFILL }},
    { &hf_rnsap_dCH_InformationResponse1,
      { "dCH-InformationResponse", "rnsap.dCH_InformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dsch_InformationResponse,
      { "dsch-InformationResponse", "rnsap.dsch_InformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-SetupRspTDD/dsch-InformationResponse", HFILL }},
    { &hf_rnsap_usch_InformationResponse,
      { "usch-InformationResponse", "rnsap.usch_InformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-SetupRspTDD/usch-InformationResponse", HFILL }},
    { &hf_rnsap_UL_CCTrCHInformationListIE_RL_SetupRspTDD_item,
      { "Item", "rnsap.UL_CCTrCHInformationListIE_RL_SetupRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCHInformationListIE-RL-SetupRspTDD/_item", HFILL }},
    { &hf_rnsap_ul_DPCH_Information,
      { "ul-DPCH-Information", "rnsap.ul_DPCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCHInformationItem-RL-SetupRspTDD/ul-DPCH-Information", HFILL }},
    { &hf_rnsap_repetitionPeriod,
      { "repetitionPeriod", "rnsap.repetitionPeriod",
        FT_UINT32, BASE_DEC, VALS(rnsap_RepetitionPeriod_vals), 0,
        "", HFILL }},
    { &hf_rnsap_repetitionLength,
      { "repetitionLength", "rnsap.repetitionLength",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tDD_DPCHOffset,
      { "tDD-DPCHOffset", "rnsap.tDD_DPCHOffset",
        FT_UINT32, BASE_DEC, VALS(rnsap_TDD_DPCHOffset_vals), 0,
        "", HFILL }},
    { &hf_rnsap_uL_Timeslot_Information,
      { "uL-Timeslot-Information", "rnsap.uL_Timeslot_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_DL_CCTrCHInformationListIE_RL_SetupRspTDD_item,
      { "Item", "rnsap.DL_CCTrCHInformationListIE_RL_SetupRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCHInformationListIE-RL-SetupRspTDD/_item", HFILL }},
    { &hf_rnsap_dl_DPCH_Information,
      { "dl-DPCH-Information", "rnsap.dl_DPCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCHInformationItem-RL-SetupRspTDD/dl-DPCH-Information", HFILL }},
    { &hf_rnsap_dL_Timeslot_Information,
      { "dL-Timeslot-Information", "rnsap.dL_Timeslot_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_DSCH_InformationListIEs_RL_SetupRspTDD_item,
      { "Item", "rnsap.DSCH_InformationListIEs_RL_SetupRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DSCH-InformationListIEs-RL-SetupRspTDD/_item", HFILL }},
    { &hf_rnsap_dsch_ID,
      { "dsch-ID", "rnsap.dsch_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dSCH_FlowControlInformation,
      { "dSCH-FlowControlInformation", "rnsap.dSCH_FlowControlInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_bindingID,
      { "bindingID", "rnsap.bindingID",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_transportLayerAddress,
      { "transportLayerAddress", "rnsap.transportLayerAddress",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_transportFormatManagement,
      { "transportFormatManagement", "rnsap.transportFormatManagement",
        FT_UINT32, BASE_DEC, VALS(rnsap_TransportFormatManagement_vals), 0,
        "", HFILL }},
    { &hf_rnsap_USCH_InformationListIEs_RL_SetupRspTDD_item,
      { "Item", "rnsap.USCH_InformationListIEs_RL_SetupRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "USCH-InformationListIEs-RL-SetupRspTDD/_item", HFILL }},
    { &hf_rnsap_usch_ID,
      { "usch-ID", "rnsap.usch_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_TimeSlot_ISCP_LCR_Info,
      { "ul-TimeSlot-ISCP-LCR-Info", "rnsap.ul_TimeSlot_ISCP_LCR_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_secondary_LCR_CCPCH_Info_TDD,
      { "secondary-LCR-CCPCH-Info-TDD", "rnsap.secondary_LCR_CCPCH_Info_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_LCR_CCTrCHInformation,
      { "ul-LCR-CCTrCHInformation", "rnsap.ul_LCR_CCTrCHInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-LCR-InformationResponse-RL-SetupRspTDD/ul-LCR-CCTrCHInformation", HFILL }},
    { &hf_rnsap_dl_LCR_CCTrCHInformation,
      { "dl-LCR-CCTrCHInformation", "rnsap.dl_LCR_CCTrCHInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-LCR-InformationResponse-RL-SetupRspTDD/dl-LCR-CCTrCHInformation", HFILL }},
    { &hf_rnsap_dsch_LCR_InformationResponse,
      { "dsch-LCR-InformationResponse", "rnsap.dsch_LCR_InformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-LCR-InformationResponse-RL-SetupRspTDD/dsch-LCR-InformationResponse", HFILL }},
    { &hf_rnsap_usch_LCR_InformationResponse,
      { "usch-LCR-InformationResponse", "rnsap.usch_LCR_InformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-LCR-InformationResponse-RL-SetupRspTDD/usch-LCR-InformationResponse", HFILL }},
    { &hf_rnsap_UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD_item,
      { "Item", "rnsap.UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-LCR-CCTrCHInformationListIE-RL-SetupRspTDD/_item", HFILL }},
    { &hf_rnsap_ul_DPCH_LCR_Information,
      { "ul-DPCH-LCR-Information", "rnsap.ul_DPCH_LCR_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD/ul-DPCH-LCR-Information", HFILL }},
    { &hf_rnsap_uL_TimeslotLCR_Information,
      { "uL-TimeslotLCR-Information", "rnsap.uL_TimeslotLCR_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD_item,
      { "Item", "rnsap.DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD/_item", HFILL }},
    { &hf_rnsap_dl_DPCH_LCR_Information,
      { "dl-DPCH-LCR-Information", "rnsap.dl_DPCH_LCR_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD/dl-DPCH-LCR-Information", HFILL }},
    { &hf_rnsap_dL_Timeslot_LCR_Information,
      { "dL-Timeslot-LCR-Information", "rnsap.dL_Timeslot_LCR_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-DPCH-LCR-InformationItem-RL-SetupRspTDD/dL-Timeslot-LCR-Information", HFILL }},
    { &hf_rnsap_tSTD_Indicator,
      { "tSTD-Indicator", "rnsap.tSTD_Indicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_TSTD_Indicator_vals), 0,
        "", HFILL }},
    { &hf_rnsap_DSCH_LCR_InformationListIEs_RL_SetupRspTDD_item,
      { "Item", "rnsap.DSCH_LCR_InformationListIEs_RL_SetupRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DSCH-LCR-InformationListIEs-RL-SetupRspTDD/_item", HFILL }},
    { &hf_rnsap_USCH_LCR_InformationListIEs_RL_SetupRspTDD_item,
      { "Item", "rnsap.USCH_LCR_InformationListIEs_RL_SetupRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "USCH-LCR-InformationListIEs-RL-SetupRspTDD/_item", HFILL }},
    { &hf_rnsap_generalCause,
      { "generalCause", "rnsap.generalCause",
        FT_NONE, BASE_NONE, NULL, 0,
        "CauseLevel-RL-SetupFailureFDD/generalCause", HFILL }},
    { &hf_rnsap_rLSpecificCause,
      { "rLSpecificCause", "rnsap.rLSpecificCause",
        FT_NONE, BASE_NONE, NULL, 0,
        "CauseLevel-RL-SetupFailureFDD/rLSpecificCause", HFILL }},
    { &hf_rnsap_cause,
      { "cause", "rnsap.cause",
        FT_UINT32, BASE_DEC, VALS(rnsap_Cause_vals), 0,
        "", HFILL }},
    { &hf_rnsap_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD,
      { "unsuccessful-RL-InformationRespList-RL-SetupFailureFDD", "rnsap.unsuccessful_RL_InformationRespList_RL_SetupFailureFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RLSpecificCauseList-RL-SetupFailureFDD/unsuccessful-RL-InformationRespList-RL-SetupFailureFDD", HFILL }},
    { &hf_rnsap_successful_RL_InformationRespList_RL_SetupFailureFDD,
      { "successful-RL-InformationRespList-RL-SetupFailureFDD", "rnsap.successful_RL_InformationRespList_RL_SetupFailureFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RLSpecificCauseList-RL-SetupFailureFDD/successful-RL-InformationRespList-RL-SetupFailureFDD", HFILL }},
    { &hf_rnsap_UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item,
      { "Item", "rnsap.UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UnsuccessfulRL-InformationResponseList-RL-SetupFailureFDD/_item", HFILL }},
    { &hf_rnsap_SuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item,
      { "Item", "rnsap.SuccessfulRL_InformationResponseList_RL_SetupFailureFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "SuccessfulRL-InformationResponseList-RL-SetupFailureFDD/_item", HFILL }},
    { &hf_rnsap_diversityIndication1,
      { "diversityIndication", "rnsap.diversityIndication",
        FT_UINT32, BASE_DEC, VALS(rnsap_DiversityIndication_RL_SetupFailureFDD_vals), 0,
        "SuccessfulRL-InformationResponse-RL-SetupFailureFDD/diversityIndication", HFILL }},
    { &hf_rnsap_not_Used_dSCH_InformationResponse_RL_SetupFailureFDD,
      { "not-Used-dSCH-InformationResponse-RL-SetupFailureFDD", "rnsap.not_Used_dSCH_InformationResponse_RL_SetupFailureFDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "SuccessfulRL-InformationResponse-RL-SetupFailureFDD/not-Used-dSCH-InformationResponse-RL-SetupFailureFDD", HFILL }},
    { &hf_rnsap_combining1,
      { "combining", "rnsap.combining",
        FT_NONE, BASE_NONE, NULL, 0,
        "DiversityIndication-RL-SetupFailureFDD/combining", HFILL }},
    { &hf_rnsap_nonCombiningOrFirstRL1,
      { "nonCombiningOrFirstRL", "rnsap.nonCombiningOrFirstRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "DiversityIndication-RL-SetupFailureFDD/nonCombiningOrFirstRL", HFILL }},
    { &hf_rnsap_generalCause1,
      { "generalCause", "rnsap.generalCause",
        FT_NONE, BASE_NONE, NULL, 0,
        "CauseLevel-RL-SetupFailureTDD/generalCause", HFILL }},
    { &hf_rnsap_rLSpecificCause1,
      { "rLSpecificCause", "rnsap.rLSpecificCause",
        FT_NONE, BASE_NONE, NULL, 0,
        "CauseLevel-RL-SetupFailureTDD/rLSpecificCause", HFILL }},
    { &hf_rnsap_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD,
      { "unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD", "rnsap.unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "RLSpecificCauseList-RL-SetupFailureTDD/unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD", HFILL }},
    { &hf_rnsap_RL_InformationList_RL_AdditionRqstFDD_item,
      { "Item", "rnsap.RL_InformationList_RL_AdditionRqstFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-RL-AdditionRqstFDD/_item", HFILL }},
    { &hf_rnsap_dL_TimeSlot_ISCP_Info,
      { "dL-TimeSlot-ISCP-Info", "rnsap.dL_TimeSlot_ISCP_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Information-RL-AdditionRqstTDD/dL-TimeSlot-ISCP-Info", HFILL }},
    { &hf_rnsap_UL_CCTrCH_InformationList_RL_AdditionRqstTDD_item,
      { "Item", "rnsap.UL_CCTrCH_InformationList_RL_AdditionRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationList-RL-AdditionRqstTDD/_item", HFILL }},
    { &hf_rnsap_uplinkStepSizeLCR,
      { "uplinkStepSizeLCR", "rnsap.uplinkStepSizeLCR",
        FT_UINT32, BASE_DEC, VALS(rnsap_TDD_TPC_UplinkStepSize_LCR_vals), 0,
        "UL-CCTrCH-InformationItem-RL-AdditionRqstTDD/uplinkStepSizeLCR", HFILL }},
    { &hf_rnsap_DL_CCTrCH_InformationList_RL_AdditionRqstTDD_item,
      { "Item", "rnsap.DL_CCTrCH_InformationList_RL_AdditionRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationList-RL-AdditionRqstTDD/_item", HFILL }},
    { &hf_rnsap_downlinkStepSize,
      { "downlinkStepSize", "rnsap.downlinkStepSize",
        FT_UINT32, BASE_DEC, VALS(rnsap_TDD_TPC_DownlinkStepSize_vals), 0,
        "DL-CCTrCH-InformationItem-RL-AdditionRqstTDD/downlinkStepSize", HFILL }},
    { &hf_rnsap_RL_InformationResponseList_RL_AdditionRspFDD_item,
      { "Item", "rnsap.RL_InformationResponseList_RL_AdditionRspFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseList-RL-AdditionRspFDD/_item", HFILL }},
    { &hf_rnsap_dl_CodeInformation1,
      { "dl-CodeInformation", "rnsap.dl_CodeInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseItem-RL-AdditionRspFDD/dl-CodeInformation", HFILL }},
    { &hf_rnsap_diversityIndication2,
      { "diversityIndication", "rnsap.diversityIndication",
        FT_UINT32, BASE_DEC, VALS(rnsap_DiversityIndication_RL_AdditionRspFDD_vals), 0,
        "RL-InformationResponseItem-RL-AdditionRspFDD/diversityIndication", HFILL }},
    { &hf_rnsap_combining2,
      { "combining", "rnsap.combining",
        FT_NONE, BASE_NONE, NULL, 0,
        "DiversityIndication-RL-AdditionRspFDD/combining", HFILL }},
    { &hf_rnsap_nonCombining,
      { "nonCombining", "rnsap.nonCombining",
        FT_NONE, BASE_NONE, NULL, 0,
        "DiversityIndication-RL-AdditionRspFDD/nonCombining", HFILL }},
    { &hf_rnsap_ul_CCTrCHInformation1,
      { "ul-CCTrCHInformation", "rnsap.ul_CCTrCHInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-AdditionRspTDD/ul-CCTrCHInformation", HFILL }},
    { &hf_rnsap_dl_CCTrCHInformation1,
      { "dl-CCTrCHInformation", "rnsap.dl_CCTrCHInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-AdditionRspTDD/dl-CCTrCHInformation", HFILL }},
    { &hf_rnsap_dCH_Information,
      { "dCH-Information", "rnsap.dCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-AdditionRspTDD/dCH-Information", HFILL }},
    { &hf_rnsap_dSCH_InformationResponse,
      { "dSCH-InformationResponse", "rnsap.dSCH_InformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-AdditionRspTDD/dSCH-InformationResponse", HFILL }},
    { &hf_rnsap_uSCH_InformationResponse,
      { "uSCH-InformationResponse", "rnsap.uSCH_InformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-AdditionRspTDD/uSCH-InformationResponse", HFILL }},
    { &hf_rnsap_UL_CCTrCHInformationListIE_RL_AdditionRspTDD_item,
      { "Item", "rnsap.UL_CCTrCHInformationListIE_RL_AdditionRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCHInformationListIE-RL-AdditionRspTDD/_item", HFILL }},
    { &hf_rnsap_ul_DPCH_Information1,
      { "ul-DPCH-Information", "rnsap.ul_DPCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCHInformationItem-RL-AdditionRspTDD/ul-DPCH-Information", HFILL }},
    { &hf_rnsap_DL_CCTrCHInformationListIE_RL_AdditionRspTDD_item,
      { "Item", "rnsap.DL_CCTrCHInformationListIE_RL_AdditionRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCHInformationListIE-RL-AdditionRspTDD/_item", HFILL }},
    { &hf_rnsap_dl_DPCH_Information1,
      { "dl-DPCH-Information", "rnsap.dl_DPCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCHInformationItem-RL-AdditionRspTDD/dl-DPCH-Information", HFILL }},
    { &hf_rnsap_diversityIndication3,
      { "diversityIndication", "rnsap.diversityIndication",
        FT_UINT32, BASE_DEC, VALS(rnsap_DiversityIndication_RL_AdditionRspTDD_vals), 0,
        "DCH-Information-RL-AdditionRspTDD/diversityIndication", HFILL }},
    { &hf_rnsap_combining3,
      { "combining", "rnsap.combining",
        FT_NONE, BASE_NONE, NULL, 0,
        "DiversityIndication-RL-AdditionRspTDD/combining", HFILL }},
    { &hf_rnsap_nonCombining1,
      { "nonCombining", "rnsap.nonCombining",
        FT_NONE, BASE_NONE, NULL, 0,
        "DiversityIndication-RL-AdditionRspTDD/nonCombining", HFILL }},
    { &hf_rnsap_DSCH_InformationListIE_RL_AdditionRspTDD_item,
      { "Item", "rnsap.DSCH_InformationListIE_RL_AdditionRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DSCH-InformationListIE-RL-AdditionRspTDD/_item", HFILL }},
    { &hf_rnsap_diversityIndication4,
      { "diversityIndication", "rnsap.diversityIndication",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_USCH_InformationListIE_RL_AdditionRspTDD_item,
      { "Item", "rnsap.USCH_InformationListIE_RL_AdditionRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "USCH-InformationListIE-RL-AdditionRspTDD/_item", HFILL }},
    { &hf_rnsap_uSCH_ID,
      { "uSCH-ID", "rnsap.uSCH_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_CCTrCH_LCR_Information,
      { "ul-CCTrCH-LCR-Information", "rnsap.ul_CCTrCH_LCR_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-LCR-InformationResponse-RL-AdditionRspTDD/ul-CCTrCH-LCR-Information", HFILL }},
    { &hf_rnsap_dl_CCTrCH_LCR_Information,
      { "dl-CCTrCH-LCR-Information", "rnsap.dl_CCTrCH_LCR_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-LCR-InformationResponse-RL-AdditionRspTDD/dl-CCTrCH-LCR-Information", HFILL }},
    { &hf_rnsap_dCH_InformationResponse2,
      { "dCH-InformationResponse", "rnsap.dCH_InformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-LCR-InformationResponse-RL-AdditionRspTDD/dCH-InformationResponse", HFILL }},
    { &hf_rnsap_dsch_LCR_InformationResponse1,
      { "dsch-LCR-InformationResponse", "rnsap.dsch_LCR_InformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-LCR-InformationResponse-RL-AdditionRspTDD/dsch-LCR-InformationResponse", HFILL }},
    { &hf_rnsap_usch_LCR_InformationResponse1,
      { "usch-LCR-InformationResponse", "rnsap.usch_LCR_InformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-LCR-InformationResponse-RL-AdditionRspTDD/usch-LCR-InformationResponse", HFILL }},
    { &hf_rnsap_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item,
      { "Item", "rnsap.UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD/_item", HFILL }},
    { &hf_rnsap_ul_DPCH_LCR_Information1,
      { "ul-DPCH-LCR-Information", "rnsap.ul_DPCH_LCR_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD/ul-DPCH-LCR-Information", HFILL }},
    { &hf_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item,
      { "Item", "rnsap.DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD/_item", HFILL }},
    { &hf_rnsap_dl_DPCH_LCR_Information1,
      { "dl-DPCH-LCR-Information", "rnsap.dl_DPCH_LCR_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD/dl-DPCH-LCR-Information", HFILL }},
    { &hf_rnsap_dL_TimeslotLCR_Information,
      { "dL-TimeslotLCR-Information", "rnsap.dL_TimeslotLCR_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD/dL-TimeslotLCR-Information", HFILL }},
    { &hf_rnsap_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD_item,
      { "Item", "rnsap.DSCH_LCR_InformationListIEs_RL_AdditionRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DSCH-LCR-InformationListIEs-RL-AdditionRspTDD/_item", HFILL }},
    { &hf_rnsap_USCH_LCR_InformationListIEs_RL_AdditionRspTDD_item,
      { "Item", "rnsap.USCH_LCR_InformationListIEs_RL_AdditionRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "USCH-LCR-InformationListIEs-RL-AdditionRspTDD/_item", HFILL }},
    { &hf_rnsap_generalCause2,
      { "generalCause", "rnsap.generalCause",
        FT_NONE, BASE_NONE, NULL, 0,
        "CauseLevel-RL-AdditionFailureFDD/generalCause", HFILL }},
    { &hf_rnsap_rLSpecificCause2,
      { "rLSpecificCause", "rnsap.rLSpecificCause",
        FT_NONE, BASE_NONE, NULL, 0,
        "CauseLevel-RL-AdditionFailureFDD/rLSpecificCause", HFILL }},
    { &hf_rnsap_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD,
      { "unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD", "rnsap.unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RLSpecificCauseList-RL-AdditionFailureFDD/unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD", HFILL }},
    { &hf_rnsap_successful_RL_InformationRespList_RL_AdditionFailureFDD,
      { "successful-RL-InformationRespList-RL-AdditionFailureFDD", "rnsap.successful_RL_InformationRespList_RL_AdditionFailureFDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RLSpecificCauseList-RL-AdditionFailureFDD/successful-RL-InformationRespList-RL-AdditionFailureFDD", HFILL }},
    { &hf_rnsap_UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item,
      { "Item", "rnsap.UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UnsuccessfulRL-InformationResponseList-RL-AdditionFailureFDD/_item", HFILL }},
    { &hf_rnsap_SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item,
      { "Item", "rnsap.SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "SuccessfulRL-InformationResponseList-RL-AdditionFailureFDD/_item", HFILL }},
    { &hf_rnsap_dl_CodeInformation2,
      { "dl-CodeInformation", "rnsap.dl_CodeInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "SuccessfulRL-InformationResponse-RL-AdditionFailureFDD/dl-CodeInformation", HFILL }},
    { &hf_rnsap_diversityIndication5,
      { "diversityIndication", "rnsap.diversityIndication",
        FT_UINT32, BASE_DEC, VALS(rnsap_DiversityIndication_RL_AdditionFailureFDD_vals), 0,
        "SuccessfulRL-InformationResponse-RL-AdditionFailureFDD/diversityIndication", HFILL }},
    { &hf_rnsap_combining4,
      { "combining", "rnsap.combining",
        FT_NONE, BASE_NONE, NULL, 0,
        "DiversityIndication-RL-AdditionFailureFDD/combining", HFILL }},
    { &hf_rnsap_nonCombining2,
      { "nonCombining", "rnsap.nonCombining",
        FT_NONE, BASE_NONE, NULL, 0,
        "DiversityIndication-RL-AdditionFailureFDD/nonCombining", HFILL }},
    { &hf_rnsap_generalCause3,
      { "generalCause", "rnsap.generalCause",
        FT_NONE, BASE_NONE, NULL, 0,
        "CauseLevel-RL-AdditionFailureTDD/generalCause", HFILL }},
    { &hf_rnsap_rLSpecificCause3,
      { "rLSpecificCause", "rnsap.rLSpecificCause",
        FT_NONE, BASE_NONE, NULL, 0,
        "CauseLevel-RL-AdditionFailureTDD/rLSpecificCause", HFILL }},
    { &hf_rnsap_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD,
      { "unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD", "rnsap.unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "RLSpecificCauseList-RL-AdditionFailureTDD/unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD", HFILL }},
    { &hf_rnsap_RL_InformationList_RL_DeletionRqst_item,
      { "Item", "rnsap.RL_InformationList_RL_DeletionRqst_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-RL-DeletionRqst/_item", HFILL }},
    { &hf_rnsap_maxNrOfUL_DPDCHs,
      { "maxNrOfUL-DPDCHs", "rnsap.maxNrOfUL_DPDCHs",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-DPCH-Information-RL-ReconfPrepFDD/maxNrOfUL-DPDCHs", HFILL }},
    { &hf_rnsap_not_Used_sSDT_CellIDLength,
      { "not-Used-sSDT-CellIDLength", "rnsap.not_Used_sSDT_CellIDLength",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-DPCH-Information-RL-ReconfPrepFDD/not-Used-sSDT-CellIDLength", HFILL }},
    { &hf_rnsap_powerOffsetInformation2,
      { "powerOffsetInformation", "rnsap.powerOffsetInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-DPCH-Power-Information-RL-ReconfPrepFDD/powerOffsetInformation", HFILL }},
    { &hf_rnsap_fdd_TPC_DownlinkStepSize,
      { "fdd-TPC-DownlinkStepSize", "rnsap.fdd_TPC_DownlinkStepSize",
        FT_UINT32, BASE_DEC, VALS(rnsap_FDD_TPC_DownlinkStepSize_vals), 0,
        "DL-DPCH-Power-Information-RL-ReconfPrepFDD/fdd-TPC-DownlinkStepSize", HFILL }},
    { &hf_rnsap_pO1_ForTFCI_Bits,
      { "pO1-ForTFCI-Bits", "rnsap.pO1_ForTFCI_Bits",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PowerOffsetInformation-RL-ReconfPrepFDD/pO1-ForTFCI-Bits", HFILL }},
    { &hf_rnsap_pO2_ForTPC_Bits,
      { "pO2-ForTPC-Bits", "rnsap.pO2_ForTPC_Bits",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PowerOffsetInformation-RL-ReconfPrepFDD/pO2-ForTPC-Bits", HFILL }},
    { &hf_rnsap_pO3_ForPilotBits,
      { "pO3-ForPilotBits", "rnsap.pO3_ForPilotBits",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PowerOffsetInformation-RL-ReconfPrepFDD/pO3-ForPilotBits", HFILL }},
    { &hf_rnsap_DCH_DeleteList_RL_ReconfPrepFDD_item,
      { "Item", "rnsap.DCH_DeleteList_RL_ReconfPrepFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-DeleteList-RL-ReconfPrepFDD/_item", HFILL }},
    { &hf_rnsap_dCH_ID,
      { "dCH-ID", "rnsap.dCH_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_RL_InformationList_RL_ReconfPrepFDD_item,
      { "Item", "rnsap.RL_InformationList_RL_ReconfPrepFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-RL-ReconfPrepFDD/_item", HFILL }},
    { &hf_rnsap_not_Used_sSDT_Indication,
      { "not-Used-sSDT-Indication", "rnsap.not_Used_sSDT_Indication",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Information-RL-ReconfPrepFDD/not-Used-sSDT-Indication", HFILL }},
    { &hf_rnsap_not_Used_sSDT_CellIdentity,
      { "not-Used-sSDT-CellIdentity", "rnsap.not_Used_sSDT_CellIdentity",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Information-RL-ReconfPrepFDD/not-Used-sSDT-CellIdentity", HFILL }},
    { &hf_rnsap_powerOffsetInformation3,
      { "powerOffsetInformation", "rnsap.powerOffsetInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "F-DPCH-Information-RL-ReconfPrepFDD/powerOffsetInformation", HFILL }},
    { &hf_rnsap_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_punctureLimit,
      { "punctureLimit", "rnsap.punctureLimit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_cCTrCH_TPCList1,
      { "cCTrCH-TPCList", "rnsap.cCTrCH_TPCList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD/cCTrCH-TPCList", HFILL }},
    { &hf_rnsap_CCTrCH_TPCAddList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.CCTrCH_TPCAddList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "CCTrCH-TPCAddList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_cCTrCH_TPCList2,
      { "cCTrCH-TPCList", "rnsap.cCTrCH_TPCList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD/cCTrCH-TPCList", HFILL }},
    { &hf_rnsap_CCTrCH_TPCModifyList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.CCTrCH_TPCModifyList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "CCTrCH-TPCModifyList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_DCH_DeleteList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.DCH_DeleteList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-DeleteList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_DSCH_ModifyList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.DSCH_ModifyList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DSCH-ModifyList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_dSCH_ID,
      { "dSCH-ID", "rnsap.dSCH_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dl_ccTrCHID,
      { "dl-ccTrCHID", "rnsap.dl_ccTrCHID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_trChSourceStatisticsDescriptor,
      { "trChSourceStatisticsDescriptor", "rnsap.trChSourceStatisticsDescriptor",
        FT_UINT32, BASE_DEC, VALS(rnsap_TrCH_SrcStatisticsDescr_vals), 0,
        "", HFILL }},
    { &hf_rnsap_transportFormatSet,
      { "transportFormatSet", "rnsap.transportFormatSet",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_allocationRetentionPriority,
      { "allocationRetentionPriority", "rnsap.allocationRetentionPriority",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_schedulingPriorityIndicator,
      { "schedulingPriorityIndicator", "rnsap.schedulingPriorityIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_SchedulingPriorityIndicator_vals), 0,
        "", HFILL }},
    { &hf_rnsap_bLER,
      { "bLER", "rnsap.bLER",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_transportBearerRequestIndicator,
      { "transportBearerRequestIndicator", "rnsap.transportBearerRequestIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_TransportBearerRequestIndicator_vals), 0,
        "", HFILL }},
    { &hf_rnsap_DSCH_DeleteList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.DSCH_DeleteList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DSCH-DeleteList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_USCH_ModifyList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.USCH_ModifyList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "USCH-ModifyList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_ul_ccTrCHID,
      { "ul-ccTrCHID", "rnsap.ul_ccTrCHID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "USCH-ModifyItem-RL-ReconfPrepTDD/ul-ccTrCHID", HFILL }},
    { &hf_rnsap_rb_Info,
      { "rb-Info", "rnsap.rb_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_USCH_DeleteList_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.USCH_DeleteList_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "USCH-DeleteList-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_RL_Information_RL_ReconfPrepTDD_item,
      { "Item", "rnsap.RL_Information_RL_ReconfPrepTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Information-RL-ReconfPrepTDD/_item", HFILL }},
    { &hf_rnsap_rL_Specific_DCH_Info,
      { "rL-Specific-DCH-Info", "rnsap.rL_Specific_DCH_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_RL_InformationResponseList_RL_ReconfReadyFDD_item,
      { "Item", "rnsap.RL_InformationResponseList_RL_ReconfReadyFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseList-RL-ReconfReadyFDD/_item", HFILL }},
    { &hf_rnsap_max_UL_SIR,
      { "max-UL-SIR", "rnsap.max_UL_SIR",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_min_UL_SIR,
      { "min-UL-SIR", "rnsap.min_UL_SIR",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dl_CodeInformationList,
      { "dl-CodeInformationList", "rnsap.dl_CodeInformationList",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseItem-RL-ReconfReadyFDD/dl-CodeInformationList", HFILL }},
    { &hf_rnsap_dCHInformationResponse,
      { "dCHInformationResponse", "rnsap.dCHInformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseItem-RL-ReconfReadyFDD/dCHInformationResponse", HFILL }},
    { &hf_rnsap_not_Used_dSCHsToBeAddedOrModified,
      { "not-Used-dSCHsToBeAddedOrModified", "rnsap.not_Used_dSCHsToBeAddedOrModified",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseItem-RL-ReconfReadyFDD/not-Used-dSCHsToBeAddedOrModified", HFILL }},
    { &hf_rnsap_ul_CCTrCH_Information,
      { "ul-CCTrCH-Information", "rnsap.ul_CCTrCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-ReconfReadyTDD/ul-CCTrCH-Information", HFILL }},
    { &hf_rnsap_dl_CCTrCH_Information,
      { "dl-CCTrCH-Information", "rnsap.dl_CCTrCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-ReconfReadyTDD/dl-CCTrCH-Information", HFILL }},
    { &hf_rnsap_dCHInformationResponse1,
      { "dCHInformationResponse", "rnsap.dCHInformationResponse",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-ReconfReadyTDD/dCHInformationResponse", HFILL }},
    { &hf_rnsap_dSCHsToBeAddedOrModified,
      { "dSCHsToBeAddedOrModified", "rnsap.dSCHsToBeAddedOrModified",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-ReconfReadyTDD/dSCHsToBeAddedOrModified", HFILL }},
    { &hf_rnsap_uSCHsToBeAddedOrModified,
      { "uSCHsToBeAddedOrModified", "rnsap.uSCHsToBeAddedOrModified",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-ReconfReadyTDD/uSCHsToBeAddedOrModified", HFILL }},
    { &hf_rnsap_UL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.UL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCHInformationListIE-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_ul_DPCH_AddInformation,
      { "ul-DPCH-AddInformation", "rnsap.ul_DPCH_AddInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationItem-RL-ReconfReadyTDD/ul-DPCH-AddInformation", HFILL }},
    { &hf_rnsap_ul_DPCH_ModifyInformation,
      { "ul-DPCH-ModifyInformation", "rnsap.ul_DPCH_ModifyInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationItem-RL-ReconfReadyTDD/ul-DPCH-ModifyInformation", HFILL }},
    { &hf_rnsap_ul_DPCH_DeleteInformation,
      { "ul-DPCH-DeleteInformation", "rnsap.ul_DPCH_DeleteInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationItem-RL-ReconfReadyTDD/ul-DPCH-DeleteInformation", HFILL }},
    { &hf_rnsap_uL_TimeslotLCR_Info,
      { "uL-TimeslotLCR-Info", "rnsap.uL_TimeslotLCR_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD/uL-TimeslotLCR-Info", HFILL }},
    { &hf_rnsap_rxTimingDeviationForTA,
      { "rxTimingDeviationForTA", "rnsap.rxTimingDeviationForTA",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD/rxTimingDeviationForTA", HFILL }},
    { &hf_rnsap_uL_Timeslot_InformationModifyList_RL_ReconfReadyTDD,
      { "uL-Timeslot-InformationModifyList-RL-ReconfReadyTDD", "rnsap.uL_Timeslot_InformationModifyList_RL_ReconfReadyTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD/uL-Timeslot-InformationModifyList-RL-ReconfReadyTDD", HFILL }},
    { &hf_rnsap_UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_timeSlotLCR,
      { "timeSlotLCR", "rnsap.timeSlotLCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_midambleShiftLCR,
      { "midambleShiftLCR", "rnsap.midambleShiftLCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tDD_uL_Code_LCR_Information,
      { "tDD-uL-Code-LCR-Information", "rnsap.tDD_uL_Code_LCR_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD/tDD-uL-Code-LCR-Information", HFILL }},
    { &hf_rnsap_TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TDD-UL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_dPCH_ID,
      { "dPCH-ID", "rnsap.dPCH_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tDD_ChannelisationCodeLCR,
      { "tDD-ChannelisationCodeLCR", "rnsap.tDD_ChannelisationCodeLCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_timeSlot,
      { "timeSlot", "rnsap.timeSlot",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_midambleShiftAndBurstType,
      { "midambleShiftAndBurstType", "rnsap.midambleShiftAndBurstType",
        FT_UINT32, BASE_DEC, VALS(rnsap_MidambleShiftAndBurstType_vals), 0,
        "", HFILL }},
    { &hf_rnsap_uL_Code_Information,
      { "uL-Code-Information", "rnsap.uL_Code_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD/uL-Code-Information", HFILL }},
    { &hf_rnsap_TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_tDD_ChannelisationCode,
      { "tDD-ChannelisationCode", "rnsap.tDD_ChannelisationCode",
        FT_UINT32, BASE_DEC, VALS(rnsap_TDD_ChannelisationCode_vals), 0,
        "", HFILL }},
    { &hf_rnsap_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_DL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.DL_CCTrCHInformationListIE_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCHInformationListIE-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_dl_DPCH_AddInformation,
      { "dl-DPCH-AddInformation", "rnsap.dl_DPCH_AddInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationItem-RL-ReconfReadyTDD/dl-DPCH-AddInformation", HFILL }},
    { &hf_rnsap_dl_DPCH_ModifyInformation,
      { "dl-DPCH-ModifyInformation", "rnsap.dl_DPCH_ModifyInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationItem-RL-ReconfReadyTDD/dl-DPCH-ModifyInformation", HFILL }},
    { &hf_rnsap_dl_DPCH_DeleteInformation,
      { "dl-DPCH-DeleteInformation", "rnsap.dl_DPCH_DeleteInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationItem-RL-ReconfReadyTDD/dl-DPCH-DeleteInformation", HFILL }},
    { &hf_rnsap_dL_TimeslotLCR_Info,
      { "dL-TimeslotLCR-Info", "rnsap.dL_TimeslotLCR_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD/dL-TimeslotLCR-Info", HFILL }},
    { &hf_rnsap_dL_Timeslot_InformationModifyList_RL_ReconfReadyTDD,
      { "dL-Timeslot-InformationModifyList-RL-ReconfReadyTDD", "rnsap.dL_Timeslot_InformationModifyList_RL_ReconfReadyTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD/dL-Timeslot-InformationModifyList-RL-ReconfReadyTDD", HFILL }},
    { &hf_rnsap_DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_tDD_dL_Code_LCR_Information,
      { "tDD-dL-Code-LCR-Information", "rnsap.tDD_dL_Code_LCR_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD/tDD-dL-Code-LCR-Information", HFILL }},
    { &hf_rnsap_TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TDD-DL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_dL_Code_Information,
      { "dL-Code-Information", "rnsap.dL_Code_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD/dL-Code-Information", HFILL }},
    { &hf_rnsap_TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_Multiple_RL_InformationResponse_RL_ReconfReadyTDD_item,
      { "Item", "rnsap.Multiple_RL_InformationResponse_RL_ReconfReadyTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Multiple-RL-InformationResponse-RL-ReconfReadyTDD/_item", HFILL }},
    { &hf_rnsap_generalCause4,
      { "generalCause", "rnsap.generalCause",
        FT_NONE, BASE_NONE, NULL, 0,
        "CauseLevel-RL-ReconfFailure/generalCause", HFILL }},
    { &hf_rnsap_rLSpecificCause4,
      { "rLSpecificCause", "rnsap.rLSpecificCause",
        FT_NONE, BASE_NONE, NULL, 0,
        "CauseLevel-RL-ReconfFailure/rLSpecificCause", HFILL }},
    { &hf_rnsap_rL_ReconfigurationFailureList_RL_ReconfFailure,
      { "rL-ReconfigurationFailureList-RL-ReconfFailure", "rnsap.rL_ReconfigurationFailureList_RL_ReconfFailure",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RLSpecificCauseList-RL-ReconfFailure/rL-ReconfigurationFailureList-RL-ReconfFailure", HFILL }},
    { &hf_rnsap_RL_ReconfigurationFailureList_RL_ReconfFailure_item,
      { "Item", "rnsap.RL_ReconfigurationFailureList_RL_ReconfFailure_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-ReconfigurationFailureList-RL-ReconfFailure/_item", HFILL }},
    { &hf_rnsap_DCH_DeleteList_RL_ReconfRqstFDD_item,
      { "Item", "rnsap.DCH_DeleteList_RL_ReconfRqstFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-DeleteList-RL-ReconfRqstFDD/_item", HFILL }},
    { &hf_rnsap_RL_ReconfigurationRequestFDD_RL_InformationList_item,
      { "Item", "rnsap.RL_ReconfigurationRequestFDD_RL_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-ReconfigurationRequestFDD-RL-InformationList/_item", HFILL }},
    { &hf_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item,
      { "Item", "rnsap.UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item,
      { "Item", "rnsap.UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item,
      { "Item", "rnsap.DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item,
      { "Item", "rnsap.DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_DCH_DeleteList_RL_ReconfRqstTDD_item,
      { "Item", "rnsap.DCH_DeleteList_RL_ReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-DeleteList-RL-ReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_Multiple_RL_ReconfigurationRequestTDD_RL_Information_item,
      { "Item", "rnsap.Multiple_RL_ReconfigurationRequestTDD_RL_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Multiple-RL-ReconfigurationRequestTDD-RL-Information/_item", HFILL }},
    { &hf_rnsap_RL_InformationResponseList_RL_ReconfRspFDD_item,
      { "Item", "rnsap.RL_InformationResponseList_RL_ReconfRspFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseList-RL-ReconfRspFDD/_item", HFILL }},
    { &hf_rnsap_dCHsInformationResponseList,
      { "dCHsInformationResponseList", "rnsap.dCHsInformationResponseList",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseItem-RL-ReconfRspFDD/dCHsInformationResponseList", HFILL }},
    { &hf_rnsap_dL_CodeInformationList_RL_ReconfResp,
      { "dL-CodeInformationList-RL-ReconfResp", "rnsap.dL_CodeInformationList_RL_ReconfResp",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponseItem-RL-ReconfRspFDD/dL-CodeInformationList-RL-ReconfResp", HFILL }},
    { &hf_rnsap_dCHsInformationResponseList1,
      { "dCHsInformationResponseList", "rnsap.dCHsInformationResponseList",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationResponse-RL-ReconfRspTDD/dCHsInformationResponseList", HFILL }},
    { &hf_rnsap_DL_CCTrCH_InformationList_RL_ReconfRspTDD_item,
      { "Item", "rnsap.DL_CCTrCH_InformationList_RL_ReconfRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationList-RL-ReconfRspTDD/_item", HFILL }},
    { &hf_rnsap_dl_DPCH_ModifyInformation_LCR,
      { "dl-DPCH-ModifyInformation-LCR", "rnsap.dl_DPCH_ModifyInformation_LCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationItem-RL-ReconfRspTDD/dl-DPCH-ModifyInformation-LCR", HFILL }},
    { &hf_rnsap_cCTrCH_Maximum_DL_Power,
      { "cCTrCH-Maximum-DL-Power", "rnsap.cCTrCH_Maximum_DL_Power",
        FT_INT32, BASE_DEC, NULL, 0,
        "DL-CCTrCH-InformationItem-RL-ReconfRspTDD/cCTrCH-Maximum-DL-Power", HFILL }},
    { &hf_rnsap_cCTrCH_Minimum_DL_Power,
      { "cCTrCH-Minimum-DL-Power", "rnsap.cCTrCH_Minimum_DL_Power",
        FT_INT32, BASE_DEC, NULL, 0,
        "DL-CCTrCH-InformationItem-RL-ReconfRspTDD/cCTrCH-Minimum-DL-Power", HFILL }},
    { &hf_rnsap_dL_Timeslot_LCR_InformationModifyList_RL_ReconfRqstTDD,
      { "dL-Timeslot-LCR-InformationModifyList-RL-ReconfRqstTDD", "rnsap.dL_Timeslot_LCR_InformationModifyList_RL_ReconfRqstTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD/dL-Timeslot-LCR-InformationModifyList-RL-ReconfRqstTDD", HFILL }},
    { &hf_rnsap_DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD_item,
      { "Item", "rnsap.DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-Timeslot-LCR-InformationModifyList-RL-ReconfRspTDD/_item", HFILL }},
    { &hf_rnsap_maxPowerLCR,
      { "maxPowerLCR", "rnsap.maxPowerLCR",
        FT_INT32, BASE_DEC, NULL, 0,
        "DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD/maxPowerLCR", HFILL }},
    { &hf_rnsap_minPowerLCR,
      { "minPowerLCR", "rnsap.minPowerLCR",
        FT_INT32, BASE_DEC, NULL, 0,
        "DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD/minPowerLCR", HFILL }},
    { &hf_rnsap_Multiple_RL_InformationResponse_RL_ReconfRspTDD_item,
      { "Item", "rnsap.Multiple_RL_InformationResponse_RL_ReconfRspTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Multiple-RL-InformationResponse-RL-ReconfRspTDD/_item", HFILL }},
    { &hf_rnsap_rL,
      { "rL", "rnsap.rL",
        FT_NONE, BASE_NONE, NULL, 0,
        "Reporting-Object-RL-FailureInd/rL", HFILL }},
    { &hf_rnsap_rL_Set,
      { "rL-Set", "rnsap.rL_Set",
        FT_NONE, BASE_NONE, NULL, 0,
        "Reporting-Object-RL-FailureInd/rL-Set", HFILL }},
    { &hf_rnsap_cCTrCH,
      { "cCTrCH", "rnsap.cCTrCH",
        FT_NONE, BASE_NONE, NULL, 0,
        "Reporting-Object-RL-FailureInd/cCTrCH", HFILL }},
    { &hf_rnsap_rL_InformationList_RL_FailureInd,
      { "rL-InformationList-RL-FailureInd", "rnsap.rL_InformationList_RL_FailureInd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-RL-FailureInd/rL-InformationList-RL-FailureInd", HFILL }},
    { &hf_rnsap_RL_InformationList_RL_FailureInd_item,
      { "Item", "rnsap.RL_InformationList_RL_FailureInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-RL-FailureInd/_item", HFILL }},
    { &hf_rnsap_rL_Set_InformationList_RL_FailureInd,
      { "rL-Set-InformationList-RL-FailureInd", "rnsap.rL_Set_InformationList_RL_FailureInd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Set-RL-FailureInd/rL-Set-InformationList-RL-FailureInd", HFILL }},
    { &hf_rnsap_RL_Set_InformationList_RL_FailureInd_item,
      { "Item", "rnsap.RL_Set_InformationList_RL_FailureInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Set-InformationList-RL-FailureInd/_item", HFILL }},
    { &hf_rnsap_cCTrCH_InformationList_RL_FailureInd,
      { "cCTrCH-InformationList-RL-FailureInd", "rnsap.cCTrCH_InformationList_RL_FailureInd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "CCTrCH-RL-FailureInd/cCTrCH-InformationList-RL-FailureInd", HFILL }},
    { &hf_rnsap_CCTrCH_InformationList_RL_FailureInd_item,
      { "Item", "rnsap.CCTrCH_InformationList_RL_FailureInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "CCTrCH-InformationList-RL-FailureInd/_item", HFILL }},
    { &hf_rnsap_RL_InformationList_RL_PreemptRequiredInd_item,
      { "Item", "rnsap.RL_InformationList_RL_PreemptRequiredInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-RL-PreemptRequiredInd/_item", HFILL }},
    { &hf_rnsap_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd_item,
      { "Item", "rnsap.HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd/_item", HFILL }},
    { &hf_rnsap_hSDSCH_MACdFlow_ID,
      { "hSDSCH-MACdFlow-ID", "rnsap.hSDSCH_MACdFlow_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd_item,
      { "Item", "rnsap.EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd/_item", HFILL }},
    { &hf_rnsap_eDCH_MACdFlow_ID,
      { "eDCH-MACdFlow-ID", "rnsap.eDCH_MACdFlow_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_rL1,
      { "rL", "rnsap.rL",
        FT_NONE, BASE_NONE, NULL, 0,
        "Reporting-Object-RL-RestoreInd/rL", HFILL }},
    { &hf_rnsap_rL_Set1,
      { "rL-Set", "rnsap.rL_Set",
        FT_NONE, BASE_NONE, NULL, 0,
        "Reporting-Object-RL-RestoreInd/rL-Set", HFILL }},
    { &hf_rnsap_cCTrCH1,
      { "cCTrCH", "rnsap.cCTrCH",
        FT_NONE, BASE_NONE, NULL, 0,
        "Reporting-Object-RL-RestoreInd/cCTrCH", HFILL }},
    { &hf_rnsap_rL_InformationList_RL_RestoreInd,
      { "rL-InformationList-RL-RestoreInd", "rnsap.rL_InformationList_RL_RestoreInd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-RL-RestoreInd/rL-InformationList-RL-RestoreInd", HFILL }},
    { &hf_rnsap_RL_InformationList_RL_RestoreInd_item,
      { "Item", "rnsap.RL_InformationList_RL_RestoreInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-RL-RestoreInd/_item", HFILL }},
    { &hf_rnsap_rL_Set_InformationList_RL_RestoreInd,
      { "rL-Set-InformationList-RL-RestoreInd", "rnsap.rL_Set_InformationList_RL_RestoreInd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Set-RL-RestoreInd/rL-Set-InformationList-RL-RestoreInd", HFILL }},
    { &hf_rnsap_RL_Set_InformationList_RL_RestoreInd_item,
      { "Item", "rnsap.RL_Set_InformationList_RL_RestoreInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Set-InformationList-RL-RestoreInd/_item", HFILL }},
    { &hf_rnsap_cCTrCH_InformationList_RL_RestoreInd,
      { "cCTrCH-InformationList-RL-RestoreInd", "rnsap.cCTrCH_InformationList_RL_RestoreInd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "CCTrCH-RL-RestoreInd/cCTrCH-InformationList-RL-RestoreInd", HFILL }},
    { &hf_rnsap_CCTrCH_InformationList_RL_RestoreInd_item,
      { "Item", "rnsap.CCTrCH_InformationList_RL_RestoreInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "CCTrCH-InformationList-RL-RestoreInd/_item", HFILL }},
    { &hf_rnsap_DL_ReferencePowerInformationList_DL_PC_Rqst_item,
      { "Item", "rnsap.DL_ReferencePowerInformationList_DL_PC_Rqst_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-ReferencePowerInformationList-DL-PC-Rqst/_item", HFILL }},
    { &hf_rnsap_dl_Reference_Power,
      { "dl-Reference-Power", "rnsap.dl_Reference_Power",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dl_CodeInformation3,
      { "dl-CodeInformation", "rnsap.dl_CodeInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Information-PhyChReconfRqstFDD/dl-CodeInformation", HFILL }},
    { &hf_rnsap_ul_CCTrCH_Information1,
      { "ul-CCTrCH-Information", "rnsap.ul_CCTrCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Information-PhyChReconfRqstTDD/ul-CCTrCH-Information", HFILL }},
    { &hf_rnsap_dl_CCTrCH_Information1,
      { "dl-CCTrCH-Information", "rnsap.dl_CCTrCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Information-PhyChReconfRqstTDD/dl-CCTrCH-Information", HFILL }},
    { &hf_rnsap_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item,
      { "Item", "rnsap.UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_ul_DPCH_Information2,
      { "ul-DPCH-Information", "rnsap.ul_DPCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-CCTrCH-InformationItem-PhyChReconfRqstTDD/ul-DPCH-Information", HFILL }},
    { &hf_rnsap_uL_Timeslot_InformationList_PhyChReconfRqstTDD,
      { "uL-Timeslot-InformationList-PhyChReconfRqstTDD", "rnsap.uL_Timeslot_InformationList_PhyChReconfRqstTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-DPCH-InformationItem-PhyChReconfRqstTDD/uL-Timeslot-InformationList-PhyChReconfRqstTDD", HFILL }},
    { &hf_rnsap_UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item,
      { "Item", "rnsap.UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-TimeslotLCR-InformationList-PhyChReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_uL_Code_LCR_Information,
      { "uL-Code-LCR-Information", "rnsap.uL_Code_LCR_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD/uL-Code-LCR-Information", HFILL }},
    { &hf_rnsap_UL_Timeslot_InformationList_PhyChReconfRqstTDD_item,
      { "Item", "rnsap.UL_Timeslot_InformationList_PhyChReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-Timeslot-InformationList-PhyChReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_uL_Code_Information1,
      { "uL-Code-Information", "rnsap.uL_Code_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item,
      { "Item", "rnsap.DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_dl_DPCH_Information2,
      { "dl-DPCH-Information", "rnsap.dl_DPCH_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-CCTrCH-InformationItem-PhyChReconfRqstTDD/dl-DPCH-Information", HFILL }},
    { &hf_rnsap_dL_Timeslot_InformationList_PhyChReconfRqstTDD,
      { "dL-Timeslot-InformationList-PhyChReconfRqstTDD", "rnsap.dL_Timeslot_InformationList_PhyChReconfRqstTDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-DPCH-InformationItem-PhyChReconfRqstTDD/dL-Timeslot-InformationList-PhyChReconfRqstTDD", HFILL }},
    { &hf_rnsap_DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item,
      { "Item", "rnsap.DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-TimeslotLCR-InformationList-PhyChReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_dL_Code_LCR_Information,
      { "dL-Code-LCR-Information", "rnsap.dL_Code_LCR_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_DL_Timeslot_InformationList_PhyChReconfRqstTDD_item,
      { "Item", "rnsap.DL_Timeslot_InformationList_PhyChReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-Timeslot-InformationList-PhyChReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_dL_Code_Information1,
      { "dL-Code-Information", "rnsap.dL_Code_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD_item,
      { "Item", "rnsap.HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_timeslot,
      { "timeslot", "rnsap.timeslot",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD_item,
      { "Item", "rnsap.HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD/_item", HFILL }},
    { &hf_rnsap_timeslotLCR,
      { "timeslotLCR", "rnsap.timeslotLCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_RL_InformationList_RL_CongestInd_item,
      { "Item", "rnsap.RL_InformationList_RL_CongestInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-RL-CongestInd/_item", HFILL }},
    { &hf_rnsap_dCH_Rate_Information,
      { "dCH-Rate-Information", "rnsap.dCH_Rate_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-InformationItem-RL-CongestInd/dCH-Rate-Information", HFILL }},
    { &hf_rnsap_DCH_Rate_Information_RL_CongestInd_item,
      { "Item", "rnsap.DCH_Rate_Information_RL_CongestInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-Rate-Information-RL-CongestInd/_item", HFILL }},
    { &hf_rnsap_allowed_Rate_Information,
      { "allowed-Rate-Information", "rnsap.allowed_Rate_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-Rate-InformationItem-RL-CongestInd/allowed-Rate-Information", HFILL }},
    { &hf_rnsap_EDCH_MacdFlowSpecificInformationList_RL_CongestInd_item,
      { "Item", "rnsap.EDCH_MacdFlowSpecificInformationList_RL_CongestInd_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-MacdFlowSpecificInformationList-RL-CongestInd/_item", HFILL }},
    { &hf_rnsap_uRA,
      { "uRA", "rnsap.uRA",
        FT_NONE, BASE_NONE, NULL, 0,
        "PagingArea-PagingRqst/uRA", HFILL }},
    { &hf_rnsap_cell,
      { "cell", "rnsap.cell",
        FT_NONE, BASE_NONE, NULL, 0,
        "PagingArea-PagingRqst/cell", HFILL }},
    { &hf_rnsap_uRA_ID,
      { "uRA-ID", "rnsap.uRA_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_pagingCause,
      { "pagingCause", "rnsap.pagingCause",
        FT_UINT32, BASE_DEC, VALS(rnsap_PagingCause_vals), 0,
        "CNOriginatedPage-PagingRqst/pagingCause", HFILL }},
    { &hf_rnsap_cNDomainType,
      { "cNDomainType", "rnsap.cNDomainType",
        FT_UINT32, BASE_DEC, VALS(rnsap_CNDomainType_vals), 0,
        "CNOriginatedPage-PagingRqst/cNDomainType", HFILL }},
    { &hf_rnsap_pagingRecordType,
      { "pagingRecordType", "rnsap.pagingRecordType",
        FT_UINT32, BASE_DEC, VALS(rnsap_PagingRecordType_vals), 0,
        "CNOriginatedPage-PagingRqst/pagingRecordType", HFILL }},
    { &hf_rnsap_rL2,
      { "rL", "rnsap.rL",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rqst/rL", HFILL }},
    { &hf_rnsap_rLS,
      { "rLS", "rnsap.rLS",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rqst/rLS", HFILL }},
    { &hf_rnsap_allRL,
      { "allRL", "rnsap.allRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rqst/allRL", HFILL }},
    { &hf_rnsap_allRLS,
      { "allRLS", "rnsap.allRLS",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rqst/allRLS", HFILL }},
    { &hf_rnsap_rL_InformationList_DM_Rqst,
      { "rL-InformationList-DM-Rqst", "rnsap.rL_InformationList_DM_Rqst",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-DM-Rqst/rL-InformationList-DM-Rqst", HFILL }},
    { &hf_rnsap_RL_InformationList_DM_Rqst_item,
      { "Item", "rnsap.RL_InformationList_DM_Rqst_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-DM-Rqst/_item", HFILL }},
    { &hf_rnsap_HSSICH_Info_DM_Rqst_item,
      { "Item", "rnsap.HSSICH_Info_DM_Rqst_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSSICH-Info-DM-Rqst/_item", HFILL }},
    { &hf_rnsap_rL_Set_InformationList_DM_Rqst,
      { "rL-Set-InformationList-DM-Rqst", "rnsap.rL_Set_InformationList_DM_Rqst",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Set-DM-Rqst/rL-Set-InformationList-DM-Rqst", HFILL }},
    { &hf_rnsap_RL_Set_InformationList_DM_Rqst_item,
      { "Item", "rnsap.RL_Set_InformationList_DM_Rqst_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Set-InformationList-DM-Rqst/_item", HFILL }},
    { &hf_rnsap_rLs,
      { "rLs", "rnsap.rLs",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rsp/rLs", HFILL }},
    { &hf_rnsap_rLS1,
      { "rLS", "rnsap.rLS",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rsp/rLS", HFILL }},
    { &hf_rnsap_allRL1,
      { "allRL", "rnsap.allRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rsp/allRL", HFILL }},
    { &hf_rnsap_allRLS1,
      { "allRLS", "rnsap.allRLS",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rsp/allRLS", HFILL }},
    { &hf_rnsap_rL_InformationList_DM_Rsp,
      { "rL-InformationList-DM-Rsp", "rnsap.rL_InformationList_DM_Rsp",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-DM-Rsp/rL-InformationList-DM-Rsp", HFILL }},
    { &hf_rnsap_rL_Set_InformationList_DM_Rsp,
      { "rL-Set-InformationList-DM-Rsp", "rnsap.rL_Set_InformationList_DM_Rsp",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Set-DM-Rsp/rL-Set-InformationList-DM-Rsp", HFILL }},
    { &hf_rnsap_RL_InformationList_DM_Rsp_item,
      { "Item", "rnsap.RL_InformationList_DM_Rsp_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-DM-Rsp/_item", HFILL }},
    { &hf_rnsap_dedicatedMeasurementValue,
      { "dedicatedMeasurementValue", "rnsap.dedicatedMeasurementValue",
        FT_UINT32, BASE_DEC, VALS(rnsap_DedicatedMeasurementValue_vals), 0,
        "", HFILL }},
    { &hf_rnsap_cFN,
      { "cFN", "rnsap.cFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_RL_Set_InformationList_DM_Rsp_item,
      { "Item", "rnsap.RL_Set_InformationList_DM_Rsp_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Set-InformationList-DM-Rsp/_item", HFILL }},
    { &hf_rnsap_Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp_item,
      { "Item", "rnsap.Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp/_item", HFILL }},
    { &hf_rnsap_Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp_item,
      { "Item", "rnsap.Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp/_item", HFILL }},
    { &hf_rnsap_rL3,
      { "rL", "rnsap.rL",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Fail/rL", HFILL }},
    { &hf_rnsap_rLS2,
      { "rLS", "rnsap.rLS",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Fail/rLS", HFILL }},
    { &hf_rnsap_allRL2,
      { "allRL", "rnsap.allRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Fail/allRL", HFILL }},
    { &hf_rnsap_allRLS2,
      { "allRLS", "rnsap.allRLS",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Fail/allRLS", HFILL }},
    { &hf_rnsap_rL_unsuccessful_InformationRespList_DM_Fail,
      { "rL-unsuccessful-InformationRespList-DM-Fail", "rnsap.rL_unsuccessful_InformationRespList_DM_Fail",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-DM-Fail/rL-unsuccessful-InformationRespList-DM-Fail", HFILL }},
    { &hf_rnsap_rL_successful_InformationRespList_DM_Fail,
      { "rL-successful-InformationRespList-DM-Fail", "rnsap.rL_successful_InformationRespList_DM_Fail",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-DM-Fail/rL-successful-InformationRespList-DM-Fail", HFILL }},
    { &hf_rnsap_rL_Set_unsuccessful_InformationRespList_DM_Fail,
      { "rL-Set-unsuccessful-InformationRespList-DM-Fail", "rnsap.rL_Set_unsuccessful_InformationRespList_DM_Fail",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Set-DM-Fail/rL-Set-unsuccessful-InformationRespList-DM-Fail", HFILL }},
    { &hf_rnsap_rL_Set_successful_InformationRespList_DM_Fail,
      { "rL-Set-successful-InformationRespList-DM-Fail", "rnsap.rL_Set_successful_InformationRespList_DM_Fail",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Set-DM-Fail/rL-Set-successful-InformationRespList-DM-Fail", HFILL }},
    { &hf_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_item,
      { "Item", "rnsap.RL_Unsuccessful_InformationRespList_DM_Fail_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Unsuccessful-InformationRespList-DM-Fail/_item", HFILL }},
    { &hf_rnsap_individualcause,
      { "individualcause", "rnsap.individualcause",
        FT_UINT32, BASE_DEC, VALS(rnsap_Cause_vals), 0,
        "", HFILL }},
    { &hf_rnsap_RL_Successful_InformationRespList_DM_Fail_item,
      { "Item", "rnsap.RL_Successful_InformationRespList_DM_Fail_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Successful-InformationRespList-DM-Fail/_item", HFILL }},
    { &hf_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_item,
      { "Item", "rnsap.RL_Set_Unsuccessful_InformationRespList_DM_Fail_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Set-Unsuccessful-InformationRespList-DM-Fail/_item", HFILL }},
    { &hf_rnsap_RL_Set_Successful_InformationRespList_DM_Fail_item,
      { "Item", "rnsap.RL_Set_Successful_InformationRespList_DM_Fail_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Set-Successful-InformationRespList-DM-Fail/_item", HFILL }},
    { &hf_rnsap_rLs1,
      { "rLs", "rnsap.rLs",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rprt/rLs", HFILL }},
    { &hf_rnsap_rLS3,
      { "rLS", "rnsap.rLS",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rprt/rLS", HFILL }},
    { &hf_rnsap_allRL3,
      { "allRL", "rnsap.allRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rprt/allRL", HFILL }},
    { &hf_rnsap_allRLS3,
      { "allRLS", "rnsap.allRLS",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Rprt/allRLS", HFILL }},
    { &hf_rnsap_rL_InformationList_DM_Rprt,
      { "rL-InformationList-DM-Rprt", "rnsap.rL_InformationList_DM_Rprt",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-DM-Rprt/rL-InformationList-DM-Rprt", HFILL }},
    { &hf_rnsap_rL_Set_InformationList_DM_Rprt,
      { "rL-Set-InformationList-DM-Rprt", "rnsap.rL_Set_InformationList_DM_Rprt",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Set-DM-Rprt/rL-Set-InformationList-DM-Rprt", HFILL }},
    { &hf_rnsap_RL_InformationList_DM_Rprt_item,
      { "Item", "rnsap.RL_InformationList_DM_Rprt_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-InformationList-DM-Rprt/_item", HFILL }},
    { &hf_rnsap_dedicatedMeasurementValueInformation,
      { "dedicatedMeasurementValueInformation", "rnsap.dedicatedMeasurementValueInformation",
        FT_UINT32, BASE_DEC, VALS(rnsap_DedicatedMeasurementValueInformation_vals), 0,
        "", HFILL }},
    { &hf_rnsap_RL_Set_InformationList_DM_Rprt_item,
      { "Item", "rnsap.RL_Set_InformationList_DM_Rprt_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Set-InformationList-DM-Rprt/_item", HFILL }},
    { &hf_rnsap_rL4,
      { "rL", "rnsap.rL",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Fail-Ind/rL", HFILL }},
    { &hf_rnsap_rLS4,
      { "rLS", "rnsap.rLS",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Fail-Ind/rLS", HFILL }},
    { &hf_rnsap_allRL4,
      { "allRL", "rnsap.allRL",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Fail-Ind/allRL", HFILL }},
    { &hf_rnsap_allRLS4,
      { "allRLS", "rnsap.allRLS",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementObjectType-DM-Fail-Ind/allRLS", HFILL }},
    { &hf_rnsap_rL_unsuccessful_InformationRespList_DM_Fail_Ind,
      { "rL-unsuccessful-InformationRespList-DM-Fail-Ind", "rnsap.rL_unsuccessful_InformationRespList_DM_Fail_Ind",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-DM-Fail-Ind/rL-unsuccessful-InformationRespList-DM-Fail-Ind", HFILL }},
    { &hf_rnsap_rL_Set_unsuccessful_InformationRespList_DM_Fail_Ind,
      { "rL-Set-unsuccessful-InformationRespList-DM-Fail-Ind", "rnsap.rL_Set_unsuccessful_InformationRespList_DM_Fail_Ind",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Set-DM-Fail-Ind/rL-Set-unsuccessful-InformationRespList-DM-Fail-Ind", HFILL }},
    { &hf_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_Ind_item,
      { "Item", "rnsap.RL_Unsuccessful_InformationRespList_DM_Fail_Ind_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Unsuccessful-InformationRespList-DM-Fail-Ind/_item", HFILL }},
    { &hf_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind_item,
      { "Item", "rnsap.RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Set-Unsuccessful-InformationRespList-DM-Fail-Ind/_item", HFILL }},
    { &hf_rnsap_fACH_FlowControlInformation,
      { "fACH-FlowControlInformation", "rnsap.fACH_FlowControlInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD/fACH-FlowControlInformation", HFILL }},
    { &hf_rnsap_fACH_FlowControlInformation1,
      { "fACH-FlowControlInformation", "rnsap.fACH_FlowControlInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD/fACH-FlowControlInformation", HFILL }},
    { &hf_rnsap_cell1,
      { "cell", "rnsap.cell",
        FT_NONE, BASE_NONE, NULL, 0,
        "CommonMeasurementObjectType-CM-Rqst/cell", HFILL }},
    { &hf_rnsap_uC_ID,
      { "uC-ID", "rnsap.uC_ID",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_neighbouringCellMeasurementInformation,
      { "neighbouringCellMeasurementInformation", "rnsap.neighbouringCellMeasurementInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Cell-CM-Rqst/neighbouringCellMeasurementInformation", HFILL }},
    { &hf_rnsap_NeighbouringCellMeasurementInfo_item,
      { "Item", "rnsap.NeighbouringCellMeasurementInfo_item",
        FT_UINT32, BASE_DEC, VALS(rnsap_NeighbouringCellMeasurementInfo_item_vals), 0,
        "NeighbouringCellMeasurementInfo/_item", HFILL }},
    { &hf_rnsap_neighbouringFDDCellMeasurementInformation,
      { "neighbouringFDDCellMeasurementInformation", "rnsap.neighbouringFDDCellMeasurementInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "NeighbouringCellMeasurementInfo/_item/neighbouringFDDCellMeasurementInformation", HFILL }},
    { &hf_rnsap_neighbouringTDDCellMeasurementInformation,
      { "neighbouringTDDCellMeasurementInformation", "rnsap.neighbouringTDDCellMeasurementInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "NeighbouringCellMeasurementInfo/_item/neighbouringTDDCellMeasurementInformation", HFILL }},
    { &hf_rnsap_extension_neighbouringCellMeasurementInformation,
      { "extension-neighbouringCellMeasurementInformation", "rnsap.extension_neighbouringCellMeasurementInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "NeighbouringCellMeasurementInfo/_item/extension-neighbouringCellMeasurementInformation", HFILL }},
    { &hf_rnsap_cell2,
      { "cell", "rnsap.cell",
        FT_NONE, BASE_NONE, NULL, 0,
        "CommonMeasurementObjectType-CM-Rsp/cell", HFILL }},
    { &hf_rnsap_commonMeasurementValue,
      { "commonMeasurementValue", "rnsap.commonMeasurementValue",
        FT_UINT32, BASE_DEC, VALS(rnsap_CommonMeasurementValue_vals), 0,
        "", HFILL }},
    { &hf_rnsap_cell3,
      { "cell", "rnsap.cell",
        FT_NONE, BASE_NONE, NULL, 0,
        "CommonMeasurementObjectType-CM-Rprt/cell", HFILL }},
    { &hf_rnsap_commonMeasurementValueInformation,
      { "commonMeasurementValueInformation", "rnsap.commonMeasurementValueInformation",
        FT_UINT32, BASE_DEC, VALS(rnsap_CommonMeasurementValueInformation_vals), 0,
        "Cell-CM-Rprt/commonMeasurementValueInformation", HFILL }},
    { &hf_rnsap_cell4,
      { "cell", "rnsap.cell",
        FT_NONE, BASE_NONE, NULL, 0,
        "InformationExchangeObjectType-InfEx-Rqst/cell", HFILL }},
    { &hf_rnsap_extension_InformationExchangeObjectType_InfEx_Rqst,
      { "extension-InformationExchangeObjectType-InfEx-Rqst", "rnsap.extension_InformationExchangeObjectType_InfEx_Rqst",
        FT_NONE, BASE_NONE, NULL, 0,
        "InformationExchangeObjectType-InfEx-Rqst/extension-InformationExchangeObjectType-InfEx-Rqst", HFILL }},
    { &hf_rnsap_cGI,
      { "cGI", "rnsap.cGI",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_cell5,
      { "cell", "rnsap.cell",
        FT_NONE, BASE_NONE, NULL, 0,
        "InformationExchangeObjectType-InfEx-Rsp/cell", HFILL }},
    { &hf_rnsap_extension_InformationExchangeObjectType_InfEx_Rsp,
      { "extension-InformationExchangeObjectType-InfEx-Rsp", "rnsap.extension_InformationExchangeObjectType_InfEx_Rsp",
        FT_NONE, BASE_NONE, NULL, 0,
        "InformationExchangeObjectType-InfEx-Rsp/extension-InformationExchangeObjectType-InfEx-Rsp", HFILL }},
    { &hf_rnsap_requestedDataValue,
      { "requestedDataValue", "rnsap.requestedDataValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_MBMS_Bearer_Service_List_InfEx_Rsp_item,
      { "Item", "rnsap.MBMS_Bearer_Service_List_InfEx_Rsp_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "MBMS-Bearer-Service-List-InfEx-Rsp/_item", HFILL }},
    { &hf_rnsap_tmgi,
      { "tmgi", "rnsap.tmgi",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_cell6,
      { "cell", "rnsap.cell",
        FT_NONE, BASE_NONE, NULL, 0,
        "InformationExchangeObjectType-InfEx-Rprt/cell", HFILL }},
    { &hf_rnsap_requestedDataValueInformation,
      { "requestedDataValueInformation", "rnsap.requestedDataValueInformation",
        FT_UINT32, BASE_DEC, VALS(rnsap_RequestedDataValueInformation_vals), 0,
        "Cell-InfEx-Rprt/requestedDataValueInformation", HFILL }},
    { &hf_rnsap_context,
      { "context", "rnsap.context",
        FT_NONE, BASE_NONE, NULL, 0,
        "ResetIndicator/context", HFILL }},
    { &hf_rnsap_all_contexts,
      { "all-contexts", "rnsap.all_contexts",
        FT_NONE, BASE_NONE, NULL, 0,
        "ResetIndicator/all-contexts", HFILL }},
    { &hf_rnsap_contextGroup,
      { "contextGroup", "rnsap.contextGroup",
        FT_NONE, BASE_NONE, NULL, 0,
        "ResetIndicator/contextGroup", HFILL }},
    { &hf_rnsap_contextInfoList_Reset,
      { "contextInfoList-Reset", "rnsap.contextInfoList_Reset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ContextList-Reset/contextInfoList-Reset", HFILL }},
    { &hf_rnsap_ContextInfoList_Reset_item,
      { "Item", "rnsap.ContextInfoList_Reset_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "ContextInfoList-Reset/_item", HFILL }},
    { &hf_rnsap_contextType_Reset,
      { "contextType-Reset", "rnsap.contextType_Reset",
        FT_UINT32, BASE_DEC, VALS(rnsap_ContextType_Reset_vals), 0,
        "ContextInfoItem-Reset/contextType-Reset", HFILL }},
    { &hf_rnsap_sRNTI,
      { "sRNTI", "rnsap.sRNTI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dRNTI,
      { "dRNTI", "rnsap.dRNTI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ContextType-Reset/dRNTI", HFILL }},
    { &hf_rnsap_contextGroupInfoList_Reset,
      { "contextGroupInfoList-Reset", "rnsap.contextGroupInfoList_Reset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ContextGroupList-Reset/contextGroupInfoList-Reset", HFILL }},
    { &hf_rnsap_ContextGroupInfoList_Reset_item,
      { "Item", "rnsap.ContextGroupInfoList_Reset_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "ContextGroupInfoList-Reset/_item", HFILL }},
    { &hf_rnsap_s_RNTI_Group,
      { "s-RNTI-Group", "rnsap.s_RNTI_Group",
        FT_NONE, BASE_NONE, NULL, 0,
        "ContextGroupInfoItem-Reset/s-RNTI-Group", HFILL }},
    { &hf_rnsap_DelayedActivationInformationList_RL_ActivationCmdFDD_item,
      { "Item", "rnsap.DelayedActivationInformationList_RL_ActivationCmdFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DelayedActivationInformationList-RL-ActivationCmdFDD/_item", HFILL }},
    { &hf_rnsap_delayed_activation_update,
      { "delayed-activation-update", "rnsap.delayed_activation_update",
        FT_UINT32, BASE_DEC, VALS(rnsap_DelayedActivationUpdate_vals), 0,
        "", HFILL }},
    { &hf_rnsap_DelayedActivationInformationList_RL_ActivationCmdTDD_item,
      { "Item", "rnsap.DelayedActivationInformationList_RL_ActivationCmdTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DelayedActivationInformationList-RL-ActivationCmdTDD/_item", HFILL }},
    { &hf_rnsap_RL_ParameterUpdateIndicationFDD_RL_InformationList_item,
      { "Item", "rnsap.RL_ParameterUpdateIndicationFDD_RL_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-ParameterUpdateIndicationFDD-RL-InformationList/_item", HFILL }},
    { &hf_rnsap_phase_Reference_Update_Indicator,
      { "phase-Reference-Update-Indicator", "rnsap.phase_Reference_Update_Indicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_Phase_Reference_Update_Indicator_vals), 0,
        "RL-ParameterUpdateIndicationFDD-RL-Information-Item/phase-Reference-Update-Indicator", HFILL }},
    { &hf_rnsap_ListOfInterfacesToTrace_item,
      { "Item", "rnsap.ListOfInterfacesToTrace_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "ListOfInterfacesToTrace/_item", HFILL }},
    { &hf_rnsap_interface,
      { "interface", "rnsap.interface",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_interface_vals), 0,
        "InterfacesToTraceItem/interface", HFILL }},
    { &hf_rnsap_privateIEs,
      { "privateIEs", "rnsap.privateIEs",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PrivateMessage/privateIEs", HFILL }},
    { &hf_rnsap_Active_MBMS_Bearer_Service_ListFDD_item,
      { "Item", "rnsap.Active_MBMS_Bearer_Service_ListFDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Active-MBMS-Bearer-Service-ListFDD/_item", HFILL }},
    { &hf_rnsap_Active_MBMS_Bearer_Service_ListFDD_PFL_item,
      { "Item", "rnsap.Active_MBMS_Bearer_Service_ListFDD_PFL_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Active-MBMS-Bearer-Service-ListFDD-PFL/_item", HFILL }},
    { &hf_rnsap_Active_MBMS_Bearer_Service_ListTDD_item,
      { "Item", "rnsap.Active_MBMS_Bearer_Service_ListTDD_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Active-MBMS-Bearer-Service-ListTDD/_item", HFILL }},
    { &hf_rnsap_Active_MBMS_Bearer_Service_ListTDD_PFL_item,
      { "Item", "rnsap.Active_MBMS_Bearer_Service_ListTDD_PFL_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Active-MBMS-Bearer-Service-ListTDD-PFL/_item", HFILL }},
    { &hf_rnsap_cMConfigurationChangeCFN,
      { "cMConfigurationChangeCFN", "rnsap.cMConfigurationChangeCFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Active-Pattern-Sequence-Information/cMConfigurationChangeCFN", HFILL }},
    { &hf_rnsap_transmission_Gap_Pattern_Sequence_Status,
      { "transmission-Gap-Pattern-Sequence-Status", "rnsap.transmission_Gap_Pattern_Sequence_Status",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Active-Pattern-Sequence-Information/transmission-Gap-Pattern-Sequence-Status", HFILL }},
    { &hf_rnsap_AdditionalPreferredFrequency_item,
      { "Item", "rnsap.AdditionalPreferredFrequency_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "AdditionalPreferredFrequency/_item", HFILL }},
    { &hf_rnsap_correspondingCells,
      { "correspondingCells", "rnsap.correspondingCells",
        FT_UINT32, BASE_DEC, NULL, 0,
        "AdditionalPreferredFrequencyItem/correspondingCells", HFILL }},
    { &hf_rnsap_AffectedUEInformationForMBMS_item,
      { "Item", "rnsap.AffectedUEInformationForMBMS_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "AffectedUEInformationForMBMS/_item", HFILL }},
    { &hf_rnsap_priorityLevel,
      { "priorityLevel", "rnsap.priorityLevel",
        FT_UINT32, BASE_DEC, NULL, 0,
        "AllocationRetentionPriority/priorityLevel", HFILL }},
    { &hf_rnsap_pre_emptionCapability,
      { "pre-emptionCapability", "rnsap.pre_emptionCapability",
        FT_UINT32, BASE_DEC, VALS(rnsap_Pre_emptionCapability_vals), 0,
        "AllocationRetentionPriority/pre-emptionCapability", HFILL }},
    { &hf_rnsap_pre_emptionVulnerability,
      { "pre-emptionVulnerability", "rnsap.pre_emptionVulnerability",
        FT_UINT32, BASE_DEC, VALS(rnsap_Pre_emptionVulnerability_vals), 0,
        "AllocationRetentionPriority/pre-emptionVulnerability", HFILL }},
    { &hf_rnsap_allowed_UL_Rate,
      { "allowed-UL-Rate", "rnsap.allowed_UL_Rate",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Allowed-Rate-Information/allowed-UL-Rate", HFILL }},
    { &hf_rnsap_allowed_DL_Rate,
      { "allowed-DL-Rate", "rnsap.allowed_DL_Rate",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Allowed-Rate-Information/allowed-DL-Rate", HFILL }},
    { &hf_rnsap_aOA_LCR,
      { "aOA-LCR", "rnsap.aOA_LCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Angle-Of-Arrival-Value-LCR/aOA-LCR", HFILL }},
    { &hf_rnsap_aOA_LCR_Accuracy_Class,
      { "aOA-LCR-Accuracy-Class", "rnsap.aOA_LCR_Accuracy_Class",
        FT_UINT32, BASE_DEC, VALS(rnsap_AOA_LCR_Accuracy_Class_vals), 0,
        "Angle-Of-Arrival-Value-LCR/aOA-LCR-Accuracy-Class", HFILL }},
    { &hf_rnsap_badSatelliteInformation,
      { "badSatelliteInformation", "rnsap.badSatelliteInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "BadSatellites/badSatelliteInformation", HFILL }},
    { &hf_rnsap_badSatelliteInformation_item,
      { "Item", "rnsap.badSatelliteInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "BadSatellites/badSatelliteInformation/_item", HFILL }},
    { &hf_rnsap_badSAT_ID,
      { "badSAT-ID", "rnsap.badSAT_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "BadSatellites/badSatelliteInformation/_item/badSAT-ID", HFILL }},
    { &hf_rnsap_nCC,
      { "nCC", "rnsap.nCC",
        FT_BYTES, BASE_HEX, NULL, 0,
        "BSIC/nCC", HFILL }},
    { &hf_rnsap_bCC,
      { "bCC", "rnsap.bCC",
        FT_BYTES, BASE_HEX, NULL, 0,
        "BSIC/bCC", HFILL }},
    { &hf_rnsap_burstStart,
      { "burstStart", "rnsap.burstStart",
        FT_UINT32, BASE_DEC, NULL, 0,
        "BurstModeParameters/burstStart", HFILL }},
    { &hf_rnsap_burstLength,
      { "burstLength", "rnsap.burstLength",
        FT_UINT32, BASE_DEC, NULL, 0,
        "BurstModeParameters/burstLength", HFILL }},
    { &hf_rnsap_burstFreq,
      { "burstFreq", "rnsap.burstFreq",
        FT_UINT32, BASE_DEC, NULL, 0,
        "BurstModeParameters/burstFreq", HFILL }},
    { &hf_rnsap_radioNetwork,
      { "radioNetwork", "rnsap.radioNetwork",
        FT_UINT32, BASE_DEC, VALS(rnsap_CauseRadioNetwork_vals), 0,
        "Cause/radioNetwork", HFILL }},
    { &hf_rnsap_transport,
      { "transport", "rnsap.transport",
        FT_UINT32, BASE_DEC, VALS(rnsap_CauseTransport_vals), 0,
        "Cause/transport", HFILL }},
    { &hf_rnsap_protocol,
      { "protocol", "rnsap.protocol",
        FT_UINT32, BASE_DEC, VALS(rnsap_CauseProtocol_vals), 0,
        "Cause/protocol", HFILL }},
    { &hf_rnsap_misc,
      { "misc", "rnsap.misc",
        FT_UINT32, BASE_DEC, VALS(rnsap_CauseMisc_vals), 0,
        "Cause/misc", HFILL }},
    { &hf_rnsap_uplinkCellCapacityClassValue,
      { "uplinkCellCapacityClassValue", "rnsap.uplinkCellCapacityClassValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Cell-Capacity-Class-Value/uplinkCellCapacityClassValue", HFILL }},
    { &hf_rnsap_downlinkCellCapacityClassValue,
      { "downlinkCellCapacityClassValue", "rnsap.downlinkCellCapacityClassValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Cell-Capacity-Class-Value/downlinkCellCapacityClassValue", HFILL }},
    { &hf_rnsap_lAI,
      { "lAI", "rnsap.lAI",
        FT_NONE, BASE_NONE, NULL, 0,
        "CGI/lAI", HFILL }},
    { &hf_rnsap_pLMN_Identity,
      { "pLMN-Identity", "rnsap.pLMN_Identity",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_lAC,
      { "lAC", "rnsap.lAC",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_cI,
      { "cI", "rnsap.cI",
        FT_BYTES, BASE_HEX, NULL, 0,
        "CGI/cI", HFILL }},
    { &hf_rnsap_tUTRANGPSMeasurementAccuracyClass,
      { "tUTRANGPSMeasurementAccuracyClass", "rnsap.tUTRANGPSMeasurementAccuracyClass",
        FT_UINT32, BASE_DEC, VALS(rnsap_TUTRANGPSAccuracyClass_vals), 0,
        "CommonMeasurementAccuracy/tUTRANGPSMeasurementAccuracyClass", HFILL }},
    { &hf_rnsap_tUTRANGPSMeasurementValueInformation,
      { "tUTRANGPSMeasurementValueInformation", "rnsap.tUTRANGPSMeasurementValueInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "CommonMeasurementValue/tUTRANGPSMeasurementValueInformation", HFILL }},
    { &hf_rnsap_sFNSFNMeasurementValueInformation,
      { "sFNSFNMeasurementValueInformation", "rnsap.sFNSFNMeasurementValueInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "CommonMeasurementValue/sFNSFNMeasurementValueInformation", HFILL }},
    { &hf_rnsap_loadValue,
      { "loadValue", "rnsap.loadValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "CommonMeasurementValue/loadValue", HFILL }},
    { &hf_rnsap_transmittedCarrierPowerValue,
      { "transmittedCarrierPowerValue", "rnsap.transmittedCarrierPowerValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "CommonMeasurementValue/transmittedCarrierPowerValue", HFILL }},
    { &hf_rnsap_receivedTotalWideBandPowerValue,
      { "receivedTotalWideBandPowerValue", "rnsap.receivedTotalWideBandPowerValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "CommonMeasurementValue/receivedTotalWideBandPowerValue", HFILL }},
    { &hf_rnsap_uplinkTimeslotISCPValue,
      { "uplinkTimeslotISCPValue", "rnsap.uplinkTimeslotISCPValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "CommonMeasurementValue/uplinkTimeslotISCPValue", HFILL }},
    { &hf_rnsap_extension_CommonMeasurementValue,
      { "extension-CommonMeasurementValue", "rnsap.extension_CommonMeasurementValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "CommonMeasurementValue/extension-CommonMeasurementValue", HFILL }},
    { &hf_rnsap_measurementAvailable,
      { "measurementAvailable", "rnsap.measurementAvailable",
        FT_NONE, BASE_NONE, NULL, 0,
        "CommonMeasurementValueInformation/measurementAvailable", HFILL }},
    { &hf_rnsap_measurementnotAvailable,
      { "measurementnotAvailable", "rnsap.measurementnotAvailable",
        FT_NONE, BASE_NONE, NULL, 0,
        "CommonMeasurementValueInformation/measurementnotAvailable", HFILL }},
    { &hf_rnsap_CorrespondingCells_item,
      { "Item", "rnsap.CorrespondingCells_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "CorrespondingCells/_item", HFILL }},
    { &hf_rnsap_triggeringMessage,
      { "triggeringMessage", "rnsap.triggeringMessage",
        FT_UINT32, BASE_DEC, VALS(rnsap_TriggeringMessage_vals), 0,
        "CriticalityDiagnostics/triggeringMessage", HFILL }},
    { &hf_rnsap_procedureCriticality,
      { "procedureCriticality", "rnsap.procedureCriticality",
        FT_UINT32, BASE_DEC, VALS(rnsap_Criticality_vals), 0,
        "CriticalityDiagnostics/procedureCriticality", HFILL }},
    { &hf_rnsap_iEsCriticalityDiagnostics,
      { "iEsCriticalityDiagnostics", "rnsap.iEsCriticalityDiagnostics",
        FT_UINT32, BASE_DEC, NULL, 0,
        "CriticalityDiagnostics/iEsCriticalityDiagnostics", HFILL }},
    { &hf_rnsap_CriticalityDiagnostics_IE_List_item,
      { "Item", "rnsap.CriticalityDiagnostics_IE_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "CriticalityDiagnostics-IE-List/_item", HFILL }},
    { &hf_rnsap_iECriticality,
      { "iECriticality", "rnsap.iECriticality",
        FT_UINT32, BASE_DEC, VALS(rnsap_Criticality_vals), 0,
        "CriticalityDiagnostics-IE-List/_item/iECriticality", HFILL }},
    { &hf_rnsap_iE_ID,
      { "iE-ID", "rnsap.iE_ID",
        FT_UINT32, BASE_DEC, VALS(rnsap_ProtocolIE_ID_vals), 0,
        "", HFILL }},
    { &hf_rnsap_repetitionNumber,
      { "repetitionNumber", "rnsap.repetitionNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "CriticalityDiagnostics-IE-List/_item/repetitionNumber", HFILL }},
    { &hf_rnsap_MessageStructure_item,
      { "Item", "rnsap.MessageStructure_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "MessageStructure/_item", HFILL }},
    { &hf_rnsap_repetitionNumber1,
      { "repetitionNumber", "rnsap.repetitionNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MessageStructure/_item/repetitionNumber", HFILL }},
    { &hf_rnsap_rAC,
      { "rAC", "rnsap.rAC",
        FT_BYTES, BASE_HEX, NULL, 0,
        "CN-PS-DomainIdentifier/rAC", HFILL }},
    { &hf_rnsap_DCH_FDD_Information_item,
      { "Item", "rnsap.DCH_FDD_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-FDD-Information/_item", HFILL }},
    { &hf_rnsap_payloadCRC_PresenceIndicator,
      { "payloadCRC-PresenceIndicator", "rnsap.payloadCRC_PresenceIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_PayloadCRC_PresenceIndicator_vals), 0,
        "", HFILL }},
    { &hf_rnsap_ul_FP_Mode,
      { "ul-FP-Mode", "rnsap.ul_FP_Mode",
        FT_UINT32, BASE_DEC, VALS(rnsap_UL_FP_Mode_vals), 0,
        "", HFILL }},
    { &hf_rnsap_toAWS,
      { "toAWS", "rnsap.toAWS",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_toAWE,
      { "toAWE", "rnsap.toAWE",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dCH_SpecificInformationList,
      { "dCH-SpecificInformationList", "rnsap.dCH_SpecificInformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DCH-FDD-InformationItem/dCH-SpecificInformationList", HFILL }},
    { &hf_rnsap_DCH_Specific_FDD_InformationList_item,
      { "Item", "rnsap.DCH_Specific_FDD_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-Specific-FDD-InformationList/_item", HFILL }},
    { &hf_rnsap_trCH_SrcStatisticsDescr,
      { "trCH-SrcStatisticsDescr", "rnsap.trCH_SrcStatisticsDescr",
        FT_UINT32, BASE_DEC, VALS(rnsap_TrCH_SrcStatisticsDescr_vals), 0,
        "", HFILL }},
    { &hf_rnsap_ul_transportFormatSet,
      { "ul-transportFormatSet", "rnsap.ul_transportFormatSet",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dl_transportFormatSet,
      { "dl-transportFormatSet", "rnsap.dl_transportFormatSet",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ul_BLER,
      { "ul-BLER", "rnsap.ul_BLER",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dl_BLER,
      { "dl-BLER", "rnsap.dl_BLER",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_frameHandlingPriority,
      { "frameHandlingPriority", "rnsap.frameHandlingPriority",
        FT_UINT32, BASE_DEC, VALS(rnsap_FrameHandlingPriority_vals), 0,
        "", HFILL }},
    { &hf_rnsap_qE_Selector,
      { "qE-Selector", "rnsap.qE_Selector",
        FT_UINT32, BASE_DEC, VALS(rnsap_QE_Selector_vals), 0,
        "", HFILL }},
    { &hf_rnsap_dRACControl,
      { "dRACControl", "rnsap.dRACControl",
        FT_UINT32, BASE_DEC, VALS(rnsap_DRACControl_vals), 0,
        "DCH-Specific-FDD-Item/dRACControl", HFILL }},
    { &hf_rnsap_DCH_InformationResponse_item,
      { "Item", "rnsap.DCH_InformationResponse_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-InformationResponse/_item", HFILL }},
    { &hf_rnsap_DCH_TDD_Information_item,
      { "Item", "rnsap.DCH_TDD_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-TDD-Information/_item", HFILL }},
    { &hf_rnsap_dCH_SpecificInformationList1,
      { "dCH-SpecificInformationList", "rnsap.dCH_SpecificInformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DCH-TDD-InformationItem/dCH-SpecificInformationList", HFILL }},
    { &hf_rnsap_DCH_Specific_TDD_InformationList_item,
      { "Item", "rnsap.DCH_Specific_TDD_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DCH-Specific-TDD-InformationList/_item", HFILL }},
    { &hf_rnsap_ul_cCTrCH_ID,
      { "ul-cCTrCH-ID", "rnsap.ul_cCTrCH_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DCH-Specific-TDD-Item/ul-cCTrCH-ID", HFILL }},
    { &hf_rnsap_dl_cCTrCH_ID,
      { "dl-cCTrCH-ID", "rnsap.dl_cCTrCH_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DCH-Specific-TDD-Item/dl-cCTrCH-ID", HFILL }},
    { &hf_rnsap_sIR_Value,
      { "sIR-Value", "rnsap.sIR_Value",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DedicatedMeasurementValue/sIR-Value", HFILL }},
    { &hf_rnsap_sIR_ErrorValue,
      { "sIR-ErrorValue", "rnsap.sIR_ErrorValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DedicatedMeasurementValue/sIR-ErrorValue", HFILL }},
    { &hf_rnsap_transmittedCodePowerValue,
      { "transmittedCodePowerValue", "rnsap.transmittedCodePowerValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DedicatedMeasurementValue/transmittedCodePowerValue", HFILL }},
    { &hf_rnsap_rSCP,
      { "rSCP", "rnsap.rSCP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DedicatedMeasurementValue/rSCP", HFILL }},
    { &hf_rnsap_rxTimingDeviationValue,
      { "rxTimingDeviationValue", "rnsap.rxTimingDeviationValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DedicatedMeasurementValue/rxTimingDeviationValue", HFILL }},
    { &hf_rnsap_roundTripTime,
      { "roundTripTime", "rnsap.roundTripTime",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DedicatedMeasurementValue/roundTripTime", HFILL }},
    { &hf_rnsap_extension_DedicatedMeasurementValue,
      { "extension-DedicatedMeasurementValue", "rnsap.extension_DedicatedMeasurementValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementValue/extension-DedicatedMeasurementValue", HFILL }},
    { &hf_rnsap_measurementAvailable1,
      { "measurementAvailable", "rnsap.measurementAvailable",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementValueInformation/measurementAvailable", HFILL }},
    { &hf_rnsap_measurementnotAvailable1,
      { "measurementnotAvailable", "rnsap.measurementnotAvailable",
        FT_NONE, BASE_NONE, NULL, 0,
        "DedicatedMeasurementValueInformation/measurementnotAvailable", HFILL }},
    { &hf_rnsap_dedicatedmeasurementValue,
      { "dedicatedmeasurementValue", "rnsap.dedicatedmeasurementValue",
        FT_UINT32, BASE_DEC, VALS(rnsap_DedicatedMeasurementValue_vals), 0,
        "DedicatedMeasurementAvailable/dedicatedmeasurementValue", HFILL }},
    { &hf_rnsap_cfn,
      { "cfn", "rnsap.cfn",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DelayedActivation/cfn", HFILL }},
    { &hf_rnsap_separate_indication,
      { "separate-indication", "rnsap.separate_indication",
        FT_NONE, BASE_NONE, NULL, 0,
        "DelayedActivation/separate-indication", HFILL }},
    { &hf_rnsap_activate,
      { "activate", "rnsap.activate",
        FT_NONE, BASE_NONE, NULL, 0,
        "DelayedActivationUpdate/activate", HFILL }},
    { &hf_rnsap_deactivate,
      { "deactivate", "rnsap.deactivate",
        FT_NONE, BASE_NONE, NULL, 0,
        "DelayedActivationUpdate/deactivate", HFILL }},
    { &hf_rnsap_activation_type,
      { "activation-type", "rnsap.activation_type",
        FT_UINT32, BASE_DEC, VALS(rnsap_Execution_Type_vals), 0,
        "Activate-Info/activation-type", HFILL }},
    { &hf_rnsap_initial_dl_tx_power,
      { "initial-dl-tx-power", "rnsap.initial_dl_tx_power",
        FT_INT32, BASE_DEC, NULL, 0,
        "Activate-Info/initial-dl-tx-power", HFILL }},
    { &hf_rnsap_firstRLS_Indicator,
      { "firstRLS-Indicator", "rnsap.firstRLS_Indicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_FirstRLS_Indicator_vals), 0,
        "Activate-Info/firstRLS-Indicator", HFILL }},
    { &hf_rnsap_propagation_delay,
      { "propagation-delay", "rnsap.propagation_delay",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Activate-Info/propagation-delay", HFILL }},
    { &hf_rnsap_deactivation_type,
      { "deactivation-type", "rnsap.deactivation_type",
        FT_UINT32, BASE_DEC, VALS(rnsap_Execution_Type_vals), 0,
        "Deactivate-Info/deactivation-type", HFILL }},
    { &hf_rnsap_synchronised,
      { "synchronised", "rnsap.synchronised",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Execution-Type/synchronised", HFILL }},
    { &hf_rnsap_unsynchronised,
      { "unsynchronised", "rnsap.unsynchronised",
        FT_NONE, BASE_NONE, NULL, 0,
        "Execution-Type/unsynchronised", HFILL }},
    { &hf_rnsap_gPSTOW,
      { "gPSTOW", "rnsap.gPSTOW",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DGPSCorrections/gPSTOW", HFILL }},
    { &hf_rnsap_gPS_Status_Health,
      { "gPS-Status-Health", "rnsap.gPS_Status_Health",
        FT_UINT32, BASE_DEC, VALS(rnsap_GPS_Status_Health_vals), 0,
        "DGPSCorrections/gPS-Status-Health", HFILL }},
    { &hf_rnsap_satellite_DGPSCorrections_Information,
      { "satellite-DGPSCorrections-Information", "rnsap.satellite_DGPSCorrections_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DGPSCorrections/satellite-DGPSCorrections-Information", HFILL }},
    { &hf_rnsap_satellite_DGPSCorrections_Information_item,
      { "Item", "rnsap.satellite_DGPSCorrections_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DGPSCorrections/satellite-DGPSCorrections-Information/_item", HFILL }},
    { &hf_rnsap_sAT_ID,
      { "sAT-ID", "rnsap.sAT_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_iode_dgps,
      { "iode-dgps", "rnsap.iode_dgps",
        FT_BYTES, BASE_HEX, NULL, 0,
        "DGPSCorrections/satellite-DGPSCorrections-Information/_item/iode-dgps", HFILL }},
    { &hf_rnsap_uDRE,
      { "uDRE", "rnsap.uDRE",
        FT_UINT32, BASE_DEC, VALS(rnsap_UDRE_vals), 0,
        "DGPSCorrections/satellite-DGPSCorrections-Information/_item/uDRE", HFILL }},
    { &hf_rnsap_pRC,
      { "pRC", "rnsap.pRC",
        FT_INT32, BASE_DEC, NULL, 0,
        "DGPSCorrections/satellite-DGPSCorrections-Information/_item/pRC", HFILL }},
    { &hf_rnsap_range_Correction_Rate,
      { "range-Correction-Rate", "rnsap.range_Correction_Rate",
        FT_INT32, BASE_DEC, NULL, 0,
        "DGPSCorrections/satellite-DGPSCorrections-Information/_item/range-Correction-Rate", HFILL }},
    { &hf_rnsap_pRCDeviation,
      { "pRCDeviation", "rnsap.pRCDeviation",
        FT_UINT32, BASE_DEC, VALS(rnsap_PRCDeviation_vals), 0,
        "DGPSThreshold/pRCDeviation", HFILL }},
    { &hf_rnsap_powerAdjustmentType,
      { "powerAdjustmentType", "rnsap.powerAdjustmentType",
        FT_UINT32, BASE_DEC, VALS(rnsap_PowerAdjustmentType_vals), 0,
        "DL-PowerBalancing-Information/powerAdjustmentType", HFILL }},
    { &hf_rnsap_dLReferencePower,
      { "dLReferencePower", "rnsap.dLReferencePower",
        FT_INT32, BASE_DEC, NULL, 0,
        "DL-PowerBalancing-Information/dLReferencePower", HFILL }},
    { &hf_rnsap_dLReferencePowerList,
      { "dLReferencePowerList", "rnsap.dLReferencePowerList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-PowerBalancing-Information/dLReferencePowerList", HFILL }},
    { &hf_rnsap_maxAdjustmentStep,
      { "maxAdjustmentStep", "rnsap.maxAdjustmentStep",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-PowerBalancing-Information/maxAdjustmentStep", HFILL }},
    { &hf_rnsap_adjustmentPeriod,
      { "adjustmentPeriod", "rnsap.adjustmentPeriod",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-PowerBalancing-Information/adjustmentPeriod", HFILL }},
    { &hf_rnsap_adjustmentRatio,
      { "adjustmentRatio", "rnsap.adjustmentRatio",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-PowerBalancing-Information/adjustmentRatio", HFILL }},
    { &hf_rnsap_DL_ReferencePowerInformationList_item,
      { "Item", "rnsap.DL_ReferencePowerInformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-ReferencePowerInformationList/_item", HFILL }},
    { &hf_rnsap_common_DL_ReferencePowerInformation,
      { "common-DL-ReferencePowerInformation", "rnsap.common_DL_ReferencePowerInformation",
        FT_INT32, BASE_DEC, NULL, 0,
        "DL-ReferencePowerInformation/common-DL-ReferencePowerInformation", HFILL }},
    { &hf_rnsap_individual_DL_ReferencePowerInformation,
      { "individual-DL-ReferencePowerInformation", "rnsap.individual_DL_ReferencePowerInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "DL-ReferencePowerInformation/individual-DL-ReferencePowerInformation", HFILL }},
    { &hf_rnsap_DL_Timeslot_Information_item,
      { "Item", "rnsap.DL_Timeslot_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-Timeslot-Information/_item", HFILL }},
    { &hf_rnsap_DL_TimeslotLCR_Information_item,
      { "Item", "rnsap.DL_TimeslotLCR_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-TimeslotLCR-Information/_item", HFILL }},
    { &hf_rnsap_DL_TimeSlot_ISCP_Info_item,
      { "Item", "rnsap.DL_TimeSlot_ISCP_Info_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-TimeSlot-ISCP-Info/_item", HFILL }},
    { &hf_rnsap_dL_TimeslotISCP,
      { "dL-TimeslotISCP", "rnsap.dL_TimeslotISCP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_DL_TimeSlot_ISCP_LCR_Information_item,
      { "Item", "rnsap.DL_TimeSlot_ISCP_LCR_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DL-TimeSlot-ISCP-LCR-Information/_item", HFILL }},
    { &hf_rnsap_DSCH_FlowControlInformation_item,
      { "Item", "rnsap.DSCH_FlowControlInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DSCH-FlowControlInformation/_item", HFILL }},
    { &hf_rnsap_dSCH_SchedulingPriority,
      { "dSCH-SchedulingPriority", "rnsap.dSCH_SchedulingPriority",
        FT_UINT32, BASE_DEC, VALS(rnsap_SchedulingPriorityIndicator_vals), 0,
        "DSCH-FlowControlItem/dSCH-SchedulingPriority", HFILL }},
    { &hf_rnsap_mAC_c_sh_SDU_Lengths,
      { "mAC-c-sh-SDU-Lengths", "rnsap.mAC_c_sh_SDU_Lengths",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_DSCH_TDD_Information_item,
      { "Item", "rnsap.DSCH_TDD_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "DSCH-TDD-Information/_item", HFILL }},
    { &hf_rnsap_eAGCH_ERGCH_EHICH_FDD_ScramblingCode,
      { "eAGCH-ERGCH-EHICH-FDD-ScramblingCode", "rnsap.eAGCH_ERGCH_EHICH_FDD_ScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-FDD-DL-ControlChannelInformation/eAGCH-ERGCH-EHICH-FDD-ScramblingCode", HFILL }},
    { &hf_rnsap_eAGCH_ChannelisationCode,
      { "eAGCH-ChannelisationCode", "rnsap.eAGCH_ChannelisationCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-FDD-DL-ControlChannelInformation/eAGCH-ChannelisationCode", HFILL }},
    { &hf_rnsap_primary_e_RNTI,
      { "primary-e-RNTI", "rnsap.primary_e_RNTI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-FDD-DL-ControlChannelInformation/primary-e-RNTI", HFILL }},
    { &hf_rnsap_secondary_e_RNTI,
      { "secondary-e-RNTI", "rnsap.secondary_e_RNTI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-FDD-DL-ControlChannelInformation/secondary-e-RNTI", HFILL }},
    { &hf_rnsap_eRGCH_EHICH_ChannelisationCode,
      { "eRGCH-EHICH-ChannelisationCode", "rnsap.eRGCH_EHICH_ChannelisationCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-FDD-DL-ControlChannelInformation/eRGCH-EHICH-ChannelisationCode", HFILL }},
    { &hf_rnsap_eRGCH_SignatureSequence,
      { "eRGCH-SignatureSequence", "rnsap.eRGCH_SignatureSequence",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-FDD-DL-ControlChannelInformation/eRGCH-SignatureSequence", HFILL }},
    { &hf_rnsap_eHICH_SignatureSequence,
      { "eHICH-SignatureSequence", "rnsap.eHICH_SignatureSequence",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-FDD-DL-ControlChannelInformation/eHICH-SignatureSequence", HFILL }},
    { &hf_rnsap_serving_Grant_Value,
      { "serving-Grant-Value", "rnsap.serving_Grant_Value",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-FDD-DL-ControlChannelInformation/serving-Grant-Value", HFILL }},
    { &hf_rnsap_primary_Secondary_Grant_Selector,
      { "primary-Secondary-Grant-Selector", "rnsap.primary_Secondary_Grant_Selector",
        FT_UINT32, BASE_DEC, VALS(rnsap_E_Primary_Secondary_Grant_Selector_vals), 0,
        "EDCH-FDD-DL-ControlChannelInformation/primary-Secondary-Grant-Selector", HFILL }},
    { &hf_rnsap_e_RGCH_Release_Indicator,
      { "e-RGCH-Release-Indicator", "rnsap.e_RGCH_Release_Indicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_E_RGCH_Release_Indicator_vals), 0,
        "EDCH-FDD-DL-ControlChannelInformation/e-RGCH-Release-Indicator", HFILL }},
    { &hf_rnsap_eDCH_MACdFlows_Information,
      { "eDCH-MACdFlows-Information", "rnsap.eDCH_MACdFlows_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-FDD-Information/eDCH-MACdFlows-Information", HFILL }},
    { &hf_rnsap_EDCH_FDD_InformationResponse_item,
      { "Item", "rnsap.EDCH_FDD_InformationResponse_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-FDD-InformationResponse/_item", HFILL }},
    { &hf_rnsap_eDCH_MACdFlow_Specific_Information,
      { "eDCH-MACdFlow-Specific-Information", "rnsap.eDCH_MACdFlow_Specific_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-FDD-Information-To-Modify/eDCH-MACdFlow-Specific-Information", HFILL }},
    { &hf_rnsap_EDCH_FDD_Update_Information_item,
      { "Item", "rnsap.EDCH_FDD_Update_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-FDD-Update-Information/_item", HFILL }},
    { &hf_rnsap_eDCH_FDD_DL_ControlChannelInformation,
      { "eDCH-FDD-DL-ControlChannelInformation", "rnsap.eDCH_FDD_DL_ControlChannelInformation",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-FDD-Update-InfoItem/eDCH-FDD-DL-ControlChannelInformation", HFILL }},
    { &hf_rnsap_e_DCH_Non_Scheduled_Transmission_Grant,
      { "e-DCH-Non-Scheduled-Transmission-Grant", "rnsap.e_DCH_Non_Scheduled_Transmission_Grant",
        FT_NONE, BASE_NONE, NULL, 0,
        "E-DCH-Grant-Type-Information/e-DCH-Non-Scheduled-Transmission-Grant", HFILL }},
    { &hf_rnsap_e_DCH_Scheduled_Transmission_Grant,
      { "e-DCH-Scheduled-Transmission-Grant", "rnsap.e_DCH_Scheduled_Transmission_Grant",
        FT_NONE, BASE_NONE, NULL, 0,
        "E-DCH-Grant-Type-Information/e-DCH-Scheduled-Transmission-Grant", HFILL }},
    { &hf_rnsap_E_DCH_LogicalChannelInformation_item,
      { "Item", "rnsap.E_DCH_LogicalChannelInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "E-DCH-LogicalChannelInformation/_item", HFILL }},
    { &hf_rnsap_logicalChannelId,
      { "logicalChannelId", "rnsap.logicalChannelId",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_mACes_GuaranteedBitRate,
      { "mACes-GuaranteedBitRate", "rnsap.mACes_GuaranteedBitRate",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_eDCH_DDI_Value,
      { "eDCH-DDI-Value", "rnsap.eDCH_DDI_Value",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_mACd_PDU_Size_List,
      { "mACd-PDU-Size-List", "rnsap.mACd_PDU_Size_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "E-DCH-LogicalChannelInformationItem/mACd-PDU-Size-List", HFILL }},
    { &hf_rnsap_E_DCH_MACdPDU_SizeList_item,
      { "Item", "rnsap.E_DCH_MACdPDU_SizeList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "E-DCH-MACdPDU-SizeList/_item", HFILL }},
    { &hf_rnsap_mACdPDU_Size,
      { "mACdPDU-Size", "rnsap.mACdPDU_Size",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_E_DCH_LogicalChannelToModify_item,
      { "Item", "rnsap.E_DCH_LogicalChannelToModify_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "E-DCH-LogicalChannelToModify/_item", HFILL }},
    { &hf_rnsap_mACd_PDU_Size_List1,
      { "mACd-PDU-Size-List", "rnsap.mACd_PDU_Size_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "E-DCH-LogicalChannelToModifyItem/mACd-PDU-Size-List", HFILL }},
    { &hf_rnsap_E_DCH_MACdPDU_SizeToModifyList_item,
      { "Item", "rnsap.E_DCH_MACdPDU_SizeToModifyList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "E-DCH-MACdPDU-SizeToModifyList/_item", HFILL }},
    { &hf_rnsap_E_DCH_LogicalChannelToDelete_item,
      { "Item", "rnsap.E_DCH_LogicalChannelToDelete_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "E-DCH-LogicalChannelToDelete/_item", HFILL }},
    { &hf_rnsap_eDCH_MACdFlow_Specific_Information1,
      { "eDCH-MACdFlow-Specific-Information", "rnsap.eDCH_MACdFlow_Specific_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-MACdFlows-Information/eDCH-MACdFlow-Specific-Information", HFILL }},
    { &hf_rnsap_EDCH_MACdFlow_Specific_InfoList_item,
      { "Item", "rnsap.EDCH_MACdFlow_Specific_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-MACdFlow-Specific-InfoList/_item", HFILL }},
    { &hf_rnsap_eDSCH_MACdFlow_ID,
      { "eDSCH-MACdFlow-ID", "rnsap.eDSCH_MACdFlow_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tnlQoS,
      { "tnlQoS", "rnsap.tnlQoS",
        FT_UINT32, BASE_DEC, VALS(rnsap_TnlQos_vals), 0,
        "", HFILL }},
    { &hf_rnsap_maxNr_Retransmissions_EDCH,
      { "maxNr-Retransmissions-EDCH", "rnsap.maxNr_Retransmissions_EDCH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_trafficClass,
      { "trafficClass", "rnsap.trafficClass",
        FT_UINT32, BASE_DEC, VALS(rnsap_TrafficClass_vals), 0,
        "", HFILL }},
    { &hf_rnsap_eDCH_HARQ_PO_FDD,
      { "eDCH-HARQ-PO-FDD", "rnsap.eDCH_HARQ_PO_FDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_eDCH_MACdFlow_Multiplexing_List,
      { "eDCH-MACdFlow-Multiplexing-List", "rnsap.eDCH_MACdFlow_Multiplexing_List",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_eDCH_Grant_Type_Information,
      { "eDCH-Grant-Type-Information", "rnsap.eDCH_Grant_Type_Information",
        FT_UINT32, BASE_DEC, VALS(rnsap_E_DCH_Grant_Type_Information_vals), 0,
        "", HFILL }},
    { &hf_rnsap_bundlingModeIndicator,
      { "bundlingModeIndicator", "rnsap.bundlingModeIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_BundlingModeIndicator_vals), 0,
        "", HFILL }},
    { &hf_rnsap_eDCHLogicalChannelInformation,
      { "eDCHLogicalChannelInformation", "rnsap.eDCHLogicalChannelInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-MACdFlow-Specific-InfoItem/eDCHLogicalChannelInformation", HFILL }},
    { &hf_rnsap_EDCH_MACdFlow_Specific_InfoToModifyList_item,
      { "Item", "rnsap.EDCH_MACdFlow_Specific_InfoToModifyList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-MACdFlow-Specific-InfoToModifyList/_item", HFILL }},
    { &hf_rnsap_eDCH_LogicalChannelToAdd,
      { "eDCH-LogicalChannelToAdd", "rnsap.eDCH_LogicalChannelToAdd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-MACdFlow-Specific-InfoToModifyItem/eDCH-LogicalChannelToAdd", HFILL }},
    { &hf_rnsap_eDCH_LogicalChannelToModify,
      { "eDCH-LogicalChannelToModify", "rnsap.eDCH_LogicalChannelToModify",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-MACdFlow-Specific-InfoToModifyItem/eDCH-LogicalChannelToModify", HFILL }},
    { &hf_rnsap_eDCH_LogicalChannelToDelete,
      { "eDCH-LogicalChannelToDelete", "rnsap.eDCH_LogicalChannelToDelete",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-MACdFlow-Specific-InfoToModifyItem/eDCH-LogicalChannelToDelete", HFILL }},
    { &hf_rnsap_EDCH_MACdFlows_To_Delete_item,
      { "Item", "rnsap.EDCH_MACdFlows_To_Delete_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-MACdFlows-To-Delete/_item", HFILL }},
    { &hf_rnsap_maxBits_MACe_PDU_non_scheduled,
      { "maxBits-MACe-PDU-non-scheduled", "rnsap.maxBits_MACe_PDU_non_scheduled",
        FT_UINT32, BASE_DEC, NULL, 0,
        "E-DCH-Non-Scheduled-Transmission-Grant-Items/maxBits-MACe-PDU-non-scheduled", HFILL }},
    { &hf_rnsap_hARQ_Process_Allocation_2ms,
      { "hARQ-Process-Allocation-2ms", "rnsap.hARQ_Process_Allocation_2ms",
        FT_BYTES, BASE_HEX, NULL, 0,
        "E-DCH-Non-Scheduled-Transmission-Grant-Items/hARQ-Process-Allocation-2ms", HFILL }},
    { &hf_rnsap_maxSet_E_DPDCHs,
      { "maxSet-E-DPDCHs", "rnsap.maxSet_E_DPDCHs",
        FT_UINT32, BASE_DEC, VALS(rnsap_Max_Set_E_DPDCHs_vals), 0,
        "", HFILL }},
    { &hf_rnsap_e_TFCS_Information,
      { "e-TFCS-Information", "rnsap.e_TFCS_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_e_TTI,
      { "e-TTI", "rnsap.e_TTI",
        FT_UINT32, BASE_DEC, VALS(rnsap_E_TTI_vals), 0,
        "", HFILL }},
    { &hf_rnsap_e_DPCCH_PO,
      { "e-DPCCH-PO", "rnsap.e_DPCCH_PO",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_e_DCH_Serving_RL_in_this_DRNS,
      { "e-DCH-Serving-RL-in-this-DRNS", "rnsap.e_DCH_Serving_RL_in_this_DRNS",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-Serving-RL/e-DCH-Serving-RL-in-this-DRNS", HFILL }},
    { &hf_rnsap_e_DCH_Serving_RL_not_in_this_DRNS,
      { "e-DCH-Serving-RL-not-in-this-DRNS", "rnsap.e_DCH_Serving_RL_not_in_this_DRNS",
        FT_NONE, BASE_NONE, NULL, 0,
        "EDCH-Serving-RL/e-DCH-Serving-RL-not-in-this-DRNS", HFILL }},
    { &hf_rnsap_e_DCH_Serving_RL_Id,
      { "e-DCH-Serving-RL-Id", "rnsap.e_DCH_Serving_RL_Id",
        FT_UINT32, BASE_DEC, NULL, 0,
        "EDCH-Serving-RL-in-this-DRNS/e-DCH-Serving-RL-Id", HFILL }},
    { &hf_rnsap_e_DCH_TFCI_Table_Index,
      { "e-DCH-TFCI-Table-Index", "rnsap.e_DCH_TFCI_Table_Index",
        FT_UINT32, BASE_DEC, NULL, 0,
        "E-TFCS-Information/e-DCH-TFCI-Table-Index", HFILL }},
    { &hf_rnsap_e_DCH_Min_Set_E_TFCI,
      { "e-DCH-Min-Set-E-TFCI", "rnsap.e_DCH_Min_Set_E_TFCI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "E-TFCS-Information/e-DCH-Min-Set-E-TFCI", HFILL }},
    { &hf_rnsap_reference_E_TFCI_Information,
      { "reference-E-TFCI-Information", "rnsap.reference_E_TFCI_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "E-TFCS-Information/reference-E-TFCI-Information", HFILL }},
    { &hf_rnsap_measurementTreshold,
      { "measurementTreshold", "rnsap.measurementTreshold",
        FT_UINT32, BASE_DEC, VALS(rnsap_MeasurementThreshold_vals), 0,
        "", HFILL }},
    { &hf_rnsap_measurementHysteresisTime,
      { "measurementHysteresisTime", "rnsap.measurementHysteresisTime",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_measurementIncreaseDecreaseThreshold,
      { "measurementIncreaseDecreaseThreshold", "rnsap.measurementIncreaseDecreaseThreshold",
        FT_UINT32, BASE_DEC, VALS(rnsap_MeasurementIncreaseDecreaseThreshold_vals), 0,
        "", HFILL }},
    { &hf_rnsap_measurementChangeTime,
      { "measurementChangeTime", "rnsap.measurementChangeTime",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_measurementThreshold1,
      { "measurementThreshold1", "rnsap.measurementThreshold1",
        FT_UINT32, BASE_DEC, VALS(rnsap_MeasurementThreshold_vals), 0,
        "", HFILL }},
    { &hf_rnsap_measurementThreshold2,
      { "measurementThreshold2", "rnsap.measurementThreshold2",
        FT_UINT32, BASE_DEC, VALS(rnsap_MeasurementThreshold_vals), 0,
        "", HFILL }},
    { &hf_rnsap_reportPeriodicity,
      { "reportPeriodicity", "rnsap.reportPeriodicity",
        FT_UINT32, BASE_DEC, VALS(rnsap_ReportPeriodicity_vals), 0,
        "", HFILL }},
    { &hf_rnsap_FACH_FlowControlInformation_item,
      { "Item", "rnsap.FACH_FlowControlInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "FACH-FlowControlInformation/_item", HFILL }},
    { &hf_rnsap_fACH_SchedulingPriority,
      { "fACH-SchedulingPriority", "rnsap.fACH_SchedulingPriority",
        FT_UINT32, BASE_DEC, VALS(rnsap_SchedulingPriorityIndicator_vals), 0,
        "FACH-FlowControlInformationItem/fACH-SchedulingPriority", HFILL }},
    { &hf_rnsap_fACH_InitialWindowSize,
      { "fACH-InitialWindowSize", "rnsap.fACH_InitialWindowSize",
        FT_UINT32, BASE_DEC, VALS(rnsap_FACH_InitialWindowSize_vals), 0,
        "FACH-FlowControlInformationItem/fACH-InitialWindowSize", HFILL }},
    { &hf_rnsap_FACH_InformationList_item,
      { "Item", "rnsap.FACH_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "FACH-InformationList/_item", HFILL }},
    { &hf_rnsap_FACH_PCH_InformationList_item,
      { "Item", "rnsap.FACH_PCH_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "FACH-PCH-InformationList/_item", HFILL }},
    { &hf_rnsap_FDD_DCHs_to_Modify_item,
      { "Item", "rnsap.FDD_DCHs_to_Modify_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "FDD-DCHs-to-Modify/_item", HFILL }},
    { &hf_rnsap_dCH_SpecificInformationList2,
      { "dCH-SpecificInformationList", "rnsap.dCH_SpecificInformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "FDD-DCHs-to-ModifyItem/dCH-SpecificInformationList", HFILL }},
    { &hf_rnsap_FDD_DCHs_to_ModifySpecificInformationList_item,
      { "Item", "rnsap.FDD_DCHs_to_ModifySpecificInformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "FDD-DCHs-to-ModifySpecificInformationList/_item", HFILL }},
    { &hf_rnsap_ul_TransportformatSet,
      { "ul-TransportformatSet", "rnsap.ul_TransportformatSet",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dl_TransportformatSet,
      { "dl-TransportformatSet", "rnsap.dl_TransportformatSet",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_not_Used_dRACControl,
      { "not-Used-dRACControl", "rnsap.not_Used_dRACControl",
        FT_NONE, BASE_NONE, NULL, 0,
        "FDD-DCHs-to-ModifySpecificItem/not-Used-dRACControl", HFILL }},
    { &hf_rnsap_FDD_DL_CodeInformation_item,
      { "Item", "rnsap.FDD_DL_CodeInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "FDD-DL-CodeInformation/_item", HFILL }},
    { &hf_rnsap_dl_ScramblingCode,
      { "dl-ScramblingCode", "rnsap.dl_ScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_fDD_DL_ChannelisationCodeNumber,
      { "fDD-DL-ChannelisationCodeNumber", "rnsap.fDD_DL_ChannelisationCodeNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_transmission_Gap_Pattern_Sequence_ScramblingCode_Information,
      { "transmission-Gap-Pattern-Sequence-ScramblingCode-Information", "rnsap.transmission_Gap_Pattern_Sequence_ScramblingCode_Information",
        FT_UINT32, BASE_DEC, VALS(rnsap_Transmission_Gap_Pattern_Sequence_ScramblingCode_Information_vals), 0,
        "FDD-DL-CodeInformationItem/transmission-Gap-Pattern-Sequence-ScramblingCode-Information", HFILL }},
    { &hf_rnsap_wT,
      { "wT", "rnsap.wT",
        FT_UINT32, BASE_DEC, NULL, 0,
        "FPACH-Information/wT", HFILL }},
    { &hf_rnsap_GA_Cell_item,
      { "Item", "rnsap.GA_Cell_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "GA-Cell/_item", HFILL }},
    { &hf_rnsap_cell_GAIgeographicalCoordinate,
      { "cell-GAIgeographicalCoordinate", "rnsap.cell_GAIgeographicalCoordinate",
        FT_NONE, BASE_NONE, NULL, 0,
        "GA-Cell/_item/cell-GAIgeographicalCoordinate", HFILL }},
    { &hf_rnsap_pointWithUncertainty,
      { "pointWithUncertainty", "rnsap.pointWithUncertainty",
        FT_NONE, BASE_NONE, NULL, 0,
        "GA-CellAdditionalShapes/pointWithUncertainty", HFILL }},
    { &hf_rnsap_pointWithUncertaintyEllipse,
      { "pointWithUncertaintyEllipse", "rnsap.pointWithUncertaintyEllipse",
        FT_NONE, BASE_NONE, NULL, 0,
        "GA-CellAdditionalShapes/pointWithUncertaintyEllipse", HFILL }},
    { &hf_rnsap_pointWithAltitude,
      { "pointWithAltitude", "rnsap.pointWithAltitude",
        FT_NONE, BASE_NONE, NULL, 0,
        "GA-CellAdditionalShapes/pointWithAltitude", HFILL }},
    { &hf_rnsap_pointWithAltitudeAndUncertaintyEllipsoid,
      { "pointWithAltitudeAndUncertaintyEllipsoid", "rnsap.pointWithAltitudeAndUncertaintyEllipsoid",
        FT_NONE, BASE_NONE, NULL, 0,
        "GA-CellAdditionalShapes/pointWithAltitudeAndUncertaintyEllipsoid", HFILL }},
    { &hf_rnsap_ellipsoidArc,
      { "ellipsoidArc", "rnsap.ellipsoidArc",
        FT_NONE, BASE_NONE, NULL, 0,
        "GA-CellAdditionalShapes/ellipsoidArc", HFILL }},
    { &hf_rnsap_directionOfAltitude,
      { "directionOfAltitude", "rnsap.directionOfAltitude",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_directionOfAltitude_vals), 0,
        "GA-AltitudeAndDirection/directionOfAltitude", HFILL }},
    { &hf_rnsap_altitude,
      { "altitude", "rnsap.altitude",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GA-AltitudeAndDirection/altitude", HFILL }},
    { &hf_rnsap_geographicalCoordinates,
      { "geographicalCoordinates", "rnsap.geographicalCoordinates",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_innerRadius,
      { "innerRadius", "rnsap.innerRadius",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GA-EllipsoidArc/innerRadius", HFILL }},
    { &hf_rnsap_uncertaintyRadius,
      { "uncertaintyRadius", "rnsap.uncertaintyRadius",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GA-EllipsoidArc/uncertaintyRadius", HFILL }},
    { &hf_rnsap_offsetAngle,
      { "offsetAngle", "rnsap.offsetAngle",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GA-EllipsoidArc/offsetAngle", HFILL }},
    { &hf_rnsap_includedAngle,
      { "includedAngle", "rnsap.includedAngle",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GA-EllipsoidArc/includedAngle", HFILL }},
    { &hf_rnsap_confidence,
      { "confidence", "rnsap.confidence",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_altitudeAndDirection,
      { "altitudeAndDirection", "rnsap.altitudeAndDirection",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_uncertaintyEllipse,
      { "uncertaintyEllipse", "rnsap.uncertaintyEllipse",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_uncertaintyAltitude,
      { "uncertaintyAltitude", "rnsap.uncertaintyAltitude",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GA-PointWithAltitudeAndUncertaintyEllipsoid/uncertaintyAltitude", HFILL }},
    { &hf_rnsap_uncertaintySemi_major,
      { "uncertaintySemi-major", "rnsap.uncertaintySemi_major",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GA-UncertaintyEllipse/uncertaintySemi-major", HFILL }},
    { &hf_rnsap_uncertaintySemi_minor,
      { "uncertaintySemi-minor", "rnsap.uncertaintySemi_minor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GA-UncertaintyEllipse/uncertaintySemi-minor", HFILL }},
    { &hf_rnsap_orientationOfMajorAxis,
      { "orientationOfMajorAxis", "rnsap.orientationOfMajorAxis",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GA-UncertaintyEllipse/orientationOfMajorAxis", HFILL }},
    { &hf_rnsap_uncertaintyCode,
      { "uncertaintyCode", "rnsap.uncertaintyCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GA-PointWithUnCertainty/uncertaintyCode", HFILL }},
    { &hf_rnsap_geographicalCoordinate,
      { "geographicalCoordinate", "rnsap.geographicalCoordinate",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_latitudeSign,
      { "latitudeSign", "rnsap.latitudeSign",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_latitudeSign_vals), 0,
        "GeographicalCoordinate/latitudeSign", HFILL }},
    { &hf_rnsap_latitude,
      { "latitude", "rnsap.latitude",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GeographicalCoordinate/latitude", HFILL }},
    { &hf_rnsap_longitude,
      { "longitude", "rnsap.longitude",
        FT_INT32, BASE_DEC, NULL, 0,
        "GeographicalCoordinate/longitude", HFILL }},
    { &hf_rnsap_sI,
      { "sI", "rnsap.sI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GERAN-SI-Type/sI", HFILL }},
    { &hf_rnsap_pSI,
      { "pSI", "rnsap.pSI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GERAN-SI-Type/pSI", HFILL }},
    { &hf_rnsap_GERAN_SystemInfo_item,
      { "Item", "rnsap.GERAN_SystemInfo_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "GERAN-SystemInfo/_item", HFILL }},
    { &hf_rnsap_gERAN_SI_block,
      { "gERAN-SI-block", "rnsap.gERAN_SI_block",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GERAN-SystemInfo/_item/gERAN-SI-block", HFILL }},
    { &hf_rnsap_wna_alm,
      { "wna-alm", "rnsap.wna_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-Almanac/wna-alm", HFILL }},
    { &hf_rnsap_satellite_Almanac_Information,
      { "satellite-Almanac-Information", "rnsap.satellite_Almanac_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GPS-Almanac/satellite-Almanac-Information", HFILL }},
    { &hf_rnsap_satellite_Almanac_Information_item,
      { "Item", "rnsap.satellite_Almanac_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "GPS-Almanac/satellite-Almanac-Information/_item", HFILL }},
    { &hf_rnsap_dATA_ID,
      { "dATA-ID", "rnsap.dATA_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_gps_e_alm,
      { "gps-e-alm", "rnsap.gps_e_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_gps_toa_alm,
      { "gps-toa-alm", "rnsap.gps_toa_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_gps_delta_I_alm,
      { "gps-delta-I-alm", "rnsap.gps_delta_I_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_omegadot_alm,
      { "omegadot-alm", "rnsap.omegadot_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_svhealth_alm,
      { "svhealth-alm", "rnsap.svhealth_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_gps_a_sqrt_alm,
      { "gps-a-sqrt-alm", "rnsap.gps_a_sqrt_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_omegazero_alm,
      { "omegazero-alm", "rnsap.omegazero_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_m_zero_alm,
      { "m-zero-alm", "rnsap.m_zero_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_gps_omega_alm,
      { "gps-omega-alm", "rnsap.gps_omega_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_gps_af_zero_alm,
      { "gps-af-zero-alm", "rnsap.gps_af_zero_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_gps_af_one_alm,
      { "gps-af-one-alm", "rnsap.gps_af_one_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_sVGlobalHealth_alm,
      { "sVGlobalHealth-alm", "rnsap.sVGlobalHealth_alm",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-Almanac/sVGlobalHealth-alm", HFILL }},
    { &hf_rnsap_Satellite_Almanac_Information_ExtItem_item,
      { "Item", "rnsap.Satellite_Almanac_Information_ExtItem_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Satellite-Almanac-Information-ExtItem/_item", HFILL }},
    { &hf_rnsap_GPSInformation_item,
      { "Item", "rnsap.GPSInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "GPSInformation/_item", HFILL }},
    { &hf_rnsap_gPSInformationItem,
      { "gPSInformationItem", "rnsap.gPSInformationItem",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_gPSInformationItem_vals), 0,
        "GPSInformation/_item/gPSInformationItem", HFILL }},
    { &hf_rnsap_alpha_zero_ionos,
      { "alpha-zero-ionos", "rnsap.alpha_zero_ionos",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-Ionospheric-Model/alpha-zero-ionos", HFILL }},
    { &hf_rnsap_alpha_one_ionos,
      { "alpha-one-ionos", "rnsap.alpha_one_ionos",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-Ionospheric-Model/alpha-one-ionos", HFILL }},
    { &hf_rnsap_alpha_two_ionos,
      { "alpha-two-ionos", "rnsap.alpha_two_ionos",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-Ionospheric-Model/alpha-two-ionos", HFILL }},
    { &hf_rnsap_alpha_three_ionos,
      { "alpha-three-ionos", "rnsap.alpha_three_ionos",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-Ionospheric-Model/alpha-three-ionos", HFILL }},
    { &hf_rnsap_beta_zero_ionos,
      { "beta-zero-ionos", "rnsap.beta_zero_ionos",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-Ionospheric-Model/beta-zero-ionos", HFILL }},
    { &hf_rnsap_beta_one_ionos,
      { "beta-one-ionos", "rnsap.beta_one_ionos",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-Ionospheric-Model/beta-one-ionos", HFILL }},
    { &hf_rnsap_beta_two_ionos,
      { "beta-two-ionos", "rnsap.beta_two_ionos",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-Ionospheric-Model/beta-two-ionos", HFILL }},
    { &hf_rnsap_beta_three_ionos,
      { "beta-three-ionos", "rnsap.beta_three_ionos",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-Ionospheric-Model/beta-three-ionos", HFILL }},
    { &hf_rnsap_GPS_NavigationModel_and_TimeRecovery_item,
      { "Item", "rnsap.GPS_NavigationModel_and_TimeRecovery_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item", HFILL }},
    { &hf_rnsap_tx_tow_nav,
      { "tx-tow-nav", "rnsap.tx_tow_nav",
        FT_UINT32, BASE_DEC, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/tx-tow-nav", HFILL }},
    { &hf_rnsap_tlm_message_nav,
      { "tlm-message-nav", "rnsap.tlm_message_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/tlm-message-nav", HFILL }},
    { &hf_rnsap_tlm_revd_c_nav,
      { "tlm-revd-c-nav", "rnsap.tlm_revd_c_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/tlm-revd-c-nav", HFILL }},
    { &hf_rnsap_ho_word_nav,
      { "ho-word-nav", "rnsap.ho_word_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/ho-word-nav", HFILL }},
    { &hf_rnsap_w_n_nav,
      { "w-n-nav", "rnsap.w_n_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/w-n-nav", HFILL }},
    { &hf_rnsap_ca_or_p_on_l2_nav,
      { "ca-or-p-on-l2-nav", "rnsap.ca_or_p_on_l2_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/ca-or-p-on-l2-nav", HFILL }},
    { &hf_rnsap_user_range_accuracy_index_nav,
      { "user-range-accuracy-index-nav", "rnsap.user_range_accuracy_index_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/user-range-accuracy-index-nav", HFILL }},
    { &hf_rnsap_sv_health_nav,
      { "sv-health-nav", "rnsap.sv_health_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/sv-health-nav", HFILL }},
    { &hf_rnsap_iodc_nav,
      { "iodc-nav", "rnsap.iodc_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/iodc-nav", HFILL }},
    { &hf_rnsap_l2_p_dataflag_nav,
      { "l2-p-dataflag-nav", "rnsap.l2_p_dataflag_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/l2-p-dataflag-nav", HFILL }},
    { &hf_rnsap_sf1_reserved_nav,
      { "sf1-reserved-nav", "rnsap.sf1_reserved_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/sf1-reserved-nav", HFILL }},
    { &hf_rnsap_t_gd_nav,
      { "t-gd-nav", "rnsap.t_gd_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/t-gd-nav", HFILL }},
    { &hf_rnsap_t_oc_nav,
      { "t-oc-nav", "rnsap.t_oc_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/t-oc-nav", HFILL }},
    { &hf_rnsap_a_f_2_nav,
      { "a-f-2-nav", "rnsap.a_f_2_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/a-f-2-nav", HFILL }},
    { &hf_rnsap_a_f_1_nav,
      { "a-f-1-nav", "rnsap.a_f_1_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/a-f-1-nav", HFILL }},
    { &hf_rnsap_a_f_zero_nav,
      { "a-f-zero-nav", "rnsap.a_f_zero_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/a-f-zero-nav", HFILL }},
    { &hf_rnsap_c_rs_nav,
      { "c-rs-nav", "rnsap.c_rs_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/c-rs-nav", HFILL }},
    { &hf_rnsap_delta_n_nav,
      { "delta-n-nav", "rnsap.delta_n_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/delta-n-nav", HFILL }},
    { &hf_rnsap_m_zero_nav,
      { "m-zero-nav", "rnsap.m_zero_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/m-zero-nav", HFILL }},
    { &hf_rnsap_c_uc_nav,
      { "c-uc-nav", "rnsap.c_uc_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/c-uc-nav", HFILL }},
    { &hf_rnsap_gps_e_nav,
      { "gps-e-nav", "rnsap.gps_e_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/gps-e-nav", HFILL }},
    { &hf_rnsap_c_us_nav,
      { "c-us-nav", "rnsap.c_us_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/c-us-nav", HFILL }},
    { &hf_rnsap_a_sqrt_nav,
      { "a-sqrt-nav", "rnsap.a_sqrt_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/a-sqrt-nav", HFILL }},
    { &hf_rnsap_t_oe_nav,
      { "t-oe-nav", "rnsap.t_oe_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/t-oe-nav", HFILL }},
    { &hf_rnsap_fit_interval_flag_nav,
      { "fit-interval-flag-nav", "rnsap.fit_interval_flag_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/fit-interval-flag-nav", HFILL }},
    { &hf_rnsap_aodo_nav,
      { "aodo-nav", "rnsap.aodo_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/aodo-nav", HFILL }},
    { &hf_rnsap_c_ic_nav,
      { "c-ic-nav", "rnsap.c_ic_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/c-ic-nav", HFILL }},
    { &hf_rnsap_omega_zero_nav,
      { "omega-zero-nav", "rnsap.omega_zero_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/omega-zero-nav", HFILL }},
    { &hf_rnsap_c_is_nav,
      { "c-is-nav", "rnsap.c_is_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/c-is-nav", HFILL }},
    { &hf_rnsap_i_zero_nav,
      { "i-zero-nav", "rnsap.i_zero_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/i-zero-nav", HFILL }},
    { &hf_rnsap_c_rc_nav,
      { "c-rc-nav", "rnsap.c_rc_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/c-rc-nav", HFILL }},
    { &hf_rnsap_gps_omega_nav,
      { "gps-omega-nav", "rnsap.gps_omega_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/gps-omega-nav", HFILL }},
    { &hf_rnsap_omegadot_nav,
      { "omegadot-nav", "rnsap.omegadot_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/omegadot-nav", HFILL }},
    { &hf_rnsap_idot_nav,
      { "idot-nav", "rnsap.idot_nav",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/idot-nav", HFILL }},
    { &hf_rnsap_spare_zero_fill,
      { "spare-zero-fill", "rnsap.spare_zero_fill",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-NavigationModel-and-TimeRecovery/_item/spare-zero-fill", HFILL }},
    { &hf_rnsap_badSatellites,
      { "badSatellites", "rnsap.badSatellites",
        FT_NONE, BASE_NONE, NULL, 0,
        "GPS-RealTime-Integrity/badSatellites", HFILL }},
    { &hf_rnsap_noBadSatellite,
      { "noBadSatellite", "rnsap.noBadSatellite",
        FT_NONE, BASE_NONE, NULL, 0,
        "GPS-RealTime-Integrity/noBadSatellite", HFILL }},
    { &hf_rnsap_a_one_utc,
      { "a-one-utc", "rnsap.a_one_utc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-UTC-Model/a-one-utc", HFILL }},
    { &hf_rnsap_a_zero_utc,
      { "a-zero-utc", "rnsap.a_zero_utc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-UTC-Model/a-zero-utc", HFILL }},
    { &hf_rnsap_t_ot_utc,
      { "t-ot-utc", "rnsap.t_ot_utc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-UTC-Model/t-ot-utc", HFILL }},
    { &hf_rnsap_delta_t_ls_utc,
      { "delta-t-ls-utc", "rnsap.delta_t_ls_utc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-UTC-Model/delta-t-ls-utc", HFILL }},
    { &hf_rnsap_w_n_t_utc,
      { "w-n-t-utc", "rnsap.w_n_t_utc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-UTC-Model/w-n-t-utc", HFILL }},
    { &hf_rnsap_w_n_lsf_utc,
      { "w-n-lsf-utc", "rnsap.w_n_lsf_utc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-UTC-Model/w-n-lsf-utc", HFILL }},
    { &hf_rnsap_dn_utc,
      { "dn-utc", "rnsap.dn_utc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-UTC-Model/dn-utc", HFILL }},
    { &hf_rnsap_delta_t_lsf_utc,
      { "delta-t-lsf-utc", "rnsap.delta_t_lsf_utc",
        FT_BYTES, BASE_HEX, NULL, 0,
        "GPS-UTC-Model/delta-t-lsf-utc", HFILL }},
    { &hf_rnsap_guaranteed_UL_Rate,
      { "guaranteed-UL-Rate", "rnsap.guaranteed_UL_Rate",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Guaranteed-Rate-Information/guaranteed-UL-Rate", HFILL }},
    { &hf_rnsap_guaranteed_DL_Rate,
      { "guaranteed-DL-Rate", "rnsap.guaranteed_DL_Rate",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Guaranteed-Rate-Information/guaranteed-DL-Rate", HFILL }},
    { &hf_rnsap_implicit,
      { "implicit", "rnsap.implicit",
        FT_NONE, BASE_NONE, NULL, 0,
        "HARQ-MemoryPartitioning/implicit", HFILL }},
    { &hf_rnsap_explicit,
      { "explicit", "rnsap.explicit",
        FT_NONE, BASE_NONE, NULL, 0,
        "HARQ-MemoryPartitioning/explicit", HFILL }},
    { &hf_rnsap_number_of_Processes,
      { "number-of-Processes", "rnsap.number_of_Processes",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HARQ-MemoryPartitioning-Implicit/number-of-Processes", HFILL }},
    { &hf_rnsap_hARQ_MemoryPartitioningList,
      { "hARQ-MemoryPartitioningList", "rnsap.hARQ_MemoryPartitioningList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HARQ-MemoryPartitioning-Explicit/hARQ-MemoryPartitioningList", HFILL }},
    { &hf_rnsap_HARQ_MemoryPartitioningList_item,
      { "Item", "rnsap.HARQ_MemoryPartitioningList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HARQ-MemoryPartitioningList/_item", HFILL }},
    { &hf_rnsap_process_Memory_Size,
      { "process-Memory-Size", "rnsap.process_Memory_Size",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_process_Memory_Size_vals), 0,
        "HARQ-MemoryPartitioningItem/process-Memory-Size", HFILL }},
    { &hf_rnsap_hSDSCH_MACdFlows_Information,
      { "hSDSCH-MACdFlows-Information", "rnsap.hSDSCH_MACdFlows_Information",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_uE_Capabilities_Info,
      { "uE-Capabilities-Info", "rnsap.uE_Capabilities_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_mAChs_Reordering_Buffer_Size_for_RLC_UM,
      { "mAChs-Reordering-Buffer-Size-for-RLC-UM", "rnsap.mAChs_Reordering_Buffer_Size_for_RLC_UM",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_cqiFeedback_CycleK,
      { "cqiFeedback-CycleK", "rnsap.cqiFeedback_CycleK",
        FT_UINT32, BASE_DEC, VALS(rnsap_CQI_Feedback_Cycle_vals), 0,
        "", HFILL }},
    { &hf_rnsap_cqiRepetitionFactor,
      { "cqiRepetitionFactor", "rnsap.cqiRepetitionFactor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ackNackRepetitionFactor,
      { "ackNackRepetitionFactor", "rnsap.ackNackRepetitionFactor",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_cqiPowerOffset,
      { "cqiPowerOffset", "rnsap.cqiPowerOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ackPowerOffset,
      { "ackPowerOffset", "rnsap.ackPowerOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_nackPowerOffset,
      { "nackPowerOffset", "rnsap.nackPowerOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_hsscch_PowerOffset,
      { "hsscch-PowerOffset", "rnsap.hsscch_PowerOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_hSDSCH_MACdFlow_Specific_InfoList_Response,
      { "hSDSCH-MACdFlow-Specific-InfoList-Response", "rnsap.hSDSCH_MACdFlow_Specific_InfoList_Response",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_hSSCCH_Specific_InfoList_Response,
      { "hSSCCH-Specific-InfoList-Response", "rnsap.hSSCCH_Specific_InfoList_Response",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-FDD-Information-Response/hSSCCH-Specific-InfoList-Response", HFILL }},
    { &hf_rnsap_hSPDSCH_and_HSSCCH_ScramblingCode,
      { "hSPDSCH-and-HSSCCH-ScramblingCode", "rnsap.hSPDSCH_and_HSSCCH_ScramblingCode",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-FDD-Information-Response/hSPDSCH-and-HSSCCH-ScramblingCode", HFILL }},
    { &hf_rnsap_measurement_Power_Offset,
      { "measurement-Power-Offset", "rnsap.measurement_Power_Offset",
        FT_INT32, BASE_DEC, NULL, 0,
        "HSDSCH-FDD-Information-Response/measurement-Power-Offset", HFILL }},
    { &hf_rnsap_hARQ_MemoryPartitioning,
      { "hARQ-MemoryPartitioning", "rnsap.hARQ_MemoryPartitioning",
        FT_UINT32, BASE_DEC, VALS(rnsap_HARQ_MemoryPartitioning_vals), 0,
        "", HFILL }},
    { &hf_rnsap_hSDSCH_MACdFlow_Specific_InfoList_to_Modify,
      { "hSDSCH-MACdFlow-Specific-InfoList-to-Modify", "rnsap.hSDSCH_MACdFlow_Specific_InfoList_to_Modify",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_priorityQueue_Info_to_Modify,
      { "priorityQueue-Info-to-Modify", "rnsap.priorityQueue_Info_to_Modify",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-Information-to-Modify/priorityQueue-Info-to-Modify", HFILL }},
    { &hf_rnsap_hSSCCH_CodeChangeGrant,
      { "hSSCCH-CodeChangeGrant", "rnsap.hSSCCH_CodeChangeGrant",
        FT_UINT32, BASE_DEC, VALS(rnsap_HSSCCH_Code_Change_Grant_vals), 0,
        "HSDSCH-Information-to-Modify/hSSCCH-CodeChangeGrant", HFILL }},
    { &hf_rnsap_tDDAckNackPowerOffset,
      { "tDDAckNackPowerOffset", "rnsap.tDDAckNackPowerOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_priorityQueueInfotoModifyUnsynchronised,
      { "priorityQueueInfotoModifyUnsynchronised", "rnsap.priorityQueueInfotoModifyUnsynchronised",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-Information-to-Modify-Unsynchronised/priorityQueueInfotoModifyUnsynchronised", HFILL }},
    { &hf_rnsap_HSDSCH_MACdFlow_Specific_InfoList_item,
      { "Item", "rnsap.HSDSCH_MACdFlow_Specific_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSDSCH-MACdFlow-Specific-InfoList/_item", HFILL }},
    { &hf_rnsap_HSDSCH_MACdFlow_Specific_InfoList_Response_item,
      { "Item", "rnsap.HSDSCH_MACdFlow_Specific_InfoList_Response_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSDSCH-MACdFlow-Specific-InfoList-Response/_item", HFILL }},
    { &hf_rnsap_hSDSCH_Initial_Capacity_Allocation,
      { "hSDSCH-Initial-Capacity-Allocation", "rnsap.hSDSCH_Initial_Capacity_Allocation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-MACdFlow-Specific-InfoItem-Response/hSDSCH-Initial-Capacity-Allocation", HFILL }},
    { &hf_rnsap_HSDSCH_MACdFlow_Specific_InfoList_to_Modify_item,
      { "Item", "rnsap.HSDSCH_MACdFlow_Specific_InfoList_to_Modify_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSDSCH-MACdFlow-Specific-InfoList-to-Modify/_item", HFILL }},
    { &hf_rnsap_hSDSCH_MACdFlow_Specific_Info,
      { "hSDSCH-MACdFlow-Specific-Info", "rnsap.hSDSCH_MACdFlow_Specific_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-MACdFlows-Information/hSDSCH-MACdFlow-Specific-Info", HFILL }},
    { &hf_rnsap_priorityQueue_Info,
      { "priorityQueue-Info", "rnsap.priorityQueue_Info",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-MACdFlows-Information/priorityQueue-Info", HFILL }},
    { &hf_rnsap_HSDSCH_MACdFlows_to_Delete_item,
      { "Item", "rnsap.HSDSCH_MACdFlows_to_Delete_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSDSCH-MACdFlows-to-Delete/_item", HFILL }},
    { &hf_rnsap_hsDSCH_MACdFlow_ID,
      { "hsDSCH-MACdFlow-ID", "rnsap.hsDSCH_MACdFlow_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-MACdFlows-to-Delete-Item/hsDSCH-MACdFlow-ID", HFILL }},
    { &hf_rnsap_HSDSCH_Initial_Capacity_Allocation_item,
      { "Item", "rnsap.HSDSCH_Initial_Capacity_Allocation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSDSCH-Initial-Capacity-Allocation/_item", HFILL }},
    { &hf_rnsap_maximum_MACdPDU_Size,
      { "maximum-MACdPDU-Size", "rnsap.maximum_MACdPDU_Size",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-Initial-Capacity-AllocationItem/maximum-MACdPDU-Size", HFILL }},
    { &hf_rnsap_hSDSCH_InitialWindowSize,
      { "hSDSCH-InitialWindowSize", "rnsap.hSDSCH_InitialWindowSize",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-Initial-Capacity-AllocationItem/hSDSCH-InitialWindowSize", HFILL }},
    { &hf_rnsap_tDD_AckNack_Power_Offset,
      { "tDD-AckNack-Power-Offset", "rnsap.tDD_AckNack_Power_Offset",
        FT_INT32, BASE_DEC, NULL, 0,
        "HSDSCH-TDD-Information/tDD-AckNack-Power-Offset", HFILL }},
    { &hf_rnsap_hSSCCH_TDD_Specific_InfoList_Response,
      { "hSSCCH-TDD-Specific-InfoList-Response", "rnsap.hSSCCH_TDD_Specific_InfoList_Response",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-TDD-Information-Response/hSSCCH-TDD-Specific-InfoList-Response", HFILL }},
    { &hf_rnsap_hSSCCH_TDD_Specific_InfoList_Response_LCR,
      { "hSSCCH-TDD-Specific-InfoList-Response-LCR", "rnsap.hSSCCH_TDD_Specific_InfoList_Response_LCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-TDD-Information-Response/hSSCCH-TDD-Specific-InfoList-Response-LCR", HFILL }},
    { &hf_rnsap_hSPDSCH_TDD_Specific_InfoList_Response,
      { "hSPDSCH-TDD-Specific-InfoList-Response", "rnsap.hSPDSCH_TDD_Specific_InfoList_Response",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-TDD-Information-Response/hSPDSCH-TDD-Specific-InfoList-Response", HFILL }},
    { &hf_rnsap_hSPDSCH_TDD_Specific_InfoList_Response_LCR,
      { "hSPDSCH-TDD-Specific-InfoList-Response-LCR", "rnsap.hSPDSCH_TDD_Specific_InfoList_Response_LCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSDSCH-TDD-Information-Response/hSPDSCH-TDD-Specific-InfoList-Response-LCR", HFILL }},
    { &hf_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_item,
      { "Item", "rnsap.HSPDSCH_TDD_Specific_InfoList_Response_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSPDSCH-TDD-Specific-InfoList-Response/_item", HFILL }},
    { &hf_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_LCR_item,
      { "Item", "rnsap.HSPDSCH_TDD_Specific_InfoList_Response_LCR_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSPDSCH-TDD-Specific-InfoList-Response-LCR/_item", HFILL }},
    { &hf_rnsap_HSSCCH_FDD_Specific_InfoList_Response_item,
      { "Item", "rnsap.HSSCCH_FDD_Specific_InfoList_Response_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSSCCH-FDD-Specific-InfoList-Response/_item", HFILL }},
    { &hf_rnsap_code_Number,
      { "code-Number", "rnsap.code_Number",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HSSCCH-FDD-Specific-InfoItem-Response/code-Number", HFILL }},
    { &hf_rnsap_HSSCCH_TDD_Specific_InfoList_Response_item,
      { "Item", "rnsap.HSSCCH_TDD_Specific_InfoList_Response_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSSCCH-TDD-Specific-InfoList-Response/_item", HFILL }},
    { &hf_rnsap_hSSICH_Info,
      { "hSSICH-Info", "rnsap.hSSICH_Info",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSSCCH-TDD-Specific-InfoItem-Response/hSSICH-Info", HFILL }},
    { &hf_rnsap_HSSCCH_TDD_Specific_InfoList_Response_LCR_item,
      { "Item", "rnsap.HSSCCH_TDD_Specific_InfoList_Response_LCR_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSSCCH-TDD-Specific-InfoList-Response-LCR/_item", HFILL }},
    { &hf_rnsap_first_TDD_ChannelisationCode,
      { "first-TDD-ChannelisationCode", "rnsap.first_TDD_ChannelisationCode",
        FT_UINT32, BASE_DEC, VALS(rnsap_TDD_ChannelisationCode_vals), 0,
        "HSSCCH-TDD-Specific-InfoItem-Response-LCR/first-TDD-ChannelisationCode", HFILL }},
    { &hf_rnsap_second_TDD_ChannelisationCode,
      { "second-TDD-ChannelisationCode", "rnsap.second_TDD_ChannelisationCode",
        FT_UINT32, BASE_DEC, VALS(rnsap_TDD_ChannelisationCode_vals), 0,
        "HSSCCH-TDD-Specific-InfoItem-Response-LCR/second-TDD-ChannelisationCode", HFILL }},
    { &hf_rnsap_hSSICH_InfoLCR,
      { "hSSICH-InfoLCR", "rnsap.hSSICH_InfoLCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "HSSCCH-TDD-Specific-InfoItem-Response-LCR/hSSICH-InfoLCR", HFILL }},
    { &hf_rnsap_hsSICH_ID,
      { "hsSICH-ID", "rnsap.hsSICH_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_failed_HS_SICH,
      { "failed-HS-SICH", "rnsap.failed_HS_SICH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HS-SICH-Reception-Quality-Value/failed-HS-SICH", HFILL }},
    { &hf_rnsap_missed_HS_SICH,
      { "missed-HS-SICH", "rnsap.missed_HS_SICH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HS-SICH-Reception-Quality-Value/missed-HS-SICH", HFILL }},
    { &hf_rnsap_total_HS_SICH,
      { "total-HS-SICH", "rnsap.total_HS_SICH",
        FT_UINT32, BASE_DEC, NULL, 0,
        "HS-SICH-Reception-Quality-Value/total-HS-SICH", HFILL }},
    { &hf_rnsap_hsSCCHCodeChangeIndicator,
      { "hsSCCHCodeChangeIndicator", "rnsap.hsSCCHCodeChangeIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_HSSCCH_CodeChangeIndicator_vals), 0,
        "", HFILL }},
    { &hf_rnsap_onDemand,
      { "onDemand", "rnsap.onDemand",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_periodic,
      { "periodic", "rnsap.periodic",
        FT_NONE, BASE_NONE, NULL, 0,
        "InformationReportCharacteristics/periodic", HFILL }},
    { &hf_rnsap_onModification,
      { "onModification", "rnsap.onModification",
        FT_NONE, BASE_NONE, NULL, 0,
        "InformationReportCharacteristics/onModification", HFILL }},
    { &hf_rnsap_min,
      { "min", "rnsap.min",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_hour,
      { "hour", "rnsap.hour",
        FT_UINT32, BASE_DEC, NULL, 0,
        "InformationReportPeriodicity/hour", HFILL }},
    { &hf_rnsap_dGPSThreshold,
      { "dGPSThreshold", "rnsap.dGPSThreshold",
        FT_NONE, BASE_NONE, NULL, 0,
        "InformationThreshold/dGPSThreshold", HFILL }},
    { &hf_rnsap_informationTypeItem,
      { "informationTypeItem", "rnsap.informationTypeItem",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_informationTypeItem_vals), 0,
        "InformationType/informationTypeItem", HFILL }},
    { &hf_rnsap_gPSInformation,
      { "gPSInformation", "rnsap.gPSInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "InformationType/gPSInformation", HFILL }},
    { &hf_rnsap_iPDL_FDD_Parameters,
      { "iPDL-FDD-Parameters", "rnsap.iPDL_FDD_Parameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "IPDLParameters/iPDL-FDD-Parameters", HFILL }},
    { &hf_rnsap_iPDL_TDD_Parameters,
      { "iPDL-TDD-Parameters", "rnsap.iPDL_TDD_Parameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "IPDLParameters/iPDL-TDD-Parameters", HFILL }},
    { &hf_rnsap_extension_IPDLParameters,
      { "extension-IPDLParameters", "rnsap.extension_IPDLParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "IPDLParameters/extension-IPDLParameters", HFILL }},
    { &hf_rnsap_iPSpacingFDD,
      { "iPSpacingFDD", "rnsap.iPSpacingFDD",
        FT_UINT32, BASE_DEC, VALS(rnsap_IPSpacingFDD_vals), 0,
        "IPDL-FDD-Parameters/iPSpacingFDD", HFILL }},
    { &hf_rnsap_iPLength,
      { "iPLength", "rnsap.iPLength",
        FT_UINT32, BASE_DEC, VALS(rnsap_IPLength_vals), 0,
        "IPDL-FDD-Parameters/iPLength", HFILL }},
    { &hf_rnsap_iPOffset,
      { "iPOffset", "rnsap.iPOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "IPDL-FDD-Parameters/iPOffset", HFILL }},
    { &hf_rnsap_seed,
      { "seed", "rnsap.seed",
        FT_UINT32, BASE_DEC, NULL, 0,
        "IPDL-FDD-Parameters/seed", HFILL }},
    { &hf_rnsap_burstModeParameters,
      { "burstModeParameters", "rnsap.burstModeParameters",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_iPSpacingTDD,
      { "iPSpacingTDD", "rnsap.iPSpacingTDD",
        FT_UINT32, BASE_DEC, VALS(rnsap_IPSpacingTDD_vals), 0,
        "", HFILL }},
    { &hf_rnsap_iPStart,
      { "iPStart", "rnsap.iPStart",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_iPSlot,
      { "iPSlot", "rnsap.iPSlot",
        FT_UINT32, BASE_DEC, NULL, 0,
        "IPDL-TDD-Parameters/iPSlot", HFILL }},
    { &hf_rnsap_iP_P_CCPCH,
      { "iP-P-CCPCH", "rnsap.iP_P_CCPCH",
        FT_UINT32, BASE_DEC, VALS(rnsap_IP_P_CCPCH_vals), 0,
        "IPDL-TDD-Parameters/iP-P-CCPCH", HFILL }},
    { &hf_rnsap_iPSub,
      { "iPSub", "rnsap.iPSub",
        FT_UINT32, BASE_DEC, VALS(rnsap_IPSub_vals), 0,
        "IPDL-TDD-ParametersLCR/iPSub", HFILL }},
    { &hf_rnsap_uplinkLoadValue,
      { "uplinkLoadValue", "rnsap.uplinkLoadValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "LoadValue/uplinkLoadValue", HFILL }},
    { &hf_rnsap_downlinkLoadValue,
      { "downlinkLoadValue", "rnsap.downlinkLoadValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "LoadValue/downlinkLoadValue", HFILL }},
    { &hf_rnsap_MAC_c_sh_SDU_LengthList_item,
      { "Item", "rnsap.MAC_c_sh_SDU_LengthList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MAC-c-sh-SDU-LengthList/_item", HFILL }},
    { &hf_rnsap_MACdPDU_Size_IndexList_item,
      { "Item", "rnsap.MACdPDU_Size_IndexList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "MACdPDU-Size-IndexList/_item", HFILL }},
    { &hf_rnsap_sID,
      { "sID", "rnsap.sID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_MACdPDU_Size_IndexList_to_Modify_item,
      { "Item", "rnsap.MACdPDU_Size_IndexList_to_Modify_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "MACdPDU-Size-IndexList-to-Modify/_item", HFILL }},
    { &hf_rnsap_accessPointName,
      { "accessPointName", "rnsap.accessPointName",
        FT_BYTES, BASE_HEX, NULL, 0,
        "MBMS-Bearer-Service-Full-Address/accessPointName", HFILL }},
    { &hf_rnsap_iPMulticastAddress,
      { "iPMulticastAddress", "rnsap.iPMulticastAddress",
        FT_BYTES, BASE_HEX, NULL, 0,
        "MBMS-Bearer-Service-Full-Address/iPMulticastAddress", HFILL }},
    { &hf_rnsap_MBMS_Bearer_Service_List_item,
      { "Item", "rnsap.MBMS_Bearer_Service_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "MBMS-Bearer-Service-List/_item", HFILL }},
    { &hf_rnsap_transmissionMode,
      { "transmissionMode", "rnsap.transmissionMode",
        FT_UINT32, BASE_DEC, VALS(rnsap_TransmissionMode_vals), 0,
        "", HFILL }},
    { &hf_rnsap_preferredFrequencyLayer,
      { "preferredFrequencyLayer", "rnsap.preferredFrequencyLayer",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tMGI,
      { "tMGI", "rnsap.tMGI",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_pTM_Cell_List,
      { "pTM-Cell-List", "rnsap.pTM_Cell_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MBMSChannelTypeInfo/pTM-Cell-List", HFILL }},
    { &hf_rnsap_pTP_Cell_List,
      { "pTP-Cell-List", "rnsap.pTP_Cell_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MBMSChannelTypeInfo/pTP-Cell-List", HFILL }},
    { &hf_rnsap_not_Provided_Cell_List,
      { "not-Provided-Cell-List", "rnsap.not_Provided_Cell_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MBMSChannelTypeInfo/not-Provided-Cell-List", HFILL }},
    { &hf_rnsap_affectedUEInformationForMBMS,
      { "affectedUEInformationForMBMS", "rnsap.affectedUEInformationForMBMS",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MBMSChannelTypeCellList/affectedUEInformationForMBMS", HFILL }},
    { &hf_rnsap_preferredFrequencyLayerInfo,
      { "preferredFrequencyLayerInfo", "rnsap.preferredFrequencyLayerInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "MBMSPreferredFreqLayerInfo/preferredFrequencyLayerInfo", HFILL }},
    { &hf_rnsap_sir,
      { "sir", "rnsap.sir",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementIncreaseDecreaseThreshold/sir", HFILL }},
    { &hf_rnsap_sir_error,
      { "sir-error", "rnsap.sir_error",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementIncreaseDecreaseThreshold/sir-error", HFILL }},
    { &hf_rnsap_transmitted_code_power,
      { "transmitted-code-power", "rnsap.transmitted_code_power",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementIncreaseDecreaseThreshold/transmitted-code-power", HFILL }},
    { &hf_rnsap_rscp,
      { "rscp", "rnsap.rscp",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementIncreaseDecreaseThreshold/rscp", HFILL }},
    { &hf_rnsap_round_trip_time,
      { "round-trip-time", "rnsap.round_trip_time",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementIncreaseDecreaseThreshold/round-trip-time", HFILL }},
    { &hf_rnsap_extension_MeasurementIncreaseDecreaseThreshold,
      { "extension-MeasurementIncreaseDecreaseThreshold", "rnsap.extension_MeasurementIncreaseDecreaseThreshold",
        FT_NONE, BASE_NONE, NULL, 0,
        "MeasurementIncreaseDecreaseThreshold/extension-MeasurementIncreaseDecreaseThreshold", HFILL }},
    { &hf_rnsap_sir1,
      { "sir", "rnsap.sir",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementThreshold/sir", HFILL }},
    { &hf_rnsap_sir_error1,
      { "sir-error", "rnsap.sir_error",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementThreshold/sir-error", HFILL }},
    { &hf_rnsap_transmitted_code_power1,
      { "transmitted-code-power", "rnsap.transmitted_code_power",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementThreshold/transmitted-code-power", HFILL }},
    { &hf_rnsap_rscp1,
      { "rscp", "rnsap.rscp",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementThreshold/rscp", HFILL }},
    { &hf_rnsap_rx_timing_deviation,
      { "rx-timing-deviation", "rnsap.rx_timing_deviation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementThreshold/rx-timing-deviation", HFILL }},
    { &hf_rnsap_round_trip_time1,
      { "round-trip-time", "rnsap.round_trip_time",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MeasurementThreshold/round-trip-time", HFILL }},
    { &hf_rnsap_extension_MeasurementThreshold,
      { "extension-MeasurementThreshold", "rnsap.extension_MeasurementThreshold",
        FT_NONE, BASE_NONE, NULL, 0,
        "MeasurementThreshold/extension-MeasurementThreshold", HFILL }},
    { &hf_rnsap_type1,
      { "type1", "rnsap.type1",
        FT_NONE, BASE_NONE, NULL, 0,
        "MidambleShiftAndBurstType/type1", HFILL }},
    { &hf_rnsap_midambleConfigurationBurstType1And3,
      { "midambleConfigurationBurstType1And3", "rnsap.midambleConfigurationBurstType1And3",
        FT_UINT32, BASE_DEC, VALS(rnsap_MidambleConfigurationBurstType1And3_vals), 0,
        "", HFILL }},
    { &hf_rnsap_midambleAllocationMode,
      { "midambleAllocationMode", "rnsap.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_midambleAllocationMode_vals), 0,
        "MidambleShiftAndBurstType/type1/midambleAllocationMode", HFILL }},
    { &hf_rnsap_defaultMidamble,
      { "defaultMidamble", "rnsap.defaultMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_commonMidamble,
      { "commonMidamble", "rnsap.commonMidamble",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_ueSpecificMidamble,
      { "ueSpecificMidamble", "rnsap.ueSpecificMidamble",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_type2,
      { "type2", "rnsap.type2",
        FT_NONE, BASE_NONE, NULL, 0,
        "MidambleShiftAndBurstType/type2", HFILL }},
    { &hf_rnsap_midambleConfigurationBurstType2,
      { "midambleConfigurationBurstType2", "rnsap.midambleConfigurationBurstType2",
        FT_UINT32, BASE_DEC, VALS(rnsap_MidambleConfigurationBurstType2_vals), 0,
        "MidambleShiftAndBurstType/type2/midambleConfigurationBurstType2", HFILL }},
    { &hf_rnsap_midambleAllocationMode1,
      { "midambleAllocationMode", "rnsap.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_midambleAllocationMode1_vals), 0,
        "MidambleShiftAndBurstType/type2/midambleAllocationMode", HFILL }},
    { &hf_rnsap_ueSpecificMidamble1,
      { "ueSpecificMidamble", "rnsap.ueSpecificMidamble",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MidambleShiftAndBurstType/type2/midambleAllocationMode/ueSpecificMidamble", HFILL }},
    { &hf_rnsap_type3,
      { "type3", "rnsap.type3",
        FT_NONE, BASE_NONE, NULL, 0,
        "MidambleShiftAndBurstType/type3", HFILL }},
    { &hf_rnsap_midambleAllocationMode2,
      { "midambleAllocationMode", "rnsap.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_midambleAllocationMode2_vals), 0,
        "MidambleShiftAndBurstType/type3/midambleAllocationMode", HFILL }},
    { &hf_rnsap_midambleAllocationMode3,
      { "midambleAllocationMode", "rnsap.midambleAllocationMode",
        FT_UINT32, BASE_DEC, VALS(rnsap_MidambleAllocationMode_vals), 0,
        "MidambleShiftLCR/midambleAllocationMode", HFILL }},
    { &hf_rnsap_midambleShift,
      { "midambleShift", "rnsap.midambleShift",
        FT_UINT32, BASE_DEC, NULL, 0,
        "MidambleShiftLCR/midambleShift", HFILL }},
    { &hf_rnsap_midambleConfigurationLCR,
      { "midambleConfigurationLCR", "rnsap.midambleConfigurationLCR",
        FT_UINT32, BASE_DEC, VALS(rnsap_MidambleConfigurationLCR_vals), 0,
        "MidambleShiftLCR/midambleConfigurationLCR", HFILL }},
    { &hf_rnsap_addPriorityQueue,
      { "addPriorityQueue", "rnsap.addPriorityQueue",
        FT_NONE, BASE_NONE, NULL, 0,
        "ModifyPriorityQueue/addPriorityQueue", HFILL }},
    { &hf_rnsap_modifyPriorityQueue,
      { "modifyPriorityQueue", "rnsap.modifyPriorityQueue",
        FT_NONE, BASE_NONE, NULL, 0,
        "ModifyPriorityQueue/modifyPriorityQueue", HFILL }},
    { &hf_rnsap_deletePriorityQueue,
      { "deletePriorityQueue", "rnsap.deletePriorityQueue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ModifyPriorityQueue/deletePriorityQueue", HFILL }},
    { &hf_rnsap_gERAN_SI_Type,
      { "gERAN-SI-Type", "rnsap.gERAN_SI_Type",
        FT_UINT32, BASE_DEC, VALS(rnsap_GERAN_SI_Type_vals), 0,
        "NACC-Related-Data/gERAN-SI-Type", HFILL }},
    { &hf_rnsap_Neighbouring_UMTS_CellInformation_item,
      { "Item", "rnsap.Neighbouring_UMTS_CellInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Neighbouring-UMTS-CellInformation/_item", HFILL }},
    { &hf_rnsap_rNC_ID,
      { "rNC-ID", "rnsap.rNC_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_cN_PS_DomainIdentifier,
      { "cN-PS-DomainIdentifier", "rnsap.cN_PS_DomainIdentifier",
        FT_NONE, BASE_NONE, NULL, 0,
        "Neighbouring-UMTS-CellInformationItem/cN-PS-DomainIdentifier", HFILL }},
    { &hf_rnsap_cN_CS_DomainIdentifier,
      { "cN-CS-DomainIdentifier", "rnsap.cN_CS_DomainIdentifier",
        FT_NONE, BASE_NONE, NULL, 0,
        "Neighbouring-UMTS-CellInformationItem/cN-CS-DomainIdentifier", HFILL }},
    { &hf_rnsap_neighbouring_FDD_CellInformation,
      { "neighbouring-FDD-CellInformation", "rnsap.neighbouring_FDD_CellInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Neighbouring-UMTS-CellInformationItem/neighbouring-FDD-CellInformation", HFILL }},
    { &hf_rnsap_neighbouring_TDD_CellInformation,
      { "neighbouring-TDD-CellInformation", "rnsap.neighbouring_TDD_CellInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Neighbouring-UMTS-CellInformationItem/neighbouring-TDD-CellInformation", HFILL }},
    { &hf_rnsap_Neighbouring_FDD_CellInformation_item,
      { "Item", "rnsap.Neighbouring_FDD_CellInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Neighbouring-FDD-CellInformation/_item", HFILL }},
    { &hf_rnsap_uARFCNforNu,
      { "uARFCNforNu", "rnsap.uARFCNforNu",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Neighbouring-FDD-CellInformationItem/uARFCNforNu", HFILL }},
    { &hf_rnsap_uARFCNforNd,
      { "uARFCNforNd", "rnsap.uARFCNforNd",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Neighbouring-FDD-CellInformationItem/uARFCNforNd", HFILL }},
    { &hf_rnsap_cellIndividualOffset,
      { "cellIndividualOffset", "rnsap.cellIndividualOffset",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_txDiversityIndicator,
      { "txDiversityIndicator", "rnsap.txDiversityIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_TxDiversityIndicator_vals), 0,
        "Neighbouring-FDD-CellInformationItem/txDiversityIndicator", HFILL }},
    { &hf_rnsap_sTTD_SupportIndicator,
      { "sTTD-SupportIndicator", "rnsap.sTTD_SupportIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_STTD_SupportIndicator_vals), 0,
        "Neighbouring-FDD-CellInformationItem/sTTD-SupportIndicator", HFILL }},
    { &hf_rnsap_closedLoopMode1_SupportIndicator,
      { "closedLoopMode1-SupportIndicator", "rnsap.closedLoopMode1_SupportIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_ClosedLoopMode1_SupportIndicator_vals), 0,
        "Neighbouring-FDD-CellInformationItem/closedLoopMode1-SupportIndicator", HFILL }},
    { &hf_rnsap_not_used_closedLoopMode2_SupportIndicator,
      { "not-used-closedLoopMode2-SupportIndicator", "rnsap.not_used_closedLoopMode2_SupportIndicator",
        FT_NONE, BASE_NONE, NULL, 0,
        "Neighbouring-FDD-CellInformationItem/not-used-closedLoopMode2-SupportIndicator", HFILL }},
    { &hf_rnsap_uARFCN,
      { "uARFCN", "rnsap.uARFCN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_Neighbouring_GSM_CellInformationIEs_item,
      { "Item", "rnsap.Neighbouring_GSM_CellInformationIEs_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Neighbouring-GSM-CellInformationIEs/_item", HFILL }},
    { &hf_rnsap_bSIC,
      { "bSIC", "rnsap.bSIC",
        FT_NONE, BASE_NONE, NULL, 0,
        "Neighbouring-GSM-CellInformationItem/bSIC", HFILL }},
    { &hf_rnsap_band_Indicator,
      { "band-Indicator", "rnsap.band_Indicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_Band_Indicator_vals), 0,
        "Neighbouring-GSM-CellInformationItem/band-Indicator", HFILL }},
    { &hf_rnsap_bCCH_ARFCN,
      { "bCCH-ARFCN", "rnsap.bCCH_ARFCN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Neighbouring-GSM-CellInformationItem/bCCH-ARFCN", HFILL }},
    { &hf_rnsap_Neighbouring_TDD_CellInformation_item,
      { "Item", "rnsap.Neighbouring_TDD_CellInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Neighbouring-TDD-CellInformation/_item", HFILL }},
    { &hf_rnsap_dPCHConstantValue,
      { "dPCHConstantValue", "rnsap.dPCHConstantValue",
        FT_INT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_Neighbouring_LCR_TDD_CellInformation_item,
      { "Item", "rnsap.Neighbouring_LCR_TDD_CellInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Neighbouring-LCR-TDD-CellInformation/_item", HFILL }},
    { &hf_rnsap_restrictionStateIndicator,
      { "restrictionStateIndicator", "rnsap.restrictionStateIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_RestrictionStateIndicator_vals), 0,
        "Neighbouring-LCR-TDD-CellInformationItem/restrictionStateIndicator", HFILL }},
    { &hf_rnsap_NotProvidedCellList_item,
      { "Item", "rnsap.NotProvidedCellList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "NotProvidedCellList/_item", HFILL }},
    { &hf_rnsap_uplinkNRTLoadInformationValue,
      { "uplinkNRTLoadInformationValue", "rnsap.uplinkNRTLoadInformationValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "NRTLoadInformationValue/uplinkNRTLoadInformationValue", HFILL }},
    { &hf_rnsap_downlinkNRTLoadInformationValue,
      { "downlinkNRTLoadInformationValue", "rnsap.downlinkNRTLoadInformationValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "NRTLoadInformationValue/downlinkNRTLoadInformationValue", HFILL }},
    { &hf_rnsap_measurementThreshold,
      { "measurementThreshold", "rnsap.measurementThreshold",
        FT_UINT32, BASE_DEC, VALS(rnsap_MeasurementThreshold_vals), 0,
        "OnModification/measurementThreshold", HFILL }},
    { &hf_rnsap_informationThreshold,
      { "informationThreshold", "rnsap.informationThreshold",
        FT_UINT32, BASE_DEC, VALS(rnsap_InformationThreshold_vals), 0,
        "OnModificationInformation/informationThreshold", HFILL }},
    { &hf_rnsap_PCH_InformationList_item,
      { "Item", "rnsap.PCH_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "PCH-InformationList/_item", HFILL }},
    { &hf_rnsap_informationReportPeriodicity,
      { "informationReportPeriodicity", "rnsap.informationReportPeriodicity",
        FT_UINT32, BASE_DEC, VALS(rnsap_InformationReportPeriodicity_vals), 0,
        "PeriodicInformation/informationReportPeriodicity", HFILL }},
    { &hf_rnsap_imsi,
      { "imsi", "rnsap.imsi",
        FT_BYTES, BASE_HEX, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_defaultPreferredFrequency,
      { "defaultPreferredFrequency", "rnsap.defaultPreferredFrequency",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PreferredFrequencyLayerInfo/defaultPreferredFrequency", HFILL }},
    { &hf_rnsap_additionalPreferredFrequency,
      { "additionalPreferredFrequency", "rnsap.additionalPreferredFrequency",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PreferredFrequencyLayerInfo/additionalPreferredFrequency", HFILL }},
    { &hf_rnsap_PriorityQueue_InfoList_item,
      { "Item", "rnsap.PriorityQueue_InfoList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "PriorityQueue-InfoList/_item", HFILL }},
    { &hf_rnsap_priorityQueue_Id,
      { "priorityQueue-Id", "rnsap.priorityQueue_Id",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_associatedHSDSCH_MACdFlow,
      { "associatedHSDSCH-MACdFlow", "rnsap.associatedHSDSCH_MACdFlow",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_t1,
      { "t1", "rnsap.t1",
        FT_UINT32, BASE_DEC, VALS(rnsap_T1_vals), 0,
        "", HFILL }},
    { &hf_rnsap_discardTimer,
      { "discardTimer", "rnsap.discardTimer",
        FT_UINT32, BASE_DEC, VALS(rnsap_DiscardTimer_vals), 0,
        "", HFILL }},
    { &hf_rnsap_mAC_hsWindowSize,
      { "mAC-hsWindowSize", "rnsap.mAC_hsWindowSize",
        FT_UINT32, BASE_DEC, VALS(rnsap_MAC_hsWindowSize_vals), 0,
        "", HFILL }},
    { &hf_rnsap_mAChsGuaranteedBitRate,
      { "mAChsGuaranteedBitRate", "rnsap.mAChsGuaranteedBitRate",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_mACdPDU_Size_Index,
      { "mACdPDU-Size-Index", "rnsap.mACdPDU_Size_Index",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_rLC_Mode,
      { "rLC-Mode", "rnsap.rLC_Mode",
        FT_UINT32, BASE_DEC, VALS(rnsap_RLC_Mode_vals), 0,
        "", HFILL }},
    { &hf_rnsap_PriorityQueue_InfoList_to_Modify_item,
      { "Item", "rnsap.PriorityQueue_InfoList_to_Modify_item",
        FT_UINT32, BASE_DEC, VALS(rnsap_ModifyPriorityQueue_vals), 0,
        "PriorityQueue-InfoList-to-Modify/_item", HFILL }},
    { &hf_rnsap_mACdPDU_Size_Index_to_Modify,
      { "mACdPDU-Size-Index-to-Modify", "rnsap.mACdPDU_Size_Index_to_Modify",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PriorityQueue-InfoItem-to-Modify/mACdPDU-Size-Index-to-Modify", HFILL }},
    { &hf_rnsap_PriorityQueue_InfoList_to_Modify_Unsynchronised_item,
      { "Item", "rnsap.PriorityQueue_InfoList_to_Modify_Unsynchronised_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "PriorityQueue-InfoList-to-Modify-Unsynchronised/_item", HFILL }},
    { &hf_rnsap_priorityQueueId,
      { "priorityQueueId", "rnsap.priorityQueueId",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PriorityQueue-InfoItem-to-Modify-Unsynchronised/priorityQueueId", HFILL }},
    { &hf_rnsap_mBMSChannelTypeInfo,
      { "mBMSChannelTypeInfo", "rnsap.mBMSChannelTypeInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "ProvidedInformation/mBMSChannelTypeInfo", HFILL }},
    { &hf_rnsap_mBMSPreferredFreqLayerInfo,
      { "mBMSPreferredFreqLayerInfo", "rnsap.mBMSPreferredFreqLayerInfo",
        FT_NONE, BASE_NONE, NULL, 0,
        "ProvidedInformation/mBMSPreferredFreqLayerInfo", HFILL }},
    { &hf_rnsap_PTMCellList_item,
      { "Item", "rnsap.PTMCellList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "PTMCellList/_item", HFILL }},
    { &hf_rnsap_PTPCellList_item,
      { "Item", "rnsap.PTPCellList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "PTPCellList/_item", HFILL }},
    { &hf_rnsap_RB_Info_item,
      { "Item", "rnsap.RB_Info_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RB-Info/_item", HFILL }},
    { &hf_rnsap_Reference_E_TFCI_Information_item,
      { "Item", "rnsap.Reference_E_TFCI_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Reference-E-TFCI-Information/_item", HFILL }},
    { &hf_rnsap_reference_E_TFCI,
      { "reference-E-TFCI", "rnsap.reference_E_TFCI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Reference-E-TFCI-Information-Item/reference-E-TFCI", HFILL }},
    { &hf_rnsap_reference_E_TFCI_PO,
      { "reference-E-TFCI-PO", "rnsap.reference_E_TFCI_PO",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Reference-E-TFCI-Information-Item/reference-E-TFCI-PO", HFILL }},
    { &hf_rnsap_periodic1,
      { "periodic", "rnsap.periodic",
        FT_NONE, BASE_NONE, NULL, 0,
        "ReportCharacteristics/periodic", HFILL }},
    { &hf_rnsap_eventA,
      { "eventA", "rnsap.eventA",
        FT_NONE, BASE_NONE, NULL, 0,
        "ReportCharacteristics/eventA", HFILL }},
    { &hf_rnsap_eventB,
      { "eventB", "rnsap.eventB",
        FT_NONE, BASE_NONE, NULL, 0,
        "ReportCharacteristics/eventB", HFILL }},
    { &hf_rnsap_eventC,
      { "eventC", "rnsap.eventC",
        FT_NONE, BASE_NONE, NULL, 0,
        "ReportCharacteristics/eventC", HFILL }},
    { &hf_rnsap_eventD,
      { "eventD", "rnsap.eventD",
        FT_NONE, BASE_NONE, NULL, 0,
        "ReportCharacteristics/eventD", HFILL }},
    { &hf_rnsap_eventE,
      { "eventE", "rnsap.eventE",
        FT_NONE, BASE_NONE, NULL, 0,
        "ReportCharacteristics/eventE", HFILL }},
    { &hf_rnsap_eventF,
      { "eventF", "rnsap.eventF",
        FT_NONE, BASE_NONE, NULL, 0,
        "ReportCharacteristics/eventF", HFILL }},
    { &hf_rnsap_extension_ReportCharacteristics,
      { "extension-ReportCharacteristics", "rnsap.extension_ReportCharacteristics",
        FT_NONE, BASE_NONE, NULL, 0,
        "ReportCharacteristics/extension-ReportCharacteristics", HFILL }},
    { &hf_rnsap_ten_msec,
      { "ten-msec", "rnsap.ten_msec",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ReportPeriodicity/ten-msec", HFILL }},
    { &hf_rnsap_gA_AccessPointPositionwithAltitude,
      { "gA-AccessPointPositionwithAltitude", "rnsap.gA_AccessPointPositionwithAltitude",
        FT_NONE, BASE_NONE, NULL, 0,
        "RequestedDataValue/gA-AccessPointPositionwithAltitude", HFILL }},
    { &hf_rnsap_iPDLParameters,
      { "iPDLParameters", "rnsap.iPDLParameters",
        FT_UINT32, BASE_DEC, VALS(rnsap_IPDLParameters_vals), 0,
        "RequestedDataValue/iPDLParameters", HFILL }},
    { &hf_rnsap_dGPSCorrections,
      { "dGPSCorrections", "rnsap.dGPSCorrections",
        FT_NONE, BASE_NONE, NULL, 0,
        "RequestedDataValue/dGPSCorrections", HFILL }},
    { &hf_rnsap_gPS_NavigationModel_and_TimeRecovery,
      { "gPS-NavigationModel-and-TimeRecovery", "rnsap.gPS_NavigationModel_and_TimeRecovery",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RequestedDataValue/gPS-NavigationModel-and-TimeRecovery", HFILL }},
    { &hf_rnsap_gPS_Ionospheric_Model,
      { "gPS-Ionospheric-Model", "rnsap.gPS_Ionospheric_Model",
        FT_NONE, BASE_NONE, NULL, 0,
        "RequestedDataValue/gPS-Ionospheric-Model", HFILL }},
    { &hf_rnsap_gPS_UTC_Model,
      { "gPS-UTC-Model", "rnsap.gPS_UTC_Model",
        FT_NONE, BASE_NONE, NULL, 0,
        "RequestedDataValue/gPS-UTC-Model", HFILL }},
    { &hf_rnsap_gPS_Almanac,
      { "gPS-Almanac", "rnsap.gPS_Almanac",
        FT_NONE, BASE_NONE, NULL, 0,
        "RequestedDataValue/gPS-Almanac", HFILL }},
    { &hf_rnsap_gPS_RealTime_Integrity,
      { "gPS-RealTime-Integrity", "rnsap.gPS_RealTime_Integrity",
        FT_UINT32, BASE_DEC, VALS(rnsap_GPS_RealTime_Integrity_vals), 0,
        "RequestedDataValue/gPS-RealTime-Integrity", HFILL }},
    { &hf_rnsap_gPS_RX_POS,
      { "gPS-RX-POS", "rnsap.gPS_RX_POS",
        FT_NONE, BASE_NONE, NULL, 0,
        "RequestedDataValue/gPS-RX-POS", HFILL }},
    { &hf_rnsap_sFNSFN_GA_AccessPointPosition,
      { "sFNSFN-GA-AccessPointPosition", "rnsap.sFNSFN_GA_AccessPointPosition",
        FT_NONE, BASE_NONE, NULL, 0,
        "RequestedDataValue/sFNSFN-GA-AccessPointPosition", HFILL }},
    { &hf_rnsap_informationAvailable,
      { "informationAvailable", "rnsap.informationAvailable",
        FT_NONE, BASE_NONE, NULL, 0,
        "RequestedDataValueInformation/informationAvailable", HFILL }},
    { &hf_rnsap_informationNotAvailable,
      { "informationNotAvailable", "rnsap.informationNotAvailable",
        FT_NONE, BASE_NONE, NULL, 0,
        "RequestedDataValueInformation/informationNotAvailable", HFILL }},
    { &hf_rnsap_RL_Specific_DCH_Info_item,
      { "Item", "rnsap.RL_Specific_DCH_Info_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Specific-DCH-Info/_item", HFILL }},
    { &hf_rnsap_dCH_id,
      { "dCH-id", "rnsap.dCH_id",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RL-Specific-DCH-Info-Item/dCH-id", HFILL }},
    { &hf_rnsap_RL_Specific_EDCH_Information_item,
      { "Item", "rnsap.RL_Specific_EDCH_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RL-Specific-EDCH-Information/_item", HFILL }},
    { &hf_rnsap_uplinkRTLoadValue,
      { "uplinkRTLoadValue", "rnsap.uplinkRTLoadValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RTLoadValue/uplinkRTLoadValue", HFILL }},
    { &hf_rnsap_downlinkRTLoadValue,
      { "downlinkRTLoadValue", "rnsap.downlinkRTLoadValue",
        FT_UINT32, BASE_DEC, NULL, 0,
        "RTLoadValue/downlinkRTLoadValue", HFILL }},
    { &hf_rnsap_sAC,
      { "sAC", "rnsap.sAC",
        FT_BYTES, BASE_HEX, NULL, 0,
        "SAI/sAC", HFILL }},
    { &hf_rnsap_secondary_CCPCH_TDD_InformationList,
      { "secondary-CCPCH-TDD-InformationList", "rnsap.secondary_CCPCH_TDD_InformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Secondary-CCPCH-Info-TDD/secondary-CCPCH-TDD-InformationList", HFILL }},
    { &hf_rnsap_fACH_InformationList,
      { "fACH-InformationList", "rnsap.fACH_InformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_pCH_InformationList,
      { "pCH-InformationList", "rnsap.pCH_InformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_new_secondary_CPICH,
      { "new-secondary-CPICH", "rnsap.new_secondary_CPICH",
        FT_NONE, BASE_NONE, NULL, 0,
        "Secondary-CPICH-Information-Change/new-secondary-CPICH", HFILL }},
    { &hf_rnsap_secondary_CPICH_shall_not_be_used,
      { "secondary-CPICH-shall-not-be-used", "rnsap.secondary_CPICH_shall_not_be_used",
        FT_NONE, BASE_NONE, NULL, 0,
        "Secondary-CPICH-Information-Change/secondary-CPICH-shall-not-be-used", HFILL }},
    { &hf_rnsap_secondary_LCR_CCPCH_TDD_InformationList,
      { "secondary-LCR-CCPCH-TDD-InformationList", "rnsap.secondary_LCR_CCPCH_TDD_InformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Secondary-LCR-CCPCH-Info-TDD/secondary-LCR-CCPCH-TDD-InformationList", HFILL }},
    { &hf_rnsap_Secondary_CCPCH_TDD_InformationList_item,
      { "Item", "rnsap.Secondary_CCPCH_TDD_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Secondary-CCPCH-TDD-InformationList/_item", HFILL }},
    { &hf_rnsap_secondary_CCPCH_TDD_Code_Information,
      { "secondary-CCPCH-TDD-Code-Information", "rnsap.secondary_CCPCH_TDD_Code_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Secondary-CCPCH-TDD-InformationItem/secondary-CCPCH-TDD-Code-Information", HFILL }},
    { &hf_rnsap_tDD_PhysicalChannelOffset,
      { "tDD-PhysicalChannelOffset", "rnsap.tDD_PhysicalChannelOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_Secondary_LCR_CCPCH_TDD_InformationList_item,
      { "Item", "rnsap.Secondary_LCR_CCPCH_TDD_InformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Secondary-LCR-CCPCH-TDD-InformationList/_item", HFILL }},
    { &hf_rnsap_secondary_LCR_CCPCH_TDD_Code_Information,
      { "secondary-LCR-CCPCH-TDD-Code-Information", "rnsap.secondary_LCR_CCPCH_TDD_Code_Information",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Secondary-LCR-CCPCH-TDD-InformationItem/secondary-LCR-CCPCH-TDD-Code-Information", HFILL }},
    { &hf_rnsap_Secondary_CCPCH_TDD_Code_Information_item,
      { "Item", "rnsap.Secondary_CCPCH_TDD_Code_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Secondary-CCPCH-TDD-Code-Information/_item", HFILL }},
    { &hf_rnsap_Secondary_LCR_CCPCH_TDD_Code_Information_item,
      { "Item", "rnsap.Secondary_LCR_CCPCH_TDD_Code_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Secondary-LCR-CCPCH-TDD-Code-Information/_item", HFILL }},
    { &hf_rnsap_s_CCPCH_TimeSlotFormat_LCR,
      { "s-CCPCH-TimeSlotFormat-LCR", "rnsap.s_CCPCH_TimeSlotFormat_LCR",
        FT_UINT32, BASE_DEC, VALS(rnsap_TDD_DL_DPCH_TimeSlotFormat_LCR_vals), 0,
        "Secondary-LCR-CCPCH-TDD-Code-InformationItem/s-CCPCH-TimeSlotFormat-LCR", HFILL }},
    { &hf_rnsap_sFNSFNChangeLimit,
      { "sFNSFNChangeLimit", "rnsap.sFNSFNChangeLimit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SFNSFNMeasurementThresholdInformation/sFNSFNChangeLimit", HFILL }},
    { &hf_rnsap_predictedSFNSFNDeviationLimit,
      { "predictedSFNSFNDeviationLimit", "rnsap.predictedSFNSFNDeviationLimit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SFNSFNMeasurementThresholdInformation/predictedSFNSFNDeviationLimit", HFILL }},
    { &hf_rnsap_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation,
      { "successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation", "rnsap.successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SFNSFNMeasurementValueInformation/successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation", HFILL }},
    { &hf_rnsap_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item,
      { "Item", "rnsap.successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "SFNSFNMeasurementValueInformation/successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation/_item", HFILL }},
    { &hf_rnsap_sFNSFNValue,
      { "sFNSFNValue", "rnsap.sFNSFNValue",
        FT_UINT32, BASE_DEC, VALS(rnsap_SFNSFNValue_vals), 0,
        "SFNSFNMeasurementValueInformation/successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation/_item/sFNSFNValue", HFILL }},
    { &hf_rnsap_sFNSFNQuality,
      { "sFNSFNQuality", "rnsap.sFNSFNQuality",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SFNSFNMeasurementValueInformation/successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation/_item/sFNSFNQuality", HFILL }},
    { &hf_rnsap_sFNSFNDriftRate,
      { "sFNSFNDriftRate", "rnsap.sFNSFNDriftRate",
        FT_INT32, BASE_DEC, NULL, 0,
        "SFNSFNMeasurementValueInformation/successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation/_item/sFNSFNDriftRate", HFILL }},
    { &hf_rnsap_sFNSFNDriftRateQuality,
      { "sFNSFNDriftRateQuality", "rnsap.sFNSFNDriftRateQuality",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SFNSFNMeasurementValueInformation/successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation/_item/sFNSFNDriftRateQuality", HFILL }},
    { &hf_rnsap_sFNSFNTimeStampInformation,
      { "sFNSFNTimeStampInformation", "rnsap.sFNSFNTimeStampInformation",
        FT_UINT32, BASE_DEC, VALS(rnsap_SFNSFNTimeStampInformation_vals), 0,
        "SFNSFNMeasurementValueInformation/successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation/_item/sFNSFNTimeStampInformation", HFILL }},
    { &hf_rnsap_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation,
      { "unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation", "rnsap.unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SFNSFNMeasurementValueInformation/unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation", HFILL }},
    { &hf_rnsap_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item,
      { "Item", "rnsap.unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "SFNSFNMeasurementValueInformation/unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation/_item", HFILL }},
    { &hf_rnsap_sFNSFNTimeStamp_FDD,
      { "sFNSFNTimeStamp-FDD", "rnsap.sFNSFNTimeStamp_FDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SFNSFNTimeStampInformation/sFNSFNTimeStamp-FDD", HFILL }},
    { &hf_rnsap_sFNSFNTimeStamp_TDD,
      { "sFNSFNTimeStamp-TDD", "rnsap.sFNSFNTimeStamp_TDD",
        FT_NONE, BASE_NONE, NULL, 0,
        "SFNSFNTimeStampInformation/sFNSFNTimeStamp-TDD", HFILL }},
    { &hf_rnsap_sFN,
      { "sFN", "rnsap.sFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SFNSFNTimeStamp-TDD/sFN", HFILL }},
    { &hf_rnsap_sFNSFN_FDD,
      { "sFNSFN-FDD", "rnsap.sFNSFN_FDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SFNSFNValue/sFNSFN-FDD", HFILL }},
    { &hf_rnsap_sFNSFN_TDD,
      { "sFNSFN-TDD", "rnsap.sFNSFN_TDD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SFNSFNValue/sFNSFN-TDD", HFILL }},
    { &hf_rnsap_listOfSNAs,
      { "listOfSNAs", "rnsap.listOfSNAs",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SNA-Information/listOfSNAs", HFILL }},
    { &hf_rnsap_ListOfSNAs_item,
      { "Item", "rnsap.ListOfSNAs_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ListOfSNAs/_item", HFILL }},
    { &hf_rnsap_sRNTI_BitMaskIndex,
      { "sRNTI-BitMaskIndex", "rnsap.sRNTI_BitMaskIndex",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_sRNTI_BitMaskIndex_vals), 0,
        "S-RNTI-Group/sRNTI-BitMaskIndex", HFILL }},
    { &hf_rnsap_n_INSYNC_IND,
      { "n-INSYNC-IND", "rnsap.n_INSYNC_IND",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SynchronisationConfiguration/n-INSYNC-IND", HFILL }},
    { &hf_rnsap_n_OUTSYNC_IND,
      { "n-OUTSYNC-IND", "rnsap.n_OUTSYNC_IND",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SynchronisationConfiguration/n-OUTSYNC-IND", HFILL }},
    { &hf_rnsap_t_RLFAILURE,
      { "t-RLFAILURE", "rnsap.t_RLFAILURE",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SynchronisationConfiguration/t-RLFAILURE", HFILL }},
    { &hf_rnsap_maxSYNC_UL_transmissions,
      { "maxSYNC-UL-transmissions", "rnsap.maxSYNC_UL_transmissions",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_maxSYNC_UL_transmissions_vals), 0,
        "SYNC-UL-ProcParameters/maxSYNC-UL-transmissions", HFILL }},
    { &hf_rnsap_powerRampStep,
      { "powerRampStep", "rnsap.powerRampStep",
        FT_UINT32, BASE_DEC, NULL, 0,
        "SYNC-UL-ProcParameters/powerRampStep", HFILL }},
    { &hf_rnsap_modulation,
      { "modulation", "rnsap.modulation",
        FT_UINT32, BASE_DEC, VALS(rnsap_Modulation_vals), 0,
        "TDD-ChannelisationCodeLCR/modulation", HFILL }},
    { &hf_rnsap_TDD_DCHs_to_Modify_item,
      { "Item", "rnsap.TDD_DCHs_to_Modify_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TDD-DCHs-to-Modify/_item", HFILL }},
    { &hf_rnsap_dCH_SpecificInformationList3,
      { "dCH-SpecificInformationList", "rnsap.dCH_SpecificInformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TDD-DCHs-to-ModifyItem/dCH-SpecificInformationList", HFILL }},
    { &hf_rnsap_TDD_DCHs_to_ModifySpecificInformationList_item,
      { "Item", "rnsap.TDD_DCHs_to_ModifySpecificInformationList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TDD-DCHs-to-ModifySpecificInformationList/_item", HFILL }},
    { &hf_rnsap_ul_CCTrCH_ID,
      { "ul-CCTrCH-ID", "rnsap.ul_CCTrCH_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_dl_CCTrCH_ID,
      { "dl-CCTrCH-ID", "rnsap.dl_CCTrCH_ID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TDD-DCHs-to-ModifySpecificItem/dl-CCTrCH-ID", HFILL }},
    { &hf_rnsap_TDD_DL_Code_Information_item,
      { "Item", "rnsap.TDD_DL_Code_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TDD-DL-Code-Information/_item", HFILL }},
    { &hf_rnsap_TDD_DL_Code_LCR_Information_item,
      { "Item", "rnsap.TDD_DL_Code_LCR_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TDD-DL-Code-LCR-Information/_item", HFILL }},
    { &hf_rnsap_tdd_ChannelisationCodeLCR,
      { "tdd-ChannelisationCodeLCR", "rnsap.tdd_ChannelisationCodeLCR",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tdd_DL_DPCH_TimeSlotFormat_LCR,
      { "tdd-DL-DPCH-TimeSlotFormat-LCR", "rnsap.tdd_DL_DPCH_TimeSlotFormat_LCR",
        FT_UINT32, BASE_DEC, VALS(rnsap_TDD_DL_DPCH_TimeSlotFormat_LCR_vals), 0,
        "TDD-DL-Code-LCR-InformationItem/tdd-DL-DPCH-TimeSlotFormat-LCR", HFILL }},
    { &hf_rnsap_qPSK,
      { "qPSK", "rnsap.qPSK",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TDD-DL-DPCH-TimeSlotFormat-LCR/qPSK", HFILL }},
    { &hf_rnsap_eightPSK,
      { "eightPSK", "rnsap.eightPSK",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TDD-DL-DPCH-TimeSlotFormat-LCR/eightPSK", HFILL }},
    { &hf_rnsap_initialOffset,
      { "initialOffset", "rnsap.initialOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TDD-DPCHOffset/initialOffset", HFILL }},
    { &hf_rnsap_noinitialOffset,
      { "noinitialOffset", "rnsap.noinitialOffset",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TDD-DPCHOffset/noinitialOffset", HFILL }},
    { &hf_rnsap_TDD_UL_Code_Information_item,
      { "Item", "rnsap.TDD_UL_Code_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TDD-UL-Code-Information/_item", HFILL }},
    { &hf_rnsap_TDD_UL_Code_LCR_Information_item,
      { "Item", "rnsap.TDD_UL_Code_LCR_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TDD-UL-Code-LCR-Information/_item", HFILL }},
    { &hf_rnsap_tdd_UL_DPCH_TimeSlotFormat_LCR,
      { "tdd-UL-DPCH-TimeSlotFormat-LCR", "rnsap.tdd_UL_DPCH_TimeSlotFormat_LCR",
        FT_UINT32, BASE_DEC, VALS(rnsap_TDD_UL_DPCH_TimeSlotFormat_LCR_vals), 0,
        "TDD-UL-Code-LCR-InformationItem/tdd-UL-DPCH-TimeSlotFormat-LCR", HFILL }},
    { &hf_rnsap_qPSK1,
      { "qPSK", "rnsap.qPSK",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TDD-UL-DPCH-TimeSlotFormat-LCR/qPSK", HFILL }},
    { &hf_rnsap_eightPSK1,
      { "eightPSK", "rnsap.eightPSK",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TDD-UL-DPCH-TimeSlotFormat-LCR/eightPSK", HFILL }},
    { &hf_rnsap_plmn_id,
      { "plmn-id", "rnsap.plmn_id",
        FT_BYTES, BASE_HEX, NULL, 0,
        "TMGI/plmn-id", HFILL }},
    { &hf_rnsap_service_id,
      { "service-id", "rnsap.service_id",
        FT_BYTES, BASE_HEX, NULL, 0,
        "TMGI/service-id", HFILL }},
    { &hf_rnsap_dsField,
      { "dsField", "rnsap.dsField",
        FT_BYTES, BASE_HEX, NULL, 0,
        "TnlQos/dsField", HFILL }},
    { &hf_rnsap_genericTrafficCategory,
      { "genericTrafficCategory", "rnsap.genericTrafficCategory",
        FT_BYTES, BASE_HEX, NULL, 0,
        "TnlQos/genericTrafficCategory", HFILL }},
    { &hf_rnsap_Transmission_Gap_Pattern_Sequence_Information_item,
      { "Item", "rnsap.Transmission_Gap_Pattern_Sequence_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item", HFILL }},
    { &hf_rnsap_tGPSID,
      { "tGPSID", "rnsap.tGPSID",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tGSN,
      { "tGSN", "rnsap.tGSN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/tGSN", HFILL }},
    { &hf_rnsap_tGL1,
      { "tGL1", "rnsap.tGL1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/tGL1", HFILL }},
    { &hf_rnsap_tGL2,
      { "tGL2", "rnsap.tGL2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/tGL2", HFILL }},
    { &hf_rnsap_tGD,
      { "tGD", "rnsap.tGD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/tGD", HFILL }},
    { &hf_rnsap_tGPL1,
      { "tGPL1", "rnsap.tGPL1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/tGPL1", HFILL }},
    { &hf_rnsap_not_to_be_used_1,
      { "not-to-be-used-1", "rnsap.not_to_be_used_1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/not-to-be-used-1", HFILL }},
    { &hf_rnsap_uL_DL_mode,
      { "uL-DL-mode", "rnsap.uL_DL_mode",
        FT_UINT32, BASE_DEC, VALS(rnsap_UL_DL_mode_vals), 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/uL-DL-mode", HFILL }},
    { &hf_rnsap_downlink_Compressed_Mode_Method,
      { "downlink-Compressed-Mode-Method", "rnsap.downlink_Compressed_Mode_Method",
        FT_UINT32, BASE_DEC, VALS(rnsap_Downlink_Compressed_Mode_Method_vals), 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/downlink-Compressed-Mode-Method", HFILL }},
    { &hf_rnsap_uplink_Compressed_Mode_Method,
      { "uplink-Compressed-Mode-Method", "rnsap.uplink_Compressed_Mode_Method",
        FT_UINT32, BASE_DEC, VALS(rnsap_Uplink_Compressed_Mode_Method_vals), 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/uplink-Compressed-Mode-Method", HFILL }},
    { &hf_rnsap_dL_FrameType,
      { "dL-FrameType", "rnsap.dL_FrameType",
        FT_UINT32, BASE_DEC, VALS(rnsap_DL_FrameType_vals), 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/dL-FrameType", HFILL }},
    { &hf_rnsap_delta_SIR1,
      { "delta-SIR1", "rnsap.delta_SIR1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/delta-SIR1", HFILL }},
    { &hf_rnsap_delta_SIR_after1,
      { "delta-SIR-after1", "rnsap.delta_SIR_after1",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/delta-SIR-after1", HFILL }},
    { &hf_rnsap_delta_SIR2,
      { "delta-SIR2", "rnsap.delta_SIR2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/delta-SIR2", HFILL }},
    { &hf_rnsap_delta_SIR_after2,
      { "delta-SIR-after2", "rnsap.delta_SIR_after2",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Information/_item/delta-SIR-after2", HFILL }},
    { &hf_rnsap_Transmission_Gap_Pattern_Sequence_Status_List_item,
      { "Item", "rnsap.Transmission_Gap_Pattern_Sequence_Status_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Status-List/_item", HFILL }},
    { &hf_rnsap_tGPRC,
      { "tGPRC", "rnsap.tGPRC",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Status-List/_item/tGPRC", HFILL }},
    { &hf_rnsap_tGCFN,
      { "tGCFN", "rnsap.tGCFN",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Transmission-Gap-Pattern-Sequence-Status-List/_item/tGCFN", HFILL }},
    { &hf_rnsap_ms_part,
      { "ms-part", "rnsap.ms_part",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TUTRANGPS/ms-part", HFILL }},
    { &hf_rnsap_ls_part,
      { "ls-part", "rnsap.ls_part",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TUTRANGPS/ls-part", HFILL }},
    { &hf_rnsap_tUTRANGPSChangeLimit,
      { "tUTRANGPSChangeLimit", "rnsap.tUTRANGPSChangeLimit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TUTRANGPSMeasurementThresholdInformation/tUTRANGPSChangeLimit", HFILL }},
    { &hf_rnsap_predictedTUTRANGPSDeviationLimit,
      { "predictedTUTRANGPSDeviationLimit", "rnsap.predictedTUTRANGPSDeviationLimit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TUTRANGPSMeasurementThresholdInformation/predictedTUTRANGPSDeviationLimit", HFILL }},
    { &hf_rnsap_tUTRANGPS,
      { "tUTRANGPS", "rnsap.tUTRANGPS",
        FT_NONE, BASE_NONE, NULL, 0,
        "TUTRANGPSMeasurementValueInformation/tUTRANGPS", HFILL }},
    { &hf_rnsap_tUTRANGPSQuality,
      { "tUTRANGPSQuality", "rnsap.tUTRANGPSQuality",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TUTRANGPSMeasurementValueInformation/tUTRANGPSQuality", HFILL }},
    { &hf_rnsap_tUTRANGPSDriftRate,
      { "tUTRANGPSDriftRate", "rnsap.tUTRANGPSDriftRate",
        FT_INT32, BASE_DEC, NULL, 0,
        "TUTRANGPSMeasurementValueInformation/tUTRANGPSDriftRate", HFILL }},
    { &hf_rnsap_tUTRANGPSDriftRateQuality,
      { "tUTRANGPSDriftRateQuality", "rnsap.tUTRANGPSDriftRateQuality",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TUTRANGPSMeasurementValueInformation/tUTRANGPSDriftRateQuality", HFILL }},
    { &hf_rnsap_iEe_Extensions,
      { "iEe-Extensions", "rnsap.iEe_Extensions",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TUTRANGPSMeasurementValueInformation/iEe-Extensions", HFILL }},
    { &hf_rnsap_signalledGainFactors,
      { "signalledGainFactors", "rnsap.signalledGainFactors",
        FT_NONE, BASE_NONE, NULL, 0,
        "TransportFormatCombination-Beta/signalledGainFactors", HFILL }},
    { &hf_rnsap_betaC,
      { "betaC", "rnsap.betaC",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TransportFormatCombination-Beta/signalledGainFactors/betaC", HFILL }},
    { &hf_rnsap_betaD,
      { "betaD", "rnsap.betaD",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TransportFormatCombination-Beta/signalledGainFactors/betaD", HFILL }},
    { &hf_rnsap_refTFCNumber,
      { "refTFCNumber", "rnsap.refTFCNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_tFCSvalues,
      { "tFCSvalues", "rnsap.tFCSvalues",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_tFCSvalues_vals), 0,
        "TFCS/tFCSvalues", HFILL }},
    { &hf_rnsap_no_Split_in_TFCI,
      { "no-Split-in-TFCI", "rnsap.no_Split_in_TFCI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TFCS/tFCSvalues/no-Split-in-TFCI", HFILL }},
    { &hf_rnsap_not_Used_split_in_TFCI,
      { "not-Used-split-in-TFCI", "rnsap.not_Used_split_in_TFCI",
        FT_NONE, BASE_NONE, NULL, 0,
        "TFCS/tFCSvalues/not-Used-split-in-TFCI", HFILL }},
    { &hf_rnsap_TFCS_TFCSList_item,
      { "Item", "rnsap.TFCS_TFCSList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TFCS-TFCSList/_item", HFILL }},
    { &hf_rnsap_cTFC,
      { "cTFC", "rnsap.cTFC",
        FT_UINT32, BASE_DEC, VALS(rnsap_TFCS_CTFC_vals), 0,
        "TFCS-TFCSList/_item/cTFC", HFILL }},
    { &hf_rnsap_tFC_Beta,
      { "tFC-Beta", "rnsap.tFC_Beta",
        FT_UINT32, BASE_DEC, VALS(rnsap_TransportFormatCombination_Beta_vals), 0,
        "TFCS-TFCSList/_item/tFC-Beta", HFILL }},
    { &hf_rnsap_ctfc2bit,
      { "ctfc2bit", "rnsap.ctfc2bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TFCS-CTFC/ctfc2bit", HFILL }},
    { &hf_rnsap_ctfc4bit,
      { "ctfc4bit", "rnsap.ctfc4bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TFCS-CTFC/ctfc4bit", HFILL }},
    { &hf_rnsap_ctfc6bit,
      { "ctfc6bit", "rnsap.ctfc6bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TFCS-CTFC/ctfc6bit", HFILL }},
    { &hf_rnsap_ctfc8bit,
      { "ctfc8bit", "rnsap.ctfc8bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TFCS-CTFC/ctfc8bit", HFILL }},
    { &hf_rnsap_ctfc12bit,
      { "ctfc12bit", "rnsap.ctfc12bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TFCS-CTFC/ctfc12bit", HFILL }},
    { &hf_rnsap_ctfc16bit,
      { "ctfc16bit", "rnsap.ctfc16bit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TFCS-CTFC/ctfc16bit", HFILL }},
    { &hf_rnsap_ctfcmaxbit,
      { "ctfcmaxbit", "rnsap.ctfcmaxbit",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TFCS-CTFC/ctfcmaxbit", HFILL }},
    { &hf_rnsap_dynamicParts,
      { "dynamicParts", "rnsap.dynamicParts",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TransportFormatSet/dynamicParts", HFILL }},
    { &hf_rnsap_semi_staticPart,
      { "semi-staticPart", "rnsap.semi_staticPart",
        FT_NONE, BASE_NONE, NULL, 0,
        "TransportFormatSet/semi-staticPart", HFILL }},
    { &hf_rnsap_TransportFormatSet_DynamicPartList_item,
      { "Item", "rnsap.TransportFormatSet_DynamicPartList_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TransportFormatSet-DynamicPartList/_item", HFILL }},
    { &hf_rnsap_nrOfTransportBlocks,
      { "nrOfTransportBlocks", "rnsap.nrOfTransportBlocks",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TransportFormatSet-DynamicPartList/_item/nrOfTransportBlocks", HFILL }},
    { &hf_rnsap_transportBlockSize,
      { "transportBlockSize", "rnsap.transportBlockSize",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TransportFormatSet-DynamicPartList/_item/transportBlockSize", HFILL }},
    { &hf_rnsap_mode,
      { "mode", "rnsap.mode",
        FT_UINT32, BASE_DEC, VALS(rnsap_TransportFormatSet_ModeDP_vals), 0,
        "TransportFormatSet-DynamicPartList/_item/mode", HFILL }},
    { &hf_rnsap_tdd,
      { "tdd", "rnsap.tdd",
        FT_NONE, BASE_NONE, NULL, 0,
        "TransportFormatSet-ModeDP/tdd", HFILL }},
    { &hf_rnsap_notApplicable,
      { "notApplicable", "rnsap.notApplicable",
        FT_NONE, BASE_NONE, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_transmissionTimeIntervalInformation,
      { "transmissionTimeIntervalInformation", "rnsap.transmissionTimeIntervalInformation",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TDD-TransportFormatSet-ModeDP/transmissionTimeIntervalInformation", HFILL }},
    { &hf_rnsap_TransmissionTimeIntervalInformation_item,
      { "Item", "rnsap.TransmissionTimeIntervalInformation_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "TransmissionTimeIntervalInformation/_item", HFILL }},
    { &hf_rnsap_transmissionTimeInterval,
      { "transmissionTimeInterval", "rnsap.transmissionTimeInterval",
        FT_UINT32, BASE_DEC, VALS(rnsap_TransmissionTimeIntervalDynamic_vals), 0,
        "TransmissionTimeIntervalInformation/_item/transmissionTimeInterval", HFILL }},
    { &hf_rnsap_transmissionTime,
      { "transmissionTime", "rnsap.transmissionTime",
        FT_UINT32, BASE_DEC, VALS(rnsap_TransmissionTimeIntervalSemiStatic_vals), 0,
        "TransportFormatSet-Semi-staticPart/transmissionTime", HFILL }},
    { &hf_rnsap_channelCoding,
      { "channelCoding", "rnsap.channelCoding",
        FT_UINT32, BASE_DEC, VALS(rnsap_ChannelCodingType_vals), 0,
        "TransportFormatSet-Semi-staticPart/channelCoding", HFILL }},
    { &hf_rnsap_codingRate,
      { "codingRate", "rnsap.codingRate",
        FT_UINT32, BASE_DEC, VALS(rnsap_CodingRate_vals), 0,
        "TransportFormatSet-Semi-staticPart/codingRate", HFILL }},
    { &hf_rnsap_rateMatcingAttribute,
      { "rateMatcingAttribute", "rnsap.rateMatcingAttribute",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TransportFormatSet-Semi-staticPart/rateMatcingAttribute", HFILL }},
    { &hf_rnsap_cRC_Size,
      { "cRC-Size", "rnsap.cRC_Size",
        FT_UINT32, BASE_DEC, VALS(rnsap_CRC_Size_vals), 0,
        "TransportFormatSet-Semi-staticPart/cRC-Size", HFILL }},
    { &hf_rnsap_mode1,
      { "mode", "rnsap.mode",
        FT_UINT32, BASE_DEC, VALS(rnsap_TransportFormatSet_ModeSSP_vals), 0,
        "TransportFormatSet-Semi-staticPart/mode", HFILL }},
    { &hf_rnsap_tdd1,
      { "tdd", "rnsap.tdd",
        FT_UINT32, BASE_DEC, VALS(rnsap_SecondInterleavingMode_vals), 0,
        "TransportFormatSet-ModeSSP/tdd", HFILL }},
    { &hf_rnsap_hSDSCH_Physical_Layer_Category,
      { "hSDSCH-Physical-Layer-Category", "rnsap.hSDSCH_Physical_Layer_Category",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UE-Capabilities-Info/hSDSCH-Physical-Layer-Category", HFILL }},
    { &hf_rnsap_imei,
      { "imei", "rnsap.imei",
        FT_BYTES, BASE_HEX, NULL, 0,
        "UEIdentity/imei", HFILL }},
    { &hf_rnsap_imeisv,
      { "imeisv", "rnsap.imeisv",
        FT_BYTES, BASE_HEX, NULL, 0,
        "UEIdentity/imeisv", HFILL }},
    { &hf_rnsap_periodic2,
      { "periodic", "rnsap.periodic",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementReportCharacteristics/periodic", HFILL }},
    { &hf_rnsap_event1h,
      { "event1h", "rnsap.event1h",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementReportCharacteristics/event1h", HFILL }},
    { &hf_rnsap_event1i,
      { "event1i", "rnsap.event1i",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementReportCharacteristics/event1i", HFILL }},
    { &hf_rnsap_event6a,
      { "event6a", "rnsap.event6a",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementReportCharacteristics/event6a", HFILL }},
    { &hf_rnsap_event6b,
      { "event6b", "rnsap.event6b",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementReportCharacteristics/event6b", HFILL }},
    { &hf_rnsap_event6c,
      { "event6c", "rnsap.event6c",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementReportCharacteristics/event6c", HFILL }},
    { &hf_rnsap_event6d,
      { "event6d", "rnsap.event6d",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementReportCharacteristics/event6d", HFILL }},
    { &hf_rnsap_extension_ReportCharacteristics1,
      { "extension-ReportCharacteristics", "rnsap.extension_ReportCharacteristics",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementReportCharacteristics/extension-ReportCharacteristics", HFILL }},
    { &hf_rnsap_uEMeasurementTreshold,
      { "uEMeasurementTreshold", "rnsap.uEMeasurementTreshold",
        FT_UINT32, BASE_DEC, VALS(rnsap_UEMeasurementThreshold_vals), 0,
        "", HFILL }},
    { &hf_rnsap_uEMeasurementTimeToTrigger,
      { "uEMeasurementTimeToTrigger", "rnsap.uEMeasurementTimeToTrigger",
        FT_UINT32, BASE_DEC, VALS(rnsap_UEMeasurementTimeToTrigger_vals), 0,
        "", HFILL }},
    { &hf_rnsap_uEMeasurementHysteresisTime,
      { "uEMeasurementHysteresisTime", "rnsap.uEMeasurementHysteresisTime",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_amountofReporting,
      { "amountofReporting", "rnsap.amountofReporting",
        FT_UINT32, BASE_DEC, VALS(rnsap_UEMeasurementReportCharacteristicsPeriodicAmountofReporting_vals), 0,
        "UEMeasurementReportCharacteristicsPeriodic/amountofReporting", HFILL }},
    { &hf_rnsap_reportingInterval,
      { "reportingInterval", "rnsap.reportingInterval",
        FT_UINT32, BASE_DEC, VALS(rnsap_UEMeasurementReportCharacteristicsPeriodicReportingInterval_vals), 0,
        "UEMeasurementReportCharacteristicsPeriodic/reportingInterval", HFILL }},
    { &hf_rnsap_timeslotISCP,
      { "timeslotISCP", "rnsap.timeslotISCP",
        FT_INT32, BASE_DEC, NULL, 0,
        "UEMeasurementThreshold/timeslotISCP", HFILL }},
    { &hf_rnsap_uETransmitPower,
      { "uETransmitPower", "rnsap.uETransmitPower",
        FT_INT32, BASE_DEC, NULL, 0,
        "UEMeasurementThreshold/uETransmitPower", HFILL }},
    { &hf_rnsap_extension_UEMeasurementThreshold,
      { "extension-UEMeasurementThreshold", "rnsap.extension_UEMeasurementThreshold",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementThreshold/extension-UEMeasurementThreshold", HFILL }},
    { &hf_rnsap_UEMeasurementTimeslotInfoHCR_item,
      { "Item", "rnsap.UEMeasurementTimeslotInfoHCR_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementTimeslotInfoHCR/_item", HFILL }},
    { &hf_rnsap_burstType,
      { "burstType", "rnsap.burstType",
        FT_UINT32, BASE_DEC, VALS(rnsap_UEMeasurementTimeslotInfoHCRBurstType_vals), 0,
        "UEMeasurementTimeslotInfoHCR-IEs/burstType", HFILL }},
    { &hf_rnsap_UEMeasurementTimeslotInfoLCR_item,
      { "Item", "rnsap.UEMeasurementTimeslotInfoLCR_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementTimeslotInfoLCR/_item", HFILL }},
    { &hf_rnsap_timeSlot1,
      { "timeSlot", "rnsap.timeSlot",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UEMeasurementTimeslotInfoLCR-IEs/timeSlot", HFILL }},
    { &hf_rnsap_uE_Transmitted_Power,
      { "uE-Transmitted-Power", "rnsap.uE_Transmitted_Power",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementValue/uE-Transmitted-Power", HFILL }},
    { &hf_rnsap_primary_CCPCH_RSCP,
      { "primary-CCPCH-RSCP", "rnsap.primary_CCPCH_RSCP",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementValue/primary-CCPCH-RSCP", HFILL }},
    { &hf_rnsap_dL_Timeslot_ISCP,
      { "dL-Timeslot-ISCP", "rnsap.dL_Timeslot_ISCP",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementValue/dL-Timeslot-ISCP", HFILL }},
    { &hf_rnsap_extension_UEMeasurementValue,
      { "extension-UEMeasurementValue", "rnsap.extension_UEMeasurementValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementValue/extension-UEMeasurementValue", HFILL }},
    { &hf_rnsap_uEMeasurementTransmittedPowerListHCR,
      { "uEMeasurementTransmittedPowerListHCR", "rnsap.uEMeasurementTransmittedPowerListHCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UE-MeasurementValue-UE-Transmitted-Power/uEMeasurementTransmittedPowerListHCR", HFILL }},
    { &hf_rnsap_uEMeasurementTransmittedPowerListLCR,
      { "uEMeasurementTransmittedPowerListLCR", "rnsap.uEMeasurementTransmittedPowerListLCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UE-MeasurementValue-UE-Transmitted-Power/uEMeasurementTransmittedPowerListLCR", HFILL }},
    { &hf_rnsap_UEMeasurementValueTransmittedPowerListHCR_item,
      { "Item", "rnsap.UEMeasurementValueTransmittedPowerListHCR_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementValueTransmittedPowerListHCR/_item", HFILL }},
    { &hf_rnsap_uETransmitPower1,
      { "uETransmitPower", "rnsap.uETransmitPower",
        FT_UINT32, BASE_DEC, NULL, 0,
        "", HFILL }},
    { &hf_rnsap_UEMeasurementValueTransmittedPowerListLCR_item,
      { "Item", "rnsap.UEMeasurementValueTransmittedPowerListLCR_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementValueTransmittedPowerListLCR/_item", HFILL }},
    { &hf_rnsap_primaryCCPCH_RSCP_Delta,
      { "primaryCCPCH-RSCP-Delta", "rnsap.primaryCCPCH_RSCP_Delta",
        FT_INT32, BASE_DEC, NULL, 0,
        "UE-MeasurementValue-Primary-CCPCH-RSCP/primaryCCPCH-RSCP-Delta", HFILL }},
    { &hf_rnsap_uEMeasurementTimeslotISCPListHCR,
      { "uEMeasurementTimeslotISCPListHCR", "rnsap.uEMeasurementTimeslotISCPListHCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UE-MeasurementValue-DL-Timeslot-ISCP/uEMeasurementTimeslotISCPListHCR", HFILL }},
    { &hf_rnsap_uEMeasurementTimeslotISCPListLCR,
      { "uEMeasurementTimeslotISCPListLCR", "rnsap.uEMeasurementTimeslotISCPListLCR",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UE-MeasurementValue-DL-Timeslot-ISCP/uEMeasurementTimeslotISCPListLCR", HFILL }},
    { &hf_rnsap_UEMeasurementValueTimeslotISCPListHCR_item,
      { "Item", "rnsap.UEMeasurementValueTimeslotISCPListHCR_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementValueTimeslotISCPListHCR/_item", HFILL }},
    { &hf_rnsap_UEMeasurementValueTimeslotISCPListLCR_item,
      { "Item", "rnsap.UEMeasurementValueTimeslotISCPListLCR_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementValueTimeslotISCPListLCR/_item", HFILL }},
    { &hf_rnsap_measurementAvailable2,
      { "measurementAvailable", "rnsap.measurementAvailable",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementValueInformation/measurementAvailable", HFILL }},
    { &hf_rnsap_measurementnotAvailable2,
      { "measurementnotAvailable", "rnsap.measurementnotAvailable",
        FT_NONE, BASE_NONE, NULL, 0,
        "UEMeasurementValueInformation/measurementnotAvailable", HFILL }},
    { &hf_rnsap_uEmeasurementValue,
      { "uEmeasurementValue", "rnsap.uEmeasurementValue",
        FT_UINT32, BASE_DEC, VALS(rnsap_UEMeasurementValue_vals), 0,
        "UEMeasurementValueInformationAvailable/uEmeasurementValue", HFILL }},
    { &hf_rnsap_cell_fach_pch,
      { "cell-fach-pch", "rnsap.cell_fach_pch",
        FT_NONE, BASE_NONE, NULL, 0,
        "UE-State/cell-fach-pch", HFILL }},
    { &hf_rnsap_ura_pch,
      { "ura-pch", "rnsap.ura_pch",
        FT_NONE, BASE_NONE, NULL, 0,
        "UE-State/ura-pch", HFILL }},
    { &hf_rnsap_d_RNTI,
      { "d-RNTI", "rnsap.d_RNTI",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Cell-Fach-Pch-State/d-RNTI", HFILL }},
    { &hf_rnsap_srnc_id,
      { "srnc-id", "rnsap.srnc_id",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Ura-Pch-State/srnc-id", HFILL }},
    { &hf_rnsap_ura_id,
      { "ura-id", "rnsap.ura_id",
        FT_UINT32, BASE_DEC, NULL, 0,
        "Ura-Pch-State/ura-id", HFILL }},
    { &hf_rnsap_UL_Timeslot_Information_item,
      { "Item", "rnsap.UL_Timeslot_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-Timeslot-Information/_item", HFILL }},
    { &hf_rnsap_UL_TimeslotLCR_Information_item,
      { "Item", "rnsap.UL_TimeslotLCR_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-TimeslotLCR-Information/_item", HFILL }},
    { &hf_rnsap_uL_Code_LCR_InformationList,
      { "uL-Code-LCR-InformationList", "rnsap.uL_Code_LCR_InformationList",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-TimeslotLCR-InformationItem/uL-Code-LCR-InformationList", HFILL }},
    { &hf_rnsap_UL_TimeSlot_ISCP_Info_item,
      { "Item", "rnsap.UL_TimeSlot_ISCP_Info_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-TimeSlot-ISCP-Info/_item", HFILL }},
    { &hf_rnsap_uL_TimeslotISCP,
      { "uL-TimeslotISCP", "rnsap.uL_TimeslotISCP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-TimeSlot-ISCP-InfoItem/uL-TimeslotISCP", HFILL }},
    { &hf_rnsap_UL_TimeSlot_ISCP_LCR_Info_item,
      { "Item", "rnsap.UL_TimeSlot_ISCP_LCR_Info_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-TimeSlot-ISCP-LCR-Info/_item", HFILL }},
    { &hf_rnsap_iSCP,
      { "iSCP", "rnsap.iSCP",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-TimeSlot-ISCP-LCR-InfoItem/iSCP", HFILL }},
    { &hf_rnsap_sync_UL_codes_bitmap,
      { "sync-UL-codes-bitmap", "rnsap.sync_UL_codes_bitmap",
        FT_BYTES, BASE_HEX, NULL, 0,
        "UL-TimingAdvanceCtrl-LCR/sync-UL-codes-bitmap", HFILL }},
    { &hf_rnsap_fPACH_info,
      { "fPACH-info", "rnsap.fPACH_info",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-TimingAdvanceCtrl-LCR/fPACH-info", HFILL }},
    { &hf_rnsap_prxUpPCHdes,
      { "prxUpPCHdes", "rnsap.prxUpPCHdes",
        FT_INT32, BASE_DEC, NULL, 0,
        "UL-TimingAdvanceCtrl-LCR/prxUpPCHdes", HFILL }},
    { &hf_rnsap_syncUL_procParameter,
      { "syncUL-procParameter", "rnsap.syncUL_procParameter",
        FT_NONE, BASE_NONE, NULL, 0,
        "UL-TimingAdvanceCtrl-LCR/syncUL-procParameter", HFILL }},
    { &hf_rnsap_mMax,
      { "mMax", "rnsap.mMax",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-TimingAdvanceCtrl-LCR/mMax", HFILL }},
    { &hf_rnsap_ul_ScramblingCodeNumber,
      { "ul-ScramblingCodeNumber", "rnsap.ul_ScramblingCodeNumber",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-ScramblingCode/ul-ScramblingCodeNumber", HFILL }},
    { &hf_rnsap_ul_ScramblingCodeLength,
      { "ul-ScramblingCodeLength", "rnsap.ul_ScramblingCodeLength",
        FT_UINT32, BASE_DEC, VALS(rnsap_UL_ScramblingCodeLength_vals), 0,
        "UL-ScramblingCode/ul-ScramblingCodeLength", HFILL }},
    { &hf_rnsap_uL_Synchronisation_StepSize,
      { "uL-Synchronisation-StepSize", "rnsap.uL_Synchronisation_StepSize",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-Synchronisation-Parameters-LCR/uL-Synchronisation-StepSize", HFILL }},
    { &hf_rnsap_uL_Synchronisation_Frequency,
      { "uL-Synchronisation-Frequency", "rnsap.uL_Synchronisation_Frequency",
        FT_UINT32, BASE_DEC, NULL, 0,
        "UL-Synchronisation-Parameters-LCR/uL-Synchronisation-Frequency", HFILL }},
    { &hf_rnsap_multipleURAsIndicator,
      { "multipleURAsIndicator", "rnsap.multipleURAsIndicator",
        FT_UINT32, BASE_DEC, VALS(rnsap_MultipleURAsIndicator_vals), 0,
        "URA-Information/multipleURAsIndicator", HFILL }},
    { &hf_rnsap_rNCsWithCellsInTheAccessedURA_List,
      { "rNCsWithCellsInTheAccessedURA-List", "rnsap.rNCsWithCellsInTheAccessedURA_List",
        FT_UINT32, BASE_DEC, NULL, 0,
        "URA-Information/rNCsWithCellsInTheAccessedURA-List", HFILL }},
    { &hf_rnsap_RNCsWithCellsInTheAccessedURA_List_item,
      { "Item", "rnsap.RNCsWithCellsInTheAccessedURA_List_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "RNCsWithCellsInTheAccessedURA-List/_item", HFILL }},
    { &hf_rnsap_USCH_Information_item,
      { "Item", "rnsap.USCH_Information_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "USCH-Information/_item", HFILL }},
    { &hf_rnsap_local,
      { "local", "rnsap.local",
        FT_UINT32, BASE_DEC, NULL, 0,
        "PrivateIE-ID/local", HFILL }},
    { &hf_rnsap_global,
      { "global", "rnsap.global",
        FT_OID, BASE_NONE, NULL, 0,
        "PrivateIE-ID/global", HFILL }},
    { &hf_rnsap_procedureCode,
      { "procedureCode", "rnsap.procedureCode",
        FT_UINT32, BASE_DEC, VALS(rnsap_ProcedureCode_vals), 0,
        "ProcedureID/procedureCode", HFILL }},
    { &hf_rnsap_ddMode,
      { "ddMode", "rnsap.ddMode",
        FT_UINT32, BASE_DEC, VALS(rnsap_T_ddMode_vals), 0,
        "ProcedureID/ddMode", HFILL }},
    { &hf_rnsap_shortTransActionId,
      { "shortTransActionId", "rnsap.shortTransActionId",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TransactionID/shortTransActionId", HFILL }},
    { &hf_rnsap_longTransActionId,
      { "longTransActionId", "rnsap.longTransActionId",
        FT_UINT32, BASE_DEC, NULL, 0,
        "TransactionID/longTransActionId", HFILL }},
    { &hf_rnsap_ProtocolIE_Container_item,
      { "Item", "rnsap.ProtocolIE_Container_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "ProtocolIE-Container/_item", HFILL }},
    { &hf_rnsap_id,
      { "id", "rnsap.id",
        FT_UINT32, BASE_DEC, VALS(rnsap_ProtocolIE_ID_vals), 0,
        "", HFILL }},
    { &hf_rnsap_value,
      { "value", "rnsap.value",
        FT_NONE, BASE_NONE, NULL, 0,
        "ProtocolIE-Field/value", HFILL }},
    { &hf_rnsap_ProtocolIE_ContainerPair_item,
      { "Item", "rnsap.ProtocolIE_ContainerPair_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "ProtocolIE-ContainerPair/_item", HFILL }},
    { &hf_rnsap_firstCriticality,
      { "firstCriticality", "rnsap.firstCriticality",
        FT_UINT32, BASE_DEC, VALS(rnsap_Criticality_vals), 0,
        "ProtocolIE-FieldPair/firstCriticality", HFILL }},
    { &hf_rnsap_firstValue,
      { "firstValue", "rnsap.firstValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "ProtocolIE-FieldPair/firstValue", HFILL }},
    { &hf_rnsap_secondCriticality,
      { "secondCriticality", "rnsap.secondCriticality",
        FT_UINT32, BASE_DEC, VALS(rnsap_Criticality_vals), 0,
        "ProtocolIE-FieldPair/secondCriticality", HFILL }},
    { &hf_rnsap_secondValue,
      { "secondValue", "rnsap.secondValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "ProtocolIE-FieldPair/secondValue", HFILL }},
    { &hf_rnsap_ProtocolIE_ContainerList_item,
      { "Item", "rnsap.ProtocolIE_ContainerList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ProtocolIE-ContainerList/_item", HFILL }},
    { &hf_rnsap_ProtocolIE_ContainerPairList_item,
      { "Item", "rnsap.ProtocolIE_ContainerPairList_item",
        FT_UINT32, BASE_DEC, NULL, 0,
        "ProtocolIE-ContainerPairList/_item", HFILL }},
    { &hf_rnsap_ProtocolExtensionContainer_item,
      { "Item", "rnsap.ProtocolExtensionContainer_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "ProtocolExtensionContainer/_item", HFILL }},
    { &hf_rnsap_extensionValue,
      { "extensionValue", "rnsap.extensionValue",
        FT_NONE, BASE_NONE, NULL, 0,
        "ProtocolExtensionField/extensionValue", HFILL }},
    { &hf_rnsap_PrivateIE_Container_item,
      { "Item", "rnsap.PrivateIE_Container_item",
        FT_NONE, BASE_NONE, NULL, 0,
        "PrivateIE-Container/_item", HFILL }},
    { &hf_rnsap_privateIEid,
      { "privateIEid", "rnsap.privateIEid",
        FT_UINT32, BASE_DEC, VALS(rnsap_PrivateIE_ID_vals), 0,
        "PrivateIE-Field/privateIEid", HFILL }},
    { &hf_rnsap_privateIEvalue,
      { "privateIEvalue", "rnsap.privateIEvalue",
        FT_NONE, BASE_NONE, NULL, 0,
        "PrivateIE-Field/privateIEvalue", HFILL }},

/*--- End of included file: packet-rnsap-hfarr.c ---*/
#line 1324 "packet-rnsap-template.c"
  };

  /* List of subtrees */
  static gint *ett[] = {
		  &ett_rnsap,
		  &ett_rnsap_initiatingMessageValue,
		  &ett_rnsap_ProtocolIEValueValue,
		  &ett_rnsap_SuccessfulOutcomeValue,
		  &ett_rnsap_UnsuccessfulOutcomeValue,

/*--- Included file: packet-rnsap-ettarr.c ---*/
#line 1 "packet-rnsap-ettarr.c"
    &ett_rnsap_RNSAP_PDU,
    &ett_rnsap_InitiatingMessage,
    &ett_rnsap_SuccessfulOutcome,
    &ett_rnsap_UnsuccessfulOutcome,
    &ett_rnsap_Outcome,
    &ett_rnsap_DummyInitiatingValue,
    &ett_rnsap_DummySuccessfulOutcomeValue,
    &ett_rnsap_DummyUnSuccessfulOutcomeValue,
    &ett_rnsap_DummyProtocolIE,
    &ett_rnsap_RadioLinkSetupRequestFDD,
    &ett_rnsap_UL_DPCH_Information_RL_SetupRqstFDD,
    &ett_rnsap_DL_DPCH_Information_RL_SetupRqstFDD,
    &ett_rnsap_PowerOffsetInformation_RL_SetupRqstFDD,
    &ett_rnsap_RL_InformationList_RL_SetupRqstFDD,
    &ett_rnsap_RL_InformationItem_RL_SetupRqstFDD,
    &ett_rnsap_F_DPCH_Information_RL_SetupRqstFDD,
    &ett_rnsap_PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD,
    &ett_rnsap_RadioLinkSetupRequestTDD,
    &ett_rnsap_UL_Physical_Channel_Information_RL_SetupRqstTDD,
    &ett_rnsap_DL_Physical_Channel_Information_RL_SetupRqstTDD,
    &ett_rnsap_UL_CCTrCH_InformationList_RL_SetupRqstTDD,
    &ett_rnsap_UL_CCTrCH_InformationItem_RL_SetupRqstTDD,
    &ett_rnsap_DL_CCTrCH_InformationList_RL_SetupRqstTDD,
    &ett_rnsap_DL_CCTrCH_InformationItem_RL_SetupRqstTDD,
    &ett_rnsap_CCTrCH_TPCList_RL_SetupRqstTDD,
    &ett_rnsap_CCTrCH_TPCItem_RL_SetupRqstTDD,
    &ett_rnsap_RL_Information_RL_SetupRqstTDD,
    &ett_rnsap_RadioLinkSetupResponseFDD,
    &ett_rnsap_RL_InformationResponseList_RL_SetupRspFDD,
    &ett_rnsap_RL_InformationResponseItem_RL_SetupRspFDD,
    &ett_rnsap_DiversityIndication_RL_SetupRspFDD,
    &ett_rnsap_Combining_RL_SetupRspFDD,
    &ett_rnsap_NonCombiningOrFirstRL_RL_SetupRspFDD,
    &ett_rnsap_RadioLinkSetupResponseTDD,
    &ett_rnsap_RL_InformationResponse_RL_SetupRspTDD,
    &ett_rnsap_UL_CCTrCHInformationListIE_RL_SetupRspTDD,
    &ett_rnsap_UL_CCTrCHInformationItem_RL_SetupRspTDD,
    &ett_rnsap_UL_DPCH_InformationItem_RL_SetupRspTDD,
    &ett_rnsap_DL_CCTrCHInformationListIE_RL_SetupRspTDD,
    &ett_rnsap_DL_CCTrCHInformationItem_RL_SetupRspTDD,
    &ett_rnsap_DL_DPCH_InformationItem_RL_SetupRspTDD,
    &ett_rnsap_DSCH_InformationListIEs_RL_SetupRspTDD,
    &ett_rnsap_DSCHInformationItem_RL_SetupRspTDD,
    &ett_rnsap_USCH_InformationListIEs_RL_SetupRspTDD,
    &ett_rnsap_USCHInformationItem_RL_SetupRspTDD,
    &ett_rnsap_RL_LCR_InformationResponse_RL_SetupRspTDD,
    &ett_rnsap_UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD,
    &ett_rnsap_UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD,
    &ett_rnsap_UL_DPCH_LCR_InformationItem_RL_SetupRspTDD,
    &ett_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD,
    &ett_rnsap_DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD,
    &ett_rnsap_DL_DPCH_LCR_InformationItem_RL_SetupRspTDD,
    &ett_rnsap_DSCH_LCR_InformationListIEs_RL_SetupRspTDD,
    &ett_rnsap_DSCH_LCR_InformationItem_RL_SetupRspTDD,
    &ett_rnsap_USCH_LCR_InformationListIEs_RL_SetupRspTDD,
    &ett_rnsap_USCH_LCR_InformationItem_RL_SetupRspTDD,
    &ett_rnsap_RadioLinkSetupFailureFDD,
    &ett_rnsap_CauseLevel_RL_SetupFailureFDD,
    &ett_rnsap_GeneralCauseList_RL_SetupFailureFDD,
    &ett_rnsap_RLSpecificCauseList_RL_SetupFailureFDD,
    &ett_rnsap_UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD,
    &ett_rnsap_UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD,
    &ett_rnsap_SuccessfulRL_InformationResponseList_RL_SetupFailureFDD,
    &ett_rnsap_SuccessfulRL_InformationResponse_RL_SetupFailureFDD,
    &ett_rnsap_DiversityIndication_RL_SetupFailureFDD,
    &ett_rnsap_Combining_RL_SetupFailureFDD,
    &ett_rnsap_NonCombiningOrFirstRL_RL_SetupFailureFDD,
    &ett_rnsap_RadioLinkSetupFailureTDD,
    &ett_rnsap_CauseLevel_RL_SetupFailureTDD,
    &ett_rnsap_GeneralCauseList_RL_SetupFailureTDD,
    &ett_rnsap_RLSpecificCauseList_RL_SetupFailureTDD,
    &ett_rnsap_UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD,
    &ett_rnsap_RadioLinkAdditionRequestFDD,
    &ett_rnsap_RL_InformationList_RL_AdditionRqstFDD,
    &ett_rnsap_RL_Information_RL_AdditionRqstFDD,
    &ett_rnsap_RadioLinkAdditionRequestTDD,
    &ett_rnsap_RL_Information_RL_AdditionRqstTDD,
    &ett_rnsap_UL_CCTrCH_InformationList_RL_AdditionRqstTDD,
    &ett_rnsap_UL_CCTrCH_InformationItem_RL_AdditionRqstTDD,
    &ett_rnsap_DL_CCTrCH_InformationList_RL_AdditionRqstTDD,
    &ett_rnsap_DL_CCTrCH_InformationItem_RL_AdditionRqstTDD,
    &ett_rnsap_RadioLinkAdditionResponseFDD,
    &ett_rnsap_RL_InformationResponseList_RL_AdditionRspFDD,
    &ett_rnsap_RL_InformationResponseItem_RL_AdditionRspFDD,
    &ett_rnsap_DiversityIndication_RL_AdditionRspFDD,
    &ett_rnsap_Combining_RL_AdditionRspFDD,
    &ett_rnsap_NonCombining_RL_AdditionRspFDD,
    &ett_rnsap_RadioLinkAdditionResponseTDD,
    &ett_rnsap_RL_InformationResponse_RL_AdditionRspTDD,
    &ett_rnsap_UL_CCTrCHInformationListIE_RL_AdditionRspTDD,
    &ett_rnsap_UL_CCTrCHInformationItem_RL_AdditionRspTDD,
    &ett_rnsap_UL_DPCH_InformationItem_RL_AdditionRspTDD,
    &ett_rnsap_DL_CCTrCHInformationListIE_RL_AdditionRspTDD,
    &ett_rnsap_DL_CCTrCHInformationItem_RL_AdditionRspTDD,
    &ett_rnsap_DL_DPCH_InformationItem_RL_AdditionRspTDD,
    &ett_rnsap_DCH_Information_RL_AdditionRspTDD,
    &ett_rnsap_DiversityIndication_RL_AdditionRspTDD,
    &ett_rnsap_Combining_RL_AdditionRspTDD,
    &ett_rnsap_NonCombining_RL_AdditionRspTDD,
    &ett_rnsap_DSCH_InformationListIE_RL_AdditionRspTDD,
    &ett_rnsap_DSCHInformationItem_RL_AdditionRspTDD,
    &ett_rnsap_DiversityIndication_RL_AdditionRspTDD2,
    &ett_rnsap_USCH_InformationListIE_RL_AdditionRspTDD,
    &ett_rnsap_USCHInformationItem_RL_AdditionRspTDD,
    &ett_rnsap_RL_LCR_InformationResponse_RL_AdditionRspTDD,
    &ett_rnsap_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD,
    &ett_rnsap_UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD,
    &ett_rnsap_UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD,
    &ett_rnsap_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD,
    &ett_rnsap_DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD,
    &ett_rnsap_DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD,
    &ett_rnsap_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD,
    &ett_rnsap_DSCH_LCR_InformationItem_RL_AdditionRspTDD,
    &ett_rnsap_USCH_LCR_InformationListIEs_RL_AdditionRspTDD,
    &ett_rnsap_USCH_LCR_InformationItem_RL_AdditionRspTDD,
    &ett_rnsap_RadioLinkAdditionFailureFDD,
    &ett_rnsap_CauseLevel_RL_AdditionFailureFDD,
    &ett_rnsap_GeneralCauseList_RL_AdditionFailureFDD,
    &ett_rnsap_RLSpecificCauseList_RL_AdditionFailureFDD,
    &ett_rnsap_UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD,
    &ett_rnsap_UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD,
    &ett_rnsap_SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD,
    &ett_rnsap_SuccessfulRL_InformationResponse_RL_AdditionFailureFDD,
    &ett_rnsap_DiversityIndication_RL_AdditionFailureFDD,
    &ett_rnsap_Combining_RL_AdditionFailureFDD,
    &ett_rnsap_NonCombining_RL_AdditionFailureFDD,
    &ett_rnsap_RadioLinkAdditionFailureTDD,
    &ett_rnsap_CauseLevel_RL_AdditionFailureTDD,
    &ett_rnsap_GeneralCauseList_RL_AdditionFailureTDD,
    &ett_rnsap_RLSpecificCauseList_RL_AdditionFailureTDD,
    &ett_rnsap_UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD,
    &ett_rnsap_RadioLinkDeletionRequest,
    &ett_rnsap_RL_InformationList_RL_DeletionRqst,
    &ett_rnsap_RL_Information_RL_DeletionRqst,
    &ett_rnsap_RadioLinkDeletionResponse,
    &ett_rnsap_RadioLinkReconfigurationPrepareFDD,
    &ett_rnsap_UL_DPCH_Information_RL_ReconfPrepFDD,
    &ett_rnsap_DL_DPCH_Information_RL_ReconfPrepFDD,
    &ett_rnsap_DL_DPCH_Power_Information_RL_ReconfPrepFDD,
    &ett_rnsap_PowerOffsetInformation_RL_ReconfPrepFDD,
    &ett_rnsap_DCH_DeleteList_RL_ReconfPrepFDD,
    &ett_rnsap_DCH_DeleteItem_RL_ReconfPrepFDD,
    &ett_rnsap_RL_InformationList_RL_ReconfPrepFDD,
    &ett_rnsap_RL_Information_RL_ReconfPrepFDD,
    &ett_rnsap_F_DPCH_Information_RL_ReconfPrepFDD,
    &ett_rnsap_PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD,
    &ett_rnsap_RadioLinkReconfigurationPrepareTDD,
    &ett_rnsap_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
    &ett_rnsap_UL_CCTrCH_AddInformation_RL_ReconfPrepTDD,
    &ett_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD,
    &ett_rnsap_UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD,
    &ett_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD,
    &ett_rnsap_UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD,
    &ett_rnsap_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
    &ett_rnsap_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD,
    &ett_rnsap_CCTrCH_TPCAddList_RL_ReconfPrepTDD,
    &ett_rnsap_CCTrCH_TPCAddItem_RL_ReconfPrepTDD,
    &ett_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD,
    &ett_rnsap_DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD,
    &ett_rnsap_CCTrCH_TPCModifyList_RL_ReconfPrepTDD,
    &ett_rnsap_CCTrCH_TPCModifyItem_RL_ReconfPrepTDD,
    &ett_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD,
    &ett_rnsap_DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD,
    &ett_rnsap_DCH_DeleteList_RL_ReconfPrepTDD,
    &ett_rnsap_DCH_DeleteItem_RL_ReconfPrepTDD,
    &ett_rnsap_DSCH_ModifyList_RL_ReconfPrepTDD,
    &ett_rnsap_DSCH_ModifyItem_RL_ReconfPrepTDD,
    &ett_rnsap_DSCH_DeleteList_RL_ReconfPrepTDD,
    &ett_rnsap_DSCH_DeleteItem_RL_ReconfPrepTDD,
    &ett_rnsap_USCH_ModifyList_RL_ReconfPrepTDD,
    &ett_rnsap_USCH_ModifyItem_RL_ReconfPrepTDD,
    &ett_rnsap_USCH_DeleteList_RL_ReconfPrepTDD,
    &ett_rnsap_USCH_DeleteItem_RL_ReconfPrepTDD,
    &ett_rnsap_RL_Information_RL_ReconfPrepTDD,
    &ett_rnsap_RL_InformationIE_RL_ReconfPrepTDD,
    &ett_rnsap_RadioLinkReconfigurationReadyFDD,
    &ett_rnsap_RL_InformationResponseList_RL_ReconfReadyFDD,
    &ett_rnsap_RL_InformationResponseItem_RL_ReconfReadyFDD,
    &ett_rnsap_RadioLinkReconfigurationReadyTDD,
    &ett_rnsap_RL_InformationResponse_RL_ReconfReadyTDD,
    &ett_rnsap_UL_CCTrCHInformationListIE_RL_ReconfReadyTDD,
    &ett_rnsap_UL_CCTrCH_InformationItem_RL_ReconfReadyTDD,
    &ett_rnsap_UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD,
    &ett_rnsap_UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD,
    &ett_rnsap_UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD,
    &ett_rnsap_UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD,
    &ett_rnsap_UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD,
    &ett_rnsap_TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD,
    &ett_rnsap_TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD,
    &ett_rnsap_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD,
    &ett_rnsap_UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD,
    &ett_rnsap_TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD,
    &ett_rnsap_TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD,
    &ett_rnsap_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD,
    &ett_rnsap_UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD,
    &ett_rnsap_DL_CCTrCHInformationListIE_RL_ReconfReadyTDD,
    &ett_rnsap_DL_CCTrCH_InformationItem_RL_ReconfReadyTDD,
    &ett_rnsap_DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD,
    &ett_rnsap_DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD,
    &ett_rnsap_DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD,
    &ett_rnsap_DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD,
    &ett_rnsap_DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD,
    &ett_rnsap_TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD,
    &ett_rnsap_TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD,
    &ett_rnsap_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD,
    &ett_rnsap_DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD,
    &ett_rnsap_TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD,
    &ett_rnsap_TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD,
    &ett_rnsap_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD,
    &ett_rnsap_DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD,
    &ett_rnsap_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD,
    &ett_rnsap_DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD,
    &ett_rnsap_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD,
    &ett_rnsap_USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD,
    &ett_rnsap_Multiple_RL_InformationResponse_RL_ReconfReadyTDD,
    &ett_rnsap_RadioLinkReconfigurationCommit,
    &ett_rnsap_RadioLinkReconfigurationFailure,
    &ett_rnsap_CauseLevel_RL_ReconfFailure,
    &ett_rnsap_GeneralCauseList_RL_ReconfFailure,
    &ett_rnsap_RLSpecificCauseList_RL_ReconfFailure,
    &ett_rnsap_RL_ReconfigurationFailureList_RL_ReconfFailure,
    &ett_rnsap_RL_ReconfigurationFailure_RL_ReconfFail,
    &ett_rnsap_RadioLinkReconfigurationCancel,
    &ett_rnsap_RadioLinkReconfigurationRequestFDD,
    &ett_rnsap_UL_DPCH_Information_RL_ReconfRqstFDD,
    &ett_rnsap_DL_DPCH_Information_RL_ReconfRqstFDD,
    &ett_rnsap_DCH_DeleteList_RL_ReconfRqstFDD,
    &ett_rnsap_DCH_DeleteItem_RL_ReconfRqstFDD,
    &ett_rnsap_RL_ReconfigurationRequestFDD_RL_InformationList,
    &ett_rnsap_RL_ReconfigurationRequestFDD_RL_Information_IEs,
    &ett_rnsap_RadioLinkReconfigurationRequestTDD,
    &ett_rnsap_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
    &ett_rnsap_UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD,
    &ett_rnsap_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
    &ett_rnsap_UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
    &ett_rnsap_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
    &ett_rnsap_DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD,
    &ett_rnsap_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
    &ett_rnsap_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
    &ett_rnsap_DCH_DeleteList_RL_ReconfRqstTDD,
    &ett_rnsap_DCH_DeleteItem_RL_ReconfRqstTDD,
    &ett_rnsap_Multiple_RL_ReconfigurationRequestTDD_RL_Information,
    &ett_rnsap_RL_ReconfigurationRequestTDD_RL_Information,
    &ett_rnsap_RadioLinkReconfigurationResponseFDD,
    &ett_rnsap_RL_InformationResponseList_RL_ReconfRspFDD,
    &ett_rnsap_RL_InformationResponseItem_RL_ReconfRspFDD,
    &ett_rnsap_RadioLinkReconfigurationResponseTDD,
    &ett_rnsap_RL_InformationResponse_RL_ReconfRspTDD,
    &ett_rnsap_DL_CCTrCH_InformationList_RL_ReconfRspTDD,
    &ett_rnsap_DL_CCTrCH_InformationItem_RL_ReconfRspTDD,
    &ett_rnsap_DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD,
    &ett_rnsap_DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD,
    &ett_rnsap_DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD,
    &ett_rnsap_Multiple_RL_InformationResponse_RL_ReconfRspTDD,
    &ett_rnsap_RadioLinkFailureIndication,
    &ett_rnsap_Reporting_Object_RL_FailureInd,
    &ett_rnsap_RL_RL_FailureInd,
    &ett_rnsap_RL_InformationList_RL_FailureInd,
    &ett_rnsap_RL_Information_RL_FailureInd,
    &ett_rnsap_RL_Set_RL_FailureInd,
    &ett_rnsap_RL_Set_InformationList_RL_FailureInd,
    &ett_rnsap_RL_Set_Information_RL_FailureInd,
    &ett_rnsap_CCTrCH_RL_FailureInd,
    &ett_rnsap_CCTrCH_InformationList_RL_FailureInd,
    &ett_rnsap_CCTrCH_InformationItem_RL_FailureInd,
    &ett_rnsap_RadioLinkPreemptionRequiredIndication,
    &ett_rnsap_RL_InformationList_RL_PreemptRequiredInd,
    &ett_rnsap_RL_InformationItem_RL_PreemptRequiredInd,
    &ett_rnsap_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd,
    &ett_rnsap_HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd,
    &ett_rnsap_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd,
    &ett_rnsap_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd,
    &ett_rnsap_RadioLinkRestoreIndication,
    &ett_rnsap_Reporting_Object_RL_RestoreInd,
    &ett_rnsap_RL_RL_RestoreInd,
    &ett_rnsap_RL_InformationList_RL_RestoreInd,
    &ett_rnsap_RL_Information_RL_RestoreInd,
    &ett_rnsap_RL_Set_RL_RestoreInd,
    &ett_rnsap_RL_Set_InformationList_RL_RestoreInd,
    &ett_rnsap_RL_Set_Information_RL_RestoreInd,
    &ett_rnsap_CCTrCH_RL_RestoreInd,
    &ett_rnsap_CCTrCH_InformationList_RL_RestoreInd,
    &ett_rnsap_CCTrCH_InformationItem_RL_RestoreInd,
    &ett_rnsap_DL_PowerControlRequest,
    &ett_rnsap_DL_ReferencePowerInformationList_DL_PC_Rqst,
    &ett_rnsap_DL_ReferencePowerInformation_DL_PC_Rqst,
    &ett_rnsap_DL_PowerTimeslotControlRequest,
    &ett_rnsap_PhysicalChannelReconfigurationRequestFDD,
    &ett_rnsap_RL_Information_PhyChReconfRqstFDD,
    &ett_rnsap_PhysicalChannelReconfigurationRequestTDD,
    &ett_rnsap_RL_Information_PhyChReconfRqstTDD,
    &ett_rnsap_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD,
    &ett_rnsap_UL_CCTrCH_InformationItem_PhyChReconfRqstTDD,
    &ett_rnsap_UL_DPCH_InformationItem_PhyChReconfRqstTDD,
    &ett_rnsap_UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD,
    &ett_rnsap_UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD,
    &ett_rnsap_UL_Timeslot_InformationList_PhyChReconfRqstTDD,
    &ett_rnsap_UL_Timeslot_InformationItem_PhyChReconfRqstTDD,
    &ett_rnsap_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD,
    &ett_rnsap_DL_CCTrCH_InformationItem_PhyChReconfRqstTDD,
    &ett_rnsap_DL_DPCH_InformationItem_PhyChReconfRqstTDD,
    &ett_rnsap_DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD,
    &ett_rnsap_DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD,
    &ett_rnsap_DL_Timeslot_InformationList_PhyChReconfRqstTDD,
    &ett_rnsap_DL_Timeslot_InformationItem_PhyChReconfRqstTDD,
    &ett_rnsap_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD,
    &ett_rnsap_HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD,
    &ett_rnsap_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD,
    &ett_rnsap_HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD,
    &ett_rnsap_PhysicalChannelReconfigurationCommand,
    &ett_rnsap_PhysicalChannelReconfigurationFailure,
    &ett_rnsap_RadioLinkCongestionIndication,
    &ett_rnsap_RL_InformationList_RL_CongestInd,
    &ett_rnsap_RL_InformationItem_RL_CongestInd,
    &ett_rnsap_DCH_Rate_Information_RL_CongestInd,
    &ett_rnsap_DCH_Rate_InformationItem_RL_CongestInd,
    &ett_rnsap_EDCH_MacdFlowSpecificInformationList_RL_CongestInd,
    &ett_rnsap_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd,
    &ett_rnsap_UplinkSignallingTransferIndicationFDD,
    &ett_rnsap_UplinkSignallingTransferIndicationTDD,
    &ett_rnsap_DownlinkSignallingTransferRequest,
    &ett_rnsap_RelocationCommit,
    &ett_rnsap_PagingRequest,
    &ett_rnsap_PagingArea_PagingRqst,
    &ett_rnsap_URA_PagingRqst,
    &ett_rnsap_Cell_PagingRqst,
    &ett_rnsap_CNOriginatedPage_PagingRqst,
    &ett_rnsap_DedicatedMeasurementInitiationRequest,
    &ett_rnsap_DedicatedMeasurementObjectType_DM_Rqst,
    &ett_rnsap_RL_DM_Rqst,
    &ett_rnsap_RL_InformationList_DM_Rqst,
    &ett_rnsap_RL_InformationItem_DM_Rqst,
    &ett_rnsap_HSSICH_Info_DM_Rqst,
    &ett_rnsap_RL_Set_DM_Rqst,
    &ett_rnsap_RL_Set_InformationList_DM_Rqst,
    &ett_rnsap_RL_Set_InformationItem_DM_Rqst,
    &ett_rnsap_DedicatedMeasurementInitiationResponse,
    &ett_rnsap_DedicatedMeasurementObjectType_DM_Rsp,
    &ett_rnsap_RL_DM_Rsp,
    &ett_rnsap_RL_Set_DM_Rsp,
    &ett_rnsap_RL_InformationList_DM_Rsp,
    &ett_rnsap_RL_InformationItem_DM_Rsp,
    &ett_rnsap_RL_Set_InformationList_DM_Rsp,
    &ett_rnsap_RL_Set_InformationItem_DM_Rsp,
    &ett_rnsap_Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp,
    &ett_rnsap_Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp,
    &ett_rnsap_Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp,
    &ett_rnsap_Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp,
    &ett_rnsap_DedicatedMeasurementInitiationFailure,
    &ett_rnsap_DedicatedMeasurementObjectType_DM_Fail,
    &ett_rnsap_RL_DM_Fail,
    &ett_rnsap_RL_Set_DM_Fail,
    &ett_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail,
    &ett_rnsap_RL_Unsuccessful_InformationItem_DM_Fail,
    &ett_rnsap_RL_Successful_InformationRespList_DM_Fail,
    &ett_rnsap_RL_Successful_InformationItem_DM_Fail,
    &ett_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail,
    &ett_rnsap_RL_Set_Unsuccessful_InformationItem_DM_Fail,
    &ett_rnsap_RL_Set_Successful_InformationRespList_DM_Fail,
    &ett_rnsap_RL_Set_Successful_InformationItem_DM_Fail,
    &ett_rnsap_DedicatedMeasurementReport,
    &ett_rnsap_DedicatedMeasurementObjectType_DM_Rprt,
    &ett_rnsap_RL_DM_Rprt,
    &ett_rnsap_RL_Set_DM_Rprt,
    &ett_rnsap_RL_InformationList_DM_Rprt,
    &ett_rnsap_RL_InformationItem_DM_Rprt,
    &ett_rnsap_RL_Set_InformationList_DM_Rprt,
    &ett_rnsap_RL_Set_InformationItem_DM_Rprt,
    &ett_rnsap_DedicatedMeasurementTerminationRequest,
    &ett_rnsap_DedicatedMeasurementFailureIndication,
    &ett_rnsap_DedicatedMeasurementObjectType_DM_Fail_Ind,
    &ett_rnsap_RL_DM_Fail_Ind,
    &ett_rnsap_RL_Set_DM_Fail_Ind,
    &ett_rnsap_RL_Unsuccessful_InformationRespList_DM_Fail_Ind,
    &ett_rnsap_RL_Unsuccessful_InformationItem_DM_Fail_Ind,
    &ett_rnsap_RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind,
    &ett_rnsap_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind,
    &ett_rnsap_CommonTransportChannelResourcesReleaseRequest,
    &ett_rnsap_CommonTransportChannelResourcesRequest,
    &ett_rnsap_CommonTransportChannelResourcesResponseFDD,
    &ett_rnsap_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD,
    &ett_rnsap_CommonTransportChannelResourcesResponseTDD,
    &ett_rnsap_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD,
    &ett_rnsap_CommonTransportChannelResourcesFailure,
    &ett_rnsap_CompressedModeCommand,
    &ett_rnsap_ErrorIndication,
    &ett_rnsap_CommonMeasurementInitiationRequest,
    &ett_rnsap_CommonMeasurementObjectType_CM_Rqst,
    &ett_rnsap_Cell_CM_Rqst,
    &ett_rnsap_NeighbouringCellMeasurementInfo,
    &ett_rnsap_NeighbouringCellMeasurementInfo_item,
    &ett_rnsap_CommonMeasurementInitiationResponse,
    &ett_rnsap_CommonMeasurementObjectType_CM_Rsp,
    &ett_rnsap_Cell_CM_Rsp,
    &ett_rnsap_CommonMeasurementInitiationFailure,
    &ett_rnsap_CommonMeasurementReport,
    &ett_rnsap_CommonMeasurementObjectType_CM_Rprt,
    &ett_rnsap_Cell_CM_Rprt,
    &ett_rnsap_CommonMeasurementTerminationRequest,
    &ett_rnsap_CommonMeasurementFailureIndication,
    &ett_rnsap_InformationExchangeInitiationRequest,
    &ett_rnsap_InformationExchangeObjectType_InfEx_Rqst,
    &ett_rnsap_Cell_InfEx_Rqst,
    &ett_rnsap_GSM_Cell_InfEx_Rqst,
    &ett_rnsap_InformationExchangeInitiationResponse,
    &ett_rnsap_InformationExchangeObjectType_InfEx_Rsp,
    &ett_rnsap_Cell_InfEx_Rsp,
    &ett_rnsap_MBMS_Bearer_Service_List_InfEx_Rsp,
    &ett_rnsap_MBMS_Bearer_ServiceItemIEs_InfEx_Rsp,
    &ett_rnsap_InformationExchangeInitiationFailure,
    &ett_rnsap_InformationReport,
    &ett_rnsap_InformationExchangeObjectType_InfEx_Rprt,
    &ett_rnsap_Cell_InfEx_Rprt,
    &ett_rnsap_InformationExchangeTerminationRequest,
    &ett_rnsap_InformationExchangeFailureIndication,
    &ett_rnsap_ResetRequest,
    &ett_rnsap_ResetIndicator,
    &ett_rnsap_ContextList_Reset,
    &ett_rnsap_ContextInfoList_Reset,
    &ett_rnsap_ContextInfoItem_Reset,
    &ett_rnsap_ContextType_Reset,
    &ett_rnsap_ContextGroupList_Reset,
    &ett_rnsap_ContextGroupInfoList_Reset,
    &ett_rnsap_ContextGroupInfoItem_Reset,
    &ett_rnsap_ResetResponse,
    &ett_rnsap_RadioLinkActivationCommandFDD,
    &ett_rnsap_DelayedActivationInformationList_RL_ActivationCmdFDD,
    &ett_rnsap_DelayedActivationInformation_RL_ActivationCmdFDD,
    &ett_rnsap_RadioLinkActivationCommandTDD,
    &ett_rnsap_DelayedActivationInformationList_RL_ActivationCmdTDD,
    &ett_rnsap_DelayedActivationInformation_RL_ActivationCmdTDD,
    &ett_rnsap_GERANUplinkSignallingTransferIndication,
    &ett_rnsap_RadioLinkParameterUpdateIndicationFDD,
    &ett_rnsap_RL_ParameterUpdateIndicationFDD_RL_InformationList,
    &ett_rnsap_RL_ParameterUpdateIndicationFDD_RL_Information_Item,
    &ett_rnsap_RadioLinkParameterUpdateIndicationTDD,
    &ett_rnsap_UEMeasurementInitiationRequest,
    &ett_rnsap_UEMeasurementInitiationResponse,
    &ett_rnsap_UEMeasurementInitiationFailure,
    &ett_rnsap_UEMeasurementReport,
    &ett_rnsap_UEMeasurementTerminationRequest,
    &ett_rnsap_UEMeasurementFailureIndication,
    &ett_rnsap_IurInvokeTrace,
    &ett_rnsap_ListOfInterfacesToTrace,
    &ett_rnsap_InterfacesToTraceItem,
    &ett_rnsap_IurDeactivateTrace,
    &ett_rnsap_MBMSAttachCommand,
    &ett_rnsap_MBMSDetachCommand,
    &ett_rnsap_DirectInformationTransfer,
    &ett_rnsap_PrivateMessage,
    &ett_rnsap_Active_MBMS_Bearer_Service_ListFDD,
    &ett_rnsap_Active_MBMS_Bearer_Service_ListFDD_PFL,
    &ett_rnsap_Active_MBMS_Bearer_Service_ListTDD,
    &ett_rnsap_Active_MBMS_Bearer_Service_ListTDD_PFL,
    &ett_rnsap_Active_Pattern_Sequence_Information,
    &ett_rnsap_AdditionalPreferredFrequency,
    &ett_rnsap_AdditionalPreferredFrequencyItem,
    &ett_rnsap_AffectedUEInformationForMBMS,
    &ett_rnsap_AllocationRetentionPriority,
    &ett_rnsap_Allowed_Rate_Information,
    &ett_rnsap_Angle_Of_Arrival_Value_LCR,
    &ett_rnsap_BadSatellites,
    &ett_rnsap_T_badSatelliteInformation,
    &ett_rnsap_T_badSatelliteInformation_item,
    &ett_rnsap_BSIC,
    &ett_rnsap_BurstModeParameters,
    &ett_rnsap_Cause,
    &ett_rnsap_Cell_Capacity_Class_Value,
    &ett_rnsap_CGI,
    &ett_rnsap_T_lAI,
    &ett_rnsap_CommonMeasurementAccuracy,
    &ett_rnsap_CommonMeasurementValue,
    &ett_rnsap_CommonMeasurementValueInformation,
    &ett_rnsap_CommonMeasurementAvailable,
    &ett_rnsap_CorrespondingCells,
    &ett_rnsap_CriticalityDiagnostics,
    &ett_rnsap_CriticalityDiagnostics_IE_List,
    &ett_rnsap_CriticalityDiagnostics_IE_List_item,
    &ett_rnsap_MessageStructure,
    &ett_rnsap_MessageStructure_item,
    &ett_rnsap_CN_CS_DomainIdentifier,
    &ett_rnsap_CN_PS_DomainIdentifier,
    &ett_rnsap_DCH_FDD_Information,
    &ett_rnsap_DCH_FDD_InformationItem,
    &ett_rnsap_DCH_Specific_FDD_InformationList,
    &ett_rnsap_DCH_Specific_FDD_Item,
    &ett_rnsap_DCH_InformationResponse,
    &ett_rnsap_DCH_InformationResponseItem,
    &ett_rnsap_DCH_TDD_Information,
    &ett_rnsap_DCH_TDD_InformationItem,
    &ett_rnsap_DCH_Specific_TDD_InformationList,
    &ett_rnsap_DCH_Specific_TDD_Item,
    &ett_rnsap_DedicatedMeasurementValue,
    &ett_rnsap_DedicatedMeasurementValueInformation,
    &ett_rnsap_DedicatedMeasurementAvailable,
    &ett_rnsap_DelayedActivation,
    &ett_rnsap_DelayedActivationUpdate,
    &ett_rnsap_Activate_Info,
    &ett_rnsap_Deactivate_Info,
    &ett_rnsap_Execution_Type,
    &ett_rnsap_DGPSCorrections,
    &ett_rnsap_T_satellite_DGPSCorrections_Information,
    &ett_rnsap_T_satellite_DGPSCorrections_Information_item,
    &ett_rnsap_DGPSThreshold,
    &ett_rnsap_DL_PowerBalancing_Information,
    &ett_rnsap_DL_ReferencePowerInformationList,
    &ett_rnsap_DL_ReferencePowerInformationItem,
    &ett_rnsap_DL_ReferencePowerInformation,
    &ett_rnsap_DL_Timeslot_Information,
    &ett_rnsap_DL_Timeslot_InformationItem,
    &ett_rnsap_DL_TimeslotLCR_Information,
    &ett_rnsap_DL_TimeslotLCR_InformationItem,
    &ett_rnsap_DL_TimeSlot_ISCP_Info,
    &ett_rnsap_DL_TimeSlot_ISCP_InfoItem,
    &ett_rnsap_DL_TimeSlot_ISCP_LCR_Information,
    &ett_rnsap_DL_TimeSlot_ISCP_LCR_InfoItem,
    &ett_rnsap_DSCH_FlowControlInformation,
    &ett_rnsap_DSCH_FlowControlItem,
    &ett_rnsap_DSCH_TDD_Information,
    &ett_rnsap_DSCH_TDD_InformationItem,
    &ett_rnsap_EDCH_FDD_DL_ControlChannelInformation,
    &ett_rnsap_EDCH_FDD_Information,
    &ett_rnsap_EDCH_FDD_InformationResponse,
    &ett_rnsap_EDCH_FDD_InformationResponseItem,
    &ett_rnsap_EDCH_FDD_Information_To_Modify,
    &ett_rnsap_EDCH_FDD_Update_Information,
    &ett_rnsap_EDCH_FDD_Update_InfoItem,
    &ett_rnsap_E_DCH_Grant_Type_Information,
    &ett_rnsap_E_DCH_LogicalChannelInformation,
    &ett_rnsap_E_DCH_LogicalChannelInformationItem,
    &ett_rnsap_E_DCH_MACdPDU_SizeList,
    &ett_rnsap_E_DCH_MACdPDU_SizeListItem,
    &ett_rnsap_E_DCH_LogicalChannelToModify,
    &ett_rnsap_E_DCH_LogicalChannelToModifyItem,
    &ett_rnsap_E_DCH_MACdPDU_SizeToModifyList,
    &ett_rnsap_E_DCH_LogicalChannelToDelete,
    &ett_rnsap_E_DCH_LogicalChannelToDeleteItem,
    &ett_rnsap_EDCH_MACdFlows_Information,
    &ett_rnsap_EDCH_MACdFlow_Specific_InfoList,
    &ett_rnsap_EDCH_MACdFlow_Specific_InfoItem,
    &ett_rnsap_EDCH_MACdFlow_Specific_InfoToModifyList,
    &ett_rnsap_EDCH_MACdFlow_Specific_InfoToModifyItem,
    &ett_rnsap_EDCH_MACdFlows_To_Delete,
    &ett_rnsap_EDCH_MACdFlows_To_Delete_Item,
    &ett_rnsap_E_DCH_Non_Scheduled_Transmission_Grant_Items,
    &ett_rnsap_EDPCH_Information_FDD,
    &ett_rnsap_EDPCH_Information_RLReconfPrepare_FDD,
    &ett_rnsap_EDPCH_Information_RLReconfRequest_FDD,
    &ett_rnsap_EDCH_Serving_RL,
    &ett_rnsap_EDCH_Serving_RL_in_this_DRNS,
    &ett_rnsap_E_TFCS_Information,
    &ett_rnsap_EventA,
    &ett_rnsap_EventB,
    &ett_rnsap_EventC,
    &ett_rnsap_EventD,
    &ett_rnsap_EventE,
    &ett_rnsap_EventF,
    &ett_rnsap_FACH_FlowControlInformation,
    &ett_rnsap_FACH_FlowControlInformationItem,
    &ett_rnsap_FACH_InformationList,
    &ett_rnsap_FACH_InformationItem,
    &ett_rnsap_FACH_PCH_InformationList,
    &ett_rnsap_FACH_PCH_InformationItem,
    &ett_rnsap_FDD_DCHs_to_Modify,
    &ett_rnsap_FDD_DCHs_to_ModifyItem,
    &ett_rnsap_FDD_DCHs_to_ModifySpecificInformationList,
    &ett_rnsap_FDD_DCHs_to_ModifySpecificItem,
    &ett_rnsap_FDD_DL_CodeInformation,
    &ett_rnsap_FDD_DL_CodeInformationItem,
    &ett_rnsap_FPACH_Information,
    &ett_rnsap_GA_Cell,
    &ett_rnsap_GA_Cell_item,
    &ett_rnsap_GA_CellAdditionalShapes,
    &ett_rnsap_GA_AltitudeAndDirection,
    &ett_rnsap_GA_EllipsoidArc,
    &ett_rnsap_GA_PointWithAltitude,
    &ett_rnsap_GA_PointWithAltitudeAndUncertaintyEllipsoid,
    &ett_rnsap_GA_PointWithUnCertaintyEllipse,
    &ett_rnsap_GA_UncertaintyEllipse,
    &ett_rnsap_GA_PointWithUnCertainty,
    &ett_rnsap_GA_AccessPointPosition,
    &ett_rnsap_GeographicalCoordinate,
    &ett_rnsap_GERAN_SI_Type,
    &ett_rnsap_GERAN_SystemInfo,
    &ett_rnsap_GERAN_SystemInfo_item,
    &ett_rnsap_GPS_Almanac,
    &ett_rnsap_T_satellite_Almanac_Information,
    &ett_rnsap_T_satellite_Almanac_Information_item,
    &ett_rnsap_Satellite_Almanac_Information_ExtItem,
    &ett_rnsap_Satellite_Almanac_Information_ExtItem_item,
    &ett_rnsap_GPSInformation,
    &ett_rnsap_GPSInformation_item,
    &ett_rnsap_GPS_Ionospheric_Model,
    &ett_rnsap_GPS_NavigationModel_and_TimeRecovery,
    &ett_rnsap_GPS_NavigationModel_and_TimeRecovery_item,
    &ett_rnsap_GPS_RealTime_Integrity,
    &ett_rnsap_GPS_RX_POS,
    &ett_rnsap_GPS_UTC_Model,
    &ett_rnsap_Guaranteed_Rate_Information,
    &ett_rnsap_HARQ_MemoryPartitioning,
    &ett_rnsap_HARQ_MemoryPartitioning_Implicit,
    &ett_rnsap_HARQ_MemoryPartitioning_Explicit,
    &ett_rnsap_HARQ_MemoryPartitioningList,
    &ett_rnsap_HARQ_MemoryPartitioningItem,
    &ett_rnsap_HSDSCH_FDD_Information,
    &ett_rnsap_HSDSCH_FDD_Information_Response,
    &ett_rnsap_HSDSCH_Information_to_Modify,
    &ett_rnsap_HSDSCH_Information_to_Modify_Unsynchronised,
    &ett_rnsap_HSDSCH_MACdFlow_Specific_InfoList,
    &ett_rnsap_HSDSCH_MACdFlow_Specific_InfoItem,
    &ett_rnsap_HSDSCH_MACdFlow_Specific_InfoList_Response,
    &ett_rnsap_HSDSCH_MACdFlow_Specific_InfoItem_Response,
    &ett_rnsap_HSDSCH_MACdFlow_Specific_InfoList_to_Modify,
    &ett_rnsap_HSDSCH_MACdFlow_Specific_InfoItem_to_Modify,
    &ett_rnsap_HSDSCH_MACdFlows_Information,
    &ett_rnsap_HSDSCH_MACdFlows_to_Delete,
    &ett_rnsap_HSDSCH_MACdFlows_to_Delete_Item,
    &ett_rnsap_HSDSCH_Initial_Capacity_Allocation,
    &ett_rnsap_HSDSCH_Initial_Capacity_AllocationItem,
    &ett_rnsap_HSDSCH_TDD_Information,
    &ett_rnsap_HSDSCH_TDD_Information_Response,
    &ett_rnsap_HSPDSCH_TDD_Specific_InfoList_Response,
    &ett_rnsap_HSPDSCH_TDD_Specific_InfoItem_Response,
    &ett_rnsap_HSPDSCH_TDD_Specific_InfoList_Response_LCR,
    &ett_rnsap_HSPDSCH_TDD_Specific_InfoItem_Response_LCR,
    &ett_rnsap_HSSCCH_FDD_Specific_InfoList_Response,
    &ett_rnsap_HSSCCH_FDD_Specific_InfoItem_Response,
    &ett_rnsap_HSSCCH_TDD_Specific_InfoList_Response,
    &ett_rnsap_HSSCCH_TDD_Specific_InfoItem_Response,
    &ett_rnsap_HSSCCH_TDD_Specific_InfoList_Response_LCR,
    &ett_rnsap_HSSCCH_TDD_Specific_InfoItem_Response_LCR,
    &ett_rnsap_HSSICH_Info,
    &ett_rnsap_HSSICH_InfoLCR,
    &ett_rnsap_HS_SICH_Reception_Quality_Value,
    &ett_rnsap_HSDSCH_FDD_Update_Information,
    &ett_rnsap_HSDSCH_TDD_Update_Information,
    &ett_rnsap_InformationAvailable,
    &ett_rnsap_InformationReportCharacteristics,
    &ett_rnsap_InformationReportPeriodicity,
    &ett_rnsap_InformationThreshold,
    &ett_rnsap_InformationType,
    &ett_rnsap_IPDLParameters,
    &ett_rnsap_IPDL_FDD_Parameters,
    &ett_rnsap_IPDL_TDD_Parameters,
    &ett_rnsap_IPDL_TDD_ParametersLCR,
    &ett_rnsap_LoadValue,
    &ett_rnsap_MAC_c_sh_SDU_LengthList,
    &ett_rnsap_MACdPDU_Size_IndexList,
    &ett_rnsap_MACdPDU_Size_IndexItem,
    &ett_rnsap_MACdPDU_Size_IndexList_to_Modify,
    &ett_rnsap_MACdPDU_Size_IndexItem_to_Modify,
    &ett_rnsap_MBMS_Bearer_Service_Full_Address,
    &ett_rnsap_MBMS_Bearer_Service_List,
    &ett_rnsap_MBMS_Bearer_ServiceItemFDD,
    &ett_rnsap_MBMS_Bearer_ServiceItemFDD_PFL,
    &ett_rnsap_MBMS_Bearer_ServiceItemTDD,
    &ett_rnsap_MBMS_Bearer_ServiceItemTDD_PFL,
    &ett_rnsap_MBMSChannelTypeInfo,
    &ett_rnsap_MBMSChannelTypeCellList,
    &ett_rnsap_MBMSPreferredFreqLayerInfo,
    &ett_rnsap_MeasurementIncreaseDecreaseThreshold,
    &ett_rnsap_MeasurementThreshold,
    &ett_rnsap_MidambleShiftAndBurstType,
    &ett_rnsap_T_type1,
    &ett_rnsap_T_midambleAllocationMode,
    &ett_rnsap_T_type2,
    &ett_rnsap_T_midambleAllocationMode1,
    &ett_rnsap_T_type3,
    &ett_rnsap_T_midambleAllocationMode2,
    &ett_rnsap_MidambleShiftLCR,
    &ett_rnsap_ModifyPriorityQueue,
    &ett_rnsap_NACC_Related_Data,
    &ett_rnsap_Neighbouring_UMTS_CellInformation,
    &ett_rnsap_Neighbouring_UMTS_CellInformationItem,
    &ett_rnsap_Neighbouring_FDD_CellInformation,
    &ett_rnsap_Neighbouring_FDD_CellInformationItem,
    &ett_rnsap_NeighbouringFDDCellMeasurementInformation,
    &ett_rnsap_Neighbouring_GSM_CellInformationIEs,
    &ett_rnsap_Neighbouring_GSM_CellInformationItem,
    &ett_rnsap_Neighbouring_TDD_CellInformation,
    &ett_rnsap_Neighbouring_TDD_CellInformationItem,
    &ett_rnsap_NeighbouringTDDCellMeasurementInformation,
    &ett_rnsap_NeighbouringTDDCellMeasurementInformationLCR,
    &ett_rnsap_Neighbouring_LCR_TDD_CellInformation,
    &ett_rnsap_Neighbouring_LCR_TDD_CellInformationItem,
    &ett_rnsap_NotProvidedCellList,
    &ett_rnsap_NRTLoadInformationValue,
    &ett_rnsap_OnModification,
    &ett_rnsap_OnModificationInformation,
    &ett_rnsap_PCH_InformationList,
    &ett_rnsap_PCH_InformationItem,
    &ett_rnsap_Periodic,
    &ett_rnsap_PeriodicInformation,
    &ett_rnsap_Permanent_NAS_UE_Identity,
    &ett_rnsap_PreferredFrequencyLayerInfo,
    &ett_rnsap_PriorityQueue_InfoList,
    &ett_rnsap_PriorityQueue_InfoItem,
    &ett_rnsap_PriorityQueue_InfoList_to_Modify,
    &ett_rnsap_PriorityQueue_InfoItem_to_Add,
    &ett_rnsap_PriorityQueue_InfoItem_to_Modify,
    &ett_rnsap_PriorityQueue_InfoList_to_Modify_Unsynchronised,
    &ett_rnsap_PriorityQueue_InfoItem_to_Modify_Unsynchronised,
    &ett_rnsap_ProvidedInformation,
    &ett_rnsap_PTMCellList,
    &ett_rnsap_PTPCellList,
    &ett_rnsap_RB_Info,
    &ett_rnsap_Reference_E_TFCI_Information,
    &ett_rnsap_Reference_E_TFCI_Information_Item,
    &ett_rnsap_ReportCharacteristics,
    &ett_rnsap_ReportPeriodicity,
    &ett_rnsap_RequestedDataValue,
    &ett_rnsap_RequestedDataValueInformation,
    &ett_rnsap_RL_Specific_DCH_Info,
    &ett_rnsap_RL_Specific_DCH_Info_Item,
    &ett_rnsap_RL_Specific_EDCH_Information,
    &ett_rnsap_RL_Specific_EDCH_InfoItem,
    &ett_rnsap_RTLoadValue,
    &ett_rnsap_SAI,
    &ett_rnsap_Secondary_CCPCH_Info_TDD,
    &ett_rnsap_Secondary_CPICH_Information,
    &ett_rnsap_Secondary_CPICH_Information_Change,
    &ett_rnsap_Secondary_LCR_CCPCH_Info_TDD,
    &ett_rnsap_Secondary_CCPCH_TDD_InformationList,
    &ett_rnsap_Secondary_CCPCH_TDD_InformationItem,
    &ett_rnsap_Secondary_LCR_CCPCH_TDD_InformationList,
    &ett_rnsap_Secondary_LCR_CCPCH_TDD_InformationItem,
    &ett_rnsap_Secondary_CCPCH_TDD_Code_Information,
    &ett_rnsap_Secondary_CCPCH_TDD_Code_InformationItem,
    &ett_rnsap_Secondary_LCR_CCPCH_TDD_Code_Information,
    &ett_rnsap_Secondary_LCR_CCPCH_TDD_Code_InformationItem,
    &ett_rnsap_GA_AccessPointPositionwithOptionalAltitude,
    &ett_rnsap_SFNSFNMeasurementThresholdInformation,
    &ett_rnsap_SFNSFNMeasurementValueInformation,
    &ett_rnsap_T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation,
    &ett_rnsap_T_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item,
    &ett_rnsap_T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation,
    &ett_rnsap_T_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation_item,
    &ett_rnsap_SFNSFNTimeStampInformation,
    &ett_rnsap_SFNSFNTimeStamp_TDD,
    &ett_rnsap_SFNSFNValue,
    &ett_rnsap_SNA_Information,
    &ett_rnsap_ListOfSNAs,
    &ett_rnsap_S_RNTI_Group,
    &ett_rnsap_SynchronisationConfiguration,
    &ett_rnsap_SYNC_UL_ProcParameters,
    &ett_rnsap_TDD_ChannelisationCodeLCR,
    &ett_rnsap_TDD_DCHs_to_Modify,
    &ett_rnsap_TDD_DCHs_to_ModifyItem,
    &ett_rnsap_TDD_DCHs_to_ModifySpecificInformationList,
    &ett_rnsap_TDD_DCHs_to_ModifySpecificItem,
    &ett_rnsap_TDD_DL_Code_Information,
    &ett_rnsap_TDD_DL_Code_InformationItem,
    &ett_rnsap_TDD_DL_Code_LCR_Information,
    &ett_rnsap_TDD_DL_Code_LCR_InformationItem,
    &ett_rnsap_TDD_DL_DPCH_TimeSlotFormat_LCR,
    &ett_rnsap_TDD_DPCHOffset,
    &ett_rnsap_TDD_UL_Code_Information,
    &ett_rnsap_TDD_UL_Code_InformationItem,
    &ett_rnsap_TDD_UL_Code_LCR_Information,
    &ett_rnsap_TDD_UL_Code_LCR_InformationItem,
    &ett_rnsap_TDD_UL_DPCH_TimeSlotFormat_LCR,
    &ett_rnsap_TMGI,
    &ett_rnsap_TnlQos,
    &ett_rnsap_Transmission_Gap_Pattern_Sequence_Information,
    &ett_rnsap_Transmission_Gap_Pattern_Sequence_Information_item,
    &ett_rnsap_Transmission_Gap_Pattern_Sequence_Status_List,
    &ett_rnsap_Transmission_Gap_Pattern_Sequence_Status_List_item,
    &ett_rnsap_TUTRANGPS,
    &ett_rnsap_TUTRANGPSMeasurementThresholdInformation,
    &ett_rnsap_TUTRANGPSMeasurementValueInformation,
    &ett_rnsap_TransportFormatCombination_Beta,
    &ett_rnsap_T_signalledGainFactors,
    &ett_rnsap_TFCS,
    &ett_rnsap_T_tFCSvalues,
    &ett_rnsap_TFCS_TFCSList,
    &ett_rnsap_TFCS_TFCSList_item,
    &ett_rnsap_TFCS_CTFC,
    &ett_rnsap_TransportFormatSet,
    &ett_rnsap_TransportFormatSet_DynamicPartList,
    &ett_rnsap_TransportFormatSet_DynamicPartList_item,
    &ett_rnsap_TransportFormatSet_ModeDP,
    &ett_rnsap_TDD_TransportFormatSet_ModeDP,
    &ett_rnsap_TransmissionTimeIntervalInformation,
    &ett_rnsap_TransmissionTimeIntervalInformation_item,
    &ett_rnsap_TransportFormatSet_Semi_staticPart,
    &ett_rnsap_TransportFormatSet_ModeSSP,
    &ett_rnsap_UE_Capabilities_Info,
    &ett_rnsap_UEIdentity,
    &ett_rnsap_UEMeasurementReportCharacteristics,
    &ett_rnsap_UEMeasurementReportCharacteristicsEvent1h,
    &ett_rnsap_UEMeasurementReportCharacteristicsEvent1i,
    &ett_rnsap_UEMeasurementReportCharacteristicsEvent6a,
    &ett_rnsap_UEMeasurementReportCharacteristicsEvent6b,
    &ett_rnsap_UEMeasurementReportCharacteristicsEvent6c,
    &ett_rnsap_UEMeasurementReportCharacteristicsEvent6d,
    &ett_rnsap_UEMeasurementReportCharacteristicsPeriodic,
    &ett_rnsap_UEMeasurementThreshold,
    &ett_rnsap_UEMeasurementTimeslotInfoHCR,
    &ett_rnsap_UEMeasurementTimeslotInfoHCR_IEs,
    &ett_rnsap_UEMeasurementTimeslotInfoLCR,
    &ett_rnsap_UEMeasurementTimeslotInfoLCR_IEs,
    &ett_rnsap_UEMeasurementValue,
    &ett_rnsap_UE_MeasurementValue_UE_Transmitted_Power,
    &ett_rnsap_UEMeasurementValueTransmittedPowerListHCR,
    &ett_rnsap_UEMeasurementValueTransmittedPowerListHCR_IEs,
    &ett_rnsap_UEMeasurementValueTransmittedPowerListLCR,
    &ett_rnsap_UEMeasurementValueTransmittedPowerListLCR_IEs,
    &ett_rnsap_UE_MeasurementValue_Primary_CCPCH_RSCP,
    &ett_rnsap_UE_MeasurementValue_DL_Timeslot_ISCP,
    &ett_rnsap_UEMeasurementValueTimeslotISCPListHCR,
    &ett_rnsap_UEMeasurementValueTimeslotISCPListHCR_IEs,
    &ett_rnsap_UEMeasurementValueTimeslotISCPListLCR,
    &ett_rnsap_UEMeasurementValueTimeslotISCPListLCR_IEs,
    &ett_rnsap_UEMeasurementValueInformation,
    &ett_rnsap_UEMeasurementValueInformationAvailable,
    &ett_rnsap_UE_State,
    &ett_rnsap_Cell_Fach_Pch_State,
    &ett_rnsap_Ura_Pch_State,
    &ett_rnsap_UL_Timeslot_Information,
    &ett_rnsap_UL_Timeslot_InformationItem,
    &ett_rnsap_UL_TimeslotLCR_Information,
    &ett_rnsap_UL_TimeslotLCR_InformationItem,
    &ett_rnsap_UL_TimeSlot_ISCP_Info,
    &ett_rnsap_UL_TimeSlot_ISCP_InfoItem,
    &ett_rnsap_UL_TimeSlot_ISCP_LCR_Info,
    &ett_rnsap_UL_TimeSlot_ISCP_LCR_InfoItem,
    &ett_rnsap_UL_TimingAdvanceCtrl_LCR,
    &ett_rnsap_UC_ID,
    &ett_rnsap_UL_ScramblingCode,
    &ett_rnsap_UL_Synchronisation_Parameters_LCR,
    &ett_rnsap_URA_Information,
    &ett_rnsap_RNCsWithCellsInTheAccessedURA_List,
    &ett_rnsap_RNCsWithCellsInTheAccessedURA_Item,
    &ett_rnsap_USCH_Information,
    &ett_rnsap_USCH_InformationItem,
    &ett_rnsap_PrivateIE_ID,
    &ett_rnsap_ProcedureID,
    &ett_rnsap_TransactionID,
    &ett_rnsap_ProtocolIE_Container,
    &ett_rnsap_ProtocolIE_Field,
    &ett_rnsap_ProtocolIE_ContainerPair,
    &ett_rnsap_ProtocolIE_FieldPair,
    &ett_rnsap_ProtocolIE_ContainerList,
    &ett_rnsap_ProtocolIE_ContainerPairList,
    &ett_rnsap_ProtocolExtensionContainer,
    &ett_rnsap_ProtocolExtensionField,
    &ett_rnsap_PrivateIE_Container,
    &ett_rnsap_PrivateIE_Field,

/*--- End of included file: packet-rnsap-ettarr.c ---*/
#line 1334 "packet-rnsap-template.c"
  };


  /* Register protocol */
  proto_rnsap = proto_register_protocol(PNAME, PSNAME, PFNAME);
  /* Register fields and subtrees */
  proto_register_field_array(proto_rnsap, hf, array_length(hf));
  proto_register_subtree_array(ett, array_length(ett));

 
  register_dissector("rnsap", dissect_rnsap, proto_rnsap);


}


/*--- proto_reg_handoff_rnsap ---------------------------------------*/
void
proto_reg_handoff_rnsap(void)
{

	rnsap_handle = find_dissector("rnsap");

}


